README file for Pspline Module

Prepared by C.Ludescher-Furth -- ludescher@pppl.gov 10/23/00

****************
REVISION HISTORY
****************
      date         Description

  May 15, 1999  -- Created 
  Apr 12, 2000  -- Houlberg/Pletzer enhancements

----------------------------------------------------------------

Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. RUNNING INSTRUCTIONS
   6. TESTING INSTRUCTIONS
   7. DOCUMENTATION
   8. FINAL INSTALLATION


************
1. CONTENTS:
************
This directory should contain the following files:

README_Pspline:  This file.  Brief descriptions of the other files, and
                 instructions for compiling, testing and installing the
                 pspline library libpspline.a and its test drivers
                 pspltest, qk_pspline, ezspline_* and czspline_test.cxx. 

EzSpline_HowTo:  FAQ for EzSpline.
EzSpline_README: User Guide for EzSpline 
CzSpline_README: User Guide for CzSpline 

Makefile:       NOTE, "GNU make" must be used
                      (usually in /usr/gnu/bin or /usr/local/bin).
                      You also need "gcc" for pre-processing
                      (exept on CRAY).
		Main Makefile to invoke Makefiles in all subdirectories.  

./ezcdf
   Makefile               -- to build libezcdf.a
   Sources to build libezcdf.a, an internally used library
   
./include/fpreproc:
   *.h files for source pre-processing.

./pspline:
   README       -- A copy of README_Pspline from above.
   Makefile     -- to build libpspline and test programs
   Sources to build the library libpspline.a
   pspltest.for           -- source for basic test driver
   pspltest.output        -- sample output file for respective test case
   lookup_test   	  -- source to study performance
   lookup_test.output     -- sample output file for respective test case
   ezspline_test          -- source to test ezspline
   ezspline_perf          -- source to test ezspline
   ezspline_test.ref      -- sample output file for respective test case
   ezspline_test.m        -- matlab program to display the test output 
   qk_pspline.f90         -- source for derivative test driver
   qk_pspline.output      -- sample output file for respective test case

./share/Make.flags:  Include file for Makefile, to setup Flags, etc.

**************************
2. UNPACKING INSTRUCTIONS:
**************************
for tarfiles:
  > gunzip pspline.tar.gz
  > tar xvf pspline.tar

or, for zip archives:
  > unzip pspline.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:
./pspline          --  Spline and Hermite Cubic Interpolation 
./ezcdf            --  Easy Interface for netCDF Routines
./share            --  include file Make.flags 
./portlib          --  portability routines
./include/fpreproc --  *.h files for cpp

The makefile will create more sub directories,
lib:           for the library, libpspline.a
mod:           for the f90 modules
obj/<libname>: for compiled objects
test:          for the test programs and the sample output files.

By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/{lib,mod,obj,test}.

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2), or with make (e.g. "gmake OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/{lib,mod,obj,test}.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/{lib,mod,obj,test}.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.
      Alternatively you can modify share/Make.local.sample
      and rename it to share/Make.local.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Required Compilers:
===================
   gcc        -- for pre-processing (exept on CRAY)
   Fortran 90
   C

Required Libraries:
===================
   netCDF
         The library is assumed to be in /usr/local/{lib,include}
         If your site has it somwhere else, define NETCDF_DIR
         e.g. gmake NETCDF_DIR=/my/nonstandard
         (on CRAY, the Makefile knows where it is)
         Alternatively you can modify share/Make.local.sample
         and rename it to share/Make.local.

>>>>Note: If you don't have netCDF installed, do this:
         > cp cdf_dummy/netcdf.inc include/
         > gmake NETCDF_DIR=   


> gmake            -- to compile library and link all test programs

> gmake checklibs  -- tells you what the makefile will do
                      (without any action);
                      it says which libraries it will make and
                      which ones it already found and where.
                      It also tells you how to rebuild an existing library.
 
> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library

> gmake show_makeflags -- to see what flags, definitions Make will use


COMPILING FLAGS:
----------------
By default all routines are compiled with the automatic flag.
If you want static, say:

> gmake DYNAMIC=

On IRIX64:
> gmake DYNAMIC=-static

On CRAY:
> gmake DYNAMIC=-ev

On HP
> gmake DYNAMIC=-K


Compiling on Linux:
-------------------

By default the Makefile will select Lahey Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland" "PathScale" " GCC" "NagWare"  "Fujitsu" "Intel" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

Note: some test programs are linked with g++; to find the Fortran libraries,
      you need to define FLIBROOT
      e.g. export FLIBROOT=/usr/pppl/lf64x/lf6480

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


************************
5. RUNNING INSTRUCTIONS:
************************
Be sure your "stack size" is adequate ~ 32000 (100000 on alpha), otherwise
you might get segmentation faults.
To check yor stack size:
> ulimit -a
To increase it:
> ulimit -Ss 131072

************************
6. TESTING INSTRUCTIONS:
************************

To verify functioning of the software:
--------------------------------------

There is no input required.
Run pspltes{t,8} and compare it's output
with  pspltes{t,8}.output:

e.g.:
> cd <MACHINE>/test        or   > cd $OBJ/test 
> ./pspltest > foo
> diff foo pspltest.output

To study performance of pspline software:
-----------------------------------------
e.g.:
> ./lookup_test > foo
> diff foo lookup_test.output

To test derivatives:
---------------------
e.g.:
> ./qk_pspline > qk_foo
> diff qk_foo qk_pspline.output

To test ezspline:
-----------------
e.g.:
> ./ezspline_test
  then look at it with matlab:
> matlab
  >> ezspline_test

To test c interface:
-----------------
e.g.:
> ./czspline_test

************************
7. DOCUMENTATION:
************************

PSPLINE Home Page:
http://w3.pppl.gov/NTCC/PSPLINE

PSPLINE HELP
http://w3.pppl.gov/~pshare/help/pspline.htm

NTCC Home Page:
http://w3.pppl.gov/NTCC


**********************
8. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in:       $PREFIX/lib        = $LIBDIR
f90 modules in:     $PREFIX/mod        = $MODDIR
man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

>   gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

>   gmake install  
    to install into /usr/ntcc/...
    or, if PREFIX is defined in share/Make.local

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx MODDIR=yyy MANDIR=/zzz

NOTE:
-----
The library is installed as libpspline.a
Users should link with

-L<PREFIX>/lib -lpspline

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT: transp_support@pppl.gov

PortLib
=============================================

The module is available through the NTCC Webpage,
w3.pppl.gov/NTTC  under "Modules Library", as compressed
tarfile, portlib.tar.gz, and as zip archive, portlib.zip.
Alternatively it can be obtained from ftp.pppl.gov
in pub/NTCC/.

For documentation see:
http://w3.pppl.gov/ntcc/Port


o AUTHOR
  D. McCune dmccune@pppl.gov 

o CONTACT
  ntcc_webmaster@pppl.gov  
  D. McCune : dmccune@pppl.gov 
  C. Ludescher-Furth : cludesche@pppl.gov

****************
REVISION HISTORY
****************
      date         Description

  May 15, 1999  -- Created
  May 15, 2000  -- Update of README / Makefile

----------------------------------------------------------------

Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. RUNNING INSTRUCTIONS
   6. TESTING INSTRUCTIONS
   7. FINAL INSTALLATION
   8. ABSTRACT

************
1. CONTENTS:
************
   Makefile:     NOTE, "GNU make" must be used
                 (usually in /usr/gnu/bin or /usr/local/bin).
                 Main Makefile to invoke Makefile(s) in subdirectories
                 (allows for several modules to be built with one step).

-- in subdirectory portlib:

   README:   This file.  Brief descriptions of the other files, and
             instructions for compiling libportlib.a  and a test. 

   Makefile: Makefile to build library and test. 

   Sources to build libportlib.a:
             *.F, *.f, *.f9f, *.c, *.h

   Test program:  porttest.F  
     

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory share:
   Make.flags:  Include file for Makefile, to setup Flags, etc.


**************************
2. UNPACKING INSTRUCTIONS:
**************************

for tarfiles:
  > gunzip portlib.tar.gz
  > tar xvf portlib.tar

or, for zip archives:
  > unzip portlib.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?

When you extract the tar file you get three sub directories:
./portlib  --  sources and Makefile
./share    --  include file Make.flags 

The location of the following subtrees, containing binaries, can be
controlled via environment variable "OBJ".
   
test        : test program
lib         : the actual library modules
obj/portlib : temporary for objects


By default above directories are created in ./<MACHINE>/, where
MACHINE is defined in Make.flags.
e.g.: if you are running Linux, the destination would be ./LINUX/obj, etc.

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make  OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rational behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

*************************
4. BUILDING INSTRUCTIONS:
************************* 

> gmake            -- to build/link library and porttest

> gmake libs       -- to build library only
> gmake clean      -- to remove all .o files
> gmake realclean  -- to remove everything but sources.



Compiling on Linux:
-------------------

At present, there is no native Linux  fortran 90 compiler. However, many
vendors offer good quality compilers. The following have been successfully
used:

-Fujitsu f95
-PGI pgf77 / pgf90

By default the Makefile will select Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "NagWare"  "Fujitsu" or "Absoft"
e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

To use vastf90:
> gmake all VAST90=y

Caveat: Be careful to use the same compiler for all objects.


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option to link.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option to link.


***********
5. TESTING:
***********

cd <MACHINE>/test  or  cd $OBJ/test
./porttest

**********************
7. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in: $PREFIX/lib        = $LIBDIR       
man pages in: $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

> gmake install  
    to install into /usr/ntcc/...

> gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/yyy MANDIR=/zzz

NOTE:
-----
The library is installed as libportlib.a
Users should link with

-L<PREFIX>/lib -lportlib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.



************
8. ABSTRACT
************

There are a number of "operating systems support" functions that are frequently
needed in programs, for which no standard interface is available. Examples of 
such functions are: access to the shell, access to command line arguments, 
access to environment variables or VMS logical names, elapsed cpu time, and so
on. In UNIX terminology these are the fortran "3f" routines: system, getarg, 
getenv, etc. Accessing these routines requires slightly different code, 
depending on vendor or operating system.
    The portlib library provides a standardized portable interface to these 
routines, encapsulating the system to system variability, making it easier for 
the applications developer to achieve portability without the need to resort to
such techniques as conditional compilation via cpp directives. 

-------------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:


        Doug McCune, Princeton University
                dmccune@pppl.gov
        or

        Christiane Ludescher-Furth, Princeton University
                cludescher@pppl.gov
        or      
                ntcc_webmaster@pppl.gov

 
      SUBROUTINE SHOWFILE(IFILNAME,DEVNAM,LDEV,DIRNAM,LDIR)
C
C  GET THE CURRENT DEFAULT DISK AND DIRECTORY BY PARSING A DUMMY
C  FILENAME WITH THE RMS SERVICE CALL
C  DMC:  FOLLOWING HINTS BY M. THOMPSON
C
        CHARACTER*(*) IFILNAME  ! INPUT FILENAME
      CHARACTER*(*) DEVNAM  ! OUTPUT DEVICE NAME
      CHARACTER*(*) DIRNAM  ! OUTPUT DIRECTORY NAME
 
      INTEGER LDEV	      ! OUTPUT LENGTH OF DEVICE NAME
      INTEGER LDIR	      ! OUTPUT LENGTH OF DIRECTORY NAME
 
C-----------------------------------------------------------------------
C  VAX CODE
#ifdef __VMS
      CHARACTER*127 XPDNAM
      CHARACTER*127 IFILNAMI
C
C  RMS CONTROL BLOCK DECLARATIONS
C
 
      INCLUDE '($FABDEF)'
      INCLUDE '($NAMDEF)'
 
      RECORD /FABDEF/ DFAB
      RECORD /NAMDEF/ DNAM
 
      LDEVMAX=LEN(DEVNAM)
      LDIRMAX=LEN(DIRNAM)
C
      IFILNAMI=IFILNAME
C
C  SET UP FILE ACCESS BLOCK (FAB) AND RMS NAME BLOCK (NAM)
C
      DFAB.FAB$B_BID = FAB$C_BID
      DFAB.FAB$B_BLN = FAB$C_BLN
      DFAB.FAB$L_FNA = %LOC(IFILNAMI)
      DFAB.FAB$B_FNS = LEN(IFILNAMI)
      DFAB.FAB$W_IFI = 0
      DFAB.FAB$L_NAM = %LOC(DNAM)
 
      DNAM.NAM$B_BID = NAM$C_BID
      DNAM.NAM$B_BLN = NAM$C_BLN
      DNAM.NAM$L_ESA = %LOC(XPDNAM)
      DNAM.NAM$B_ESS = LEN(XPDNAM)
 
      CALL SYS$PARSE(DFAB)
 
      LENDEV = DNAM.NAM$B_DEV
      LENDIR = DNAM.NAM$B_DIR
 
      IDEV=1
      IDIR=LENDEV+1
 
      LDEV=MIN0(LDEVMAX,LENDEV)
      DEVNAM(1:LDEV)=XPDNAM(IDEV:IDEV+LDEV-1)
 
      LDIR=MIN0(LDIRMAX,LENDIR)
      DIRNAM(1:LDIR)=XPDNAM(IDIR:IDIR+LDIR-1)
C
#endif
      RETURN
      END

! $Id: eztest.F90,v 1.5 2007-05-04 16:50:45 Ludescher-Furth Exp $
! lf95 -I${LOCAL}/mod eztest.f90 ${LOCAL}/lib/ezcdf.a /usr/local/lib/libnetcdf.a 
! lf95 -I/usr/local/include -I./LINUX/mod eztest.f90 ./LINUX/lib/ezcdf.a /usr/local/lib/libnetcdf.a
! ifc -w -I./LINUX/mod eztest.f90 ./LINUX/lib/ezcdf.a /usr/local/lib/libnetcdf.a 

PROGRAM eztest

  call SampleWrite
  call SampleRead
  call OldSyntaxWrite
  call OldSyntaxRead
  call mixNetcdfEzcdf
  call BigFile

END PROGRAM eztest

subroutine BigFile
  use ezcdf
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  integer, parameter :: n1=20, n2=40, n3=300
  integer, parameter :: nd1=1, nd2=2, nd3=3
  integer :: ai(n1,n2,n3), bi(n1+nd1,n2+nd2,n3+nd3)
  real :: ar(n1,n2,n3), br(n1+nd1,n2+nd2,n3+nd3)
  real(r8) :: ar8(n1,n2,n3), br8(n1+nd1,n2+nd2,n3+nd3)
  complex :: ac8(n1,n2,n3), bc8(n1+nd1,n2+nd2,n3+nd3)
  complex(r8) :: ac16(n1,n2,n3), bc16(n1+nd1,n2+nd2,n3+nd3)
  integer :: ci(n2,n3), di(n2+nd2,n3+nd3)
  integer :: cr(n2,n3), dr(n2+nd2,n3+nd3)
  integer :: cr8(n2,n3), dr8(n2+nd2,n3+nd3)
  integer :: cc8(n2,n3), dc8(n2+nd2,n3+nd3)
  integer :: cc16(n2,n3), dc16(n2+nd2,n3+nd3)
  real :: tic, tac
  
  integer i, j, k, ncid, no_errors
#ifdef __UNIX
#if __HP || __NAGWARE
      integer :: cpclock
#elif __CRAY || __X1
      real :: second
#elif __ABS
      real :: etime_
      real :: tarray(2)
#else
      real :: etime
      real :: tarray(2)
#endif
#endif  /* __UNIX */
  
  do k = 1, n3
     do j = 1, n2
        ci(j,k) = 10*j + k
        cr(j,k) = 10*j + k + 0.1
        cr8(j,k) = 10*j + k + 0.1_r8
        cc8(j,k) = 10*j + k + 0.1
        cc16(j,k) = 10*j + k + 0.1_r8
        do i = 1, n1
           ai(i,j,k) = 100*i + 10*j + k
           ar(i,j,k) = 100*i + 10*j + k + 0.1
           ar8(i,j,k) = 100*i + 10*j + k + 0.1_r8
           ac8(i,j,k) = 100*i + 10*j + k + 0.1
           ac16(i,j,k) = 100*i + 10*j + k + 0.1_r8
        enddo
     enddo
  enddo
  call cdf_open(ncid, 'bigFile.nc', 'w')
  call cdf_define(ncid, 'ai', ai)
  call cdf_define(ncid, 'ar', ar)
  call cdf_define(ncid, 'ar8', ar8)
  call cdf_define(ncid, 'ac8', ac8)
  call cdf_define(ncid, 'ac16', ac16)
  call cdf_define(ncid, 'ci', ci)
  call cdf_define(ncid, 'cr', cr)
  call cdf_define(ncid, 'cr8', cr8)
  call cdf_define(ncid, 'cc8', cc8)
  call cdf_define(ncid, 'cc16', cc16)
  print *,' writing data ...'
  call cdf_write(ncid, 'ai', ai)
  call cdf_write(ncid, 'ar', ar)
  call cdf_write(ncid, 'ar8', ar8)
  call cdf_write(ncid, 'ac8', ac8)
  call cdf_write(ncid, 'ac16', ac16)
  call cdf_write(ncid, 'ci', ci)
  call cdf_write(ncid, 'cr', cr)
  call cdf_write(ncid, 'cr8', cr8)
  call cdf_write(ncid, 'cc8', cc8)
  call cdf_write(ncid, 'cc16', cc16)
  call cdf_close(ncid)  

  call cdf_open(ncid, 'bigFile.nc', 'r')

#ifdef __UNIX 
#if __FUJITSU || __OSX || __IBM || __RS6000 
      call cpu_time(tic)    ! not portable
#elif __HP || __NAGWARE
      tic = 1.0e-6*cpclock()
#elif __CRAY || __X1
      tic = second()
#elif __ABS
      tic = etime_(tarray)
#else
      tic = etime(tarray)
#endif
 
#endif  /* __UNIX */
!  call cpu_time(tic)
  print *,' reading data ...'
  call cdf_read(ncid, 'ai', bi)
  call cdf_read(ncid, 'ar', br)
  call cdf_read(ncid, 'ar8', br8)
  call cdf_read(ncid, 'ac8', bc8)
  call cdf_read(ncid, 'ac16', bc16)
  call cdf_read(ncid, 'ci', di)
  call cdf_read(ncid, 'cr', dr)
  call cdf_read(ncid, 'cr8', dr8)
  call cdf_read(ncid, 'cc8', dc8)
  call cdf_read(ncid, 'cc16', dc16)
#ifdef __UNIX 
#if __FUJITSU || __OSX || __IBM || __RS6000 
      call cpu_time(tac)    ! not portable
#elif __HP || __NAGWARE
      tac = 1.0e-6*cpclock()
#elif __CRAY || __X1
      tac = second()
#elif __ABS
      tac = etime_(tarray)
#else
      tac = etime(tarray)
#endif
 
#endif  /* __UNIX */

  call cdf_close(ncid)  
  print *,' checking data ...'
  no_errors = 0
  do k = 1, n3
     do j = 1, n2
        if(ci(j,k)/=di(j,k)) no_errors = no_errors+1
        if(cr(j,k)/=dr(j,k)) no_errors = no_errors+1
        if(cr8(j,k)/=dr8(j,k)) no_errors = no_errors+1
        if(cc8(j,k)/=dc8(j,k)) no_errors = no_errors+1
        if(cc16(j,k)/=dc16(j,k)) no_errors = no_errors+1        
        do i = 1, n1
           if(ai(i,j,k) /= bi(i,j,k)) no_errors = no_errors+1
           if(ar(i,j,k) /= br(i,j,k)) no_errors = no_errors+1
           if(ar8(i,j,k) /= br8(i,j,k)) no_errors = no_errors+1
           if(ac8(i,j,k) /= bc8(i,j,k)) then
              print *,i,j,k, ac8(i,j,k), bc8(i,j,k)
              no_errors = no_errors+1
           endif
!!$           if(ac16(i,j,k) /= bc16(i,j,k)) no_errors = no_errors+1
        enddo
     enddo
  enddo
  print *,' cpu time (read): ', tac-tic
  print *, no_errors, ' errors after BigFile'

end subroutine BigFile

subroutine mixNetcdfEzcdf

  ! Mixing ezcdf and netcdf calls

  use ezcdf
  implicit none
!!$  include 'netcdf.inc'

  integer ScalarInt
  integer :: ScalarInt_id, ier, fid
  character(NF_MAX_NAME) :: dim_names(3)

  ! write

  call ezcdf_open(fid, 'EZtest3.nc', 'w', ier)
  call ezcdf_close(fid, ier)

  ! read 

  call ezcdf_open(fid, 'EZtest.nc', 'r', ier)
  ier = NF_INQ_VARID(fid, 'ScalarInt', ScalarInt_id)
  ier = NF_GET_VAR_INT(fid, ScalarInt_id, ScalarInt)
  print *,' ScalarInt = ', ScalarInt
  call ezcdf_close(fid, ier)


  

end subroutine mixNetcdfEzcdf

subroutine OldSyntaxWrite

  use ezcdf
  implicit none
  integer ncid
  call cdfOpn(ncid, 'test2.nc', 'w')
  call cdfDefVar(ncid, 'myvar', (/1,1,1/), 'LOG')
  call cdfPutVar(ncid, 'myvar', .TRUE.)
  call cdfCls(ncid)

end subroutine OldSyntaxWrite

subroutine OldSyntaxRead

  use ezcdf
  implicit none
  integer ncid
  integer dimlens(3)
  character(5) :: xtype
  logical myvar
  call cdfOpn(ncid, 'test2.nc', 'r')
  call cdfInqVar(ncid, 'myvar', dimlens, xtype)
  call cdfGetVar(ncid, 'myvar', myvar)
  if(.not. myvar) stop '1 error in OldSyntaxRead'
  call cdfCls(ncid)

end subroutine OldSyntaxRead
  


subroutine SampleWrite
! Sample to Write / Read netCDF dataset
! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
! Added logicals S. Hirshman Oct 2 2002
      USE ezcdf
      IMPLICIT NONE
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
! Variables to be written
      character :: a = 'a'
      character(25)                  :: title =                         &
     &                                  "Test of EZcdf Interface"
      character(8), dimension(2)      :: comment =                       &
     &                                  (/"Written ","02/15/99"/)
      character(8), dimension(2)      :: comment_a =                     &
     &                                  (/"Written ","10/02/02"/)
      real (KIND=r8)                 :: scalar = 999.99_r8
      integer                        :: scalar_int = 33
      integer,        dimension(5)   :: ival = (/1,2,3,4,5/)
      logical,        dimension(4)   :: lval = (/.true.,.false.,.false., .true./)
      logical,        dimension(4,2) :: lval2
      real (KIND=r8), dimension(3,4) :: dval =                          &
     &       reshape ( (/11.1_r8, 12.2_r8, 13.3_r8,                     &
     &                   21.1_r8, 22.2_r8, 23.3_r8,                     &
     &                   31.1_r8, 32.2_r8, 33.3_r8,                     &
     &                   41.1_r8, 42.2_r8, 43.3_r8/),                   &
     &                  (/3,4/))
      real (KIND=r4), dimension(3,4,2) :: fval =            &
     &       reshape ( (/                                   &
     &                   1.1, 1.2, 1.3,                     &
     &                   2.1, 2.2, 2.3,                     &
     &                   3.1, 3.2, 3.3,                     &
     &                   4.1, 4.2, 4.3,                     &
     &                   5.1, 5.2, 5.3,                     &
     &                   6.1, 6.2, 6.3,                     &
     &                   7.1, 7.2, 7.3,                     &
     &                   8.1, 8.2, 8.3                      &
     &                  /),                                 &
     &                  (/3,4,2/))
      complex(KIND=r8) :: c16val_0,  c16val_1(5), c16val_2(3,4), c16val_3(3,4,2)
      complex(KIND=r4) :: c8val_0,  c8val_1(5), c8val_2(3,4), c8val_3(3,4,2)
      integer :: intarray(-3:2) = (/ -3, -2, -1, 0, 1, 2/)

! to define Variables
      integer, dimension(3) :: dimlens = (/1,1,1/)
      integer               :: ncid
      integer               :: ier
       
!
!----------------------------------------
! Create File
      call cdf_open(ncid,'EZtest.nc','w',ier)
      if (ier .ne. 0) then
         print *,'Error creating file'
         stop
      end if
! Define Variables
! Title
      dimlens(1)=len(title)
      call cdf_define(ncid, 'a', a)
      call cdf_define(ncid,'Title',dimlens,'CHAR',ier)  ! ier = optional
      call cdf_define(ncid,'Title-A', title)
      if (ier .ne. 0) stop
! Comment
      dimlens(1)=len(comment(1))
      dimlens(2)=size(comment)
      call cdf_define(ncid,'Comment',dimlens,'CHAR')
      call cdf_define(ncid,'Comment-A', comment_a)
! Scalar
      dimlens(1)=1
      dimlens(2)=1
      call cdf_define(ncid,'Scalar',dimlens,'R8')

! 1D-INT
      dimlens(1)=size(ival)
      call cdf_define(ncid,'1D-INT',dimlens,'INT')
      call cdf_define(ncid, '1d_array_with_indexing_starting_at_-3', intarray, ier)
      ! we can set attributes
      call cdf_setatt(ncid, '1D-INT', 'this is the long name of 1D-INT', 'Wb', ier)
      call cdf_define(ncid,'1D-INTa',ival,dimname=(/'radius'/))
      ! without error code
      call cdf_setatt(ncid, '1D-INTa','long name of 1D-INTa', 'm')
      
      dimlens = (/ 1,1,1 /)
      call cdf_define(ncid,'ScalarInt',dimlens,'INT')
      call cdf_define(ncid,'ScalarInta',scalar_int)
! 2D-R8
      dimlens(1)=3
      dimlens(2)=4
      call cdf_define(ncid,'2D-R8',dimlens,'R8')
      call cdf_define(ncid,'2D-R8a',dval,dimname=(/'x_coord','y_coord'/))
! 3D-R4
      dimlens(1)=3
      dimlens(2)=4
      dimlens(3)=2
      call cdf_define(ncid,'3D-R4',dimlens,'R4')
! Complex
      dimlens = 0
      call cdf_define(ncid,'Scalar_C16',dimlens,'C16')
      call cdf_define(ncid,'Scalar_C8',dimlens,'C8')
      dimlens = (/ 5, 1, 1 /)
      call cdf_define(ncid,'1D_C16',dimlens,'C16')
      call cdf_define(ncid,'1D_C8',dimlens,'C8')
      dimlens = (/ 3, 4, 1 /)
      call cdf_define(ncid,'2D_C16',dimlens,'C16')
      call cdf_setatt(ncid,'2D_C16', 'complex data have their name mangled', 'kA')
      call cdf_define(ncid,'2D_C8',dimlens,'C8')
      dimlens = (/ 3, 4, 2 /)
      call cdf_define(ncid,'3D_C16',dimlens,'C16')
      call cdf_define(ncid,'3D_C8',dimlens,'C8')

      c16val_0 = scalar * (1._r8, 2._r8)
      c16val_1 = ival * (1._r8, 2._r8)
      c16val_2 = dval * (1._r8, 2._r8)
      c16val_3 = fval * (1._r8, 2._r8)
      c8val_0 = scalar * (3._r4, 4._r4)
      c8val_1 = ival * (3._r4, 4._r4)
      c8val_2 = dval * (3._r4, 4._r4)
      c8val_3 = fval * (3._r4, 4._r4)
! 1D Logical
      dimlens = (/ size(lval), 1, 1 /)
      call cdf_define(ncid,'1D-LOG',dimlens,'LOG')
      ! units are optional
      call cdf_setatt(ncid,'1D-LOG', 'logicals are stored with appending __logical__')
! 2D Logical
      dimlens = (/ size(lval2,1), size(lval2,2), 1 /)
      call cdf_define(ncid,'2D-LOG',dimlens,'LOG')
      lval2(:,1) = lval
      lval2(:,2) = .not.lval
     
!
! Write Variables
      call cdf_write(ncid, 'a', a)
      call cdf_write(ncid,'Title',title,ier)   ! ier = optional
      call cdf_write(ncid,'Title-A',title,ier)  
      if (ier .ne. 0) stop
      call cdf_write(ncid,'Comment',comment)
      call cdf_write(ncid,'Comment-A',comment_a)
      call cdf_write(ncid,'Scalar',scalar)
      call cdf_write(ncid,'2D-R8',dval)
      call cdf_write(ncid,'2D-R8a',dval)
      call cdf_write(ncid,'3D-R4',fval)
      call cdf_write(ncid,'1D-INT',ival)
      call cdf_write(ncid,'1D-INTa',ival)
      call cdf_write(ncid,'1d_array_with_indexing_starting_at_-3', intarray, ier)
      call cdf_write(ncid,'Scalar_C16',c16val_0)
      call cdf_write(ncid,'1D_C16',c16val_1)
      call cdf_write(ncid,'2D_C16',c16val_2)
      call cdf_write(ncid,'3D_C16',c16val_3)
      call cdf_write(ncid,'Scalar_C8',C8val_0)
      call cdf_write(ncid,'1D_C8',C8val_1)
      call cdf_write(ncid,'2D_C8',C8val_2)
      call cdf_write(ncid,'3D_C8',C8val_3)
      call cdf_write(ncid,'1D-LOG',lval)
      call cdf_write(ncid,'2D-LOG',lval2)

      call cdf_write(ncid,'ScalarInt',scalar_int)
      call cdf_write(ncid,'ScalarInta',scalar_int)

      call cdf_close(ncid ,ier)
!
! Now read back
      call SampleRead

    END subroutine SampleWrite

!========================================================================
      SUBROUTINE SampleRead
      USE ezcdf
      implicit none
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
! netCDF data sets:
      real (KIND=r8), dimension(:,:), allocatable :: dval, dval_a
      real (KIND=r4), dimension(:,:,:), allocatable :: fval
      integer,        dimension(:),   allocatable :: ival
      logical,        dimension(:),   allocatable :: lval
      logical,        dimension(:,:), allocatable :: lval2
      integer                                     :: scalarInt, scalarInta
      real (KIND=r8)                              :: scalar
      character :: a
      character(25)                                :: title, title_a
      character(8), dimension(2)                   :: comment, comment_a
      complex(KIND=r8) :: c16val_0
      complex(KIND=r8), allocatable :: c16val_1(:), c16val_2(:,:), &
           & c16val_3(:,:,:)
      complex(KIND=r4) :: c8val_0
      complex(KIND=r4), allocatable :: c8val_1(:), c8val_2(:,:), &
           & c8val_3(:,:,:)
      integer, dimension(-3:2) :: intarray
! Local
      integer                 :: ncid
      integer                 :: ierror
      integer, dimension(3)   :: dimlens = (/1,1,1/)
      character(4)            :: xtype
!
      integer                 :: i, j, k, ner
      character(80) :: longname, units
      integer ier
!----------------------------------------------------------------

      ner = 0
      print "(/'Read again:'/)"
! Open File
      call cdf_open(ncid,'EZtest.nc','r')
! Inquire dimensions and type of Variable
! 1D-INT
      call cdf_inquire(ncid,'1D-INT',dimlens,ier=ierror)  
      ALLOCATE( ival(dimlens(1)), STAT=ierror )
      call cdf_getatt(ncid, '1D-INT', longname, units, ier)
      print *,' -- 1D-INT: ',trim(longname), ' units=', trim(units), ' ier=', ier
      call cdf_inquire(ncid, '1d_array_with_indexing_starting_at_-3', dimlens, xtype)
      print *,' variable 1d_array_with_indexing_starting_at_-3 has dimlens=', dimlens, ' and type ', xtype
! 1D-LOG
      call cdf_inquire(ncid,'1D-LOG',dimlens,ier=ierror)
      call cdf_getatt(ncid, '1D-LOG', longname, units)
      print *,' -- 1D-LOG: ',trim(longname), ' units=', trim(units)
      ALLOCATE( lval(dimlens(1)), STAT=ierror)
! 2D-LOG
      call cdf_inquire(ncid,'2D-LOG',dimlens,ier=ierror)
      ALLOCATE( lval2(dimlens(1), dimlens(2)), STAT=ierror)
! 2D-R8
      call cdf_inquire(ncid,'2D-R8',dimlens)
      ALLOCATE( dval(dimlens(1),dimlens(2)), STAT=ierror )
      call cdf_inquire(ncid,'2D-R8a',dimlens)
      ALLOCATE( dval_a(dimlens(1),dimlens(2)), STAT=ierror )
! 2D-R4
      call cdf_inquire(ncid,'3D-R4',dimlens)
      ALLOCATE( fval(dimlens(1),dimlens(2),dimlens(3)), STAT=ierror )
! Comment
      call cdf_inquire(ncid,'Comment',dimlens)
! Complex
      call cdf_inquire(ncid,'Scalar_C16',dimlens)
      print "('Scalar_C16 dims=',3I4, 2x, a)", dimlens, xtype
      call cdf_inquire(ncid,'1D_C16',dimlens,xtype)
      print "('1D_C16 dims=',3I4, 2x, a)", dimlens, xtype
      allocate(c16val_1(dimlens(1)))
      call cdf_inquire(ncid,'1D_C8',dimlens)
      allocate(c8val_1(dimlens(1)))
      call cdf_inquire(ncid,'2D_C16',dimlens,xtype)
      print "('2D_C16 dims=',3I4, 2x, a)", dimlens, xtype
      allocate(c16val_2(dimlens(1), dimlens(2)))
      call cdf_getatt(ncid, '2D_C16', longname, units, ier)
      print *,' -- 2D_C16: ',trim(longname), ' units=', trim(units), ' ier=', ier
      call cdf_inquire(ncid,'2D_C8',dimlens)
      allocate(c8val_2(dimlens(1), dimlens(2)))
      call cdf_inquire(ncid,'3D_C16',dimlens,xtype)
      print "('3D_C16 dims=',3I4, 2x, a)", dimlens, xtype
      allocate(c16val_3(dimlens(1), dimlens(2), dimlens(3)))
      call cdf_inquire(ncid,'3D_C8',dimlens)
      allocate(c8val_3(dimlens(1), dimlens(2), dimlens(3)))
!
! Get data
      call cdf_read(ncid, 'a', a)
      call cdf_read(ncid,'Title',title,ierror)             ! ierror = optional
      call cdf_read(ncid,'Title-A',title_a,ierror)    
      print *,'Title:   ',title
      print *,'Title-A: ',title_a
      call cdf_read(ncid,'Comment',comment)
      print *,'Comment(1): ',comment(1)
      print *,'Comment(2): ',comment(2)
      call cdf_read(ncid,'Comment-A',comment_a)
      print *,'Comment-A(1): ',comment_a(1)
      print *,'Comment-A(2): ',comment_a(2)
      call cdf_read(ncid,'Scalar',scalar)
      print *,'Scalar:  ',scalar
      call cdf_read(ncid,'1D-INT',ival)
      print *,'1d-INT:  ',ival
      call cdf_read(ncid,'1D-LOG',lval)
      print *,'1d-LOG:  ',lval
      call cdf_read(ncid,'2D-LOG',lval2)
      print *,'2d-LOG:  ',lval2
      call cdf_read(ncid,'2D-R8',dval)
      call cdf_read(ncid,'2D-R8a',dval_a)
      call cdf_read(ncid,'3D-R4',fval)
      call cdf_read(ncid,'Scalar_C16',c16val_0)
      call cdf_read(ncid,'1D_C16',c16val_1)
      call cdf_read(ncid,'2D_C16',c16val_2)
      call cdf_read(ncid,'3D_C16',c16val_3)
      call cdf_read(ncid,'Scalar_C8',C8val_0)
      call cdf_read(ncid,'1D_C8',C8val_1)
      call cdf_read(ncid,'2D_C8',C8val_2)
      call cdf_read(ncid,'3D_C8',C8val_3)

      call cdf_read(ncid,'ScalarInt',scalarInt)
      call cdf_read(ncid,'ScalarInta',scalarInta)

      print *,' Scalar Int = ', scalarInt, ' Alternative form = ', scalarInta

      print *,'2D-R8:'
      do i=1,4
         print *,dval(:,i)
      end do
      print *,'2D-R8a:'
      do i=1,4
         print *,dval_a(:,i)
      end do
      print *,'3D-R4:'
      do i=1,2
         print *,(fval(:,j,i),j=1,4)
      end do

      if(c16val_0 /= scalar * (1._r8, 2._r8)) ner = ner + 1

      do i = 1, size(ival)
         if(c16val_1(i) /= ival(i) * (1._r8, 2._r8)) ner = ner + 1
      enddo

      do j = 1, size(dval, 2)
         do i = 1, size(dval, 1)
            if(c16val_2(i,j) /= dval(i,j) * (1._r8, 2._r8)) ner = ner + 1
         enddo
      enddo

      do k = 1, size(fval, 3)
         do j = 1, size(fval, 2)
            do i = 1, size(fval, 1)
               if(c16val_3(i,j,k) /= fval(i,j,k) * (1._r8, 2._r8)) ner = ner + 1
            enddo
         enddo
      enddo
      print *,ner,' errors occurred while reading in complex data'
      
    END SUBROUTINE SampleRead

      subroutine sget_host(host)
      implicit none
      character*(*) host                ! computer host name, returned.
      integer ix                        ! loop variable
C
C  get the hostname, on various systems...
C
#ifdef __VMS
      include '($SYIDEF)'
#endif
#ifdef __UNIX
 
#if __CRAY || __X1
      character dummy(4)
      integer junam,ierr,ilen,stat
#elif __HP || __IBM || __RS6000
      integer gethostname
#else
      integer hostnm
#endif
 
      do ix=1,len(host)
         host(ix:ix)=' '  ! RGA, clear host in compiler safe manner for str_pad
      end do
#endif /* __UNIX  */
 
#ifdef __VMS
      call lib$getsyi(SYI$_NODENAME,,host,,,)
#endif
 
#ifdef __UNIX
 
#if __CRAY || __X1
      stat=0
      call pxfstructcreate('utsname',junam,ierr)
      stat=stat+abs(ierr)
      call pxfuname(junam,ierr)
      stat=stat+abs(ierr)
      ilen=0
      call pxfstrget(junam,'nodename',host,ilen,ierr)
      stat=stat+abs(ierr)
      call pxfstructfree(junam,ierr)
      if (stat/=0) host='UNKNOWN'
#elif __HP || __IBM || __RS6000
      if (gethostname(host) .ne. 0) host='UNKNOWN'
#else
      if (hostnm(host) .ne. 0) host='UNKNOWN'
#endif
 
#endif  /*  __UNIX  */
      call str_pad(host)
C
      return
      end

C***********************************************************************
      SUBROUTINE TERM_OUT(BUFFER,NBYTES)
C
      implicit none
C
#include "fpreproc/byte_declare.h"
C
C...This routine was written by Harry H. Towner of the Princeton
C...Plasma Physics Lab. This routine is similar to John Coonrod's
C...routine JC_LINE. This routine will output NBYTES of array BUFFER
C...to the user's terminal
C
C...Parameters:
C*..BUFFER	- Array of NBYTES to be sent to ther user's terminal.
C*..NBYTES	- The number of bytes to be sent to the terminal
C
C***********************************************************************
C
      integer nbytes
      byte_declare BUFFER(NBYTES)
C
#ifdef __VMS
	INCLUDE '($IODEF)'
	INTEGER SYS$ASSIGN,SYS$QIOW,IOS(2)	
	INTEGER*2 ICHAN	
C	
        integer ifunc,istat
C
C...Define function for passall style output	
C	
	IFUNC=IOR(IO$_WRITEVBLK,IO$M_NOFORMAT)	
C	
	DATA ICHAN/0/	
C	
C***********************************************************************	
C	
C...Obtain channel if necessary.	
C	
	IF(ICHAN.EQ.0) THEN	
	  ISTAT=SYS$ASSIGN('TT',ICHAN,,)	
	END IF	
C	
	ISTAT=SYS$QIOW(,%VAL(ICHAN),%VAL(IFUNC),IOS,,,%REF(BUFFER),	
     >		%VAL(NBYTES),,,,)
C
#endif
C-----------------------------------------------------------------------
C  UNIX CODE
C
#ifdef __UNIX
      INTEGER ITEMP,ISTAT,I,ZPUTC
C
      DO I=1,NBYTES
#if __CRAY || __SX
        ITEMP=ichar(BUFFER(I))
#else	
        ITEMP=BUFFER(I)
#endif	
        ISTAT=ZPUTC(ITEMP)	
      END DO	
C
#endif
      RETURN
      END
C-----------------------
      subroutine term_str_out(str)
      implicit none
C
      character*(*) str
C
      integer NBSIZ
      parameter (NBSIZ=128)
C
      byte_declare BUFFER(NBSIZ)
C
      integer ilen,ic0,ice,inb,i,ic,str_length
C
      ilen=str_length(str)
C
      do ic0=1,ilen,NBSIZ
         ice=min(ilen,(ic0+NBSIZ-1))
         inb=ice-ic0+1
         do i=1,inb
            ic=ic0+i-1
#if __CRAY || __SX
            buffer(i)=str(ic:ic)
#else
            buffer(i)=ichar(str(ic:ic))
#endif
         enddo
C
         call term_out(buffer,inb)
      enddo
C
      return
      end

subroutine vecintrp3d(ict,ivec,xvec,yvec,zvec,ivd,fval, &
     nx,xpkg,ny,ypkg,nz,zpkg,jspline,fspl,icoeff,ixdim,iydim,izdim, &
     iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !
  !  vectorized hybrid spline evaluation routine -- 3d
  !  1.  call vectorized zone lookup routine
  !  2.  call vectorized hybrid spline evaluation routine
  !
  !--------------------------
  !  input:
  !============
  implicit none
  real(fp) :: stat
  !============
  integer ict(10)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate if ict(1)=0)
  !        ict(2)=1 for df/dx  (don't evaluate if ict(2)=0)
  !        ict(3)=1 for df/dy  (don't evaluate if ict(3)=0)
  !        ict(4)=1 for df/dy  (don't evaluate if ict(4)=0)
  !        ict(5)=1 for d2f/dx2 (don't evaluate if ict(5)=0)
  !        ict(6)=1 for d2f/dy2 (don't evaluate if ict(6)=0)
  !        ict(7)=1 for d2f/dz2 (don't evaluate if ict(7)=0)
  !        ict(8)=1 for d2f/dxdy (don't evaluate if ict(8)=0)
  !        ict(9)=1 for d2f/dxdz (don't evaluate if ict(9)=0)
  !        ict(10)=1 for d2f/dydz (don't evaluate if ict(10)=0)
  !
  !     higher derivatives can be selected by setting ict(1)=3,-3,4,-4,...
  !     see fvtricub.f90 comments.
  !
  !     in hybrid spline evaluation, any derivative along a dimension
  !     with zonal interpolation (jspline(i)=-1) gives zero;
  !
  !     piecewise linear and Hermite interpolation give zero if a 2nd or
  !     higher derivative is sought along any dimension.
  !
  integer ivec                      ! vector dimensioning
  !
  !    ivec-- number of vector pts (spline values to look up)
  !
  !  list of (x,y,z) triples:
  !
  real(fp) :: xvec(ivec)                   ! x-locations at which to evaluate
  real(fp) :: yvec(ivec)                   ! y-locations at which to evaluate
  real(fp) :: zvec(ivec)                   ! z-locations at which to evaluate
  !
  integer ivd                       ! 1st dimension of output array
  !
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                  ! output array
  !
  !  fval(1:ivec,1) -- values as per 1st non-zero ict(...) element
  !  fval(1:ivec,2) -- values as per 2nd non-zero ict(...) element
  !   --etc--
  !
  ! input:
  integer nx,ny,nz                  ! dimension of spline grids
  real(fp) :: xpkg(nx,4)                   ! x grid "package" (cf genxpkg)
  real(fp) :: ypkg(ny,4)                   ! y grid "package" (cf genxpkg)
  real(fp) :: zpkg(nz,4)                   ! z grid "package" (cf genxpkg)
  !
  integer :: jspline(3)             ! interpolation method on each dim:
  !        jspline(1) for x; jspline(2) for y; jspline(3) for z
  !        -1: zonal step fcn; 0: pcwise linear; 1: Hermite; 2: compact spline
  !
  integer icoeff                    ! #coeffs per data node
  integer ixdim                     ! x dim for fspl
  integer iydim                     ! y dim for fspl
  integer izdim                     ! z dim for fspl
  real(fp) :: fspl(icoeff,ixdim,iydim,izdim)     ! hybrid spline coefficients
  !
  !  ixdim=nx-1 for zonal step function along x dimension; o.w. expect ixdim=nx
  !  iydim=ny-1 for zonal step function along y dimension; o.w. expect iydim=ny
  !  izdim=nz-1 for zonal step function along z dimension; o.w. expect izdim=nz
  !
  ! output:
  ! condition codes, 0 = normal return
  integer iwarn                     ! =1 if an x value was out of range
  integer ier                       ! =1 if argument error detected
  !
  !---------------------------------------------------------------
  !  local arrays
  !
  integer :: iwarn1,iwarn2,iwarn3
  !
  integer, dimension(:), allocatable :: ix,iy,iz
  real(fp), dimension(:), allocatable :: dxn,dyn,dzn
  real(fp), dimension(:), allocatable :: hx,hxi,hy,hyi,hz,hzi
  !
  !---------------------------------------------------------------
  !
  !  error checks
  !
  ier=0
  !
  if(nx.lt.2) then
     write(6,*) ' ?vecintrp3d:  nx.lt.2:  nx = ',nx
     ier=1
  end if
  !
  if(ny.lt.2) then
     write(6,*) ' ?vecintrp3d:  ny.lt.2:  ny = ',ny
     ier=1
  end if
  !
  if(nz.lt.2) then
     write(6,*) ' ?vecintrp3d:  nz.lt.2:  nz = ',nz
     ier=1
  end if
  !
  call vecin3d_argchk('vecintrp3d',jspline, &
       icoeff,nx,ny,nz,ixdim,iydim,izdim,ier)
  !
  if(ivec.le.0) then
     write(6,*) ' ?vecintrp3d:  vector dimension .le. 0:  ivec = ', &
          ivec
     ier=1
  end if
  !
  if(ivd.lt.ivec) then
     write(6,*) &
          ' ?vecintrp3d:  output vector dimension less than input ', &
          'vector dimension.'
     write(6,*) ' ivec=',ivec,' ivd=',ivd
     ier=1
  end if
  !
  if(ier.ne.0) return
  !
  allocate(ix(ivec), iy(ivec), iz(ivec), &
       dxn(ivec), dyn(ivec), dzn(ivec), &
       hx(ivec),  hy(ivec),  hz(ivec), &
       hxi(ivec), hyi(ivec), hzi(ivec), stat=ier)
  !
  if(ier.ne.0) then
     write(6,*) &
          ' ?vecintrp3d: memory allocation failure.'
     ier=99
  end if
  !
  if(ier.ne.0) return
  !
  !  vectorized lookup
  !
  ix=0; iy=0; iz=0
  call xlookup(ivec,xvec,nx,xpkg,2,ix,dxn,hx,hxi,iwarn1)
  call xlookup(ivec,yvec,ny,ypkg,2,iy,dyn,hy,hyi,iwarn2)
  call xlookup(ivec,zvec,nz,zpkg,2,iz,dzn,hz,hzi,iwarn3)
  iwarn=max(iwarn1,iwarn2,iwarn3)
  !
  !  vectorized evaluation
  !
  call fvintrp3d(ict,ivec,ivd,fval,ix,iy,iz,dxn,dyn,dzn, &
       hx,hxi,hy,hyi,hz,hzi,jspline,fspl,icoeff,ixdim,iydim,izdim)
  !
  deallocate(ix,iy,iz,dxn,dyn,dzn,hx,hy,hz,hxi,hyi,hzi)
  !
  return
end subroutine vecintrp3d

subroutine EZspline_setup1(spline_o, f, ier, exact_dim)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  real(fp), dimension(:), intent(in) :: f
  ! ier:
  ! 0=ok
  ! 98=some error occurred in EZspline_setup
  integer, intent(out) :: ier

  logical, intent(in), OPTIONAL :: exact_dim  ! set T to require exact 
  !  dimensioning match between f and spline_o%fspl; default is F

  logical :: iexact
  integer ifail

  integer :: ipx
  integer iper, imsg, itol, inum, in1
  real(fp) ztol, df1, df2

  !-------------------------
  iexact=.FALSE.
  if(present(exact_dim)) iexact = exact_dim

  if( .not.EZspline_allocated(spline_o) ) then
     ier = 98
     return
  end if

  in1 = size(spline_o%fspl,2)

  ier = 57
  if(size(f,1).lt.in1) return

  if(iexact) then
     ier = 58
     if(size(f,1).gt.in1) return
  end if
  ier = 0

  !
  ! recompute min/max in case user changed the grid manually
  spline_o%x1max = maxval(spline_o%x1)
  spline_o%x1min = minval(spline_o%x1)
  !
  ! set xpkg, useful for cloud and array interpolation
  imsg=0
  itol=0        ! range tolerance option
  ztol=5.e-7_fp ! range tolerance, if itol is set
  iper=0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) iper=1
  call genxpkg(spline_o%n1, spline_o%x1(1), spline_o%x1pkg(1,1),&
       & iper,imsg,itol,ztol, spline_o%klookup1 ,ifail)
  if(ifail/=0) ier=27

  spline_o%isReady = 0

  spline_o%fspl(1, 1:in1) = &
       &  f(1:in1)

  if (spline_o%isHermite == 0 .and. spline_o%isLinear == 0) then

     call mkspline(             &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%fspl(1,1), &
          &   spline_o%ibctype1(1), spline_o%bcval1min, &
          &   spline_o%ibctype1(2), spline_o%bcval1max, &
          &   spline_o%ilin1, ifail)

     if(ifail /= 0) then
        ier = 98
     else
        spline_o%isReady = 1
     end if

  else if (spline_o%isLinear == 1) then

     spline_o%ilin1=0
     if(in1.gt.2) then
        if(spline_o%x1pkg(3,4).eq.0.0_fp) spline_o%ilin1=1  ! evenly spaced grid
     else
        spline_o%ilin1=1
     end if

     spline_o%isReady = 1   ! no coefficient setup necessary

  else
     !
     ! Hermite polynomial coefficient setup based on Akima's method
     ! (df/dx..etc not required)
     !
     ipx = 0
     if (spline_o%ibctype1(1)==-1 .or. spline_o%ibctype1(2)==-1) then
        ipx=1
     else if (spline_o%ibctype1(1)<-1 .or. spline_o%ibctype1(1)>1 .or. &
          spline_o%ibctype1(2)<-1 .or. spline_o%ibctype1(2)>1 ) then
        ipx=99  ! an error...
     else if (spline_o%ibctype1(1)==1 .or. spline_o%ibctype1(2)==1) then
        ipx=2
        if(spline_o%ibctype1(1)==1) then
           spline_o%fspl(2,1)=spline_o%bcval1min
        else
           ! hand implemented default BC
           df1=(spline_o%fspl(1,2)-spline_o%fspl(1,1))/ &
                (spline_o%x1(2)-spline_o%x1(1))
           df2=(spline_o%fspl(1,3)-spline_o%fspl(1,2))/ &
                (spline_o%x1(3)-spline_o%x1(2))
           spline_o%fspl(2,1)=(3*df1-df2)/2
        end if
        inum=spline_o%n1
        if(spline_o%ibctype1(2)==1) then
           spline_o%fspl(2,inum)=spline_o%bcval1max
        else
           ! hand implemented default BC
           df1=(spline_o%fspl(1,inum)-spline_o%fspl(1,inum-1))/ &
                (spline_o%x1(inum)-spline_o%x1(inum-1))
           df2=(spline_o%fspl(1,inum-1)-spline_o%fspl(1,inum-2))/ &
                (spline_o%x1(inum-1)-spline_o%x1(inum-2))
           spline_o%fspl(2,inum)=(3*df1-df2)/2
        end if
     end if
     ifail = 0
     call akherm1p(spline_o%x1(1), spline_o%n1, &
          & spline_o%fspl(1,1), &
          & spline_o%ilin1, &
          & ipx, ifail)

     if (ifail /=0 ) then
        ier = 91
     else
        spline_o%isReady = 1
     end if

  end if


end subroutine EZspline_setup1


subroutine EZspline_setup2(spline_o, f, ier, exact_dim)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  real(fp), dimension(:,:), intent(in) :: f
  ! ier:
  ! 0=ok
  ! 98=some error occurred in EZspline_setup
  integer, intent(out) :: ier

  logical, intent(in), OPTIONAL :: exact_dim  ! set T to require exact
  !  dimensioning match between f and spline_o%fspl; default is F

  logical :: iexact
  integer ifail

  integer :: ipx, ipy
  integer iper, imsg, itol, inum, ii, jj, in0, in1, in2
  real(fp) ztol, df1, df2

  !-------------------------
  iexact=.FALSE.
  if(present(exact_dim)) iexact = exact_dim

  if( .not.EZspline_allocated(spline_o) ) then
     ier = 98
     return
  end if

  in0 = size(spline_o%fspl,1)
  in1 = size(spline_o%fspl,2)
  in2 = size(spline_o%fspl,3)

  ier = 57
  if(size(f,1).lt.in1) return
  if(size(f,2).lt.in2) return

  if(iexact) then
     ier = 58
     if(size(f,1).gt.in1) return
     if(size(f,2).gt.in2) return
  end if
  ier = 0

  !
  ! recompute min/max in case user changed the grid manually
  spline_o%x1max = maxval(spline_o%x1)
  spline_o%x2max = maxval(spline_o%x2)
  spline_o%x1min = minval(spline_o%x1)
  spline_o%x2min = minval(spline_o%x2)

  !
  ! set xpkg, useful for cloud and array interpolation
  imsg=0
  itol=0        ! range tolerance option
  ztol=5.e-7_fp ! range tolerance, if itol is set
  iper=0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) iper=1
  call genxpkg(spline_o%n1,spline_o%x1(1),spline_o%x1pkg(1,1),&
       & iper,imsg,itol,ztol,spline_o%klookup1,ifail)
  if(ifail/=0) ier=27
  iper=0
  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) iper=1
  call genxpkg(spline_o%n2,spline_o%x2(1),spline_o%x2pkg(1,1),&
       & iper,imsg,itol,ztol,spline_o%klookup2,ifail)
  if(ifail/=0) ier=27

  spline_o%isReady = 0

  spline_o%fspl(1, 1:in1, 1:in2) = &
       &  f(1:in1, 1:in2)

  ! this fixes a VMS f90 compiler optimizer problem:
  if(ztol.eq.-1.2345d30) &
       write(6,*) 'spline_o%fspl(1,1,1) = ', spline_o%fspl(1,1,1)

  if (spline_o%isHybrid == 1) then

     call mkintrp2d( &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%hspline, spline_o%fspl(1,1,1), &
          &   in0,in1,in2, &
          &   spline_o%ibctype1(1), spline_o%bcval1min(1), &
          &   spline_o%ibctype1(2), spline_o%bcval1max(1), &
          &   spline_o%ibctype2(1), spline_o%bcval2min(1), &
          &   spline_o%ibctype2(2), spline_o%bcval2max(1), &
          &   ifail)

     spline_o%ilin1 = 0  ! Hybrid does not compute this
     spline_o%ilin2 = 0  ! Hybrid does not compute this

     if(ifail /= 0) then
        ier = 98
     else
        spline_o%isReady = 1
     end if

  else if (spline_o%isHermite == 0 .and. spline_o%isLinear == 0) then

     call mkbicub(             &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   spline_o%ibctype1(1), spline_o%bcval1min(1), &
          &   spline_o%ibctype1(2), spline_o%bcval1max(1), &
          &   spline_o%ibctype2(1), spline_o%bcval2min(1), &
          &   spline_o%ibctype2(2), spline_o%bcval2max(1), &
          &   spline_o%ilin1, spline_o%ilin2, ifail)

     if(ifail /= 0) then
        ier = 98
     else
        spline_o%isReady = 1
     end if

  else if (spline_o%isLinear == 1) then

     spline_o%ilin1=0
     if(in1.gt.2) then
        if(spline_o%x1pkg(3,4).eq.0.0_fp) spline_o%ilin1=1  ! evenly spaced grid
     else
        spline_o%ilin1=1
     end if

     spline_o%ilin2=0
     if(in2.gt.2) then
        if(spline_o%x2pkg(3,4).eq.0.0_fp) spline_o%ilin2=1  ! evenly spaced grid
     else
        spline_o%ilin2=1
     end if

     spline_o%isReady = 1   ! no coefficient setup necessary

  else
     !
     ! Hermite polynomial coefficient setup based on Akima's method
     ! (df/dx..etc not required)
     !
     ipx = 0
     if (spline_o%ibctype1(1)==-1 .or. spline_o%ibctype1(2)==-1) then
        ipx=1
     else if (spline_o%ibctype1(1)<-1 .or. spline_o%ibctype1(1)>1 .or. &
          spline_o%ibctype1(2)<-1 .or. spline_o%ibctype1(2)>1 ) then
        ipx=99  ! an error...
     else if (spline_o%ibctype1(1)==1 .or. spline_o%ibctype1(2)==1) then
        ipx=2
        do jj=1,spline_o%n2
           if(spline_o%ibctype1(1)==1) then
              spline_o%fspl(2,1,jj)=spline_o%bcval1min(jj)
           else
              ! hand implemented default BC
              df1=(spline_o%fspl(1,2,jj)-spline_o%fspl(1,1,jj))/ &
                   (spline_o%x1(2)-spline_o%x1(1))
              df2=(spline_o%fspl(1,3,jj)-spline_o%fspl(1,2,jj))/ &
                   (spline_o%x1(3)-spline_o%x1(2))
              spline_o%fspl(2,1,jj)=(3*df1-df2)/2
           end if
           inum=spline_o%n1
           if(spline_o%ibctype1(2)==1) then
              spline_o%fspl(2,inum,jj)=spline_o%bcval1max(jj)
           else
              ! hand implemented default BC
              df1=(spline_o%fspl(1,inum,jj)-spline_o%fspl(1,inum-1,jj))/ &
                   (spline_o%x1(inum)-spline_o%x1(inum-1))
              df2=(spline_o%fspl(1,inum-1,jj)-spline_o%fspl(1,inum-2,jj))/ &
                   (spline_o%x1(inum-1)-spline_o%x1(inum-2))
              spline_o%fspl(2,inum,jj)=(3*df1-df2)/2
           end if
        end do
     end if
     ipy = 0
     if (spline_o%ibctype2(1)==-1 .or. spline_o%ibctype2(2)==-1) then
        ipy=1
     else if (spline_o%ibctype2(1)<-1 .or. spline_o%ibctype2(1)>1 .or. &
          spline_o%ibctype2(2)<-1 .or. spline_o%ibctype2(2)>1 ) then
        ipy=99  ! an error...
     else if (spline_o%ibctype2(1)==1 .or. spline_o%ibctype2(2)==1) then
        ipy=2
        do ii=1,spline_o%n1
           if(spline_o%ibctype2(1)==1) then
              spline_o%fspl(3,ii,1)=spline_o%bcval2min(ii)
           else
              ! hand implemented default BC
              df1=(spline_o%fspl(1,ii,2)-spline_o%fspl(1,ii,1))/ &
                   (spline_o%x2(2)-spline_o%x2(1))
              df2=(spline_o%fspl(1,ii,3)-spline_o%fspl(1,ii,2))/ &
                   (spline_o%x2(3)-spline_o%x2(2))
              spline_o%fspl(3,ii,1)=(3*df1-df2)/2
           end if
           inum=spline_o%n2
           if(spline_o%ibctype2(2)==1) then
              spline_o%fspl(3,ii,inum)=spline_o%bcval2max(ii)
           else
              ! hand implemented default BC
              df1=(spline_o%fspl(1,ii,inum)-spline_o%fspl(1,ii,inum-1))/ &
                   (spline_o%x2(inum)-spline_o%x2(inum-1))
              df2=(spline_o%fspl(1,ii,inum-1)-spline_o%fspl(1,ii,inum-2))/ &
                   (spline_o%x2(inum-1)-spline_o%x2(inum-2))
              spline_o%fspl(3,ii,inum)=(3*df1-df2)/2
           end if
        end do
     end if
     ifail = 0
     call akherm2p(spline_o%x1(1), spline_o%n1, &
          &         spline_o%x2(1), spline_o%n2, &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & spline_o%ilin1, spline_o%ilin2, &
          & ipx,ipy, ifail)

     if (ifail /=0 ) then
        ier = 91
     else
        spline_o%isReady = 1
     end if

  end if


end subroutine EZspline_setup2



subroutine EZspline_setup3(spline_o, f, ier, exact_dim)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  real(fp), dimension(:,:,:), intent(in) :: f
  ! ier:
  ! 0=ok
  ! 98=some error occurred in EZspline_setup
  integer, intent(out) :: ier

  logical, intent(in), OPTIONAL :: exact_dim  ! set T to require exact
  !  dimensioning match between f and spline_o%fspl; default is F

  logical :: iexact
  integer ifail

  integer :: ipx, ipy, ipz
  integer iper, imsg, itol, inum, ii, jj, in0, in1, in2, in3
  real(fp) ztol, df1, df2

  !-------------------------
  iexact=.FALSE.
  if(present(exact_dim)) iexact = exact_dim

  if( .not.EZspline_allocated(spline_o) ) then
     ier = 98
     return
  end if

  in0 = size(spline_o%fspl,1)
  in1 = size(spline_o%fspl,2)
  in2 = size(spline_o%fspl,3)
  in3 = size(spline_o%fspl,4)

  ier = 57
  if(size(f,1).lt.in1) return
  if(size(f,2).lt.in2) return
  if(size(f,3).lt.in3) return

  if(iexact) then
     ier = 58
     if(size(f,1).gt.in1) return
     if(size(f,2).gt.in2) return
     if(size(f,3).gt.in3) return
  end if
  ier = 0

  !
  ! recompute min/max in case user changed the grid manually
  spline_o%x1max = maxval(spline_o%x1)
  spline_o%x2max = maxval(spline_o%x2)
  spline_o%x3max = maxval(spline_o%x3)
  spline_o%x1min = minval(spline_o%x1)
  spline_o%x2min = minval(spline_o%x2)
  spline_o%x3min = minval(spline_o%x3)

  !
  ! set xpkg, useful for cloud and array interpolation
  imsg=0
  itol=0        ! range tolerance option
  ztol=5.e-7_fp ! range tolerance, if itol is set
  iper=0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) iper=1
  call genxpkg(spline_o%n1,spline_o%x1(1),spline_o%x1pkg(1,1),&
       & iper,imsg,itol,ztol,spline_o%klookup1,ifail)
  if(ifail/=0) ier=27
  iper=0
  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) iper=1
  call genxpkg(spline_o%n2,spline_o%x2(1),spline_o%x2pkg(1,1),&
       & iper,imsg,itol,ztol,spline_o%klookup2,ifail)
  if(ifail/=0) ier=27
  iper=0
  if(spline_o%ibctype3(1)==-1 .OR. spline_o%ibctype3(2)==-1) iper=1
  call genxpkg(spline_o%n3,spline_o%x3(1),spline_o%x3pkg(1,1),&
       & iper,imsg,itol,ztol,spline_o%klookup3,ifail)
  if(ifail/=0) ier=27

  spline_o%isReady = 0

  spline_o%fspl(1, 1:in1, 1:in2, 1:in3) = &
       &  f(1:in1, 1:in2, 1:in3)

  if (spline_o%isHybrid == 1) then

     call mkintrp3d( &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%hspline, spline_o%fspl(1,1,1,1), &
          &   in0,in1,in2,in3, &
          &   spline_o%ibctype1(1), spline_o%bcval1min(1,1), &
          &   spline_o%ibctype1(2), spline_o%bcval1max(1,1), &
          &   spline_o%ibctype2(1), spline_o%bcval2min(1,1), &
          &   spline_o%ibctype2(2), spline_o%bcval2max(1,1), &
          &   spline_o%ibctype3(1), spline_o%bcval3min(1,1), &
          &   spline_o%ibctype3(2), spline_o%bcval3max(1,1), &
          &   ifail)

     spline_o%ilin1 = 0  ! Hybrid does not compute this
     spline_o%ilin2 = 0  ! Hybrid does not compute this
     spline_o%ilin3 = 0  ! Hybrid does not compute this

     if(ifail /= 0) then
        ier = 98
     else
        spline_o%isReady = 1
     end if

  else if (spline_o%isHermite == 0 .and. spline_o%isLinear == 0) then

     call mktricub(             &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   spline_o%ibctype1(1), spline_o%bcval1min(1,1), &
          &   spline_o%ibctype1(2), spline_o%bcval1max(1,1), spline_o%n2, &
          &   spline_o%ibctype2(1), spline_o%bcval2min(1,1), &
          &   spline_o%ibctype2(2), spline_o%bcval2max(1,1), spline_o%n1, &
          &   spline_o%ibctype3(1), spline_o%bcval3min(1,1), &
          &   spline_o%ibctype3(2), spline_o%bcval3max(1,1), spline_o%n1, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, ifail)

     if(ifail /= 0) then
        ier = 98
     else
        spline_o%isReady = 1
     end if

  else if (spline_o%isLinear == 1) then

     spline_o%ilin1=0
     if(in1.gt.2) then
        if(spline_o%x1pkg(3,4).eq.0.0_fp) spline_o%ilin1=1  ! evenly spaced grid
     else
        spline_o%ilin1=1
     end if

     spline_o%ilin2=0
     if(in2.gt.2) then
        if(spline_o%x2pkg(3,4).eq.0.0_fp) spline_o%ilin2=1  ! evenly spaced grid
     else
        spline_o%ilin2=1
     end if

     spline_o%ilin3=0
     if(in3.gt.2) then
        if(spline_o%x3pkg(3,4).eq.0.0_fp) spline_o%ilin3=1  ! evenly spaced grid
     else
        spline_o%ilin3=1
     end if

     spline_o%isReady = 1   ! no coefficient setup necessary

  else
     !
     ! Hermite polynomial coefficient setup based on Akima's method
     ! (df/dx..etc not required)
     !
     ipx = 0
     if (spline_o%ibctype1(1)==-1 .or. spline_o%ibctype1(2)==-1) then
        ipx=1
     else if (spline_o%ibctype1(1)<-1 .or. spline_o%ibctype1(1)>1 .or. &
          spline_o%ibctype1(2)<-1 .or. spline_o%ibctype1(2)>1 ) then
        ipx=99  ! an error...
     else if (spline_o%ibctype1(1)==1 .or. spline_o%ibctype1(2)==1) then
        ipx=2
        do jj=1,spline_o%n3
           do ii=1,spline_o%n2
              if(spline_o%ibctype1(1)==1) then
                 spline_o%fspl(2,1,ii,jj)=spline_o%bcval1min(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,2,ii,jj)-spline_o%fspl(1,1,ii,jj))/ &
                      (spline_o%x1(2)-spline_o%x1(1))
                 df2=(spline_o%fspl(1,3,ii,jj)-spline_o%fspl(1,2,ii,jj))/ &
                      (spline_o%x1(3)-spline_o%x1(2))
                 spline_o%fspl(2,1,ii,jj)=(3*df1-df2)/2
              end if
              inum=spline_o%n1
              if(spline_o%ibctype1(2)==1) then
                 spline_o%fspl(2,inum,ii,jj)=spline_o%bcval1max(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,inum,ii,jj)-spline_o%fspl(1,inum-1,ii,jj))/ &
                      (spline_o%x1(inum)-spline_o%x1(inum-1))
                 df2=(spline_o%fspl(1,inum-1,ii,jj)-spline_o%fspl(1,inum-2,ii,jj))/ &
                      (spline_o%x1(inum-1)-spline_o%x1(inum-2))
                 spline_o%fspl(2,inum,ii,jj)=(3*df1-df2)/2
              end if
           end do
        end do
     end if
     ipy = 0
     if (spline_o%ibctype2(1)==-1 .or. spline_o%ibctype2(2)==-1) then
        ipy=1
     else if (spline_o%ibctype2(1)<-1 .or. spline_o%ibctype2(1)>1 .or. &
          spline_o%ibctype2(2)<-1 .or. spline_o%ibctype2(2)>1 ) then
        ipy=99  ! an error...
     else if (spline_o%ibctype2(1)==1 .or. spline_o%ibctype2(2)==1) then
        ipy=2
        do jj=1,spline_o%n3
           do ii=1,spline_o%n1
              if(spline_o%ibctype2(1)==1) then
                 spline_o%fspl(3,ii,1,jj)=spline_o%bcval2min(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,ii,2,jj)-spline_o%fspl(1,ii,1,jj))/ &
                      (spline_o%x2(2)-spline_o%x2(1))
                 df2=(spline_o%fspl(1,ii,3,jj)-spline_o%fspl(1,ii,2,jj))/ &
                      (spline_o%x2(3)-spline_o%x2(2))
                 spline_o%fspl(3,ii,1,jj)=(3*df1-df2)/2
              end if
              inum=spline_o%n2
              if(spline_o%ibctype2(2)==1) then
                 spline_o%fspl(3,ii,inum,jj)=spline_o%bcval2max(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,ii,inum,jj)-spline_o%fspl(1,ii,inum-1,jj))/ &
                      (spline_o%x2(inum)-spline_o%x2(inum-1))
                 df2=(spline_o%fspl(1,ii,inum-1,jj)-spline_o%fspl(1,ii,inum-2,jj))/ &
                      (spline_o%x2(inum-1)-spline_o%x2(inum-2))
                 spline_o%fspl(3,ii,inum,jj)=(3*df1-df2)/2
              end if
           end do
        end do
     end if
     ipz = 0
     if (spline_o%ibctype3(1)==-1 .or. spline_o%ibctype3(2)==-1) then
        ipz=1
     else if (spline_o%ibctype3(1)<-1 .or. spline_o%ibctype3(1)>1 .or. &
          spline_o%ibctype3(2)<-1 .or. spline_o%ibctype3(2)>1 ) then
        ipz=99  ! an error...
     else if (spline_o%ibctype3(1)==1 .or. spline_o%ibctype3(2)==1) then
        ipz=2
        do jj=1,spline_o%n2
           do ii=1,spline_o%n1
              if(spline_o%ibctype3(1)==1) then
                 spline_o%fspl(4,ii,jj,1)=spline_o%bcval3min(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,ii,jj,2)-spline_o%fspl(1,ii,jj,1))/ &
                      (spline_o%x3(2)-spline_o%x3(1))
                 df2=(spline_o%fspl(1,ii,jj,3)-spline_o%fspl(1,ii,jj,2))/ &
                      (spline_o%x3(3)-spline_o%x3(2))
                 spline_o%fspl(4,ii,jj,1)=(3*df1-df2)/2
              end if
              inum=spline_o%n3
              if(spline_o%ibctype3(2)==1) then
                 spline_o%fspl(4,ii,jj,inum)=spline_o%bcval3max(ii,jj)
              else
                 ! hand implemented default BC
                 df1=(spline_o%fspl(1,ii,jj,inum)-spline_o%fspl(1,ii,jj,inum-1))/ &
                      (spline_o%x3(inum)-spline_o%x3(inum-1))
                 df2=(spline_o%fspl(1,ii,jj,inum-1)-spline_o%fspl(1,ii,jj,inum-2))/ &
                      (spline_o%x3(inum-1)-spline_o%x3(inum-2))
                 spline_o%fspl(4,ii,jj,inum)=(3*df1-df2)/2
              end if
           end do
        end do
     end if
     ifail = 0
     call akherm3p(spline_o%x1(1), spline_o%n1, &
          &         spline_o%x2(1), spline_o%n2, &
          &         spline_o%x3(1), spline_o%n3, &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          & ipx,ipy,ipz, ifail)

     if (ifail /=0 ) then
        ier = 91
     else
        spline_o%isReady = 1
     end if

  end if


end subroutine EZspline_setup3

subroutine util_bcherm3(fherm,idimx1,idimx2,idimx3, &
     jbcx1a,jbcx1b,   jbcx2a,jbcx2b,   jbcx3a,jbcx3b, &
     zbcx1a,zbcx1b,   zbcx2a,zbcx2b,   zbcx3a,zbcx3b, &
     x1, x2, x3)
  use iso_c_binding, only: fp => c_double

  !... insert BCs as needed for Hermite interpolation setup

  implicit none
  integer :: idimx1,idimx2,idimx3 ! array dimensions
  real(fp) :: fherm(0:7,idimx1,idimx2,idimx3)

  integer :: jbcx1a,jbcx1b  ! x1 BC controls
  real(fp) :: zbcx1a(idimx2,idimx3) ! x1(1) BC data
  real(fp) :: zbcx1b(idimx2,idimx3) ! x1(idimx1) BC data

  integer :: jbcx2a,jbcx2b  ! x2 BC controls
  real(fp) :: zbcx2a(idimx1,idimx3) ! x2(1) BC data
  real(fp) :: zbcx2b(idimx1,idimx3) ! x2(idimx2) BC data

  integer :: jbcx3a,jbcx3b  ! x3 BC controls
  real(fp) :: zbcx3a(idimx2,idimx3) ! x3(1) BC data
  real(fp) :: zbcx3b(idimx2,idimx3) ! x3(idimx3) BC data

  real(fp) :: x1(idimx1),x2(idimx2),x3(idimx3)

  !-----------------------------------------------------------------
  integer :: ix,iy
  real(fp) :: zdx
  !-----------------------------------------------------------------

  if((jbcx1a.eq.1).or.(jbcx1b.eq.1)) then

     if(jbcx1a.eq.1) then
        fherm(1,1,1:idimx2,1:idimx3)=zbcx1a(1:idimx2,1:idimx3)
     else
        zdx = x1(2)-x1(1)
        do iy=1,idimx3
           do ix=1,idimx2
              fherm(1,1,ix,iy)= &
                   (fherm(0,2,ix,iy)-fherm(0,1,ix,iy))/zdx
           end do
        end do
     end if

     if(jbcx1b.eq.1) then
        fherm(1,idimx1,1:idimx2,1:idimx3)=zbcx1b(1:idimx2,1:idimx3)
     else
        zdx = x1(idimx1)-x1(idimx1-1)
        do iy=1,idimx3
           do ix=1,idimx2
              fherm(1,idimx1,ix,iy)= &
                   (fherm(0,idimx1,ix,iy)-fherm(0,idimx1-1,ix,iy))/ &
                   zdx
           end do
        end do
     end if

  end if

  if((jbcx2a.eq.1).or.(jbcx2b.eq.1)) then

     if(jbcx2a.eq.1) then
        fherm(2,1:idimx1,1,1:idimx3)=zbcx2a(1:idimx1,1:idimx3)
     else
        zdx=x2(2)-x2(1)
        do iy=1,idimx3
           do ix=1,idimx1
              fherm(2,ix,1,iy)= &
                   (fherm(0,ix,2,iy)-fherm(0,ix,1,iy))/zdx
           end do
        end do
     end if

     if(jbcx2b.eq.1) then
        fherm(2,1:idimx1,idimx2,1:idimx3)=zbcx2b(1:idimx1,1:idimx3)
     else
        zdx=x2(idimx2)-x2(idimx2-1)
        do iy=1,idimx3
           do ix=1,idimx1
              fherm(2,ix,idimx2,iy)= &
                   (fherm(0,ix,idimx2,iy)-fherm(0,ix,idimx2-1,iy))/ &
                   zdx
           end do
        end do
     end if
  end if

  if((jbcx3a.eq.1).or.(jbcx3b.eq.1)) then

     if(jbcx3a.eq.1) then
        fherm(3,1:idimx1,1:idimx2,1)=zbcx3a(1:idimx1,1:idimx2)
     else
        zdx=x3(2)-x3(1)
        do iy=1,idimx2
           do ix=1,idimx1
              fherm(3,ix,iy,1)= &
                   (fherm(0,ix,iy,2)-fherm(0,ix,iy,1))/zdx
           end do
        end do
     end if

     if(jbcx3b.eq.1) then
        fherm(3,1:idimx1,1:idimx2,idimx3)=zbcx3b(1:idimx1,1:idimx2)
     else
        zdx=x3(idimx3)-x3(idimx3-1)
        do iy=1,idimx2
           do ix=1,idimx1
              fherm(3,ix,iy,idimx3)= &
                   (fherm(0,ix,iy,idimx3)-fherm(0,ix,iy,idimx3-1))/ &
                   zdx
           end do
        end do
     end if
  end if

end subroutine util_bcherm3

! $Id: ezcdf_genput.f90,v 1.16 2007-08-29 20:44:32 Doug_McCune Exp $
MODULE ezcdf_GenPut
  USE ezcdf_opncls
  USE ezcdf_inqvar

  ! Generic Interface to Write netcdf data Variables
  ! 03/10/99 C. Ludescher
  ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
  ! + support for complex numbers (ap) Wed May 16 15:18:05 EDT 2001
  ! added support for logicals (sph) Oct 1, 2002
  implicit none

  !
  ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
  !
  ! added support (ap) Wed May 16 15:06:34 EDT 2001
  PUBLIC :: cdfw_3i, cdfw_3l, cdfw_3d, cdfw_3c16, cdfw_3f, cdfw_3c8,  &
       & cdfw_2i, cdfw_2l, cdfw_2d, cdfw_2c16, cdfw_2f, cdfw_2c8, cdfw_2c, &
       & cdfw_1i, cdfw_1l, cdfw_1d, cdfw_1c16, cdfw_1f, cdfw_1c8, cdfw_1c, &
       & cdfw_0i, cdfw_0l, cdfw_0d, cdfw_0c16, cdfw_0f, cdfw_0c8,          &
       & cdfPutVar, cdf_write

  ! cdf_write is an alias of cdfPutVar (required by ifc compiler)
  INTERFACE cdf_write
     MODULE PROCEDURE cdfw_3i, cdfw_3l, cdfw_3d, cdfw_3c16, cdfw_3f, cdfw_3c8, &
          cdfw_2i, cdfw_2l, cdfw_2d, cdfw_2c16, cdfw_2f, cdfw_2c8, cdfw_2c, &
          cdfw_1i, cdfw_1l, cdfw_1d, cdfw_1c16, cdfw_1f, cdfw_1c8, cdfw_1c, &
          cdfw_0i, cdfw_0l, cdfw_0d, cdfw_0c16, cdfw_0f, cdfw_0c8
  END INTERFACE
  ! same as above (Intel compiler does not handle well aliases)
  INTERFACE cdfPutVar
     MODULE PROCEDURE cdfw_3i, cdfw_3l, cdfw_3d, cdfw_3c16, cdfw_3f, cdfw_3c8, &
          cdfw_2i, cdfw_2l, cdfw_2d, cdfw_2c16, cdfw_2f, cdfw_2c8, cdfw_2c, &
          cdfw_1i, cdfw_1l, cdfw_1d, cdfw_1c16, cdfw_1f, cdfw_1c8, cdfw_1c, &
          cdfw_0i, cdfw_0l, cdfw_0d, cdfw_0c16, cdfw_0f, cdfw_0c8
  END INTERFACE

  PUBLIC :: cdfDefVar, cdf_define,                                          &
       & cdfd_3i, cdfd_3l, cdfd_3d, cdfd_3c16, cdfd_3f, cdfd_3c8,          &
       & cdfd_2i, cdfd_2l, cdfd_2d, cdfd_2c16, cdfd_2f, cdfd_2c8, cdfd_2c, &
       & cdfd_1i, cdfd_1l, cdfd_1d, cdfd_1c16, cdfd_1f, cdfd_1c8, cdfd_1c, &
       & cdfd_0i, cdfd_0l, cdfd_0d, cdfd_0c16, cdfd_0f, cdfd_0c8

  INTERFACE cdf_define
     MODULE PROCEDURE cdfDefVar,                                            &
          cdfd_3i, cdfd_3l, cdfd_3d, cdfd_3c16, cdfd_3f, cdfd_3c8,          &
          cdfd_2i, cdfd_2l, cdfd_2d, cdfd_2c16, cdfd_2f, cdfd_2c8, cdfd_2c, &
          cdfd_1i, cdfd_1l, cdfd_1d, cdfd_1c16, cdfd_1f, cdfd_1c8, cdfd_1c, &
          cdfd_0i, cdfd_0l, cdfd_0d, cdfd_0c16, cdfd_0f, cdfd_0c8
  END INTERFACE

  PRIVATE
  include "netcdf.inc"

  integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
  integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
  character*13, parameter :: cmplx_name = '__CmPlx_Re_Im'

  character(len=nf_max_name)  :: varnam_noalpha
  PRIVATE :: r4, r8, cmplx_name, varnam_noalpha

  EXTERNAL ezcdf_error

CONTAINS
!-----------------------------------------------------------------
!cdfPutVar implementation routines

  SUBROUTINE cdfw_3i(ncid,varnam,varval,ier)
    !     Write 3 dimensional Integer data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    integer, dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    integer, dimension(3) :: st = (/1,1,1/)
    integer, dimension(3) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 3) then
       print "('% cdfPutVar_3i: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_int(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_3i','nf_put_vara_int')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_3i

  SUBROUTINE cdfw_3l(ncid,varnam,varval,ier)
    !     Write 3 dimensional logical array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    logical, dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,         intent(out) :: ier
    ! Local
    integer                                :: sts
    integer, allocatable, dimension(:,:,:) :: varval_i
    character*11, parameter :: logical_name = '__logical__'


    ALLOCATE (varval_i(size(varval,1), size(varval,2), size(varval,3)), stat=sts)
    if (sts .ne. 0) stop 'Allocation error in cdf_putvar'

    WHERE (varval) 
       varval_i = 1
    ELSEWHERE 
       varval_i = 0
    END WHERE

    call cdfw_3i(ncid,trim(varnam)//logical_name,varval_i,ier)

    DEALLOCATE (varval_i)
  END SUBROUTINE cdfw_3l

  SUBROUTINE cdfw_3d(ncid,varnam,varval,ier)
    !     Write 3 dimensional 64-bit Real data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                         intent(in) :: ncid
    character*(*),                   intent(in) :: varnam
    REAL(KIND=r8), dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(3) :: st = (/1,1,1/)
    integer, dimension(3) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 3) then
       print "('% cdfPutVar_3d: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_double(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_3d','nf_put_vara_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_3d

  SUBROUTINE cdfw_3c16(ncid,varnam,varval,ier)
    !     Write 3 dimensional 128-bit complex data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                         intent(in) :: ncid
    character*(*),                   intent(in) :: varnam
    COMPLEX(KIND=r8), dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(3) :: st = (/1,1,1/)
    integer, dimension(3) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 3) then
       print "('% cdfPutVar_3c16: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_double(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_3c16','nf_put_vara_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_3c16

  SUBROUTINE cdfw_3f(ncid,varnam,varval,ier)
    !     Write 3 dimensional default Real data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                         intent(in) :: ncid
    character*(*),                   intent(in) :: varnam
    REAL(KIND=r4), dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(3) :: st = (/1,1,1/)
    integer, dimension(3) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 3) then
       print "('% cdfPutVar_3f: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_real(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_3f','nf_put_vara_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_3f

  SUBROUTINE cdfw_3c8(ncid,varnam,varval,ier)
    !     Write 3 dimensional complex*8 data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                         intent(in) :: ncid
    character*(*),                   intent(in) :: varnam
    COMPLEX(KIND=r4), dimension(:,:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(3) :: st = (/1,1,1/)
    integer, dimension(3) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 3) then
       print "('% cdfPutVar_3c8: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_real(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_3c8','nf_put_vara_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_3c8

  SUBROUTINE cdfw_2i(ncid,varnam,varval,ier)
    !     Write 2 dimensional Integer data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    integer, dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2i: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_int(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_2i','nf_put_vara_int')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2i

  SUBROUTINE cdfw_2l(ncid,varnam,varval,ier)
    !     Write 2 dimensional logical array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    logical, dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    integer                              :: sts
    integer, allocatable, dimension(:,:) :: varval_i
    character*11, parameter :: logical_name = '__logical__'

    ALLOCATE (varval_i(size(varval,1), size(varval,2)), stat=sts)
    if (sts .ne. 0) stop 'Allocation error in cdf_putvar'

    WHERE (varval) 
       varval_i = 1
    ELSEWHERE 
       varval_i = 0
    END WHERE

    call cdfw_2i(ncid,trim(varnam)//logical_name,varval_i,ier)

    DEALLOCATE (varval_i)
  END SUBROUTINE cdfw_2l

  SUBROUTINE cdfw_2d(ncid,varnam,varval,ier)
    !     Write 2 dimensional 64-bit Real data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                       intent(in) :: ncid
    character*(*),                 intent(in) :: varnam
    REAL(KIND=r8), dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2d: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_double(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_2d','nf_put_vara_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2d

  SUBROUTINE cdfw_2c16(ncid,varnam,varval,ier)
    !     Write 2 dimensional 128-bit complex data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                       intent(in) :: ncid
    character*(*),                 intent(in) :: varnam
    COMPLEX(KIND=r8), dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2c16: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_double(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_2c16','nf_put_vara_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2c16

  SUBROUTINE cdfw_2f(ncid,varnam,varval,ier)
    !     Write 2 dimensional default Real data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                       intent(in) :: ncid
    character*(*),                 intent(in) :: varnam
    REAL(KIND=r4), dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2f: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_real(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_2f','nf_put_vara_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2f

  SUBROUTINE cdfw_2c8(ncid,varnam,varval,ier)
    !     Write 2 dimensional complex*8 data array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                       intent(in) :: ncid
    character*(*),                 intent(in) :: varnam
    COMPLEX(KIND=r4), dimension(:,:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts= nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0)  return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2c8: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_real(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdf_2c8','nf_put_vara_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2c8

  SUBROUTINE cdfw_2c(ncid,varnam,varval,ier)
    !     Write 2 dimensional character array
    !     Use cdfDefVar to define the Variable
    implicit none
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    character*(*), dimension(:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(2) :: st = (/1,1/)
    integer, dimension(2) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 2) then
       print "('% cdfPutVar_2c: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_vara_text(ncid,varid,st,dimlens,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_2c','nf_put_var_text')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_2c

  SUBROUTINE cdfw_1i(ncid,varnam,varval,ier)
    !     write 1 dimensional Integer array
    implicit none
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    integer, dimension(:),   intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1i: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_int(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_1i','nf_put_var_int')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1i

  SUBROUTINE cdfw_1l(ncid,varnam,varval,ier)
    !     Write 1 dimensional logical array
    implicit none
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    logical, dimension(:), intent(in) :: varval
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    integer                            :: sts
    integer, allocatable, dimension(:) :: varval_i
    character*11, parameter :: logical_name = '__logical__'

    ALLOCATE (varval_i(size(varval,1)), stat=sts)
    if (sts .ne. 0) stop 'Allocation error in cdf_putvar'

    WHERE (varval) 
       varval_i = 1
    ELSEWHERE 
       varval_i = 0
    END WHERE

    call cdfw_1i(ncid,trim(varnam)//logical_name,varval_i,ier)

    DEALLOCATE (varval_i)
  END SUBROUTINE cdfw_1l

  SUBROUTINE cdfw_1d(ncid,varnam,varval,ier)
    !     Write 1 dimensional 64-bit data array
    !     Use cdfDefVar to define the Variable
    !
    implicit none
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    REAL(KIND=r8), dimension(:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1d: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_double(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPurVar_1d','nf_put_var_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1d

  SUBROUTINE cdfw_1c16(ncid,varnam,varval,ier)
    !     Write 1 dimensional 128-bit complex data array
    !     Use cdfDefVar to define the Variable
    !
    implicit none
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    COMPLEX(KIND=r8), dimension(:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1c16: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_double(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPurVar_1c16','nf_put_var_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1c16

  SUBROUTINE cdfw_1f(ncid,varnam,varval,ier)
    !     Write 1 dimensional default real array
    !     Use cdfDefVar to define the Variable
    !
    implicit none
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    REAL(KIND=r4), dimension(:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1f: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_real(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPurVar_1f','nf_put_var_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1f

  SUBROUTINE cdfw_1c8(ncid,varnam,varval,ier)
    !     Write 1 dimensional complex*8 array
    !     Use cdfDefVar to define the Variable
    !
    implicit none
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    COMPLEX(KIND=r4), dimension(:), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1c8: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_real(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPurVar_1c8','nf_put_var_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1c8

  SUBROUTINE cdfw_1c(ncid,varnam,varval,ier)
    !     Write 1 dimensional character data array
    !     Use cdfDefVar to define the Variable
    !
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    character*(*), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_1c: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_text(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_1c','nf_put_var_text')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_1c

  SUBROUTINE cdfw_0i(ncid,varnam,varval,ier)
    !     write integer scalar
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    integer,       intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 0) then
       print "('% cdfPutVar_0i: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_int(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_0i','nf_put_var_int')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_0i

  SUBROUTINE cdfw_0l(ncid,varnam,varval,ier)
    !     Write logical scalar
    implicit none
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    logical,            intent(in) :: varval
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    integer                         :: varval_i
    character*11, parameter :: logical_name = '__logical__'

    IF (varval) THEN
       varval_i = 1
    ELSE
       varval_i = 0
    END IF

    call cdfw_0i(ncid,trim(varnam)//logical_name,varval_i,ier)

  END SUBROUTINE cdfw_0l

  SUBROUTINE cdfw_0d(ncid,varnam,varval,ier)
    !     Write Real*8 Scalar
    !
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    REAL(KIND=r8), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 0) then
       print "('% cdfPutVar_0d: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_double(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_0d','nf_put_var_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_0d

  SUBROUTINE cdfw_0c16(ncid,varnam,varval,ier)
    !     Write Complex*16 Scalar
    !
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    COMPLEX(KIND=r8), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then ! scalar complex stored as 2 element real array
       print "('% cdfPutVar_0c16: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_double(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_0c16','nf_put_var_double')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_0c16

  SUBROUTINE cdfw_0f(ncid,varnam,varval,ier)
    !     Write default real
    !
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    REAL(KIND=r4), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts
    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,varnam,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 0) then
       print "('% cdfPutVar_0f: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_real(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_0f','nf_put_var_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_0f

  SUBROUTINE cdfw_0c8(ncid,varnam,varval,ier)
    !     Write complex*8
    !
    implicit none
    ! Input
    integer,       intent(in) :: ncid
    character*(*), intent(in) :: varnam
    complex(KIND=r4), intent(in) :: varval
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer, dimension(1) :: dimlens
    integer               :: varid, ndims, sts

    if (PRESENT (ier)) ier = 1
    sts = nf_enddef(ncid)
    call cdfInqV(ncid,trim(varnam)//cmplx_name,varid,dimlens,ndims,sts)
    if (sts .ne. 0) return
    if (ndims .ne. 1) then
       print "('% cdfPutVar_0c8: --E-- The variable ',a,               &
            &         ' was defined as',i2,' dimensional')",varnam,ndims
       return
    end if
    sts = nf_put_var_real(ncid,varid,varval)
    call ezcdf_error(sts,varnam,'cdfPutVar_0c8','nf_put_var_real')
    if (PRESENT (ier)) ier = sts
  END SUBROUTINE cdfw_0c8

!------------------------------------------------------------------
! cdfDefVar implementation routines

  subroutine cdfDefVar(ncid,varnam,dimlens,xtype,ier,dimname)
    ! Define a Variable and its dimensions
    ! 03/08/99 C. Ludescher
    ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
    ! added support for complex types (ap) Wed May 16 15:06:34 EDT 2001
    ! added support for logical type Oct 1 2002 (SPH)

    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,              intent(in)  :: ncid
    character*(*),        intent(in)  :: varnam
    integer, dimension(:),intent(in)  :: dimlens
    character*(*),        intent(in)  :: xtype
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,      intent(out) :: ier
    ! Local
    integer                 :: ndims, varid, vartype, maxdims
    integer                 :: i,     n,     status
    integer, dimension(3)   :: dimids
    character*(nf_max_name) :: dimnams(3)
    character*(5)           :: zdim
    character*(9)           :: zdim1
    character*(*), parameter :: cmplx_name = '__CmPlx_Re_Im'
    character*(*), parameter :: logical_name = '__logical__'
    logical :: is_complex, is_logical

    integer dims(3)
    integer flag

    is_complex=.FALSE.
    is_logical=.FALSE.

    if (PRESENT (ier)) ier = 1
    status = 0

    dims = dimlens
    if (xtype .eq. 'R8' .or. xtype .eq. 'r8') then
       vartype=nf_double
    else if (xtype .eq. 'C16' .or. xtype .eq. 'c16') then
       ! complex array = real array with double leading length
       vartype=nf_double
       is_complex = .TRUE.
       dims(1) = 2*abs(dimlens(1))
    else if (xtype .eq. 'INT' .or. xtype .eq. 'int') then
       vartype=nf_int
    else if (xtype .eq. 'LOG' .or. xtype .eq. 'log' .or. xtype .eq. 'BOOL' .or. xtype .eq.'bool') then
       vartype=nf_int !if nf_byte, MUST use integer*1
       is_logical = .TRUE.
    else if (xtype .eq. 'R4' .or. xtype .eq. 'r4') then
       vartype=nf_float
    else if (xtype .eq. 'C8' .or. xtype .eq. 'c8') then
       ! complex array = real array with double leading length
       vartype=nf_float
       is_complex = .TRUE.
       dims(1) = 2*abs(dimlens(1))
    else if (xtype .eq. 'CHAR' .or. xtype .eq. 'char') then
       vartype=nf_char
    end if

    ! The normal behavior is to decrement the rank if all
    ! sizes to the right are 1. However, in some cases it
    ! may be desirable to keep this dimension, in which the
    ! user needs to pass -1 as dimension.

    ndims = size(dims)
    n=ndims
    flag = 1
    do i=n,1,-1
       if ((dims(i) == 1 .or. dims(i) == 0) .and. flag==1 ) then
          ndims = i-1
       else
          flag=0
       endif
       dims(i) = abs(dims(i))
    end do

    ! Check ndims <= maxdims
    if (xtype .eq. 'CHAR' .or. xtype .eq. 'char') then
       maxdims = 2
    else
       maxdims = 3
    endif
    if (ndims .gt. maxdims) then
       WRITE(*,10)ndims,xtype
10     format('% cdfDefVar --E--  Rank',i3,' not supported for ',a)
       return
    endif

    do i=1,ndims
       if (dims(i).gt. 999999999) then
          print *,'% cdfDefVar --E-- dimension >= 1.e9 not supported'
          return
       else if (dims(i) .lt. 100000) then
          write(zdim,'(i5.5)') dims(i)
          dimnams(i) = 'dim_'//zdim
       else
          write(zdim1,'(i9.9)') dims(i)
          dimnams(i) = 'dim_'//zdim1
       endif
       if (PRESENT(dimname)) then 
          if (SIZE(dimname).ge.i) then
             if (LEN_TRIM(dimname(i)).gt.0) dimnams(i) = dimname(i)
          end if
       end if
       status = nf_inq_dimid(ncid,dimnams(i),dimids(i))
       if (status .ne. nf_noerr) then
          status = nf_def_dim(ncid,dimnams(i),dims(i),dimids(i))
          call ezcdf_error(status,dimnams(i),'cdfdef','nf_def_dim')
       endif
    end do

    if (status .ne. 0) return

  ! replace any embedded blanks or non-alphanumeric characters with underscores
    varnam_noalpha = varnam
    CALL alpha_numeric(varnam_noalpha)
    ! do some name mangling to keep track of complex and 
    ! logical types
    if(is_complex) varnam_noalpha = trim(varnam_noalpha)//cmplx_name
    if(is_logical) varnam_noalpha = trim(varnam_noalpha)//logical_name

    status = nf_def_var(ncid,varnam_noalpha,vartype,ndims,dimids,varid)

    call ezcdf_error(status,varnam,'cdfDefVar','nf_def_var')
    if (PRESENT (ier)) ier = status
  end subroutine cdfDefVar

  SUBROUTINE cdfd_3i(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional Integer data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    integer, dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='INT'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3i

  SUBROUTINE cdfd_2i(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional Integer data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    integer, dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='INT'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2i

  SUBROUTINE cdfd_1i(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional Integer data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    integer, dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='INT'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1i

  SUBROUTINE cdfd_0i(ncid,varnam,varval,ier,dimname)
    !     define scalar Integer
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    integer,            intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='INT'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0i

  SUBROUTINE cdfd_3l(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional logical array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    logical, dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*4             :: vartype
    integer                 :: dims(3)

    vartype='LOG'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3l

  SUBROUTINE cdfd_2l(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional logical array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    logical, dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*3            :: vartype
    integer                 :: dims(3)

    vartype='LOG'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2l

  SUBROUTINE cdfd_1l(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional logical array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    logical, dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*3            :: vartype
    integer                 :: dims(3)

    vartype='LOG'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1l

  SUBROUTINE cdfd_0l(ncid,varnam,varval,ier,dimname)
    !     define scalar logical
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    logical,            intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*3            :: vartype
    integer                 :: dims(3)

    vartype='LOG'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0l

  SUBROUTINE cdfd_3d(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional double data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    REAL(kind=r8), dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R8'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3d

  SUBROUTINE cdfd_2d(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional double data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    REAL(kind=r8), dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R8'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2d

  SUBROUTINE cdfd_1d(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional double data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    REAL(kind=r8), dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R8'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1d

  SUBROUTINE cdfd_0d(ncid,varnam,varval,ier,dimname)
    !     define scalar double
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    REAL(kind=r8),      intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R8'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0d

  SUBROUTINE cdfd_3f(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional real data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    REAL(kind=r4), dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R4'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3f

  SUBROUTINE cdfd_2f(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional real data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    REAL(kind=r4), dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R4'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2f

  SUBROUTINE cdfd_1f(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional real data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    REAL(kind=r4), dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R4'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1f

  SUBROUTINE cdfd_0f(ncid,varnam,varval,ier,dimname)
    !     define scalar real
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    REAL(kind=r4),      intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='R4'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0f

  SUBROUTINE cdfd_3c16(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional 128-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    COMPLEX(kind=r8), dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='C16'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3c16

  SUBROUTINE cdfd_2c16(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional 128-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    COMPLEX(kind=r8), dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='C16'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2c16

  SUBROUTINE cdfd_1c16(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional 128-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    COMPLEX(kind=r8), dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='C16'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1c16

  SUBROUTINE cdfd_0c16(ncid,varnam,varval,ier,dimname)
    !     define scalar 128-bit complex
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    COMPLEX(kind=r8),      intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*3             :: vartype
    integer                 :: dims(3)

    vartype='C16'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0c16

  SUBROUTINE cdfd_3c8(ncid,varnam,varval,ier,dimname)
    !     define 3 dimensional 64-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                   intent(in) :: ncid
    character*(*),             intent(in) :: varnam
    COMPLEX(kind=r4), dimension(:,:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,        intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='C8'
    dims = -shape(varval)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_3c8

  SUBROUTINE cdfd_2c8(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional 64-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                 intent(in) :: ncid
    character*(*),           intent(in) :: varnam
    COMPLEX(kind=r4), dimension(:,:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='C8'
    dims = (/ -shape(varval), 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2c8

  SUBROUTINE cdfd_1c8(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional 64-bit complex data array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,               intent(in) :: ncid
    character*(*),         intent(in) :: varnam
    COMPLEX(kind=r4), dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='C8'
    dims = (/ -shape(varval), 1, 1 /)

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1c8

  SUBROUTINE cdfd_0c8(ncid,varnam,varval,ier,dimname)
    !     define scalar 64-bit complex
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,            intent(in) :: ncid
    character*(*),      intent(in) :: varnam
    COMPLEX(kind=r4),      intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,  intent(out) :: ier
    ! Local
    character*2             :: vartype
    integer                 :: dims(3)

    vartype='C8'
    dims = 0

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_0c8

  SUBROUTINE cdfd_2c(ncid,varnam,varval,ier,dimname)
    !     define 2 dimensional character array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,                     intent(in) :: ncid
    character*(*),               intent(in) :: varnam
    character*(*), dimension(:), intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,       intent(out) :: ier
    ! Local
    character*4             :: vartype
    integer                 :: dims(3)

    vartype='CHAR'
    dims(1) = len(varval(1))
    dims(2) = size(varval);   dims(3) = 1

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_2c

  SUBROUTINE cdfd_1c(ncid,varnam,varval,ier,dimname)
    !     define 1 dimensional character array
    implicit none
!!$  include "netcdf.inc"
    ! Input
    integer,         intent(in) :: ncid
    character*(*),   intent(in) :: varnam
    character*(*),   intent(in) :: varval
    character*(*), optional, dimension(:), intent(in) :: dimname
    ! Output
    integer, optional,     intent(out) :: ier
    ! Local
    character*4             :: vartype
    integer                 :: dims(3)

    vartype='CHAR'
    dims(1) = len(varval);  dims(2:3) = 1
    if (dims(1) .le. 1) dims(1) = -1

    ! dmc: code around seeming failure of ifort to propagate undefined
    !      optional variables

    if(present(ier)) then
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,ier,dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype,ier)
       endif
    else
       if(present(dimname)) then
          call cdfDefVar(ncid,varnam,dims,vartype,dimname=dimname)
       else
          call cdfDefVar(ncid,varnam,dims,vartype)
       endif
    endif

  END SUBROUTINE cdfd_1c

END MODULE ezcdf_GenPut

 
      integer function nblkfac(ier)
 
C     NBLKFAC returns the blocking factor for doing an OPEN
C             of a DIRECT access file.
C             For "most" systems, the RECL is given in words.
C             For HP and IBM, RECL is given in bytes.
C             So, for HP and IBM, the number of words must be
C             multiplied by 4 to get the right RECL.
C
C this version uses cpp -- instead of a getenv call for WORKSTATION_TYPE
C
C             Created 12/12/95  T.B. Terpstra
C
c modified D. Ernst           8/98 for LINUX using Portland Group compiler
C          jconboy@jet.uk 15-06-99 change default to 4; better too large
C                                  than too small
 
      Character*20 wstype
 
      ier=1
c--   nblkfac=1
      nblkfac=4
 
#ifdef __VMS
      ier=0
      nblkfac=1
#endif
 
#ifdef __UNIX
#if __ALPHA
      ier=0
      nblkfac=1
#elif __HP || __IBM || __RS6000 || __LINUX || __SUN || __SUNOS || __SGI || __SX || __OSX
      ier=0
      nblkfac=4
#elif __CRAY || __X1
      ier=0
      nblkfac=8
#endif 
#endif  /* __UNIX */
 
      return
      end

!  cspeval -- eval cubic spline function and/or derivatives
!
subroutine cspeval(xget,iselect,fval,x,nx,ilinx,f,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ier,nx
  !============
  real(fp) :: xget                         ! interpolation target
  real(fp) :: fval(3)                      ! output values
  real(fp) :: x(nx),f(4,nx)                ! spline data
  !
  integer iselect(3)                ! output selector
  integer ilinx                     ! =1 if x(...) is evenly spaced
  !
  !  modification -- dmc 11 Jan 1999 -- remove SAVE stmts; break routine
  !    into these parts:
  !
  !    cspevx -- find grid cell of target pt.
  !    cspevfn -- evaluate function using output of bcpsevxy
  !
  !    in cases where multiple functions are defined on the same grid,
  !    time can be saved by using cspevx once and then cspevfn
  !    multiple times.
  !
  !  input:
  !     (xget)        location where interpolated value is desired
  !                   x(1).le.xget.le.x(nx) expected
  !
  !     iselect       select desired output
  !
  !                     iselect(1)=1 -- want function value (f) itself
  !                     iselect(2)=1 -- want  df/dx
  !                     iselect(3)=1 -- want  d2f/dx2
  !
  !              example:  iselect(1)=iselect(2)=iselect(3)=1
  !                            f, df/dx, and d2f/dx2 are all evaluated
  !                            and returned in order in fval(1), fval(2),
  !                            and fval(3)
  !                        iselect(1)=0, iselect(2)=1, iselect(3)=0
  !                            only the 1st derivative is evaluated
  !                            and returned in fval(1).
  !
  !                     set iselect(1)=3 to get d3f/dx3, 1 value only.
  !
  !                   see fval (output) description.
  !
  !     x(1...nx)     independent coordinate x, strict ascending
  !
  !     ilinx  --  =1: flag that x is linearly spaced (avoid search for speed)
  !
  !  **CAUTION** actual even spacing of x, is NOT CHECKED HERE!
  !
  !     f             the function values (at grid points) and spline coefs
  !
  !  evaluation formula:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !
  !      spline value =
  !        f(1,i) + dx*f(2,i) + dx**2*f(3,i) + dx**3*f(4,i)
  !
  !  output:
  !      up to 3 elements of fval, ordered as follows:
  !        fval(1)=function value or lowest order derivative requested
  !        fval(2)=next order derivative
  !             etc
  !        the ordering is a subset of the sequence given under the "iselect"
  !        description.
  !
  !      ier = 0 -- successful completion; = 1 -- an error occurred.
  !
  !-------------------------------------------------------------------
  !  local
  !
  integer :: ia(1) = (/ 0 /)
  real(fp) :: dxa(1)
  !
  !--------------------------
  !
  call cspevx(xget,x,nx,ilinx,ia(1),dxa(1),ier)
  if(ier.ne.0) return
  !
  call cspevfn(iselect,1,1,fval,ia,dxa,f,nx)
  !
  return
end subroutine cspeval
!
!-------------------------------------------------------------------------
!  cspevx -- look up x zone
!
!  this is the "first part" of cspeval, see comments, above.
!
subroutine cspevx(xget,x,nx,ilinx,i,dx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nxm,ii
  !============
  real(fp) :: zxget,zxtol
  !============
  integer nx                        ! x array dimension
  !
  real(fp) :: xget                         ! target point
  real(fp) :: x(nx)                        ! independent coord. array
  !
  integer ilinx                     ! =1:  assume x evenly spaced
  !
  !  output of cspevx
  !
  integer i                         ! index to cell containing target pt
  real(fp) :: dx                           ! displacement of target pt w/in cell
  ! dx = x-x(i)
  !
  !  the input argument range is checked...
  !
  integer ier                       ! return ier.ne.0 on error
  !
  !------------------------------------
  !
  ier=0
  !
  !  range check
  !
  zxget=xget
  if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
     zxtol=4.0E-7_fp*max(abs(x(1)),abs(x(nx)))
     if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
        ier=1
        write(6,1001) xget,x(1),x(nx)
1001    format(' ?cspeval:  xget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((xget.lt.x(1)-0.5_fp*zxtol).or. &
             (xget.gt.x(nx)+0.5_fp*zxtol)) &
             write(6,1011) xget,x(1),x(nx)
1011    format(' %cspeval:  xget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(xget.lt.x(1)) then
           zxget=x(1)
        else
           zxget=x(nx)
        end if
     end if
  end if
  if(ier.ne.0) return
  !
  !  now find interval in which target point lies..
  !
  nxm=nx-1
  !
  if(ilinx.eq.1) then
     ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
     i=min(nxm, ii)
     if(zxget.lt.x(i)) then
        i=i-1
     else if(zxget.gt.x(i+1)) then
        i=i+1
     end if
  else
     if((1.le.i).and.(i.lt.nxm)) then
        if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
           continue  ! already have the zone
        else
           call zonfind(x,nx,zxget,i)
        end if
     else
        i=nx/2
        call zonfind(x,nx,zxget,i)
     end if
  end if
  !
  dx=zxget-x(i)
  !
  return
end subroutine cspevx
!------------------------------------------------------------------------
!  cspevfn -- OK now evaluate the cubic spline
!
subroutine cspevfn(ict,ivec,ivd,fval,iv,dxv,f,nx)
  use iso_c_binding, only: fp => c_double
  !
  !  input:
  !============
  implicit none
  integer nx,iaval,i
  !============
  real(fp) :: dx
  !============
  integer ict(3)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate f if ict(1)=0)
  !        ict(2)=1 for df/dx   ""
  !        ict(3)=1 for d2f/dx2
  !
  !        set ict(1)=3 to get d3f/dx3 (only)
  !
  integer ivec,ivd                  ! vector dimensioning
  !
  !    ivec-- number of vector pts (spline values to look up)
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                 ! output array
  !
  !    v = index to element in vector;
  !  fval(v,1) = first item requested by ict(...),
  !  fval(v,2) = 2nd item requested,  ...etc...
  !
  !  input:
  integer iv(ivec)                  ! grid cell indices -- vectors
  real(fp) :: dxv(ivec)                    ! displacements w/in cell -- vectors
  !
  real(fp) :: f(4,nx)                      ! cubic fcn spline coeffs array
  !
  !  usage example:
  !
  !  1.  for each element xx(v) in a vector of x values:
  !    find the x zone index and displacement with respect to the
  !    lower end point of the zone; store thes in vectors iv and dxv.
  !
  !  2.  set ict(1)=0, ict(2)=1, ict(3)=0 -- get only the 1st derivative
  !
  !  3.  ivec is the length of the vector; ivd is the 1st dimension of the
  !      array fval to receive the output
  !
  !      real fval(ivd,3)
  !      real xv(ivd)
  !      real dxv(ivd)
  !      integer iv(ivd)
  !      integer ict(3)
  !
  !      real fspline(4,nx)  ! spline coeffs
  !      data ict/0,1,0/     ! this call:  want 1st derivative only
  !                          !  this will be output to fval(*,1).
  !      ...
  !      do iv=1,ivec
  !        ...               ! comput indices & displacements
  !      end do
  !      call cspevfn(ict,ivec,ivd,fval,iv,dxv,fspline,nx)
  !
  !--------------------------------------------------------------------
  !  local:
  !
  integer v                         ! vector element index
  !
  !  OK can now do evaluations
  !
  iaval=0  ! fval addressing
  !
  if(ict(1).eq.3) then
     !
     !  fxxx = d3f/dx3
     !
     iaval=iaval+1
     do v=1,ivec
        i=iv(v)
        fval(v,iaval)=6.0_fp*f(4,i)
     end do
  else
     !
     !  normal call...
     !
     if(ict(1).gt.0) then
        !  evaluate f
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           dx=dxv(v)
           fval(v,iaval)=f(1,i)+dx*(f(2,i)+dx*(f(3,i)+dx*f(4,i)))
        end do
     end if
     !
     if(ict(2).gt.0) then
        !  evaluate df/dx
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           dx=dxv(v)
           fval(v,iaval)=f(2,i)+dx*(2.0_fp*f(3,i)+dx*3.0_fp*f(4,i))
        end do
     end if
     !
     if(ict(3).gt.0) then
        !  evaluate d2f/dx2
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           dx=dxv(v)
           fval(v,iaval)=2.0_fp*f(3,i)+dx*6.0_fp*f(4,i)
        end do
     end if
  end if
  !
  return
end subroutine cspevfn
!----------------------

program proclist

  ! write file containing list of processors and processor ID #s in current job
  ! filename = 1st command line argument, which must be nonblank
  !    if there are more than one command line arguments, these are ignored.

  implicit NONE

#ifdef __MPI
  include 'mpif.h'
#endif

  ! local communicator

#ifdef __MPI
  integer :: nbi_comm = MPI_COMM_WORLD
#endif

  !-------------------------------------
  character*180 filenam,hostnam,hostnam1,proc_name
  integer :: nargs,istat,myid,numprocs,ierr
  integer :: ii,jj,mywid,maxwid,iresult,idum
  integer :: lunout = 77
  integer, dimension(:), allocatable :: iwrite

  integer, dimension(:,:), allocatable :: intbuf,intbufr
  !-------------------------------------
  ! executable code

#ifdef __MPI

  call MPI_INIT(ierr)
  if(ierr.ne.0) call errmsg_exit(' MPI_INIT failure! ')

  call MPI_COMM_RANK(nbi_comm,myid,ierr);   call ckerr('MPI_COMM_RANK')
  call MPI_COMM_SIZE(nbi_comm,numprocs,ierr);   call ckerr('MPI_COMM_SIZE')
  if(myid.eq.0) then
     write(0,*) ' mpi_proclist:  numprocs = ',numprocs
  endif

#else

  ierr=0

  write(0,*) ' proclist: serial mode.'
  myid=0
  numprocs=0

#endif

  if (allocated(iwrite))deallocate(iwrite)
  allocate(iwrite(0:numprocs-1))
  iwrite(:)=0

  if(myid.eq.0) then

     call get_arg_count(nargs)
     if(nargs.le.0) then

        write(0,*) ' ?filename argument missing.'
        write(0,*) ' ?syntax:  [mpi_]proclist  <filename>'
        call exit(1)

     endif

     call get_arg(1,filenam)
     open(unit=lunout,file=filenam,status='unknown',iostat=istat)

     if(istat.ne.0) then

        write(0,*) ' ?filename open failure: "',trim(filenam),'".'
        write(0,*) ' ?syntax:  [mpi_]proclist  <filename>'
        call exit(1)

     endif
  endif

#ifdef __MPI

  call MPI_GET_PROCESSOR_NAME(proc_name,iresult,ierr)
  call ckerr('MPI_GET_PROCESSOR_NAME')

  mywid = len(trim(proc_name))

  call MPI_ALLREDUCE(mywid,maxwid,1, &
       MPI_INTEGER,MPI_MAX,nbi_comm,ierr)
  call ckerr('MPI_ALLREDUCE(mywid)')

  allocate(intbuf(maxwid,0:numprocs-1)); intbuf = 0
  allocate(intbufr(maxwid,0:numprocs-1))

  do ii=1,mywid
     intbuf(ii,myid) = ichar(proc_name(ii:ii))
  enddo

  call MPI_REDUCE(intbuf,intbufr, numprocs*maxwid, &
       MPI_INTEGER,MPI_SUM,0,nbi_comm,ierr)
  call ckerr('MPI_REDUCE(intbuf)')

  if(myid.eq.0) then
     hostnam1=' '
     do jj=0,numprocs-1
        hostnam=' '
        do ii=1,maxwid
           if(intbufr(ii,jj).eq.0) exit
           hostnam(ii:ii) = char(intbufr(ii,jj))
        enddo
!       if (trim(hostnam).ne.trim(hostnam1))iwrite(jj)=1
        if (trim(hostnam).ne.trim(hostnam1))iwrite(jj)=jj
        if (jj.eq.0) iwrite(jj)=0
        hostnam1=hostnam
        write(lunout,'(1x,i8,1x,a,1x,i8)') jj, trim(hostnam), iwrite(jj)
     enddo
  endif

#else
  call sget_host(hostnam)

  idum = 0
  write(lunout,'(1x,i8,1x,a,1x,i8)') myid, trim(hostnam), idum
#endif

  close(unit=lunout)

#ifdef __MPI
  call MPI_FINALIZE(ierr);  call ckerr('MPI_FINALIZE')
#endif

  deallocate(iwrite)

CONTAINS
  subroutine ckerr(callnam)

    character*(*) :: callnam

    if(ierr.ne.0) then
       write(0,*) ' error ierr=',ierr,' in call "',trim(callnam), &
            '" on proc #',myid
       call bad_Exit
    endif

  end subroutine ckerr

end program proclist

      subroutine cvt_days(iseconds,iarray)
      integer iseconds                  ! number of seconds, input (.gt.0)
      integer iarray(4)                 ! equiv. no. of days, hours, mins, secs
C
C  on output,  iarray(1) = no. of complete 24 hour days covered by iseconds
C              iarray(2) = no. of hours (past a complete day) covered
C                          btw 0 and 23
C              iarray(3) = no. of minutes (past a complete hour) covered
C                          btw 0 and 59
C              iarray(4) = no. of seconds (past a cmoplete minute) covered
C                          btw 0 and 59
C
      data isecmin/60/                  ! seconds / minute
      data isechour/3600/               ! seconds / hour
      data isecday/86400/               ! seconds / day
C
      iwork=iseconds
C
      iarray(1)=iwork/isecday
      iwork=iwork-isecday*iarray(1)
C
      iarray(2)=iwork/isechour
      iwork=iwork-isechour*iarray(2)
C
      iarray(3)=iwork/isecmin
      iarray(4)=iwork-isecmin*iarray(3)
C
      return
      end

      subroutine fdelete(filename,ier)
C
C  dmc 18 June 1996 -- delete file
C
C  encapsulate VMS/UNIX OS dependence here.
C
      character*(*) filename  ! file to delete...
C
C  ** delete a file **
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
C  VMS note:  if no file version number is supplied, ";*" is appended;
C    this will delete all versions of the named file.
C
C
      integer str_length
C
#ifdef __UNIX
#include "fpreproc/byte_declare.h"
      byte_declare fnbuf(500)
      integer cdelete
#endif
C----------------------------------
C
      ier=0
C
      ilf=str_length(filename)
      if(ilf.eq.0) then
         write(6,*) ' ?fdelete:  filename argument is blank.'
         ier=1
         return
      endif
C
C  UNIX code:
C
#ifdef __UNIX
      call cstring(filename(1:ilf),fnbuf,'2C')
      ier=cdelete(fnbuf)
#endif
C
C  VMS code:
C
#ifdef __VMS
      ichk=0
      if(filename(ilf:ilf).eq.'.') ichk=1
      if(index(filename,';').gt.0) ichk=1
      if(ichk.eq.1) then
         istat=lib$delete_file(filename(1:ilf))
      else
         istat=lib$delete_file(filename(1:ilf)//';*')
      endif
      if(istat.ne.1) then
        ier=1
      else
        ier=0
      endif
#endif
C
      return
      end

subroutine herm2ev(xget,yget,x,nx,y,ny,ilinx,iliny, &
     f,inf2,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a 2d cubic Hermite interpolant on a rectilinear
  !  grid -- this is C1 in both directions.
  !
  !  this subroutine calls two subroutines:
  !     herm2xy  -- find cell containing (xget,yget)
  !     herm2fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer ny,inf2,nx
  !============
  real(fp) :: xget,yget                    ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  integer iliny                     ! iliny=1 => assume y evenly spaced
  !
  real(fp) :: f(0:3,inf2,ny)               ! function data
  !
  !       f 2nd dimension inf2 must be .ge. nx
  !       contents of f:
  !
  !  f(0,i,j) = f @ x(i),y(j)
  !  f(1,i,j) = df/dx @ x(i),y(j)
  !  f(2,i,j) = df/dy @ x(i),y(j)
  !  f(3,i,j) = d2f/dxdy @ x(i),y(j)
  !
  integer ict(4)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return d2f/dxdy (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the fourth output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,1]
  !   on output fval= [f,df/dx,df/dy,d2f/dxdy]
  !
  !    on input ict = [1,0,0,0]
  !   on output fval= [f] ... elements 2 & 3 & 4 never referenced
  !
  !    on input ict = [0,1,1,0]
  !   on output fval= [df/dx,df/dy] ... element 3 & 4 never referenced
  !
  !    on input ict = [0,0,1,0]
  !   on output fval= [df/dy] ... elements 2 & 3 & 4 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j                       ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !
  real(fp), dimension(1) :: xparam,yparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy
  real(fp), dimension(1) :: hxi,hyi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm2xy(xget,yget,x,nx,y,ny,ilinx,iliny, &
       i(1),j(1),xparam(1),yparam(1), &
       hx(1),hxi(1),hy(1),hyi(1),ier)
  if(ier.ne.0) return
  !
  call herm2fcn(ict,1,1, &
       fval,i,j,xparam,yparam,hx,hxi,hy,hyi,f,inf2,ny)
  !
  return
end subroutine herm2ev
!---------------------------------------------------------------------
!  herm2xy -- look up x-y zone
!
!  this is the "first part" of herm2ev, see comments, above.
!
subroutine herm2xy(xget,yget,x,nx,y,ny,ilinx,iliny, &
     i,j,xparam,yparam,hx,hxi,hy,hyi,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  input of herm2xy
  !  ================
  !
  !============
  implicit none
  integer nxm,nym,ii,jj
  !============
  real(fp) :: zxget,zyget,zxtol,zytol
  !============
  integer nx,ny                     ! array dimensions
  !
  real(fp) :: xget,yget                    ! target point
  real(fp) :: x(nx),y(ny)                  ! indep. coords., strict ascending
  !
  integer ilinx                     ! =1:  x evenly spaced
  integer iliny                     ! =1:  y evenly spaced
  !
  !  output of herm2xy
  !  =================
  integer i,j                       ! index to cell containing target pt
  !          on exit:  1.le.i.le.nx-1   1.le.j.le.ny-1
  !
  !  normalized position w/in (i,j) cell (btw 0 and 1):
  !
  real(fp) :: xparam                       ! (xget-x(i))/(x(i+1)-x(i))
  real(fp) :: yparam                       ! (yget-y(j))/(y(j+1)-y(j))
  !
  !  grid spacing
  !
  real(fp) :: hx                           ! hx = x(i+1)-x(i)
  real(fp) :: hy                           ! hy = y(j+1)-y(j)
  !
  !  inverse grid spacing:
  !
  real(fp) :: hxi                          ! 1/hx = 1/(x(i+1)-x(i))
  real(fp) :: hyi                          ! 1/hy = 1/(y(j+1)-y(j))
  !
  integer ier                       ! return ier.ne.0 on error
  !
  !------------------------------------
  !
  ier=0
  !
  !  range check
  !
  zxget=xget
  zyget=yget
  if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
     zxtol=4.0E-7_fp*max(abs(x(1)),abs(x(nx)))
     if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
        ier=1
        write(6,1001) xget,x(1),x(nx)
1001    format(' ?herm2ev:  xget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((xget.lt.x(1)-0.5_fp*zxtol).or. &
             (xget.gt.x(nx)+0.5_fp*zxtol)) &
             write(6,1011) xget,x(1),x(nx)
1011    format(' %herm2ev:  xget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(xget.lt.x(1)) then
           zxget=x(1)
        else
           zxget=x(nx)
        end if
     end if
  end if
  if((yget.lt.y(1)).or.(yget.gt.y(ny))) then
     zytol=4.0E-7_fp*max(abs(y(1)),abs(y(ny)))
     if((yget.lt.y(1)-zytol).or.(yget.gt.y(ny)+zytol)) then
        ier=1
        write(6,1002) yget,y(1),y(ny)
1002    format(' ?herm2ev:  yget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((yget.lt.y(1)-0.5_fp*zytol).or. &
             (yget.gt.y(ny)+0.5_fp*zytol)) &
             write(6,1012) yget,y(1),y(ny)
1012    format(' %herm2ev:  yget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(yget.lt.y(1)) then
           zyget=y(1)
        else
           zyget=y(ny)
        end if
     end if
  end if
  if(ier.ne.0) return
  !
  !  now find interval in which target point lies..
  !
  nxm=nx-1
  nym=ny-1
  !
  if(ilinx.eq.1) then
     ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
     i=min(nxm, ii)
     if(zxget.lt.x(i)) then
        i=i-1
     else if(zxget.gt.x(i+1)) then
        i=i+1
     end if
  else
     if((1.le.i).and.(i.lt.nxm)) then
        if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
           continue  ! already have the zone
        else
           call zonfind(x,nx,zxget,i)
        end if
     else
        i=nx/2
        call zonfind(x,nx,zxget,i)
     end if
  end if
  !
  if(iliny.eq.1) then
     jj=1+nym*(zyget-y(1))/(y(ny)-y(1))
     j=min(nym, jj)
     if(zyget.lt.y(j)) then
        j=j-1
     else if(zyget.gt.y(j+1)) then
        j=j+1
     end if
  else
     if((1.le.j).and.(j.lt.nym)) then
        if((y(j).le.zyget).and.(zyget.le.y(j+1))) then
           continue  ! already have the zone
        else
           call zonfind(y,ny,zyget,j)
        end if
     else
        j=ny/2
        call zonfind(y,ny,zyget,j)
     end if
  end if
  !
  hx=(x(i+1)-x(i))
  hy=(y(j+1)-y(j))
  !
  hxi=1.0_fp/hx
  hyi=1.0_fp/hy
  !
  xparam=(zxget-x(i))*hxi
  yparam=(zyget-y(j))*hyi
  !
  return
end subroutine herm2xy
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine herm2fcn(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,i,j,iadr
  !============
  real(fp) :: xp,xpi,xp2,xpi2,ax,axbar,bx,bxbar,yp,ypi,yp2,ypi2,ay
  real(fp) :: aybar,by,bybar,axp,axbarp,bxp,bxbarp,ayp,aybarp,byp
  real(fp) :: bybarp
  !============
  integer ict(4)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec)         ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam(ivec)
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy(ivec)            ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec)          ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(0:3,inf2,ny)             ! interpolant data (cf "herm2ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  herm2ev comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Hermite cubic basis functions
  !  -->for function value matching
  !     a(0)=0 a(1)=1        a'(0)=0 a'(1)=0
  !   abar(0)=1 abar(1)=0  abar'(0)=0 abar'(1)=0
  !
  !   a(x)=-2*x**3 + 3*x**2    = x*x*(-2.0*x+3.0)
  !   abar(x)=1-a(x)
  !   a'(x)=-abar'(x)          = 6.0*x*(1.0-x)
  !
  !  -->for derivative matching
  !     b(0)=0 b(1)=0          b'(0)=0 b'(1)=1
  !   bbar(0)=0 bbar(1)=0  bbar'(0)=1 bbar'(1)=0
  !
  !     b(x)=x**3-x**2         b'(x)=3*x**2-2*x
  !     bbar(x)=x**3-2*x**2+x  bbar'(x)=3*x**2-4*x+1
  !
  real(fp) :: sum
  integer v
  !
  do v=1,ivec
     i=ii(v)
     j=jj(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     xp2=xp*xp
     xpi2=xpi*xpi
     ax=xp2*(3.0_fp-2.0_fp*xp)
     axbar=1.0_fp-ax
     bx=-xp2*xpi
     bxbar=xpi2*xp
     !
     !   ...in y direction
     !
     yp=yparam(v)
     ypi=1.0_fp-yp
     yp2=yp*yp
     ypi2=ypi*ypi
     ay=yp2*(3.0_fp-2.0_fp*yp)
     aybar=1.0_fp-ay
     by=-yp2*ypi
     bybar=ypi2*yp
     !
     !   ...derivatives...
     !
     axp=6.0_fp*xp*xpi
     axbarp=-axp
     bxp=xp*(3.0_fp*xp-2.0_fp)
     bxbarp=xpi*(3.0_fp*xpi-2.0_fp)
     !
     ayp=6.0_fp*yp*ypi
     aybarp=-ayp
     byp=yp*(3.0_fp*yp-2.0_fp)
     bybarp=ypi*(3.0_fp*ypi-2.0_fp)
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=axbar*(aybar*fin(0,i,j)  +ay*fin(0,i,j+1))+ &
             ax*(aybar*fin(0,i+1,j)+ay*fin(0,i+1,j+1))
        !
        sum=sum+hx(v)*( &
             bxbar*(aybar*fin(1,i,j)  +ay*fin(1,i,j+1))+ &
             bx*(aybar*fin(1,i+1,j)+ay*fin(1,i+1,j+1)))
        !
        sum=sum+hy(v)*( &
             axbar*(bybar*fin(2,i,j)  +by*fin(2,i,j+1))+ &
             ax*(bybar*fin(2,i+1,j)+by*fin(2,i+1,j+1)))
        !
        sum=sum+hx(v)*hy(v)*( &
             bxbar*(bybar*fin(3,i,j)  +by*fin(3,i,j+1))+ &
             bx*(bybar*fin(3,i+1,j)+by*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*( &
             axbarp*(aybar*fin(0,i,j)  +ay*fin(0,i,j+1))+ &
             axp*(aybar*fin(0,i+1,j)+ay*fin(0,i+1,j+1)))
        !
        sum=sum+ &
             bxbarp*(aybar*fin(1,i,j)  +ay*fin(1,i,j+1))+ &
             bxp*(aybar*fin(1,i+1,j)+ay*fin(1,i+1,j+1))
        !
        sum=sum+hxi(v)*hy(v)*( &
             axbarp*(bybar*fin(2,i,j)  +by*fin(2,i,j+1))+ &
             axp*(bybar*fin(2,i+1,j)+by*fin(2,i+1,j+1)))
        !
        sum=sum+hy(v)*( &
             bxbarp*(bybar*fin(3,i,j)  +by*fin(3,i,j+1))+ &
             bxp*(bybar*fin(3,i+1,j)+by*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=hyi(v)*( &
             axbar*(aybarp*fin(0,i,j)  +ayp*fin(0,i,j+1))+ &
             ax*(aybarp*fin(0,i+1,j)+ayp*fin(0,i+1,j+1)))
        !
        sum=sum+hx(v)*hyi(v)*( &
             bxbar*(aybarp*fin(1,i,j)  +ayp*fin(1,i,j+1))+ &
             bx*(aybarp*fin(1,i+1,j)+ayp*fin(1,i+1,j+1)))
        !
        sum=sum+ &
             axbar*(bybarp*fin(2,i,j)  +byp*fin(2,i,j+1))+ &
             ax*(bybarp*fin(2,i+1,j)+byp*fin(2,i+1,j+1))
        !
        sum=sum+hx(v)*( &
             bxbar*(bybarp*fin(3,i,j)  +byp*fin(3,i,j+1))+ &
             bx*(bybarp*fin(3,i+1,j)+byp*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi(v)*( &
             axbarp*(aybarp*fin(0,i,j)  +ayp*fin(0,i,j+1))+ &
             axp*(aybarp*fin(0,i+1,j)+ayp*fin(0,i+1,j+1)))
        !
        sum=sum+hyi(v)*( &
             bxbarp*(aybarp*fin(1,i,j)  +ayp*fin(1,i,j+1))+ &
             bxp*(aybarp*fin(1,i+1,j)+ayp*fin(1,i+1,j+1)))
        !
        sum=sum+hxi(v)*( &
             axbarp*(bybarp*fin(2,i,j)  +byp*fin(2,i,j+1))+ &
             axp*(bybarp*fin(2,i+1,j)+byp*fin(2,i+1,j+1)))
        !
        sum=sum+ &
             bxbarp*(bybarp*fin(3,i,j)  +byp*fin(3,i,j+1))+ &
             bxp*(bybarp*fin(3,i+1,j)+byp*fin(3,i+1,j+1))
        !
        fval(v,iadr)=sum
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine herm2fcn
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!    --optimized for VARIATION along x axis ONLY--
!
subroutine herm2fcnx(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,j,i,iadr
  !============
  real(fp) :: yp,ypi,yp2,ypi2,ay,aybar,by,bybar,ayp,aybarp,byp
  real(fp) :: bybarp,xp,xpi,xp2,xpi2,ax,axbar,bx,bxbar,axp,axbarp
  real(fp) :: bxp,bxbarp
  !============
  integer ict(4)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj               ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy                  ! grid spacing, and
  real(fp) :: hxi(ivec),hyi                ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(0:3,inf2,ny)             ! interpolant data (cf "herm2ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  herm2ev comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Hermite cubic basis functions
  !  -->for function value matching
  !     a(0)=0 a(1)=1        a'(0)=0 a'(1)=0
  !   abar(0)=1 abar(1)=0  abar'(0)=0 abar'(1)=0
  !
  !   a(x)=-2*x**3 + 3*x**2    = x*x*(-2.0*x+3.0)
  !   abar(x)=1-a(x)
  !   a'(x)=-abar'(x)          = 6.0*x*(1.0-x)
  !
  !  -->for derivative matching
  !     b(0)=0 b(1)=0          b'(0)=0 b'(1)=1
  !   bbar(0)=0 bbar(1)=0  bbar'(0)=1 bbar'(1)=0
  !
  !     b(x)=x**3-x**2         b'(x)=3*x**2-2*x
  !     bbar(x)=x**3-2*x**2+x  bbar'(x)=3*x**2-4*x+1
  !
  real(fp) :: sum
  integer v
  !
  j=jj
  !
  !   ...in y direction
  !
  yp=yparam
  ypi=1.0_fp-yp
  yp2=yp*yp
  ypi2=ypi*ypi
  ay=yp2*(3.0_fp-2.0_fp*yp)
  aybar=1.0_fp-ay
  by=-yp2*ypi
  bybar=ypi2*yp
  !
  !   ...derivatives...
  !
  ayp=6.0_fp*yp*ypi
  aybarp=-ayp
  byp=yp*(3.0_fp*yp-2.0_fp)
  bybarp=ypi*(3.0_fp*ypi-2.0_fp)
  !
  do v=1,ivec
     i=ii(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     xp2=xp*xp
     xpi2=xpi*xpi
     ax=xp2*(3.0_fp-2.0_fp*xp)
     axbar=1.0_fp-ax
     bx=-xp2*xpi
     bxbar=xpi2*xp
     !
     !   ...derivatives...
     !
     axp=6.0_fp*xp*xpi
     axbarp=-axp
     bxp=xp*(3.0_fp*xp-2.0_fp)
     bxbarp=xpi*(3.0_fp*xpi-2.0_fp)
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=axbar*(aybar*fin(0,i,j)  +ay*fin(0,i,j+1))+ &
             ax*(aybar*fin(0,i+1,j)+ay*fin(0,i+1,j+1))
        !
        sum=sum+hx(v)*( &
             bxbar*(aybar*fin(1,i,j)  +ay*fin(1,i,j+1))+ &
             bx*(aybar*fin(1,i+1,j)+ay*fin(1,i+1,j+1)))
        !
        sum=sum+hy*( &
             axbar*(bybar*fin(2,i,j)  +by*fin(2,i,j+1))+ &
             ax*(bybar*fin(2,i+1,j)+by*fin(2,i+1,j+1)))
        !
        sum=sum+hx(v)*hy*( &
             bxbar*(bybar*fin(3,i,j)  +by*fin(3,i,j+1))+ &
             bx*(bybar*fin(3,i+1,j)+by*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*( &
             axbarp*(aybar*fin(0,i,j)  +ay*fin(0,i,j+1))+ &
             axp*(aybar*fin(0,i+1,j)+ay*fin(0,i+1,j+1)))
        !
        sum=sum+ &
             bxbarp*(aybar*fin(1,i,j)  +ay*fin(1,i,j+1))+ &
             bxp*(aybar*fin(1,i+1,j)+ay*fin(1,i+1,j+1))
        !
        sum=sum+hxi(v)*hy*( &
             axbarp*(bybar*fin(2,i,j)  +by*fin(2,i,j+1))+ &
             axp*(bybar*fin(2,i+1,j)+by*fin(2,i+1,j+1)))
        !
        sum=sum+hy*( &
             bxbarp*(bybar*fin(3,i,j)  +by*fin(3,i,j+1))+ &
             bxp*(bybar*fin(3,i+1,j)+by*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=hyi*( &
             axbar*(aybarp*fin(0,i,j)  +ayp*fin(0,i,j+1))+ &
             ax*(aybarp*fin(0,i+1,j)+ayp*fin(0,i+1,j+1)))
        !
        sum=sum+hx(v)*hyi*( &
             bxbar*(aybarp*fin(1,i,j)  +ayp*fin(1,i,j+1))+ &
             bx*(aybarp*fin(1,i+1,j)+ayp*fin(1,i+1,j+1)))
        !
        sum=sum+ &
             axbar*(bybarp*fin(2,i,j)  +byp*fin(2,i,j+1))+ &
             ax*(bybarp*fin(2,i+1,j)+byp*fin(2,i+1,j+1))
        !
        sum=sum+hx(v)*( &
             bxbar*(bybarp*fin(3,i,j)  +byp*fin(3,i,j+1))+ &
             bx*(bybarp*fin(3,i+1,j)+byp*fin(3,i+1,j+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi*( &
             axbarp*(aybarp*fin(0,i,j)  +ayp*fin(0,i,j+1))+ &
             axp*(aybarp*fin(0,i+1,j)+ayp*fin(0,i+1,j+1)))
        !
        sum=sum+hyi*( &
             bxbarp*(aybarp*fin(1,i,j)  +ayp*fin(1,i,j+1))+ &
             bxp*(aybarp*fin(1,i+1,j)+ayp*fin(1,i+1,j+1)))
        !
        sum=sum+hxi(v)*( &
             axbarp*(bybarp*fin(2,i,j)  +byp*fin(2,i,j+1))+ &
             axp*(bybarp*fin(2,i+1,j)+byp*fin(2,i+1,j+1)))
        !
        sum=sum+ &
             bxbarp*(bybarp*fin(3,i,j)  +byp*fin(3,i,j+1))+ &
             bxp*(bybarp*fin(3,i+1,j)+byp*fin(3,i+1,j+1))
        !
        fval(v,iadr)=sum
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine herm2fcnx

subroutine mkspline(x,nx,fspl,ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ilinx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  make a 2-coefficient 1d spline
  !
  !  only 2 coefficients, the data and its 2nd derivative, are needed to
  !  fully specify a spline.  See e.g. Numerical Recipies in Fortran-77
  !  (2nd edition) chapter 3, section on cubic splines.
  !
  !  input:
  !============
  implicit none
  integer i,inwk
  !============
  real(fp) :: bcxmax
  !============
  integer nx                        ! no. of data points
  real(fp) :: x(nx)                        ! x axis data, strict ascending order
  !
  !  input/output:
  real(fp) :: fspl(2,nx)                   ! f(1,*):  data in; f(2,*):  coeffs out
  !
  !     f(1,j) = f(x(j))  on input (unchanged on output)
  !     f(2,j) = f''(x(j)) (of interpolating spline) (on output).
  !
  !  ...boundary conditions...
  !
  !  input:
  !
  integer ibcxmin                   ! b.c. flag @ x=xmin=x(1)
  real(fp) :: bcxmin                       ! b.c. data @xmin
  !
  integer ibcxmax                   ! b.c. flag @ x=xmax=x(nx)
  real(fp) :: bcxcmax                      ! b.c. data @xmax
  !
  !  ibcxmin=-1 -- periodic boundary condition
  !                (bcxmin,ibcxmax,bcxmax are ignored)
  !
  !                the output spline s satisfies
  !                s'(x(1))=s'(x(nx)) ..and.. s''(x(1))=s''(x(nx))
  !
  !  if non-periodic boundary conditions are used, then the xmin and xmax
  !  boundary conditions can be specified independently:
  !
  !  ibcxmin (ibcxmax) = 0 -- this specifies a "not a knot" boundary
  !                condition, see "cubsplb.f90".  This is a common way
  !                for inferring a "good" spline boundary condition
  !                automatically from data in the vicinity of the
  !                boundary.  ... bcxmin (bcxmax) are ignored.
  !
  !  ibcxmin (ibcxmax) = 1 -- boundary condition is to have s'(x(1))
  !                ( s'(x(nx)) ) match the passed value bcxmin (bcxmax).
  !
  !  ibcxmin (ibcxmax) = 2 -- boundary condition is to have s''(x(1))
  !                ( s''(x(nx)) ) match the passed value bcxmin (bcxmax).
  !
  !  ibcxmin (ibcxmax) = 3 -- boundary condition is to have s'(x(1))=0.0
  !                ( s'(x(nx))=0.0 )
  !
  !  ibcxmin (ibcxmax) = 4 -- boundary condition is to have s''(x(1))=0.0
  !                ( s''(x(nx))=0.0 )
  !
  !  ibcxmin (ibcxmax) = 5 -- boundary condition is to have s'(x(1))
  !                ( s'(x(nx)) ) match the 1st divided difference
  !                e.g. at x(1):  d(1)/h(1), where
  !                           d(j)=f(1,j+1)-f(1,j)
  !                           h(j)=x(j+1)-x(j)
  !
  !  ibcxmin (ibcxmax) = 6 -- BC is to have s''(x(1)) ( s''(x(nx)) )
  !                match the 2nd divided difference
  !                e.g. at x(1):
  !                     e(1) = [d(2)/h(2) - d(1)/h(1)]/(0.5*(h(1)+h(2)))
  !
  !  ibcxmin (ibcxmax) = 7 -- BC is to have s'''(x(1)) ( s'''(x(nx)) )
  !                match the 3rd divided difference
  !                e.g. at x(1): [e(2)-e(1)]/(0.33333*(h(1)+h(2)+h(3)))
  !
  !  output:
  !
  integer ilinx                     ! =1: hint, x axis is ~evenly spaced
  !
  !  let dx[avg] = (x(nx)-x(1))/(nx-1)
  !  let dx[j] = x(j+1)-x(j), for all j satisfying 1.le.j.lt.nx
  !
  !  if for all such j, abs(dx[j]-dx[avg]).le.(1.0e-3*dx[avg]) then
  !  ilinx=1 is returned, indicating the data is (at least nearly)
  !  evenly spaced.  Even spacing is useful, for speed of zone lookup,
  !  when evaluating a spline.
  !
  !  if the even spacing condition is not satisfied, ilinx=2 is returned.
  !
  integer ier                       ! exit code, 0=OK
  !
  !  an error code is returned if the x axis is not strict ascending,
  !  or if nx.lt.4, or if an invalid boundary condition specification was
  !  input.
  !
  !------------------------------------
  !
  !  this routine calls traditional 4 coefficient spline software, and
  !  translates the result to 2 coefficient form.
  !
  !  this could be done more efficiently but we decided out of conservatism
  !  to use the traditional software.
  !
  !------------------------------------
  !  workspaces -- f90 dynamically allocated
  !
  real(fp), dimension(:,:), allocatable :: fspl4 ! traditional 4-spline
  real(fp), dimension(:), allocatable :: wk ! cspline workspace
  !
  !------------------------------------
  !
  allocate(fspl4(4,nx),wk(nx))
  !
  !  make the traditional call
  !
  do i=1,nx
     fspl4(1,i)=fspl(1,i)
     fspl(2,i)=0.0_fp  ! for now
  end do
  !
  inwk=nx
  !
  !  boundary conditions imposed by cspline...
  !
  call cspline(x,nx,fspl4,ibcxmin,bcxmin,ibcxmax,bcxmax, &
       wk,inwk,ilinx,ier)
  !
  if(ier.eq.0) then
     !
     !  copy the output -- careful of end point.
     !
     do i=1,nx-1
        fspl(2,i)=2.0_fp*fspl4(3,i)
     end do
     fspl(2,nx)=2.0_fp*fspl4(3,nx-1) + &
          (x(nx)-x(nx-1))*6.0_fp*fspl4(4,nx-1)
  end if
  !
  deallocate(fspl4,wk)
  !
  return
end subroutine mkspline

!  pspline library test routine
!
subroutine pspltsub(filename,zctrl)
  use iso_c_binding, only: fp => c_double
  !
  !  write output to file
  !
  implicit none
  character(len=*), intent(in) :: filename  ! write output here; ' ' for stdio
  real(fp), intent(in) :: zctrl              ! control (not yet used...)
  !
  !  if filename ends in ".tmp" delete when done.
  !
  common/bc_ctrl/ nbc
  common/pspltest_io/ m
  !
  integer :: ilen,m,nbc
  logical :: tmpflag
  !-----------------------------------
  !
  tmpflag=.FALSE.
  if(filename.eq.' ') then
     m=6
  else
     m=99
     ilen=len(trim(filename))
     if(filename(max(1,(ilen-3)):ilen).eq.'.tmp') tmpflag = .TRUE.
     !
     open(unit=m,file=filename,status='unknown')
  end if
  !
  !-----------------------------------
  !  set nbc=0 to use "not a knot" instead of explicit 1st deriv bc
  !  set nbc=1 to use explicit condition based on analytic expression
  !  (more accurate)
  !
  nbc=1
  !
  write(m,1000)
1000 format(/' *** 1d spline tests ***'/ &
       '     f(x)=2+sin(x)'/ &
       '     x in the interval [0,2pi]')
  call pspltest1(zctrl)
  write(m,1001)
1001 format(/' *** 2d spline tests ***'/ &
       '     f(x,theta)=exp(2x-1)*(2+sin(theta))'/ &
       '     x in [0,1],  theta in [0,2pi]'/)
  call pspltest2(zctrl)
  write(m,1002)
1002 format(/' *** 3d spline tests ***'/ &
       '     f(x,theta,phi)=exp(2x-1)*(2+sin(theta))*(3+sin(phi))'/ &
       '     x in [0,1],  theta in [0,2pi],  phi in [0,2pi]'/)
  call pspltest3(zctrl)
  !
  !-----------------------------------
  !  dmc Feb 2010:  add tests to verify extension of pspline to
  !  small grids: nx=2, nx=3
  !
  call smalltest(zctrl)
  !
  !-----------------------------------
  !  close file
  !
  if(tmpflag) then
     close(unit=m,status='delete')
  else
     close(unit=m)
  end if
  !
  !-----------------------------------
  !
  return
end subroutine pspltsub
!
!------------------------------------------------
!
subroutine pspltest1(zctrl)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer m,is,inum,ix
  !============
  real(fp) :: pi2
  !============
  real(fp), intent(in) :: zctrl
  !
  common/pspltest_io/ m
  !
  real(fp) :: x(80)
  real(fp) :: fs(320),fsp(320),xpkg(320)
  real(fp) :: fh(160),fs2(160)
  !
  real(fp) :: xtest(1000),ftest(1000),zdum(1000)
  real(fp) :: testa1(1000),testa2(1000),testa3(1000),testa4(1000)
  real(fp) :: testa5(1000)
  !
  real(fp) :: zcos(80),z2sin(80)
  real(fp) :: zero
  !
  integer isize(4)
  !
  data isize/10,20,40,80/
  !
  data pi2/6.2831853_fp/
  data zero/0.0_fp/
  !
  !  test splining of function:  f(x)=2+sin(x)
  !
  !-------------------------------------------
  !
  call tset(1000,xtest,ftest,zdum,zero-0.1_fp,pi2+0.1_fp)
  !
  do is=1,4
     inum=isize(is)
     call tset(inum,x,z2sin,zcos,zero,pi2)
     do ix=1,inum
        zcos(ix)=cos(x(ix))         ! df/dx
     end do
     !
     write(m,*) ' '
     call dotest1(inum,x,z2sin,zcos,fs,fsp,fh,fs2,1000, &
          xtest,ftest,xpkg,testa1,testa2,testa3,testa4,testa5,zdum)
  end do
  !
  return
end subroutine pspltest1
!------------------------------------------------
!
subroutine dotest1(ns,x,f,fd,fspl,fspp,fherm,fs2,nt,xt,ft,xpkg, &
     testa1,testa2,testa3,testa4,testa5,wk)
  use iso_c_binding, only: fp => c_double
  !
  !
  !============
  implicit none
  integer nt,ns,m,nbc,i,ierg,ilinx,ier,iwarn
  !============
  real(fp) :: zdum,fmin,fmax,sdif,hdif,pdif,s2dif,pldif,sdifr,hdifr
  real(fp) :: pdifr,s2difr,pldifr,hermv,difabs,splinv,zlinv
  !============
  common/pspltest_io/ m
  !
  !  interpolant
  !
  real(fp) :: x(ns)                        ! interpolant grid
  real(fp) :: f(ns)                        ! fcn values at grid pts
  real(fp) :: fd(ns)                       ! derivatives at grid pts
  real(fp) :: fspl(4,ns)                   ! spline coeff. array (calc. here)
  real(fp) :: fspp(4,ns)                   ! spline coeff. array (calc. here)
  real(fp) :: fherm(0:1,ns)                ! hermite array (calc. here)
  real(fp) :: fs2(0:1,ns)                  ! compact spline coeff. array calc here
  !
  real(fp) :: xpkg(ns,4)                   ! x "package"
  !
  real(fp) :: wk(nt)                       ! workspace
  !
  real(fp) :: xt(nt)                       ! test grid
  real(fp) :: ft(nt)                       ! fcn values at test grid pts
  !
  real(fp) :: testa1(nt),testa2(nt),testa3(nt),testa4(nt),testa5(nt)
  !
  integer ict(3)
  !
  common/bc_ctrl/ nbc
  !
  data ict/1,0,0/                   ! just evaluate fcn value
  !
  !-------------------
  !
  do i=1,ns
     fherm(0,i)=f(i)
     fherm(1,i)=fd(i)
     fspl(1,i)=f(i)
     fspp(1,i)=f(i)
     fs2(0,i)=f(i)
  end do
  !
  call genxpkg(ns,x,xpkg,1,1,1,4.0E-7_fp,1,ierg)
  if(ierg.ne.0) write(m,*) ' ??dotest1:  genxpkg:  ierg=',ierg
  !
  !  spline setup calls
  !
  call cspline(x,ns,fspl,nbc,fd(1),nbc,fd(ns),wk,nt,ilinx,ier) ! 1st deriv bc
  call cspline(x,ns,fspp,-1,zdum,-1,zdum,wk,nt,ilinx,ier) ! periodic
  !
  call mkspline(x,ns,fs2,nbc,fd(1),nbc,fd(ns),ilinx,ier)
  !
  call akherm1p(x,ns,fherm,ilinx,1,ier)
  !
  !  vectorize spline/hermite evaluation calls
  !
  call spgrid(xt,nt,testa1,ns,xpkg,fspl,iwarn,ier)
  if(iwarn.ne.0) write(m,*) ' ?dotest1:  spgrid(1):  iwarn=',iwarn
  if(ier.ne.0) write(m,*) ' ?dotest1:  spgrid(1):  ier=',ier
  !
  call spgrid(xt,nt,testa2,ns,xpkg,fspp,iwarn,ier)
  if(iwarn.ne.0) write(m,*) ' ?dotest1:  spgrid(2):  iwarn=',iwarn
  if(ier.ne.0) write(m,*) ' ?dotest1:  spgrid(2):  ier=',ier
  !
  call gridspline(xt,nt,testa3,ns,xpkg,fs2,iwarn,ier)
  if(iwarn.ne.0) write(m,*) ' ?dotest1:  gridspline:  iwarn=', &
       iwarn
  if(ier.ne.0) write(m,*) ' ?dotest1:  gridspline:  ier=',ier
  !
  call gridherm1(xt,nt,testa4,ns,xpkg,fherm,iwarn,ier)
  if(iwarn.ne.0) write(m,*) ' ?dotest1:  gridherm1:  iwarn=', &
       iwarn
  if(ier.ne.0) write(m,*) ' ?dotest1:  gridherm1:  ier=',ier
  !
  call gridpc1(xt,nt,testa5,ns,xpkg,f,iwarn,ier)
  if(iwarn.ne.0) write(m,*) ' ?dotest1:  gridpc1:  iwarn=', &
       iwarn
  if(ier.ne.0) write(m,*) ' ?dotest1:  gridpc1:  ier=',ier
  !
  fmin=1.0E30_fp
  fmax=-fmin
  sdif=0.0_fp
  hdif=0.0_fp
  pdif=0.0_fp
  s2dif=0.0_fp
  pldif=0.0_fp
  sdifr=0.0_fp
  hdifr=0.0_fp
  pdifr=0.0_fp
  s2difr=0.0_fp
  pldifr=0.0_fp
  !
  ier=0
  !
  do i=1,nt
     fmin=min(ft(i),fmin)
     fmax=max(ft(i),fmax)
     !
     hermv=testa4(i)
     !xx         call herm1ev(xt(i),x,ns,ilinx,fherm,ict,hermv,ier)
     !xx         if(ier.ne.0) write(m,'('' ?? ier.ne.0 in dotest1 (herm1ev)'')')
     !
     difabs=abs(hermv-ft(i))
     hdif=max(hdif,difabs)
     hdifr=max(hdifr,difabs/ft(i))
     !
     splinv=testa1(i)
     !xx         call cspeval(xt(i),ict,splinv,x,ns,ilinx,fspl,ier)
     !xx         if(ier.ne.0) write(m,'('' ?? ier.ne.0 in dotest1 (cspeval)'')')
     !
     difabs=abs(splinv-ft(i))
     sdif=max(sdif,difabs)
     sdifr=max(sdifr,difabs/ft(i))
     !
     splinv=testa2(i)
     !xx         call cspeval(xt(i),ict,splinv,x,ns,ilinx,fspp,ier)
     !xx         if(ier.ne.0) write(m,'('' ?? ier.ne.0 in dotest1 (cspeval)'')')
     !
     difabs=abs(splinv-ft(i))
     pdif=max(pdif,difabs)
     pdifr=max(pdifr,difabs/ft(i))
     !
     splinv=testa3(i)
     !xx         call evspline(xt(i),x,ns,ilinx,fs2,ict,splinv,ier)
     !xx         if(ier.ne.0) write(m,'('' ?? ier.ne.0 in dotest1 (cspeval)'')')
     !
     difabs=abs(splinv-ft(i))
     s2dif=max(s2dif,difabs)
     s2difr=max(s2difr,difabs/ft(i))
     !
     zlinv=testa5(i)
     difabs=abs(zlinv-ft(i))
     pldif=max(pldif,difabs)
     pldifr=max(pldifr,difabs/ft(i))
     !
  end do
  !
  write(m,1000) '1d periodic spline',ns,fmin,fmax,pdif,pdifr
  write(m,1000) '1d spline w/bdy cond.',ns,fmin,fmax,sdif,sdifr
  write(m,1000) '1d compact spline w/bdy cond.',ns,fmin,fmax, &
       s2dif,s2difr
  write(m,1000) '1d Hermite interpolation',ns,fmin,fmax,hdif,hdifr
  write(m,1000) '1d piecewise linear',ns,fmin,fmax,pldif,pldifr
1000 format(/2x,a,' setup on ',i3,' point grid'/ &
       '   fmin=',1pe11.4,' fmax=',1pe11.4,' max(|diff|)=',1pe11.4/ &
       '     max(|diff|/f) = ',1pe11.4)
  !
  return
end subroutine dotest1
!
!------------------------------------------------
!
subroutine pspltest2(zctrl)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer m
  !============
  real(fp) :: pi2
  !============
  real(fp), intent(in) :: zctrl
  !
  common/pspltest_io/ m
  !
  !  test various bicubic spline routines
  !  for fitting the function
  !
  !     f(x,th)=exp(2*x-1)*(2+sin(th))
  !
  !  on 3 grid sizes; compare accuracy on test grid.
  !
  !  grid ranges:  x in [0,1], th in [0,2pi]
  !
  real(fp) :: x1(10),x2(20),x4(40),ex1(10),ex2(20),ex4(40)
  real(fp) :: t1(10),t2(20),t4(40),st1(10),st2(20),st4(40), &
       ct1(10),ct2(20),ct4(40)
  real(fp) :: bcx1(40),bcx2(40),bcth1(40),bcth2(40)
  !
  real(fp) :: f1(4,4,10,10),f2(4,4,20,20),f4(4,4,40,40),fh(6400)
  real(fp) :: flin(1600)
  !
  real(fp) :: xtest(200),extest(200),ttest(200),stest(200),ctest(200)
  real(fp) :: zero,one
  !
  data pi2/6.2831853_fp/
  data zero,one/0.0_fp,1.0_fp/
  !
  !---------------------------
  !
  call xset(10,x1,ex1,zero,one)
  call xset(20,x2,ex2,zero,one)
  call xset(40,x4,ex4,zero,one)
  call xset(200,xtest,extest,zero,one)
  !
  call tset(10,t1,st1,ct1,zero,pi2)
  call tset(20,t2,st2,ct2,zero,pi2)
  call tset(40,t4,st4,ct4,zero,pi2)
  call tset(200,ttest,stest,ctest,zero,pi2)
  !
  call ffset(10,ex1,st1,f1)
  call ffset(20,ex2,st2,f2)
  call ffset(40,ex4,st4,f4)
  !
  call dotest2(x1,ex1,10,t1,st1,ct1,10,f1,fh,flin, &
       bcx1,bcx2,bcth1,bcth2, &
       xtest,extest,ttest,stest,200)
  !
  call dotest2(x2,ex2,20,t2,st2,ct2,20,f2,fh,flin, &
       bcx1,bcx2,bcth1,bcth2, &
       xtest,extest,ttest,stest,200)
  !
  call dotest2(x4,ex4,40,t4,st4,ct4,40,f4,fh,flin, &
       bcx1,bcx2,bcth1,bcth2, &
       xtest,extest,ttest,stest,200)
  !
  return
end subroutine pspltest2
!-----------------------------------------------------------
subroutine xset(nx,x,ex,xmin,xmax)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nx,ix
  !============
  real(fp) :: xmin,xmax
  !============
  real(fp) :: x(nx)
  real(fp) :: ex(nx)
  !
  do ix=1,nx
     x(ix)=xmin + real(ix-1,fp)*(xmax-xmin)/real(nx-1,fp)
     ex(ix)=exp(2.0_fp*x(ix)-1.0_fp)
  end do
  !
  return
end subroutine xset
!-----------------------------------------------------------
subroutine tset(nth,th,sth,cth,thmin,thmax)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nth,ith
  !============
  real(fp) :: thmin,thmax
  !============
  real(fp) :: th(nth)
  real(fp) :: sth(nth)
  real(fp) :: cth(nth)
  !
  do ith=1,nth
     th(ith)=thmin + real(ith-1,fp)*(thmax-thmin)/real(nth-1,fp)
     sth(ith)=2.0_fp+sin(th(ith))
     cth(ith)=cos(th(ith))
  end do
  !
  return
end subroutine tset
!-----------------------------------------------------------
subroutine tset3(nph,ph,sph,cph,phmin,phmax)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nph,iph
  !============
  real(fp) :: phmin,phmax
  !============
  real(fp) :: ph(nph)
  real(fp) :: sph(nph)
  real(fp) :: cph(nph)
  !
  do iph=1,nph
     ph(iph)=phmin + real(iph-1,fp)*(phmax-phmin)/real(nph-1,fp)
     sph(iph)=3.0_fp+sin(ph(iph))
     cph(iph)=cos(ph(iph))
  end do
  !
  return
end subroutine tset3
!-----------------------------------------------------------
subroutine ffset(num,xf,tf,f)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer num,j,i
  !============
  real(fp) :: xf(num),tf(num),f(4,4,num,num)
  !
  do j=1,num
     do i=1,num
        f(1,1,i,j)=xf(i)*tf(j)
     end do
  end do
  !
  return
end subroutine ffset
!-----------------------------------------------------------
subroutine fset3(num,xf,tf,pf,f)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer num,k,j,i
  !============
  real(fp) :: xf(num),tf(num),pf(num),f(4,4,4,num,num,num)
  !
  do k=1,num
     do j=1,num
        do i=1,num
           f(1,1,1,i,j,k)=xf(i)*tf(j)*pf(k)
        end do
     end do
  end do
  !
  return
end subroutine fset3
!----------------------------------------------------------
subroutine bset(fx,nx,fth,nth,bcx1,bcx2,bcth1,bcth2)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nth,nx,ith,ix
  !============
  real(fp) :: fx(nx)                       ! x factor of test fcn
  real(fp) :: fth(nth)                     ! th factor of test fcn
  real(fp) :: bcx1(nth),bcx2(nth)          ! df/dx bdyy conds at x(1),x(nx)
  real(fp) :: bcth1(nx),bcth2(nx)          ! df/dth bdy conds at th(1),th(nth)
  !
  !  df/dx = 2*exp(2x-1)*(2+sin(th)) = 2*f
  !
  do ith=1,nth
     bcx1(ith)=2.0_fp*fx(1)*fth(ith)   ! df/dx @ x(1)
     bcx2(ith)=2.0_fp*fx(nx)*fth(ith)  ! df/dx @ x(nx)
  end do
  !
  !  df/dth = exp(2x-1)*cos(th)
  !  cos(0)=cos(2pi)=1
  !
  do ix=1,nx
     bcth1(ix)=fx(ix)               ! df/dth @ th=0 = th(1)
     bcth2(ix)=fx(ix)               ! df/dth @ th=2pi = th(nth)
  end do
  !
  return
end subroutine bset
!---------------------------------------------------------
subroutine dotest2(x,fx,nx,th,fth,dfth,nth,f,fh,flin, &
     bcx1,bcx2,bcth1,bcth2, &
     xtest,fxtest,thtest,fthtest,ntest)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nth,ntest,nx,m,nbc,ith,ix,ilinx,ilinth,ier
  !============
  common/pspltest_io/ m
  !
  !  test spline of f; f(i,j)=fx(i)*fth(j) on spline grid
  !                    f(i,j)=fxtest(i)*fthtest(j) on test grid
  !
  !  f is exp(2x-1)*(2+sin(th))  df/dx = 2*f
  !
  real(fp) :: x(nx),fx(nx)                 ! x & fx vectors (already set)
  real(fp) :: th(nth),fth(nth),dfth(nth)   ! th & fth already set
  !
  real(fp) :: f(4,4,nx,nth)                ! spline, f(1,1,*,*) already set
  real(fp) :: fh(0:3,nx,nth)               ! hermite array
  real(fp) :: flin(nx,nth)                 ! piecewise linear array
  !
  real(fp) :: bcx1(nth),bcx2(nth)          ! bcs: dfdx vs. th @ x(1), x(nx).
  real(fp) :: bcth1(nx),bcth2(nx)          ! bcs: dfdth vs. x @ th(1), th(nth).
  !
  real(fp) :: xtest(ntest),fxtest(ntest)   ! x test grid & fx
  real(fp) :: thtest(ntest),fthtest(ntest) ! th test grid & fth
  !
  real(fp) :: wk(64000)                    ! workspace
  !
  common/bc_ctrl/ nbc
  !
  !--------------
  !
  if(ntest*ntest.gt.64000) then
     write(m,*) ' ?dotest2:  ntest*ntest exceeds workspace dim.'
     return
  end if
  !
  !  set up hermite array
  !
  do ith=1,nth
     do ix=1,nx
        flin(ix,ith)=f(1,1,ix,ith)         ! f
        fh(0,ix,ith)=f(1,1,ix,ith)         ! f
        fh(1,ix,ith)=2.0_fp*f(1,1,ix,ith)     ! df/dx
        fh(2,ix,ith)=fx(ix)*dfth(ith)      ! df/dy
        fh(3,ix,ith)=2.0_fp*fx(ix)*dfth(ith)  ! d2f/dxdy
     end do
  end do
  !
  call akherm2p(x,nx,th,nth,fh,nx,ilinx,ilinth,2,1,ier)
  !
  call compare('hermite',x,nx,th,nth,f,fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  !  set bdy conds
  !
  call bset(fx,nx,fth,nth,bcx1,bcx2,bcth1,bcth2)
  !
  call bpspline(x,nx,th,nth,f,nx,wk,15000,ilinx,ilinth,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest2(bpspline)'
  end if
  !
  call compare('bpspline',x,nx,th,nth,f,fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  !
  call bpsplinb(x,nx,th,nth,f,nx, &
       nbc,bcx1,nbc,bcx2, &
       wk,15000,ilinx,ilinth,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest2(bpsplinb)'
  end if
  !
  call compare('bpsplinb',x,nx,th,nth,f,fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  !
  call bcspline(x,nx,th,nth,f,nx, &
       nbc,bcx1,nbc,bcx2, &
       nbc,bcth1,nbc,bcth2, &
       wk,15000,ilinx,ilinth,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest2(bcspline)'
     return
  end if
  !
  call compare('bcspline',x,nx,th,nth,f,fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  !  compact spline representation (as per L. Zakharov)
  !
  do ith=1,nth
     do ix=1,nx
        fh(0,ix,ith)=f(1,1,ix,ith)         ! f
     end do
  end do
  !
  call mkbicub(x,nx,th,nth,fh,nx, &
       nbc,bcx1,nbc,bcx2, &
       nbc,bcth1,nbc,bcth2, &
       ilinx,ilinth,ier)
  !
  call compare('mkbicub',x,nx,th,nth,f,fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  !  piecewise linear...
  !
  call compare('piecewise linear',x,nx,th,nth,f, &
       fh,flin,ilinx,ilinth, &
       xtest,fxtest,thtest,fthtest,ntest,wk)
  !
  return
end subroutine dotest2
!--------------------------------
!
subroutine compare(slbl,x,nx,th,nth,f,fh,fl,ilinx,ilinth, &
     xtest,fxtest,thtest,fthtest,ntest,wk)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nth,ntest,nx,m,icycle,iherm,ier,ijk,iwarn,j,i
  !============
  real(fp) :: fmin,fmax,fdif,fdifr,zdum,ztime1,ztime2,zth,zx,ff,fs
  real(fp) :: zctime
  !============
  common/pspltest_io/ m
  !
  character(len=*) slbl                ! spline coeff routine:  label
  real(fp) :: x(nx),th(nth)                ! indep. coords.
  real(fp) :: f(4,4,nx,nth)                ! spline data
  real(fp) :: fh(0:3,nx,nth)               ! hermite data
  real(fp) :: fl(nx,nth)                   ! piecewise linear data
  integer ilinx,ilinth              ! even spacing flags
  !
  !  test data grid & data:
  !
  real(fp) :: xtest(ntest),fxtest(ntest),thtest(ntest),fthtest(ntest)
  real(fp) :: wk(ntest,ntest)
  !
  !-------------
  !  select spline fcn eval only (no derivatives)
  !
  integer isel(10)
  data isel/1,0,0,0,0,0,0,0,0,0/
  !
  real(fp) :: fget(10)
  !
  real(fp) :: xpkg(200,1),thpkg(200,1)
  !-------------
  !
  icycle=20
  !
  iherm=0
  if(slbl.eq.'hermite') then
     write(m,*) ' '
     iherm=1
  end if
  if(slbl.eq.'mkbicub') then
     iherm=2
  end if
  if(slbl.eq.'piecewise linear') then
     iherm=3
  end if
  !
  fmin=1.0E30_fp
  fmax=-1.0E30_fp
  fdif=0.0_fp
  fdifr=0.0_fp
  !
  call genxpkg(nx,x,xpkg,0,1,0,zdum,1,ier)
  call genxpkg(nth,th,thpkg,1,1,0,zdum,1,ier)
  !
  if(iherm.eq.0) then
     call cpu_time(ztime1)
     do ijk=1,icycle
        call bcspgrid(xtest,ntest,thtest,ntest,wk,ntest, &
             nx,xpkg,nth,thpkg,f,nx,iwarn,ier)
     end do
     call cpu_time(ztime2)
  else if(iherm.eq.1) then
     call cpu_time(ztime1)
     do ijk=1,icycle
        call gridherm2(xtest,ntest,thtest,ntest,wk,ntest, &
             nx,xpkg,nth,thpkg,fh,nx,iwarn,ier)
     end do
     call cpu_time(ztime2)
  else if(iherm.eq.2) then
     call cpu_time(ztime1)
     do ijk=1,icycle
        call gridbicub(xtest,ntest,thtest,ntest,wk,ntest, &
             nx,xpkg,nth,thpkg,fh,nx,iwarn,ier)
     end do
     call cpu_time(ztime2)
  else
     call cpu_time(ztime1)
     do ijk=1,icycle
        call gridpc2(xtest,ntest,thtest,ntest,wk,ntest, &
             nx,xpkg,nth,thpkg,fl,nx,iwarn,ier)
     end do
     call cpu_time(ztime2)
  end if
  !
  do j=1,ntest
     zth=thtest(j)
     do i=1,ntest
        zx=xtest(i)
        !
        ff=fxtest(i)*fthtest(j)
        fmin=min(fmin,ff)
        fmax=max(fmax,ff)
        !
        if(iherm.eq.0) then
           fget(1)=wk(i,j)
           !xx               call bcspeval(zx,zth, &
           !xx                 isel,fget,x,nx,th,nth,ilinx,ilinth, &
           !xx                 f,nx,ier)
        else if(iherm.eq.1) then
           fget(1)=wk(i,j)
           !xx               call herm2ev(zx,zth,x,nx,th,nth,ilinx,ilinth, &
           !xx                  f,nx,isel,fget,ier)
        else if(iherm.eq.2) then
           fget(1)=wk(i,j)
           !xx               call evbicub(zx,zth,x,nx,th,nth,ilinx,ilinth, &
           !xx                  f,nx,isel,fget,ier)
        else
           fget(1)=wk(i,j)
        end if
        !xx            if(ier.ne.0) then
        !xx               write(m,*) ' ??compare ('//slbl//') ier.ne.0 exit'
        !xx               return
        !xx            end if
        !
        fs=fget(1)
        !
        fdif=max(fdif,abs(ff-fs))
        fdifr=max(fdifr,abs(ff-fs)/(0.5_fp*(ff+fs)))
        wk(i,j)=ff-fs
        !
     end do
  end do
  !
  zctime=ztime2-ztime1
  write(m,1000) slbl,nx,nth,fmin,fmax,fdif,fdifr
1000 format(2x,a,' setup on ',i3,' x ',i3,' grid'/ &
       '   fmin=',1pe11.4,' fmax=',1pe11.4,' max(|diff|)=',1pe11.4/ &
       '     max(|diff|/f) = ',1pe11.4)
  write(m,1001) icycle,ntest,ntest,zctime
1001 format(2x,i3,' x ',i3,' x ',i3,' evaluations, cpu = ', &
       1pe11.4,' (s)')
  !
  return
end subroutine compare
!------------------------
subroutine pspltest3(zctrl)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer m
  !============
  real(fp) :: pi2
  !============
  real(fp), intent(in) :: zctrl
  !
  common/pspltest_io/ m
  !
  !  test various bicubic spline routines
  !  for fitting the function
  !
  !     f(x,th,ph)=exp(2*x-1)*(2+sin(th))*(3+sin(ph))
  !
  !  on 3 grid sizes; compare accuracy on test grid.
  !
  !  grid ranges:  x in [0,1], th in [0,2pi], ph in [0,2pi].
  !
  real(fp) :: x1(10),x2(20),x4(40),ex1(10),ex2(20),ex4(40)
  real(fp) :: t1(10),t2(20),t4(40),st1(10),st2(20),st4(40), &
       ct1(10),ct2(20),ct4(40)
  real(fp) :: p1(10),p2(20),p4(40),sp1(10),sp2(20),sp4(40), &
       cp1(10),cp2(20),cp4(40)
  real(fp) :: bcx1(1600),bcx2(1600)
  real(fp) :: bcth1(1600),bcth2(1600)
  real(fp) :: bcph1(1600),bcph2(1600)
  !
  real(fp) :: f1(4,4,4,10,10,10),f2(4,4,4,20,20,20),f4(4,4,4,40,40,40)
  real(fp) :: fh(8,40,40,40),flin(40,40,40)
  !
  real(fp) :: xtest(100),extest(100),ttest(100),stest(100),zdum(100)
  real(fp) :: phtest(100),sptest(100)
  real(fp) :: zero,one
  !
  data pi2/6.2831853_fp/
  data zero,one/0.0_fp,1.0_fp/
  !
  !---------------------------
  !
  call xset(10,x1,ex1,zero,one)
  call xset(20,x2,ex2,zero,one)
  call xset(40,x4,ex4,zero,one)
  call xset(100,xtest,extest,zero,one)
  !
  call tset(10,t1,st1,ct1,zero,pi2)
  call tset(20,t2,st2,ct2,zero,pi2)
  call tset(40,t4,st4,ct4,zero,pi2)
  call tset(100,ttest,stest,zdum,zero,pi2)
  !
  call tset3(10,p1,sp1,cp1,zero,pi2)
  call tset3(20,p2,sp2,cp2,zero,pi2)
  call tset3(40,p4,sp4,cp4,zero,pi2)
  call tset3(100,phtest,sptest,zdum,zero,pi2)
  !
  call fset3(10,ex1,st1,sp1,f1)
  call fset3(20,ex2,st2,sp2,f2)
  call fset3(40,ex4,st4,sp4,f4)
  !
  call dotest3(x1,ex1,10,t1,st1,ct1,10,p1,sp1,cp1,10,f1,fh,flin, &
       bcx1,bcx2,bcth1,bcth2,bcph1,bcph2, &
       xtest,extest,ttest,stest,phtest,sptest,100)
  !
  call dotest3(x2,ex2,20,t2,st2,ct2,20,p2,sp2,cp2,20,f2,fh,flin, &
       bcx1,bcx2,bcth1,bcth2,bcph1,bcph2, &
       xtest,extest,ttest,stest,phtest,sptest,100)
  !
  call dotest3(x4,ex4,40,t4,st4,ct4,40,p4,sp4,cp4,40,f4,fh,flin, &
       bcx1,bcx2,bcth1,bcth2,bcph1,bcph2, &
       xtest,extest,ttest,stest,phtest,sptest,100)
  !
  return
end subroutine pspltest3
!---------------------------------------------------------
subroutine dotest3(x,fx,nx,th,fth,dfth,nth,ph,fph,dfph,nph, &
     f,fh,flin, &
     bcx1,bcx2,bcth1,bcth2,bcph1,bcph2, &
     xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  use iso_c_binding, only: fp => c_double
  !
  !
  !============
  implicit none
  integer nth,nph,ntest,nx,m,nbc,inwk,itot,iph,ith,ix,ilinx
  integer ilinth,ilinph,ier
  !============
  real(fp) :: ztime1,ztime2,zdiff,zdiffr,zbc
  !============
  common/pspltest_io/ m
  !
  !  test spline of f; f(i,j,k)=fx(i)*fth(j)*fph(k) on spline grid
  !                    f(i,j,k)=fxtest(i)*fthtest(j)*fphtest(k) on test grid
  !
  !  f is exp(2x-1)*(2+sin(th))*(3+sin(ph)) -- derivatives for BCs evaluated
  !  here...
  !
  !  df/dx = 2*f
  !
  real(fp) :: x(nx),fx(nx)                 ! x & fx vectors (already set)
  real(fp) :: th(nth),fth(nth),dfth(nth)   ! th & fth & fth' already set
  real(fp) :: ph(nph),fph(nph),dfph(nth)   ! ph & fph & fph' already set
  !
  real(fp) :: f(4,4,4,nx,nth,nph)          ! spline, f(1,1,1,*,*,*) already set
  real(fp) :: fh(0:7,nx,nth,nph)           ! hermite array
  real(fp) :: flin(nx,nth,nph)             ! function data only -- array
  !
  real(fp) :: bcx1(nth,nph),bcx2(nth,nph)  ! bcs: dfdx vs. th,ph @ x(1), x(nx).
  real(fp) :: bcth1(nx,nph),bcth2(nx,nph)  ! bcs: dfdth vs. x,ph @ th(1), th(nth).
  real(fp) :: bcph1(nx,nth),bcph2(nx,nth)  ! bcs: dfdph vs. th,ph @ ph(1), ph(nph)
  !
  real(fp) :: xtest(ntest),fxtest(ntest)   ! x test grid & fx
  real(fp) :: thtest(ntest),fthtest(ntest) ! th test grid & fth
  real(fp) :: phtest(ntest),fphtest(ntest) ! ph test grid & fph
  !
  real(fp) :: wk(80*40*40*40)
  !
  common/bc_ctrl/ nbc
  !
  !--------------
  real(fp) :: zsave(20,20,20)
  real(fp) :: zvals(10)
  integer iselect(10)
  data iselect/1,1,1,1,0,0,0,0,0,0/
  !--------------
  !
  inwk=80*40*40*40
  !
  itot=ntest*ntest*ntest
  write(m,999) itot
999 format(/ &
       ' %dotest3:  4 x ',i7, &
       ' evaluations in progress -- be patient.'/)
  !
  do iph=1,nph
     do ith=1,nth
        do ix=1,nx
           flin(ix,ith,iph)=f(1,1,1,ix,ith,iph)
           fh(0,ix,ith,iph)=f(1,1,1,ix,ith,iph)
           fh(1,ix,ith,iph)=2.0_fp*f(1,1,1,ix,ith,iph)
           fh(2,ix,ith,iph)=fx(ix)*dfth(ith)*fph(iph)
           fh(3,ix,ith,iph)=fx(ix)*fth(ith)*dfph(iph)
           fh(4,ix,ith,iph)=2.0_fp*fx(ix)*dfth(ith)*fph(iph)
           fh(5,ix,ith,iph)=2.0_fp*fx(ix)*fth(ith)*dfph(iph)
           fh(6,ix,ith,iph)=fx(ix)*dfth(ith)*dfph(iph)
           fh(7,ix,ith,iph)=2.0_fp*fx(ix)*dfth(ith)*dfph(iph)
        end do
     end do
  end do
  !
  call akherm3p(x,nx,th,nth,ph,nph,fh,nx,nth, &
       ilinx,ilinth,ilinph,2,1,1,ier)
  !
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest3(akherm3p)'
  end if
  !
  call compare3('hermite',x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  !  set bdy conds
  !
  call bset3(fx,nx,fth,nth,fph,nph, &
       bcx1,bcx2,bcth1,bcth2,bcph1,bcph2)
  !
  call tpspline(x,nx,th,nth,ph,nph,f,nx,nth, &
       wk,inwk,ilinx,ilinth,ilinph,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest3(tpspline)'
  end if
  !
  call compare3('tpspline',x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  !
  call tpsplinb(x,nx,th,nth,ph,nph,f,nx,nth, &
       nbc,bcx1,nbc,bcx2,nth, &
       wk,inwk,ilinx,ilinth,ilinph,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest3(tpsplinb)'
  end if
  !
  call compare3('tpsplinb',x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  if(max(nx,nth,nph).le.20) then
     do iph=1,nph
        do ith=1,nth
           do ix=1,nx
              zsave(ix,ith,iph)=f(1,1,1,ix,ith,iph)
           end do
        end do
     end do
  end if
  !
  call cpu_time(ztime1)
  call tcspline(x,nx,th,nth,ph,nph,f,nx,nth, &
       nbc,bcx1,nbc,bcx2,nth, &
       nbc,bcth1,nbc,bcth2,nx, &
       nbc,bcph1,nbc,bcph2,nx, &
       wk,inwk,ilinx,ilinth,ilinph,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest3(tcspline)'
     return
  end if
  call cpu_time(ztime2)
  write(m,7706) nx,ztime2-ztime1
7706 format( &
       ' ==> tcspline setup (nx=',i3,') cpu time (s):',1pe11.4, &
       ' <=================== ')
  !
  if(max(nx,nth,nph).le.20) then
     do iph=1,nph
        do ith=1,nth
           do ix=1,nx
              call tcspeval(x(ix),th(ith),ph(iph), &
                   iselect, zvals, &
                   x,nx,th,nth,ph,nph, 1, 1, 1, f,nx,nth, ier)
              zdiff=abs(zsave(ix,ith,iph)-zvals(1))
              zdiffr=zdiff/zvals(1)
              if(zdiffr.gt.(1.0E-6_fp)) then
                 write(m,7701) ix,ith,iph,zsave(ix,ith,iph),zvals(1)
              end if
           end do
        end do
     end do
     !
7701 format(' ix=',i2,' ith=',i2,' iph=',i2,' ** f changed:', &
          2(1x,1pe13.6))
     !
     do iph=1,nph
        do ith=1,nth
           do ix=1,nx,nx-1
              if(ix.eq.1) then
                 zbc=bcx1(ith,iph)
              else
                 zbc=bcx2(ith,iph)
              end if
              call tcspeval(x(ix),th(ith),ph(iph), iselect, zvals, &
                   x,nx,th,nth,ph,nph, 1, 1, 1, f,nx,nth, ier)
              if(nbc.eq.1) then
                 if(abs(zbc-zvals(2)).gt.1.0E-4_fp) &
                      write(m,7702) ix,ith,iph,zbc,zvals(2)
              end if
           end do
        end do
     end do
     !
7702 format(' df/dx BC check @ix=',i2,',ith=',i2,',iph=',i2,': ', &
          2(1x,1pe13.6))
     !
     do iph=1,nph
        do ix=1,nx
           do ith=1,nth,nth-1
              if(ith.eq.1) then
                 zbc=bcth1(ix,iph)
              else
                 zbc=bcth2(ix,iph)
              end if
              call tcspeval(x(ix),th(ith),ph(iph), iselect, zvals, &
                   x,nx,th,nth,ph,nph, 1, 1, 1, f,nx,nth, ier)
              if(nbc.eq.1) then
                 if(abs(zbc-zvals(3)).gt.1.0E-4_fp) &
                      write(m,7703) ix,ith,iph,zbc,zvals(3)
              end if
           end do
        end do
     end do
     !
7703 format(' df/dth BC check @ix=',i2,',ith=',i2,',iph=',i2,': ', &
          2(1x,1pe13.6))
     !
     do iph=1,nph,nph-1
        do ith=1,nth
           do ix=1,nx
              if(iph.eq.1) then
                 zbc=bcph1(ix,ith)
              else
                 zbc=bcph2(ix,ith)
              end if
              call tcspeval(x(ix),th(ith),ph(iph), iselect, zvals, &
                   x,nx,th,nth,ph,nph, 1, 1, 1, f,nx,nth, ier)
              if(nbc.eq.1) then
                 if(abs(zbc-zvals(4)).gt.1.0E-4_fp) &
                      write(m,7704) ix,ith,iph,zbc,zvals(4)
              end if
           end do
        end do
     end do
     !
7704 format(' df/dph BC check @ix=',i2,',ith=',i2,',iph=',i2,': ', &
          2(1x,1pe13.6))
     !
  end if
  !
  call compare3('tcspline',x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  do iph=1,nph
     do ith=1,nth
        do ix=1,nx
           fh(0,ix,ith,iph)=f(1,1,1,ix,ith,iph)
        end do
     end do
  end do
  !
  call cpu_time(ztime1)
  call mktricub(x,nx,th,nth,ph,nph,fh,nx,nth, &
       nbc,bcx1,nbc,bcx2,nth, &
       nbc,bcth1,nbc,bcth2,nx, &
       nbc,bcph1,nbc,bcph2,nx, &
       ilinx,ilinth,ilinph,ier)
  if(ier.ne.0) then
     write(m,*) ' ?? error in pspltest:  dotest3(mktricub)'
     return
  end if
  call cpu_time(ztime2)
  write(m,7707) nx,ztime2-ztime1
7707 format( &
       ' ==> mktricub setup (nx=',i3,') cpu time (s):',1pe11.4, &
       ' <=================== ')
  !
  call compare3('mktricub', &
       x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  call compare3('piecewise linear', &
       x,nx,th,nth,ph,nph,f,fh,flin, &
       ilinx,ilinth,ilinph, &
       xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  !
  return
end subroutine dotest3
!----------------------------------------------------------
subroutine bset3(fx,nx,fth,nth,fph,nph, &
     bcx1,bcx2,bcth1,bcth2,bcph1,bcph2)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nth,nph,nx,iph,ith,ix
  !============
  real(fp) :: fx(nx)                       ! x factor of test fcn
  real(fp) :: fth(nth)                     ! th factor of test fcn
  real(fp) :: fph(nph)                     ! ph factor of test fcn
  real(fp) :: bcx1(nth,nph),bcx2(nth,nph)  ! df/dx bdy conds at x(1),x(nx)
  real(fp) :: bcth1(nx,nph),bcth2(nx,nph)  ! df/dth bdy conds at th(1),th(nth)
  real(fp) :: bcph1(nx,nth),bcph2(nx,nth)  ! df/dph bdy conds at ph(1),ph(nph)
  !
  !  df/dx = 2*exp(2x-1)*(2+sin(th))*(3+sin(ph)) = 2*f
  !
  do iph=1,nph
     do ith=1,nth
        bcx1(ith,iph)=2.0_fp*fx(1)*fth(ith)*fph(iph) ! df/dx @ x(1)
        bcx2(ith,iph)=2.0_fp*fx(nx)*fth(ith)*fph(iph) ! df/dx @ x(nx)
     end do
  end do
  !
  !  df/dth = exp(2x-1)*cos(th)*(3+sin(ph))
  !  cos(0)=cos(2pi)=1
  !
  do iph=1,nph
     do ix=1,nx
        bcth1(ix,iph)=fx(ix)*fph(iph)    ! df/dth @ th=0 = th(1)
        bcth2(ix,iph)=fx(ix)*fph(iph)    ! df/dth @ th=2pi = th(nth)
     end do
  end do
  !
  !  df/dph = exp(2x-1)*(2+sin(th))*cos(ph)
  !  cos(0)=cos(2pi)=1
  !
  do ith=1,nth
     do ix=1,nx
        bcph1(ix,ith)=fx(ix)*fth(ith)    ! df/dph @ ph=0
        bcph2(ix,ith)=fx(ix)*fth(ith)    ! df/dph @ ph=2pi
     end do
  end do
  !
  return
end subroutine bset3
!--------------------------------
!
subroutine compare3(slbl,x,nx,th,nth,ph,nph,f,fh,flin, &
     ilinx,ilinth,ilinph, &
     xtest,fxtest,thtest,fthtest,phtest,fphtest,ntest)
  use iso_c_binding, only: fp => c_double
  !
  !
  !============
  implicit none
  integer nth,nph,ntest,nx,m,iherm,ier,k,j,i,iwarn
  !============
  real(fp) :: fmin,fmax,fdif,fdifr,zdum,ztime1,zph,zth,zx,ff,fs
  real(fp) :: ztime2,zctime
  !============
  common/pspltest_io/ m
  !
  character(len=*) slbl                ! spline coeff routine:  label
  real(fp) :: x(nx),th(nth),ph(nph)        ! indep. coords.
  real(fp) :: f(4,4,4,nx,nth,nph)          ! spline data
  real(fp) :: fh(0:7,nx,nth,nph)           ! hermite data
  real(fp) :: flin(nx,nth,nph)             ! pc linear data
  integer ilinx,ilinth,ilinph       ! even spacing flags
  !
  !  test data grid & data:
  !
  real(fp) :: xtest(ntest),fxtest(ntest)
  real(fp) :: thtest(ntest),fthtest(ntest)
  real(fp) :: phtest(ntest),fphtest(ntest)
  !
  !-------------
  real(fp) :: xpkg(ntest,4),thpkg(ntest,4),phpkg(ntest,4)
  real(fp) :: thvec(ntest),phvec(ntest),fvec(ntest,1)
  !-------------
  !  select spline fcn eval only (no derivatives)
  !
  integer isel(10)
  data isel/1,0,0,0,0,0,0,0,0,0/
  !
  real(fp) :: fget(10)
  !
  !-------------
  !
  iherm=0
  if(slbl.eq.'hermite') iherm=1
  if(slbl.eq.'mktricub') iherm=2
  if(slbl.eq.'piecewise linear') iherm=3
  !
  fmin=1.0E30_fp
  fmax=-1.0E30_fp
  fdif=0.0_fp
  fdifr=0.0_fp
  !
  call genxpkg(nx,x,xpkg,0,1,0,zdum,1,ier)
  call genxpkg(nth,th,thpkg,1,1,0,zdum,1,ier)
  call genxpkg(nph,ph,phpkg,1,1,0,zdum,1,ier)
  !
  call cpu_time(ztime1)
  do k=1,ntest
     zph=phtest(k)
     do j=1,ntest
        phvec(j)=zph
     end do
     do j=1,ntest
        zth=thtest(j)
        do i=1,ntest
           thvec(i)=zth
        end do
        if(iherm.eq.0) then
           call tcspvec(isel,ntest,xtest,thvec,phvec, &
                ntest,fvec,nx,xpkg,nth,thpkg,nph,phpkg, &
                f,nx,nth,iwarn,ier)
        else if(iherm.eq.1) then
           call vecherm3(isel,ntest,xtest,thvec,phvec, &
                ntest,fvec,nx,xpkg,nth,thpkg,nph,phpkg, &
                fh,nx,nth,iwarn,ier)
        else if(iherm.eq.2) then
           call vectricub(isel,ntest,xtest,thvec,phvec, &
                ntest,fvec,nx,xpkg,nth,thpkg,nph,phpkg, &
                fh,nx,nth,iwarn,ier)
        else if(iherm.eq.3) then
           call vecpc3(isel,ntest,xtest,thvec,phvec, &
                ntest,fvec,nx,xpkg,nth,thpkg,nph,phpkg, &
                flin,nx,nth,iwarn,ier)
        end if
        do i=1,ntest
           zx=xtest(i)
           !
           ff=fxtest(i)*fthtest(j)*fphtest(k)
           fmin=min(fmin,ff)
           fmax=max(fmax,ff)
           !
           if(iherm.eq.0) then
              !xx                  call tcspeval(zx,zth,zph, &
              !xx                    isel,fget,x,nx,th,nth,ph,nph, &
              !xx                    ilinx,ilinth,ilinph, &
              !xx                    f,nx,nth,ier)
              fget(1)=fvec(i,1)
           else if(iherm.eq.1) then
              !xx                  call herm3ev(zx,zth,zph,x,nx,th,nth,ph,nph, &
              !xx                    ilinx,ilinth,ilinph, &
              !xx                    fh,nx,nth,isel,fget,ier)
              fget(1)=fvec(i,1)
           else if(iherm.eq.2) then
              !xx                  call evtricub(zx,zth,zph,x,nx,th,nth,ph,nph, &
              !xx                    ilinx,ilinth,ilinph, &
              !xx                    fh,nx,nth,isel,fget,ier)
              fget(1)=fvec(i,1)
           else
              fget(1)=fvec(i,1)
           end if
           !xx               if(ier.ne.0) then
           !xx                  write(m,*) ' ??compare3 ('//slbl//') ier.ne.0 exit'
           !xx                  return
           !xx               end if
           !
           fs=fget(1)
           !
           fdif=max(fdif,abs(ff-fs))
           fdifr=max(fdifr,abs(ff-fs)/(0.5_fp*(ff+fs)))
           !
        end do
     end do
  end do
  call cpu_time(ztime2)
  !
  write(m,1000) slbl,nx,nth,nph,fmin,fmax,fdif,fdifr
1000 format(2x,a,' setup on ',i3,' x ',i3,' x ',i3,' grid'/ &
       '   fmin=',1pe11.4,' fmax=',1pe11.4,' max(|diff|)=',1pe11.4/ &
       '     max(|diff|/f) = ',1pe11.4)
  !
  zctime=ztime2-ztime1
  write(m,1001) ntest,ntest,ntest,zctime
1001 format('  ',i3,' x ',i3,' x ',i3,' evaluations, cpu = ', &
       1pe11.4,' (s)')
  !
  return
end subroutine compare3
!================================
!  smalltest added: DMC Feb 2010
!  test splines with very small grids: nx=2, nx=3

subroutine smalltest(zctrl)
  use iso_c_binding, only: fp => c_double
  implicit none
  common/pspltest_io/ m
  integer :: m

  !  1d spline & Hermite test

  real(fp) :: zctrl  ! control info (not yet used)
  real(fp) :: x1(2),xpkg(2,4)
  real(fp) :: xx1(3),xxpkg(3,4)
  real(fp) :: xxx1(4),xxxpkg(4,4)
  real(fp) :: s1da(2,2),s1db(2,2),h1da(2,2)
  real(fp) :: s1dc(2,3),s1dd(2,4),szp40
  real(fp) :: test,zbc1,zbc2
  real(fp) :: feval0(5),feval1(5),feval2(5)
  real(fp) :: feval0p(5),feval1p(5),feval2p(5)
  integer :: ibc1,ibc2
  integer :: ier,idum,iwarn,ii,jj

  real(fp), dimension(5) :: xeval = &
       (/ 0.0_fp, 0.25_fp, 0.50_fp, 0.75_fp, 1.00_fp/)
  integer, dimension(3) :: ict01 = (/ 1, 0, 0 /)
  integer, dimension(3) :: ict11 = (/ 0, 1, 0 /)
  integer, dimension(3) :: ict21 = (/ 0, 0, 1 /)

  real(fp), parameter :: ZERO = 0.0_fp
  real(fp), parameter :: ZP40 = 0.40_fp
  real(fp), parameter :: HALF = 0.5_fp
  real(fp), parameter :: ONE = 1.0_fp
  real(fp), parameter :: TWO = 2.0_fp

  real(fp) :: ztol = 1.0E-6_fp
  real(fp) :: ztest

  !---------------------------------
  !  1d splines & hermites
  !  test data with zero at node points and zero, then non-zero BCs

  call psp_tolsum(ONE,ztol,ztest)
  if(ztest.ne.ONE) ztol=ztol*ztol  ! get finer precision tol: r8

  write(m,*) ' '
  write(m,*) '  ...small grid spline tests... '

  !  2 pt grid
  x1(1) = ZERO
  x1(2) = ONE

  !  3 pt grid
  xx1(1) = ZERO
  xx1(2) = ZP40
  xx1(3) = ONE

  !  4 pt grid
  xxx1(1) = ZERO
  xxx1(2) = ZP40
  xxx1(3) = HALF
  xxx1(4) = ONE

  !  2 pt grid
  call genxpkg(2,x1,xpkg,0,1,0,ZERO,0,ier)
  call ckerr('genxpkg#1')
  if(ier.ne.0) return

  !  3 pt grid
  call genxpkg(3,xx1,xxpkg,0,1,0,ZERO,0,ier)
  call ckerr('genxpkg#2')
  if(ier.ne.0) return

  !  4 pt grid
  call genxpkg(4,xxx1,xxxpkg,0,1,0,ZERO,0,ier)
  call ckerr('genxpkg#3')
  if(ier.ne.0) return

  !  all zero spline mini-test

  s1da = ZERO
  ! 1d spline, periodic BC  -->  all zero
  call mkspline(x1,2,s1da,-1,ZERO,0,ZERO,idum,ier) ! periodic -> all zero
  call ckerr('mkspline#1')
  if(ier.ne.0) return

  test=maxval(s1da)
  if(test.ne.ZERO) then
     write(m,*) &
          ' ? short spline: expected ZERO result not obtained.'
  end if

  !  loop over two simple data tests.
  !  from the nx=2 spline results, nx=3 and nx=4 splines are constructed
  !  that should match exactly...

  do jj=1,2
     ! input datasets, all zero, then, not all zero...
     if(jj.eq.1) then
        !
        !  all ZERO data but non-zero boundary conditions
        !
        s1da=ZERO
        s1db=ZERO
        s1dc=ZERO
        s1dd=ZERO
        h1da=ZERO
     else
        !
        !  non-zero data, non-zero boundary conditions
        !
        s1da(1,1)=0.25_fp
        s1da(1,2)=0.75_fp
        s1db(1,1:2)=s1da(1,1:2)
        h1da(1,1:2)=s1da(1,1:2)
     end if

     !  3 pt copy
     s1dc(1,1)=s1da(1,1)
     s1dc(1,3)=s1da(1,2)

     !  4 pt copy
     s1dd(1,1)=s1da(1,1)
     s1dd(1,4)=s1da(1,2)

     ! 1d spline, non-zero f' boundary conditions

     call mkspline(x1,2,s1da,1,ONE,1,TWO,idum,ier)
     call ckerr('mkspline#2')
     if(ier.ne.0) return

     !  evaluate f, f', f''
     !  augment data for nx=3 and nx=4 splines

     call vecspline(ict01,1,ZP40,1,szp40,2,xpkg,s1da,iwarn,ier)
     call ckerr('vecspline#0')
     if(ier.ne.0) return

     s1dc(1,2) = szp40
     s1dd(1,2) = szp40

     call vecspline(ict01,5,xeval,5,feval0,2,xpkg,s1da,iwarn,ier)
     call ckerr('vecspline#1')
     if(ier.ne.0) return

     s1dd(1,3) = feval0(3)

     call vecspline(ict11,5,xeval,5,feval1,2,xpkg,s1da,iwarn,ier)
     call ckerr('vecspline#2')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,2,xpkg,s1da,iwarn,ier)
     call ckerr('vecspline#3')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=2 1d spline, f' boundary conditions set:"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     ! save...
     feval0p = feval0
     feval1p = feval1
     feval2p = feval2
     ! stash 2nd derivative BC values...
     zbc1=feval2(1)
     zbc2=feval2(5)
     ! 1d hermite with same f' BCs

     !  Hermite test
     h1da(2,1)=ONE
     h1da(2,2)=TWO
     call akherm1p(x1,2,h1da,idum,2,ier)
     call ckerr('akherm1p#2')
     if(ier.ne.0) return

     !  Hermite evaluation
     call vecherm1(ict01,5,xeval,5,feval0,2,xpkg,h1da,iwarn,ier)
     call ckerr('vecherm1#1')
     if(ier.ne.0) return

     call vecherm1(ict11,5,xeval,5,feval1,2,xpkg,h1da,iwarn,ier)
     call ckerr('vecherm1#1')
     if(ier.ne.0) return

     !  print results
     write(m,*) ' '
     write(m,*) " 1d hermite, f' boundary conditions (BCs) set:"
     write(m,*) "  #    x            f(x)         f'(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,3(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii)
     end do

     !  compare
     call ckdiff(2)

     !  nx=3 spline test

     call mkspline(xx1,3,s1dc,1,ONE,1,TWO,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=3 1d spline, f' LHS BC, f' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=4 spline test

     call mkspline(xxx1,4,s1dd,1,ONE,1,TWO,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=4 1d spline, f' LHS BC, f' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)
     ! 1d spline, f' LHS, f'' RHS

     call mkspline(x1,2,s1db,1,ONE,2,zbc2,idum,ier)
     call ckerr('mkspline#3')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#4')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#5')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#6')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=2 1d spline, f' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=3 spline test

     !  nx=3 spline test

     call mkspline(xx1,3,s1dc,1,ONE,2,zbc2,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=3 1d spline, f' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=4 spline test

     call mkspline(xxx1,4,s1dd,1,ONE,2,zbc2,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=4 1d spline, f' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     ! 1d spline, f'' LHS, f' RHS

     call mkspline(x1,2,s1db,2,zbc1,1,TWO,idum,ier)
     call ckerr('mkspline#4')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#7')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#8')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#9')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=2 1d spline, f'' LHS BC, f' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=3 spline test

     !  nx=3 spline test

     call mkspline(xx1,3,s1dc,2,zbc1,1,TWO,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=3 1d spline, f'' LHS BC, f' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=4 spline test

     call mkspline(xxx1,4,s1dd,2,zbc1,1,TWO,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=4 1d spline, f'' LHS BC, f' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)
     ! 1d spline, f'' LHS, f'' RHS

     call mkspline(x1,2,s1db,2,zbc1,2,zbc2,idum,ier)
     call ckerr('mkspline#5')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#10')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#11')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,2,xpkg,s1db,iwarn,ier)
     call ckerr('vecspline#12')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=2 1d spline, f'' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=3 spline test

     call mkspline(xx1,3,s1dc,2,zbc1,2,zbc2,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=3 1d spline, f'' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=4 spline test

     call mkspline(xxx1,4,s1dd,2,zbc1,2,zbc2,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=4 1d spline, f'' LHS BC, f'' RHS BC"
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)

     !  nx=4 "not a knot" spline test

     call mkspline(xxx1,4,s1dd,0,ZERO,0,ZERO,idum,ier)
     call ckerr('mkspline')
     if(ier.ne.0) return

     !  evaluate f, f', f''

     call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
          ier)
     call ckerr('vecspline')
     if(ier.ne.0) return

     !  print results

     write(m,*) ' '
     write(m,*) " nx=4 1d spline, not-a-knot BC, both sides."
     write(m,*) &
          "  #    x            f(x)         f'(x)        f''(x)"
     do ii=1,5
        write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
             feval0(ii),feval1(ii),feval2(ii)
     end do

     !  compare
     call ckdiff(3)
  end do

  ! nx=3 & nx=4 periodic spline comparison

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) ' nx=3 & nx=4 periodic spline test.'

  s1dc(1,1)=ONE
  s1dc(1,2)=TWO
  s1dc(1,3)=TWO*TWO

  s1dd(1,1)=ONE
  s1dd(1,2)=TWO
  s1dd(1,4)=TWO*TWO

  !  nx=3 periodic

  call mkspline(xx1,3,s1dc,-1,ZERO,-1,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 periodic spline "
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  ! nx=4 periodic

  call mkspline(xxx1,4,s1dd,-1,ZERO,-1,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 periodic spline "
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)

  !  nx=3 two sided not-a-knot

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) ' nx=3 & nx=4 two sided not-a-knot.'

  call mkspline(xx1,3,s1dc,0,ZERO,0,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 double not-a-knot spline "
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  ! nx=4 comparison spline

  call mkspline(xxx1,4,s1dd,0,ZERO,0,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 double not-a-knot"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)

  !  nx=3 RHS not-a-knot, LHS f' BC

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) " nx=3 RHS not-a-knot & LHS f' BC..."

  call mkspline(xx1,3,s1dc,1,ONE,0,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 RHS not-a-knot LHS f' BC"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  zbc1=feval2(1)
  zbc2=feval2(5)

  ! nx=4 comparison spline

  call mkspline(xxx1,4,s1dd,2,zbc1,2,zbc2,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 comparison spline"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)

  !  nx=3 RHS not-a-knot, LHS f'' BC

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) " nx=3 RHS not-a-knot & LHS f'' BC..."

  call mkspline(xx1,3,s1dc,2,TWO*TWO*TWO,0,ZERO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 RHS not-a-knot LHS f'' BC"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  zbc1=feval2(1)
  zbc2=feval2(5)

  ! nx=4 comparison spline

  call mkspline(xxx1,4,s1dd,2,zbc1,2,zbc2,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 comparison spline"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)


  !  nx=3 LHS not-a-knot, RHS f' BC

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) " nx=3 LHS not-a-knot & RHS f' BC..."

  call mkspline(xx1,3,s1dc,0,ZERO,1,ONE,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 LHS not-a-knot RHS f' BC"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  zbc1=feval2(1)
  zbc2=feval2(5)

  ! nx=4 comparison spline

  call mkspline(xxx1,4,s1dd,2,zbc1,2,zbc2,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 comparison spline"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)

  !  nx=3 LHS not-a-knot, RHS f'' BC

  write(m,*) ' '
  write(m,*) ' ---------------------------------'
  write(m,*) " nx=3 LHS not-a-knot & RHS f'' BC..."

  call mkspline(xx1,3,s1dc,0,ZERO,2,TWO*TWO*TWO,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  s1dd(1,3)=feval0(3)  ! copy result for nx=4 test data

  call vecspline(ict11,5,xeval,5,feval1,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,3,xxpkg,s1dc,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=3 LHS not-a-knot RHS f'' BC"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  ! save...
  feval0p = feval0
  feval1p = feval1
  feval2p = feval2

  zbc1=feval2(1)
  zbc2=feval2(5)

  ! nx=4 comparison spline

  call mkspline(xxx1,4,s1dd,2,zbc1,2,zbc2,idum,ier)
  call ckerr('mkspline')
  if(ier.ne.0) return

  !  evaluate f, f', f''

  call vecspline(ict01,5,xeval,5,feval0,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict11,5,xeval,5,feval1,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  call vecspline(ict21,5,xeval,5,feval2,4,xxxpkg,s1dd,iwarn, &
       ier)
  call ckerr('vecspline')
  if(ier.ne.0) return

  !  print results

  write(m,*) ' '
  write(m,*) " nx=4 comparison spline"
  write(m,*) &
       "  #    x            f(x)         f'(x)        f''(x)"
  do ii=1,5
     write(m,'(3x,i1,2x,4(1x,1pe12.5))') ii,xeval(ii), &
          feval0(ii),feval1(ii),feval2(ii)
  end do

  !  compare
  call ckdiff(3)


CONTAINS

  subroutine ckerr(slbl)
    character(len=*), intent(in) :: slbl

    if(ier.ne.0) then
       write(m,*) ' ? smalltest call returned error: '//trim(slbl)
    end if
  end subroutine ckerr

  subroutine ckdiff(iordp1)

    integer, intent(in) :: iordp1  ! =2: ck f & f'; =3: ck f,f',f''

    real(fp) :: zdiff

    zdiff = maxval(abs(feval0-feval0p))
    if(zdiff.gt.ztol) then
       write(m,99) " *** f value differences exceed tolerance:", &
            ztol,zdiff
    end if

    zdiff = maxval(abs(feval1-feval1p))/10
    if(zdiff.gt.ztol) then
       write(m,99) " *** f' differences exceed tolerance:", &
            ztol,zdiff
    end if

    if(iordp1.lt.3) return

    zdiff = maxval(abs(feval2-feval2p))/100
    if(zdiff.gt.ztol) then
       write(m,99) " *** f'' differences exceed tolerance:", &
            ztol,zdiff
    end if

99  format(1x,a,2(1x,1pe12.5))

  end subroutine ckdiff

end subroutine smalltest

subroutine cubsplb ( tau, c, n, ibcbeg, ibcend )
  use iso_c_binding, only: fp => c_double
  !
  !  from  * a practical guide to splines *  by c. de boor
  !     ************************  input  ***************************
  !     n = number of data points. assumed to be .ge. 2.
  !     (tau(i), c(1,i), i=1,...,n) = abscissae and ordinates of the
  !        data points. tau is assumed to be strictly increasing.
  !     ibcbeg, ibcend = boundary condition indicators, and
  !     c(2,1), c(2,n) = boundary condition information. specifically,
  !        ibcbeg = 0  means no boundary condition at tau(1) is given.
  !           in this case, the not-a-knot condition is used, i.e. the
  !           jump in the third derivative across tau(2) is forced to
  !           zero, thus the first and the second cubic polynomial pieces
  !           are made to coincide.)
  !        ibcbeg = 1  means that the slope at tau(1) is made to equal
  !           c(2,1), supplied by input.
  !        ibcbeg = 2  means that the second derivative at tau(1) is
  !           made to equal c(2,1), supplied by input.
  !        ibcend = 0, 1, or 2 has analogous meaning concerning the
  !           boundary condition at tau(n), with the additional infor-
  !           mation taken from c(2,n).
  !     ***********************  output  **************************
  !     c(j,i), j=1,...,4; i=1,...,l (= n-1) = the polynomial coefficients
  !        of the cubic interpolating spline with interior knots (or
  !        joints) tau(2), ..., tau(n-1). precisely, in the interval
  !        (tau(i), tau(i+1)), the spline f is given by
  !           f(x) = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
  !        where h = x - tau(i). the function program *ppvalu* may be
  !        used to evaluate f or its derivatives from tau,c, l = n-1,
  !        and k=4.
  !
  implicit none
  integer :: ibcbeg,ibcend,n
  real(fp) :: c(4,n),tau(n)
  !
  real(fp) :: divdf1,divdf3,dtau,g
  integer :: i,j,l,m
  !
  !****** a tridiagonal linear system for the unknown slopes s(i) of
  !  f  at tau(i), i=1,...,n, is generated and then solved by gauss elim-
  !  ination, with s(i) ending up in c(2,i), all i.
  !     c(3,.) and c(4,.) are used initially for temporary storage.
  l = n-1
  !ompute first differences of tau sequence and store in c(3,.). also,
  !ompute first divided difference of data and store in c(4,.).
  do m=2,n
     c(3,m) = tau(m) - tau(m-1)
     c(4,m) = (c(1,m) - c(1,m-1))/c(3,m)
   end do
   !construct first equation from the boundary condition, of the form
   !             c(4,1)*s(1) + c(3,1)*s(2) = c(2,1)
   if (ibcbeg-1) 11,15,16
11 if (n .gt. 2) go to 12
   !     no condition at left end and n = 2.
   c(4,1) = 1._fp
   c(3,1) = 1._fp
   c(2,1) = 2._fp*c(4,2)
   go to 25
   !     not-a-knot condition at left end and n .gt. 2.
12 c(4,1) = c(3,3)
   c(3,1) = c(3,2) + c(3,3)
   c(2,1) =((c(3,2)+2._fp*c(3,1))*c(4,2)*c(3,3)+ &
        c(3,2)**2*c(4,3))/c(3,1)
   go to 19
   !     slope prescribed at left end.
15 c(4,1) = 1._fp
   c(3,1) = 0._fp
   go to 18
   !     second derivative prescribed at left end.
16 c(4,1) = 2._fp
   c(3,1) = 1._fp
   c(2,1) = 3._fp*c(4,2) - c(3,2)/2._fp*c(2,1)
18 if(n .eq. 2) go to 25
   !  if there are interior knots, generate the corresp. equations and car-
   !  ry out the forward pass of gauss elimination, after which the m-th
   !  equation reads    c(4,m)*s(m) + c(3,m)*s(m+1) = c(2,m).
19 do m=2,l
     g = -c(3,m+1)/c(4,m-1)
     c(2,m) = g*c(2,m-1) + 3._fp*(c(3,m)*c(4,m+1)+c(3,m+1)*c(4,m))
     c(4,m) = g*c(3,m-1) + 2._fp*(c(3,m) + c(3,m+1))
   end do
   !construct last equation from the second boundary condition, of the form
   !           (-g*c(4,n-1))*s(n-1) + c(4,n)*s(n) = c(2,n)
   !     if slope is prescribed at right end, one can go directly to back-
   !     substitution, since c array happens to be set up just right for it
   !     at this point.
   if (ibcend-1)                     21,30,24
21 if (n .eq. 3 .and. ibcbeg .eq. 0) go to 22
   !     not-a-knot and n .ge. 3, and either n.gt.3 or  also not-a-knot at
   !     left end point.
   g = c(3,n-1) + c(3,n)
   c(2,n) = ((c(3,n)+2._fp*g)*c(4,n)*c(3,n-1) &
        + c(3,n)**2*(c(1,n-1)-c(1,n-2))/c(3,n-1))/g
   g = -g/c(4,n-1)
   c(4,n) = c(3,n-1)
   go to 29
   !     either (n=3 and not-a-knot also at left) or (n=2 and not not-a-
   !     knot at left end point).
22 c(2,n) = 2._fp*c(4,n)
   c(4,n) = 1._fp
   go to 28
   !     second derivative prescribed at right endpoint.
24 c(2,n) = 3._fp*c(4,n) + c(3,n)/2._fp*c(2,n)
   c(4,n) = 2._fp
   go to 28
25 if (ibcend-1)                     26,30,24
26 if (ibcbeg .gt. 0)                go to 22
   !     not-a-knot at right endpoint and at left endpoint and n = 2.
   c(2,n) = c(4,n)
   go to 30
28 g = -1._fp/c(4,n-1)
   !Complete forward pass of gauss elimination.
29 c(4,n) = g*c(3,n-1) + c(4,n)
   c(2,n) = (g*c(2,n-1) + c(2,n))/c(4,n)
   !carry out back substitution
30 j = l
40 c(2,j) = (c(2,j) - c(3,j)*c(2,j+1))/c(4,j)
   j = j - 1
   if (j .gt. 0)                  go to 40
   !****** generate cubic coefficients in each interval, i.e., the deriv.s
   !  at its left endpoint, from value and slope at its endpoints.
   do i=2,n
     dtau = c(3,i)
     divdf1 = (c(1,i) - c(1,i-1))/dtau
     divdf3 = c(2,i-1) + c(2,i) - 2._fp*divdf1
     c(3,i-1) = 2._fp*(divdf1 - c(2,i-1) - divdf3)/dtau
     c(4,i-1) = (divdf3/dtau)*(6._fp/dtau)
   end do
   !
   return
 end subroutine cubsplb

  subroutine parse( cbuf, istat )
  !.. parse                            Resolve variable references in a string
  !                                    codesys/source/portlib/parse.
  !
  !
  !  Author                            jim.conboy@ccfe.ac.uk
  !  Version                           1.00,  07Dec2011
  !  Modifications
  !
  !  1.00  07Dec2011                   jim.conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*),intent(inout)     :: cbuf           ! inp
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  integer                            :: ixi1, ixi2   & ! index to input string
                                       ,ixo          & !          output
                                       ,ixv1, ixv2   & ! 1st, last char of the variable name
                                       ,li, lo         ! lengths of strings
  !
#ifdef _DEBUG
  logical                            :: ldebug = .true.
#else
  logical                            :: ldebug = .false.
#endif
  character(len=2048)                :: cout           ! Output string
  character(len=64)                  :: cVnms          ! Characters allowed in variable names
  !
  character(len=1)                   :: cV           & ! Variable identifier
                                       ,cV1, cV2       !    "     delimiter
  !
  character(len=3), parameter        :: cVdf = '${}'
  !
  character(len=1), parameter        :: cUs  = '_'   &
                                       ,cBl  = ' '   &
                                       ,cQ   = '"'
  !
  character(len=*), parameter        :: cU = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'  &
                                       ,cL = 'abcdefghijklmnopqrstuvwxyz' 
  character(len=*),parameter         :: cSr='portlib/parse'
  !----------------------------------::================!.........................|
  !
  do ixi1=1,len(cout), 8  ; cout(ixi1:)  = '        ' ; enddo
  do ixi1=1,len(cVnms),8  ; cVnms(ixi1:) = '        ' ; enddo
  !
  cVnms = cU//cL//cUs
  cV = cVdf(1:1) ; cV1 = cVdf(2:2) ; cV2 = cVdf(3:3)
  !
  istat = 0
  ixi1 = 0 ; ixi2 = 1 ; ixo = 1
  l_var: do
     i_found: &
       if( ixi2 >= len_trim(cbuf ) )                 then
       !    end of buffer
                                                     exit l_var
       elseif( cbuf(ixi2:ixi2) == cV )               then
       !    Special case - string commences with variable
       ixi1 = ixi2
                                                        else
       ! look for next variable
       ixi1 = index(  cbuf(ixi2:), cV ) + ixi2 - 1
  !
     if( ixi1 == ixi2-1 )                       then
  !     No more variables ..
        ixi1 = len_trim( cbuf(ixi2:) ) + ixi2 
  !d    print *,'End "',cbuf(ixi2:ixi1),cQ
        cout(ixo:) = cbuf( ixi2:ixi1 )
                                                exit l_var
                                                else
  !  collect preceeding text
           cout(ixo:)  = cbuf(ixi2:ixi1-1)
           ixo = ixo + ixi1-ixi2
                                                endif
                                                        endif i_found
  !  variable delimiter ($) in cbuf(ixi1)
  !d print *,ixi1, cbuf(ixi1:ixi1+3)
     i_delim: if( cbuf(ixi1+1:ixi1+1) == cV1 )          then
     !  form is ${VARIABLE}
        ixv1 = ixi1 + 2
        ixv2 = index(  cbuf(ixi1:), cV2 ) + ixi1 -2
        if( ldebug) print *,ixv1,ixv2,cbuf(ixv1:ixv2)
        if( ixv2 < ixv1 )                       then
           istat = 2                                                    ! istat = 2 ; missing delimiter
                                                exit l_var
                                                else
           ixi2 = ixv2 + 2
                                                endif
        
                                                        else
     !     end delimiter is any invalid name character
           ixv1 = ixi1 +1
           ixv2 = ixv1  &
                + verify( trim(cbuf(ixv1:)), cVnms ) - 2
           if( ixv2 == ixv1-2 )                 then
     !          special case - variable name terminates string; ixi2 points to last char
                ixv2 = ixv1 + len_trim(cbuf(ixv1:)) -1
                ixi2 = ixv2
                                                else
     !          point to start of next substring
                ixi2 = ixv2+1
                                                endif
                                                        endif i_delim
     !
     !  cbuf(ixv1:ixv2) is the variable name
           if( ldebug ) print *,ixi1,ixv1,ixv2,ixi2, cQ,cbuf(ixv1:ixv2),cQ
           if( ixv2 < ixv1 )                            then
              istat = 3                                                 ! istat = 3 ; zero length name
                                                        exit l_var
                                                        endif
     !====     Name Translation here    ====
#ifdef __MPI
           call mpi_sget_env(  cbuf(ixv1:ixv2), cout(ixo:), istat )
#else
           call sget_env    ( cbuf(ixv1:ixv2), cout(ixo:) )
#endif
           li = len_trim(cout(ixo:))
           if( li == 0 )                        then
     !         no string returned..
               cout(ixo:) = cbuf(ixi1:ixv2)
               istat = 1                                                ! istat = 1 ; name not defined
                                                endif
           ixo = ixo + li
           if( ldebug ) print *,ixi1,ixi2,ixo,cQ,cout(:ixo-1),cQ
     enddo l_var
     !
     ixo = len_trim(cout)
     if( istat > 0 )   &
       write(6,'(4x,2a,i3)')      cSr,' -W- istat = ',istat

     if(ldebug .or.  istat > 1 )                        then
        cout(ixo+ixi1:) = '1'
        cout(ixo+ixi2:) = '2'
        if( ixv1 > 0 )   cout(ixo+ixv1:) = 'v-'
        if( ixv2 > 0 )   cout(ixo+ixv2-1:) = '-v'
        write(6,100)    cQ,trim(cbuf),cQ
        write(6,100)    cQ,cout(ixo+1:ixo+len_trim(cbuf)),cQ
                                                        endif
!
     cbuf = cout(:ixo)
!
100 format(4x,3a)
  end subroutine parse
#ifdef __TEST
  program parse_test
  !.. parse_test                       quick test of parse
  !                                    codesys/source/portlib/parse_test.
  !
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  08Dec2011
  !  Modifications
  !
  !  1.00  08Dec2011                   <author>@<place>
  !                                    Written
  !
  !  Usage
  !     >cpp --traditional -D__TEST -D_DEBUG =1/parse.f90 ./parse.f90 
  !     >lf95 -g parse.f90 -l:$CS/lib/portlib.a -o parse
  !     >./parse
  !  OR
  !     >cpp --traditional -D__TEST -D_DEBUG -D__MPI =1/parse.f90 ./parse.f90 
  !     > mpif90 -g parse.f90 -I$CS/obj/mpi_portlib -I $CS/mod -l:$CS/lib/mpi_portlib.a -o mpi_parse
  !----_^---------------------------------=========================================|
  !
#ifdef __MPI
  use mmpi
  use mpi_env_mod
#endif
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..local
  integer                                   :: istat
  character(len=1)                          :: cQ = '"'
  character(len=256)                        :: cbuf
  !
  integer                            :: iex            ! loop index 
  integer, parameter                 :: nex  = 8     & ! # of examples
                                       ,nexm = 1       !      mpi examples
#ifdef __MPI
  logical                            :: lmpi = .true.
#else
  logical                            :: lmpi = .false.
#endif
  !
  character(len=255),dimension(nex)  :: cex = &
                                       (/'No/variables/here           ' &
                                        ,'/tmp/$USER/Transp           ' &
                                        ,'/tmp/${USER}_files          ' &
                                        ,'${USER}_on_$HOST            ' &
                                        ,'$USER$HOST                  ' &
                                        ,'Undefined-$NO_SUCH_VARIABLE!' &
                                        ,'MissingRB-${HOME/directory  ' &
                                        ,'$_cwd/Toric                 ' &
                                                                       /)
  !
  character(len=*),parameter         :: cSr='portlib/parse_test'
  !----------------------------------::================!.........................|
  !
#ifdef __MPI
  call mmpi_init(istat)
  !
  call env_mod_init( istat )
  call mpi_proc_env( istat )
  !
  call mpi_env_prt( 6 )
  !
#endif
  l_ex: do iex = 1,nex
     call parse_one( cex(iex), istat )
      write(6,*) '----------------------------------------------------------------'
     if( .not. lmpi .and. iex+nexm == nex )   exit l_ex
  enddo l_ex
  !
#ifdef __MPI
  call mmpi_end( istat )
#endif
  !
  contains

  subroutine parse_one( cbuf, istat )
  !.. parse_one                        runs one example
  !                                    codesys/source/portlib/parse_test.parse_one.
  !
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  08Dec2011
  !  Modifications
  !
  !  1.00  08Dec2011                   <author>@<place>
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(inout)    :: cbuf           ! string to parse
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  integer                            :: il             ! length of string
  !
  character(len=*), parameter        :: ckey = '123456789012345678901234567890'
  character(len=*), parameter        :: cSr='portlib/parse_test.parse_one'
  !----------------------------------::================!.........................|
  !
  il = len_trim(cbuf)
  write(6,100) cQ,cbuf(:il),cQ
#ifdef _DEBUG
  write(6,100) cQ,ckey(:il),cQ
#endif
  call parse( cbuf, istat )
  write(6,100) cQ,trim(cbuf),cQ,istat
  !
100 format(10x,3a)
  end subroutine parse_one

  end program parse_test
#endif
  

program lookup_test
  use iso_c_binding, only: fp => c_double
  !
  !  timing test:  various lookup algorithms
  !
  !============
  IMPLICIT NONE
  INTEGER imul,istart,i,icur,k,j,i2,ig,ilinx,ier,idum1,idum2, &
       idum,iv,icount,iper,ia1,ia2,ia,is,ivs,ivecs,iloop,ir,iwarn, &
       igen,igenc,igen2,igen3
  !============
  real(fp) :: zfac,zscan,znorm,zval,zval2,zinc,zcur,zprev,zdum,y,x,z, &
       ztime0,ztime1,difmax,ztime
  !============
  integer gsize,g3size,tsize,oddstep,repeat
  parameter (gsize=100)             ! grid
  parameter (g3size=40)             ! grid for 3d object
  parameter (tsize=1000)            ! target vector size
  parameter (oddstep=37)            ! stepsize for scattered vector
  parameter (repeat=500000)         ! repeat count for timing
  !
  !  test grids
  !
  real(fp) :: grids(gsize,3),fspline(4,gsize,3),wk(tsize),ref(tsize)
  real(fp) :: gpkgs(gsize,4,3)
  !
  real(fp) :: gpkg2x(gsize,4),gpkg2y(gsize,4)
  real(fp) :: f2d(4,gsize,gsize)
  real(fp) :: gpkg3x(g3size,4),gpkg3y(g3size,4),gpkg3z(g3size,4)
  real(fp) :: f3d(8,g3size,g3size,g3size)
  !
  real(fp) :: wk2(tsize,2)
  real(fp) :: wk3(tsize,3)
  !
  !  test vectors
  !
  real(fp) :: tvecs(tsize,2)
  !
  real(fp) :: ztest1,ztest2,zdiff
  !
  integer ivecsize(4)
  integer izvec(tsize)
  real(fp) :: dxvec(tsize),hvec(tsize),hivec(tsize)
  !
  integer istop(6)
  !
  character(len=20) :: glbls(3)
  character(len=30) :: tlbls(2)
  character(len=20) :: albl(3)
  !
  integer ict(10),istat
  !
  data ivecsize/1,10,100,1000/
  !
  data albl/ &
       'pseudo-Newton       ', &
       'binary search       ', &
       'linear indexing fcn '/
  data glbls/ &
       'evenly spaced grid  ', &
       'smooth varying grid ', &
       'irregular grid      '/
  data tlbls/ &
       'modestly changing vector     ', &
       'rapidly changing vector      '/
  !
  data ict/1,0,0,0,0,0,0,0,0,0/
  !
  data ztest1/1.0000000000D0/
  data ztest2/1.0000000001D0/
  !
  !---------------------------------
  !
  !  form test vectors
  !
  write(6,*) ' 1d spline / lookup test program run on...'
  call execute_command_line('date')
  call execute_command_line('uname -a')

  zdiff=ztest2-ztest1
  write(6,*) ' ...test: ',ztest1,ztest2,' diff=',zdiff
  if(zdiff.eq.0.0D0) then
     write(6,*) '  [[ single precision ]]'
  else
     write(6,*) '  [[ double precision ]]'
  end if
  write(6,*) ' '
  write(6,*) ' total spline evaluations per test loop:  ',repeat
  !
  imul=0
  istart=1
  !
  do i=1,tsize
     zfac=(i-1.0D0)/(tsize-1.0D0)
     zscan=zfac*zfac*(3.0D0-2.0D0*zfac)
     tvecs(i,1)=max(0.0D0,min(100.0D0,(100.0D0*zscan)))
     !
     imul=imul+1
     if(imul.gt.4) imul=1
     istart=istart+imul*oddstep
     if(istart.gt.100) istart=istart-100
     if(istart.gt.100) istart=istart-100
     if(istart.gt.100) istart=istart-100
     tvecs(i,2)=max(0.0D0,min(100.0D0,(istart-0.5D0)))
  enddo
  !
  !  form test grids & packages
  !
  znorm=100.0D0/sqrt(100.0D0)
  do i=1,gsize
     zval=(i-1)*100.0D0/(gsize-1)
     zval2=sqrt(zval)*znorm
     grids(i,1)=zval
     grids(i,2)=zval2
     fspline(1,i,1)=10.0D0+cos(0.1D0*zval)
     fspline(1,i,2)=10.0D0+cos(0.1D0*zval2)
  enddo
  !
  zinc=100.0D0/(gsize-20-1)
  do i=1,6
     istop(i)=((gsize-20)*i)/7
  enddo
  !
  icur=0
  zcur=-zinc
  do i=1,gsize-20
     zprev=zcur
     zcur=zcur+zinc
     k=0
     do j=1,6
        if(i.eq.istop(j)) k=j
     enddo
     if(k.eq.0) then
        icur=icur+1
        grids(icur,3)=zcur
     else if(k.eq.1) then
        do i2=1,2
           icur=icur+1
           grids(icur,3)=zprev+0.5D0*i2*zinc
        enddo
     else if(k.eq.2) then
        do i2=1,4
           icur=icur+1
           grids(icur,3)=zprev+0.25D0*i2*zinc
        enddo
     else if(k.eq.3) then
        do i2=1,8
           icur=icur+1
           grids(icur,3)=zprev+0.125D0*i2*zinc
        enddo
     else if((k.eq.4).or.(k.eq.6)) then
        do i2=1,2
           icur=icur+1
           grids(icur,3)=zprev+0.25D0*i2*zinc
        enddo
        icur=icur+1
        grids(icur,3)=zcur
     else if(k.eq.5) then
        do i2=1,4
           icur=icur+1
           grids(icur,3)=zprev+0.125D0*i2*zinc
        enddo
        icur=icur+1
        grids(icur,3)=zcur
     end if
  enddo
  grids(icur+1,3)=grids(icur,3)+5.0D0
  do i=1,gsize
     fspline(1,i,3)=10.0D0+cos(0.1D0*grids(i,3))
  enddo
  !
  !  compute spline coeffs...
  !
  write(6,*) ' ... setup 1d splines ... '
  do ig=1,3
     call cspline(grids(1,ig),gsize,fspline(1,1,ig), &
          0,zdum,0,zdum,wk,gsize,ilinx,ier)
  enddo
  !
  !  setup grid packages for 2d and 3d tests
  !
  write(6,*) ' ... setup 2d & 3d test grids ... '
  do i=1,gsize
     wk(i)=grids(i,2)
  enddo
  call genxpkg(gsize,wk,gpkg2x,1,1,0,zdum,-3,ier)
  !
  do i=1,gsize
     wk(i)=grids(i,3)
  enddo
  call genxpkg(gsize,wk,gpkg2y,1,1,0,zdum,-3,ier)
  !
  do i=1,g3size
     wk(i)=grids(i,1)
  enddo
  call genxpkg(g3size,wk,gpkg3x,1,1,0,zdum,-3,ier)
  !
  do i=1,g3size
     wk(i)=grids(i,2)
  enddo
  call genxpkg(g3size,wk,gpkg3y,1,1,0,zdum,-3,ier)
  !
  do i=1,g3size
     wk(i)=grids(i,3)
  enddo
  call genxpkg(g3size,wk,gpkg3z,1,1,0,zdum,-3,ier)
  !
  write(6,*) ' ... setup 2d and 3d splines ... '
  do j=1,gsize
     y=gpkg2y(j,1)
     do i=1,gsize
        x=gpkg2x(i,1)
        f2d(1,i,j)=(10.0D0+cos(x))*(10.0D0+sin(2.0D0*y))
     enddo
  enddo
  !
  do k=1,g3size
     z=gpkg3z(k,1)
     do j=1,g3size
        y=gpkg3y(j,1)
        do i=1,g3size
           x=gpkg3x(i,1)
           f3d(1,i,j,k)=(10.0D0+cos(x))*(10.0D0+sin(2.0D0*y))* &
                exp(-0.1D0*z)
        enddo
     enddo
  enddo
  !
  call mkbicub(gpkg2x,gsize,gpkg2y,gsize,f2d,gsize, &
       0,zdum,0,zdum, &
       0,zdum,0,zdum, &
       idum1,idum2,ier)
  !
  call mktricub(gpkg3x,g3size,gpkg3y,g3size,gpkg3z,g3size, &
       f3d,g3size,g3size, &
       0,zdum,0,zdum,g3size, &
       0,zdum,0,zdum,g3size, &
       0,zdum,0,zdum,g3size, &
       idum,idum,idum,ier)
  !
  write(6,*) ' ... setup completed ... '
  !
  !-----------------------------------------------------------------
  !
  do ig=1,3
     write(6,*) '++++++++++++++++++++++++++++++++++++++++++++++++'
     write(6,*) ' ==> grid:  ',glbls(ig)
     write(6,*) ' '
     do iv=1,2
        icount=0
        write(6,*) '---------------------------------------------'
        write(6,*) ' ==> vector:  ',tlbls(iv)
        write(6,*) ' '
        do iper=0,1
           if(iper.eq.0) then
              write(6,*) ' ================='
              write(6,*) ' ...periodic:  NO'
           else
              write(6,*) ' ================='
              write(6,*) ' ...periodic:  YES'
           end if
           if(ig.eq.1) then
              ia1=1
              ia2=1
           else
              ia1=1
              ia2=3
           end if
           do ia=ia1,ia2
              if(ig.eq.1) then
                 write(6,*) ' ...even spacing:  YES'
              else
                 write(6,*) ' ...even spacing:  NO'
                 write(6,*) ' ...algorithm:  ',albl(ia)
              end if
              do is=1,-1,-2
                 write(6,*) ' '
                 if(is.lt.0) then
                    write(6,*) ' ...USE previous result as start ', &
                         'point for next search.'
                 else
                    write(6,*) ' ...DO NOT use previous search ', &
                         'result.'
                 end if
                 write(6,*) ' '
                 !
                 call genxpkg(gsize,grids(1,ig),gpkgs(1,1,ig), &
                      iper,1,0,zdum,is*ia,ier)
                 write(6,*) ' %genpkg(ngrid,grid,gpkg,',iper, &
                      ',1,0,zdum,',is*ia,',ier):  ier=',ier
                 !
                 write(6,*) ' '
                 do ivs=4,1,-1
                    ivecs=ivecsize(ivs)
                    !
                    call cpu_time(ztime0)
                    !
                    do iloop=1,repeat/tsize
                       do ir=1,tsize,ivecs
                          call spvec(ict,ivecs,tvecs(ir,iv), &
                               ivecs,wk(ir),gsize,gpkgs(1,1,ig), &
                               fspline(1,1,ig),iwarn,ier)
                          if(iwarn.ne.0) write(6,*) &
                               ' %xlookup iwarn=',iwarn,'; ir=',ir
                          if(ier.ne.0) write(6,*) &
                               ' %xlookup ier=',iwarn,'; ir=',ir
                       enddo
                    enddo
                    !
                    call cpu_time(ztime1)
                    !
                    icount=icount+1
                    if(icount.eq.1) then
                       difmax=0.0D0
                       do ir=1,tsize
                          !xx                              write(6,*) ir,wk(ir)
                          ref(ir)=wk(ir)
                       enddo
                    else
                       !  check variance
                       difmax=0.0D0
                       do ir=1,tsize
                          difmax=max(difmax,abs(ref(ir)-wk(ir)))
                       enddo
                       difmax=0.1D0*difmax
                       !
                    end if
                    !
                    ztime=ztime1-ztime0
                    write(6,1001) ztime,ivecs,difmax
1001                format(' $$$$$> cpu time (secs) = ',f8.4, &
                         ', vector size = ',i4,', variance =',1pe10.3)
1002                format(' $$$$$> cpu time (secs) = ',f8.4, &
                         ', vector size = ',i4)
                    !
                 enddo
                 !
                 write(6,*) ' '
                 !
              enddo
           enddo
        enddo
        !
     enddo
  enddo
  !
  write(6,*) ' ------------------------------------- '
  write(6,*) ' 2d test (linear fcn lookup algorithm)'
  do ivs=4,1,-1
     ivecs=ivecsize(ivs)
     !
     call cpu_time(ztime0)
     !
     do iloop=1,repeat/tsize
        igen = 1 + iloop - 2*(iloop/2)
        igenc=3-igen
        do ir=1,tsize,ivecs
           call vecbicub(ict,ivecs,tvecs(ir,igen),tvecs(ir,igenc), &
                ivecs,wk2(ir,igen),gsize,gpkg2x,gsize,gpkg2y, &
                f2d,gsize,iwarn,ier)
           if(iwarn.ne.0) write(6,*) &
                ' %xlookup iwarn=',iwarn,'; ir=',ir
           if(ier.ne.0) write(6,*) &
                ' %xlookup ier=',iwarn,'; ir=',ir
        enddo
     enddo
     !
     call cpu_time(ztime1)
     ztime=ztime1-ztime0
     write(6,1002) ztime,ivecs
  enddo
  !
  write(6,*) ' ------------------------------------- '
  write(6,*) ' 3d test (linear fcn lookup algorithm)'
  do ivs=4,1,-1
     ivecs=ivecsize(ivs)
     !
     call cpu_time(ztime0)
     !
     do iloop=1,repeat/tsize
        igen = 1 + iloop - 3*(iloop/3)
        igen2=igen+1
        igen3=igen+2
        if(igen2.gt.3) igen2=igen2-3
        if(igen3.gt.3) igen3=igen3-3
        igen=min(2,igen)            ! (1,2,2) -> (2,2,1) -> (2,1,2)
        igen2=min(2,igen2)
        igen3=min(2,igen3)
        do ir=1,tsize,ivecs
           call vectricub(ict,ivecs, &
                tvecs(ir,igen),tvecs(ir,igen2),tvecs(ir,igen3), &
                ivecs,wk3(ir,igen), &
                g3size,gpkg3x,g3size,gpkg3y,g3size,gpkg3z, &
                f3d,g3size,g3size,iwarn,ier)
           if(iwarn.ne.0) write(6,*) &
                ' %xlookup iwarn=',iwarn,'; ir=',ir
           if(ier.ne.0) write(6,*) &
                ' %xlookup ier=',iwarn,'; ir=',ir
        enddo
     enddo
     !
     call cpu_time(ztime1)
     ztime=ztime1-ztime0
     write(6,1002) ztime,ivecs
  enddo
  !
  stop
end program lookup_test

      subroutine fclean_dir(path,ier)
C
C  dmc 16 June 2011 -- delete all files in a directory (CAREFUL!)
C     "hidden" files and subdirectories are not touched.
C
      implicit NONE
C
      character*(*), intent(in) :: path  ! directory to be cleaned...
      integer, intent(out) :: ier        ! completion status, 0=normal
C
C  if (path) is blank, clean out all files in $cwd !!
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
C  VMS functionality not implemented!
C
      integer str_length,ilp
C
#include "fpreproc/byte_declare.h"
      byte_declare cpath(500)
      integer cclean_dir
C
C----------------------------------
C
      ier=0
C
      ilp=str_length(path)
      if(ilp.eq.0) then
         write(6,*) ' ?fclean_dir:  directory path argument is blank.'
         ier=1
         return
      endif
C
      if(path.eq.' ') then
         call cstring('./',cpath,'2C')
      else if(path(ilp:ilp).ne.'/') then
         call cstring(path(1:ilp)//'/',cpath,'2C')
      else
         call cstring(path(1:ilp),cpath,'2C')
      endif

      ier=cclean_dir(cpath)
C
      return
      end

subroutine EZspline_free1(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  ! ier:
  ! 101= warning, spline object was never allocated
  integer, intent(out) :: ier
  integer ifail

  ier = 0
  if(.not.EZspline_allocated(spline_o)) ier=101

  deallocate(spline_o%x1, stat=ifail)
  deallocate(spline_o%fspl, stat=ifail)
  deallocate(spline_o%x1pkg, stat=ifail)

  call EZspline_preInit(spline_o)

  spline_o%n1 = 0

  return
end subroutine EZspline_free1


subroutine EZspline_free2(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  ! ier:
  ! 101= warning, spline object was never allocated
  integer, intent(out) :: ier
  integer ifail

  ier = 0
  if(.not.EZspline_allocated(spline_o)) ier=101

  deallocate(spline_o%x1, stat=ifail)
  deallocate(spline_o%x2, stat=ifail)
  deallocate(spline_o%fspl, stat=ifail)
  deallocate(spline_o%bcval1min, stat=ifail)
  deallocate(spline_o%bcval1max, stat=ifail)
  deallocate(spline_o%bcval2min, stat=ifail)
  deallocate(spline_o%bcval2max, stat=ifail)
  deallocate(spline_o%x1pkg, stat=ifail)
  deallocate(spline_o%x2pkg, stat=ifail)

  call EZspline_preInit(spline_o)

  spline_o%n1 = 0
  spline_o%n2 = 0

  return
end subroutine EZspline_free2


subroutine EZspline_free3(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  ! ier:
  ! 101= warning, spline object was never allocated
  integer, intent(out) :: ier
  integer ifail

  ier = 0
  if(.not.EZspline_allocated(spline_o)) ier=101

  deallocate(spline_o%x1, stat=ifail)
  deallocate(spline_o%x2, stat=ifail)
  deallocate(spline_o%x3, stat=ifail)
  deallocate(spline_o%fspl, stat=ifail)
  deallocate(spline_o%bcval1min, stat=ifail)
  deallocate(spline_o%bcval1max, stat=ifail)
  deallocate(spline_o%bcval2min, stat=ifail)
  deallocate(spline_o%bcval2max, stat=ifail)
  deallocate(spline_o%bcval3min, stat=ifail)
  deallocate(spline_o%bcval3max, stat=ifail)
  deallocate(spline_o%x1pkg, stat=ifail)
  deallocate(spline_o%x2pkg, stat=ifail)
  deallocate(spline_o%x3pkg, stat=ifail)

  call EZspline_preInit(spline_o)

  spline_o%n1 = 0
  spline_o%n2 = 0
  spline_o%n3 = 0

  return
end subroutine EZspline_free3

C---------------------------------------------------------------------
C  cftio
C
#include "fpreproc/byte_declare.h"
C
C  fortran shell for C-based binary i/o routines -- fixed length
C  512 byte blocks.
C
C---------------------------------------------------------------------
C
C  check that fortran "lun" is in range.
C
      subroutine cftlunck(ilun,sr,ier)
C
      character*(*) sr
C
      if((ilun.lt.0).or.(ilun.gt.139)) then
         ier=1
         write(6,1001) sr,ilun
 1001    format(' ?',a,' -- ilun=',i10,', argument out of range.')
      else
         ier=0
      endif
C
      return
      end
C---------------------------------------------------------------------
C
C call C routine to write a 512 block
C
      subroutine cftwrite(ilun,xstream,ier)
C
      byte_declare xstream(*)
C
      call cftlunck(ilun,'cftwrite',ier)
      if(ier.ne.0) return
C
      call cftcwr(ilun,xstream,ier)
C
      return
      end
C---------------------------------------------------------------------
C
C call C routine to read a 512 block
C
      subroutine cftread(ilun,xstream,ier)
C
      byte_declare xstream(*)
C
      call cftlunck(ilun,'cftread',ier)
      if(ier.ne.0) return
C
      call cftcrd(ilun,xstream,ier)
C
      return
      end
C---------------------------------------------------------------------
C
C call C routine to rewind a file
C
      subroutine cftrewnd(ilun,ier)
C
      call cftlunck(ilun,'cftread',ier)
      if(ier.ne.0) return
C
      call cftrwn(ilun)
C
      return
      end
C---------------------------------------------------------------------
C
C call C routine to close a file
C
      subroutine cftclose(ilun)
C
      call cftlunck(ilun,'cftread',ier)
      if(ier.ne.0) return
C
      call cftcls(ilun)
C
      return
      end
C
C---------------------------------------------------------------------
C
C call C routine to open a file
C
      subroutine cftopen(ilun,filnam,acod,iquiet,ier)
C
C  ilun must be btw 0 and 99
C
      integer ilun                      ! fortran like lun number
      character*(*) filnam              ! name of file
      character*(*) acod                ! access code, 'wb' for write
C                                       !              'rb' for read
      integer iquiet                    ! =1:  suppress common error messages
      integer ier                       ! completion code, 0=OK
C
C  local buffers
C
      BYTE_DECLARE acbyts(20)           ! null terminated string
      BYTE_DECLARE fnbyts(256)          ! null terminated string
C
C--------------------------------------------
C
      call cftlunck(ilun,'cftread',ier)
      if(ier.ne.0) return
C
 
      do ic=1,20
#if __CRAY || __SX
         acbyts(ic)=char(0)
#else
         acbyts(ic)=0
#endif
      enddo
C
      do ic=1,256
#if __CRAY || __SX
         fnbyts(ic)=char(0)
#else
         fnbyts(ic)=0
#endif
      enddo
C
#if __NAGWARE && __OSX
      ilfn=len_trim(filnam)
#else
      ilfn=len(filnam)
#endif
      if(ilfn.gt.255) then
         write(6,1001) filnam(1:ilfn)
 1001    format(' ?cftopen:  filename too long:  '/1x,a)
         ier=2
         return
      else
         do ic=1,ilfn
#if __CRAY || __SX
            fnbyts(ic)=filnam(ic:ic)
#else
            fnbyts(ic)=ichar(filnam(ic:ic))
#endif
         enddo
#if __NAGWARE && __OSX
         fnbyts(ilfn+1)=0
#endif
      endif
C
      ilac=len(acod)
      if(ilac.gt.19) then
         write(6,1002) acod(1:ilac)
         ier=3
 1002    format(' ?cftopen:  file access string too long:  ',a)
         return
      else
         do ic=1,ilac
#if __CRAY || __SX
            acbyts(ic)=acod(ic:ic)
#else
            acbyts(ic)=ichar(acod(ic:ic))
#endif
         enddo
      endif
C
C  do it.
C
      call cftopn(ilun,fnbyts,acbyts,iquiet,ier)
C
      return
      end

C-----------------------------------------------------------------------
C  GENOPEN -- generic OPEN routine, VMS/UNIX portable, with condition
C    handler on VMS side.
C
C  mod dmc -- support new type, BLOCKD, for sequential access with
C  fixed length records.
C
      subroutine GENOPEN(lun,name,fstat,ftype,irecsz,ios)
C
      integer lun          ! logical unit number
      character*(*) name   ! file name
      character*(*) fstat  ! file status 'OLD' or 'NEW' or 'UNKNOWN'
      character*(*) ftype  ! file type 'ASCII' 'BINARY' or 'DIRECT'
      integer irecsz       ! record size ('DIRECT' files only)
C
C       ** units of irecsz is (4 byte) WORDS on all systems **
C       ** integer function nblkfac converts this to bytes on
C       ** systems for which this is necessary...
C
C output:
      integer ios          ! status code, 0 is normal
C                            ! <0 for argument error (message generated)
C                            ! >0 for file open error
C
      integer str_length
C
C  on VMS systems, system messages will be output if the open error is
C  something other than "file not found" -- see condition handler
C  IOPERH, set up by IOPEN subfunction
C
C--------------------------------------
C  local declarations
C
      character*10 zstat,ztype
C
C--------------------------------------
C
C  check arguments
C
      IOS=0
C
      zstat=' '
      ztype=' '
      ilstat=len(fstat)
      iltype=len(ftype)
      zstat=fstat(1:ilstat)
      ztype=ftype(1:iltype)
      call uupper(zstat)
      call uupper(ztype)
C
      if( (zstat.ne.'OLD') .and. (zstat.ne.'UNKNOWN') .and.
     >      (zstat.ne.'NEW') ) then
        write(6,'('' ?GENOPEN:  invalid fstat argument:  '',A)') fstat
        IOS=-1
      endif
C
      if( (ztype.ne.'ASCII') .and.
     >	    (ztype.ne.'BINARY') .and.
     >      (ztype.ne.'DIRECT') .and.
     >      (ztype.ne.'BLOCKD') ) then
        write(6,'('' ?GENOPEN:  invalid ftype argument:  '',A)') ftype
        IOS=-2
      endif
C
      if(ztype.eq.'DIRECT') then
        if(irecsz.le.0) then
          IOS=-3
          write(6,9901) irecsz
 9901     format(' ?GENOPEN:  invalid record size for DIRECT file:  ',
     >        i10)
        endif
        iblkfac=nblkfac(ier)
        if(ier.ne.0) then
           write(6,'('' %genopen -- NBLKFAC error on DIRECT access.'')')
           iblkfac=1
        endif
        irecl=iblkfac*irecsz
      endif
C
      if(ios.lt.0) return
C
C  ok, do the file open
C
      if(ztype.eq.'BLOCKD') then
         iln=str_length(name)
         if(zstat.eq.'OLD') then
            call cftopen(lun,name(1:iln),'rb',1,ios)
         else if(zstat.eq.'NEW') then
            call cftopen(lun,name(1:iln),'wb',1,ios)
         else
            write(6,9902) fstat
 9902       format(
     >         ' ?GENOPEN:  fstat="',a,'" not valid for BLOCKD files.')
         endif
         go to 1000  ! C code open, no fortran error handling.
      endif
C
      ios=iopen(lun,name,zstat,ztype,irecl)
C
C  on VMS, if there is an error, convert it to an IOSTAT code
C
#ifdef __VMS
      if(ios.eq.1) then
        ios=0
      else
        call errsns(ios,irmsts,irmstv,iunit,istat)
      endif
#endif
C
 1000 continue
      return
      end

subroutine mkintrp2d(x,nx,y,ny,jspline, &
     f,icoeff,ixdim,iydim, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcymin,bcymin,ibcymax,bcymax, &
     ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup bicubic spline, or bicubic hermite, or Hybrid linear/zonal with
  !  1d cubic Hermite or Spline interpolation in 1 dimension
  !
  !
  !  input:
  implicit none
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  real(fp) :: x(nx)                 ! x vector, strict ascending
  real(fp) :: y(ny)                 ! y vector, strict ascending
  !
  integer :: jspline(2)             ! interpolation method control
  !        (1) -- 1st dimension: -1: zone, 0: pclin, 1: Hermite, 2: spline
  !        (2) -- 2nd dimension: -1: zone, 0: pclin, 1: Hermite, 2: spline
  !
  !    Standard interpolation-- all jspline values match
  !      e.g. jspline(1)=jspline(2)=2 for bicubic spline
  !    Hybrid interpolation occurs when multiple jspline values are specified.
  !
  !    RESTRICTION:  jspline = (/ 1, 2 /) or (/ 2, 1 /) not allowed.  I.e.
  !    Hermite and Spline interpolation cannot be mixed in a hybrid interpolant.
  !    This restriction exists because of technical issues in the
  !    implementation (it could be removed in principle but the work to do
  !    this has not been scheduled).
  !
  !  coefficient buffer dimensioning:
  integer :: icoeff                 ! #coefficients per data point
  integer :: ixdim                  ! nx; nx-1 if jspline(1)==-1
  integer :: iydim                  ! ny; ny-1 if jspline(2)==-1
  !  input/output:
  real(fp) :: f(icoeff,ixdim,iydim)        ! data & spline coefficients
  !
  !  input bdy condition data:
  !   meaning of arguments as described in "mkbicubw.f90"
  !   *ignored* for dimensions with piecewise linear or zonal interpolation;
  !   For Hermite interpolation only the values {-1,0,1} are accepted.
  !
  integer ibcxmin                   ! bc flag for x=xmin
  real(fp) :: bcxmin(iydim)                ! bc data vs. y at x=xmin
  integer ibcxmax                   ! bc flag for x=xmax
  real(fp) :: bcxmax(iydim)                ! bc data vs. y at x=xmax
  !
  integer ibcymin                   ! bc flag for y=ymin
  real(fp) :: bcymin(ixdim)                ! bc data vs. x at y=ymin
  integer ibcymax                   ! bc flag for y=ymax
  real(fp) :: bcymax(ixdim)                ! bc data vs. x at y=ymax
  !
  integer ier                       ! =0 on exit if there is no error.
  !   ier -- completion code, 0 for normal
  !
  !-----------------------
  integer :: kspline
  integer :: ii,imul,imin,imax,ickx,icky
  integer :: idum1,idum2
  integer :: ipx,ipy
  real(fp) :: ztol = 0.0001_fp
  real(fp), dimension(:,:), allocatable :: wk2
  !-----------------------
  !
  ier = 0
  !
  imin=3
  imax=-2
  imul=1
  do ii=1,2
    imin=min(imin,jspline(ii))
    imax=max(imax,jspline(ii))
    if(jspline(ii).gt.0) imul=imul*2
  end do

  if((imin.lt.-1).or.(imax.gt.2)) then
    ier = 1
    write(6,*) ' ?mkintrp2d: spline type control out of range -1 to 2: ',jspline
  end if
  if(ier.ne.0) return

  if(imin.eq.imax) then
    kspline=imin   ! same interp type on all dimensions
  else
    kspline=-99    ! hybrid
    if(imin.gt.0) then
      ier = 1
      write(6,*) ' ?mkintrp2d: spline/Hermite hybrid not supported (',jspline,')'
    else if(imax.lt.1) then
      ier = 1
      write(6,*) ' ?mkintrp2d: zonal/linear hybrid not supported (',jspline,')'
    end if
  end if
  if(ier.ne.0) return
  !
  if(imul.ne.icoeff) then
    write(6,*) &
         ' ?coeff dimension inconsistency for spline type codes ',jspline
    write(6,*) ' in mkintrp2d: expected: ',imul,' got: ',icoeff
    ier=1
    return
  end if
  !
  !  check dimensioning consistency
  !
  if(jspline(1).eq.-1) then
    ickx=nx-1
  else
    ickx=nx
  end if
  !
  if(jspline(2).eq.-1) then
    icky=ny-1
  else
    icky=ny
  end if
  !
  if((ickx.ne.ixdim).or.(icky.ne.iydim)) then
    write(6,*) &
         ' ?mkintrp2d: dimensioning inconsistent with '// &
         'interpolation controls: ',jspline
    write(6,*) '  expected: ',ickx,icky,'; got: ',ixdim,iydim
    ier=1
    return
  end if
  !
  if(jspline(1).le.0) then
    call splinck(x,nx,idum1,ztol,ier)
    if(ier.ne.0) then
      write(6,*) ' ?mkintrp2d: x axis not strict ascending.'
      return
    end if
  end if
  !
  if(jspline(2).le.0) then
    call splinck(y,ny,idum1,ztol,ier)
    if(ier.ne.0) then
      write(6,*) ' ?mkintrp2d: y axis not strict ascending.'
      return
    end if
  end if
  !
  !  if no work to be done: exit now
  if(imul.eq.1) return
  !
  !  check Hermite BCs if necessary
  !
  if(jspline(1).eq.1) then
    if((min(ibcxmin,ibcxmax).lt.-1).or. &
         (max(ibcxmin,ibcxmax).gt.1)) then
      write(6,*) ' ?mkintrp2d: Bdy Cond code out of range for'
      write(6,*) '  Hermite interpolation; (-1:1) allowed, '// &
           'found: ',ibcxmin,ibcxmax
      ier=1
      return
    end if
    ipx=0
    if(ibcxmin.eq.-1) then
      ipx=1
    else if((ibcxmin.eq.1).or.(ibcxmax.eq.1)) then
      ipx=2
    end if
  end if
  !
  if(jspline(2).eq.1) then
    if((min(ibcymin,ibcymax).lt.-1).or. &
         (max(ibcymin,ibcymax).gt.1)) then
      write(6,*) ' ?mkintrp2d: Bdy Cond code out of range for'
      write(6,*) '  Hermite interpolation; (-1:1) allowed, '// &
           'found: ',ibcymin,ibcymax
      ier=1
      return
    end if
    ipy=0
    if(ibcymin.eq.-1) then
      ipy=1
    else if((ibcymin.eq.1).or.(ibcymax.eq.1)) then
      ipy=2
    end if
  end if

  if(kspline.eq.1) then
    ! bicubic Hermite

    ! stuff the BCs inside the function data at the right locations:
    call util_bcherm2(f, ixdim, iydim, &
         ibcxmin, ibcxmax, ibcymin, ibcymax, &
         bcxmin, bcxmax, bcymin, bcymax, &
         x, y)

    call akherm2p(x,ixdim,y,iydim, &
         f,ixdim,idum1,idum2,ipx,ipy,ier)

  else if(kspline.eq.2) then
    ! bicubic Spline

    call mkbicub(x,nx, y,ny, f,ixdim, &
         ibcxmin,bcxmin,ibcxmax,bcxmax, &
         ibcymin,bcymin,ibcymax,bcymax, &
         idum1,idum2,ier)

  else
    ! Hybrid

    if(jspline(1).gt.0) then
      ! cubic in x direction
      do ii=1,iydim
        if(jspline(1).eq.1) then
          call util_bcherm1(f(1,1,ii), ixdim, &
               ibcxmin, ibcxmax, bcxmin(ii), bcxmax(ii), x)
          call akherm1p(x,ixdim,f(1,1,ii),idum1,ipx,ier)

        else if(jspline(1).eq.2) then
          call mkspline(x,ixdim,f(1,1,ii), &
               ibcxmin,bcxmin(ii), ibcxmax,bcxmax(ii), &
               idum1,ier)
        end if
        if(ier.ne.0) exit
      end do

    else
      ! cubic in y direction
      allocate(wk2(2,ny))

      do ii=1,ixdim
        wk2(1,1:iydim) = f(1,ii,1:iydim)
        wk2(2,1:iydim) = 0.0_fp
        if(jspline(2).eq.1) then
          call util_bcherm1(wk2, iydim, &
               ibcymin, ibcymax, bcymin(ii), bcymax(ii), y)
          call akherm1p(y,iydim,wk2,idum2,ipy,ier)

        else if(jspline(2).eq.2) then
          call mkspline(y,iydim,wk2, &
               ibcymin,bcymin(ii), ibcymax,bcymax(ii), &
               idum2,ier)

        end if
        if(ier.ne.0) exit
        f(1:2,ii,1:iydim) = wk2(1:2,1:iydim)
      end do

      deallocate(wk2)
    end if

  end if

  return
end subroutine mkintrp2d

subroutine herm3ev(xget,yget,zget,x,nx,y,ny,z,nz, &
     ilinx,iliny,ilinz, &
     f,inf2,inf3,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a 3d cubic Hermite interpolant on a rectilinear
  !  grid -- this is C1 in all directions.
  !
  !  this subroutine calls two subroutines:
  !     herm3xyz  -- find cell containing (xget,yget,zget)
  !     herm3fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer ny,nz,inf2,inf3,nx
  !============
  real(fp) :: xget,yget,zget               ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  real(fp) :: z(nz)                        ! ordered z grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  integer iliny                     ! iliny=1 => assume y evenly spaced
  integer ilinz                     ! ilinz=1 => assume z evenly spaced
  !
  real(fp) :: f(0:7,inf2,inf3,nz)          ! function data
  !
  !       f 2nd dimension inf2 must be .ge. nx; 3rd dim inf3 .ge. ny
  !       contents of f:
  !
  !  f(0,i,j,k) = f @ x(i),y(j),z(k)
  !  f(1,i,j,k) = df/dx @ x(i),y(j),z(k)
  !  f(2,i,j,k) = df/dy @ x(i),y(j),z(k)
  !  f(3,i,j,k) = df/dz @ x(i),y(j),z(k)
  !  f(4,i,j,k) = d2f/dxdy @ x(i),y(j),z(k)
  !  f(5,i,j,k) = d2f/dxdz @ x(i),y(j),z(k)
  !  f(6,i,j,k) = d2f/dydz @ x(i),y(j),z(k)
  !  f(7,i,j,k) = d3f/dxdydz @ x(i),y(j),z(k)
  !
  integer ict(8)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return df/dz  (0, don't)
  !  ict(5)=1 -- return d2f/dxdy  (0, don't)
  !  ict(6)=1 -- return d2f/dxdz  (0, don't)
  !  ict(7)=1 -- return d2f/dydz  (0, don't)
  !  ict(8)=1 -- return d3f/dxdydz  (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the 4th output (depends on ict(...) spec)
  !  fval(5-8) receive 5th thru 8th outputs (if required by ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,1,0,0,0,0]
  !   on output fval= [f,df/dx,df/dy,df/dz]
  !
  !    on input ict = [1,0,0,0,0,0,0,0]
  !   on output fval= [f] ... elements 2-8 never referenced
  !
  !    on input ict = [0,1,1,0,0,0,0,0]
  !   on output fval= [df/dx,df/dy] ... elements 3-8 never referenced
  !
  !    on input ict = [0,0,0,0,1,0,0,0]
  !   on output fval= [d2f/dxdy] ... elements 2-8 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j,k                     ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !    zparam=0 @z(k)  zparam=1 @z(k+1)
  !
  real(fp), dimension(1) :: xparam,yparam,zparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy,hz
  real(fp), dimension(1) :: hxi,hyi,hzi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !  0 .le. zparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm3xyz(xget,yget,zget,x,nx,y,ny,z,nz,ilinx,iliny,ilinz, &
       i(1),j(1),k(1),xparam(1),yparam(1),zparam(1), &
       hx(1),hxi(1),hy(1),hyi(1),hz(1),hzi(1),ier)
  if(ier.ne.0) return
  !
  call herm3fcn(ict,1,1, &
       fval,i,j,k,xparam,yparam,zparam, &
       hx,hxi,hy,hyi,hz,hzi, &
       f,inf2,inf3,nz)
  !
  return
end subroutine herm3ev
!---------------------------------------------------------------------
!  herm3xyz -- look up x-y-z zone
!
!  this is the "first part" of herm3ev, see comments, above.
!
subroutine herm3xyz(xget,yget,zget,x,nx,y,ny,z,nz, &
     ilinx,iliny,ilinz, &
     i,j,k,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  input of herm3xyz
  !  ================
  !
  !============
  implicit none
  integer nxm,nym,nzm,ii,jj,kk
  !============
  real(fp) :: zxget,zyget,zzget,zxtol,zytol,zztol
  !============
  integer nx,ny,nz                  ! coord. grid dimensions
  !
  real(fp) :: xget,yget,zget               ! target point
  real(fp) :: x(nx),y(ny),z(nz)            ! indep. coords. (ascending order)
  !
  integer ilinx                     ! =1:  x evenly spaced
  integer iliny                     ! =1:  y evenly spaced
  integer ilinz                     ! =1:  z evenly spaced
  !
  !  output of herm3xyz
  !  =================
  integer i,j,k                     ! index to cell containing target pt
  !          on exit:  1.le.i.le.nx-1   1.le.j.le.ny-1  1.le.k.le.nz-1
  !
  !  normalized position w/in (i,j) cell (btw 0 and 1):
  !
  real(fp) :: xparam                       ! (xget-x(i))/(x(i+1)-x(i))
  real(fp) :: yparam                       ! (yget-y(j))/(y(j+1)-y(j))
  real(fp) :: zparam                       ! (zget-z(k))/(z(k+1)-z(k))
  !
  !  grid spacing
  !
  real(fp) :: hx                           ! hx = x(i+1)-x(i)
  real(fp) :: hy                           ! hy = y(j+1)-y(j)
  real(fp) :: hz                           ! hz = z(k+1)-z(k)
  !
  !  inverse grid spacing:
  !
  real(fp) :: hxi                          ! 1/hx = 1/(x(i+1)-x(i))
  real(fp) :: hyi                          ! 1/hy = 1/(y(j+1)-y(j))
  real(fp) :: hzi                          ! 1/hz = 1/(z(k+1)-z(k))
  !
  integer ier                       ! return ier.ne.0 on error
  !
  !------------------------------------
  !
  ier=0
  !
  !  range check
  !
  zxget=xget
  zyget=yget
  zzget=zget
  if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
     zxtol=4.0E-7_fp*max(abs(x(1)),abs(x(nx)))
     if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
        ier=1
        write(6,1001) xget,x(1),x(nx)
1001    format(' ?herm3ev:  xget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((xget.lt.x(1)-0.5_fp*zxtol).or. &
             (xget.gt.x(nx)+0.5_fp*zxtol)) &
             write(6,1011) xget,x(1),x(nx)
1011    format(' %herm3ev:  xget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(xget.lt.x(1)) then
           zxget=x(1)
        else
           zxget=x(nx)
        end if
     end if
  end if
  if((yget.lt.y(1)).or.(yget.gt.y(ny))) then
     zytol=4.0E-7_fp*max(abs(y(1)),abs(y(ny)))
     if((yget.lt.y(1)-zytol).or.(yget.gt.y(ny)+zytol)) then
        ier=1
        write(6,1002) yget,y(1),y(ny)
1002    format(' ?herm3ev:  yget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((yget.lt.y(1)-0.5_fp*zytol).or. &
             (yget.gt.y(ny)+0.5_fp*zytol)) &
             write(6,1012) yget,y(1),y(ny)
1012    format(' %herm3ev:  yget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(yget.lt.y(1)) then
           zyget=y(1)
        else
           zyget=y(ny)
        end if
     end if
  end if
  if((zget.lt.z(1)).or.(zget.gt.z(nz))) then
     zztol=4.0E-7_fp*max(abs(z(1)),abs(z(nz)))
     if((zget.lt.z(1)-zztol).or.(zget.gt.z(nz)+zztol)) then
        ier=1
        write(6,1003) zget,z(1),z(nz)
1003    format(' ?herm3ev:  zget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((zget.lt.z(1)-0.5_fp*zztol).or. &
             (zget.gt.z(nz)+0.5_fp*zztol)) &
             write(6,1013) zget,z(1),z(nz)
1013    format(' %herm3ev:  zget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(zget.lt.z(1)) then
           zzget=z(1)
        else
           zzget=z(nz)
        end if
     end if
  end if
  if(ier.ne.0) return
  !
  !  now find interval in which target point lies..
  !
  nxm=nx-1
  nym=ny-1
  nzm=nz-1
  !
  if(ilinx.eq.1) then
     ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
     i=min(nxm, ii)
     if(zxget.lt.x(i)) then
        i=i-1
     else if(zxget.gt.x(i+1)) then
        i=i+1
     end if
  else
     if((1.le.i).and.(i.lt.nxm)) then
        if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
           continue  ! already have the zone
        else
           call zonfind(x,nx,zxget,i)
        end if
     else
        i=nx/2
        call zonfind(x,nx,zxget,i)
     end if
  end if
  !
  if(iliny.eq.1) then
     jj=1+nym*(zyget-y(1))/(y(ny)-y(1))
     j=min(nym, jj)
     if(zyget.lt.y(j)) then
        j=j-1
     else if(zyget.gt.y(j+1)) then
        j=j+1
     end if
  else
     if((1.le.j).and.(j.lt.nym)) then
        if((y(j).le.zyget).and.(zyget.le.y(j+1))) then
           continue  ! already have the zone
        else
           call zonfind(y,ny,zyget,j)
        end if
     else
        j=ny/2
        call zonfind(y,ny,zyget,j)
     end if
  end if
  !
  if(ilinz.eq.1) then
     kk=1+nzm*(zzget-z(1))/(z(nz)-z(1))
     k=min(nzm, kk)
     if(zzget.lt.z(k)) then
        k=k-1
     else if(zzget.gt.z(k+1)) then
        k=k+1
     end if
  else
     if((1.le.k).and.(k.lt.nzm)) then
        if((z(k).le.zzget).and.(zzget.le.z(k+1))) then
           continue  ! already have the zone
        else
           call zonfind(z,nz,zzget,k)
        end if
     else
        k=nz/2
        call zonfind(z,nz,zzget,k)
     end if
  end if
  !
  hx=(x(i+1)-x(i))
  hy=(y(j+1)-y(j))
  hz=(z(k+1)-z(k))
  !
  hxi=1.0_fp/hx
  hyi=1.0_fp/hy
  hzi=1.0_fp/hz
  !
  xparam=(zxget-x(i))*hxi
  yparam=(zyget-y(j))*hyi
  zparam=(zzget-z(k))*hzi
  !
  return
end subroutine herm3xyz
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 3d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine herm3fcn(ict,ivec,ivecd, &
     fval,ii,jj,kk,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi, &
     fin,inf2,inf3,nz)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inf3,nz,inf2,i,j,k,iadr
  !============
  real(fp) :: xp,xpi,xp2,xpi2,ax,axbar,bx,bxbar,yp,ypi,yp2,ypi2,ay
  real(fp) :: aybar,by,bybar,zp,zpi,zp2,zpi2,az,azbar,bz,bzbar,axp
  real(fp) :: axbarp,bxp,bxbarp,ayp,aybarp,byp,bybarp,azp,azbarp,bzp
  real(fp) :: bzbarp
  !============
  integer ict(8)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec),kk(ivec) ! target cells (i,j,k)
  real(fp) :: xparam(ivec),yparam(ivec),zparam(ivec)
  ! normalized displacements from (i,j,k) corners
  !
  real(fp) :: hx(ivec),hy(ivec),hz(ivec)   ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec),hzi(ivec) ! inverse grid spacing
  ! 1/(x(i+1)-x(i)) & 1/(y(j+1)-y(j)) & 1/(z(k+1)-z(i))
  !
  real(fp) :: fin(0:7,inf2,inf3,nz)        ! interpolant data (cf "herm3ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine herm3ev
  !  comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj,kk and parameter inputs
  !     xparam,yparam,zparam,hx,hxi,hy,hyi,hz,hzi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Hermite cubic basis functions
  !  -->for function value matching
  !     a(0)=0 a(1)=1        a'(0)=0 a'(1)=0
  !   abar(0)=1 abar(1)=0  abar'(0)=0 abar'(1)=0
  !
  !   a(x)=-2*x**3 + 3*x**2    = x*x*(-2.0*x+3.0)
  !   abar(x)=1-a(x)
  !   a'(x)=-abar'(x)          = 6.0*x*(1.0-x)
  !
  !  -->for derivative matching
  !     b(0)=0 b(1)=0          b'(0)=0 b'(1)=1
  !   bbar(0)=0 bbar(1)=0  bbar'(0)=1 bbar'(1)=0
  !
  !     b(x)=x**3-x**2         b'(x)=3*x**2-2*x
  !     bbar(x)=x**3-2*x**2+x  bbar'(x)=3*x**2-4*x+1
  !
  real(fp) :: sum
  integer v
  !
  do v=1,ivec
     i=ii(v)
     j=jj(v)
     k=kk(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     xp2=xp*xp
     xpi2=xpi*xpi
     ax=xp2*(3.0_fp-2.0_fp*xp)
     axbar=1.0_fp-ax
     bx=-xp2*xpi
     bxbar=xpi2*xp
     !
     !   ...in y direction
     !
     yp=yparam(v)
     ypi=1.0_fp-yp
     yp2=yp*yp
     ypi2=ypi*ypi
     ay=yp2*(3.0_fp-2.0_fp*yp)
     aybar=1.0_fp-ay
     by=-yp2*ypi
     bybar=ypi2*yp
     !
     !   ...in z direction
     !
     zp=zparam(v)
     zpi=1.0_fp-zp
     zp2=zp*zp
     zpi2=zpi*zpi
     az=zp2*(3.0_fp-2.0_fp*zp)
     azbar=1.0_fp-az
     bz=-zp2*zpi
     bzbar=zpi2*zp
     !
     iadr=0
     !
     !  derivatives:
     !
     axp=6.0_fp*xp*xpi
     axbarp=-axp
     bxp=xp*(3.0_fp*xp-2.0_fp)
     bxbarp=xpi*(3.0_fp*xpi-2.0_fp)
     !
     ayp=6.0_fp*yp*ypi
     aybarp=-ayp
     byp=yp*(3.0_fp*yp-2.0_fp)
     bybarp=ypi*(3.0_fp*ypi-2.0_fp)
     !
     azp=6.0_fp*zp*zpi
     azbarp=-azp
     bzp=zp*(3.0_fp*zp-2.0_fp)
     bzbarp=zpi*(3.0_fp*zpi-2.0_fp)
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=azbar*( &
             axbar*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             ax*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbar*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             ax*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1)))
        !
        sum=sum+hx(v)*( &
             azbar*( &
             bxbar*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bx*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbar*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bx*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*( &
             azbar*( &
             axbar*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             ax*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + az*( &
             axbar*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             ax*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz(v)*( &
             bzbar*( &
             axbar*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             ax*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbar*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             ax*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy(v)*( &
             azbar*( &
             bxbar*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bx*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbar*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bx*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hz(v)*( &
             bzbar*( &
             bxbar*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bx*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbar*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bx*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*hz(v)*( &
             bzbar*( &
             axbar*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             ax*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbar*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             ax*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy(v)*hz(v)*( &
             bzbar*( &
             bxbar*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bx*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbar*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bx*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !     df/dx:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*( &
             azbar*( &
             axbarp*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             axp*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbarp*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             axp*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             bxbarp*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bxp*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbarp*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bxp*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy(v)*( &
             azbar*( &
             axbarp*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             axp*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + az*( &
             axbarp*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             axp*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hz(v)*( &
             bzbar*( &
             axbarp*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             axp*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbarp*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             axp*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*( &
             azbar*( &
             bxbarp*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bxp*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbarp*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bxp*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz(v)*( &
             bzbar*( &
             bxbarp*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bxp*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bxp*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy(v)*hz(v)*( &
             bzbar*( &
             axbarp*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             axp*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbarp*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             axp*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*hz(v)*( &
             bzbar*( &
             bxbarp*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bxp*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bxp*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=hyi(v)*( &
             azbar*( &
             axbar*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             ax*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbar*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             ax*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*hx(v)*( &
             azbar*( &
             bxbar*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bx*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbar*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bx*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             axbar*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             ax*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + az*( &
             axbar*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             ax*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*hz(v)*( &
             bzbar*( &
             axbar*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             ax*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbar*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             ax*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             azbar*( &
             bxbar*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bx*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbar*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bx*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hyi(v)*hz(v)*( &
             bzbar*( &
             bxbar*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bx*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbar*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bx*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz(v)*( &
             bzbar*( &
             axbar*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             ax*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbar*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             ax*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hz(v)*( &
             bzbar*( &
             bxbar*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bx*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbar*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bx*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(4).eq.1) then
        !
        !  df/dz:
        !
        iadr=iadr+1
        !
        sum=hzi(v)*( &
             azbarp*( &
             axbar*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             ax*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbar*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             ax*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*hx(v)*( &
             azbarp*( &
             bxbar*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bx*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbar*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bx*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*hy(v)*( &
             azbarp*( &
             axbar*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             ax*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbar*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             ax*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             axbar*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             ax*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbar*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             ax*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*hx(v)*hy(v)*( &
             azbarp*( &
             bxbar*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bx*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbar*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bx*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             bzbarp*( &
             bxbar*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bx*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bx*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*( &
             bzbarp*( &
             axbar*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             ax*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbar*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             ax*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy(v)*( &
             bzbarp*( &
             bxbar*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bx*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bx*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi(v)*( &
             azbar*( &
             axbarp*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             axp*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbarp*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             axp*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*( &
             azbar*( &
             bxbarp*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bxp*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbarp*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bxp*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             azbar*( &
             axbarp*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             axp*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + az*( &
             axbarp*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             axp*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hyi(v)*hz(v)*( &
             bzbar*( &
             axbarp*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             axp*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbarp*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             axp*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             bxbarp*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bxp*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbarp*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bxp*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*hz(v)*( &
             bzbar*( &
             bxbarp*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bxp*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bxp*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hz(v)*( &
             bzbar*( &
             axbarp*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             axp*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbarp*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             axp*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz(v)*( &
             bzbar*( &
             bxbarp*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bxp*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bxp*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdz:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hzi(v)*( &
             azbarp*( &
             axbarp*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             axp*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbarp*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             axp*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*( &
             azbarp*( &
             bxbarp*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bxp*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bxp*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy(v)*hzi(v)*( &
             azbarp*( &
             axbarp*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             axp*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbarp*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             axp*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             bzbarp*( &
             axbarp*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             axp*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             axp*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*hzi(v)*( &
             azbarp*( &
             bxbarp*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bxp*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bxp*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             bxbarp*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bxp*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bxp*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy(v)*( &
             bzbarp*( &
             axbarp*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             axp*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             axp*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy(v)*( &
             bzbarp*( &
             bxbarp*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bxp*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bxp*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(7).eq.1) then
        !
        !  d2f/dydz:
        !
        iadr=iadr+1
        !
        sum=hyi(v)*hzi(v)*( &
             azbarp*( &
             axbar*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             ax*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbar*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             ax*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*hzi(v)*hx(v)*( &
             azbarp*( &
             bxbar*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bx*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbar*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bx*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*( &
             azbarp*( &
             axbar*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             ax*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbar*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             ax*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*( &
             bzbarp*( &
             axbar*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             ax*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbar*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             ax*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hzi(v)*( &
             azbarp*( &
             bxbar*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bx*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbar*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bx*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hyi(v)*( &
             bzbarp*( &
             bxbar*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bx*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bx*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             axbar*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             ax*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbar*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             ax*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             bzbarp*( &
             bxbar*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bx*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bx*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(8).eq.1) then
        !
        !  d3f/dxdydz:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi(v)*hzi(v)*( &
             azbarp*( &
             axbarp*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             axp*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbarp*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             axp*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*hzi(v)*( &
             azbarp*( &
             bxbarp*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bxp*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bxp*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hzi(v)*( &
             azbarp*( &
             axbarp*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             axp*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbarp*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             axp*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hyi(v)*( &
             bzbarp*( &
             axbarp*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             axp*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             axp*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi(v)*( &
             azbarp*( &
             bxbarp*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bxp*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bxp*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi(v)*( &
             bzbarp*( &
             bxbarp*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bxp*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bxp*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             bzbarp*( &
             axbarp*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             axp*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             axp*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             bxbarp*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bxp*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bxp*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine herm3fcn
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 3d fcn
!   --vectorized-- dmc 10 Feb 1999
!    --optimized for VARIATION along x axis ONLY--
!
subroutine herm3fcnx(ict,ivec,ivecd, &
     fval,ii,jj,kk,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi, &
     fin,inf2,inf3,nz)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inf3,nz,inf2,j,k,i,iadr
  !============
  real(fp) :: yp,ypi,yp2,ypi2,ay,aybar,by,bybar,zp,zpi,zp2,zpi2,az
  real(fp) :: azbar,bz,bzbar,ayp,aybarp,byp,bybarp,azp,azbarp,bzp
  real(fp) :: bzbarp,xp,xpi,xp2,xpi2,ax,axbar,bx,bxbar,axp,axbarp
  real(fp) :: bxp,bxbarp
  !============
  integer ict(8)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj,kk            ! target cells (i,j,k)
  real(fp) :: xparam(ivec),yparam,zparam
  ! normalized displacements from (i,j,k) corners
  !
  real(fp) :: hx(ivec),hy,hz               ! grid spacing, and
  real(fp) :: hxi(ivec),hyi,hzi            ! inverse grid spacing
  ! 1/(x(i+1)-x(i)) & 1/(y(j+1)-y(j)) & 1/(z(k+1)-z(i))
  !
  real(fp) :: fin(0:7,inf2,inf3,nz)        ! interpolant data (cf "herm3ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine herm3ev
  !  comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj,kk and parameter inputs
  !     xparam,yparam,zparam,hx,hxi,hy,hyi,hz,hzi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Hermite cubic basis functions
  !  -->for function value matching
  !     a(0)=0 a(1)=1        a'(0)=0 a'(1)=0
  !   abar(0)=1 abar(1)=0  abar'(0)=0 abar'(1)=0
  !
  !   a(x)=-2*x**3 + 3*x**2    = x*x*(-2.0*x+3.0)
  !   abar(x)=1-a(x)
  !   a'(x)=-abar'(x)          = 6.0*x*(1.0-x)
  !
  !  -->for derivative matching
  !     b(0)=0 b(1)=0          b'(0)=0 b'(1)=1
  !   bbar(0)=0 bbar(1)=0  bbar'(0)=1 bbar'(1)=0
  !
  !     b(x)=x**3-x**2         b'(x)=3*x**2-2*x
  !     bbar(x)=x**3-2*x**2+x  bbar'(x)=3*x**2-4*x+1
  !
  real(fp) :: sum
  integer v
  !
  j=jj
  k=kk
  !
  !   ...in y direction
  !
  yp=yparam
  ypi=1.0_fp-yp
  yp2=yp*yp
  ypi2=ypi*ypi
  ay=yp2*(3.0_fp-2.0_fp*yp)
  aybar=1.0_fp-ay
  by=-yp2*ypi
  bybar=ypi2*yp
  !
  !   ...in z direction
  !
  zp=zparam
  zpi=1.0_fp-zp
  zp2=zp*zp
  zpi2=zpi*zpi
  az=zp2*(3.0_fp-2.0_fp*zp)
  azbar=1.0_fp-az
  bz=-zp2*zpi
  bzbar=zpi2*zp
  !
  !  derivatives
  !
  ayp=6.0_fp*yp*ypi
  aybarp=-ayp
  byp=yp*(3.0_fp*yp-2.0_fp)
  bybarp=ypi*(3.0_fp*ypi-2.0_fp)
  !
  azp=6.0_fp*zp*zpi
  azbarp=-azp
  bzp=zp*(3.0_fp*zp-2.0_fp)
  bzbarp=zpi*(3.0_fp*zpi-2.0_fp)

  do v=1,ivec
     i=ii(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     xp2=xp*xp
     xpi2=xpi*xpi
     ax=xp2*(3.0_fp-2.0_fp*xp)
     axbar=1.0_fp-ax
     bx=-xp2*xpi
     bxbar=xpi2*xp
     !
     iadr=0
     !
     !  derivatives:
     !
     axp=6.0_fp*xp*xpi
     axbarp=-axp
     bxp=xp*(3.0_fp*xp-2.0_fp)
     bxbarp=xpi*(3.0_fp*xpi-2.0_fp)
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=azbar*( &
             axbar*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             ax*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbar*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             ax*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1)))
        !
        sum=sum+hx(v)*( &
             azbar*( &
             bxbar*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bx*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbar*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bx*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*( &
             azbar*( &
             axbar*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             ax*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + az*( &
             axbar*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             ax*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz*( &
             bzbar*( &
             axbar*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             ax*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbar*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             ax*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy*( &
             azbar*( &
             bxbar*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bx*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbar*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bx*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hz*( &
             bzbar*( &
             bxbar*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bx*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbar*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bx*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*hz*( &
             bzbar*( &
             axbar*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             ax*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbar*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             ax*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy*hz*( &
             bzbar*( &
             bxbar*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bx*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbar*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bx*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !     df/dx:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*( &
             azbar*( &
             axbarp*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             axp*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbarp*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             axp*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             bxbarp*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bxp*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbarp*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bxp*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy*( &
             azbar*( &
             axbarp*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             axp*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + az*( &
             axbarp*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             axp*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hz*( &
             bzbar*( &
             axbarp*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             axp*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbarp*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             axp*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*( &
             azbar*( &
             bxbarp*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bxp*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbarp*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bxp*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz*( &
             bzbar*( &
             bxbarp*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bxp*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bxp*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy*hz*( &
             bzbar*( &
             axbarp*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             axp*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbarp*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             axp*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*hz*( &
             bzbar*( &
             bxbarp*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bxp*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bxp*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=hyi*( &
             azbar*( &
             axbar*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             ax*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbar*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             ax*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*hx(v)*( &
             azbar*( &
             bxbar*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bx*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbar*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bx*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             axbar*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             ax*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + az*( &
             axbar*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             ax*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*hz*( &
             bzbar*( &
             axbar*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             ax*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbar*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             ax*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             azbar*( &
             bxbar*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bx*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbar*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bx*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hyi*hz*( &
             bzbar*( &
             bxbar*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bx*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbar*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bx*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz*( &
             bzbar*( &
             axbar*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             ax*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbar*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             ax*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hz*( &
             bzbar*( &
             bxbar*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bx*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbar*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bx*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(4).eq.1) then
        !
        !  df/dz:
        !
        iadr=iadr+1
        !
        sum=hzi*( &
             azbarp*( &
             axbar*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             ax*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbar*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             ax*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*hx(v)*( &
             azbarp*( &
             bxbar*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bx*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbar*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bx*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*hy*( &
             azbarp*( &
             axbar*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             ax*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbar*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             ax*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             axbar*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             ax*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbar*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             ax*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*hx(v)*hy*( &
             azbarp*( &
             bxbar*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bx*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbar*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bx*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             bzbarp*( &
             bxbar*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bx*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bx*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*( &
             bzbarp*( &
             axbar*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             ax*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbar*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             ax*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hy*( &
             bzbarp*( &
             bxbar*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bx*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bx*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi*( &
             azbar*( &
             axbarp*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             axp*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  az*( &
             axbarp*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             axp*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*( &
             azbar*( &
             bxbarp*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bxp*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + az*( &
             bxbarp*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bxp*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             azbar*( &
             axbarp*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             axp*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + az*( &
             axbarp*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             axp*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hyi*hz*( &
             bzbar*( &
             axbarp*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             axp*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bz*( &
             axbarp*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             axp*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             azbar*( &
             bxbarp*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bxp*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + az*( &
             bxbarp*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bxp*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*hz*( &
             bzbar*( &
             bxbarp*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bxp*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bxp*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hz*( &
             bzbar*( &
             axbarp*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             axp*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bz*( &
             axbarp*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             axp*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hz*( &
             bzbar*( &
             bxbarp*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bxp*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bz*( &
             bxbarp*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bxp*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdz:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hzi*( &
             azbarp*( &
             axbarp*(aybar*fin(0,i,j,k)  +ay*fin(0,i,j+1,k))+ &
             axp*(aybar*fin(0,i+1,j,k)+ay*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbarp*(aybar*fin(0,i,j,k+1)  +ay*fin(0,i,j+1,k+1))+ &
             axp*(aybar*fin(0,i+1,j,k+1)+ay*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*( &
             azbarp*( &
             bxbarp*(aybar*fin(1,i,j,k)  +ay*fin(1,i,j+1,k))+ &
             bxp*(aybar*fin(1,i+1,j,k)+ay*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(aybar*fin(1,i,j,k+1)  +ay*fin(1,i,j+1,k+1))+ &
             bxp*(aybar*fin(1,i+1,j,k+1)+ay*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy*hzi*( &
             azbarp*( &
             axbarp*(bybar*fin(2,i,j,k)  +by*fin(2,i,j+1,k))+ &
             axp*(bybar*fin(2,i+1,j,k)+by*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbarp*(bybar*fin(2,i,j,k+1)  +by*fin(2,i,j+1,k+1))+ &
             axp*(bybar*fin(2,i+1,j,k+1)+by*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             bzbarp*( &
             axbarp*(aybar*fin(3,i,j,k)  +ay*fin(3,i,j+1,k))+ &
             axp*(aybar*fin(3,i+1,j,k)+ay*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(aybar*fin(3,i,j,k+1)  +ay*fin(3,i,j+1,k+1))+ &
             axp*(aybar*fin(3,i+1,j,k+1)+ay*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*hzi*( &
             azbarp*( &
             bxbarp*(bybar*fin(4,i,j,k)  +by*fin(4,i,j+1,k))+ &
             bxp*(bybar*fin(4,i+1,j,k)+by*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(bybar*fin(4,i,j,k+1)  +by*fin(4,i,j+1,k+1))+ &
             bxp*(bybar*fin(4,i+1,j,k+1)+by*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             bxbarp*(aybar*fin(5,i,j,k)  +ay*fin(5,i,j+1,k))+ &
             bxp*(aybar*fin(5,i+1,j,k)+ay*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(aybar*fin(5,i,j,k+1)  +ay*fin(5,i,j+1,k+1))+ &
             bxp*(aybar*fin(5,i+1,j,k+1)+ay*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hy*( &
             bzbarp*( &
             axbarp*(bybar*fin(6,i,j,k)  +by*fin(6,i,j+1,k))+ &
             axp*(bybar*fin(6,i+1,j,k)+by*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(bybar*fin(6,i,j,k+1)  +by*fin(6,i,j+1,k+1))+ &
             axp*(bybar*fin(6,i+1,j,k+1)+by*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hy*( &
             bzbarp*( &
             bxbarp*(bybar*fin(7,i,j,k)  +by*fin(7,i,j+1,k))+ &
             bxp*(bybar*fin(7,i+1,j,k)+by*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(bybar*fin(7,i,j,k+1)  +by*fin(7,i,j+1,k+1))+ &
             bxp*(bybar*fin(7,i+1,j,k+1)+by*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(7).eq.1) then
        !
        !  d2f/dydz:
        !
        iadr=iadr+1
        !
        sum=hyi*hzi*( &
             azbarp*( &
             axbar*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             ax*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbar*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             ax*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*hzi*hx(v)*( &
             azbarp*( &
             bxbar*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bx*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbar*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bx*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*( &
             azbarp*( &
             axbar*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             ax*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbar*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             ax*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*( &
             bzbarp*( &
             axbar*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             ax*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbar*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             ax*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hzi*( &
             azbarp*( &
             bxbar*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bx*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbar*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bx*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*hyi*( &
             bzbarp*( &
             bxbar*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bx*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bx*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             axbar*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             ax*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbar*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             ax*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hx(v)*( &
             bzbarp*( &
             bxbar*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bx*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbar*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bx*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(8).eq.1) then
        !
        !  d3f/dxdydz:
        !
        iadr=iadr+1
        !
        sum=hxi(v)*hyi*hzi*( &
             azbarp*( &
             axbarp*(aybarp*fin(0,i,j,k)  +ayp*fin(0,i,j+1,k))+ &
             axp*(aybarp*fin(0,i+1,j,k)+ayp*fin(0,i+1,j+1,k))) &
             +  azp*( &
             axbarp*(aybarp*fin(0,i,j,k+1)  +ayp*fin(0,i,j+1,k+1))+ &
             axp*(aybarp*fin(0,i+1,j,k+1)+ayp*fin(0,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*hzi*( &
             azbarp*( &
             bxbarp*(aybarp*fin(1,i,j,k)  +ayp*fin(1,i,j+1,k))+ &
             bxp*(aybarp*fin(1,i+1,j,k)+ayp*fin(1,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(aybarp*fin(1,i,j,k+1)  +ayp*fin(1,i,j+1,k+1))+ &
             bxp*(aybarp*fin(1,i+1,j,k+1)+ayp*fin(1,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hzi*( &
             azbarp*( &
             axbarp*(bybarp*fin(2,i,j,k)  +byp*fin(2,i,j+1,k))+ &
             axp*(bybarp*fin(2,i+1,j,k)+byp*fin(2,i+1,j+1,k))) &
             + azp*( &
             axbarp*(bybarp*fin(2,i,j,k+1)  +byp*fin(2,i,j+1,k+1))+ &
             axp*(bybarp*fin(2,i+1,j,k+1)+byp*fin(2,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*hyi*( &
             bzbarp*( &
             axbarp*(aybarp*fin(3,i,j,k)  +ayp*fin(3,i,j+1,k))+ &
             axp*(aybarp*fin(3,i+1,j,k)+ayp*fin(3,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(aybarp*fin(3,i,j,k+1)  +ayp*fin(3,i,j+1,k+1))+ &
             axp*(aybarp*fin(3,i+1,j,k+1)+ayp*fin(3,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hzi*( &
             azbarp*( &
             bxbarp*(bybarp*fin(4,i,j,k)  +byp*fin(4,i,j+1,k))+ &
             bxp*(bybarp*fin(4,i+1,j,k)+byp*fin(4,i+1,j+1,k))) &
             + azp*( &
             bxbarp*(bybarp*fin(4,i,j,k+1)  +byp*fin(4,i,j+1,k+1))+ &
             bxp*(bybarp*fin(4,i+1,j,k+1)+byp*fin(4,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hyi*( &
             bzbarp*( &
             bxbarp*(aybarp*fin(5,i,j,k)  +ayp*fin(5,i,j+1,k))+ &
             bxp*(aybarp*fin(5,i+1,j,k)+ayp*fin(5,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(aybarp*fin(5,i,j,k+1)  +ayp*fin(5,i,j+1,k+1))+ &
             bxp*(aybarp*fin(5,i+1,j,k+1)+ayp*fin(5,i+1,j+1,k+1))) &
             )
        !
        sum=sum+hxi(v)*( &
             bzbarp*( &
             axbarp*(bybarp*fin(6,i,j,k)  +byp*fin(6,i,j+1,k))+ &
             axp*(bybarp*fin(6,i+1,j,k)+byp*fin(6,i+1,j+1,k))) &
             + bzp*( &
             axbarp*(bybarp*fin(6,i,j,k+1)  +byp*fin(6,i,j+1,k+1))+ &
             axp*(bybarp*fin(6,i+1,j,k+1)+byp*fin(6,i+1,j+1,k+1))) &
             )
        !
        sum=sum+( &
             bzbarp*( &
             bxbarp*(bybarp*fin(7,i,j,k)  +byp*fin(7,i,j+1,k))+ &
             bxp*(bybarp*fin(7,i+1,j,k)+byp*fin(7,i+1,j+1,k))) &
             + bzp*( &
             bxbarp*(bybarp*fin(7,i,j,k+1)  +byp*fin(7,i,j+1,k+1))+ &
             bxp*(bybarp*fin(7,i+1,j,k+1)+byp*fin(7,i+1,j+1,k+1))) &
             )
        !
        fval(v,iadr)=sum
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine herm3fcnx

subroutine akherm2(x,nx,y,ny,fherm,nf2,ilinx,iliny,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on Akima's method
  !  [Hiroshi Akima, Communications of the ACM, Jan 1974, Vol. 17 No. 1]
  !
  !  input:
  !
  !============
  implicit none
  integer ilinx,iliny,ier,nf2
  !============
  integer nx,ny,nf1                 ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: fherm(0:3,nf2,ny)            ! data/Hermite array
  !
  !  fherm(0,i,j) = function value f at x(i),y(j)  **on input**
  !
  !  fherm(1,i,j) = derivative df/dx at x(i),y(j)  **on output**
  !  fherm(2,i,j) = derivative df/dy at x(i),y(j)  **on output**
  !  fherm(3,i,j) = derivative d2f/dxdy at x(i),y(j)  **on output**
  !
  !  addl output:
  !    ilinx=1 if x axis is evenly spaced
  !    iliny=1 if y axis is evenly spaced
  !    ier=0 if no error:
  !      x, y must both be strict ascending
  !      nf2.ge.nx is required.
  !
  !  a default boundary condition is used, based on divided differences
  !  in the edge region.  For more control of BC, use akherm2p...
  !
  call akherm2p(x,nx,y,ny,fherm,nf2,ilinx,iliny,0,0,ier)
  !
  return
end subroutine akherm2
!----------------------------
subroutine akherm2p(x,nx,y,ny,fherm,nf2,ilinx,iliny,ipx,ipy,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on Akima's method
  !  [Hiroshi Akima, Communications of the ACM, Jan 1974, Vol. 17 No. 1]
  !
  !  with independently settable boundary condition options:
  !     ipx or ipy  =0  -- default, boundary conditions from divided diffs
  !     ipx or ipy  =1  -- periodic boundary condition
  !     ipx or ipy  =2  -- user supplied df/dx or df/dy
  !  input:
  !
  !============
  implicit none
  integer ilinx,iliny,ier,nf2,ierx,iery,ierbc,iy,ix,icx,icy
  integer incx,incy,ix1,iy1,iym2,iym1,iymm2,iymm1,iyp2,iyp1
  integer iypp2,iypp1,ixm2,ixm1,ixmm2,ixmm1,iflagx,ixp2,ixp1
  integer ixpp2,ixpp1,iflagy
  !============
  real(fp) :: cxp,cxm,cxpp,cxmm,cxtrap0,cxtrapn,cyp,cym,cypp,cymm
  real(fp) :: cytrap0,cytrapn,zansr,cxm2,cxp2
  !============
  integer nx,ny,nf1                 ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: fherm(0:3,nf2,ny)            ! data/Hermite array
  !
  integer ipx                       ! =1 if df/dx periodic in x
  integer ipy                       ! =1 if df/dy periodic in y
  !
  !  fherm(0,1:nx,1:ny) supplied by user; this routine computes the
  !  rest of the elements, but note:
  !
  !    if ipx=2:  fherm(1,1,1:ny) & fherm(1,nx,1:ny) = INPUT df/dx BCs
  !    if ipy=2:  fherm(2,1:nx,1) & fherm(2,1:nx,ny) = INPUT df/dy BCs
  !
  !  on output, at all grid points (i,j) covering (1:nx,1:ny):
  !  fherm1(1,i,j) -- df/dx at the grid point
  !  fherm1(2,i,j) -- df/dy at the grid point
  !  fherm1(3,i,j) -- d2f/dxdy at the grid point
  !
  !---------------------
  !  local...
  !
  real(fp) :: wx(2),wy(2),e(2,2)
  !
  real(fp), dimension(:,:), allocatable ::  ftmp
  !
  real(fp) :: xx(0:nx+1)
  real(fp) :: yy(0:ny+1)
  !
  !---------------------
  !
  !  error checks
  !
  ier=0
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=ier+1
  !
  if(ierx.ne.0) then
     write(6,'('' ?akherm2:  x axis not strict ascending'')')
  end if
  !
  call splinck(y,ny,iliny,1.0E-3_fp,iery)
  if(iery.ne.0) ier=ier+1
  !
  if(iery.ne.0) then
     write(6,'('' ?akherm2:  y axis not strict ascending'')')
  end if
  !
  if(nf2.lt.nx) then
     ier=ier+1
     write(6,*) '?akherm2:  fherm array dimension too small.'
  end if
  !
  ierbc=0
  call ibc_ck(ipx,'akherm2','X Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  !
  ierbc=0
  call ibc_ck(ipy,'akherm2','Y Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  !
  if(ier.ne.0) return
  !
  !---------------------------------------
  !
  !  get a  temporary array for f -- will extend out by 1 zone in
  !  each direction so that numerical derivative evaluation can be
  !  done without a lot of special case logic near the edges...
  !
  allocate(ftmp(0:nx+1,0:ny+1))
  !
  do iy=1,ny
     do ix=1,nx
        ftmp(ix,iy)=fherm(0,ix,iy)
     end do
  end do
  !
  !  also create expanded axes grids...
  !
  xx(1:nx)=x
  yy(1:ny)=y
  xx(0)=2*x(1)-x(2)
  xx(nx+1)=2*x(nx)-x(nx-1)
  yy(0)=2*y(1)-y(2)
  yy(ny+1)=2*y(ny)-y(ny-1)
  !
  !---------------------------------------
  !
  !  handle boundary conditions and create rows of extrapolated points
  !  in ftmp.  first do ftmp(0,1:ny), ftmp(nx+1,1:ny),
  !                then ftmp(1:nx,0), ftmp(1:nx,ny+1),
  !                then ... fill in the corners
  !
  !  also, for ipx.le.1 fill in the bdy fherm(1,*) values;
  !        for ipy.le.1 fill in the bdy fherm(2,*) values
  !
  !  x bc's
  !
  do iy=1,ny
     !
     cxp=(ftmp(2,iy)-ftmp(1,iy))/(xx(2)-xx(1))
     cxm=(ftmp(nx,iy)-ftmp(nx-1,iy))/(xx(nx)-xx(nx-1))
     !
     if(ipx.eq.1) then
        !
        !  periodic BC
        !
        if(nx.gt.2) then
           cxpp=(ftmp(3,iy)-ftmp(2,iy))/(xx(3)-xx(2))
           cxmm=(ftmp(nx-1,iy)-ftmp(nx-2,iy))/(xx(nx-1)-xx(nx-2))
           !
           call akherm0(cxmm,cxm,cxp,cxpp,wx,fherm(1,1,iy))
           fherm(1,nx,iy)=fherm(1,1,iy)
        else
           fherm(1,1,iy) = cxp  ! =cxm, nx=2
           fherm(1,nx,iy) = fherm(1,1,iy)
        end if
        !
        cxtrap0=cxm
        cxtrapn=cxp
        !
     else if(ipx.eq.0) then
        !
        !  default BC -- standard numeric extrapolation
        !
        if(nx.gt.2) then
           cxpp=(ftmp(3,iy)-ftmp(2,iy))/(xx(3)-xx(2))
           fherm(1,1,iy)=1.5_fp*cxp-0.5_fp*cxpp
           !
           cxmm=(ftmp(nx-1,iy)-ftmp(nx-2,iy))/(xx(nx-1)-xx(nx-2))
           fherm(1,nx,iy)=1.5_fp*cxm-0.5_fp*cxmm
           !
        else
           fherm(1,1,iy) = cxp  ! =cxm, nx=2
           fherm(1,nx,iy) = fherm(1,1,iy)
        end if
        !
        !  extrapolate to slope to ghost points just past bdy...
        !
        cxtrap0=2.0_fp*fherm(1,1,iy)-cxp
        cxtrapn=2.0_fp*fherm(1,nx,iy)-cxm
        !
     else
        !
        !  BC supplied by user.  Also use this for extrapolation...
        !
        cxtrap0=2.0_fp*fherm(1,1,iy)-cxp
        cxtrapn=2.0_fp*fherm(1,nx,iy)-cxm
        !
     end if
     !
     ftmp(0,iy)=ftmp(1,iy)-cxtrap0*(xx(1)-xx(0))
     ftmp(nx+1,iy)=ftmp(nx,iy)+cxtrapn*(xx(nx+1)-xx(nx))
     !
  end do
  !
  !  y bc's
  !
  do ix=1,nx
     !
     cyp=(ftmp(ix,2)-ftmp(ix,1))/(yy(2)-yy(1))
     cym=(ftmp(ix,ny)-ftmp(ix,ny-1))/(yy(ny)-yy(ny-1))
     !
     if(ipy.eq.1) then
        !
        !  periodic BC
        !
        if(ny.gt.2) then
           cypp=(ftmp(ix,3)-ftmp(ix,2))/(yy(3)-yy(2))
           cymm=(ftmp(ix,ny-1)-ftmp(ix,ny-2))/(yy(ny-1)-yy(ny-2))
           !
           call akherm0(cymm,cym,cyp,cypp,wy,fherm(2,ix,1))
           fherm(2,ix,ny)=fherm(2,ix,1)
           !
        else
           fherm(2,ix,1) = cyp  ! =cym, ny=2
           fherm(2,ix,ny)=fherm(2,ix,1)
        end if
        !
        cytrap0=cym
        cytrapn=cyp
        !
     else if(ipy.eq.0) then
        !
        !  default BC -- standard numeric extrapolation
        !
        if(ny.gt.2) then
           cypp=(ftmp(ix,3)-ftmp(ix,2))/(yy(3)-yy(2))
           fherm(2,ix,1)=1.5_fp*cyp-0.5_fp*cypp
           !
           cymm=(ftmp(ix,ny-1)-ftmp(ix,ny-2))/(yy(ny-1)-yy(ny-2))
           fherm(2,ix,ny)=1.5_fp*cym-0.5_fp*cymm
           !
        else
           fherm(2,ix,1) = cyp  ! =cym, ny=2
           fherm(2,ix,ny)=fherm(2,ix,1)
        end if
        !
        !  extrapolate to slope to ghost points just past bdy...
        !
        cytrap0=2.0_fp*fherm(2,ix,1)-cyp
        cytrapn=2.0_fp*fherm(2,ix,ny)-cym
        !
     else
        !
        !  BC supplied by user.  Also use this for extrapolation...
        !
        cytrap0=2.0_fp*fherm(2,ix,1)-cyp
        cytrapn=2.0_fp*fherm(2,ix,ny)-cym
        !
     end if
     !
     ftmp(ix,0)=ftmp(ix,1)-cytrap0*(yy(1)-yy(0))
     ftmp(ix,ny+1)=ftmp(ix,ny)+cytrapn*(yy(ny+1)-yy(ny))
     !
  end do
  !
  !  and do something for the corners...
  !
  do ix=0,1
     do iy=0,1
        icx=ix*(nx+1)
        icy=iy*(ny+1)
        incx=1-2*ix
        incy=1-2*iy

        ix1=icx+incx
        iy1=icy+incy

        ftmp(icx,icy)=ftmp(icx,iy1)+ftmp(ix1,icy)-ftmp(ix1,iy1)
        !
     end do
  end do
  !
  !----------------------------------------------------------------
  !  OK, now ready to compute all the interior coefficients and the
  !  rest of the edge coefficients as well...
  !
  do iy=1,ny
     iym2=iy
     iym1=iym2-1
     !
     iymm2=iy-1
     iymm1=iymm2-1
     !
     iyp2=iy+1
     iyp1=iyp2-1
     !
     iypp2=iy+2
     iypp1=iypp2-1
     !
     do ix=1,nx
        !
        !  x div. diffs in vicinity
        !
        ixm2=ix
        ixm1=ixm2-1
        !
        ixmm2=ix-1
        ixmm1=ixmm2-1
        !
        iflagx=0
        cxm=(ftmp(ixm2,iy)-ftmp(ixm1,iy))/(xx(ixm2)-xx(ixm1))
        if(ix.gt.1) then
           cxmm=(ftmp(ixmm2,iy)-ftmp(ixmm1,iy))/ &
                (xx(ixmm2)-xx(ixmm1))
        else
           if(ipx.eq.1) then
              cxmm=(ftmp(nx-1,iy)-ftmp(nx-2,iy))/ &
                   (xx(nx-1)-xx(nx-2))
           else
              iflagx=1
           end if
        end if
        !
        ixp2=ix+1
        ixp1=ixp2-1
        !
        ixpp2=ix+2
        ixpp1=ixpp2-1
        !
        cxp=(ftmp(ixp2,iy)-ftmp(ixp1,iy))/(xx(ixp2)-xx(ixp1))
        if(ix.lt.nx) then
           cxpp=(ftmp(ixpp2,iy)-ftmp(ixpp1,iy))/ &
                (xx(ixpp2)-xx(ixpp1))
        else
           if(ipx.eq.1) then
              cxpp=(ftmp(3,iy)-ftmp(2,iy))/(xx(3)-xx(2))
           else
              cxpp=cxp+(cxm-cxmm)
           end if
        end if
        !
        if(iflagx.eq.1) then
           cxmm=cxm+(cxp-cxpp)
        end if
        !
        !  Akima weightings + df/dx for interior pts
        !
        call akherm0(cxmm,cxm,cxp,cxpp,wx,zansr)
        if((ix.gt.1).and.(ix.lt.nx)) fherm(1,ix,iy)=zansr
        !
        !  y div. diffs in vicinity
        !
        iflagy=0
        cym=(ftmp(ix,iym2)-ftmp(ix,iym1))/(yy(iym2)-yy(iym1))
        if(iy.gt.1) then
           cymm=(ftmp(ix,iymm2)-ftmp(ix,iymm1))/ &
                (yy(iymm2)-yy(iymm1))
        else
           if(ipy.eq.1) then
              cymm=(ftmp(ix,ny-1)-ftmp(ix,ny-2))/ &
                   (yy(ny-1)-yy(ny-2))
           else
              iflagy=1
           end if
        end if
        !
        cyp=(ftmp(ix,iyp2)-ftmp(ix,iyp1))/(yy(iyp2)-yy(iyp1))
        if(iy.lt.ny) then
           cypp=(ftmp(ix,iypp2)-ftmp(ix,iypp1))/ &
                (yy(iypp2)-yy(iypp1))
        else
           if(ipy.eq.1) then
              cypp=(ftmp(ix,3)-ftmp(ix,2))/(yy(3)-yy(2))
           else
              cypp=cyp+(cym-cymm)
           end if
        end if
        !
        if(iflagy.eq.1) then
           cymm=cym+(cyp-cypp)
        end if
        !
        !  Akima weightings + df/dy for interior pts
        !
        call akherm0(cymm,cym,cyp,cypp,wy,zansr)
        if((iy.gt.1).and.(iy.lt.ny)) fherm(2,ix,iy)=zansr
        !
        !  cross derivatives (2nd order divided differences)
        !
        cxm2=(ftmp(ixm2,iym1)-ftmp(ixm1,iym1))/ &
             (xx(ixm2)-xx(ixm1))
        e(1,1)=(cxm-cxm2)/(yy(iym2)-yy(iym1))
        !
        cxm2=(ftmp(ixm2,iyp2)-ftmp(ixm1,iyp2))/ &
             (xx(ixm2)-xx(ixm1))
        e(1,2)=(cxm2-cxm)/(yy(iyp2)-yy(iyp1))
        !
        cxp2=(ftmp(ixp2,iym1)-ftmp(ixp1,iym1))/ &
             (xx(ixp2)-xx(ixp1))
        e(2,1)=(cxp-cxp2)/(yy(iym2)-yy(iym1))
        !
        cxp2=(ftmp(ixp2,iyp2)-ftmp(ixp1,iyp2))/ &
             (xx(ixp2)-xx(ixp1))
        e(2,2)=(cxp2-cxp)/(yy(iyp2)-yy(iyp1))
        !
        !  the values
        !
        fherm(3,ix,iy)=(wx(1)*(wy(1)*e(1,1)+wy(2)*e(1,2))+ &
             wx(2)*(wy(1)*e(2,1)+wy(2)*e(2,2)))/ &
             ((wx(1)+wx(2))*(wy(1)+wy(2)))
        !
     end do
  end do
  !
  deallocate (ftmp)
  return
end subroutine akherm2p

subroutine mkspl2p(fun,x,nx,th,nth,fspl,nf3,wk,inwk, &
     ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a bicubic periodic spline with knots at grid points and
  !  function values from the callable function `fun' passed.
  !
  !  use bpspline to setup the spline coefficients
  !
  !============
  implicit none
  integer nth,nf3,inwk,nx,ix,ith
  !============
  real(fp) :: fun
  !============
  external fun                      ! passed real function(x,th)
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: th(nth)                      ! th coordinate array
  !
  !  output:
  !
  real(fp) :: fspl(4,4,nf3,nth)            ! function data / spline coeff array
  real(fp) :: wk(inwk)                     ! workspace -- at least 5*max(nx,nth)
  !
  integer ilinx                     ! output =1 if x(1...nx) evenly spaced
  integer ilinth                    ! output =1 if th(1..nth) evenly spaced
  !
  integer ier                       ! completion code from bpspline 0=OK
  !
  !----------------------------
  !
  ier=0
  if(nf3.lt.nx) then
     write(6,'('' ?mkspl2p -- array dim error, nf3.lt.nx'')')
     ier=1
  end if
  if(inwk.lt.5*max(nx,nth)) then
     write(6,'('' ?mkspl2p -- array dim error, inwk too small'')')
     ier=2
  end if
  !
  do ix=1,nx
     do ith=1,nth
        fspl(1,1,ix,ith)=fun(x(ix),th(ith))
     end do
  end do
  !
  call bpspline(x,nx,th,nth,fspl,nf3,wk,inwk,ilinx,ilinth,ier)
  !
  return
end subroutine mkspl2p

 subroutine mpi_mkgroup(comm, names, start, n, ranks, n_tot, new_group, group_comm, ierr)
!
! Create an mpi communicator group
! 01/07/2012 CLF

#ifdef __MPI
 use mpi
 use mpi_proc_data
 use logmod
 implicit none

! Input
 integer, intent(in)               :: comm  ! communicator
 character(len=*), intent(in), dimension(*)  :: names    ! print name for new_group
 integer, intent(in), dimension(*) :: start ! start of ranks in array ranks  
 integer, intent(in), dimension(*) :: n     ! number of elements in new group  
 integer, intent(in), dimension(*) :: ranks ! ranks of processes in orig_group to appear in new_group
 integer, intent(in)               :: n_tot ! number of sections in group  
! Output
 integer, intent(out)       :: new_group         ! new group handle 
 integer, intent(out)       :: group_comm        ! new group communicator handle
 integer, intent(out)       :: ierr

 integer        :: ierr111=111

! private
 integer        ::  orig_group 	     ! group (handle)
 integer        ::  myrank           ! rank of original process
 integer        ::  size             ! size of original group
 integer        ::  i_incl, n_incl, i, ii
 integer        ::  ranges(4,3)
 logical        ::  member           ! true if in group

 myrank=-1
 member=.false.

! Extract the original group handle
  call MPI_COMM_GROUP(comm, orig_group, ierr)
  call ckerr('MPI_COMM_GROUP',ierr)

  call MPI_COMM_RANK(comm, myrank, ierr)
  call ckerr('MPI_COMM_RANK',ierr)
  call MPI_COMM_SIZE(comm, size, ierr)

! add processes
  ii=0
  check_if_in: do i=1,n_tot
     ii=ii+1
     if (myrank .ge. ranks(start(i)) .and. &
         myrank .le. ranks(start(i)+n(i)-1)) then
         member=.true.
         exit check_if_in
     endif
   enddo check_if_in
   i_incl = ii
   n_incl = start(ii)+n(ii)-1
   
   if (member) then
      call MPI_GROUP_INCL(orig_group, n(i_incl), &
                          ranks(start(i_incl):n_incl),new_group, ierr)
      call ckerr('MPI_GROUP_INCL',ierr)
   else
      if (n_tot .gt. 1) then
         ii=0
         do i=1,n_tot
            if (i .ne.  i_incl) then
               ii=ii+1
               ranges(1,ii)=start(i)-1
               ranges(2,ii)=start(i)+n(i)-2
               ranges(3,ii)=1
            endif
         enddo
         call MPI_GROUP_RANGE_INCL(orig_group, n_tot-1, &
                          ranges,new_group, ierr)
      else
         call MPI_GROUP_INCL(orig_group, size-n(i_incl), &
                          ranks(start(1)+n(1):size),new_group, ierr)
      endif
   endif

! Create Communicator
! Must be called by all processes in "comm"
   
   call MPI_COMM_CREATE(comm, new_group, group_comm, ierr)
   call ckerr('MPI_COMM_CREATE',ierr)

! Give it a name
!   call MPI_COMM_SET_NAME(group_comm, name, ierr)
!   call ckerr('MPI_COMM_SET_NAME',ierr)

! add to storage
   if (member) then
      call mpi_env_comm_add(group_comm, ierr, trim(names(i_incl)))
   else
      call mpi_env_comm_add(MPI_COMM_NULL, ierr, trim(names(i_incl)))
   endif
   if (ierr .ne. 0) then
      call errorLog('mpi_mkgroup: mpi_env_comm_add failed. Error=',ierr)
   endif


CONTAINS

  subroutine ckerr(str, ierr)
    character*(*), intent(in) :: str
    integer, intent(in)       :: ierr     ! error if .ne.0

    if(ierr.eq.0) return
! if error abort
     call errorLog('mpi_mkgroup: '//trim(str)//' ierr=',ierr)
     call errorLog('failed to create group '//names(i_incl)// &
            ' issues MPI_ABORT(...) I am rank',myrank)
    call MPI_ABORT(comm,ierr,ierr111)
  end subroutine ckerr
#endif

 end subroutine mpi_mkgroup

subroutine errset_mpi(myid,istat)

  ! set an error status: istat>0 expected & enforced
  ! A CALL TO THIS ROUTINE KILLS YOUR RUN... EVEN IF mpi_errstat_enable=.FALSE.

  use mpi_env_mod
  implicit NONE

  integer, intent(in) :: myid   ! process ID: 0,1,2,...<Nprocs>-1
  ! NOTE: pass myid=-1 if the process ID is unknown.

  integer, intent(in) :: istat  ! error code (user defined), .gt.0 expected...

  !-----------------------
  integer :: jstat,id,mpierr
  !-----------------------

  jstat = max(1,istat)

  id=myid
  if(id.lt.0) then
#ifdef __MPI
     call MPI_COMM_RANK(mpi_env_comm,id,mpierr)
#else
     id=0
#endif
  endif

#ifdef __MPI
  write(0,*) ' ERRSET_MPI call by process myid=',id,'; istat = ',istat
  if(istat.ne.jstat) write(0,*) ' ...istat reset to: ',jstat
  write(0,*) ' **** myid=',id,' MPI_ABORT CALL **** '
  call MPI_ABORT(mpi_env_comm,jstat,mpierr)
  call exit(1)
#else
  write(0,*) ' ERRSET called, istat=',istat,' program exiting... '
  if(istat.ne.jstat) write(0,*) ' ...istat reset to: ',jstat
  call exit(1)
#endif

end subroutine errset_mpi

subroutine dnherm2(x,nx,y,ny,fherm,nf2,ilinx,iliny,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on simple
  !  numerical differentiation using the given grid.  The grid should
  !  be "approximately" evenly spaced.
  !
  !  2d routine
  !
  !  input:
  !
  !  nf2.gt.nx expected!
  !
  !============
  implicit none
  integer iliny,ier,ilinx,ierx,iery,iy,iyp,iym,ix,ixp,ixm
  !============
  real(fp) :: zd
  !============
  integer nx,ny,nf2                 ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: fherm(0:3,nf2,ny)            ! data/Hermite array
  !
  !  fherm(0,i,j) = function value f at x(i),y(j)  **on input**
  !
  !  fherm(1,i,j) = derivative df/dx at x(i),y(j)  **on output**
  !  fherm(2,i,j) = derivative df/dy at x(i),y(j)  **on output**
  !  fherm(3,i,j) = derivative d2f/dxdy at x(i),y(j)  **on output**
  !
  !  addl output:
  !    ilinx=1 if x axis is evenly spaced
  !    iliny=1 if y axis is evenly spaced
  !    ier=0 if no error:
  !      x, y must both be strict ascending
  !      nf2.ge.nx is required.
  !
  !----------------------------
  !
  ier=0
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?dnherm2:  x axis not strict ascending'')')
  end if
  !
  call splinck(y,ny,iliny,1.0E-3_fp,iery)
  if(iery.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?dnherm2:  y axis not strict ascending'')')
  end if
  !
  if(nf2.lt.nx) then
     ier=4
     write(6,*) '?dnherm2:  fherm array dimension too small.'
  end if
  !
  if(ier.ne.0) return
  !
  do iy=1,ny
     !
     iyp=min(ny,iy+1)
     iym=max(1,iy-1)
     !
     do ix=1,nx
        !
        ixp=min(nx,ix+1)
        ixm=max(1,ix-1)
        !
        !  x diffs in vicinity
        !
        zd=(fherm(0,ixp,iy)-fherm(0,ixm,iy))/(x(ixp)-x(ixm))
        !
        fherm(1,ix,iy)=zd
        !
        !  y diffs in vicinity
        !
        zd=(fherm(0,ix,iyp)-fherm(0,ix,iym))/(y(iyp)-y(iym))
        !
        fherm(2,ix,iy)=zd
        !
        !  xy cross derivs (except at corners, iedge=2)
        !
        fherm(3,ix,iy)=(fherm(0,ixp,iyp)-fherm(0,ixm,iyp) &
             -fherm(0,ixp,iym)+fherm(0,ixm,iym))/ &
             ((x(ixp)-x(ixm))*(y(iyp)-y(iym)))
        !
     end do
  end do
  !
  return
end subroutine dnherm2

program ezspline_io_test

  !  typical compilation:
  !    <fortran-driver> -c -I<module-path> ezspline_io_test.f90
  !  typical load:
  !    <fortran-driver> ezspline_io_test.o \
  !       $libpath/pspline.a  $libpath/ezcdf.a  $libpath/portlib.a \
  !       -L$netCDF_path -lnetcdf
  !
  !  demonstrate ezspline_save and ezspline_load with new options
  !  dmc March 2006.

  use ezSpline_obj
  use ezSpline
  implicit NONE

  type(EZspline3_r8) :: fs, gs

  integer, parameter :: nx=21, nth=31, nph=41
  integer :: ix,ith,iph,ier

  real*8 :: x(nx),th(nth),ph(nph), f(nx,nth,nph), g(nx,nth,nph)
  integer :: bc(2) = (/ 0.d0, 0.d0 /)
  integer :: bcperio(2) = (/ -1.0d0, -1.0d0 /)

  real*8, parameter :: C2PI = 6.2831853071795862D+00
  real*8, parameter :: ONE = 1.0d0

  real*8 :: xtest(5) = (/ 0.0d0, 0.2d0, 0.4d0, 0.6d0, 0.8d0 /)
  real*8 :: thtest(5) = (/ 0.5d0, 0.6d0, 0.7d0, 0.8d0, 0.9d0 /)
  real*8 :: phtest(5) = (/ 2.5d0, 2.6d0, 2.7d0, 2.8d0, 2.9d0 /)

  real*8 :: ftest(5), gtest(5)

  !-----------------------------------

  do ix=1,nx
     x(ix)=(ix-1)*ONE/(nx-1)
  enddo

  do ith=1,nth
     th(ith)=(ith-1)*C2PI/(nth-1)
  enddo

  do iph=1,nph
     ph(iph)=(iph-1)*C2PI/(nph-1)
  enddo

  do iph=1,nph
     do ith=1,nth
        do ix=1,nx

           f(ix,ith,iph) = (1-x(ix)**2)*cos(th(ith))*sin(ph(iph))
           g(ix,ith,iph) = (1-x(ix)**2)**2*sin(th(ith))*cos(ph(iph))

        enddo
     enddo
  enddo

  !  nullify pointers; put fs & gs into a known, empty state:
  call EZspline_preInit(fs)
  call EZspline_preInit(gs)

  !  create 2 3d splines

  write(6,*) ' initialize 3d spline objects...'

  call EZspline_init(fs, nx,nth,nph, bc,bcperio,bcperio, ier); call ckerr
  call EZspline_init(gs, nx,nth,nph, bc,bcperio,bcperio, ier); call ckerr

  fs%x1 = x
  fs%x2 = th
  fs%x3 = ph

  gs%x1 = x
  gs%x2 = th
  gs%x3 = ph

  write(6,*) ' load data and calculate spline coefficients...'

  call ezspline_setup(fs, f, ier); call ckerr
  call ezspline_setup(gs, g, ier); call ckerr

  !  evaluate a few points

  call fgeval

  write(6,*) ' save splines with all coefficients to "foo.cdf"...'

  call jsystem('rm -f foo.cdf') ! handy "portlib" call...

  call ezspline_save(fs, "foo.cdf", ier, "f", fullsave=.TRUE.); call ckerr
  call ezspline_save(gs, "foo.cdf", ier, "g", fullsave=.TRUE.); call ckerr

  write(6,*) ' free the splines... '

  call ezspline_free(fs,ier); call ckerr
  call ezspline_free(gs,ier); call ckerr

  write(6,*) ' reload splines from file "foo.cdf"...'

  call ezspline_load(fs, "foo.cdf", ier, "f")
  call ezspline_load(gs, "foo.cdf", ier, "g")

  !  evaluate a few points

  call fgeval

  write(6,*) ' test completed.'

  contains

    subroutine fgeval

      write(6,*) ' '
      write(6,*) ' test evaluations... '

      call ezspline_interp(fs, size(xtest), xtest, thtest, phtest, ftest, ier)
      call ckerr

      call ezspline_interp(gs, size(xtest), xtest, thtest, phtest, gtest, ier)
      call ckerr

      !  write them out

      do ix=1,size(xtest)
         write(6,'(1x,i2,". ",5(1x,1pe13.6))') ix, &
              xtest(ix),thtest(ix),phtest(ix),ftest(ix),gtest(ix)
      enddo

      write(6,*) ' '

    end subroutine fgeval

    subroutine ckerr

      if(ier.ne.0) then
         write(6,*) ' ?foo: unexpected error:'
         call ezspline_error(ier)
         call bad_exit
      endif

    end subroutine ckerr

end program ezspline_io_test

subroutine mpi_printenv0

  use mpi_env_mod
  implicit NONE

  !-----------------------------
  !  find current processor ID; write on unit 0
  !-----------------------------

  call mpi_printenv(-1,0)  ! unknown processor ID; write on unit 0

end subroutine mpi_printenv0

subroutine mpi_printenv(iproc_id,ilun)

  use mpi_env_mod
  implicit NONE

  ! display module contents as formatted ASCII written to unit (ilun)
  ! output is for processor #(iproc_id)

  !-------------------------------------
  ! passed:
  integer, intent(in) :: iproc_id  ! (if unknown give a negative value)
  integer, intent(in) :: ilun      ! Fortran I/O unit number for output

  !-------------------------------------
  ! local:
  integer :: i, ilenn,ilenv

  integer :: myid,mpierr
  !-------------------------------------

  myid = iproc_id
  mpierr=0
  if(myid.lt.0) then
#ifdef __MPI
     call MPI_COMM_RANK(mpi_env_comm,myid,mpierr)
#else
     myid=0
#endif
  endif

  write(ilun,'(A)') ' -------------------------------------------- '
  write(ilun,*) 'process_id: ',myid,' mpi_printenv:'

  do i=1,n_active_names

     ilenn = len(trim(mpi_env_names(i)))
     ilenv = len(trim(mpi_env_vals(i)))

     if(ilenn + ilenv.gt.72) then
        write(ilun,'(2x,a," ="/4x,a)') trim(mpi_env_names(i)), &
             trim(mpi_env_vals(i))
     else
        write(ilun,'(2x,a," = ",a)') trim(mpi_env_names(i)), &
             trim(mpi_env_vals(i))
     endif

  enddo

  write(ilun,'(A)') ' end mpi_printenv'
  write(ilun,'(A)') ' ------------------------ '
  write(ilun,'(A)') ' '

end subroutine mpi_printenv

subroutine cmpi_sset_env(cname_in,cvalue_in,ierr)

  ! C callable mpi_sset_env

  use mpi_env_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  BYTE_DECLARE cname_in(*), cvalue_in(*)
  integer, intent(out) :: ierr

  !-------------------------------

  character*(maxlen_name) :: name_in
  character*(maxlen_val) :: value

  !-------------------------------

  call cstring(name_in,cname_in,'2F')  ! cname_in -> name_in
  call cstring(value,cvalue_in,'2F')   ! cvalue_in -> value

  call mpi_sset_env(name_in,value,ierr)

end subroutine cmpi_sset_env

subroutine mpi_sset_env(name_in,value,ierr)

  use mpi_env_mod
  implicit NONE

  ! set environment variable module and in OS

  character*(*), intent(in) :: name_in   ! name
  character*(*), intent(in) :: value     ! value
  integer, intent(out) :: ierr

  !--------------------------------------------------------
  integer :: iertmp,ilen,iadr
  logical :: inew
  !--------------------------------------------------------

  call get_loc_myid
  if(mdebug) write(0,*) ' proc #',loc_myid,' entering mpi_sset_env: ', &
       'name_in,value: ',name_in,' ',value

  call legal_name(name_in,ilen,ierr)
  if(ierr.ne.0) return

  call legal_val(value,ilen,ierr)
  if(ierr.ne.0) return

  call lookup_alloc(name_in,iadr,inew)

  if(.not.inew) then
     if(value(1:ilen).ne.mpi_env_vals(iadr)) then
        inew=.TRUE.
     else
        return
     endif
  endif

  mpi_env_vals(iadr) = value(1:ilen)

  call sset_env(name_in,value(1:ilen),iertmp)

  if(mdebug) write(0,*) ' proc #',loc_myid,' exiting mpi_sset_env: ', &
       'ierr: ',ierr

end subroutine mpi_sset_env

subroutine EZhybrid_init2(spline_o, n1, n2, hspline, ier, &
     BCS1, BCS2)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: n1, n2
  integer, intent(in) :: hspline(2)
  ! ier:
  ! 0=ok
  ! 1=allocation error
  ! 99=something strange happened in EZhybrid_init
  integer, intent(out) :: ier

  integer, intent(in), OPTIONAL :: BCS1(2), BCS2(2)

  integer i, iok, icoeff, idim1, idim2
  logical :: spline_present, hermite_present

  ier = 0

  if(EZspline_allocated(spline_o)) then
     ier = 100  ! allocated already
     return
  else
     call EZspline_preInit(spline_o)
  end if

  spline_o%n1 = n1
  spline_o%n2 = n2

  spline_o%klookup1 = 3    ! default lookup algorithm selection
  spline_o%klookup2 = 3    ! default lookup algorithm selection

  spline_o%isHermite = 0
  spline_o%isLinear = 0
  spline_o%isHybrid = 1
  spline_o%hspline = hspline

  spline_present=.FALSE.
  hermite_present=.FALSE.
  icoeff=1
  do i=1,2
     if(hspline(i).lt.-1) then
        ier=54
     else if(hspline(i).gt.2) then
        ier=54
     else if(hspline(i).eq.1) then
        hermite_present=.TRUE.
        icoeff=icoeff*2
     else if(hspline(i).eq.2) then
        spline_present=.TRUE.
        icoeff=icoeff*2
     end if
  end do
  if((ier.eq.0).and.spline_present.and.hermite_present) ier=55
  if(ier.ne.0) return

  idim1 = n1
  if(hspline(1).eq.-1) idim1 = n1 - 1
  idim2 = n2
  if(hspline(2).eq.-1) idim2 = n2 - 1

  iok = 0
  allocate(spline_o%x1(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%fspl(icoeff,idim1,idim2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1min(idim2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1max(idim2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2min(idim1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2max(idim1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x1pkg(n1, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2pkg(n2, 4), stat=iok)
  if(iok /= 0) ier = 1

  do i = 1, 2

     spline_o%bcval1min(1:idim2) = 0.0_fp
     spline_o%bcval1max(1:idim2) = 0.0_fp
     spline_o%ibctype1(i) = 0
     if(present(BCS1)) then
        select case(BCS1(i))
        case (-1)
           spline_o%ibctype1(i) = -1
        case (0)
           spline_o%ibctype1(i) = 0
        case (1)
           if(hspline(1).le.0) then
              spline_o%ibctype1(i) = 0
              ier = 56
           else
              spline_o%ibctype1(i) = 1
           end if
        case (2)
           if(hspline(1).le.1) then
              spline_o%ibctype1(i) = 0
              ier = 56
           else
              spline_o%ibctype1(i) = 2
           end if
        case default
           ier = 2
           spline_o%ibctype1(i) = 0
        end select
     end if

     spline_o%bcval2min(1:idim1) = 0.0_fp
     spline_o%bcval2max(1:idim1) = 0.0_fp
     spline_o%ibctype2(i) = 0
     if(present(BCS2)) then
        select case(BCS2(i))
        case (-1)
           spline_o%ibctype2(i) = -1
        case (0)
           spline_o%ibctype2(i) = 0
        case (1)
           if(hspline(2).le.0) then
              spline_o%ibctype2(i) = 0
              ier = 56
           else
              spline_o%ibctype2(i) = 1
           end if
        case (2)
           if(hspline(2).le.1) then
              spline_o%ibctype2(i) = 0
              ier = 56
           else
              spline_o%ibctype2(i) = 2
           end if
        case default
           ier = 2
           spline_o%ibctype2(i) = 0
        end select
     end if

  end do

  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     spline_o%ibctype1(1)=-1
     spline_o%ibctype1(2)=-1
  end if
  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     spline_o%ibctype2(1)=-1
     spline_o%ibctype2(2)=-1
  end if

  ! default grid
  spline_o%x1min = 0.0_fp
  spline_o%x1max = 1.0_fp
  if(spline_o%ibctype1(1).eq.-1) spline_o%x1max = ezspline_twopi

  spline_o%x1 = spline_o%x1min + (spline_o%x1max - spline_o%x1min)* &
       & (/ (real(i-1,fp)/real(spline_o%n1-1, fp), i=1,spline_o%n1 ) /)
  spline_o%x2min = 0.0_fp
  spline_o%x2max = 1.0_fp
  if(spline_o%ibctype2(1).eq.-1) spline_o%x2max = ezspline_twopi
  spline_o%x2 = spline_o%x2min + (spline_o%x2max - spline_o%x2min)* &
       & (/ (real(i-1,fp)/real(spline_o%n2-1, fp), i=1,spline_o%n2 ) /)

  spline_o%isReady = 0

  return
end subroutine EZhybrid_init2




subroutine EZhybrid_init3(spline_o, n1, n2, n3, hspline, ier, &
     BCS1, BCS2, BCS3)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: n1, n2, n3
  integer, intent(in) :: hspline(3)
  ! ier:
  ! 0=ok
  ! 1=allocation error
  ! 99=something strange happened in EZhybrid_init
  integer, intent(out) :: ier

  integer, intent(in), OPTIONAL :: BCS1(2), BCS2(2), BCS3(2)

  integer i, iok, icoeff, idim1, idim2, idim3
  logical :: spline_present, hermite_present

  ier = 0

  if(EZspline_allocated(spline_o)) then
     ier = 100  ! allocated already
     return
  else
     call EZspline_preInit(spline_o)
  end if

  spline_o%n1 = n1
  spline_o%n2 = n2
  spline_o%n3 = n3

  spline_o%klookup1 = 3    ! default lookup algorithm selection
  spline_o%klookup2 = 3    ! default lookup algorithm selection
  spline_o%klookup3 = 3    ! default lookup algorithm selection

  spline_o%isHermite = 0
  spline_o%isLinear = 0
  spline_o%isHybrid = 1
  spline_o%hspline = hspline

  spline_present=.FALSE.
  hermite_present=.FALSE.
  icoeff=1
  do i=1,3
     if(hspline(i).lt.-1) then
        ier=54
     else if(hspline(i).gt.2) then
        ier=54
     else if(hspline(i).eq.1) then
        hermite_present=.TRUE.
        icoeff=icoeff*2
     else if(hspline(i).eq.2) then
        spline_present=.TRUE.
        icoeff=icoeff*2
     end if
  end do
  if((ier.eq.0).and.spline_present.and.hermite_present) ier=55
  if(ier.ne.0) return

  idim1 = n1
  if(hspline(1).eq.-1) idim1 = n1 - 1
  idim2 = n2
  if(hspline(2).eq.-1) idim2 = n2 - 1
  idim3 = n3
  if(hspline(3).eq.-1) idim3 = n3 - 1

  iok = 0
  allocate(spline_o%x1(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x3(n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%fspl(icoeff,idim1,idim2,idim3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1min(idim2, idim3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1max(idim2, idim3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2min(idim1, idim3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2max(idim1, idim3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval3min(idim1, idim2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval3max(idim1, idim2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x1pkg(n1, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2pkg(n2, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x3pkg(n3, 4), stat=iok)
  if(iok /= 0) ier = 1

  do i = 1, 2

     spline_o%bcval1min(1:idim2, 1:idim3) = 0.0_fp
     spline_o%bcval1max(1:idim2, 1:idim3) = 0.0_fp
     spline_o%ibctype1(i) = 0
     if(present(BCS1)) then
        select case(BCS1(i))
        case (-1)
           spline_o%ibctype1(i) = -1
        case (0)
           spline_o%ibctype1(i) = 0
        case (1)
           if(hspline(1).le.0) then
              spline_o%ibctype1(i) = 0
              ier = 56
           else
              spline_o%ibctype1(i) = 1
           end if
        case (2)
           if(hspline(1).le.1) then
              spline_o%ibctype1(i) = 0
              ier = 56
           else
              spline_o%ibctype1(i) = 2
           end if
        case default
           ier = 2
           spline_o%ibctype1(i) = 0
        end select
     end if

     spline_o%bcval2min(1:idim1, 1:idim3) = 0.0_fp
     spline_o%bcval2max(1:idim1, 1:idim3) = 0.0_fp
     spline_o%ibctype2(i) = 0
     if(present(BCS2)) then
        select case(BCS2(i))
        case (-1)
           spline_o%ibctype2(i) = -1
        case (0)
           spline_o%ibctype2(i) = 0
        case (1)
           if(hspline(2).le.0) then
              spline_o%ibctype2(i) = 0
              ier = 56
           else
              spline_o%ibctype2(i) = 1
           end if
        case (2)
           if(hspline(2).le.1) then
              spline_o%ibctype2(i) = 0
              ier = 56
           else
              spline_o%ibctype2(i) = 2
           end if
        case default
           ier = 2
           spline_o%ibctype2(i) = 0
        end select
     end if

     spline_o%bcval3min(1:idim1, 1:idim2) = 0.0_fp
     spline_o%bcval3max(1:idim1, 1:idim2) = 0.0_fp
     spline_o%ibctype3(i) = 0
     if(present(BCS3)) then
        select case(BCS3(i))
        case (-1)
           spline_o%ibctype3(i) = -1
        case (0)
           spline_o%ibctype3(i) = 0
        case (1)
           if(hspline(3).le.0) then
              spline_o%ibctype3(i) = 0
              ier = 2
           else
              spline_o%ibctype3(i) = 1
           end if
        case (2)
           if(hspline(3).le.1) then
              spline_o%ibctype3(i) = 0
              ier = 2
           else
              spline_o%ibctype3(i) = 2
           end if
        case default
           ier = 2
           spline_o%ibctype3(i) = 0
        end select
     end if

  end do

  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     spline_o%ibctype1(1)=-1
     spline_o%ibctype1(2)=-1
  end if
  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     spline_o%ibctype2(1)=-1
     spline_o%ibctype2(2)=-1
  end if
  if(spline_o%ibctype3(1)==-1 .OR. spline_o%ibctype3(2)==-1) then
     spline_o%ibctype3(1)=-1
     spline_o%ibctype3(2)=-1
  end if

  ! default grid
  spline_o%x1min = 0.0_fp
  spline_o%x1max = 1.0_fp
  if(spline_o%ibctype1(1).eq.-1) spline_o%x1max = ezspline_twopi
  spline_o%x1 = spline_o%x1min + (spline_o%x1max - spline_o%x1min)* &
       & (/ (real(i-1,fp)/real(spline_o%n1-1, fp), i=1,spline_o%n1 ) /)

  spline_o%x2min = 0.0_fp
  spline_o%x2max = 1.0_fp
  if(spline_o%ibctype2(1).eq.-1) spline_o%x2max = ezspline_twopi
  spline_o%x2 = spline_o%x2min + (spline_o%x2max - spline_o%x2min)* &
       & (/ (real(i-1,fp)/real(spline_o%n2-1, fp), i=1,spline_o%n2 ) /)

  spline_o%x3min = 0.0_fp
  spline_o%x3max = 1.0_fp
  if(spline_o%ibctype3(1).eq.-1) spline_o%x3max = ezspline_twopi
  spline_o%x3 = spline_o%x3min + (spline_o%x3max - spline_o%x3min)* &
       & (/ (real(i-1,fp)/real(spline_o%n3-1, fp), i=1,spline_o%n3 ) /)

  spline_o%isReady = 0

  return
end subroutine EZhybrid_init3

subroutine dnherm1(x,nx,fherm,ilinx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on simple
  !  numerical differentiation using the given grid.
  !
  !  1d routine
  !
  !  input:
  !
  !============
  implicit none
  integer ier,ilinx,ix,ixp,ixm
  !============
  real(fp) :: ztol,zd
  !============
  integer nx                        ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: fherm(0:1,nx)                ! data/Hermite array
  !
  !  fherm(0,i) = function value f at x(i)       **on input**
  !
  !  fherm(1,i) = derivative df/dx at x(i)       **on output**
  !
  ! addl output:
  !  ilinx=1 if x is "evenly spaced" ier=0 if no errors
  !
  !  ** x must be strict ascending **
  !
  !----------------------------
  !
  ztol=1.0E-3_fp
  call splinck(x,nx,ilinx,ztol,ier)
  if(ier.ne.0) then
     write(6,*) '?dnherm1:  x axis not strict ascending.'
     return
  end if
  !
  do ix=1,nx
     !
     !  x div. diffs in vicinity
     !
     ixp=min(nx,ix+1)
     ixm=max(1,ix-1)
     zd=(fherm(0,ixp)-fherm(0,ixm))/(x(ixp)-x(ixm))
     !
     fherm(1,ix)=zd
  end do
  !
  return
end subroutine dnherm1

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Member setters

#include "cpp/czspline_handle_size.h"

  ! x1, x2, x3
#define _S czspline_set_axes1
#define _O czspline1
  subroutine _S(handle, k1, x1, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: k1
    real(fp), intent(in) :: x1(k1)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % x1 = x1
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_axes2
#define _O czspline2
  subroutine _S(handle, k1, k2, x1, x2, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: k1, k2
    real(fp), intent(in) :: x1(k1), x2(k2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % x1 = x1
    self % ptr % x2 = x2
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_axes3
#define _O czspline3
  subroutine _S(handle, k1, k2, k3, x1, x2, x3, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: k1, k2, k3
    real(fp), intent(in) :: x1(k1), x2(k2), x3(k3)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % x1 = x1
    self % ptr % x2 = x2
    self % ptr % x3 = x3
  end subroutine _S
#undef _S
#undef _O

  ! isHermite
#define _S czspline_set_ishermite1
#define _O czspline1
  subroutine _S(handle, flag, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: flag
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % isHermite = flag
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_ishermite2
#define _O czspline2
  subroutine _S(handle, flag, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: flag
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % isHermite = flag
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_ishermite3
#define _O czspline3
  subroutine _S(handle, flag, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)  :: flag
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % isHermite = flag
  end subroutine _S
#undef _S
#undef _O

  ! Boundary types
#define _S czspline_set_bctypes1
#define _O czspline1
  subroutine _S(handle, bctype1, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)    :: bctype1(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % ibctype1 = bctype1
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_bctypes2
#define _O czspline2
  subroutine _S(handle, bctype1, bctype2, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)    :: bctype1(2), bctype2(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % ibctype1 = bctype1
    self % ptr % ibctype2 = bctype2
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_bctypes3
#define _O czspline3
  subroutine _S(handle, bctype1, bctype2, bctype3, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in)    :: bctype1(2), bctype2(2), bctype3(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % ibctype1 = bctype1
    self % ptr % ibctype2 = bctype2
    self % ptr % ibctype3 = bctype3
  end subroutine _S
#undef _S
#undef _O

  ! Boundary conditions bcval1min, bcval1max, ...
#define _S czspline_set_bcvals1
#define _O czspline1
  subroutine _S(handle, bcval1, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in)   :: bcval1(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % bcval1min = bcval1(1)
    self % ptr % bcval1max = bcval1(2)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_bcvals2
#define _O czspline2
  subroutine _S(handle, bcval1, bcval2, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in)   :: bcval1(2), bcval2(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % bcval1min = bcval1(1)
    self % ptr % bcval1max = bcval1(2)
    self % ptr % bcval2min = bcval2(1)
    self % ptr % bcval2max = bcval2(2)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_set_bcvals3
#define _O czspline3
  subroutine _S(handle, bcval1, bcval2, bcval3, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in)   :: bcval1(2), bcval2(2), bcval3(2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    ier = 0
    self % ptr % bcval1min = bcval1(1)
    self % ptr % bcval1max = bcval1(2)
    self % ptr % bcval2min = bcval2(1)
    self % ptr % bcval2max = bcval2(2)
    self % ptr % bcval3min = bcval3(1)
    self % ptr % bcval3max = bcval3(2)
  end subroutine _S
#undef _S
#undef _O

!
! ------------ get_fortran_const ----------
! Return the current fortran's concept of .true. and .false.
! For use by a C routine.
!
subroutine get_fortran_const(ftrue, ffalse)
  implicit none

  logical :: ftrue   ! fortran true
  logical :: ffalse  ! fortran false

  ftrue  = .true.
  ffalse = .false.
end subroutine get_fortran_const

subroutine mkspl2z(fun,x,nx,th,nth,fspl,nf2,wk,inwk, &
     ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a bicubic periodic spline with knots at grid points and
  !  function values from the callable function `fun' passed.
  !
  !  use bpspline to setup the spline coefficients
  !
  !============
  implicit none
  integer nth,nf2,inwk,nx,ix,ith
  !============
  real(fp) :: fun,zdummy
  !============
  external fun                      ! passed real function(x,th)
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: th(nth)                      ! th coordinate array
  !
  !  output:
  !
  real(fp) :: fspl(4,nf2,nth)              ! function data / spline coeff array
  real(fp) :: wk(inwk)                     ! workspace -- at least 5*max(nx,nth)
  !
  integer ilinx                     ! output =1 if x(1...nx) evenly spaced
  integer ilinth                    ! output =1 if th(1..nth) evenly spaced
  !
  integer ier                       ! completion code from bpspline 0=OK
  !
  !----------------------------
  !
  ier=0
  if(nf2.lt.nx) then
     write(6,'('' ?mkspl2p -- array dim error, nf2.lt.nx'')')
     ier=1
  end if
  !
  do ix=1,nx
     do ith=1,nth
        fspl(1,ix,ith)=fun(x(ix),th(ith))
     end do
  end do
  !
  call mkbicubw(x,nx,th,nth,fspl,nf2, &
       0,zdummy,0,zdummy,-1,zdummy,-1,zdummy, &
       wk,inwk,ilinx,ilinth,ier)
  !
  return
end subroutine mkspl2z

subroutine vecpc1(ict,ivec,xvec,ivd,fval,nx,xpkg,fspl, &
     iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  vectorized piecewise linear evaluation routine -- 1d
  !  1.  call vectorized zone lookup routine
  !  2.  call vectorized piecewise linear evaluation routine
  !
  !     note -- derivatives are *not* continuous
  !
  !--------------------------
  !  input:
  implicit none
  integer ict(2)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate if ict(1)=0)
  !        ict(2)=1 for df/dx  (don't evaluate if ict(2)=0)
  !
  integer ivec                      ! vector dimensioning
  !
  !    ivec-- number of vector pts (piecewise linear values to look up)
  !
  real(fp) :: xvec(ivec)                   ! x-locations at which to evaluate
  !
  integer ivd                       ! 1st dimension of output array
  !
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                  ! output array
  !
  !  fval(1:ivec,1) -- values as per 1st non-zero ict(...) element
  !  fval(1:ivec,2) -- values as per 2nd non-zero ict(...) element
  !   --etc--
  !
  ! input:
  integer nx                        ! dimension of x grid
  real(fp) :: xpkg(nx,4)                   ! x grid "package" (cf genxpkg)
  real(fp) :: fspl(nx)                     ! Piecewise Linear function
  !
  ! output:
  ! condition codes, 0 = normal return
  integer iwarn                     ! =1 if an x value was out of range
  integer ier                       ! =1 if argument error detected
  !
  !---------------------------------------------------------------
  !  local arrays
  !
  integer iv(ivec)                  ! zone indices {j}
  real(fp) :: dxn(ivec)                    ! normalized displacements w/in zones
  real(fp) :: h(ivec)                      ! h(j) vector
  real(fp) :: hi(ivec)                     ! 1/h(j) vector
  !
  !---------------------------------------------------------------
  !
  !  error checks
  !
  ier=0
  !
  if(ivec.le.0) then
     write(6,*) ' ?vecpc1:  vector dimension .le. 0:  ivec = ', &
          ivec
     ier=1
  end if
  !
  if(ivd.lt.ivec) then
     write(6,*) &
          ' ?vecpc1:  output vector dimension less than input ', &
          'vector dimension.'
     write(6,*) ' ivec=',ivec,' ivd=',ivd
     ier=1
  end if
  !
  if(ier.ne.0) return
  !
  !  vectorized lookup
  !
  iv=0
  call xlookup(ivec,xvec,nx,xpkg,2,iv,dxn,h,hi,iwarn)
  !
  !  vectorized evaluation
  !
  call pc1fcn(ict,ivec,ivd,fval,iv,dxn,h,hi,fspl,nx)
  !
  return
end subroutine vecpc1

subroutine pc1ev(xget,x,nx,ilinx,f,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a 1d piecewise linear interpolant -- this is C0.
  !    ...a derivative can be evaluated but it is not continuous.
  !
  !  this subroutine calls two subroutines:
  !     herm1x   -- find cell containing (xget,yget)
  !     pc1fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer nx
  !============
  real(fp) :: xget                         ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  !
  real(fp) :: f(nx)                        ! function data
  !
  !       contents of f:
  !
  !  f(i) = f @ x(i)
  !
  integer ict(2)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1]
  !   on output fval= [f,df/dx]
  !
  !    on input ict = [1,0]
  !   on output fval= [f] ... element 2 never referenced
  !
  !    on input ict = [0,1]
  !   on output fval= [df/dx] ... element 2 never referenced
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i=0                         ! cell index
  !
  !  normalized displacement from (x(i)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !
  real(fp), dimension(1) :: xparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i))
  !
  real(fp), dimension(1) :: hx
  real(fp), dimension(1) :: hxi
  !
  !  0 .le. xparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm1x(xget,x,nx,ilinx,i(1),xparam(1),hx(1),hxi(1),ier)
  if(ier.ne.0) return
  !
  call pc1fcn(ict,1,1,fval,i,xparam,hx,hxi,f,nx)
  !
  return
end subroutine pc1ev
!---------------------------------------------------------------------
!  evaluate C0 piecewise linear function interpolation -- 1d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine pc1fcn(ict,ivec,ivecd, &
     fval,ii,xparam,hx,hxi,fin,nx)
  use iso_c_binding, only: fp => c_double
  !
  !  input:
  !
  !============
  implicit none
  integer nx,i,iadr
  !============
  real(fp) :: xp,xpi
  !============
  integer ict(2)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec)                  ! target cells
  real(fp) :: xparam(ivec)
  ! normalized displacements in cells
  !
  real(fp) :: hx(ivec)                     ! grid spacing, and
  real(fp) :: hxi(ivec)                    ! inverse grid spacing 1/(x(i+1)-x(i))
  !
  real(fp) :: fin(nx)                      ! the data
  !
  !  output:
  !
  real(fp) :: fval(ivecd,*)                ! interpolation results
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  pc1ev comments.  Note ict is not vectorized -- the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii, and parameter inputs
  !     xparam,hx,hxi,are vectorized, and the
  !
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument; ivecd.ge.ivec
  !     expected!
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !
  integer v
  !
  do v=1,ivec
     i=ii(v)
     xp=xparam(v)
     xpi=1.0_fp-xp
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        fval(v,iadr)=xpi*fin(i)+xp*fin(i+1)
        !
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        fval(v,iadr)=(fin(i+1)-fin(i))*hxi(v)
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine pc1fcn

module EZspline_type
  use iso_c_binding, only: fp => c_double

  real(fp), parameter :: ezspline_twopi = 6.2831853071795865_fp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! EZspline data types
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  type EZspline3
    !
    ! 3-d Spline/Akima Hermite/Piecewise Linear interpolations
    !
    ! Grid
    !
    real(fp), dimension(:), allocatable :: x1, x2, x3
    !
    ! The boundary condition values (for slope and 2nd derivative).
    ! Can be optionally set by the user. Not used for periodic and
    ! not a knot boundary conditions.
    !
    real(fp), dimension(:,:), allocatable :: bcval1min, bcval1max
    real(fp), dimension(:,:), allocatable :: bcval2min, bcval2max
    real(fp), dimension(:,:), allocatable :: bcval3min, bcval3max
    !
    ! Select between spline (0) and Akima spline (1); default=0 (spline)
    !
    integer :: isHermite  ! set after EZspline_init call...
    !
    ! set =0 for Spline, Akima or Hybrid; =1 for piecewise linear: this is set
    ! by EZspline_init, EZhybrid_init, or EZlinear_init; DO NOT SET DIRECTLY:
    !
    integer :: isLinear
    !
    ! set =0 by init routines other than EZhybrid_init which sets it =1:
    integer :: isHybrid
    !
    ! the following is set by EZhybrid_init; other EZ*_init routines clear:
    integer :: hspline(3)  ! interpolation code along each dimension
    !        -1: zonal step fcn; =0: pc linear; =1: Akima Hermite; =2: Spline
    !
    ! Grid sizes (set during EZ*_init call).
    !
    integer :: n1, n2, n3
    !
    ! Grid zone lookup method
    !
    integer :: klookup1,klookup2,klookup3
    !
    ! Type of boundary conditions (set during EZspline_init call) on left
    ! and right hand side. Possible values are:
    !
    ! -1 periodic
    ! 0 not a knot
    ! +1 1st derivative imposed
    ! +2 2nd derivative imposed
    !
    ! For instance, ibctype1 =(/1, 0/) for 1st derivative set on left-hand
    ! and not a knot boundary conditions on right-hand side. The values of
    ! the derivatives a set via  bcval1min. (See above.)
    !
    integer ibctype1(2), ibctype2(2), ibctype3(2)
    !
    ! Grid lengths. DO NOT SET.
    !
    real(fp) :: x1min, x1max, x2min, x2max, x3min, x3max
    !
    ! Compact cubic coefficient arrays. DO NOT SET.
    !
    real(fp), dimension(:,:,:,:), allocatable :: fspl
    !
    ! Control/Other. DO NOT SET.
    !
    integer :: isReady

    integer :: ilin1, ilin2, ilin3
    real(fp), dimension(:,:), allocatable :: x1pkg, x2pkg, x3pkg
    !
    integer :: nguard
  end type EZspline3

  type EZspline2
    !
    ! 2-d Spline/Akima Hermite/Piecewise Linear interpolation
    !
    ! Grid
    !
    real(fp), dimension(:), allocatable :: x1, x2
    !
    ! The boundary condition values (for slope and 2nd derivative).
    ! Can be optionally set by the user. Not used for periodic and
    ! not a knot boundary conditions.
    !
    real(fp), dimension(:), allocatable :: bcval1min, bcval1max
    real(fp), dimension(:), allocatable :: bcval2min, bcval2max
    !
    ! Select between spline (0) and Akima spline (1); default=0 (spline)
    !
    integer :: isHermite  ! set after EZspline_init call...
    !
    ! set =0 for Spline, Akima or Hybrid; =1 for piecewise linear: this is set
    ! by EZspline_init, EZhybrid_init, or EZlinear_init; DO NOT SET DIRECTLY:
    !
    integer :: isLinear
    !
    ! set =0 by init routines other than EZhybrid_init which sets it =1:
    integer :: isHybrid
    !
    ! the following is set by EZhybrid_init; other EZ*_init routines clear:
    integer :: hspline(2)  ! interpolation code along each dimension
    !        -1: zonal step fcn; =0: pc linear; =1: Akima Hermite; =2: Spline
    !
    ! Grid sizes (set during EZ*_init call).
    !
    integer :: n1, n2
    !
    ! Grid zone lookup method
    !
    integer :: klookup1,klookup2
    !
    ! Type of boundary conditions (set during EZspline_init call) on left
    ! and right hand side. Possible values are:
    !
    ! -1 periodic
    ! 0 not a knot
    ! +1 1st derivative imposed
    ! +2 2nd derivative imposed
    !
    ! For instance, ibctype1 =(/1, 0/) for 1st derivative set on left-hand
    ! and not a knot boundary conditions on right-hand side. The values of
    ! the derivatives are set via  bcval1min. (See above)
    !
    integer ibctype1(2), ibctype2(2)
    !
    ! Grid lengths. DO NOT SET.
    !
    real(fp) :: x1min, x1max, x2min, x2max
    !
    ! Compact cubic coefficient arrays. DO NOT SET.
    !
    real(fp), dimension(:,:,:), allocatable :: fspl
    !
    ! Control/Other. DO NOT SET.
    !
    integer :: isReady

    integer :: ilin1, ilin2
    real(fp), dimension(:,:), allocatable :: x1pkg, x2pkg
    !
    integer :: nguard
  end type EZspline2

  type EZspline1
    !
    ! 1-d Spline/Akima Hermite/Piecewise Linear interpolation
    !
    ! Grid
    !
    real(fp), dimension(:), allocatable :: x1
    !
    ! The boundary condition values (for slope and 2nd derivative).
    ! Can be optionally set by the user. Not used for periodic and
    ! not a knot boundary conditions.
    !
    real(fp) :: bcval1min, bcval1max
    !
    ! Select between spline (0) and Akima spline (1); default=0 (spline)
    !
    integer :: isHermite  ! set after EZspline_init call...
    !
    ! set =0 for Spline or Akima; =1 for piecewise linear: this is set
    ! by EZspline_init or EZlinear_init; DO NOT SET DIRECTLY:
    !
    integer :: isLinear
    !
    ! Grid sizes (set during EZ*_init call).
    !
    integer :: n1
    !
    ! Grid zone lookup method
    !
    integer :: klookup1
    !
    ! Type of boundary conditions (set during EZspline_init call) on left
    ! and right hand side. Possible values are:
    !
    ! -1 periodic
    ! 0 not a knot
    ! +1 1st derivative imposed
    ! +2 2nd derivative imposed
    !
    ! For instance, ibctype1 =(/1, 0/) for 1st derivative set on left-hand
    ! and not a knot boundary conditions on right-hand side. The values of
    ! the derivatives are set via  bcval1min. (See above)
    !
    integer ibctype1(2)
    !
    ! Grid lengths. DO NOT SET.
    !
    real(fp) :: x1min, x1max
    !
    ! Compact cubic coefficient arrays. DO NOT SET.
    !
    real(fp), dimension(:,:), allocatable :: fspl
    !
    ! Control/Other. DO NOT SET.
    !
    integer :: isReady

    integer :: ilin1
    real(fp), dimension(:,:), allocatable :: x1pkg
    !
    integer :: nguard
  end type EZspline1

  !=========================================================================
  ! End type
end module EZspline_type

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! EZspline reflective methods (first argument is an EZspline1,2,3 type).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module EZspline_obj
  use iso_c_binding, only: fp => c_double
  use Ezspline_type
  interface EZspline_preInit
    !
    ! usage:  call EZspline_preinit(spline_o)
    !   ...where spline_o is a 1d, 2d, or 3d spline object.

    module procedure &
         EZspline_preInit1, &
         EZspline_preInit2, &
         EZspline_preInit3

  end interface

  interface EZspline_allocated
    ! logical function returns TRUE if allocated, FALSE otherwise
    !
    ! usage:  
    !   logical :: answer
    !   answer = EZspline_allocated(spline_o)
    !   ...where spline_o is a 1d, 2d, or 3d spline object.

    module procedure &
         EZspline_allocated1, &
         EZspline_allocated2, &
         EZspline_allocated3
  end interface

contains

  subroutine EZspline_preInit1(spline_o)
    use EZspline_type
    type(EZspline1) :: spline_o
    spline_o%nguard=123456789
    spline_o%isReady=0
    spline_o%ibctype1=0 
  end subroutine EZspline_preInit1

  subroutine EZspline_preInit2(spline_o)
    use EZspline_type
    type(EZspline2) :: spline_o
    spline_o%nguard=123456789
    spline_o%isReady=0
    spline_o%ibctype1=0 ; spline_o%ibctype2=0
  end subroutine EZspline_preInit2

  subroutine EZspline_preInit3(spline_o)
    use EZspline_type
    type(EZspline3) spline_o
    spline_o%nguard=123456789
    spline_o%isReady=0
    spline_o%ibctype1=0 ; spline_o%ibctype2=0 ; spline_o%ibctype3=0
  end subroutine EZspline_preInit3

  logical function EZspline_allocated1(spline_o)
    use EZspline_type
    type(EZspline1) spline_o
    EZspline_allocated1 = allocated(spline_o%fspl) &
         & .and. allocated(spline_o%x1) .and. allocated(spline_o%x1pkg) &
         & .and. (spline_o%nguard == 123456789) ! check that ezspline_init has been called
  end function EZspline_allocated1

  logical function EZspline_allocated2(spline_o)
    use EZspline_type
    type(EZspline2) spline_o
    EZspline_allocated2 = allocated(spline_o%fspl) &
         & .and. allocated(spline_o%x1) .and. allocated(spline_o%x1pkg) &
         & .and. allocated(spline_o%x2) .and. allocated(spline_o%x2pkg) &
         & .and. (spline_o%nguard == 123456789) ! check that ezspline_init has been called
  end function EZspline_allocated2

  logical function EZspline_allocated3(spline_o)
    use ezspline_type
    type(EZspline3) spline_o
    EZspline_allocated3 = allocated(spline_o%fspl) &
         & .and. allocated(spline_o%x1) .and. allocated(spline_o%x1pkg) &
         & .and. allocated(spline_o%x2) .and. allocated(spline_o%x2pkg) &
         & .and. allocated(spline_o%x3) .and. allocated(spline_o%x3pkg) &
         & .and. (spline_o%nguard == 123456789) ! check that ezspline_init has been called
  end function EZspline_allocated3

  subroutine ezmake_ict1(i,ict)
    !  (private utility for ezspline derivative2 subroutines)
    !  make ict(1:6) array
    !  for higher derivatives; d[i1+i2]f/dx[i1]dy[i2]
    !  expecting i in range [0:3] (NOT CHECKED)

    implicit NONE
    integer, intent(in) :: i
    integer, intent(out) :: ict(3)

    if(i.eq.0) then
      ict = (/1, 0, 0 /) ! seek f @ (p1)
    else if(i.eq.1) then
      ict = (/0, 1, 0 /) ! df/dx
    else if(i.eq.2) then
      ict = (/0, 0, 1 /) ! d2f/dx2
    else
      ict = (/3, 0, 0 /) ! d3f/dx3
    end if

  end subroutine ezmake_ict1

  subroutine ezmake_ict2(i1,i2,ict)
    !  (private utility for ezspline derivative2 subroutines)
    !  make ict(1:6) array
    !  for higher derivatives; d[i1+i2]f/dx[i1]dy[i2]
    !  expecting i1 & i2 in range [0:3] (NOT CHECKED)

    implicit NONE
    integer, intent(in) :: i1,i2
    integer, intent(out) :: ict(6)

    integer :: imark,isum,iii

    !  this generates the control argument needed by evbicub & similar
    !  routines...
    !----------------------

    isum = i1+i2
    ict(1)=isum

    imark=0

    if(isum.eq.0) then
      ict = (/1, 0, 0, 0, 0, 0 /) ! seek f @ (p1, p2, p3)
    else if(isum.eq.1) then
      if(i1.eq.1) then
        ict = (/0, 1, 0, 0, 0, 0 /) ! df/dx
      else
        ict = (/0, 0, 1, 0, 0, 0 /) ! df/dy
      end if
    else if(isum.eq.2) then
      if(i1.eq.2) then
        ict = (/0, 0, 0, 1, 0, 0 /) ! d2f/dx2
      else if(i2.eq.2) then
        ict = (/0, 0, 0, 0, 1, 0 /) ! d2f/dy2
      else
        ict = (/0, 0, 0, 0, 0, 1 /) ! d2f/dxdy
      end if
    else if(isum.eq.3) then
      if(i1.eq.3) then
        imark=2  ! fxxx
      else if(i1.eq.2) then
        imark=3  ! fxxy
      else if(i1.eq.1) then
        imark=4  ! fxyy
      else
        imark=5  ! fyyy
      end if
    else if(isum.eq.4) then
      if(i1.eq.3) then
        imark=2  ! fxxxy
      else if(i2.eq.3) then
        imark=4  ! fxyyy
      else
        imark=3  ! fxxyy
      end if
    else if(isum.eq.5) then
      if(i1.eq.3) then
        imark=2  ! fxxxyy
      else if(i2.eq.3) then
        imark=3  ! fxxyyy
      end if
    end if

    !  isum=6 --> fxxxyyy

    if(isum.gt.2) then
      do iii=2,6
        if(iii.eq.imark) then
          ict(iii)=1
        else
          ict(iii)=0
        end if
      end do
    end if

  end subroutine ezmake_ict2

  subroutine ezmake_ict3(i1,i2,i3,ict)
    !  (private utility for ezspline derivative3 subroutines)
    !  make ict(1:10) array
    !  for higher derivatives; d[i1+i2+i3]f/dx[i1]dy[i2]dz[i3]
    !  i1 & i2 & i3 in range [0:3] (NOT CHECKED)

    implicit NONE
    integer, intent(in) :: i1,i2,i3
    integer, intent(out) :: ict(10)

    integer :: imark,isum,iii

    !  this generates the control argument needed by evtricub & similar
    !  routines...
    !----------------------

    isum = i1+i2+i3
    if(max(i1,i2,i3).eq.3) then
      isum=-isum
    end if
    ict(1)=isum

    imark=0

    if(isum.eq.0) then
      ict = (/1, 0, 0, 0, 0, 0, 0, 0, 0, 0 /) ! seek f @ (p1, p2, p3)

    else if(isum.eq.1) then
      !  1st derivatives
      if(i1.eq.1) then
        ict = (/0, 1, 0, 0, 0, 0, 0, 0, 0, 0 /)  ! df/dx
      else if(i2.eq.1) then
        ict = (/0, 0, 1, 0, 0, 0, 0, 0, 0, 0 /)  ! df/dy
      else
        ict = (/0, 0, 0, 1, 0, 0, 0, 0, 0, 0 /)  ! df/dz
      end if

    else if(isum.eq.2) then
      !  2nd derivatives -- legacy ordering; x-precedence ordering for all
      !  higher derivatives...

      if(i1.eq.2) then
        ict = (/0, 0, 0, 0, 1, 0, 0, 0, 0, 0 /)  ! d2f/dx2
      else if(i2.eq.2) then
        ict = (/0, 0, 0, 0, 0, 1, 0, 0, 0, 0 /)  ! d2f/dy2
      else if(i3.eq.2) then
        ict = (/0, 0, 0, 0, 0, 0, 1, 0, 0, 0 /)  ! d2f/dz2
      else if(i3.eq.0) then
        ict = (/0, 0, 0, 0, 0, 0, 0, 1, 0, 0 /)  ! d2f/dxdy
      else if(i2.eq.0) then
        ict = (/0, 0, 0, 0, 0, 0, 0, 0, 1, 0 /)  ! d2f/dxdz
      else
        ict = (/0, 0, 0, 0, 0, 0, 0, 0, 0, 1 /)  ! d2f/dydz
      end if

    else if(isum.eq.3) then
      !  3rd derivative, continuous: max(i1,i2,i3)<3
      if(i1.eq.2) then
        if(i2.eq.1) then
          imark=2     ! fxxy
        else
          imark=3     ! fxxz
        end if
      else if(i1.eq.1) then
        if(i2.eq.2) then
          imark=4     ! fxyy
        else if(i2.eq.1) then
          imark=5     ! fxyz
        else
          imark=6     ! fxzz
        end if
      else
        if(i2.eq.2) then
          imark=7     ! fyyz
        else
          imark=8     ! fyzz
        end if
      end if

    else if(isum.eq.-3) then
      !  3rd derivative
      if(i1.eq.3) then
        imark=2        ! fxxx
      else if(i2.eq.3) then
        imark=3        ! fyyy
      else if(i3.eq.3) then
        imark=4        ! fzzz
      end if

    else if(isum.eq.4) then
      !  4th derivative, continuous: max(i1,i2,i3)<3
      if(i1.eq.2) then
        if(i2.eq.2) then
          imark=2     ! fxxyy
        else if(i2.eq.1) then
          imark=3     ! fxxyz
        else
          imark=4     ! fxxzz
        end if
      else if(i1.eq.1) then
        if(i2.eq.2) then
          imark=5     ! fxyyz
        else
          imark=6     ! fxyzz
        end if
      else
        imark=7        ! fyyzz
      end if

    else if(isum.eq.-4) then
      !  4th derivative
      if(i1.eq.3) then
        if(i2.eq.1) then
          imark=2     ! fxxxy
        else
          imark=3     ! fxxxz
        end if
      else if(i1.eq.1) then
        if(i2.eq.3) then
          imark=4     ! fxyyy
        else
          imark=5     ! fxzzz
        end if
      else
        if(i2.eq.3) then
          imark=6     ! fyyyz
        else
          imark=7     ! fyzzz
        end if
      end if

    else if(isum.eq.5) then
      !  5th derivative, continuous: max(i1,i2,i3)<3
      if(i3.eq.1) then
        imark=2     ! fxxyyz
      else if(i2.eq.1) then
        imark=3     ! fxxyzz
      else
        imark=4     ! fxyyzz
      end if

    else if(isum.eq.-5) then
      !  5th derivative
      if(i1.eq.3) then
        if(i2.eq.2) then
          imark=2  ! fxxxyy
        else if(i2.eq.1) then
          imark=3  ! fxxxyz
        else
          imark=4  ! fxxxzz
        end if
      else if(i1.eq.2) then
        if(i2.eq.3) then
          imark=5  ! fxxyyy
        else
          imark=6  ! fxxzzz
        end if
      else if(i1.eq.1) then
        if(i2.eq.3) then
          imark=7  ! fxyyyz
        else
          imark=8  ! fxyzzz
        end if
      else
        if(i2.eq.3) then
          imark=9  ! fyyyzz
        else
          imark=10 ! fyyzzz
        end if
      end if

      !  isum=6 --> fxxyyzz  (i1=i2=i3=2)
    else if(isum.eq.-6) then
      !  6th derivative
      if(i1.eq.3) then
        if(i2.eq.3) then
          imark=2  ! fxxxyyy
        else if(i2.eq.2) then
          imark=3  ! fxxxyyz
        else if(i2.eq.1) then
          imark=4  ! fxxxyzz
        else
          imark=5  ! fxxxzzz
        end if
      else if(i1.eq.2) then
        if(i2.eq.3) then
          imark=6  ! fxxyyyz
        else if(i2.eq.1) then
          imark=7  ! fxxyzzz
        end if
      else if(i1.eq.1) then
        if(i2.eq.3) then
          imark=8  ! fxyyyzz
        else
          imark=9  ! fxyyzzz
        end if
      else
        imark=10    ! fyyyzzz
      end if

      !  isum=7 not possible
    else if(isum.eq.-7) then
      !  7th derivative
      if(i1.eq.3) then
        if(i2.eq.3) then
          imark=2  ! fxxxyyyz
        else if(i2.eq.2) then
          imark=3  ! fxxxyyzz
        else
          imark=4  ! fxxxyzzz
        end if
      else if(i1.eq.2) then
        if(i2.eq.3) then
          imark=5  ! fxxyyyzz
        else
          imark=6  ! fxxyyzzz
        end if
      else
        imark=7     ! fxyyyzzz
      end if

      !  isum=8 not possible
    else if(isum.eq.-8) then
      !  8th derivative
      if(i3.eq.2) then 
        imark=2  ! fxxxyyyzz
      else if(i2.eq.2) then
        imark=3  ! fxxxyyzzz
      else
        imark=4  ! fxxyyyzzz
      end if

      !  isum=9 not possible
      !  isum=-9 --> fxxxyyyzzz

    end if

    if(abs(isum).gt.2) then
      do iii=2,10
        if(iii.eq.imark) then
          ict(iii)=1
        else
          ict(iii)=0
        end if
      end do
    end if

  end subroutine ezmake_ict3

end module EZspline_obj

!=======================================================================

module EZspline
  use iso_c_binding, only: fp => c_double

  interface EZspline_init
    !
    ! Initialize and allocate memory. BCS1,2,3 determine the type of boundary
    ! conditions on either end of the x1,2,3 grids: eg (/0, 0/) for not-a-knot
    ! on the left and (/-1, -1/) periodic. Other BCs such as imposed slope or
    ! second derivative can also be applied by setting '1' or '2' respectively
    ! on either side. For instance (/1, 2/) for 1st derivative on the left and
    ! 2nd derivative on the right. The value of the 1st/2nd derivative must be
    ! set explicitely set through the bcval1,2,3min and bcval1,2,3max arrays.
    !
    subroutine EZspline_init3(spline_o, n1, n2, n3, BCS1, BCS2, BCS3, ier)
      use EZspline_obj
      type(EZspline3) :: spline_o
      integer, intent(in) :: n1, n2, n3
      integer, intent(in) :: BCS1(2), BCS2(2), BCS3(2)
      integer, intent(out) :: ier
    end subroutine EZspline_init3

    subroutine EZspline_init2(spline_o, n1, n2, BCS1, BCS2, ier)
      use EZspline_obj
      type(EZspline2) :: spline_o
      integer, intent(in) :: n1, n2
      integer, intent(in) :: BCS1(2), BCS2(2)
      integer, intent(out) :: ier
    end subroutine EZspline_init2

    subroutine EZspline_init1(spline_o, n1, BCS1, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(in) :: n1
      integer, intent(in) :: BCS1(2)
      integer, intent(out) :: ier
    end subroutine EZspline_init1

  end interface


  interface EZlinear_init
    !
    ! Initialize and allocate memory for piecewise LINEAR interpolation
    ! object.  This is C0.  For C2 cubic spline or C1 Akima Hermite spline,
    ! please see EZspline_init.
    !
    ! No boundary conditions are needed for piecewise linear interpolation
    !
    subroutine EZlinear_init3(spline_o, n1, n2, n3, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: n1, n2, n3
      integer, intent(out) :: ier
    end subroutine EZlinear_init3

    subroutine EZlinear_init2(spline_o, n1, n2, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: n1, n2
      integer, intent(out) :: ier
    end subroutine EZlinear_init2

    subroutine EZlinear_init1(spline_o, n1, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(in) :: n1
      integer, intent(out) :: ier
    end subroutine EZlinear_init1

  end interface


  interface EZhybrid_init
    !
    ! Initialize and allocate memory for hybrid interpolation object:
    ! dimensionality > 1 only.  Interpolation method is specified separately
    ! for each dimension.  At present, Akima Hermite and Spline interpolation
    ! cannot be mixed.
    !
    ! Boundary condition arguments are optional.  They are appropriate only
    ! for the end points of dimensions for which Hermite or Spline cubic
    ! interpolation is used.
    !
    ! hspline(...) specifies the interpolation method for each dimension,
    ! according to the code: -1 for step function, 0 for piecewise linear,
    ! 1 for Akima Hermite, 2 for cubic Spline.
    !
    subroutine EZhybrid_init3(spline_o, n1, n2, n3, hspline, ier, &
         BCS1, BCS2, BCS3)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: n1, n2, n3
      integer, intent(in) :: hspline(3)
      integer, intent(out) :: ier
      integer, intent(in), OPTIONAL :: BCS1(2), BCS2(2), BCS3(2)
    end subroutine EZhybrid_init3

    subroutine EZhybrid_init2(spline_o, n1, n2, hspline, ier, &
         BCS1, BCS2)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: n1, n2
      integer, intent(in) :: hspline(2)
      integer, intent(out) :: ier
      integer, intent(in), OPTIONAL :: BCS1(2), BCS2(2)
    end subroutine EZhybrid_init2

  end interface

  interface EZspline_free
    !
    ! Reset and free the memory. This method must be called to avoid
    ! memory leaks after all interpolations have been computed.
    !
    subroutine EZspline_free3(spline_o, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_free3

    subroutine EZspline_free2(spline_o, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_free2

    subroutine EZspline_free1(spline_o, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_free1

  end interface

  interface EZspline_setup
    !
    ! Compute the cubic spline coefficients. Note: the grid and the
    ! boundary conditions should be properly set prior to this call.
    !
    ! NEW optional argument: exact_dim=TRUE to requre f dimensions to
    ! match higher dimensions of spline_o%fspl exactly; default or FALSE
    ! means f dimensions can match or exceed dimensions of spline_o%fspl.
    !
    ! array arguments are now declared with f90 style dimensioning; the
    ! module interface must be used (if not feasible see ezspline_setupx.f90).
    ! 
    subroutine EZspline_setup3(spline_o, f, ier, exact_dim)
      use EZspline_obj
      type(EZspline3) spline_o
      real(fp), dimension(:,:,:), intent(in) :: f
      integer, intent(out) :: ier
      logical, intent(in), optional :: exact_dim
    end subroutine EZspline_setup3

    subroutine EZspline_setup2(spline_o, f, ier, exact_dim)
      use EZspline_obj
      type(EZspline2) spline_o
      real(fp), dimension(:,:), intent(in) :: f
      integer, intent(out) :: ier
      logical, intent(in), optional :: exact_dim
    end subroutine EZspline_setup2

    subroutine EZspline_setup1(spline_o, f, ier, exact_dim)
      use EZspline_obj
      type(EZspline1) spline_o
      real(fp), dimension(:), intent(in) :: f
      integer, intent(out) :: ier
      logical, intent(in), optional :: exact_dim
    end subroutine EZspline_setup1

  end interface



  interface EZspline_interp
    !
    ! Interpolation at grid point(s) p1, [p2, [p3]]. Result is returned in
    ! f. Interpolation can be sought at a single point (p1, [p2, [p3]] are
    ! scalars), on an unordered list of points (p1, [p2, [p3]] have dimension
    ! k), or on a structured grid (p1, [p2, [p3]] have dimension k1, [k2, [k3]]
    ! respectively).
    !
    subroutine EZspline_interp3(spline_o, p1, p2, p3, f, ier)
      ! single point evaluation
      use EZspline_obj
      type(EZspline3) spline_o
      real(fp) :: p1, p2, p3
      real(fp) f
      integer, intent(out) :: ier
    end subroutine EZspline_interp3

    subroutine EZspline_interp3_array(spline_o, k1, k2, k3, p1, p2, p3, f, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer :: k1, k2, k3
      real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
      real(fp), intent(out):: f(k1,k2,*)
      integer, intent(out) :: ier
    end subroutine EZspline_interp3_array

    subroutine EZspline_interp3_cloud(spline_o, k, p1, p2, p3, f, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k
      real(fp), intent(in) :: p1(k), p2(k), p3(k)
      real(fp), intent(out):: f(k)
      integer, intent(out) :: ier
    end subroutine EZspline_interp3_cloud

    subroutine EZspline_interp2(spline_o, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      real(fp) :: p1, p2
      real(fp) f
      integer, intent(out) :: ier
    end subroutine EZspline_interp2

    subroutine EZspline_interp2_array(spline_o, k1, k2, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer :: k1, k2
      real(fp), intent(in) :: p1(k1), p2(k2)
      real(fp), intent(out):: f(k1,*)
      integer, intent(out) :: ier
    end subroutine EZspline_interp2_array

    subroutine EZspline_interp2_cloud(spline_o, k, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: k
      real(fp), intent(in) :: p1(k), p2(k)
      real(fp), intent(out):: f(k)
      integer, intent(out) :: ier
    end subroutine EZspline_interp2_cloud

    subroutine EZspline_interp1(spline_o, p1, f, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      real(fp) :: p1
      real(fp) f
      integer, intent(out) :: ier
    end subroutine EZspline_interp1

    subroutine EZspline_interp1_array(spline_o, k1, p1, f, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer :: k1
      real(fp), intent(in) :: p1(k1)
      real(fp), intent(out):: f(k1)
      integer, intent(out) :: ier
    end subroutine EZspline_interp1_array

  end interface

  interface EZspline_derivative
    !
    ! Evaluate the spline/Akima Hermite derivative of order
    ! d^{i1} d^{i2} d^{i3} f / d x1^{i1} d x2^{i2} d x2^{i2}
    ! at p1, [p2, [p3]]. The sum of i1+[i2+[i3]] should be <=2 for spline, or
    ! <=1 for Akima Hermite or Piecewise Linear. 
    ! Result is return in f. The evaluation can
    ! be sought at a single point (p1, [p2, [p3]] are scalars), on
    ! an unordered list of points (p1, [p2, [p3]] have dimension k), or
    ! on a structured grid (p1, [p2, [p3]] have dimension k1, [k2, [k3]]
    ! respectively).
    !
    !
    subroutine EZspline_derivative3(spline_o, i1, i2, i3, p1, p2, p3, f, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: i1, i2, i3
      real(fp), intent(in) :: p1, p2, p3
      real(fp), intent(out) :: f
      integer, intent(out) :: ier
    end subroutine EZspline_derivative3

    subroutine EZspline_derivative3_array(spline_o, i1, i2, i3, &
         & k1, k2, k3, p1, p2, p3, f, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: i1, i2, i3, k1, k2, k3
      real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
      real(fp), intent(out) :: f(k1, k2, *)
      integer, intent(out) :: ier
    end subroutine EZspline_derivative3_array

    subroutine EZspline_derivative3_cloud(spline_o, i1, i2, i3, &
         & k, p1, p2, p3, f, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: i1, i2, i3, k
      real(fp), intent(in) :: p1(k), p2(k), p3(k)
      real(fp), intent(out) :: f(k)
      integer, intent(out) :: ier
    end subroutine EZspline_derivative3_cloud

    subroutine EZspline_derivative2(spline_o, i1, i2, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: i1, i2
      real(fp), intent(in) :: p1, p2
      real(fp), intent(out) :: f
      integer, intent(out) :: ier
    end subroutine EZspline_derivative2

    subroutine EZspline_derivative2_array(spline_o, i1, i2, k1, k2, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: i1, i2, k1, k2
      real(fp), intent(in) :: p1(k1), p2(k2)
      real(fp), intent(out) :: f(k1,k2)
      integer, intent(out) :: ier
    end subroutine EZspline_derivative2_array

    subroutine EZspline_derivative2_cloud(spline_o, i1, i2, k, p1, p2, f, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: i1, i2, k
      real(fp), intent(in) :: p1(k), p2(k)
      real(fp), intent(out) :: f(k)
      integer, intent(out) :: ier
    end subroutine EZspline_derivative2_cloud

    subroutine EZspline_derivative1(spline_o, i1, p1, f, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(in) :: i1
      real(fp), intent(in) :: p1
      real(fp), intent(out) :: f
      integer, intent(out) :: ier
    end subroutine EZspline_derivative1

    subroutine EZspline_derivative1_array(spline_o, i1, k1, p1, f, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(in) :: i1, k1
      real(fp), intent(in) :: p1(k1)
      real(fp), intent(out) :: f(k1)
      integer, intent(out) :: ier
    end subroutine EZspline_derivative1_array

  end interface

  interface EZspline_gradient
    !
    ! Return the gradient in df. When the dimensionality is 1 then
    ! df is df/dx. In more than one dimension, df has rank >=1 with
    ! the last index yielding df/dx, df/dy ... etc. Subsequent indices
    ! reflect the node positions when cloud or array evaluation is
    ! sought, as in df(k1, k2, k3, 1) for df/dx at x(k1), y(k2), z(k3).
    !
    subroutine EZspline_gradient3(spline_o, p1, p2, p3, df, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      real(fp), intent(in) :: p1, p2, p3
      real(fp), intent(out) :: df(3)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient3

    subroutine EZspline_gradient3_array(spline_o, k1, k2, k3, &
         & p1, p2, p3, df, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k1, k2, k3
      real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
      real(fp), intent(out) :: df(k1,k2,k3,3)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient3_array

    subroutine EZspline_gradient3_cloud(spline_o, k, &
         & p1, p2, p3, df, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k
      real(fp), intent(in) :: p1(k), p2(k), p3(k)
      real(fp), intent(out) :: df(k,3)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient3_cloud

    subroutine EZspline_gradient2(spline_o, p1, p2, df, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      real(fp), intent(in) :: p1, p2
      real(fp), intent(out) :: df(2)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient2

    subroutine EZspline_gradient2_array(spline_o, k1, k2, &
         & p1, p2, df, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in)  :: k1, k2
      real(fp), intent(in) :: p1(k1), p2(k2)
      real(fp), intent(out) :: df(k1, k2, 2)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient2_array

    subroutine EZspline_gradient2_cloud(spline_o, k, &
         & p1, p2, df, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in)  :: k
      real(fp), intent(in) :: p1(k), p2(k)
      real(fp), intent(out) :: df(k, 2)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient2_cloud

    subroutine EZspline_gradient1(spline_o, p1, df, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      real(fp), intent(in) :: p1
      real(fp), intent(out) :: df
      integer, intent(out) :: ier
    end subroutine EZspline_gradient1

    subroutine EZspline_gradient1_array(spline_o, k1, p1, df, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      integer, intent(in) :: k1
      real(fp), intent(in) :: p1(k1)
      real(fp), intent(out) :: df(k1)
      integer, intent(out) :: ier
    end subroutine EZspline_gradient1_array

  end interface

  interface EZspline_isInDomain
    !
    ! Return error code if position (p1, [p2, [p3]]) is outside domain.
    ! The evaluation can be sought at a single point (p1, [p2, [p3]]
    ! are scalars), on an unordered list of points (p1, [p2, [p3]] have
    ! dimension k), or on a structured grid (p1, [p2, [p3]] have dimension
    ! k1, [k2, [k3]] respectively).
    !
    subroutine EZspline_isInDomain3(spline_o, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) :: spline_o
      real(fp), intent(in) :: p1, p2, p3
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain3

    subroutine EZspline_isInDomain3_array(spline_o, k1, k2, k3, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) :: spline_o
      integer, intent(in) :: k1, k2, k3
      real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain3_array

    subroutine EZspline_isInDomain3_cloud(spline_o, k, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) :: spline_o
      integer, intent(in) :: k
      real(fp), intent(in) :: p1(k), p2(k), p3(k)
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain3_cloud

    subroutine EZspline_isInDomain2(spline_o, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) :: spline_o
      real(fp), intent(in) :: p1, p2
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain2

    subroutine EZspline_isInDomain2_array(spline_o, k1, k2, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) :: spline_o
      integer, intent(in) :: k1, k2
      real(fp), intent(in) :: p1(k1), p2(k2)
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain2_array

    subroutine EZspline_isInDomain2_cloud(spline_o, k, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) :: spline_o
      integer, intent(in) :: k
      real(fp), intent(in) :: p1(k), p2(k)
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain2_cloud

    subroutine EZspline_isInDomain1(spline_o, p1, ier)
      use EZspline_obj
      type(EZspline1) :: spline_o
      real(fp), intent(in) :: p1
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain1

    subroutine EZspline_isInDomain1_array(spline_o, k1, p1, ier)
      use EZspline_obj
      type(EZspline1) :: spline_o
      integer, intent(in) :: k1
      real(fp), intent(in) :: p1(k1)
      integer, intent(out) :: ier
    end subroutine EZspline_isInDomain1_array

  end interface

  interface EZspline_isGridRegular
    !
    ! Return error code if grid is not regular (not strictly  increasing).
    ! The evaluation can be sought at a single point (p1, [p2, [p3]]
    ! are scalars), on an unordered list of points (p1, [p2, [p3]] have
    ! dimension k), or on a structured grid (p1, [p2, [p3]] have dimension
    ! k1, [k2, [k3]] respectively).
    !
    subroutine EZspline_isGridRegular3(spline_o, ier)
      use EZspline_obj
      type(EZspline3) :: spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_isGridRegular3

    subroutine EZspline_isGridRegular2(spline_o, ier)
      use EZspline_obj
      type(EZspline2) :: spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_isGridRegular2

    subroutine EZspline_isGridRegular1(spline_o, ier)
      use EZspline_obj
      type(EZspline1) :: spline_o
      integer, intent(out) :: ier
    end subroutine EZspline_isGridRegular1

  end interface

  interface EZspline_save
    !
    ! Save spline/Akima Hermite/Linear object in netcdf file 'filename'. Use
    ! EZspline_load to load spline/Akima Hermite/Linear object from netcdf 
    ! file.
    !
    ! Mod DMC March 2006 -- optionally, by giving each spline a name, 
    ! multiple splines can be saved in a single file.  Also, by specifying
    ! "fullsave=.TRUE." the spline coefficients can be saved as well in the
    ! file, so that they do not have to be recomputed at ezspline_load time.
    !
    ! When creating a single file with multiple spline objects, it is the
    ! user's responsibilitly to make sure that a different name is used for
    ! each spline that is to be saved.  Names can consist of upper or lower
    ! case letters, numerals, and "_", but must not start with a numeral.
    ! Imbedded blanks are not allowed, and the length of the name must be
    ! no more than 20 characters long-- to allow the names of the spline
    ! object elements to be appended.
    !
    subroutine EZspline_save3(spline_o, filename, ier, &
         spl_name,fullsave)
      use EZspline_obj
      use EZcdf
      type(EZspline3) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
      logical, intent(in), optional :: fullsave

    end subroutine EZspline_save3

    subroutine EZspline_save2(spline_o, filename, ier, &
         spl_name,fullsave)
      use EZspline_obj
      use EZcdf
      type(EZspline2) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
      logical, intent(in), optional :: fullsave

    end subroutine EZspline_save2

    subroutine EZspline_save1(spline_o, filename, ier, &
         spl_name,fullsave)
      use EZspline_obj
      use EZcdf
      type(EZspline1) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
      logical, intent(in), optional :: fullsave

    end subroutine EZspline_save1

  end interface

  interface EZspline_load
    !
    ! Load spline/Akima Hermite object from netcdf file 'filename'. Use
    ! EZspline_save to save spline/Akima Hermite/Linear object in netcdf file.
    !
    ! MOD DMC March 2006-- a single NetCDF file can now contain multiple
    ! *named* spline objects.  If accessing such an object, the name must
    ! be supplied via the optional argument "spl_name".  If this is omitted,
    ! the default is to read the contents of the file which is presumed to
    ! consist of but a single spline object.

    ! Each call still opens and closes the file; if users find this 
    ! inefficient, an improvement to the control interface may be built.

    subroutine EZspline_load3(spline_o, filename, ier, spl_name)
      use EZspline_obj
      use EZcdf
      type(EZspline3) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
    end subroutine EZspline_load3

    subroutine EZspline_load2(spline_o, filename, ier, spl_name)
      use EZspline_obj
      use EZcdf
      type(EZspline2) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
    end subroutine EZspline_load2

    subroutine EZspline_load1(spline_o, filename, ier, spl_name)
      use EZspline_obj
      use EZcdf
      type(EZspline1) :: spline_o
      character(len=*) :: filename
      integer, intent(out) :: ier

      character(len=*), intent(in),optional :: spl_name
    end subroutine EZspline_load1

  end interface

  interface EZspline_modulo
    !
    ! Map argument to (x1,2,3min, x1,2,3max) interval. This is useful to avoid
    ! an out-of-grid error when periodic boundary conditions are applied.
    ! The evaluation can be sought at a single point (p1, [p2, [p3]]
    ! are scalars), on an unordered list of points (p1, [p2, [p3]] have
    ! dimension k), or on a structured grid (p1, [p2, [p3]] have dimension
    ! k1, [k2, [k3]] respectively).
    !
    subroutine EZspline_modulo3(spline_o, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      real(fp) :: p1, p2, p3
      integer, intent(out) :: ier
    end subroutine EZspline_modulo3

    subroutine EZspline_modulo_array3(spline_o, k1, k2, k3, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k1, k2, k3
      real(fp) :: p1(k1), p2(k2), p3(k3)
      integer, intent(out) :: ier
    end subroutine EZspline_modulo_array3

    subroutine EZspline_modulo_cloud3(spline_o, k, p1, p2, p3, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k
      real(fp) :: p1(k), p2(k), p3(k)
      integer, intent(out) :: ier
    end subroutine EZspline_modulo_cloud3

    subroutine EZspline_modulo2(spline_o, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      real(fp) :: p1, p2
      integer, intent(out) :: ier
    end subroutine EZspline_modulo2

    subroutine EZspline_modulo_array2(spline_o, k1, k2, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: k1, k2
      real(fp) :: p1(k1), p2(k2)
      integer, intent(out) :: ier
    end subroutine EZspline_modulo_array2

    subroutine EZspline_modulo_cloud2(spline_o, k, p1, p2, ier)
      use EZspline_obj
      type(EZspline2) spline_o
      integer, intent(in) :: k
      real(fp) :: p1(k), p2(k)
      integer, intent(out) :: ier
    end subroutine EZspline_modulo_cloud2

    subroutine EZspline_modulo1(spline_o, p1, ier)
      use EZspline_obj
      type(EZspline1) spline_o
      real(fp) :: p1
      integer, intent(out) :: ier
    end subroutine EZspline_modulo1

    subroutine EZspline_modulo_array1(spline_o, k1, p1, ier)
      use EZspline_obj
      type(EZspline3) spline_o
      integer, intent(in) :: k1
      real(fp) :: p1(k1)
      integer, intent(out) :: ier
    end subroutine EZspline_modulo_array1

  end interface

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! EZspline object-less methods (first argument is NOT an EZspline1,2,3 type).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  interface EZspline_2NetCDF
    !
    ! Save data in netCDF file 'filename'. To save an EZspline1,2,3 object use
    ! EZspline_save method.
    !
    subroutine EZspline_2NetCDF_array3(n1, n2, n3, x1, x2, x3, f, filename, ier)
      use EZspline_obj
      use EZcdf
      implicit none
      integer, intent(in) :: n1, n2, n3
      real(fp), intent(in) :: x1(:), x2(:), x3(:), f(:, :, :)
      character(len=*), intent(in) :: filename
      integer, intent(out) :: ier
    end subroutine EZspline_2NetCDF_array3

    subroutine EZspline_2NetCDF_array2(n1, n2, x1, x2, f, filename, ier)
      use EZspline_obj
      use EZcdf
      implicit none
      integer, intent(in) :: n1, n2
      real(fp), intent(in) ::  x1(:), x2(:), f(:,:)
      character(len=*), intent(in) :: filename
      integer, intent(out) :: ier
    end subroutine EZspline_2NetCDF_array2

    subroutine EZspline_2NetCDF1(n1, x1, f, filename, ier)
      use EZspline_obj
      use EZcdf
      implicit none
      integer, intent(in) :: n1
      real(fp), intent(in) :: x1(:), f(:)
      character(len=*), intent(in) :: filename
      integer, intent(out) :: ier
    end subroutine EZspline_2NetCDF1

    subroutine EZspline_2NetCDF_cloud3(n, x1, x2, x3, f, filename, ier)
      use EZspline_obj
      use EZcdf
      implicit none
      integer, intent(in) :: n
      real(fp), intent(in) :: x1(:), x2(:), x3(:), f(:)
      character(len=*), intent(in) :: filename
      integer, intent(out) :: ier
    end subroutine EZspline_2NetCDF_cloud3

    subroutine EZspline_2NetCDF_cloud2(n, x1, x2, f, filename, ier)
      use EZspline_obj
      use EZcdf
      implicit none
      integer, intent(in) :: n
      real(fp), intent(in) :: x1(:), x2(:), f(:)
      character(len=*), intent(in) :: filename
      integer, intent(out) :: ier
    end subroutine EZspline_2NetCDF_cloud2

  end interface


contains


  subroutine EZspline_error(ier)
    !
    ! Error handling routine. Maps error ier code to a meaningful message.
    ! Note: does not abort nor stop if ier/=0.
    !
    implicit none
    integer, intent(in) :: ier

    if(ier == 0) return
    write(6,*) '**EZspline** ERROR/WARNING #', ier,' occurred'

    select case(ier)
    case(1)
      write(6,*) '**EZspline** allocation error'
    case(2)
      write(6,*) '**EZspline** wrong BCS1 code'
    case(3)
      write(6,*) '**EZspline** wrong BCS2 code'
    case(4)
      write(6,*) '**EZspline** wrong BCS3 code'
    case(5)
      write(6,*) '**EZspline** Que??'
    case(6)
      write(6,*) '**EZspline** out of interval p1 < min(x1)'
    case(7)
      write(6,*) '**EZspline** out of interval p1 > max(x1)'
    case(8)
      write(6,*) '**EZspline** out of interval p2 < min(x2)'
    case(9)
      write(6,*) '**EZspline** out of interval p2 > max(x2)'
    case(10)
      write(6,*) '**EZspline** out of interval p3 < min(x3)'
    case(11)
      write(6,*) '**EZspline** out of interval p3 > max(x3)'
    case(12)
      write(6,*) '**EZspline** negative derivative order'
    case(13)
      write(6,*) '**EZspline** derivative order too high'
    case(14)
      write(6,*) '**EZspline** x1 grid is not strictly increasing'
    case(15)
      write(6,*) '**EZspline** x2 grid is not strictly increasing'
    case(16)
      write(6,*) '**EZspline** x3 grid is not strictly increasing'
    case(17)
      write(6,*) '**EZspline** could not save spline object in file '
    case(18)
      write(6,*) '**EZspline** memory allocation failure in coefficient setup'

    case(20)
      write(6,*) '**EZspline** attempt to load spline object with wrong rank.'
    case(21)
      write(6,*) '**EZspline** could not load spline object from file '
    case(22)
      write(6,*) '**EZspline** loaded spline object from file but failed at coefficient set-up'
    case(23)
      write(6,*) '**EZspline** failed to free spline object'
    case(24)
      write(6,*) '**EZspline** 2nd order derivative not supported for Akima-Hermite (isHermite=1)'
    case(25)
      write(6,*) '**EZspline** not supported for Akima-Hermite (isHermite=1)'
    case(26)
      write(6,*) '**EZspline** memory allocation error in EZspline_interp'
    case(27)
      write(6,*) '**EZspline** an error ocurred in genxpkg'
    case(28)
      write(6,*) '**EZspline** memory allocation failure in ezspline_interp'
    case(29)
      write(6,*) '**EZspline** memory deallocation failure in ezspline_interp'
    case(30)
      write(6,*) '**EZspline** memory allocation error in EZspline_gradient'
    case(31)
      write(6,*) '**EZspline** memory deallocation error in EZspline_gradient'
    case(32)
      write(6,*) '**EZspline** memory allocation error in EZspline_derivative'
    case(33)
      write(6,*) '**EZspline** memory deallocation error in EZspline_derivative'
    case(34)
      write(6,*) '**EZspline** could not open netCDF file in EZspline_2netcdf'
    case(35)
      write(6,*) '**EZspline** could not write into netCDF file in EZspline_2netcdf'
    case(36)
      write(6,*) '**EZspline** could not read from netCDF file in EZspline_2netcdf'
    case(37)
      write(6,*) '**EZspline** could not close netCDF file in EZspline_2netcdf'
    case(38)
      write(6,*) '**EZspline** could not define variable (cdfDefVar) in EZspline_2netcdf'
    case(39)
      write(6,*) '**EZspline** could not open netCDF file in EZspline_save'
    case(40)
      write(6,*) '**EZspline** could not write into netCDF file in EZspline_save'
    case(41)
      write(6,*) '**EZspline** could not close netCDF file in EZspline_save'
    case(42)
      write(6,*) '**EZspline** could not define variable (cdfDefVar) in EZspline_save'
    case(43)
      write(6,*) '**EZspline** could not open netCDF file in EZspline_load'
    case(44)
      write(6,*) '**EZspline** could not read from netCDF file in EZspline_load'
    case(45)
      write(6,*) '**EZspline** could not close netCDF file in EZspline_load'
    case(46)
      write(6,*) '**EZspline** 2nd order derivative not supported for Piecewise Linear Interpolation (isLinear=1)'
    case(47)
      write(6,*) '**EZspline** not supported for Piecewise Linear Interpolation (isLinear=1)'

    case(50)
      write(6,*) '**EZspline** ezspline_save (optional) spline name is blank.'
    case(51)
      write(6,*) '**EZspline** ezspline_save (optional) spline name too long (max 20 characters).'
    case(52)
      write(6,*) '**EZspline** ezspline_save (optional) spline name contains'
      write(6,*) '             imbedded blanks or other illegal characters.'
    case(53)
      write(6,*) '**EZspline** attempt to write named spline object to NetCDF'
      write(6,*) '             file with change of dimensionality or data type.'

    case(54)
      write(6,*) '**EZspline** hybrid interpolation specification not in range -1:2'
      write(6,*) '             error in EZhybrid_init.'
    case(55)
      write(6,*) '**EZspline** hybrid interpolation cannot mix Hermite and Spline interpolation.'
      write(6,*) '             hspline(i)=1 and hspline(j)=2 in EZhybrid_init.'
    case(56)
      write(6,*) '**EZspline** non-default boundary condition unavailable: zonal or piecewise linear dimension.'
      write(6,*) '             in EZhybrid_init.'

    case(57)
      write(6,*) '**EZspline** dimension of "f" smaller than corresponding "fspl"'
      write(6,*) '             dimension in "spline_o".'
    case(58)
      write(6,*) '**EZspline** dimension of "f" larger than corresponding "fspl"'
      write(6,*) '             dimension in "spline_o".'

    case(90)
      write(6,*) '**EZspline** an error occurred after attempting to evaluate the'
      write(6,*) '             Hermite polynomials'
    case(91)
      write(6,*) '**EZspline** an error occurred after attempting to set up the'
      write(6,*) '             Hermite polynomial coefficients'
    case(92)
      write(6,*) '**EZspline** warning in EZspline_load. Looks like saved object '
      write(6,*) '             was not properly set-up (isReady=0).'
    case(93)
      write(6,*) '**EZspline** warning in EZspline_save. Looks like saved object '
      write(6,*) '             was not properly set-up (isReady=0).'
    case(94)
      write(6,*) '**EZspline** an error occurred in EZspline_interp. Did you forget'
      write(6,*) '             to set up the cubic spline coefficients by calling'
      write(6,*) '             call EZspline_setup(spline_o, f, ier)'
      write(6,*) '             ?'
    case(95)
      write(6,*) '**EZspline** some error occurred in EZspline_gradient'
    case(96)
      write(6,*) '**EZspline** some error occurred in EZspline_derivative'
    case(97)
      write(6,*) '**EZspline** some error occurred in EZspline_interp apparently'
      write(6,*) '             related to a PSPLINE routine. Check if argument is '
      write(6,*) '             outside interpolation domain by calling'
      write(6,*) '             call EZspline_isInDomain(spline_o, [[k1, k2, k3,] .OR. k,] p1, p2, p3, ier ,ier)'
      write(6,*) '             call EZspline_error(ier)'
    case(98)
      write(6,*) '**EZspline** error occurred in EZspline_setup'
      write(6,*) '  if no other explanation-- ezspline_init call never made.'
    case(99)
      write(6,*) '**EZspline** some error occurred in EZspline_init, EZhybrid_init,  or EZlinear_init'
    case(100)
      write(6,*) '**EZSPLINE** EZspline_init, EZhybrid_init,  or EZlinear_init -- object already allocated.'
    case(101)
      write(6,*) '**EZSPLINE** object was never allocated.'
    case default
      write(6,*) '**EZspline** '
    end select

    return
  end subroutine EZspline_error

end module EZspline

MODULE ezcdf_attrib
   USE ezcdf_inqvar
   include "netcdf.inc"
   integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
   integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
   character(len=nf_max_name) :: varnam_noalpha
   PRIVATE :: r4, r8, varnam_noalpha
   PUBLIC :: cdf_setatt, cdf_getatt
 
   INTERFACE cdf_setatt
      MODULE PROCEDURE cdfSetatt, cdfsa_i, cdfsa_d, cdfsa_f
   END INTERFACE
 
   INTERFACE cdf_getatt
      MODULE PROCEDURE cdfGetatt, cdfga_i, cdfga_d, cdfga_f
   END INTERFACE

CONTAINS
 
SUBROUTINE cdfSetatt(ncid,varnam,long_name,units,ier,varid)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: varnam
  character*(*), intent(in), optional :: long_name, units
  ! Output
  integer, optional,     intent(out) :: ier, varid
  ! Local
  integer                 :: varid0
  integer                 :: status
  character*(*), parameter :: cmplx_name = '__CmPlx_Re_Im'
  character*(*), parameter :: logical_name = '__logical__'
 
  if (PRESENT (ier)) ier = 1
 
  varnam_noalpha = varnam
  CALL alpha_numeric(varnam_noalpha)

!Find varid
  status = nf_inq_varid(ncid,varnam_noalpha,varid0)
  if (status .ne. 0) then
     ! perhaps varnam is complex, try...
     status = nf_inq_varid(ncid,trim(varnam_noalpha)//cmplx_name,varid0)
     if(status .ne. 0) then
        status = nf_inq_varid(ncid,trim(varnam_noalpha)//logical_name,varid0)
     endif
  endif
 
!  call ezcdf_error(status,varnam,'cdf_setatt','nf_inq_varid')
  if(status .ne. 0) GO TO 100
 
  if (PRESENT(long_name)) then
     status = nf_put_att_text (ncid, varid0, 'long_name', LEN_TRIM(long_name),  &
                          TRIM(long_name))
     CALL ezcdf_error(status,long_name,'cdf_setatt','nf_put_att_text')
     if (status .ne. 0) GO TO 100
  end if
 
  if (PRESENT(units)) then
     status = nf_put_att_text (ncid, varid0, 'units', LEN_TRIM(units),          &
                          TRIM(units))
     CALL ezcdf_error(status,units,'cdf_setatt','nf_put_att_text')
     if (status .ne. 0) GO TO 100
  end if
 
100 CONTINUE
 
  if (PRESENT (ier)) ier = status
  if (PRESENT (varid)) varid = varid0
 
END SUBROUTINE cdfSetatt
 
SUBROUTINE cdf_SetTitle(ncid,title,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: title
  ! Output
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: status
 
  if (PRESENT (ier)) ier = 1
 
  status = nf_put_att_text (ncid, nf_global, 'title', LEN_TRIM(title),  &
                          TRIM(title))
  CALL ezcdf_error(status,title,'cdf_settitle','nf_put_att_text')
 
  if (PRESENT (ier)) ier = status
 
END SUBROUTINE cdf_SetTitle
 
SUBROUTINE cdfsa_i(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: varnam
  character*(*), intent(in), optional :: long_name, units
  integer, intent(in), dimension(2)   :: valid_range
  ! Output
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfSetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_put_att_int(ncid, varid, 'valid_range', nf_double, &
                          2, valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_setatt','nf_put_att_double')
 
END SUBROUTINE cdfsa_i
 
 
SUBROUTINE cdfsa_f(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)               :: ncid
  character*(*), intent(in)               :: varnam
  character*(*), intent(in), optional     :: long_name, units
  real(kind=r4), intent(in), dimension(2) :: valid_range
  ! Output
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfSetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_put_att_real(ncid, varid, 'valid_range', nf_double, &
                           2, valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_setatt','nf_put_att_double')
 
END SUBROUTINE cdfsa_f
 
SUBROUTINE cdfsa_d(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)               :: ncid
  character*(*), intent(in)               :: varnam
  character*(*), intent(in), optional     :: long_name, units
  real(kind=r8), intent(in), dimension(2) :: valid_range
  ! Output
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfSetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_put_att_double(ncid, varid, 'valid_range', nf_double, &
                             2, valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_setatt','nf_put_att_double')
 
END SUBROUTINE cdfsa_d
 
 
SUBROUTINE cdfGetatt(ncid,varnam,long_name,units,ier,varid)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: varnam
  ! Output
  character*(*), intent(out), optional :: long_name, units
  integer, optional,     intent(out) :: ier, varid
  ! Local
  integer                 :: varid0
  integer                 :: status
  character*(*), parameter :: cmplx_name = '__CmPlx_Re_Im'
  character*(*), parameter :: logical_name = '__logical__'
  character*(nf_max_name) :: name
 
  if (PRESENT (ier)) ier = 1

  varnam_noalpha = varnam
  CALL alpha_numeric(varnam_noalpha)
 
!Find varid0
  status = nf_inq_varid(ncid,varnam_noalpha,varid0)
  if (status .ne. 0) then
     ! perhaps varnam is complex, try...
     status = nf_inq_varid(ncid,trim(varnam_noalpha)//cmplx_name,varid0)
     if(status .ne. 0) then
        status = nf_inq_varid(ncid,trim(varnam_noalpha)//logical_name,varid0)
     endif
  endif
 
!  call ezcdf_error(status,varnam,'cdf_setatt','nf_inq_varid')
  if(status .ne. 0) GO TO 100
 
  if (PRESENT(long_name)) then
     name = ""
     status = nf_get_att_text (ncid, varid0, 'long_name', name)
     if (status .eq. nf_noerr) then
        long_name = name(1:len(name))
     else
        long_name = ""
     end if
  end if
 
  if (PRESENT(units)) then
     name = ""
     status = nf_get_att_text (ncid, varid0, 'units', name)
     if (status .eq. nf_noerr) then
        units = name(1:len(name))
     else
        units = ""
     end if
  end if
 
100 CONTINUE
 
  if (PRESENT (ier)) ier = status
  if (PRESENT (varid)) varid = varid0
 
END SUBROUTINE cdfGetatt
 
SUBROUTINE cdf_GetTitle(ncid,title,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  ! Output
  character*(*), intent(out)         :: title
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: status
  character*(nf_max_name) :: name
 
  if (PRESENT (ier)) ier = 1
 
  status = nf_get_att_text (ncid, nf_global, 'title', name)
  if (status .eq. nf_noerr) then
     title = name(1:len(name))
  else
     title = ""
  end if
 
  if (PRESENT (ier)) ier = status
 
END SUBROUTINE cdf_GetTitle
 
SUBROUTINE cdfga_i(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)            :: ncid
  character*(*), intent(in)            :: varnam
  ! Output
  character*(*), intent(out), optional :: long_name, units
  integer, intent(out), dimension(2)   :: valid_range
  integer, optional,     intent(out)   :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfGetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_get_att_int(ncid, varid, 'valid_range', valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_getatt','nf_get_att_int')
 
END SUBROUTINE cdfga_i
 
SUBROUTINE cdfga_f(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: varnam
  ! Output
  character*(*), intent(out), optional     :: long_name, units
  real(kind=r4), intent(out), dimension(2) :: valid_range
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfGetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_get_att_real(ncid, varid, 'valid_range', valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_getatt','nf_get_att_real')
 
END SUBROUTINE cdfga_f
 
SUBROUTINE cdfga_d(ncid,varnam,valid_range,long_name,units,ier)
  implicit none
!  include "netcdf.inc"
  ! Input
  integer,       intent(in)           :: ncid
  character*(*), intent(in)           :: varnam
  ! Output
  character*(*), intent(out), optional     :: long_name, units
  real(kind=r8), intent(out), dimension(2) :: valid_range
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid
  integer                 :: status
 
  call cdfGetatt(ncid,varnam,long_name,units,ier,varid)
 
  status = nf_get_att_double(ncid, varid, 'valid_range', valid_range)
  CALL ezcdf_error(status,'valid_range','cdf_getatt','nf_get_att_double')
 
END SUBROUTINE cdfga_d
 
END MODULE ezcdf_attrib
 

      Subroutine err_ini
C
C  code provided to arrange for portability to SUN with
C  desired floating point error handling
C
C  on newer SUN systems use compiler switches "-fns -ftrap=common" instead
C
#if __SUN || __SUNOS
 
#define SIGFPE_ABORT    %val(2) /* abort on exception */
 
      Integer  ieee_handler
      External ieee_handler
      Integer  ieee_flags
      External ieee_flags
      Integer  istat
C
      istat=ieee_handler('set','division',SIGFPE_ABORT)
      If (istat.Ne.0) Call Errmsg_Exit('Error in setting ieee division')
      istat=ieee_handler('set','invalid' ,SIGFPE_ABORT)
      If (istat.Ne.0) Call Errmsg_Exit('Error in setting ieee invalid')
      istat=ieee_handler('set','overflow',SIGFPE_ABORT)
      If (istat.Ne.0) Call Errmsg_Exit('Error in setting ieee overflow')
      Call nonstandard_arithmetic()
#endif
      return
      End

subroutine dnherm3(x,nx,y,ny,z,nz,fherm,nf2,nf3, &
     ilinx,iliny,ilinz,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on simple
  !  numerical differentiation using the given grid.  The grid should
  !  be "approximately" evenly spaced.
  !
  !  3d routine
  !
  !  input:
  !
  !  nf2.get.nx and nf3.ge.ny  expected!
  !
  !============
  implicit none
  integer iliny,ilinz,ier,ilinx,ierx,iery,ierz,iz,izp,izm,iy
  integer iyp,iym,ix,ixp,ixm
  !============
  real(fp) :: zd
  !============
  integer nx,ny,nz,nf2,nf3          ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: z(nz)                        ! z coordinate array
  real(fp) :: fherm(0:7,nf2,nf3,nz)        ! data/Hermite array
  !
  !  fherm(0,i,j,k) = function value f at x(i),y(j),z(k)  **on input**
  !
  !  fherm(1,i,j,k) = derivative df/dx at x(i),y(j),z(k)  **on output**
  !  fherm(2,i,j,k) = derivative df/dy at x(i),y(j),z(k)  **on output**
  !  fherm(3,i,j,k) = derivative df/dz at x(i),y(j),z(k)  **on output**
  !  fherm(4,i,j,k) = derivative d2f/dxdy at x(i),y(j),z(k)  **on output**
  !  fherm(5,i,j,k) = derivative d2f/dxdz at x(i),y(j),z(k)  **on output**
  !  fherm(6,i,j,k) = derivative d2f/dydz at x(i),y(j),z(k)  **on output**
  !  fherm(7,i,j,k) = derivative d3f/dxdydz at x(i),y(j),z(k)  **on output**
  !
  !  additional outputs:
  !
  !    ilinx = 1  if x is evenly spaced (approximately)
  !    iliny = 1  if y is evenly spaced (approximately)
  !    ilinz = 1  if z is evenly spaced (approximately)
  !
  !    ier = 0 if there are no errors
  !
  !  note possible errors:  x y or z NOT strict ascending
  !  nf2.lt.nx   .or.   nf3.lt.ny
  !
  !----------------------------
  !
  !
  !  error check
  !
  ier=0
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?dnherm3:  x axis not strict ascending'')')
  end if
  !
  call splinck(y,ny,iliny,1.0E-3_fp,iery)
  if(iery.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?dnherm3:  y axis not strict ascending'')')
  end if
  !
  call splinck(z,nz,ilinz,1.0E-3_fp,ierz)
  if(ierz.ne.0) ier=4
  !
  if(ier.eq.4) then
     write(6,'('' ?dnherm3:  z axis not strict ascending'')')
  end if
  !
  if(nf2.lt.nx) then
     ier=5
     write(6,*) '?dnherm3:  fherm (x) array dimension too small.'
  end if
  !
  if(nf3.lt.ny) then
     ier=6
     write(6,*) '?dnherm3:  fherm (y) array dimension too small.'
  end if
  !
  if(ier.ne.0) return
  !
  !  error check OK
  !
  do iz=1,nz
     !
     izp=min(nz,iz+1)
     izm=max(1,iz-1)
     !
     do iy=1,ny
        !
        iyp=min(ny,iy+1)
        iym=max(1,iy-1)
        !
        do ix=1,nx
           !
           ixp=min(nx,ix+1)
           ixm=max(1,ix-1)
           !
           !  x diffs in vicinity
           !
           zd=(fherm(0,ixp,iy,iz)-fherm(0,ixm,iy,iz))/ &
                (x(ixp)-x(ixm))
           !
           fherm(1,ix,iy,iz)=zd
           !
           !  y diffs in vicinity
           !
           zd=(fherm(0,ix,iyp,iz)-fherm(0,ix,iym,iz))/ &
                (y(iyp)-y(iym))
           !
           fherm(2,ix,iy,iz)=zd
           !
           !  z diffs in vicinity
           !
           zd=(fherm(0,ix,iy,izp)-fherm(0,ix,iy,izm))/ &
                (z(izp)-z(izm))
           !
           fherm(3,ix,iy,iz)=zd
           !
           !  xy cross derivs
           !
           fherm(4,ix,iy,iz)= &
                (fherm(0,ixp,iyp,iz)-fherm(0,ixm,iyp,iz) &
                -fherm(0,ixp,iym,iz)+fherm(0,ixm,iym,iz))/ &
                ((x(ixp)-x(ixm))*(y(iyp)-y(iym)))
           !
           !  xz cross derivs
           !
           fherm(5,ix,iy,iz)= &
                (fherm(0,ixp,iy,izp)-fherm(0,ixm,iy,izp) &
                -fherm(0,ixp,iy,izm)+fherm(0,ixm,iy,izm))/ &
                ((x(ixp)-x(ixm))*(z(izp)-z(izm)))
           !
           !  yz cross derivs
           !
           fherm(6,ix,iy,iz)= &
                (fherm(0,ix,iyp,izp)-fherm(0,ix,iym,izp) &
                -fherm(0,ix,iyp,izm)+fherm(0,ix,iym,izm))/ &
                ((y(iyp)-y(iym))*(z(izp)-z(izm)))
           !
           !  xyz cross deriv
           !
           fherm(7,ix,iy,iz)= &
                ((fherm(0,ixp,iyp,izp)-fherm(0,ixp,iym,izp) &
                -fherm(0,ixp,iyp,izm)+fherm(0,ixp,iym,izm))- &
                (fherm(0,ixm,iyp,izp)-fherm(0,ixm,iym,izp) &
                -fherm(0,ixm,iyp,izm)+fherm(0,ixm,iym,izm)))/ &
                ((x(ixp)-x(ixm))*(y(iyp)-y(iym))*(z(izp)-z(izm)))
           !
        end do
     end do
  end do
  !
  return
end subroutine dnherm3

      subroutine frename_OK(oldname,newname,ier)
C
C  dmc 30 June 2011 -- rename a file if it exists & can be opened; otherwise
C  do nothing & return 0 error status 
C
      implicit NONE
C
      character*(*), intent(in) :: oldname   ! old filename
      character*(*), intent(in) :: newname   ! new filename
      integer, intent(out) :: ier
C
C-------------------------------------------
      integer :: io,istat
C-------------------------------------------
      ier=0
C
      call find_io_unit(io)
      open(unit=io,file=oldname,status='old',iostat=istat)
      if(istat.ne.0) then
                                ! return silently
         ier=0
         return
      endif

      !  OK, file is accessible; proceed with rename
      close(unit=io)
      call frename(oldname,newname,ier)

      return
      end

C======================================================
C
      subroutine frename(oldname,newname,ier)
C
C  dmc 18 June 1996 -- rename file
C
C  encapsulate VMS/UNIX OS dependence here.
C
      implicit NONE

      character*(*), intent(in) :: oldname   ! old filename
      character*(*), intent(in) :: newname   ! new filename
      integer, intent(out) :: ier  
C
C  ** rename a file **
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
      integer str_length,ilo,iln,istat
C
#ifdef __UNIX
#include "fpreproc/byte_declare.h"
      byte_declare fnbuf1(500),fnbuf2(500)
      integer cdelete,crename,cccopy
#endif
C----------------------------------
C
      ier=0
C
      ilo=str_length(oldname)
      iln=str_length(newname)
      if(min(ilo,iln).le.0) then
         write(6,*) ' ?frename:  filename argument is blank.'
         ier=1
         return
      endif
C
      if(oldname.eq.newname) then
         write(6,*) ' %frename:  oldname & newname match: '//
     >        trim(oldname)
         write(6,*) '  ...no action taken.'
         ier=0
         return
      endif
C
C  UNIX code:
C
#ifdef __UNIX
      call cstring(oldname(1:ilo),fnbuf1,'2C')
      call cstring(newname(1:iln),fnbuf2,'2C')
      ier=cdelete(fnbuf2)
      ier=crename(fnbuf1,fnbuf2)
      if(ier.ne.0) then
         write(6,*) ' %frename: retry as copy & delete...'
         ier=cccopy(fnbuf1,fnbuf2)
         if(ier.eq.0) then
            ier=cdelete(fnbuf1)
            if(ier.ne.0) then
               write(6,*) ' ?frename: delete of oldname failed: '//
     >              trim(oldname)
            endif
         else
            write(6,*) ' ?frename: copy failed: '
            write(6,*) '    oldname: '//trim(oldname)
            write(6,*) '    newname: '//trim(newname)
         endif
      endif
#endif
C
C  VMS code:
C
#ifdef __VMS
      istat=lib$rename_file(oldname(1:ilo),newname(1:iln))
      if(istat.ne.1) then
        ier=1
      else
        ier=0
      endif
#endif
C
      return
      end

subroutine pc2ev(xget,yget,x,nx,y,ny,ilinx,iliny, &
     f,inf2,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a piecewise bilinear interpolant on a rectilinear
  !  grid -- this is C1 in both directions.
  !
  !  this subroutine calls two subroutines:
  !     herm2xy  -- find cell containing (xget,yget)
  !     pc2fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer ny,inf2,nx
  !============
  real(fp) :: xget,yget                    ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  integer iliny                     ! iliny=1 => assume y evenly spaced
  !
  real(fp) :: f(inf2,ny)                   ! function data
  !
  !       f 2nd dimension inf2 must be .ge. nx
  !       contents of f:
  !
  !  f(i,j) = f @ x(i),y(j)
  !
  integer ict(4)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return d2f/dxdy (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the fourth output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,1]
  !   on output fval= [f,df/dx,df/dy,d2f/dxdy]
  !
  !    on input ict = [1,0,0,0]
  !   on output fval= [f] ... elements 2 & 3 & 4 never referenced
  !
  !    on input ict = [0,1,1,0]
  !   on output fval= [df/dx,df/dy] ... element 3 & 4 never referenced
  !
  !    on input ict = [0,0,1,0]
  !   on output fval= [df/dy] ... elements 2 & 3 & 4 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j                       ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !
  real(fp), dimension(1) :: xparam,yparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy
  real(fp), dimension(1) :: hxi,hyi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm2xy(xget,yget,x,nx,y,ny,ilinx,iliny, &
       i(1),j(1),xparam(1),yparam(1), &
       hx(1),hxi(1),hy(1),hyi(1),ier)
  if(ier.ne.0) return
  !
  call pc2fcn(ict,1,1, &
       fval,i,j,xparam,yparam,hx,hxi,hy,hyi,f,inf2,ny)
  !
  return
end subroutine pc2ev
!---------------------------------------------------------------------
!  evaluate piecewise bilinear function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine pc2fcn(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,i,j,iadr
  !============
  real(fp) :: xp,xpi,yp,ypi
  !============
  integer ict(4)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec)         ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam(ivec)
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy(ivec)            ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec)          ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(inf2,ny)                 ! interpolant data (cf "pc2ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  pc2ev comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !
  real(fp) :: sum
  integer v
  !
  !   ...in x direction
  !
  do v=1,ivec
     i=ii(v)
     j=jj(v)
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     !
     !   ...in y direction
     !
     yp=yparam(v)
     ypi=1.0_fp-yp
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=ypi*(xpi*fin(i,j)+xp*fin(i+1,j)) &
             + yp*(xpi*fin(i,j+1)+xp*fin(i+1,j+1))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        sum=ypi*(fin(i+1,j)-fin(i,j)) &
             + yp*(fin(i+1,j+1)-fin(i,j+1))
        fval(v,iadr)=sum*hxi(v)
        !
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=xpi*(fin(i,j+1)-fin(i,j)) &
             + xp*(fin(i+1,j+1)-fin(i+1,j))
        fval(v,iadr)=sum*hyi(v)
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=fin(i+1,j+1)-fin(i,j+1)-fin(i+1,j)+fin(i,j)
        fval(v,iadr)=sum*hxi(v)*hyi(v)
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine pc2fcn
!---------------------------------------------------------------------
!  evaluate piecewise bilinear function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!    --optimized for VARIATION along x axis ONLY--
!
subroutine pc2fcnx(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,j,i,iadr
  !============
  real(fp) :: yp,ypi,xp,xpi
  !============
  integer ict(4)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj               ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy                  ! grid spacing, and
  real(fp) :: hxi(ivec),hyi                ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(inf2,ny)                 ! interpolant data (cf "pc2ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  pc2ev comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !
  real(fp) :: sum
  integer v
  !
  !   ...in x direction
  !
  j=jj
  !
  !   ...in y direction
  !
  yp=yparam
  ypi=1.0_fp-yp
  !
  do v=1,ivec
     i=ii(v)
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=ypi*(xpi*fin(i,j)+xp*fin(i+1,j)) &
             + yp*(xpi*fin(i,j+1)+xp*fin(i+1,j+1))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        sum=ypi*(fin(i+1,j)-fin(i,j)) &
             + yp*(fin(i+1,j+1)-fin(i,j+1))
        fval(v,iadr)=sum*hxi(v)
        !
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        !
        sum=xpi*(fin(i,j+1)-fin(i,j)) &
             + xp*(fin(i+1,j+1)-fin(i+1,j))
        fval(v,iadr)=sum*hyi
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        !
        sum=fin(i+1,j+1)-fin(i,j+1)-fin(i+1,j)+fin(i,j)
        fval(v,iadr)=sum*hxi(v)*hyi
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine pc2fcnx

subroutine nanscan_r4(ilun,zexpr,inum,zdata_r4,icount)

  ! look for NaNs or other floating invalids, by scanning ascii encoding

  implicit NONE

  integer, intent(in) :: ilun        ! I/O unit number
  character*(*), intent(in) :: zexpr ! expression or label identifying the data
  integer, intent(in) :: inum        ! number of data points
  real, intent(inout) :: zdata_r4(inum) ! data to be scanned
  integer, intent(inout) :: icount   ! NaN count -- incremented

  !--------------------------
  character*30 :: nanscan
  integer :: iwarn,ii
  !--------------------------

  iwarn=0
  do ii=1,inum
     nanscan=' '
     write(nanscan,*) zdata_r4(ii)
     if(index(nanscan,'.').eq.0) then

        icount = icount + 1
        zdata_r4(ii) = 0.0

        iwarn=iwarn+1
        if(iwarn.le.5) then
           write(ilun,*) ' ***NaNscan: at index ',ii,': ',trim(nanscan), &
                ' detected in ',trim(zexpr)
        else if(iwarn.eq.6) then
           write(ilun,*) ' [more NaNs were detected...]'
        endif

     endif
  enddo

end subroutine nanscan_r4

MODULE ezcdf_inqvar
 
  implicit none
 
  PUBLIC :: cdfInqVar, cdfgv, cdfInqV, cdf_inquire, alpha_numeric

  INTERFACE cdfInqVarDim
      MODULE PROCEDURE cdfInqV, cdfgv
  END INTERFACE

  PRIVATE
  include "netcdf.inc"

  character*(nf_max_name) :: varnam_noalpha
  PRIVATE varnam_noalpha
 
CONTAINS
 
subroutine cdfInqVar(ncid,varnam,dimlens,eztype,ier)
  ! Inquire a Variable and its dimensions
  ! 03/08/99 C. Ludescher
  ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
  ! + support for complex type (ap) Wed May 16 15:18:05 EDT 2001
  implicit none
  ! Input
  integer,       intent(in)          :: ncid
  character*(*), intent(in)          :: varnam
  ! Output
  integer, dimension(:), intent(out) :: dimlens
  character*(*),           intent(out) :: eztype
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: ndims, varid, natts, xtype
  integer                 :: status, i
  integer, dimension(3)   :: dimids
  character*(nf_max_name) :: name
  integer, parameter      :: cmplx_len = 13
  character(cmplx_len), parameter :: cmplx_name = '__CmPlx_Re_Im'
  character*11, parameter :: logical_name = '__logical__'
  logical :: is_complex, is_logical
 
  if (PRESENT (ier)) ier = 1
  is_complex = .false.
  is_logical = .false.
  eztype = '??'
 
! replace any non-alphanumeric characters with underscores
  varnam_noalpha = varnam
  CALL alpha_numeric(varnam_noalpha)

  status = nf_inq_varid(ncid,varnam_noalpha,varid)
  if (status .ne. 0) then
     ! perhaps varnam is complex, try...
     status = nf_inq_varid(ncid,trim(varnam_noalpha)//cmplx_name,varid)
     if(status .eq. 0) then
        is_complex = .true.
     else
        status = nf_inq_varid(ncid,trim(varnam_noalpha)//logical_name,varid)
        if(status .eq. 0) is_logical = .true.
     endif
  endif

  if(is_complex)  varnam_noalpha = trim(varnam_noalpha)//cmplx_name
  if(is_logical)  varnam_noalpha = trim(varnam_noalpha)//logical_name
! call ezcdf_error(status,varnam_noalpha,'cdfInqVar','nf_inq_varid')
  if(status .ne. 0) return
 
  status = nf_inq_var(ncid,varid,name,xtype,ndims,dimids,natts)
  call ezcdf_error(status,varnam_noalpha,'cdfInqVar','nf_inq_var')
  if (status .ne. 0) return
 
  if (size(dimlens) .lt. ndims) return
  dimlens = 0
 
  select case (xtype)
  case (nf_double)
     eztype = 'R8'
     if(is_complex) eztype = 'C16'
  case (nf_int)
     eztype = 'INT'
     if(is_logical) eztype = 'LOG'
!  case (nf_byte)
!     eztype = 'LOG'
  case (nf_float)
     eztype = 'R4'
     if(is_complex) eztype = 'C8'
  case (nf_char)
     eztype = 'CHAR'
  end select
 
  do i=1,ndims
     status = nf_inq_dim(ncid,dimids(i),name,dimlens(i))
     call ezcdf_error(status,varnam,'cdfInqVar','nf_inq_dim')
  end do
 
  if(is_complex) then
     dimlens(1) = dimlens(1)/2
  endif
  if (PRESENT (ier)) ier = status
 
end subroutine cdfInqVar
 
  ! automatic conversion to free f90 compatible form
  ! free.pl cdfgv.for
  ! linewidth: 72
  ! file names: cdfgv.for
  !
  !23456789-123456789-123456789-123456789-123456789-123456789-123456789-23
  SUBROUTINE cdfgv(ncid,varnam,varid,dimlens,sizes,xtype,status)
    !
    !     Get Variable id, etc.
    !     02/11/99 C.Ludescher
    ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
    !
    implicit none
!!$      include "netcdf.inc"
    ! Input
    integer                 :: ncid
    character*(*)           :: varnam
    character*1             :: xtype
    integer, dimension(:)   :: sizes
    ! Output
    integer, dimension(:)   :: dimlens
    integer                 :: varid, status
    ! Local
    integer                 :: i, vartyp, ndims, atts, rank
    integer, dimension(3)   :: dimids
    character*(nf_max_name) :: name

!   replace any non-alphanumeric characters with underscores
    varnam_noalpha = varnam
    CALL alpha_numeric(varnam_noalpha)
    
    status = nf_inq_varid(ncid,varnam_noalpha,varid)
!   call ezcdf_error(status,varnam,'cdfgv','nf_inq_varid')
    if (status .ne. 0) return
    status = nf_inq_var(ncid,varid,name,vartyp,ndims,dimids,atts)
    call ezcdf_error(status,varnam,'cdfgv','nf_inq_var')
    if (status .ne. 0) return
    ! Verify input dimension is correct
    rank = size(sizes)
    status = 1
    if (ndims .eq. 3 .and. rank .ne. 3) then
       print "('% cdfgv: --E-- The variable ',a,                      &
            &         ' is 3 dimensional')",varnam
       return
    else if (ndims .eq. 2 .and. rank .ne. 2) then
       print "('% cdfgv: --E-- The variable ',a,                      &
            &         ' is 2 dimensional')",varnam
       return
    endif
    if (ndims .eq. 0 .and. sizes(1) .ne. 0) then
       print "('% cdfgv: --E-- The variable ',a,                      &
            &           ' is a Scalar')",varnam
       return
    else if (ndims .eq. 1 .and. rank .ne. 1 ) then
       print "('% cdfgv: --E-- The variable ',a,                      &
            &           ' is 1 dimensional')",                                 &
            &         varnam
       return
    endif
    ! Verify data type is matching
    select case (xtype)
    case ('i')
       if(vartyp .ne. nf_int) then
          print "('% cdfgv: --E-- ',a,' is of type Integer !')",      &
               &             varnam
          return
       end if
    case ('l')
       if(vartyp .ne. nf_byte) then
          print "('% cdfgv: --E-- ',a,' is of type logical !')",         &
               &            varnam
          return
       end if
    case ('d')
       if(vartyp .ne. nf_double) then
          print "('% cdfgv: --E-- ',a,' is of type REAL*8 !')",       &
               &            varnam
          return
       end if
    case ('r')
       if(vartyp .ne. nf_real) then
          print "('% cdfgv: --E-- ',a,' is of type default REAL !')",       &
               &            varnam
          return
       end if
    case ('c')
       if(vartyp .ne. nf_char) then
          print "('% cdfgv: --E-- ',a,' is of type Character !')",         &
               &            varnam
          return
       end if
    end select
    status = 0
    do i=1,ndims
       dimlens(i) = 0
       status = nf_inq_dim(ncid,dimids(i),name,dimlens(i))
       call ezcdf_error(status,varnam,'cdfgv','nf_inq_dim')
    end do
    ! Check array size is big enough
    select case (ndims)
    case (1)
       if(dimlens(1) .gt. sizes(1) ) then
          print "('% cdfgv: --W-- Output array size =',I6,/           &
               &           '                is smaller than ',                    &
               &           a,' size =',I6/,                                       &
               &           '                output will be truncated !')",        &
               &         sizes(1),varnam,dimlens(1)
       endif
    case (2)
       if(dimlens(1) .gt. sizes(1) .or. dimlens(2) .gt. sizes(2)) then
          print "('% cdfgv: --W-- Output array size =',I6,' *',I6,/      &
               &           '                is smaller than ',                    &
               &           a,' size =',I6,' *',I6/,                               &
               &           '                output will be truncated !')",        &
               &         sizes(1),sizes(2),varnam,dimlens(1),dimlens(2)
       endif
    case (3)
       if(dimlens(1) .gt. sizes(1) .or. dimlens(2) .gt. sizes(2)         &
            &   .or. dimlens(3) .gt. sizes(3)) then
          print "('% cdfgv: --W-- Output array size =',                  &
               &          I5,' *',I5,' *',I5/,                                    &
               &           '                is smaller than ',                    &
               &           a,' size =',I5,' *',I5,' *',I5/,                       &
               &           '                output will be truncated !')",        &
               &         sizes(1),sizes(2),sizes(3),varnam,                       &
               &         dimlens(1),dimlens(2),dimlens(3)
       endif
    end select

  end SUBROUTINE cdfgv
 
  SUBROUTINE cdfInqV(ncid,varnam,varid,dimlens,ndims,status)
    ! Inquire variable-id and dimlens
    ! 03/09/99 C.Ludescher
    !
    implicit none
    !
!!$      include "netcdf.inc"
    ! Input
    integer,       intent(in)  :: ncid
    character*(*), intent(in)  :: varnam
    ! Returns
    !      integer, dimension(3)  ::  dimlens
    !      integer ::  ndims, varid
    !      integer ::  status
    integer, dimension(:), intent(out)   ::  dimlens
    integer,               intent(out)   ::  ndims, varid
    integer,               intent(out)   ::  status
    ! Local
    integer                 :: natts, xtype, i
    integer, dimension(3)   :: dimids
    character*(nf_max_name) :: name
    !---------------------------------------------------------------------------
!   replace any non-alphanumeric characters with underscores
    varnam_noalpha = varnam
    CALL alpha_numeric(varnam_noalpha)

    status = nf_inq_varid(ncid,varnam_noalpha,varid)
!    call ezcdf_error(status,varnam,'cdfInqV','nf_inq_varid')
    if (status .ne. 0) return
    status = nf_inq_var(ncid,varid,name,xtype,ndims,dimids,natts)
    call ezcdf_error(status,varnam,'cdfInqV','nf_inq_var')

    if (ndims .gt. size(dimlens)) stop 'dimlens too small in cdfInqV'

    do i=1,ndims
       status = nf_inq_dimlen(ncid,dimids(i),dimlens(i))
       call ezcdf_error(status,varnam,'cdfInqV','nf_inq_dimlen')
    end do
  END SUBROUTINE cdfInqV
 
  SUBROUTINE cdf_inquire(ncid,varnam,dimlens,xtype,ier)
       implicit none
       ! Input
       integer,       intent(in)            :: ncid
       character*(*), intent(in)            :: varnam
       ! Output
       integer, dimension(:),   intent(out) :: dimlens
       character*(*), optional, intent(out) :: xtype
       integer, optional,       intent(out) :: ier
       integer :: ezerror
       character*4 :: eztype
 
       CALL cdfInqVar(ncid, varnam, dimlens, eztype, ezerror)
 
       IF (PRESENT(xtype)) xtype = eztype
       IF (PRESENT(ier)) ier = ezerror
 
  END SUBROUTINE cdf_inquire
 
  SUBROUTINE alpha_numeric(string)
     IMPLICIT NONE
     CHARACTER*(*), INTENT(INOUT)     :: string
     CHARACTER*(LEN_TRIM(string))     :: temp
     INTEGER                          :: iascii, i

  ! 04/03/03 S. Hirshman
  ! replaces any non-alphanumeric characters with underscores
     temp = adjustl(string)
     string = trim(temp)
     do i = 2, len_trim(string)
       iascii = iachar(string(i:i))
       if ( ((iascii >= iachar('0')) .and. (iascii <= iachar('9')))           &
      .or.  ((iascii >= iachar('A')) .and. (iascii <= iachar('z')))) cycle
       string(i:i) = '_'
     end do

  END SUBROUTINE alpha_numeric

END MODULE ezcdf_inqvar

      SUBROUTINE SHOWDEFL(DEVNAM,LDEV,DIRNAM,LDIR)
C
#ifdef __NAGWARE
      use f90_unix_dir
#endif
      implicit none
C
C  GET THE CURRENT DEFAULT DISK AND DIRECTORY BY PARSING A DUMMY
C  FILENAME WITH THE RMS SERVICE CALL
C  DMC:  FOLLOWING HINTS BY M. THOMPSON
C
 
      CHARACTER*(*) DEVNAM  ! OUTPUT DEVICE NAME
      CHARACTER*(*) DIRNAM  ! OUTPUT DIRECTORY NAME
 
      INTEGER LDEV	      ! OUTPUT LENGTH OF DEVICE NAME
      INTEGER LDIR	      ! OUTPUT LENGTH OF DIRECTORY NAME
 
#ifdef __UNIX
      integer str_length
      integer istat
#ifndef __NAGWARE
      integer getcwd
#endif
 
#endif  /* __UNIX */
 
C-----------------------------------------------------------------------
C  VAX CODE
#ifdef __VMS
      CHARACTER*8 DUMNAM/'FOOO.FOO'/	! DUMMY FILENAME
C
      devnam=' '
      dirnam=' '
      CALL SHOWFILE(DUMNAM,DEVNAM,LDEV,DIRNAM,LDIR)
#endif
C
C-----------------------------------------------------------------------
C  UNIX CODE -- DMC 22 May 1992
C
#ifdef __UNIX
      ldev=0
      devnam=' '
C
      ldir=0
      dirnam=' '
#ifdef __NAGWARE
      call getcwd(dirnam,ldir,istat)
#elif __X1
      call cgetcwd(dirnam,ldir,istat)
#else
      istat=getcwd(dirnam)
#endif
C
#if __CRAY
      if (istat.le.0) dirnam='UNKNOWN'
#elif __HP
      if (istat.eq.0) then
         print *,' ...sget_cwd:showdefl - dirnam =',dirnam
         if (dirnam(1:1) .eq. ' ') dirnam='UNKNOWN'
      endif
#elif __IBM || __RS6000 || __SGI
      if (istat.eq.0) dirnam='UNKNOWN'
#endif
C
      call str_pad(dirnam)
C
      ldir=str_length(dirnam)
#endif  /* __UNIX */
C
      RETURN
      END

subroutine mkherm3(fun,x,nx,y,ny,z,nz,fherm)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, from evaluation of
  !  function and derivatives.  Function of 3 indep. coordinates.
  !
  !  input:
  !
  !============
  implicit none
  integer ny,nz,nx,iz,iy,ix
  !============
  real(fp) :: fun,dfdx,dfdy,dfdz,d2fdxdy,d2fdxdz,d2fdydz,d3fdxyz
  !============
  external fun                      ! passed real function(x,y,z)
  real(fp) :: x(nx)                        ! x coordinate array  (1st dim)
  real(fp) :: y(ny)                        ! y coordinate array  (2nd dim)
  real(fp) :: z(nz)                        ! z coordinate array  (3rd dim)
  !
  !  the passed function fun must have the interface:
  !
  !        real function <name>(x,y,z,dfdx,dfdy,dfdz,
  !               d2fdxdy,d2fdxdz,d2fdydz,d3fdxdydz)
  !  where x,y,z are input, the function returns the function value,
  !  and the arguments dfdx, dfdy and dfdz return as output the function
  !  derivative at the point (x,y,z).
  !
  !  output:
  !
  real(fp) :: fherm(0:7,nx,ny,nz)          ! function data & derivatives
  !
  !  fherm(0,i,j,k) = function value f at x(i),y(j),z(k)
  !  fherm(1,i,j,k) = derivative df/dx at x(i),y(j),z(k)
  !  fherm(2,i,j,k) = derivative df/dy at x(i),y(j),z(k)
  !  fherm(3,i,j,k) = derivative df/dz at x(i),y(j),z(k)
  !  fherm(4,i,j,k) = derivative d2f/dxdy at x(i),y(j),z(k)
  !  fherm(5,i,j,k) = derivative d2f/dxdz at x(i),y(j),z(k)
  !  fherm(6,i,j,k) = derivative d2f/dydz at x(i),y(j),z(k)
  !  fherm(7,i,j,k) = derivative d3f/dxdydz at x(i),y(j),z(k)
  !
  !----------------------------
  !
  do iz=1,nz
     do iy=1,ny
        do ix=1,nx
           fherm(0,ix,iy,iz)= &
                fun(x(ix),y(iy),z(iz),dfdx,dfdy,dfdz, &
                d2fdxdy,d2fdxdz,d2fdydz,d3fdxyz)
           fherm(1,ix,iy,iz)=dfdx
           fherm(2,ix,iy,iz)=dfdy
           fherm(3,ix,iy,iz)=dfdz
           fherm(4,ix,iy,iz)=d2fdxdy
           fherm(5,ix,iy,iz)=d2fdxdz
           fherm(6,ix,iy,iz)=d2fdydz
           fherm(7,ix,iy,iz)=d3fdxyz
        end do
     end do
  end do
  !
  return
end subroutine mkherm3

subroutine mktricubw(x,nx,y,ny,z,nz,f,nf2,nf3, &
     ibcxmin,bcxmin,ibcxmax,bcxmax,inb1x, &
     ibcymin,bcymin,ibcymax,bcymax,inb1y, &
     ibczmin,bczmin,ibczmax,bczmax,inb1z, &
     wk,nwk,ilinx,iliny,ilinz,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup a tricubic spline; store coefficients in compatct form
  !  (as per suggestion of L. Zakharov, PPPL, Feb. 1999)
  !  8 coeffs per (x,y,z) grid point:
  !          f,fxx,fyy,fzz,fxxyy,fxxzz,fyyzz,fxxyyzz
  !
  !  input:
  !============
  implicit none
  integer itest,iadfp,isiz1,iadfw,inwk
  !============
  real(fp) :: hxlast,hylast,hzlast
  !============
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  integer nz                        ! length of z vector
  real(fp) :: x(nx)                        ! x vector, strict ascending
  real(fp) :: y(ny)                        ! y vector, strict ascending
  real(fp) :: z(nz)                        ! z vector, strict ascending
  !
  integer nf2                       ! 2nd dim. of f array, nf2.ge.nx
  integer nf3                       ! 3rd dim. of f array, nf3.ge.ny
  !
  !  input/output:
  !
  real(fp) :: f(8,nf2,nf3,nz)              ! data and spline coefficients
  !
  !  on input:  f(1,i,j,k) = f(x(i),y(j),z(k))
  !  on output:  f(1,i,j,k) unchanged
  !              f(2,i,j,k) = d2f/dx2(x(i),y(j),z(k))
  !              f(3,i,j,k) = d2f/dy2(x(i),y(j),z(k))
  !              f(4,i,j,k) = d2f/dz2(x(i),y(j),z(k))
  !              f(5,i,j,k) = d4f/dx2dy2(x(i),y(j),z(k))
  !              f(6,i,j,k) = d4f/dx2dz2(x(i),y(j),z(k))
  !              f(7,i,j,k) = d4f/dy2dz2(x(i),y(j),z(k))
  !              f(8,i,j,k) = d6f/dx2dy2dz2(x(i),y(j),z(k))
  !
  !  there is a rather Hermite like interpolation formula to go with
  !  this-- see evtricub.f90.  Also the bicubic formula is given in
  !  mkbicubw.f90; the tricubic formula is precisely analogous.
  !
  !  boundary condition data
  !  inputs:
  integer inb1x                     ! 1st dim of xmin & xmax bc arrays
  integer inb1y                     ! 1st dim of ymin & ymax bc arrays
  integer inb1z                     ! 1st dim of zmin & zmax bc arrays
  !
  integer ibcxmin,ibcxmax           ! BC type flag @xmin, xmax
  integer ibcymin,ibcymax           ! BC type flag @ymin, ymax
  integer ibczmin,ibczmax           ! BC type flag @zmin, zmax
  !
  real(fp) :: bcxmin(inb1x,nz),bcxmax(inb1x,nz) ! xmin & xmax BC data, ny x nz
  real(fp) :: bcymin(inb1y,nz),bcymax(inb1y,nz) ! ymin & ymax BC data, nx x nz
  real(fp) :: bczmin(inb1z,ny),bczmax(inb1z,ny) ! zmin & zmax BC data, nx x ny
  !
  !  where BC data is not required, dummy scalars may be passed.
  !  the ibc* flags determine whether BC data isneeded.
  !
  !  BC data:  bcxmin & bcxmax:  BC vs. y,z @xmin,xmax
  !            bcymin & bcymax:  BC vs. x,z @ymin,ymax
  !            bczmin & bczmax:  BC vs. x,y @zmin,zmax
  !
  !   ibcxmin -- indicator for boundary condition at xmin=x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- use periodic boundary condition
  !     =0 -- use "not a knot"
  !     =1 -- match slope, specified at x(1),y(iy),z(iz) by bcxmin(iy,iz)
  !     =2 -- match 2nd derivative, specified at x(1),y(iy),z(iz)
  !           by bcxmin(iy,iz
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all y(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all y(j)
  !     =5 -- match 1st derivative to 1st divided difference
  !     =6 -- match 2nd derivative to 2nd divided difference
  !     =7 -- match 3rd derivative to 3rd divided difference
  !           (for more detailed definition of BCs 5-7, see the
  !           comments of subroutine mkspline)
  !   ***NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !     NOTE:  if ibcxmin=-1 then the periodic BC applies on both sides
  !            and ibcxmax, bcxmax are ignored.
  !   inb1x -- 1st dimension of bcxmin, bcxmax: if ibcxmin or ibcxmax .gt. 0
  !            this must be .ge. ny.
  !
  !   interpretation of ibcymin,bcymin,ibcymax,bcymax,inb1y
  !     is same as with ibcxmin,...
  !
  !   interpretation of ibczmin,bczmin,ibczmax,bczmax,inb1z
  !     is same as with ibcxmin,...
  !
  !   the explicit bdy condition arrays are referenced only if the
  !     corresponding "ibc" flag values are set to 1 or 2.
  !
  !  workspace:
  integer nwk                       ! size of workspace
  real(fp) :: wk(nwk)                      ! workspace array
  !
  !  this version requires a very large workspace, nwk.ge.80*nx*ny*nz
  !  so as to be able to use tcspline to calculate the spline coefficients.
  !
  !  output:
  integer ilinx                     ! x vector equal spacing flag
  integer iliny                     ! y vector equal spacing flag
  integer ilinz                     ! z vector equal spacing flag
  !
  !   ilinx -- =1 on output if x(nx) pts are nearly evenly spaced (tol=1e-3)
  !   iliny -- =1 on output if y(ny) evenly spaced (tol=1e-3)
  !   ilinz -- =1 on output if z(nz) evenly spaced (tol=1e-3)
  !
  integer ier                       ! exit code
  !   ier -- completion code, 0 for normal
  !
  !-----------------------------------------------------
  !
  itest=80*nx*ny*nz
  if(nwk.lt.itest) then
     write(6,9901) nwk,itest
9901 format(' ?mktricubw:  workspace too small:'/ &
          '  user supplied:  nwk=',i7,'; need at least:  ',i7/ &
          '  nwk = at least 21*nx*ny is required.')
     ier=1
     return
  end if
  !
  iadfp=1
  isiz1=64*nx*ny*nz
  iadfw=iadfp+isiz1
  inwk = nwk-isiz1
  !
  call mktricop(f,nf2,nf3,wk(iadfp),nx,ny,nz)
  !
  !  evaluate 4x4x4 continuous tricubic spline
  !
  call tcspline(x,nx,y,ny,z,nz,wk(iadfp),nx,ny, &
       ibcxmin,bcxmin,ibcxmax,bcxmax,inb1x, &
       ibcymin,bcymin,ibcymax,bcymax,inb1y, &
       ibczmin,bczmin,ibczmax,bczmax,inb1z, &
       wk(iadfw),inwk,ilinx,iliny,ilinz,ier)
  !
  !  convert to 8-coefficient form
  !
  hxlast=x(nx)-x(nx-1)
  hylast=y(ny)-y(ny-1)
  hzlast=z(nz)-z(nz-1)
  call mktricon(f,nf2,nf3,wk(iadfp),nx,ny,nz,hxlast,hylast,hzlast)
  !
  return
end subroutine mktricubw
!----------------------------------------------------------------
!  mktricop -- copy spline function input data
!
subroutine mktricop(fin,nf2,nf3,fwk,nx,ny,nz)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nf3,nx,ny,nz,nf2,iz,iy,ix
  !============
  real(fp) :: fin(8,nf2,nf3,nz)
  real(fp) :: fwk(4,4,4,nx,ny,nz)
  !
  do iz=1,nz
     do iy=1,ny
        do ix=1,nx
           fwk(1,1,1,ix,iy,iz)=fin(1,ix,iy,iz)
        end do
     end do
  end do
  !
  return
end subroutine mktricop
!----------------------------------------------------------------
!  mktricon -- create compact spline representation from 4x4
!             (bcspline) representation
!
subroutine mktricon(fin,nf2,nf3,fwk,nx,ny,nz, &
     hxlast,hylast,hzlast)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nf3,nx,ny,nz,nf2,iz,iy,ix,iflag,ixuse,iyuse,izuse,j
  !============
  real(fp) :: hxlast,hylast,hzlast,dxuse,dyuse,dzuse
  !============
  real(fp) :: fin(8,nf2,nf3,nz)
  real(fp) :: fwk(4,4,4,nx,ny,nz)
  !-----------------------------------------------------
  !  local arrays
  !
  integer iselect(10)
  real(fp) :: zvalues(10)
  !
  data iselect/-1,0,0,0,0,0,0,0,0,0/
  !
  !-----------------------------------------------------
  !
  do iz=1,nz
     do iy=1,ny
        do ix=1,nx
           !
           !  copy derivatives from result.  Special treatment needed for end zones
           !
           iflag=0
           dxuse=0.0_fp
           dyuse=0.0_fp
           dzuse=0.0_fp
           ixuse=ix
           iyuse=iy
           izuse=iz
           !
           if(ix.eq.nx) then
              iflag=1
              dxuse=hxlast
              ixuse=ix-1
           end if
           if(iy.eq.ny) then
              iflag=1
              dyuse=hylast
              iyuse=iy-1
           end if
           if(iz.eq.nz) then
              iflag=1
              dzuse=hzlast
              izuse=iz-1
           end if
           !
           if(iflag.eq.1) then
              call tcspevfn(iselect,1,1,zvalues, &
                   ixuse,iyuse,izuse,dxuse,dyuse,dzuse, &
                   fwk,nx,ny,nz)
              do j=2,8
                 fin(j,ix,iy,iz)=zvalues(j)
              end do
           else
              fin(2,ix,iy,iz)=2.0_fp*fwk(3,1,1,ix,iy,iz)
              fin(3,ix,iy,iz)=2.0_fp*fwk(1,3,1,ix,iy,iz)
              fin(4,ix,iy,iz)=2.0_fp*fwk(1,1,3,ix,iy,iz)
              fin(5,ix,iy,iz)=4.0_fp*fwk(3,3,1,ix,iy,iz)
              fin(6,ix,iy,iz)=4.0_fp*fwk(3,1,3,ix,iy,iz)
              fin(7,ix,iy,iz)=4.0_fp*fwk(1,3,3,ix,iy,iz)
              fin(8,ix,iy,iz)=8.0_fp*fwk(3,3,3,ix,iy,iz)
           end if
           !
        end do
     end do
  end do
  !
  return
end subroutine mktricon

module mpi_proc_data
!. mpi_proc_data                      module to store process rank and node data on a 
!                   short list of MPI  communicators  (the serial code has an especially short list),
!                   & handle inter-process file transmission
!
!
!  Author                            D. McCune @ pppl.gov
!  Version                           1.01,  05Dec2011
!  Modifications
!
!  1.02  10Feb2012                   C.Ludescher-Furth @ pppl.gov
!                                    add comm-name to mpi_env_comm_add
!                                    interface mpi_proc_info to get comm from name
!                                    interface find_comm to get index from name
!
!  1.01  05Dec2011                   Jim.Conboy@ccfe.ac.uk
!                                    mpi_env_comm_add, mpi_bcast_list -
!                                    Add more comments, label major loops
!                                    NO functional changes
!
!  1.00  05May2011                   D. McCune @ pppl.gov
!                                    Committed, svn rev 14909
!
!----_^---------------------------------=========================================|
!
!
#ifdef __MPI
  use mpi
#endif

  implicit NONE
  PRIVATE
  SAVE
!
!..GLOBAL
!
  PUBLIC :: mpi_proc_info,mpi_env_comm_add,mpi_print_info
  PUBLIC :: mpi_proc_info_comm, mpi_proc_info_name
  PUBLIC :: mpi_set_filesys
  PUBLIC :: mpi_mkdir,mpi_file_bcast,mpi_file_transfer
  PUBLIC :: mpi_file_bcast_single,mpi_file_bcast_list
  PUBLIC :: nodepath_translator
  PUBLIC :: check_mpi_io_node, mpi_parallel_file_system

  private :: comm_arg        !  Translates comm ID to 0 ifndef _MPI
  private :: find_comm

  INTERFACE mpi_file_bcast
     module procedure mpi_file_bcast_single,mpi_file_bcast_list
  END INTERFACE

  INTERFACE mpi_proc_info
     module procedure mpi_proc_info_comm, mpi_proc_info_name
  END INTERFACE

  INTERFACE find_comm
     module procedure find_index_comm, find_index_name
  END INTERFACE


#ifdef __MPI
!  integer, parameter :: max_comm = 250
  integer, parameter :: max_comm = 20   ! CLF: dont think we need 250
#else
  integer, parameter :: max_comm = 1
#endif

  logical, parameter :: loc_debug = .FALSE.
! logical, parameter :: loc_debug = .TRUE.

  integer, parameter :: ncnode = 140       ! max characters in node name

  type :: comdat
     ! saved data for one communicator, this process
     integer :: comm        ! communicator 
                            ! if not in group: MPI_COMM_NULL (=2)
     integer :: group       ! group (handle)
     integer :: num_procs   ! #processors (size)
     integer :: myproc      ! #this process (rank in this group)
                            ! if not in group: MPI_UNDEFINED
     integer :: num_nodes   ! #nodes
     integer :: mynode      ! #this node

     character(len=18)     :: comm_name    ! print name of communicator
     character(len=ncnode) :: mynode_name  ! name this node

     integer :: mynode_numprocs    ! #processors on this node (for comm)
     integer :: maxnode_numprocs   ! max #processors on any node (for comm)

     integer, dimension(:),   allocatable :: mynode_proclist    ! list of ranks
     integer, dimension(:),   allocatable :: allnode_numprocs   ! #s on each node
     integer, dimension(:,:), allocatable :: allnode_proclists  ! all ranks
                                                                !    allnode_proclists(j,k) = rank of j'th process on k'th node
                                                                !      =-1 if j > allnode_numprocs(k)

     integer, dimension(:), allocatable :: node_map  ! rank->node map
                                                     !    rank r is on node allnode_names(node_map(r))

     character(len=ncnode), dimension(:), allocatable :: allnode_names ! all nodenames

     character(len=255) :: save_path
  end type comdat

  !=====================================================================
  !  **** module variables ****
  !
  !  for all known communicators...

  integer :: ncomm = 0

  type (comdat) :: comm_data(max_comm)

  !  file system information...

  logical      :: pll_file_sys_flag = .TRUE.    ! (default value)
  character*20 :: file_sys_ident    = 'UNKNOWN' ! (default value)

  !  if(pll_file_sys_flag) -- rank(0) of each communicator is "I/O process".
  !  if(.NOT.pll_file_sys_flag) -- 1st rank on each node for each communicator
  !                                serves as "I/O process".
  !
  !  file_sys_ident:
  !  "PPPLCLUSTER" file system -- pll_file_sys_flag = .FALSE.
  !-------------------------------------
  !  (for module local use only)...

  integer :: indx = 0   ! index into comm_data (private use)

#ifdef __MPI
  integer :: istatus(MPI_STATUS_SIZE)  ! (local for MPI_RECV calls)
#endif

  character*200 :: cwd    ! current working directory (this rank) ( GLOBAL !! )
  character*200 :: cwd_0  ! current working directory (rank 0)

  character(len=*), parameter :: cMd = 'portlib/mpi_proc_data'
  !=====================================================================

CONTAINS

  !---------------------------------------------------
  !  PUBLIC...

! 02/07/2012 CLF: How about sanity check for group?
!  subroutine mpi_env_comm_add(comm, group, ierr)
  subroutine mpi_env_comm_add(comm, ierr, name, group_in)

    ! add a communicator to the list
    ! (if already there, do nothing)
    ! 02/15/2012 CLF: add by group-name if process is not in group
    !                 in this case comm=MPI_COMM_NULL
    ! error returns:
    !   ierr=1 means the communicator data setup failed
    !   ierr=2 means the maximum number of communicators has been exceeded.
    !   CAUTION: for collective operation errors MPI_ABORT may be issued...

    ! MPI version: 
    ! it is assumed that the caller has already done MPI_INIT(...).

    ! serial version:
    ! single dummy communicator data setup; hostname still fetched.

    integer, intent(in)  :: comm
    integer, intent(out) :: ierr
    character(len=*), intent(in),optional   :: name       ! group name 
    integer, intent(in),optional            :: group_in   ! group handle

    !----------------------------------
    integer :: icomm,ii,jj,kk,imatch,ierloc,iam,ilen

    integer :: ilen_max         ! length of node name array
    integer :: isize_all        ! = num_procs, total # mpi processes ( in comm world )
    integer :: ierr_my, iabort         
    integer :: ifrom, ito, itag, ibase
    integer :: ichname(140)
    integer :: nact, imax

    character(len=140), dimension(:), allocatable :: allnames    ! node names, subscripted by process mpi ID
    character(len=140), dimension(:), allocatable :: actnames    ! node names - unique list ( 1 entry each node )

    integer, dimension(:),   allocatable :: iactcount
    integer, dimension(:,:), allocatable :: iactnames   ! character representation of actnames strings
    !
    character(len=*), parameter :: cSr = cMd//'.mpi_env_comm_add'
    !-------------------------------------------------------------------------------------------

    ierr = 0
    icomm = comm_arg(comm)                   ! mpi_proc_data.comm_arg

    if (present(name)) then
       call find_comm(name,imatch)
    else   
       call find_comm(icomm,imatch)
    endif

    if(imatch.gt.0) return
    
    ! no match, add to list
    
    if(ncomm.eq.max_comm)    then
       ierr=2
       if(loc_debug) write(0,*) ' ?mpi_proc_data: max_comm exceeded. '
       return
    endif

    ncomm = ncomm + 1
    
    comm_data(ncomm)%comm = icomm
    comm_data(ncomm)%mynode_name = ' '
    
    indx = ncomm

    
#ifdef __MPI

   !Check for group name
    if (present(name)) then
       comm_data(ncomm)%comm_name=name
    else if (icomm .eq. MPI_COMM_WORLD) then
       comm_data(ncomm)%comm_name='MPI_COMM_WORLD'
    else
       comm_data(ncomm)%comm_name=' '
    endif
    if (icomm .eq. MPI_COMM_NULL) then
       comm_data(ncomm)%myproc=-1
       return
    endif
      
    l_get_proc_names: do          !  one trip (only) loop; uses   exit <loop> for error jump
       iabort = 0

       call MPI_COMM_GROUP(icomm, comm_data(ncomm)%group, ierloc)
       call ckerr('MPI_COMM_GROUP',ierloc,ierr)

       call MPI_COMM_RANK(icomm, comm_data(ncomm)%myproc, ierloc)
       call ckerr('MPI_COMM_RANK',ierloc,ierr)

       call MPI_COMM_SIZE(icomm, comm_data(ncomm)%num_procs, ierloc)
       call ckerr('MPI_COMM_SIZE',ierloc,ierr)

       if(ierr.gt.0) exit l_get_proc_names

       isize_all = comm_data(ncomm)%num_procs
       iam = comm_data(ncomm)%myproc

       !  this processor (node name)...
       comm_data(ncomm)%mynode_name = ' '
       call MPI_GET_PROCESSOR_NAME(comm_data(ncomm)%mynode_name, ilen, ierloc)
       call ckerr('MPI_GET_PROCESSOR_NAME',ierloc,ierr)

       if(ierr.gt.0) exit l_get_proc_names

       if(loc_debug.AND.(iam.eq.0)) then
          write(0,*) ' %mpi_proc_data(debug): icomm,isize_all = ', &
               icomm,isize_all
       endif

       !  length of name -- 
       ilen = len(trim(comm_data(ncomm)%mynode_name))

       !  length of name string --                                 [ Must be ncnode ?? jec
!      ilen_max = len(comm_data(ncomm)%mynode_name)                [ yes CLF
       ilen_max = ncnode

       ibase = 0

       iabort = 1  ! subsequent collective failures => MPI_ABORT call...

       !--------------------------
       !  gather all node names on proc 0
       !--------------------------

       i_get_allnames:  if(iam.eq.0) then        !  V  iam 0
          if(allocated(allnames)) deallocate(allnames,actnames,iactcount)
          allocate(allnames(0:isize_all-1),actnames(isize_all))
          allocate(iactcount(isize_all))

          allnames(iam) = comm_data(ncomm)%mynode_name

          l_rcv_names: do ifrom=1,isize_all-1

             itag = ibase + ifrom
             call MPI_RECV(ichname, ilen_max, MPI_INTEGER, ifrom, &
                itag, icomm, istatus, ierloc)
             call ckerr('MPI_RECV',ierloc,ierr)
             if(ierr.gt.0)   exit

             allnames(ifrom)=' '
             do ii=1,ilen_max
                if(ichname(ii).eq.0)   exit
                allnames(ifrom)(ii:ii) = char(ichname(ii))
             enddo
          enddo l_rcv_names

       else                                      !  V   not 0 ( i_get_allnames 

          ichname = 0
          do ii=1,ilen
             ichname(ii) = ichar(comm_data(ncomm)%mynode_name(ii:ii))
          enddo

          itag = ibase + iam
          call MPI_SEND(ichname, ilen_max, MPI_INTEGER, 0, &
               itag, icomm, ierloc)
          call ckerr('MPI_SEND',ierloc,ierr)
          if(ierr.gt.0) exit

       endif  i_get_allnames

       if(ierr.gt.0) exit l_get_proc_names

       !--------------------------
       !  OK, build node table (on iam==0) and broadcast
       !--------------------------

       i_nodetbl: if(iam.eq.0) then        !  V  iam 0
          nact = 1
          imatch = 1
          actnames(nact) = allnames(iam)
          iactcount(imatch) = 1

          l_match_all: do ii=1,isize_all-1
             if(allnames(ii).eq.allnames(ii-1)) then
                ! same node as previous process - skip search
                iactcount(imatch)=iactcount(imatch) + 1
                cycle l_match_all
             endif

             imatch=0
             l_match_1: do jj=1,nact-1
                if(allnames(ii).eq.actnames(jj)) then
                   imatch=jj
                   iactcount(imatch)=iactcount(imatch) + 1     ! increment proc count, this node
                   exit l_match_1
                endif
             enddo l_match_1

             if(imatch.gt.0) cycle l_match_all

             ! we have a new node ( host ) name.. add to actnames
             nact = nact + 1
             actnames(nact)=allnames(ii)
             imatch = nact
             iactcount(imatch) = 1                             ! initialise proc count, this node

          enddo l_match_all

          ! maximum process count over all nodes:

          imax = maxval(iactcount(1:nact))
          
          ! build integer representation
          
          if(allocated(iactnames)) deallocate(iactnames)
          allocate(iactnames(ilen_max,nact))
          do ii=1,nact
             do jj=1,ilen_max
                if(actnames(ii)(jj:jj).eq.' ') then
                   iactnames(jj:ilen_max,ii)=0
                   exit
                else
                   iactnames(jj,ii) = ichar(actnames(ii)(jj:jj))
                endif
             enddo
          enddo
          if(loc_debug ) &
               write(0,*) '%mpi_proc_data(debug): ' &
               ,'MPI_BCAST #nodes and maxval(proc/node):',nact,imax
       endif i_nodetbl                                                          ! ^ iam 0


       !  broadcast #nodes...                                                   ! V   ALL

       call MPI_BCAST(nact, 1, MPI_INTEGER, 0, icomm, ierloc)
       call ckerr('MPI_BCAST(nact)',ierloc,ierr)
       if(ierr.gt.0)   exit l_get_proc_names

       !  broadcast max #process on a single node
       
       call MPI_BCAST(imax, 1, MPI_INTEGER, 0, icomm, ierloc)
       call ckerr('MPI_BCAST(imax)',ierloc,ierr)
       if(ierr.gt.0)   exit l_get_proc_names
       
       !  all ranks record these

       comm_data(ncomm)%num_nodes = nact
       comm_data(ncomm)%maxnode_numprocs = imax

       !--------------------------
       !  all ranks can now allocate...
       !--------------------------
       
       allocate( comm_data(ncomm)%allnode_numprocs(0:nact-1) )
       allocate( comm_data(ncomm)%allnode_names(0:nact-1) )
       allocate( comm_data(ncomm)%mynode_proclist(imax) )
       allocate( comm_data(ncomm)%allnode_proclists(imax,0:nact-1) )
       comm_data(ncomm)%save_path = ' '
       allocate( comm_data(ncomm)%node_map(0:isize_all-1) )

       i_alloc: if(iam.gt.0) then        ! V  not 0
          if(allocated(iactnames)) deallocate(iactnames)
          allocate(iactnames(ilen_max,nact))
          if(allocated(actnames)) deallocate(actnames)
          allocate(actnames(nact))
          if(allocated(iactcount)) deallocate(iactcount)
          allocate(iactcount(nact))
       endif i_alloc                                                            !  ^ not 0
       
       !  broadcast all node proclist lengths                                   !  V ALL

       if(loc_debug.AND.(iam.eq.0)) then
          write(0,*) '%mpi_proc_data(debug): broadcast proclist lengths...'
       endif

       call MPI_BCAST(iactcount, nact, MPI_INTEGER, 0, icomm, ierloc)
       call ckerr('MPI_BCAST(iactcount)',ierloc,ierr)
       if(ierr.gt.0)   exit l_get_proc_names

       !  broadcast all node names as integer

       if(loc_debug.AND.(iam.eq.0)) then
          write(0,*) '%mpi_proc_data(debug): broadcast node names as int...'
       endif

       call MPI_BCAST(iactnames, nact*ilen_max, MPI_INTEGER, 0, icomm, ierloc)
       call ckerr('MPI_BCAST(iactnames)',ierloc,ierr)
       if(ierr.gt.0) exit l_get_proc_names

       !  iam.gt.0: convert int to CHARACTER strings                            !  ^ ALL

       if(iam.gt.0) then        !  V not 0
          do ii=1,nact
             actnames(ii) = ' '
             do jj=1,ilen_max
                if(iactnames(jj,ii).eq.0) exit
                actnames(ii)(jj:jj)=char(iactnames(jj,ii))
             enddo
          enddo
        endif                                                                    !  ^ not 0

       !---------------------------
       !  all ranks
       !  can now set list of node names and identify mynode
       !  can also set list sizes
       !---------------------------                                             !  V ALL

       do ii=1,nact
          comm_data(ncomm)%allnode_names(ii-1) = actnames(ii)
          comm_data(ncomm)%allnode_numprocs(ii-1) = iactcount(ii)
          if(actnames(ii).eq.comm_data(ncomm)%mynode_name) then
             comm_data(ncomm)%mynode = ii-1
             comm_data(ncomm)%mynode_numprocs = iactcount(ii)
          endif
       enddo
       
       !---------------------------
       !  rank 0 now fills in the process lists for each node; which will
       !  be broadcast
       !---------------------------
       
       !  iactcount gets recomputed...
       
       i_recount: if(iam.eq.0) then        ! V iam 0
          comm_data(ncomm)%allnode_proclists = -1

          imatch=1
          iactcount(1:nact)=0
          do ii=0,isize_all-1

             if(allnames(ii).eq.actnames(imatch)) then
                continue
             else
                do kk=1,nact
                   if(allnames(ii).eq.actnames(kk)) then
                      imatch=kk
                      exit
                   endif
                enddo
             endif
             
             iactcount(imatch)=iactcount(imatch)+1
             jj=iactcount(imatch)
             comm_data(ncomm)%allnode_proclists(jj,imatch-1) = ii
          enddo
       endif i_recount                                                          ! ^ iam 0

       ! broadcast process lists                                                ! V ALL
       
       if(loc_debug.AND.(iam.eq.0)) then
          write(0,*) '%mpi_proc_data(debug): broadcast node proclists...'
       endif
       
       call MPI_BCAST( comm_data(ncomm)%allnode_proclists, nact*imax, &
            MPI_INTEGER, 0, icomm, ierloc)

       call ckerr('MPI_BCAST(allnode_proclists)',ierloc,ierr)
       if(ierr.gt.0) exit l_get_proc_names

       ii = comm_data(ncomm)%mynode
       
       comm_data(ncomm)%mynode_proclist = comm_data(ncomm)%allnode_proclists(:,ii)

       exit
    enddo  l_get_proc_names  !====================================================================

    if((ierr.ne.0).and.(iabort.gt.0))    then
       write(0,*) ' ?mpi_proc_data: ierr=',ierr,' for communicator: ',icomm
       write(0,*) '  process #',comm_data(ncomm)%myproc, &
            ' issues MPI_ABORT(...)'
       call MPI_ABORT(icomm,ierr,ierloc)
    endif

    !  MPI_ALLREDUCE'd error code...
    
    call collective_errchk('mpi_env_comm_add',icomm,ierr)
    if(ierr.gt.0) then
       ierr=1
       if(loc_debug.and.(iam.eq.0)) &
            write(0,*) ' ?mpi_proc_data: setup failed for comm = ',comm
    else
       if(loc_debug)   &
            write(0,*) ' %mpi_proc_data: MPI comm_data(',ncomm,')'&
            ,' setup OK on ', iam
    endif
    
    if(ierr.eq.0)    then
       !  build node map
       
       do ii=0,nact-1
          do jj=1,comm_data(ncomm)%allnode_numprocs(ii)
             kk = comm_data(ncomm)%allnode_proclists(jj,ii)
             comm_data(ncomm)%node_map(kk) = ii
          enddo
       enddo
    endif
    
#else
    comm_data(ncomm)%num_procs = 1
    comm_data(ncomm)%num_nodes = 1
    comm_data(ncomm)%myproc = 0
    comm_data(ncomm)%mynode = 0

    call sget_host( comm_data(ncomm)%mynode_name )

    comm_data(ncomm)%mynode_numprocs = 1
    comm_data(ncomm)%maxnode_numprocs = 1

    allocate( comm_data(ncomm)%mynode_proclist(1) )
    allocate( comm_data(ncomm)%allnode_numprocs(0:0) )
    allocate( comm_data(ncomm)%allnode_proclists(1,0:0) )
    allocate( comm_data(ncomm)%allnode_names(0:0) )
    allocate( comm_data(ncomm)%node_map(0:0) )

    comm_data(ncomm)%mynode_proclist(1) = 0
    comm_data(ncomm)%allnode_numprocs(0) = 1
    comm_data(ncomm)%allnode_proclists(1,0) = 0
    comm_data(ncomm)%allnode_names(0) = comm_data(ncomm)%mynode_name
    comm_data(ncomm)%node_map(0) = 0

    if(loc_debug) write(0,*) ' %mpi_proc_data: serial comm_data(1) setup OK.'
#endif

  end subroutine mpi_env_comm_add

  !---------------------------------------------------
  !  PUBLIC...

  subroutine mpi_print_info(comm,proc_id,ierr)

    ! print available information for communicator (comm)
    ! on process (proc_id); issue MPI_BARRIER call so that 
    ! output from a single processor only is output without
    ! concurrent outputs from other processors

    integer, intent(in)  :: comm     ! communicator
    integer, intent(in)  :: proc_id  ! process number
    integer, intent(out) :: ierr     ! completion status, 0=normal

    !  error returns:
    !    ierr=1 -- comm unknown
    !    ierr=2 -- proc_id unknown for (comm)

    !-------------------------------------------------
    integer :: icomm,imax,iam,ierloc,inum,ii,jj,kk
    logical :: okmap
    !-------------------------------------------------

    ierr = 0
    icomm = comm_arg(comm)
    call find_comm(icomm,indx)
    
    iam = -1
    
    if(indx.eq.0) then
       ierr=1

    else
       iam = comm_data(indx)%myproc
       imax = comm_data(indx)%num_procs - 1
       if((proc_id.lt.0).OR.(proc_id.gt.imax)) then
          ierr=2
       endif
    endif

    if((ierr.eq.0).AND.(iam.eq.proc_id)) then

       write(0,*) ' '
       write(0,*) '-------------> node/proc info for proc_id = ',proc_id
       write(0,*) '  communicator:  ',icomm
       write(0,*) '  group:         ',comm_data(indx)%comm_name
       write(0,*) '  internal indx: ',indx
       write(0,*) '    myproc:      ',comm_data(indx)%myproc
       write(0,*) '    mynode:      ',comm_data(indx)%mynode
       write(0,*) '    num_procs:   ',comm_data(indx)%num_procs
       write(0,*) '    num_nodes:   ',comm_data(indx)%num_nodes
       write(0,*) '    node name:   ',comm_data(indx)%mynode_name
       inum = comm_data(indx)%mynode_numprocs
       write(0,*) '    #procs on node:  ',inum
       write(0,*) '    max #procs/node: ',comm_data(indx)%maxnode_numprocs
       write(0,*) '    mynode proc#s:   ', &
            comm_data(indx)%mynode_proclist(1:inum)
       okmap = .TRUE.
       do ii=0,comm_data(indx)%num_nodes-1
          inum = comm_data(indx)%allnode_numprocs(ii)
          write(0,*) '    '//trim(comm_data(indx)%allnode_names(ii))// &
               ':  ',comm_data(indx)%allnode_proclists(1:inum,ii)
          do jj=1,inum
             kk=comm_data(indx)%allnode_proclists(jj,ii)
             if(comm_data(indx)%node_map(kk).ne.(ii)) okmap=.FALSE.
          enddo
       enddo
       write(0,*) '    node_map check OK = ',okmap
       write(0,*) ' '

   endif

  #ifdef __MPI
    if(loc_debug) write(0,*) 'mpi_print_info: I am ',iam,' call MPI_BARRIER'
    call MPI_BARRIER(icomm,ierloc)
  #endif

  end subroutine mpi_print_info

  !---------------------------------------------------
  !  PUBLIC...

  subroutine mpi_proc_info_comm(comm,ierr, &
       myproc,num_procs,mynode,num_nodes, &
       maxnode_numprocs, &
       node_number, &
       node_name,node_numprocs,node_proclist, &
       parallel_file_system, &
       file_system_ident )

    !  public interface to retrieve module data for a single communicator: comm

    integer, intent(in)  :: comm   ! communicator
    integer, intent(out) :: ierr   ! completion status (0=OK)

    !  error returns:
    !    ierr=1 -- comm unknown
    !    ierr=2 -- an proclist array size is too small
    !    ierr=3 -- node_number value out of range

    integer, intent(out), optional :: myproc     ! process # (rank)
                                                 !   range of values (0:num_procs-1)
    integer, intent(out), optional :: num_procs  ! #processors in (comm)

    integer, intent(out), optional :: mynode     ! node # 
                                                 !   range of values (0:num_nodes-1)
    integer, intent(out), optional :: num_nodes  ! #nodes in (comm)

    integer, intent(out), optional :: maxnode_numprocs  ! max #procs/node
                                                        !  this is the maximum #processors on any one node in (comm)

    !-----------
    !  set this to select node of interest.  If omitted, mynode is assumed!

    integer, intent(in), optional :: node_number

    !  NOTE: valid range is 0:num_nodes-1
    !-----------

    character*(*), intent(out), optional :: node_name

    integer, intent(out), optional :: node_numprocs

    integer, intent(out), dimension(:), optional :: node_proclist
    !  where dimension exceeds list size: extra array element values set to -1

    !-------------
    ! optionally return internal setting of parallel_file_system flag
    !-------------

    logical, intent(out), optional :: parallel_file_system

    character*(*), intent(out), optional :: file_system_ident

    !---------------------------------------
    integer :: isize1,isize1a,icomm,inode
    !---------------------------------------

    ierr=0
    icomm = comm_arg(comm)
    call find_comm(icomm,indx)

    if(indx.eq.0)    then
       ierr=1
       return
   endif

    if(present(myproc)) myproc = comm_data(indx)%myproc
    if(present(num_procs)) num_procs = comm_data(indx)%num_procs
    if(present(mynode)) mynode = comm_data(indx)%mynode
    if(present(num_nodes)) num_nodes = comm_data(indx)%num_nodes

    if(present(maxnode_numprocs)) maxnode_numprocs = comm_data(indx)%maxnode_numprocs

    if(present(parallel_file_system)) parallel_file_system = pll_file_sys_flag

    if(present(file_system_ident)) file_system_ident = file_sys_ident

    inode = comm_data(indx)%mynode
    if(present(node_number)) then
       inode = node_number
       if((inode.lt.0).OR.(inode.ge.comm_data(indx)%num_nodes)) then
          ierr=3
          if(present(node_name)) node_name = ' '
          if(present(node_numprocs)) node_numprocs = 0
          if(present(node_proclist)) node_proclist = -1
          return
       endif
    endif

    if(present(node_name)) node_name = comm_data(indx)%allnode_names(inode)

    if(present(node_numprocs)) node_numprocs = comm_data(indx)%allnode_numprocs(inode)

    if(present(node_proclist)) then
       node_proclist = -1
       isize1 = comm_data(indx)%allnode_numprocs(inode)
       isize1a = size(node_proclist)
       if(isize1a.lt.isize1) then
          ierr=2
       else
          node_proclist(1:isize1) = comm_data(indx)%allnode_proclists(1:isize1,inode)
       endif
   endif

  end subroutine mpi_proc_info_comm

  !------------------------------------------------
  !  (public routine)

  subroutine mpi_proc_info_name(name,status,icomm,irank,num_procs)

    !  find communicator and rank for comm-name
#ifdef __MPI
    use mpi
#endif

    character(len=*), intent(in)   :: name       ! group name 
    logical, intent(out)           :: status     ! status of group = -1 if not created
    integer, intent(out)           :: icomm      ! group communicator
    integer, intent(out), optional :: irank      ! rank of process in group
    integer, intent(out), optional :: num_procs  ! # of processes in group

    !------------------
    integer :: ii
    !------------------

    status= .false.
    icomm = -1
    if(present(irank)) irank = -1
    if(present(num_procs)) num_procs = -1

#ifdef __MPI
    
    ii=0
    call find_comm(trim(name),ii)
    if (ii .gt. 0) then
       status = .true.
       icomm = comm_data(ii)%comm       
       if (comm_data(ii)%comm .ne. MPI_COMM_NULL) then
          if(present(irank)) irank = comm_data(ii)%myproc
          if(present(num_procs)) num_procs = comm_data(ii)%num_procs
       endif
    endif
#endif    
    
  end subroutine mpi_proc_info_name



  !---------------------------------------------------
  !  PUBLIC...

  subroutine mpi_set_filesys(filesys_id)

    ! set file system identification

    character*(*), intent(in) :: filesys_id

    !---------------------------------
    logical :: assume_pll
    !---------------------------------

    file_sys_ident = filesys_id

    assume_pll = .TRUE.
    if(filesys_id.eq.'PPPLCLUSTER') assume_pll = .FALSE.

    call mpi_parallel_file_system(assume_pll)

  end subroutine mpi_set_filesys

  !---------------------------------------------------
  !  private:
  subroutine mpi_parallel_file_system(iswitch)

    ! set/clear parallel file system flag

    logical, intent(in) :: iswitch

    pll_file_sys_flag = iswitch

  end subroutine mpi_parallel_file_system

  !---------------------------------------------------
  !  PUBLIC...

  logical function check_mpi_io_node(comm,ierr)

    ! return .TRUE. if for (comm) this process is an I/O node
    !   if(pll_file_sys_flag) this is rank 0 only
    !   if(.NOT.pll_file_sys_flag) it is 1st process on each node list

    integer, intent(in) :: comm    ! communicator
    integer, intent(out) :: ierr   ! status, 0=normal; 1 if (comm) unknown

    !----------------------------
    integer :: icomm,iam
    logical :: iaction
    !----------------------------

    check_mpi_io_node = .FALSE.

    ierr = 0
    icomm = comm_arg(comm)
    call find_comm(icomm,indx)
    if(indx.eq.0) then
       ierr=1
       return
    endif

    iam = comm_data(indx)%myproc
    iaction = (iam.eq.0)  ! root process always acts...

    if(.NOT.pll_file_sys_flag) then
       !  only act on 1st process on each node...
       iaction = iam.eq.comm_data(indx)%mynode_proclist(1)
    endif

    check_mpi_io_node = iaction

  end function check_mpi_io_node

  !---------------------------------------------------
  !  PUBLIC...

  subroutine nodepath_translator(path_in,path_out,comm,irank)

    ! for given rank on given communicator, give a file path translation
    !
    ! for a system with pll_file_sys_flag=T, path_in = path_out ALWAYS

    character*(*), intent(in) :: path_in   ! input path
    character*(*), intent(out) :: path_out ! translated path

    integer, intent(in) :: comm    ! communicator
    integer, intent(in) :: irank   ! rank of interest

    !--------------------------------------
    integer :: icomm,indx,inum,inode_indx,idm1
    character*140 :: node_name
    !--------------------------------------
    path_out = path_in

    if(pll_file_sys_flag) return

    icomm = comm_arg(comm)
    call find_comm(icomm,indx)
    if(indx.eq.0) return

    inum = comm_data(indx)%num_procs
    if((irank.lt.0).or.(irank.ge.inum)) then
       write(0,*) ' %nodepath_translator: rank=',irank, ' out of range 0 to ',inum-1
       return
    endif

    inode_indx = comm_data(indx)%node_map(irank)
    node_name = comm_data(indx)%allnode_names(inode_indx)

    if(file_sys_ident.eq.'PPPLCLUSTER') then
       if(path_in(1:7).eq.'/local/') then
          idm1 = index(node_name,'.') - 1
          if(idm1.le.0) idm1 = len(trim(node_name))
          
          path_out = '/l/'//node_name(1:idm1)//'/'//path_in(8:)
          
       endif
    endif
   
  end subroutine nodepath_translator

  !---------------------------------------------------
  !  PUBLIC...

  subroutine mpi_mkdir(comm,path,ierr,clean)

    ! create a file path for processes in (comm)
    !   if(pll_file_sys_flag) only rank 0 does this
    !   if(.NOT.pll_file_sys_flag) the 1st process on each node does it

    integer, intent(in) :: comm    ! communicator
    character*(*), intent(in) :: path

    integer, intent(out) :: ierr   ! completion status (0=normal)

    !---------------------------------------------------------------------
    !  CAREFUL: could be dangerous...

    logical, intent(in), OPTIONAL :: clean  ! remove existing files in path

    !  (this removes files in the path directory, if it already exists;
    !  hidden files and subdirectories are not touched)
    !---------------------------------------------------------------------

    !------------------------------
    integer :: icomm,iam,ierloc
    logical :: iclean,iaction
    !------------------------------

    ierr=0
    iclean = .FALSE.
    if(present(clean)) iclean = clean
    
    iaction = check_mpi_io_node(comm,ierr)
    
    icomm = comm_data(indx)%comm

    !  if processed this path on preceding call for (comm), no action...
    if(.NOT.iclean) then
       if(path.eq.comm_data(indx)%save_path) then
          iaction=.FALSE.
       else
          comm_data(indx)%save_path = path
       endif
    endif

    if(iaction) then
       call gmkdir(' ',path,ierr)
       if(ierr.eq.0) then
          if(iclean) then
             call fclean_dir(path,ierr)
          endif
       endif
    endif

    ! make sure directory creation is complete on all nodes before continuing
    ! use collective
    
    call collective_errchk('mpi_mkdir',icomm,ierr)
    
  end subroutine mpi_mkdir
  !---------------------------------------------------
  !  PUBLIC...

  subroutine mpi_file_bcast_single(comm,filenam,ierr,newname)
    
    ! broadcast single file from [node 0] to remaining nodes
    ! assume only [node 0] knows the names.
    ! no action if(pll_file_sys_flag)
    
    integer,       intent(in)  :: comm    ! communicator
    character*(*), intent(in)  :: filenam
    integer,       intent(out) :: ierr    ! return status, 0=normal
                                          !  1 means unknown communicator; 2 means a file transfer failed although
                                          !  the code may not survive such a failure...

    character*(*), intent(in), optional :: newname  ! set this if copied
                                                    ! file should have a different name than the original file; if omitted
                                                    ! the original name is kept.

    !----------------------------------------------
    character*200 :: flist(1),nname(1)
    !----------------------------------------------

    flist(1) = filenam

    if(present(newname))    then
       nname(1)=newname
       call mpi_file_bcast_list(comm,flist,ierr,newname=nname)

    else
       call mpi_file_bcast_list(comm,flist,ierr)
    endif

  end subroutine mpi_file_bcast_single
    
  subroutine mpi_file_bcast_list( comm, filelist, ierr, newname)

    ! Broadcast files from [node 0] to remaining nodes, optionally renaming output files
    ! [ portlib/portlib_parcopy performs the actual send/receive data ]
    !
    ! Assume only [node 0] knows the names.  No action if(pll_file_sys_flag)

    integer, intent(in) :: comm  ! communicator

    character(len=*), intent(in), dimension(:) :: filelist  ! (input) file names

    integer, intent(out) :: ierr       ! return status, 0=normal
                                       ! 1 means unknown communicator; 
                                       ! 2 means a file transfer failed although
                                       !   the code may not survive such a failure...
                                                                 
    character(len=*), intent(in), optional, dimension(:) :: newname  ! new/output file names df to same as input
                                                                     ! set this optional list if each copied file should 
                                                                     ! have a different name than the original file; 
                                                                     ! if omitted original name is used for all copies.
                                                                     ! MAY HAVE LESS ENTRIES than filelist ; 
                                                                     ! >> renamed files must preceed non-renamed files in filelist <<
                                                                 

    integer :: icomm,innodes,ii,jj 

    integer :: innew          ! number of entries in newname array
    integer :: ierloc,iam       
    integer :: inum_files     ! Number of file transfers requested
    integer :: ilenc            
    integer :: inum_actual    ! number which must be sent
    integer :: ina            !  "  "   + 1
    integer :: iact           !  0 - none ; 1 - local copy ; 2 - MPI transfer

    logical :: iaction      
      
    integer, dimension(:), allocatable :: ifrom,ito

    integer, parameter :: ncfnm = 256  ! # chars/file name

    character(len=ncfnm),dimension(:),  allocatable :: from_list  ! (local) copy of filelist
    character(len=ncfnm),dimension(:),  allocatable :: to_list    ! filelist OR newname
    character(len=ncfnm),dimension(:,:),allocatable :: ffrom      ! copy of from_list, for bcast/recieve
    character(len=ncfnm),dimension(:,:),allocatable :: fto        ! copy of   to_list, for bcast/recieve
    !-------------------------------------

    ierr=0

    icomm = comm_arg(comm)
    call find_comm(icomm,indx)

    if(indx.eq.0) then
       ierr=1
       return
    endif

 
    call mpi_cwd_check(indx,ierr)
    
    if(ierr.ne.0) then
       write(0,*) '??mpi_file_bcast_list: ierr =',ierr,indx
       write(0,*) '           return'
       return
    endif
    
    iam=comm_data(indx)%myproc
    if(pll_file_sys_flag) then
       innodes = 1
    else
       innodes=comm_data(indx)%num_nodes
    endif

    allocate(ifrom(innodes))
    allocate(ito(innodes))

    if(present(newname)) then
       innew=size(newname)
    else
       innew=0
    endif

    i_filenm: if(iam.eq.0) then    !  V  iam 0
       inum_files = size(filelist)

       inum_actual = 0
       allocate(from_list(inum_files),to_list(inum_files))
       
       l_filenm: do ii=1,inum_files
          if(filelist(ii).eq.' ')  then
             write(0,*) ' ?? mpi_file_bcast_list: blank filename received.'
             write(0,*) '    "filelist" list index: ',ii
             ierr = 2
             exit l_filenm
          endif
          if(ii.le.innew) then
             if(newname(ii).eq.' ') then
                write(0,*) ' ?? mpi_file_bcast_list: blank new name received.'
                write(0,*) '    "newname" list index: ',ii
                ierr = 2
                exit l_filenm
             endif
          endif
          
          ina = inum_actual+1
          from_list(ina) = filelist(ii)
          if(ii.le.innew) then
             to_list(ina) = newname(ii)
          else
             to_list(ina) = filelist(ii)
          endif

          !  what to do with this pair ??
          call mpi_copy_status(from_list(ina),to_list(ina),iact)

          if(iact.eq.0) then
             continue                                          !    no action
          else if(iact.eq.1) then
             ! rank 0 only
             call fcopy(from_list(ina),to_list(ina),ierr)      !    local copy only
             if(ierr.ne.0)   exit l_filenm
          else if(iact.eq.2)    then
             !  MPI distribution needed
             inum_actual = inum_actual + 1                     !     MPI copy needed - increment counter
          endif

       enddo l_filenm
    else    !  ^ iam 0
       !    set counters                                                        !  V not 0
       inum_files = 0
       inum_actual = 0
    endif i_filenm 

    call collective_errchk('mpi_file_bcast_list',icomm,ierr)
    if(ierr.ne.0) return

    l_actual: do ii=1,innodes
       !         broadcast actual # of transfers ( those with  iact = 2 )
       jj=ii-1
       ifrom(ii) = 0                                                            !   all transfers are from  root
       if(pll_file_sys_flag) then
          ito(ii) = 0
       else
          ito(ii) = comm_data(indx)%allnode_proclists(1,jj)
       endif
       
       if(ito(ii).eq.ifrom(ii)) cycle l_actual

#ifdef __MPI
       if(iam.eq.ifrom(ii)) then                      !  V  iam 0
          call MPI_SEND(inum_actual,1,MPI_INTEGER,ito(ii), &
               2001,icomm,ierloc)
          call ckerr('MPI_SEND(inum_actual)',ierloc,ierr)
       else if(iam.eq.ito(ii))    then                ! V not 0
          call MPI_RECV(inum_actual,1,MPI_INTEGER,ifrom(ii), &
               2001,icomm, istatus, ierloc)
          call ckerr('MPI_RECV(inum_actual)',ierloc,ierr)
       endif
#endif
    enddo l_actual

    call collective_errchk('mpi_file_bcast_list',icomm,ierr)                    !  V ALL
    if(ierr.ne.0) return

    i_actual_nm: if(inum_actual.gt.0) then

       ! exchange file names
       ! only procs actively involved in MPI file copying enter this section

       allocate(ffrom(inum_actual,innodes),fto(inum_actual,innodes))
       ilenc = len(ffrom(1,1))

       l_copy_node_nm: do ii=1,innodes
          l_copy_file_nm: do jj=1,inum_actual
             
             ! send/receive file names
             
             if(iam.eq.ifrom(ii)) then
                ffrom(jj,ii) = from_list(jj)
                fto(jj,ii) = to_list(jj)
             endif
             
             if(ito(ii).eq.ifrom(ii)) cycle l_copy_file_nm
             
#ifdef __MPI
             if(iam.eq.ifrom(ii)) then
                call MPI_SEND(ffrom(jj,ii),ilenc,MPI_CHARACTER,ito(ii), &
                     2002,icomm,ierloc)
                call ckerr('MPI_SEND(ffrom)',ierloc,ierr)
                call MPI_SEND(fto(jj,ii),ilenc,MPI_CHARACTER,ito(ii), &
                     2003,icomm,ierloc)
                call ckerr('MPI_SEND(fto)',ierloc,ierr)
             else if(iam.eq.ito(ii)) then
                call MPI_RECV(ffrom(jj,ii),ilenc,MPI_CHARACTER,ifrom(ii), &
                     2002,icomm, istatus, ierloc)
                call ckerr('MPI_RECV(ffrom)',ierloc,ierr)
                call MPI_RECV(fto(jj,ii),ilenc,MPI_CHARACTER,ifrom(ii), &
                     2003,icomm, istatus, ierloc)
                call ckerr('MPI_RECV(fto)',ierloc,ierr)
                !  else
                !  other nodes - do nowt
             endif
#endif
          enddo l_copy_file_nm
       enddo l_copy_node_nm
    endif i_actual_nm

    call collective_errchk('mpi_file_bcast_list',icomm,ierr)
    if(ierr.ne.0) return

    i_actual_cp: if(inum_actual.gt.0) then

       ! perform copy -
       ! only procs actively involved in file copying enter this section
       
       l_node_cp: do ii=1,innodes
          l_file_cp: do jj=1,inum_actual

             if(ifrom(ii).eq.ito(ii)) then
                if(ffrom(jj,ii).eq.fto(jj,ii)) cycle l_file_cp
             endif
             if (loc_debug)    then
                write(0,*) 'mpi_file_bcast_list: iam=',iam, &
                     trim(ffrom(jj,ii)),trim(fto(jj,ii))
             endif
             call parcopy(icomm,iam,ifrom(ii),ito(ii), &                        ! portlib/parcopy 
                  trim(ffrom(jj,ii)),trim(fto(jj,ii)),ierloc)                   !    -> portlib/portlib_parcopy
             if(ierloc.ne.0) ierr=2
             
          enddo l_file_cp
       enddo l_node_cp

    endif i_actual_cp

    ! make sure file transfer is complete on all nodes before continuing
    
    call collective_errchk('mpi_file_bcast',icomm,ierr)
    
  end subroutine mpi_file_bcast_list
  
  !---------------------------------------------------
  !  PUBLIC...
  
  subroutine mpi_file_transfer(ierr)
    
    integer, intent(out) :: ierr
    
    write(0,*) ' ?? mpi_file_transfer: not implemented, do not use! '
    ierr = 1
    
  end subroutine mpi_file_transfer
  
  !------------------------------------------------
  !  (private routine, deal with serial vs. MPI)
  
  integer function comm_arg(comm)
    
    integer, intent(in) :: comm
    
#ifdef __MPI
    comm_arg = comm
#else
    comm_arg = 0   ! serial code: ignore
#endif
  end function comm_arg
  !------------------------------------------------
  !  (private)

  subroutine mpi_cwd_check(indx,ierr)
    
    ! verify that all ranks are in the same $cwd
    ! if not: report error
    
    integer, intent(in) :: indx  ! index to communicator
    integer, intent(out) :: ierr ! completion status (0=normal)
    
    !-----------------------------------
    integer :: iam,icomm,ierloc
    
    !-----------------------------------
    
    iam=comm_data(indx)%myproc
    icomm=comm_data(indx)%comm

    ierr = 0

    call sget_cwd(cwd)
    if(iam.eq.0) cwd_0 = cwd

#ifdef __MPI
    if(loc_debug) write(0,*) 'mpi_cwd_check(',iam,') call MPI_BCAST',trim(cwd_0)
    call MPI_BCAST(cwd_0, len(cwd_0), MPI_CHARACTER, 0, icomm, ierloc)
    if((iam.ne.0).AND.(ierloc.ne.0)) cwd_0='?MPI_BCAST_error'
    ! 07/22/2011 CLF: synch
    if(loc_debug) write(0,*) ' mpi_cwd_check(',iam,') call MPI_BARRIER: ',trim(cwd_0)
    call MPI_BARRIER(icomm, ierr)
    if(ierr.ne.0)    then
       write(0,*) '?mpi_cwd_check(',iam,') MPI_BARRIER error detected!'
    endif

    if(cwd.ne.cwd_0)    then
       ierr=1 
       write(0,*) ' ?mpi_cwd_check(',iam,') cwd mismatch: ',trim(cwd)
       write(0,*) ' ?                                      ',trim(cwd_0)
    endif

    call collective_errchk('mpi_cwd_check',icomm,ierr)
#endif

    if((iam.eq.0).AND.(ierr.ne.0)) then

       write(0,*) ' ================================ '
       write(0,*) ' mpi_cwd_check rank(0) cwd: '//trim(cwd)
       write(0,*) ' ================================ '

    endif
    
  end subroutine mpi_cwd_check

  subroutine mpi_copy_status(cfrom,cto,iact)

    ! file transfer status assessment

    character*(*), intent(in) :: cfrom  ! "from" path
    character*(*), intent(in) :: cto    ! "to" path
    integer, intent(out)      :: iact   ! assessment

    !  iact=0 means, no transfer required
    !  iact=1 means, only local transfer required
    !  iact=2 means, MPI transfer required
    
    iact=0
    if(cfrom.ne.cto) iact=1
    
    if(pll_file_sys_flag) then

       ! MPI transfer never required
       ! local transfer (root proc) if cfrom.ne.cto

       CONTINUE

    else

       if(file_sys_ident.eq.'PPPLCLUSTER') then
          if(cto(1:7).eq.'/local/') then
             iact=2
          else
             if((cto(1:1).ne.'/').AND.(cto(1:1).ne.'~')) then
                if(cwd(1:7).eq.'/local/') then
                   iact=2
                endif
             endif
          endif
       endif
       
    endif
    
  end subroutine mpi_copy_status

  !------------------------------------------------
  !  (private routine, error handling)

  subroutine ckerr(thiscall, ierloc, ierr)

    character*(*), intent(in) :: thiscall   ! label point of error
    integer, intent(in)       :: ierloc     ! error if ierloc.ne.0
    integer, intent(inout)    :: ierr       ! increment if ierloc.ne.0

    if(ierloc.eq.0) return

    if(loc_debug) write(0,*) ' ?mpi_proc_data: error in '//trim(thiscall)
    ierr = ierr + 1
    
  end subroutine ckerr
  !------------------------------------------------
  !  (private routine)

  subroutine find_index_comm(icomm,imatch)

    !  find index to data structure for communicator (icomm)

    integer, intent(in) :: icomm
    integer, intent(out) :: imatch

    !------------------
    integer :: ii
    !------------------

    imatch = 0
    do ii=1,ncomm
       if(comm_data(ii)%comm.eq.icomm) then
          imatch = ii
          exit
       endif
    enddo
    
  end subroutine find_index_comm

  subroutine find_index_name(name,imatch)

    !  find index to data structure for communicator (icomm)

    character(len=*), intent(in)  :: name       ! group name 
    integer, intent(out)          :: imatch     ! index into comm_data
    
    !------------------
    integer :: ii
    !------------------

    imatch = 0
    do ii=1,ncomm
       if(trim(comm_data(ii)%comm_name).eq.trim(name)) then
          imatch = ii
          exit
       endif
    enddo
    
  end subroutine find_index_name


  !------------------------------------------------
  !  (private routine)
  
  subroutine collective_errchk(subr,icomm,ierr)

    character*(*), intent(in) :: subr  ! calling subroutine
    integer, intent(in)    :: icomm    ! verified communicator
    integer, intent(inout) :: ierr     ! this proc error code on input, collective
    !                                  ! error code, on output.

    !---------------------
    integer :: ierloc,iertmp,iam
    !---------------------

    iam = comm_data(indx)%myproc

    !  prevent MPI_ALLREDUCE starting while other procs still
    !  have MPI_SEND/RECV calls pending

    if(loc_debug) write(0,*) ' I, ',iam,' ',comm_data(indx)%comm_name, &
                  ' am in collective_errchk: ierr = ',ierr,' for '//trim(subr)

#ifdef __MPI
    iertmp = ierr
    CALL MPI_ALLREDUCE(iertmp,ierr,1,MPI_INTEGER,MPI_MAX,icomm,ierloc)
    if (ierloc.gt.0) then
       write(0,*) 'collective_errchk:',iam, &
            ' MPI_ALLREDUCE retuned error =',ierloc
    endif
#endif

  end subroutine collective_errchk
  
  !------------------------------------------------
end module mpi_proc_data

!
! 1-D
!


subroutine EZspline_isInDomain1(spline_o, p1, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) :: spline_o
  real(fp), intent(in) :: p1

  ! ier:
  ! 6=out of interval p1 < min(x1)
  ! 7=out of interval p1 > max(x1)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))


  if(p1 < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(p1 > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if

end subroutine EZspline_isInDomain1

subroutine EZspline_isInDomain1_array(spline_o, k1, p1, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  type(EZspline1) :: spline_o
  integer, intent(in) :: k1
  real(fp), intent(in) :: p1(k1)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))

  if(minval(p1(1:k1)) < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(maxval(p1(1:k1)) > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if

end subroutine EZspline_isInDomain1_array



!!
!! 2-D
!!


subroutine EZspline_isInDomain2(spline_o, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) :: spline_o
  real(fp), intent(in) :: p1, p2

  ! ier:
  ! 6=out of interval p1 < min(x1)
  ! 7=out of interval p1 > max(x1)
  ! 8=out of interval p2 < min(x2)
  ! 9=out of interval p2 > max(x2)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))


  if(p1 < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(p1 > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(p2 < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(p2 > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if

end subroutine EZspline_isInDomain2

subroutine EZspline_isInDomain2_array(spline_o, k1, k2, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  type(EZspline2) :: spline_o
  integer, intent(in) :: k1, k2
  real(fp), intent(in) :: p1(k1), p2(k2)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))

  if(minval(p1(1:k1)) < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(maxval(p1(1:k1)) > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(minval(p2(1:k2)) < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(maxval(p2(1:k2)) > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if

end subroutine EZspline_isInDomain2_array

subroutine EZspline_isInDomain2_cloud(spline_o, k, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  type(EZspline2) :: spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))

  if(minval(p1(1:k)) < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(maxval(p1(1:k)) > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(minval(p2(1:k)) < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(maxval(p2(1:k)) > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if

end subroutine EZspline_isInDomain2_cloud



!!!
!!! 3-D
!!!


subroutine EZspline_isInDomain3(spline_o, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) :: spline_o
  real(fp), intent(in) :: p1, p2, p3

  ! ier:
  ! 6=out of interval p1 < min(x1)
  ! 7=out of interval p1 > max(x1)
  ! 8=out of interval p2 < min(x2)
  ! 9=out of interval p2 > max(x2)
  ! 10=out of interval p3 < min(x3)
  ! 11=out of interval p3 > max(x3)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2, eps3

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))
  eps3 = small*(spline_o%x3(spline_o%n3) - spline_o%x3(1))


  if(p1 < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(p1 > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(p2 < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(p2 > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if
  if(p3 < spline_o%x3(          1)-eps3) then
     ier = 10
     return
  end if
  if(p3 > spline_o%x3(spline_o%n3)+eps3) then
     ier = 11
     return
  end if

end subroutine EZspline_isInDomain3

subroutine EZspline_isInDomain3_array(spline_o, k1, k2, k3, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  type(EZspline3) :: spline_o
  integer, intent(in) :: k1, k2, k3
  real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2, eps3

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))
  eps3 = small*(spline_o%x3(spline_o%n3) - spline_o%x3(1))

  if(minval(p1(1:k1)) < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(maxval(p1(1:k1)) > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(minval(p2(1:k2)) < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(maxval(p2(1:k2)) > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if
  if(minval(p3(1:k3)) < spline_o%x3(          1)-eps3) then
     ier = 10
     return
  end if
  if(maxval(p3(1:k3)) > spline_o%x3(spline_o%n3)+eps3) then
     ier = 11
     return
  end if

end subroutine EZspline_isInDomain3_array

subroutine EZspline_isInDomain3_cloud(spline_o, k, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  type(EZspline3) :: spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k), p3(k)
  integer, intent(out) :: ier

  real(fp), parameter :: small = 1.e-10_fp
  real(fp) :: eps1, eps2, eps3

  ier = 0

  eps1 = small*(spline_o%x1(spline_o%n1) - spline_o%x1(1))
  eps2 = small*(spline_o%x2(spline_o%n2) - spline_o%x2(1))
  eps3 = small*(spline_o%x3(spline_o%n3) - spline_o%x3(1))

  if(minval(p1(1:k)) < spline_o%x1(          1)-eps1) then
     ier = 6
     return
  end if
  if(maxval(p1(1:k)) > spline_o%x1(spline_o%n1)+eps1) then
     ier = 7
     return
  end if
  if(minval(p2(1:k)) < spline_o%x2(          1)-eps2) then
     ier = 8
     return
  end if
  if(maxval(p2(1:k)) > spline_o%x2(spline_o%n2)+eps2) then
     ier = 9
     return
  end if
  if(minval(p3(1:k)) < spline_o%x3(          1)-eps3) then
     ier = 10
     return
  end if
  if(maxval(p3(1:k)) > spline_o%x3(spline_o%n3)+eps3) then
     ier = 11
     return
  end if
end subroutine EZspline_isInDomain3_cloud

!#define _TEST
   module mtrfile
!. mtrfile                           File handling operations
!
!
!  Author                            jim.conboy@ccfe.ac.uk
!  Version                           1.00,  06Jan2012
!  Modifications
!
!  1.00  06Jan2012                   jim.conboy@ccfe.ac.uk
!                                    Written
!----_^---------------------------------=========================================|
!
!
   use mtrcons, only  : cdlm, cdkdlm, cfpath, cspace, csp8, char0
   use logmod
   implicit  none
   private   cfnapp
!
!..GLOBAL
!
   integer, parameter                :: ncfnm = 1024    ! Max chars in file path
   character(len=8)                  :: cbl8
   character(len=ncfnm)              :: cerr          & ! error msg buffer      
                                       ,cbuf            ! working space
!
   contains

  subroutine filename( cfnm, istat, c0, c1, c2, c3, c4 )
  !.. filename                         construct a filename from strings
  !                                    codesys/source/portlib/mtrfile.filename.
  !
  !
  !  Author                            jim.conboy@ccfe.ac.uk
  !  Version                           1.00,  06Jan2012
  !  Modifications
  !
  !  1.00  06Jan2012                   jim.conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(inout)    :: cfnm           ! file name
  integer, intent(out)               :: istat          ! return status, 0=OK
  character(len=*), intent(in)       :: c0, c1         ! path elements
  character(len=*), intent(in),    &
                    optional         :: c2,c3,c4
  !
  !..local
  integer                            :: lfnm         & ! length cfnm
                                       ,l1             ! index, last char in cfnm
  !
  character(len=*),parameter         :: cSr='portlib/mtrfile.filename'
  !----------------------------------::================!.........................|
  !
  lfnm = len( cfnm )
  !
  if( c0 == '+' )                               then
     l1 = len_trim(cfnm) 
     if( cfnm(l1:l1) == cdlm )  l1 = l1-1
                                                else
     l1   = 0
     cfnm = repeat(csp8, len(cfnm)/8)
     call cfnapp( cfnm, lfnm, l1, c0, istat )
     if( istat /= 0 )                         then
         print *,cSr,' Arg 1 istat = ',istat 
                       return ;               endif
                                                endif
  !
  call cfnapp( cfnm, lfnm, l1, c1, istat )
  if( istat /= 0 )                              then 
      print *,cSr,' Arg 2 istat = ',istat 
                       return ;                 endif
  !
  !--       3rd field
  if( .not. present( c2 ))                      then
                                                return 
                                                else
     call cfnapp(  cfnm, lfnm, l1, c2, istat )
     if( istat /= 0 )                        then 
      print *,cSr,' Arg 3 istat = ',istat 
                       return ;              endif
                                                endif
  !
  !--       4th field
  if( .not. present( c3 ))                      then
                                                return 
                                                else
     call cfnapp(  cfnm, lfnm, l1, c3, istat )
     if( istat /= 0 )                        then
      print *,cSr,' Arg 1 istat = ',istat 
                       return ;              endif 
                                                endif
  !
  !--       5th field
  if( .not. present( c4 ))                      then
                                                return 
                                                else
     call cfnapp(  cfnm, lfnm, l1, c4, istat )
     if( istat /= 0 )                        then 
                       return ;              endif
                                                endif
  !
  end subroutine filename

  subroutine cfnapp( cpath, lpath, ix, cdir, istat )
  !.. cfnapp                           append single path element to file path
  !                                    codesys/source/portlib/mtrfile.cfnapp.
  !
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  00mmm2012
  !  Modifications
  !
  !  1.00  00mmm2012                   <author>@<place>
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  integer, intent(in)                :: lpath          ! length of the path string
  character(len=lpath),intent(inout) :: cpath
  integer, intent(inout)             :: ix             ! to last used character
  character(len=*), intent(in)       :: cdir           ! path element to append
  integer, intent(out)               :: istat          ! return status, 0=OK
                                                       ! > lpath :  # chars needed
                                                       ! < lpath :  ptr to invalid character
  !
  !..local
  integer                            :: ldir           ! length of element to add
  !
  character(len=*),parameter         :: cSr='portlib/mtrfile.cfnapp'
  !----------------------------------::================!.........................|
  !
  ldir = len_trim(cdir)
  if( ldir == 0 )                                       return  ! ??
  if( cdir(ldir:ldir) == char(0))   ldir = ldir - 1
  !d print *,cSr,ldir,cdir(:ldir)
  !d call cdump( cSr//cdir, cdir, istat )
  !
  if( ix+ldir+1 > lpath )                               then
!    call errorlog( cSr,'filename buffer overflow' )
    istat = ix+ldir+1 ;                                 return
                                                        endif
  !
  if( ix /= 0 .and. cdir(1:1) /= cdlm )                 then
     ix = ix + 1
     cpath(ix:ix) = cdlm
                                                        endif
  !
  istat = verify( cdir(:ldir), cfpath )
  if( istat /= 0 )                                      then
     print *,cSr,' -E- ',istat
     write(cerr,'(a,z2,2a)')  'Invalid char  = (Z'      &
                            , ichar(cdir(istat:istat))  &
                            ,') follows ',cdir(1:min(1000,istat-1))
!     call warnlog( cSr, cerr )
     istat = istat + ix                                 ! address of char in path
                                                        endif
  !
  cpath(ix+1:ix+ldir)  = cdir(:ldir)
  ix = ix + ldir
  !
  if( cpath(ix:ix) == cdlm )                            then
     cpath(ix:ix)  = cspace
     ix = ix - 1
                                                        endif
  !
  end subroutine cfnapp

  function get_cwd( copt )
  !.. get_cwd                             Return cwd 
  !                                       codesys/source/portlib/mtrfile.get_cwd.
  !
  !
  !     Author                            <author>@<place>
  !     Version                           1.00,  17Jan2012
  !     Modifications
  !
  !     1.00  17Jan2012                   <author>@<place>
  !                                       Written
  !----_^---------------------------------=========================================|
  !
      implicit  none
  !
  !..GLOBAL
  !--   variable                       :: name           ! description
  !
  !..Arguments
  !
      character(len=ncfnm)           :: get_cwd        !
      character(len=*), optional     :: copt           ! 'full|last' 
  !
  !..local
      integer                        :: ildisk        &
                                       ,ilcwd         &
                                       ,ixdlm         &
                                       ,ixcwd
  !
      character(len=*),parameter     :: cFn='portlib/mtrfile.get_cwd'
  !----_^------------------------------::================!.........................|
  !
      cbuf = repeat( '        ', len(cbuf)/8 )
  !
  !   get current working directory (VMS or UNIX)
  !
      ixcwd = 33
      call showdefl( cbuf(1:ixcwd-1), ildisk     &
                    ,cbuf(ixcwd:   ), ilcwd   )
      if( cbuf(1:1) /= cspace )                          then
         ildisk = len_trim( cbuf(:ixcwd-1) )
         if( cbuf(ildisk:ildisk) /= cdkdlm )           then
            ildisk = ildisk + 1
            cbuf(ildisk:ildisk) = cdkdlm
                                                       endif
            cbuf(:ixcwd-1) =  adjustr( cbuf(:ixcwd-1))
            ixcwd = ixcwd - ildisk
                                                          endif
   !
      if( present( copt ))                                then
         if( copt == 'last' )                           then
            ixdlm = index( cbuf, cdlm, .true. )
            if( ixdlm /= 0 )     ixcwd = ixdlm 
                                                        endif
                                                          endif
      get_cwd = trim( cbuf(ixcwd:))

      end function get_cwd

  subroutine ioerr( lunerr, ioerrno, file, iolun, status  )
  !.. ioerr                            Diagnostics for IO error
  !                                    codesys/source/portlib/ioerr.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.20  12Jan2012
  !  Modifications
  !
  !  1.20  12Jan2012                   Jim.Conboy@ccfe.ac.uk
  !                                    included in mtrfile
  !                                    add cStatus arg
  !
  !  1.10  11Nov2011                   Jim.Conboy@ccfe.ac.uk
  !                                    use logmod routines, if lunerr < 0
  !
  !  1.00  31Oct2011                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  use logmod
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  integer, intent(in)                :: lunerr        &! lun to write error info
                                       ,ioerrno        ! io error code
  character(len=*), intent(in), &
                         optional    :: file           ! file attempted
  integer,   intent(in), optional    :: iolun          ! Lun for which error occured
  character(len=*), intent(in)     &
                  , optional         :: status         ! requested status
  !
  !..local
  character(len=1024)                :: cbuf           ! io buffer
  !
  character(len=*),parameter         :: cSr='portlib/ioerr'
  !----------------------------------::================!.........................|
  !
  if( ioerrno == 0 )                                     return
  !
#ifdef _LAHEY
  call iostat_msg( ioerrno, cbuf )
#else
  cbuf = "No error description available " 
#endif

  if( lunerr > -1 )                                      then 
      write(lunerr,'(a,i8,2a)') &
        ' IO error ',ioerrno,': ',trim(cbuf)
                                                         else
!      call warnlog( trim(cbuf), ioerrno )
                                                         endif
!
  if( present(file) .and. file(1:1) /= '/' )             then
!         relative file name - where are we ?? 
     call sget_cwd( cbuf )
     if( lunerr > -1 )                                then
      write(lunerr,'(2a)') ' cwd : ',trim(cbuf)  
                                                      else
!      call infolog( 'cwd :', trim(cbuf) )
                                                      endif
                                                         endif
!    
  if( present( file ) .and. present( iolun ))            then
    write( cbuf, '(3a,i4)' ) &
          '    for ',trim(file),' on unit ',iolun
  elseif( present( iolun ) )                             then
    write( cbuf, '( a,i4)' ) '    on unit ',iolun
  elseif( present( file ) )                              then
    write( cbuf, '(2a)' ) '    for ',trim(file)
  else
                                                         return
                                                         endif
!
  if( present(status ) )  &
    cbuf = cbuf // ' Status '// trim( status )
  if( lunerr > -1 )                                      then
      write(lunerr,'(2a)') '          ',trim(cbuf)  
                                                         else
      call infolog( trim(cbuf) )
                                                         endif
!
  end subroutine ioerr


  subroutine mkdir( cdir, istat, cdir_full, set )
  !.. mkdir                            Create a directory ( tree); definition may
  !                                    contain environment variables
  !                                    codesys/source/portlib/mkdir.f90
  !
  !                                    fpopen is used to expand the directory name using 
  !                                    echo, so reproducing the (Bourne) shell syntax 
  !                                    
  !  Author                            jim.conboy@ccfe.ac.uk
  !  Version                           1.10  04Jan2012
  !  Modifications
  !
  !  1.10  04Jan2012                   jim.conboy@ccfe.ac.uk
  !                                    Protect against trailing file delimiter
  !
  !  1.00  20May2011                   jim.conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  ! character(len=1024)              :: cbuf
  !
  !..Arguments
  !
  character(len=*), intent(in)       :: cdir           ! the directory name
  integer, intent(out)               :: istat          ! return status, 0=OK
  character(len=*), intent(out),    &
                    optional         :: cdir_full      ! full dir nm
  logical, intent(in), optional      :: set            ! .t to change directory
  !
  !..local
  integer                            :: i
  integer                            :: lx             ! len ( cdir_ex )
  logical                            :: lexist
  character(len=1)                   :: char
  character(len=256)                 :: cdir_ex &
                                       ,cbl256
  !
  character(len=1),parameter         :: cd = '/'
  character(len=*),parameter         :: cSr='portlib/mtrfile.mkdir'
  !----------------------------------::================!.........................|
  !
  print *,cSr,' -I- ',trim(cdir)
  cbl256  = repeat( cbl8, len(cbl256)/8)
  cdir_ex = repeat( cbl8, len(cdir_ex)/8)
  !
  cdir_ex = trim(cdir)
  call parse( cdir_ex, istat )
  ! 
  lx = len_trim(cdir_ex)
  if( cdir_ex(lx:lx) == cd )  lx = lx - 1
  !d print *,cSr,' -I- ',cdir_ex(:lx)
  !
  call fpopen( 'mkdir -vp '//cdir_ex(:lx)//char(0), cbuf )  ! & create directory
  !
  !   Test for success - a test that the file is in fact a directory
  !                      would be better
  !
  inquire( file=cdir_ex(:lx), exist=lexist )                ! .. did we ?
  if( lexist )                                      then
    istat = 0
    if( present( cdir_full )) &
        cdir_full(:len(cdir_full))  = cdir_ex(:lx)//cbl256
    if( present( set ))                         then
        !d print *,cSr,' len ',len_trim(cdir_ex)
        if( set ) call set_cwd( trim(cdir_ex), istat )
                                                endif
                                                    else
    print *,cSr,' -E- could not create ',trim(cdir)
    istat = 1
                                                    endif
  !
  return
  end subroutine mkdir

  subroutine mklink( cfnm, clnm, istat )
  !.. mklink                           Create a ( unix file system ) link
  !                                    codesys/source/portlib/mtrfile.mklink.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  13Dec2011
  !  Modifications
  !
  !  1.00  13Dec2011                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(in)       :: cfnm           ! the target file
  character(len=*), intent(inout)    :: clnm           ! the link name
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  integer                            :: l              ! buffer index 
  !
  character(len=512)                 :: cbuf         & ! buffer ( for  Unix command )
                                       ,cout           ! output ( from Unix command )
  character(len=*),parameter         :: cSr='portlib/mtrfile.mklink'
  !----------------------------------::================!.........................|
  !
  cbuf = 'ln -snf '                  ! -n no deref; -f delete existing =>
                                     ! any existing link will be ( silently ) replaced
  l = len_trim(cbuf)
#ifndef __MPI
  cbuf(l+2:) = trim(cfnm) // cspace // trim(clnm )
#else
  cbuf(l+2:) = trim(cfnm)
  call parse( cbuf(l+1:), istat )
  l = len_trim(cbuf)
  cbuf(l+1:) = cspace//trim(clnm)
  call parse( cbuf(l+2:), istat )
#endif
  !
!  call infolog( cSr, trim(cbuf) )
  cout = repeat( csp8, len(cout)/8 )
  call fpopen( trim(cbuf)//' 2>&1'//char(0), cout )
  l = len_trim(cout )
  if(      len_trim(cout) > 2    &
     .and. cout(1:2) /= cspace//char0  )   then   ! Is zero terminated.. 
!     call errorlog( csr, trim(cout) )
     call cdump( 'mklink.cout', cout(:l), l )
     istat = 1
                                           else
     istat = 0
                                           endif
  !
  end subroutine mklink


  subroutine qset_cwd( creq, istat, ccwd )
  !.. qset_cwd                         Change cwd, unless there already..
  !                                    codesys/source/portlib/mtrfile.qset_cwd.
  !
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  19Jan2012
  !  Modifications
  !
  !  1.00  19Jan2012                   <author>@<place>
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(in)       :: creq           ! requested directory
  integer, intent(out)               :: istat          ! return status, 0=OK
  character(len=*), intent(out),    &
                    optional         :: ccwd           ! where we ended up..
  !
  !..local
  integer                            :: ixreq        & !
                                       ,lenreq       & ! length creq ( w/out trailing / )
                                       ,lencwd         !        cwd
  !
  character(len=ncfnm)               :: creqp          ! expanded directory name
  !
  character(len=*),parameter         :: cSr='portlib/mtrfile.qset_cwd'
  !----------------------------------::================!.........................|
  !
  cbuf = get_cwd( 'full' )
  lencwd = len_trim(cbuf) 
  if( cbuf(lencwd:lencwd) == cdlm ) lencwd = lencwd - 1
  !
  creqp  = creq
  call parse( creqp, istat )
  lenreq = len_trim(creqp)
  if( creqp(lenreq:lenreq) == cdlm )  lenreq = lenreq - 1
  ! 
  ixreq = index( cbuf(:lencwd), creqp(:lenreq), .true. )
  !d print *,cSr,lencwd,lenreq,ixreq
  !d print *,cbuf(:lencwd)
  !d print *,creqp(:lenreq)
  if( ixreq + lenreq -1 == lencwd )                     then
  !        Already there
!     call warnlog( cSr, ' already in '//trim(creqp) )
     istat = 1
                                                        else
     call set_cwd( creqp, istat )
     if( istat /= 0 )                               then
       write(cerr,'(a,i6,a)') &
          'set_cwd error ',istat,': '
!       call warnlog( csr, trim(cerr)//trim(creqp) )
                                                    endif
                                                        endif
  !
  cbuf = get_cwd( 'full' )
  lencwd = len_trim(cbuf) 
  if( cbuf(lencwd:lencwd) == cdlm ) lencwd = lencwd - 1  
  ! 
  ixreq = index( cbuf(:lencwd), creqp(:lenreq), .true. )

  !d print *,lenreq,cbuf(:lenreq)
  !d print *,lencwd,cbuf(:lencwd),ixreq

  if( ixreq + lenreq -1 /= lencwd )                        then
!     call errorlog( cSr, ' in '//trim(cbuf) )
     istat = 8
                                                        else
     call infolog( cSr, ' in '//trim(cbuf) )
     istat = 0
                                                        endif
  !
  if( present( ccwd ))                                  then
     ccwd = trim( cbuf )
                                                        endif

  end subroutine qset_cwd



      subroutine set_cwd( dir, ierr )
      character(len=*)           :: dir                 ! directory to cd to...
      integer                    :: ierr                ! error status code, 0 = normal
 
#include "fpreproc/byte_declare.h"
      byte_declare dirbuf(512)
      integer, parameter         :: ildmax = 512 
      integer                    :: chdir           &
                                   ,linux_chdir
      integer str_length,ild
      character(len=12)          :: clen
      character(len=*), parameter   :: cSr = 'portlib/mtrfile.set_cwd'
!
      ild=max(1,len_trim(dir))
      !d print *,cSr, ' length ',ild
#ifdef __VMS
      write(6,*) ' ?sset_cwd:  VMS:  cannot change directory.'
      ierr = 1                          ! VMS:  no can do
#endif
#ifdef __UNIX
 
#ifdef __CRAY
      call pxfchdir(dir,0,ierr)
#elif __HP || __IBM || __RS6000
      ierr = chdir(dir(1:ild)//char(0))
#else
      if( ild .lt. ildmax ) then
         call cstring(dir(1:ild),dirbuf,'2C')
         ierr = linux_chdir(dirbuf)
      else
         write(clen,'(I8)')  ild
!         call errorlog( 'portlib/mtrfile.set_ccwd',  ' path too long: '//clen )
         write(6,*) 'set_cwd : too long ',dir(1:ildmax)
         ierr=1
      endif
#endif
 
#endif  /*  __UNIX  */
#ifdef _DEBUG
      if( ierr == 0 )  write(6,*) 'portlib/mtrfile.set_cwd : ',trim(dir)
#endif
 
      return
      end  subroutine set_cwd
 

  subroutine tf_inquire( ilun, cfnm_a, istat_a )
  !.. tf_inquire                       File status enquiry
  !                                    codesys/source/portlib/mtrfile.tf_inquire.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  04Jan2012
  !  Modifications
  !
  !  1.00  04Jan2012                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  use logmod
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  integer, intent(in), optional      :: ilun           ! unit for enquire
  character(len=*), intent(in)     &
                  , optional         :: cfnm_a         ! File name 
  integer, intent(out), optional     :: istat_a        ! return status, 0=OK
  !
  !..local
  integer, parameter                 :: ncfnm = 512  & ! len file name buffer
                                       ,lunio = 6      ! for report
  !
  integer                            :: istat        & ! return status
                                       ,iflb         & ! file length ( bytes )
                                       ,lbuf         & ! ptr into cbuf
                                       ,lfnm           ! len(cfnm)
  !
  logical                            :: lex          & ! .T if file exists
                                       ,lnm          & !            has a name
                                       ,lopen          !            is opened
  !
  character(len=20)                  :: caccs        & ! access method
                                       ,cact         & ! action { R | W | RW }
                                       ,cread        & ! read status  {yes|no|unknown}
                                       ,cwrite         ! write status   "

  character(len=ncfnm)               :: cfnm         & ! file name
                                       ,cbuf           ! IO buffer
  !
  character(len=*),parameter         :: cSr='portlib/mtrfile.tf_inquire'
  !----------------------------------::================!.........................|
  !
  if( present(ilun))                                    then
     inquire(        unit     = ilun   &
                    ,iostat   = istat  &
                    ,access   = caccs  &
                    ,action   = cact   &
                    ,exist    = lex    &
!                    ,flen     = iflb   &
                    ,name     = cfnm   & 
                    ,named    = lnm    &
                    ,opened   = lopen  &
                    ,read     = cread  &
                    ,write    = cwrite &
                                         )
     !
     if( istat /= 0 )                                then
        write(cbuf,*) ' iostat = ',istat  &
                     ,' for unit ',ilun,' :'
                                                     else
        if( .not. lnm )  cfnm = '<unnamed file>'
        lfnm  = min( len_trim(cfnm), ncfnm-12-9-6 ) 
        write(cbuf,'(3a,i4)') ' Status for ',cfnm(:lfnm)  &
                     ,' on unit ',ilun
                                                     endif
  !
  else if( present( cfnm_a ))                           then
     inquire(        file     = cfnm_a &
                    ,iostat   = istat  &
                    ,access   = caccs  &
                    ,action   = cact   &
                    ,exist    = lex    &
!                    ,flen     = iflb   &
                    ,name     = cfnm   & 
                    ,named    = lnm    &
                    ,opened   = lopen  &
                    ,read     = cread  &
                    ,write    = cwrite &
                                         )
     !
     if( istat /= 0 )                                then
        write(cbuf,*) ' iostat = ',istat  &
                     ,' for file ',trim(cfnm),' :'
                                                     else
        write(cbuf,*) ' Status for ',trim(cfnm)        
                                                     endif
                                                        else
     if( present( istat_a))    istat_a = -1
                                                        return
                                                        endif
  !
  if( present( istat_a))    istat_a = istat
  !
  if( istat /= 0 )                                      then
        lbuf = len_trim(cbuf)
#ifdef _LAHEY
        call iostat_msg( istat, cbuf(lbuf+1:) )
#else
        cbuf(lbuf+1:) = "No error description available " 
#endif
!        call errorlog( cSr, trim(cbuf))
                                                        return
                                                        endif
  !
  write(lunio,*) trim(cbuf)
  if( .not. lex ) write(lunio,*) '    File does not exist ! '
  write(lunio,100 ) trim(caccs), trim(cact), iflb, lopen &
                   ,trim( cread), trim(cwrite)
  !
  100 format( 4x,'Access ',t24,a  &
             /4x,'Action ',t24,a  &
             /4x,'Length ',t24,i9,' bytes' &
             /4x,'Open ? ',t24,l  &
             /4x,'Read ? ',t24,a, t36,'Write ? ',t48,a &
            )
  !
  end subroutine tf_inquire

   end module mtrfile

#ifdef _TEST

  program test_trfile
  !.. test_trfile                      As on the tin
  !                                    codesys/source/portlib/mtrfile.test_trfile.
  !
  !  Usage
  ! >cpp --traditional =1/portlib/mtrfile.f90 ./mtrfile.f90
  ! >lf95 --nfix mtrfile.f90 -o ttrfile -I $CS/mod -l:$CS/lib/portlib.a
  !
  !  Test VMS function ( on Unix )
  ! >cpp --traditional -D_VMS_TEST =1/portlib/showdefl.for ./showdefl.for
  ! >lf95 -c showdefl.for
  ! >lf95 --nfix mtrfile.f90 showdefl.o -o ttrfile -I $CS/mod -l:$CS/lib/portlib.a
  !
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  17Jan2012
  !  Modifications
  !
  !  1.00  17Jan2012                   <author>@<place>
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  use mtrfile
  use logmod
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..local
  integer                            :: i            & ! loop index 
                                       ,istat
  character(len=256)                 :: ccwd
  !
  character(len=*),parameter         :: cPr='portlib/mtrfile.test_trfile'
  !----------------------------------::================!.........................|
  !
  call openlog( 'testtrfile.log' )
  call setloglevel( 'inf' )
  !
  ccwd = get_cwd( 'full' )
  print *,cPr,' -I- "',trim(ccwd),'"'
  !
  ccwd = get_cwd( 'last' )
  print *,cPr,' -I- "',trim(ccwd),'"'
  !
  ccwd = 'TranspTemp'
  call mklink( '/common/transp_shared/Code/transp/JET_56/tmp', ccwd, istat )
  !
  call mkdir( 'Test', istat )
  !
  call qset_cwd( 'Test', istat, ccwd  )
  print *,cPr,' in ',trim(ccwd )
  !
  call qset_cwd( 'Test', istat, ccwd  )
  print *,cPr,' in ',trim(ccwd )
  !
  end program test_trfile
#endif

subroutine evintrp3d(xget,yget,zget,x,nx,y,ny,z,nz,jspline, &
     f,icoeff,ixdim,iydim,izdim,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !
  !  use mkintrp3d to set up spline coefficients...
  !
  !  evaluate a 3d Hybrid interpolant on a rectilinear grid
  !
  !  this subroutine calls two subroutines:
  !     vecin3d_argchk -- error check
  !     herm3xyz  -- find cell containing (xget,yget,zget)
  !     fvintrp3d  -- evaluate the spline function (w/derivatives if req.)
  !
  !  input arguments:
  !  ================
  !
  implicit none
  real(fp) :: xget,yget,zget               ! target of this interpolation
  integer nx,ny,nz                  ! grid sizes
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  real(fp) :: z(nz)                        ! ordered z grid
  !
  integer :: jspline(3)             ! interpolation method for each
  !           dimension: jspline(1) for x; jspline(2) for y; jspline(3) for z
  !           =-1: zonal step function; =0: pc lin; =1: Hermite; =2: Spline
  !
  integer :: icoeff                 ! no. of coefficients per data point

  integer :: ixdim,iydim,izdim      ! dimensioning:
  !  ixdim=nx-1 for zonal step in x; otherwise nx
  !  iydim=ny-1 for zonal step in y; otherwise ny
  !  izdim=nz-1 for zonal step in z; otherwise nz
  !
  real(fp) :: f(icoeff,ixdim,iydim,izdim)  ! function data
  !
  integer ict(10)                   ! code specifying output desired
  !
  !  Note on derivatives: for dimensions along which zonal step function
  !    interpolation is done, ANY derivative request returns ZERO.
  !    For dimensions along which piecewise linear or Hermite interpolation
  !    are done, more than one differentiation returns ZERO!
  !
  !  Derivative controls are the same as for the compact 3d spline evaluation
  !  routine (evtricub):
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return df/dz  (0, don't)
  !  ict(5)=1 -- return d2f/dx2  (0, don't)
  !  ict(6)=1 -- return d2f/dy2  (0, don't)
  !  ict(7)=1 -- return d2f/dz2  (0, don't)
  !  ict(8)=1 -- return d2f/dxdy (0, don't)
  !  ict(9)=1 -- return d2f/dxdz (0, don't)
  !  ict(10)=1-- return d2f/dydz (0, don't)
  !
  !  (new dmc Dec 2005 -- higher derivatives available)
  !    ict(1)=3 --> 3rd derivative, .le.2 diff. in any coordinate
  !      ict(2:8) select: fxxy fxxz fxyy fxyz fxzz fyyz fyzz
  !      ->note ict(1)=3, ict(5)=1 gives fxyz = d3f/dxdydz
  !    ict(1)=-3 --> 3rd derivative, 3 in one coordinate
  !      ict(2:4) select: fxxx fyyy fzzz
  !    ict(1)=4 --> 3rd derivative, .le.2 diff. in any coordinate
  !      ict(2:7) select: fxxyy fxxyz fxxzz fxyyz fxyzz fyyzz
  !    ict(1)=-4 --> 3rd derivative, 3 in one coordinate
  !      ict(2:7) select: fxxxy fxxxz fxyyy fxzzz fyyyz fyzzz
  !    ict(1)=5 --> 3rd derivative, .le.2 diff. in any coordinate
  !      ict(2:4) select: fxxyyz fxxyzz fxyyzz
  !    ict(1)=-5 --> 3rd derivative, 3 in one coordinate
  !      ict(2:10) select:  fxxxyy fxxxyz fxxxzz fxxyyy fxxzzz
  !                         fxyyyz fxyzzz fyyyzz fzzzyy
  !    ict(1)=6 --> 3rd derivative, .le.2 diff. in any coordinate
  !      fxxyyzz
  !    ict(1)=-6 --> 3rd derivative, 3 in one coordinate
  !      ict(2:10) select: fxxxyyy fxxxyyz fxxxyzz fxxxyyz
  !                        fxxyyyz fxxyzzz fxyyyzz fxyyzzz fyyyzzz
  !    ict(1)=-7 --> 7th derivative
  !      ict(2:7) select: fxxxyyyz fxxxyyzz fxxxyzzz
  !                       fxxyyyzz fxxyyzzz fxyyyzzz
  !    ict(1)=-8 --> 8th derivative
  !      ict(2:4) select: fxxxyyyzz fxxxyyzzz fxxyyyzzz
  !    ict(1)=-9 --> 9th derivative:  fxxxyyyzzz
  !
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(10)                     ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the 4th output (depends on ict(...) spec)
  !  fval(5-10) receive 5th thru 10th outputs (if required by ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,1,0,0,0,0,0,0,0]
  !   on output fval= [f,df/dx,df/dy,df/dz]
  !
  !    on input ict = [1,0,0,0,0,0,0,0,0,0,0]
  !   on output fval= [f] ... elements 2-10 never referenced
  !
  !    on input ict = [0,1,1,0,0,0,0,0,0,0,0]
  !   on output fval= [df/dx,df/dy] ... elements 3-10 never referenced
  !
  !    on input ict = [0,0,0,0,1,0,0,0,0,0,0]
  !   on output fval= [d2f/dx2] ... elements 2-10 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j,k                     ! cell indices
  !
  !  normalized displacement from (x(i),y(j),z(k)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !    zparam=0 @z(k)  zparam=1 @z(k+1)
  !
  real(fp) :: xparam,yparam,zparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy,hz
  real(fp), dimension(1) :: hxi,hyi,hzi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !  0 .le. zparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call vecin3d_argchk('evintrp3d',jspline, &
       icoeff,nx,ny,nz,ixdim,iydim,izdim,ier)
  if(ier.ne.0) return
  !
  !  use lookup routine as in Hermite interpolation
  !
  call herm3xyz(xget,yget,zget,x,nx,y,ny,z,nz,0,0,0, &
       i(1),j(1),k(1),xparam,yparam,zparam, &
       hx(1),hxi(1),hy(1),hyi(1),hz(1),hzi(1),ier)
  if(ier.ne.0) return
  !
  call fvintrp3d(ict,1,1, &
       fval,i,j,k,xparam,yparam,zparam, &
       hx,hxi,hy,hyi,hz,hzi, &
       jspline,f,icoeff,ixdim,iydim,izdim)

  !
  return
end subroutine evintrp3d
!---------------------------------------------------------------------
!  evaluate Hybrid function interpolation -- 3d fcn
!   NO ERROR CHECKING
!
subroutine fvintrp3d(ict,ivec,ivecd, &
     fval,ii,jj,kk,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi, &
     jspline,fin,icoeff,ixdim,iydim,izdim)
  use iso_c_binding, only: fp => c_double
  !
  !
  !  use mkintrp3d to set up spline coefficients...
  !
  implicit none
  integer ict(10)                   ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec),kk(ivec) ! target cells (i,j,k)
  real(fp) :: xparam(ivec),yparam(ivec),zparam(ivec)
  ! normalized displacements from (i,j,k) corners
  !
  real(fp) :: hx(ivec),hy(ivec),hz(ivec)   ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec),hzi(ivec) ! inverse grid spacing
  ! 1/(x(i+1)-x(i)) & 1/(y(j+1)-y(j)) & 1/(z(k+1)-z(i))
  !
  integer :: jspline(3)             ! interpolation type control
  integer :: icoeff                 ! coefficient dimension
  integer :: ixdim,iydim,izdim      ! x & y & z dimensions
  real(fp) :: fin(icoeff,ixdim,iydim,izdim)  ! data on which to interpolate...
  !
  real(fp) :: fval(ivecd,10)               ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine evintrp3d
  !  comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj,kk and parameter inputs
  !     xparam,yparam,zparam,hx,hxi,hy,hyi,hz,hzi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  local:
  !
  integer :: i,j,k1,k2,imaxx,imaxy,imaxz,linrank,cubrank,zonrank
  logical :: splin_flag
  !
  integer :: inum
  integer :: iderivs(3,10),ict8(8),maxd_lin(8),maxd_cub(8)
  integer :: idcub,idlin,idcub2(2),idlin2(2)
  !
  real(fp) :: xp,yp,hhx,hhy,hhxi,hhyi,fac1,fac2(2)
  real(fp) :: h,hi,hhi,h2(2),h2i(2)
  real(fp) :: f22(2,2),f22b(2,2),f2222(2,2,2,2),ans22(2,2),ans1,ans2
  real(fp) :: f422(4,2,2),f422b(4,2,2)
  !
  real(fp), parameter :: ONE = 1.0_fp
  real(fp), parameter :: sixth = 0.166666666666666667_fp
  real(fp), parameter :: z36th = sixth*sixth
  !
  !---------------
  !
  zonrank=0
  linrank=0
  cubrank=0

  do i=1,3
     if(jspline(i).eq.-1) then
        zonrank = zonrank + 1
     else if(jspline(i).eq.0) then
        linrank = linrank + 1
     else
        splin_flag = jspline(i).eq.2
        cubrank = cubrank + 1
     end if
  end do
  !
  if(cubrank.eq.3) then
     if(splin_flag) then
        !  bicubic spline
        call fvtricub(ict,ivec,ivecd, &
             fval,ii,jj,kk,xparam,yparam,zparam, &
             hx,hxi,hy,hyi,hz,hzi, &
             fin,ixdim,iydim,izdim)

     else
        !  bicubic Hermite -- translate derivative code
        call dtrans
        do i=1,inum
           if(maxval(iderivs(1:3,i)).le.1) then
              call gen_ict8

              call herm3fcn(ict8,ivec,ivecd, &
                   fval(1,i),ii,jj,kk,xparam,yparam,zparam, &
                   hx,hxi,hy,hyi,hz,hzi, &
                   fin,ixdim,iydim,izdim)

           else
              fval(1:ivec,i) = 0
           end if
        end do
     end if

     return
  end if

  call dtrans

  if(cubrank.eq.0) then
     if(jspline(1).eq.-1) then
        imaxx=0
     else
        imaxx=1
     end if
     if(jspline(2).eq.-1) then
        imaxy=0
     else
        imaxy=1
     end if
     if(jspline(3).eq.-1) then
        imaxz=0
     else
        imaxz=1
     end if

     do i=1,inum
        if((iderivs(1,i).le.imaxx).and.(iderivs(2,i).le.imaxy) &
             .and.(iderivs(3,i).le.imaxz)) then
           if(linrank.eq.3) then
              !  trilinear interpolation
              call gen_ict8

              call pc3fcn(ict8,ivec,ivecd, &
                   fval(1,i), ii,jj,kk, xparam,yparam,zparam, &
                   hx,hxi, hy,hyi, hz,hzi, &
                   fin, ixdim,iydim,izdim)
           else if(zonrank.eq.3) then
              !  3d step fcn
              do j=1,ivec
                 fval(j,i)=fin(1,ii(j),jj(j),kk(j))
              end do
           else if(linrank.eq.1) then
              if(jspline(1).eq.0) then
                 ! linear in x, zonal in y,z
                 do j=1,ivec
                    if(iderivs(1,i).eq.0) then
                       fval(j,i) = &
                            (ONE-xparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j),kk(j))
                    else
                       fval(j,i) = hxi(j)* &
                            (fin(1,ii(j)+1,jj(j),kk(j))- &
                            fin(1,ii(j),jj(j),kk(j)))
                    end if
                 end do
              else if(jspline(2).eq.0) then
                 ! linear in y, zonal in x,z
                 do j=1,ivec
                    if(iderivs(2,i).eq.0) then
                       fval(j,i) = &
                            (ONE-yparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            +yparam(j)*fin(1,ii(j),jj(j)+1,kk(j))
                    else
                       fval(j,i) = hyi(j)* &
                            (fin(1,ii(j),jj(j)+1,kk(j))- &
                            fin(1,ii(j),jj(j),kk(j)))
                    end if
                 end do
              else
                 ! linear in z, zonal in x,y
                 do j=1,ivec
                    if(iderivs(3,i).eq.0) then
                       fval(j,i) = &
                            (ONE-zparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            +zparam(j)*fin(1,ii(j),jj(j),kk(j)+1)
                    else
                       fval(j,i) = hzi(j)* &
                            (fin(1,ii(j),jj(j),kk(j)+1)- &
                            fin(1,ii(j),jj(j),kk(j)))
                    end if
                 end do
              end if
           else
              if(jspline(1).eq.-1) then
                 ! zonal in x, linear in y,z
                 do j=1,ivec
                    if((iderivs(2,i).eq.0).and. &
                         (iderivs(3,i).eq.0)) then
                       fval(j,i) = (ONE-zparam(j))* &
                            ((ONE-yparam(j))* &
                            fin(1,ii(j),jj(j),kk(j)) &
                            +yparam(j)*fin(1,ii(j),jj(j)+1,kk(j))) &
                            +zparam(j)* &
                            ((ONE-yparam(j))* &
                            fin(1,ii(j),jj(j),kk(j)+1) &
                            +yparam(j)*fin(1,ii(j),jj(j)+1,kk(j)+1))

                    else if((iderivs(2,i).eq.1).and. &
                         (iderivs(3,i).eq.0)) then
                       fval(j,i) = hyi(j)*( &
                            (ONE-zparam(j))*fin(1,ii(j),jj(j)+1,kk(j)) &
                            +zparam(j)*fin(1,ii(j),jj(j)+1,kk(j)+1) &
                            -(ONE-zparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -zparam(j)*fin(1,ii(j),jj(j),kk(j)+1)  )

                    else if((iderivs(2,i).eq.0).and. &
                         (iderivs(3,i).eq.1)) then
                       fval(j,i) = hzi(j)*( &
                            (ONE-yparam(j))*fin(1,ii(j),jj(j),kk(j)+1) &
                            +yparam(j)*fin(1,ii(j),jj(j)+1,kk(j)+1) &
                            -(ONE-yparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -yparam(j)*fin(1,ii(j),jj(j)+1,kk(j))  )

                    else
                       fval(j,i) = hyi(j)*hzi(j)*( &
                            fin(1,ii(j),jj(j),kk(j)) &
                            -fin(1,ii(j),jj(j)+1,kk(j)) &
                            -fin(1,ii(j),jj(j),kk(j)+1) &
                            +fin(1,ii(j),jj(j)+1,kk(j)+1))

                    end if
                 end do
              else if(jspline(2).eq.-1) then
                 ! zonal in y, linear in x,z
                 do j=1,ivec
                    if((iderivs(1,i).eq.0).and. &
                         (iderivs(3,i).eq.0)) then
                       fval(j,i) = (ONE-zparam(j))* &
                            ((ONE-xparam(j))* &
                            fin(1,ii(j),jj(j),kk(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j),kk(j))) &
                            +zparam(j)* &
                            ((ONE-xparam(j))* &
                            fin(1,ii(j),jj(j),kk(j)+1) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j),kk(j)+1))

                    else if((iderivs(1,i).eq.1).and. &
                         (iderivs(3,i).eq.0)) then
                       fval(j,i) = hxi(j)*( &
                            (ONE-zparam(j))*fin(1,ii(j)+1,jj(j),kk(j)) &
                            +zparam(j)*fin(1,ii(j)+1,jj(j),kk(j)+1) &
                            -(ONE-zparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -zparam(j)*fin(1,ii(j),jj(j),kk(j)+1)  )

                    else if((iderivs(1,i).eq.0).and. &
                         (iderivs(3,i).eq.1)) then
                       fval(j,i) = hzi(j)*( &
                            (ONE-xparam(j))*fin(1,ii(j),jj(j),kk(j)+1) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j),kk(j)+1) &
                            -(ONE-xparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -xparam(j)*fin(1,ii(j)+1,jj(j),kk(j))  )

                    else
                       fval(j,i) = hxi(j)*hzi(j)*( &
                            fin(1,ii(j),jj(j),kk(j)) &
                            -fin(1,ii(j)+1,jj(j),kk(j)) &
                            -fin(1,ii(j),jj(j),kk(j)+1) &
                            +fin(1,ii(j)+1,jj(j),kk(j)+1))

                    end if
                 end do
              else
                 ! zonal in z, linear in x,y
                 do j=1,ivec
                    if((iderivs(1,i).eq.0).and. &
                         (iderivs(2,i).eq.0)) then
                       fval(j,i) = (ONE-yparam(j))* &
                            ((ONE-xparam(j))* &
                            fin(1,ii(j),jj(j),kk(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j),kk(j))) &
                            +yparam(j)* &
                            ((ONE-xparam(j))* &
                            fin(1,ii(j),jj(j)+1,kk(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j)+1,kk(j)))

                    else if((iderivs(1,i).eq.1).and. &
                         (iderivs(2,i).eq.0)) then
                       fval(j,i) = hxi(j)*( &
                            (ONE-yparam(j))*fin(1,ii(j)+1,jj(j),kk(j)) &
                            +yparam(j)*fin(1,ii(j)+1,jj(j)+1,kk(j)) &
                            -(ONE-yparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -yparam(j)*fin(1,ii(j),jj(j)+1,kk(j))  )

                    else if((iderivs(1,i).eq.0).and. &
                         (iderivs(2,i).eq.1)) then
                       fval(j,i) = hyi(j)*( &
                            (ONE-xparam(j))*fin(1,ii(j),jj(j)+1,kk(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j)+1,kk(j)) &
                            -(ONE-xparam(j))*fin(1,ii(j),jj(j),kk(j)) &
                            -xparam(j)*fin(1,ii(j)+1,jj(j),kk(j))  )

                    else
                       fval(j,i) = hxi(j)*hyi(j)*( &
                            fin(1,ii(j),jj(j),kk(j)) &
                            -fin(1,ii(j)+1,jj(j),kk(j)) &
                            -fin(1,ii(j),jj(j)+1,kk(j)) &
                            +fin(1,ii(j)+1,jj(j)+1,kk(j)))

                    end if
                 end do
              end if
           end if
        else
           fval(1:ivec,i) = 0
        end if
     end do

     return
  end if

  !  OK -- Hybrid: Hermite or Spline in one or two dimensions
  !        pclin or step in the other dimension(s).

  if(jspline(1).eq.2) then
     imaxx=3
  else if(jspline(1).eq.-1) then
     imaxx=0
  else
     imaxx=1
  end if

  if(jspline(2).eq.2) then
     imaxy=3
  else if(jspline(2).eq.-1) then
     imaxy=0
  else
     imaxy=1
  end if

  if(jspline(3).eq.2) then
     imaxz=3
  else if(jspline(3).eq.-1) then
     imaxz=0
  else
     imaxz=1
  end if

  if(cubrank.eq.1) then
     !  cubic in 1 dimension; bilinear or lookup in other dimensions

     do i=1,inum
        if(jspline(1).ge.1) then
           idcub=iderivs(1,i)
           idlin2(1)=iderivs(2,i)
           idlin2(2)=iderivs(3,i)
        else if(jspline(2).ge.1) then
           idcub=iderivs(2,i)
           idlin2(1)=iderivs(1,i)
           idlin2(2)=iderivs(3,i)
        else if(jspline(3).ge.1) then
           idcub=iderivs(3,i)
           idlin2(1)=iderivs(1,i)
           idlin2(2)=iderivs(2,i)
        end if

        if((iderivs(1,i).le.imaxx).and.(iderivs(2,i).le.imaxy) &
             .and.(iderivs(3,i).le.imaxz)) then
           if(linrank.eq.2) then
              do j=1,ivec
                 if(jspline(1).ge.1) then
                    xp=xparam(j)
                    fac2(1)=yparam(j)
                    fac2(2)=zparam(j)
                    h=hx(j)
                    hi=hxi(j)
                    h2i(1)=hyi(j)
                    h2i(2)=hzi(j)
                    f2222(1:2,1,1:2,1:2) = &
                         fin(1:2,ii(j),jj(j):jj(j)+1,kk(j):kk(j)+1)
                    f2222(1:2,2,1:2,1:2) = &
                         fin(1:2,ii(j)+1,jj(j):jj(j)+1,kk(j):kk(j)+1)
                 else if(jspline(2).ge.1) then
                    xp=yparam(j)
                    fac2(1)=xparam(j)
                    fac2(2)=zparam(j)
                    h=hy(j)
                    hi=hyi(j)
                    h2i(1)=hxi(j)
                    h2i(2)=hzi(j)
                    f2222(1:2,1,1:2,1:2) = &
                         fin(1:2,ii(j):ii(j)+1,jj(j),kk(j):kk(j)+1)
                    f2222(1:2,2,1:2,1:2) = &
                         fin(1:2,ii(j):ii(j)+1,jj(j)+1,kk(j):kk(j)+1)
                 else if(jspline(3).ge.1) then
                    xp=zparam(j)
                    fac2(1)=xparam(j)
                    fac2(2)=yparam(j)
                    h=hz(j)
                    hi=hzi(j)
                    h2i(1)=hxi(j)
                    h2i(2)=hyi(j)
                    f2222(1:2,1,1:2,1:2) = &
                         fin(1:2,ii(j):ii(j)+1,jj(j):jj(j)+1,kk(j))
                    f2222(1:2,2,1:2,1:2) = &
                         fin(1:2,ii(j):ii(j)+1,jj(j):jj(j)+1,kk(j)+1)
                 end if

                 !  evaluate 2x2 array of 1d splines
                 do k2=1,2
                    do k1=1,2
                       if(splin_flag) then
                          call sp1d(ans22(k1,k2), &
                               f2222(1:2,1:2,k1,k2))
                       else
                          call hm1d(ans22(k1,k2), &
                               f2222(1:2,1:2,k1,k2))
                       end if
                    end do
                 end do

                 !  bilinear interpolation
                 if((idlin2(1).eq.0).and.(idlin2(2).eq.0)) then
                    !  value
                    ans1 = (ONE-fac2(2))* &
                         ((ONE-fac2(1))*ans22(1,1)+fac2(1)*ans22(2,1)) &
                         +fac2(2)* &
                         ((ONE-fac2(1))*ans22(1,2)+fac2(1)*ans22(2,2))
                 else if((idlin2(1).eq.1).and.(idlin2(2).eq.0)) then
                    !  1st deriv along 1st dimension
                    ans1 = (ONE-fac2(2))*(ans22(2,1)-ans22(1,1)) &
                         +fac2(2)*(ans22(2,2)-ans22(1,2))
                    ans1 = ans1*h2i(1)
                 else if((idlin2(1).eq.0).and.(idlin2(2).eq.1)) then
                    !  1st deriv along 2nd dimension
                    ans1 = (ONE-fac2(1))*(ans22(1,2)-ans22(1,1)) &
                         +fac2(1)*(ans22(2,2)-ans22(2,1))
                    ans1 = ans1*h2i(2)
                 else
                    !  derivatives along both dimensions
                    ans1 = ans22(2,2)-ans22(1,2) &
                         -ans22(2,1)+ans22(1,1)
                    ans1 = ans1*h2i(1)*h2i(2)
                 end if
                 fval(j,i)=ans1
              end do

           else if(linrank.eq.0) then
              do j=1,ivec
                 if(jspline(1).ge.1) then
                    xp=xparam(j)
                    h=hx(j)
                    hi=hxi(j)
                    f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                    f22(1:2,2)=fin(1:2,ii(j)+1,jj(j),kk(j))
                 else if(jspline(2).ge.1) then
                    xp=yparam(j)
                    h=hy(j)
                    hi=hyi(j)
                    f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                    f22(1:2,2)=fin(1:2,ii(j),jj(j)+1,kk(j))
                 else if(jspline(3).ge.1) then
                    xp=zparam(j)
                    h=hz(j)
                    hi=hzi(j)
                    f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                    f22(1:2,2)=fin(1:2,ii(j),jj(j),kk(j)+1)
                 end if
                 if(splin_flag) then
                    call sp1d(ans1,f22)
                 else
                    call hm1d(ans1,f22)
                 end if
                 fval(j,i)=ans1
              end do

           else if(linrank.eq.1) then
              do j=1,ivec
                 if(jspline(1).ge.1) then
                    xp=xparam(j)
                    h=hx(j)
                    hi=hxi(j)
                    if(jspline(2).eq.0) then
                       hhi=hyi(j)
                       fac1=yparam(j)
                       idlin=iderivs(2,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j)+1,jj(j),kk(j))
                       f22b(1:2,1)=fin(1:2,ii(j),jj(j)+1,kk(j))
                       f22b(1:2,2)=fin(1:2,ii(j)+1,jj(j)+1,kk(j))
                    else
                       hhi=hzi(j)
                       fac1=zparam(j)
                       idlin=iderivs(3,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j)+1,jj(j),kk(j))
                       f22b(1:2,1)=fin(1:2,ii(j),jj(j),kk(j)+1)
                       f22b(1:2,2)=fin(1:2,ii(j)+1,jj(j),kk(j)+1)
                    end if
                 else if(jspline(2).ge.1) then
                    xp=yparam(j)
                    h=hy(j)
                    hi=hyi(j)
                    if(jspline(1).eq.0) then
                       hhi=hxi(j)
                       fac1=xparam(j)
                       idlin=iderivs(1,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j),jj(j)+1,kk(j))
                       f22b(1:2,1)=fin(1:2,ii(j)+1,jj(j),kk(j))
                       f22b(1:2,2)=fin(1:2,ii(j)+1,jj(j)+1,kk(j))
                    else
                       hhi=hzi(j)
                       fac1=zparam(j)
                       idlin=iderivs(3,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j),jj(j)+1,kk(j))
                       f22b(1:2,1)=fin(1:2,ii(j),jj(j),kk(j)+1)
                       f22b(1:2,2)=fin(1:2,ii(j),jj(j)+1,kk(j)+1)
                    end if
                 else if(jspline(3).ge.1) then
                    xp=zparam(j)
                    h=hz(j)
                    hi=hzi(j)
                    if(jspline(1).eq.0) then
                       hhi=hxi(j)
                       fac1=xparam(j)
                       idlin=iderivs(1,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j),jj(j),kk(j)+1)
                       f22b(1:2,1)=fin(1:2,ii(j)+1,jj(j),kk(j))
                       f22b(1:2,2)=fin(1:2,ii(j)+1,jj(j),kk(j)+1)
                    else
                       hhi=hyi(j)
                       fac1=yparam(j)
                       idlin=iderivs(2,i)
                       f22(1:2,1)=fin(1:2,ii(j),jj(j),kk(j))
                       f22(1:2,2)=fin(1:2,ii(j),jj(j),kk(j)+1)
                       f22b(1:2,1)=fin(1:2,ii(j),jj(j)+1,kk(j))
                       f22b(1:2,2)=fin(1:2,ii(j),jj(j)+1,kk(j)+1)
                    end if
                 end if
                 if(splin_flag) then
                    call sp1d(ans1,f22)
                    call sp1d(ans2,f22b)
                 else
                    call hm1d(ans1,f22)
                    call hm1d(ans2,f22b)
                 end if
                 if(idlin.eq.0) then
                    fval(j,i)=(ONE-fac1)*ans1 + fac1*ans2
                 else
                    fval(j,i)=(ans2-ans1)*hhi
                 end if
              end do

           end if
        else
           fval(1:ivec,i) = 0
        end if
     end do
     return
  end if

  !  OK:  cubic in 2 dimensions; linear or lookup in other dimension.

  do i=1,inum
     if(jspline(1).le.0) then
        idlin=iderivs(1,i)
        idcub2(1)=iderivs(2,i)
        idcub2(2)=iderivs(3,i)
     else if(jspline(2).le.0) then
        idlin=iderivs(2,i)
        idcub2(1)=iderivs(1,i)
        idcub2(2)=iderivs(3,i)
     else if(jspline(3).le.0) then
        idlin=iderivs(3,i)
        idcub2(1)=iderivs(1,i)
        idcub2(2)=iderivs(2,i)
     end if

     if((iderivs(1,i).le.imaxx).and.(iderivs(2,i).le.imaxy) &
          .and.(iderivs(3,i).le.imaxz)) then

        if(linrank.eq.1) then
           ! linear interpolation in non-spline dimension
           do j=1,ivec
              if(jspline(1).le.0) then
                 fac1=xparam(j)
                 hi=hxi(j)
                 xp=yparam(j)
                 yp=zparam(j)
                 hhx=hy(j)
                 hhxi=hyi(j)
                 hhy=hz(j)
                 hhyi=hzi(j)
                 f422 = fin(1:4,ii(j),jj(j):jj(j)+1,kk(j):kk(j)+1)
                 f422b= fin(1:4,ii(j)+1,jj(j):jj(j)+1,kk(j):kk(j)+1)
              else if(jspline(2).le.0) then
                 fac1=yparam(j)
                 hi=hyi(j)
                 xp=xparam(j)
                 yp=zparam(j)
                 hhx=hx(j)
                 hhxi=hxi(j)
                 hhy=hz(j)
                 hhyi=hzi(j)
                 f422 = fin(1:4,ii(j):ii(j)+1,jj(j),kk(j):kk(j)+1)
                 f422b= fin(1:4,ii(j):ii(j)+1,jj(j)+1,kk(j):kk(j)+1)
              else if(jspline(3).le.0) then
                 fac1=zparam(j)
                 hi=hzi(j)
                 xp=xparam(j)
                 yp=yparam(j)
                 hhx=hx(j)
                 hhxi=hxi(j)
                 hhy=hy(j)
                 hhyi=hyi(j)
                 f422 = fin(1:4,ii(j):ii(j)+1,jj(j):jj(j)+1,kk(j))
                 f422b= fin(1:4,ii(j):ii(j)+1,jj(j):jj(j)+1,kk(j)+1)
              end if
              if(splin_flag) then
                 call sp2d(ans1,f422)
                 call sp2d(ans2,f422b)
              else
                 call hm2d(ans1,f422)
                 call hm2d(ans2,f422b)
              end if
              if(idlin.eq.1) then
                 fval(j,i) = (ans2-ans1)*hi
              else
                 fval(j,i) = (ONE-fac1)*ans1 + fac1*ans2
              end if
           end do
        else
           ! lookup in the non-spline dimension
           do j=1,ivec
              if(jspline(1).le.0) then
                 xp=yparam(j)
                 yp=zparam(j)
                 hhx=hy(j)
                 hhxi=hyi(j)
                 hhy=hz(j)
                 hhyi=hzi(j)
                 f422 = fin(1:4,ii(j),jj(j):jj(j)+1,kk(j):kk(j)+1)
              else if(jspline(2).le.0) then
                 xp=xparam(j)
                 yp=zparam(j)
                 hhx=hx(j)
                 hhxi=hxi(j)
                 hhy=hz(j)
                 hhyi=hzi(j)
                 f422 = fin(1:4,ii(j):ii(j)+1,jj(j),kk(j):kk(j)+1)
              else if(jspline(3).le.0) then
                 xp=xparam(j)
                 yp=yparam(j)
                 hhx=hx(j)
                 hhxi=hxi(j)
                 hhy=hy(j)
                 hhyi=hyi(j)
                 f422 = fin(1:4,ii(j):ii(j)+1,jj(j):jj(j)+1,kk(j))
              end if
              if(splin_flag) then
                 call sp2d(ans1,f422)
              else
                 call hm2d(ans1,f422)
              end if
              fval(j,i) = ans1
           end do
        end if
     else
        fval(1:ivec,i) = 0
     end if
  end do
contains
  subroutine gen_ict8
    ict8=0
    if(iderivs(1,i).eq.0) then
       if(iderivs(2,i).eq.0) then
          if(iderivs(3,i).eq.0) then
             ict8(1)=1    ! f
          else
             ict8(4)=1    ! df/dz
          end if
       else
          if(iderivs(3,i).eq.0) then
             ict8(3)=1    ! df/dy
          else
             ict8(7)=1    ! d2f/dydz
          end if
       end if
    else
       if(iderivs(2,i).eq.0) then
          if(iderivs(3,i).eq.0) then
             ict8(2)=2    ! df/dx
          else
             ict8(6)=6    ! d2f/dxdz
          end if
       else
          if(iderivs(3,i).eq.0) then
             ict8(5)=1    ! d2f/dxdy
          else
             ict8(8)=1    ! d3f/dxdydz
          end if
       end if
    end if
  end subroutine gen_ict8

  subroutine dtrans

    ! convert ict(...) codes into intermediate coding:
    !   iderivs(i,j) = number of differentiations in coordinate i
    !                  of the j'th value evaluated

    !   maxd_lin(j) = max # of differentiations for a linear dimension
    !   maxd_cub(j) = max # of differentiations for a spline dimension

    integer :: i

    inum=0   ! actual number of vectors to be evaluated (summed here)

    if(abs(ict(1)).le.(2)) then
       if(ict(1).eq.1) then
          call add1(0,0,0)
       end if
       if(ict(2).eq.1) then
          call add1(1,0,0)
       end if
       if(ict(3).eq.1) then
          call add1(0,1,0)
       end if
       if(ict(4).eq.1) then
          call add1(0,0,1)
       end if
       if(ict(5).eq.1) then
          call add1(2,0,0)
       end if
       if(ict(6).eq.1) then
          call add1(0,2,0)
       end if
       if(ict(7).eq.1) then
          call add1(0,0,2)
       end if
       if(ict(8).eq.1) then
          call add1(1,1,0)
       end if
       if(ict(9).eq.1) then
          call add1(1,0,1)
       end if
       if(ict(10).eq.1) then
          call add1(0,1,1)
       end if

    else if(ict(1).eq.3) then
       if(ict(2).eq.1) then
          call add1(2,1,0)
       end if
       if(ict(3).eq.1) then
          call add1(2,0,1)
       end if
       if(ict(4).eq.1) then
          call add1(1,2,0)
       end if
       if(ict(5).eq.1) then
          call add1(1,1,1)
       end if
       if(ict(6).eq.1) then
          call add1(1,0,2)
       end if
       if(ict(7).eq.1) then
          call add1(0,2,1)
       end if
       if(ict(8).eq.1) then
          call add1(0,1,2)
       end if

    else if(ict(1).eq.-3) then
       if(ict(2).eq.1) then
          call add1(3,0,0)
       end if
       if(ict(3).eq.1) then
          call add1(0,3,0)
       end if
       if(ict(4).eq.1) then
          call add1(0,0,3)
       end if

    else if(ict(1).eq.4) then
       if(ict(2).eq.1) then
          call add1(2,2,0)
       end if
       if(ict(3).eq.1) then
          call add1(2,1,1)
       end if
       if(ict(4).eq.1) then
          call add1(2,0,2)
       end if
       if(ict(5).eq.1) then
          call add1(1,2,1)
       end if
       if(ict(6).eq.1) then
          call add1(1,1,2)
       end if
       if(ict(7).eq.1) then
          call add1(0,2,2)
       end if

    else if(ict(1).eq.-4) then
       if(ict(2).eq.1) then
          call add1(3,1,0)
       end if
       if(ict(3).eq.1) then
          call add1(3,0,1)
       end if
       if(ict(4).eq.1) then
          call add1(1,3,0)
       end if
       if(ict(5).eq.1) then
          call add1(1,0,3)
       end if
       if(ict(6).eq.1) then
          call add1(0,3,1)
       end if
       if(ict(7).eq.1) then
          call add1(0,1,3)
       end if

    else if(ict(1).eq.5) then
       if(ict(2).eq.1) then
          call add1(2,2,1)
       end if
       if(ict(3).eq.1) then
          call add1(2,1,2)
       end if
       if(ict(4).eq.1) then
          call add1(1,2,2)
       end if

    else if(ict(1).eq.-5) then
       if(ict(2).eq.1) then
          call add1(3,2,0)
       end if
       if(ict(3).eq.1) then
          call add1(3,1,1)
       end if
       if(ict(4).eq.1) then
          call add1(3,0,2)
       end if
       if(ict(5).eq.1) then
          call add1(2,3,0)
       end if
       if(ict(6).eq.1) then
          call add1(2,0,3)
       end if
       if(ict(7).eq.1) then
          call add1(1,3,1)
       end if
       if(ict(8).eq.1) then
          call add1(1,1,3)
       end if
       if(ict(9).eq.1) then
          call add1(0,3,2)
       end if
       if(ict(10).eq.1) then
          call add1(0,2,3)
       end if

    else if(ict(1).eq.6) then
       call add1(2,2,2)

    else if(ict(1).eq.-6) then
       if(ict(2).eq.1) then
          call add1(3,3,0)
       end if
       if(ict(3).eq.1) then
          call add1(3,2,1)
       end if
       if(ict(4).eq.1) then
          call add1(3,1,2)
       end if
       if(ict(5).eq.1) then
          call add1(3,0,3)
       end if
       if(ict(6).eq.1) then
          call add1(2,3,1)
       end if
       if(ict(7).eq.1) then
          call add1(2,1,3)
       end if
       if(ict(8).eq.1) then
          call add1(1,3,2)
       end if
       if(ict(9).eq.1) then
          call add1(1,2,3)
       end if
       if(ict(10).eq.1) then
          call add1(0,3,3)
       end if

    else if(abs(ict(1)).eq.7) then
       if(ict(2).eq.1) then
          call add1(3,3,1)
       end if
       if(ict(3).eq.1) then
          call add1(3,2,2)
       end if
       if(ict(4).eq.1) then
          call add1(3,1,3)
       end if
       if(ict(5).eq.1) then
          call add1(2,3,2)
       end if
       if(ict(6).eq.1) then
          call add1(2,2,3)
       end if
       if(ict(7).eq.1) then
          call add1(1,3,3)
       end if

    else if(abs(ict(1)).eq.8) then
       if(ict(2).eq.1) then
          call add1(3,3,2)
       end if
       if(ict(3).eq.1) then
          call add1(3,2,3)
       end if
       if(ict(4).eq.1) then
          call add1(2,3,3)
       end if

    else if(abs(ict(1)).eq.9) then
       call add1(3,3,3)

    end if

  end subroutine dtrans

  subroutine add1(idx,idy,idz)
    ! insert record of derivative d[idx+idy+idz]f/dx[idx]dy[idy]dz[idz]

    integer, intent(in) :: idx,idy,idz

    inum=inum+1

    iderivs(1,inum)=idx
    if(jspline(1).le.0) then
       maxd_lin(inum)=idx
       maxd_cub(inum)=0
    else
       maxd_lin(inum)=0
       maxd_cub(inum)=idx
    end if

    iderivs(2,inum)=idy
    if(jspline(2).le.0) then
       maxd_lin(inum)=max(maxd_lin(inum),idy)
    else
       maxd_cub(inum)=max(maxd_cub(inum),idy)
    end if


    iderivs(3,inum)=idz
    if(jspline(3).le.0) then
       maxd_lin(inum)=max(maxd_lin(inum),idz)
    else
       maxd_cub(inum)=max(maxd_cub(inum),idz)
    end if

  end subroutine add1

  !===========================================================================
  subroutine sp1d(ans,f22)
    real(fp), intent(in) :: f22(2,2)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 1d spline evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,cx,cxi,hx2,cxd,cxdi
    !
    !----------------------

    xpi=1.0_fp-xp
    xp2=xp*xp
    xpi2=xpi*xpi

    if(idcub.eq.0) then
       ! value

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=h*h

       ans=xpi*f22(1,1) +xp*f22(1,2)
       ans=ans+sixth*hx2*(cxi*f22(2,1) +cx*f22(2,2))

    else if(idcub.eq.1) then
       ! 1st derivative

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hi*(f22(1,2)-f22(1,1))
       ans=ans+sixth*h*(cxdi*f22(2,1) +cxd*f22(2,2))

    else if(idcub.eq.2) then
       ! 2nd derivative

       xpi=1.0_fp-xp
       ans=xpi*f22(2,1) + xp*f22(2,2)

    else
       ! 3rd derivative

       ans = hi*(f22(2,2)-f22(2,1))

    end if

  end subroutine sp1d

  !===========================================================================
  subroutine hm1d(ans,f22)
    real(fp), intent(in) :: f22(2,2)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 1d hermite evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,ax,axbar,bx,bxbar
    real(fp) :: axp,axbarp,bxp,bxbarp

    xpi=1.0_fp-xp
    xp2=xp*xp
    xpi2=xpi*xpi

    if(idcub.eq.0) then
       ! value

       ax=xp2*(3.0_fp-2.0_fp*xp)
       axbar=1.0_fp-ax
       bx=-xp2*xpi
       bxbar=xpi2*xp

       ans=axbar*f22(1,1) + ax*f22(1,2)
       ans=ans + h*(bxbar*f22(2,1) + bx*f22(2,2))

    else
       ! 1st derivative

       axp=6.0_fp*xp*xpi
       axbarp=-axp
       bxp=xp*(3.0_fp*xp-2.0_fp)
       bxbarp=xpi*(3.0_fp*xpi-2.0_fp)

       ans=hi*(axbarp*f22(1,1) +axp*f22(1,2))
       ans=ans + bxbarp*f22(2,1) + bxp*f22(2,2)

    end if

  end subroutine hm1d

  !===========================================================================
  subroutine sp2d(ans,ff)
    real(fp), intent(in) :: ff(0:3,2,2)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 2d spline evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,cx,cxi,hx2,cxd,cxdi
    real(fp) :: ypi,yp2,ypi2,cy,cyi,hy2,cyd,cydi

    !----------------------

    xpi=1.0_fp-xp
    xp2=xp*xp
    xpi2=xpi*xpi

    ypi=1.0_fp-yp
    yp2=yp*yp
    ypi2=ypi*ypi
    !
    !  get desired values:
    !
    if((idcub2(1).eq.0).and.(idcub2(2).eq.0)) then

       !  function value:

       cy=yp*(yp2-1.0_fp)
       cyi=ypi*(ypi2-1.0_fp)
       hy2=hhy*hhy

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=hhx*hhx

       ans=xpi*(ypi*ff(0,1,1)  +yp*ff(0,1,2))+ &
            xp*(ypi*ff(0,2,1)+yp*ff(0,2,2))

       ans=ans+sixth*hx2*( &
            cxi*(ypi*ff(1,1,1)  +yp*ff(1,1,2))+ &
            cx*(ypi*ff(1,2,1)+yp*ff(1,2,2)))

       ans=ans+sixth*hy2*( &
            xpi*(cyi*ff(2,1,1)  +cy*ff(2,1,2))+ &
            xp*(cyi*ff(2,2,1)+cy*ff(2,2,2)))

       ans=ans+z36th*hx2*hy2*( &
            cxi*(cyi*ff(3,1,1)  +cy*ff(3,1,2))+ &
            cx*(cyi*ff(3,2,1)+cy*ff(3,2,2)))


    else if((idcub2(1).eq.1).and.(idcub2(2).eq.0)) then

       !  df/dx:

       cy=yp*(yp2-1.0_fp)
       cyi=ypi*(ypi2-1.0_fp)
       hy2=hhy*hhy

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hhxi*( &
            -(ypi*ff(0,1,1)  +yp*ff(0,1,2)) &
            +(ypi*ff(0,2,1)+yp*ff(0,2,2)))

       ans=ans+sixth*hhx*( &
            cxdi*(ypi*ff(1,1,1)  +yp*ff(1,1,2))+ &
            cxd*(ypi*ff(1,2,1)+yp*ff(1,2,2)))

       ans=ans+sixth*hhxi*hy2*( &
            -(cyi*ff(2,1,1)  +cy*ff(2,1,2)) &
            +(cyi*ff(2,2,1)+cy*ff(2,2,2)))

       ans=ans+z36th*hhx*hy2*( &
            cxdi*(cyi*ff(3,1,1)  +cy*ff(3,1,2))+ &
            cxd*(cyi*ff(3,2,1)+cy*ff(3,2,2)))


    else if((idcub2(1).eq.0).and.(idcub2(2).eq.1)) then

       !  df/dy:

       cyd=3.0_fp*yp2-1.0_fp
       cydi=-3.0_fp*ypi2+1.0_fp

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=hhx*hhx

       ans=hhyi*( &
            xpi*(-ff(0,1,1)  +ff(0,1,2))+ &
            xp*(-ff(0,2,1)+ff(0,2,2)))

       ans=ans+sixth*hx2*hhyi*( &
            cxi*(-ff(1,1,1)  +ff(1,1,2))+ &
            cx*(-ff(1,2,1)+ff(1,2,2)))

       ans=ans+sixth*hhy*( &
            xpi*(cydi*ff(2,1,1)  +cyd*ff(2,1,2))+ &
            xp*(cydi*ff(2,2,1)+cyd*ff(2,2,2)))

       ans=ans+z36th*hx2*hhy*( &
            cxi*(cydi*ff(3,1,1)  +cyd*ff(3,1,2))+ &
            cx*(cydi*ff(3,2,1)+cyd*ff(3,2,2)))


    else if((idcub2(1).eq.2).and.(idcub2(2).eq.0)) then

       !  d2f/dx2:

       cy=yp*(yp2-1.0_fp)
       cyi=ypi*(ypi2-1.0_fp)
       hy2=hhy*hhy

       ans=( &
            xpi*(ypi*ff(1,1,1)  +yp*ff(1,1,2))+ &
            xp*(ypi*ff(1,2,1)+yp*ff(1,2,2)))

       ans=ans+sixth*hy2*( &
            xpi*(cyi*ff(3,1,1)  +cy*ff(3,1,2))+ &
            xp*(cyi*ff(3,2,1)+cy*ff(3,2,2)))


    else if((idcub2(1).eq.0).and.(idcub2(2).eq.2)) then

       !  d2f/dy2:

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=hhx*hhx

       ans=( &
            xpi*(ypi*ff(2,1,1)  +yp*ff(2,1,2))+ &
            xp*(ypi*ff(2,2,1)+yp*ff(2,2,2)))

       ans=ans+sixth*hx2*( &
            cxi*(ypi*ff(3,1,1)  +yp*ff(3,1,2))+ &
            cx*(ypi*ff(3,2,1)+yp*ff(3,2,2)))


    else if((idcub2(1).eq.1).and.(idcub2(2).eq.1)) then

       !  d2f/dxdy:

       cyd=3.0_fp*yp2-1.0_fp
       cydi=-3.0_fp*ypi2+1.0_fp

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hhxi*hhyi*( &
            ff(0,1,1)  -ff(0,1,2) &
            -ff(0,2,1)+ff(0,2,2))

       ans=ans+sixth*hhx*hhyi*( &
            cxdi*(-ff(1,1,1)  +ff(1,1,2))+ &
            cxd*(-ff(1,2,1)+ff(1,2,2)))

       ans=ans+sixth*hhxi*hhy*( &
            -(cydi*ff(2,1,1)  +cyd*ff(2,1,2)) &
            +(cydi*ff(2,2,1)+cyd*ff(2,2,2)))

       ans=ans+z36th*hhx*hhy*( &
            cxdi*(cydi*ff(3,1,1)  +cyd*ff(3,1,2))+ &
            cxd*(cydi*ff(3,2,1)+cyd*ff(3,2,2)))

    else if((idcub2(1).eq.3).and.(idcub2(2).eq.0)) then

       !  evaluate d3f/dx3 (not continuous):

       cy=yp*(yp2-1.0_fp)
       cyi=ypi*(ypi2-1.0_fp)
       hy2=hhy*hhy

       ans=hhxi*( &
            -(ypi*ff(1,1,1)  +yp*ff(1,1,2)) &
            +(ypi*ff(1,2,1)+yp*ff(1,2,2)))

       ans=ans+sixth*hy2*hhxi*( &
            -(cyi*ff(3,1,1)  +cy*ff(3,1,2)) &
            +(cyi*ff(3,2,1)+cy*ff(3,2,2)))


    else if((idcub2(1).eq.2).and.(idcub2(2).eq.1)) then

       !  evaluate d3f/dx2dy

       cyd=3.0_fp*yp2-1.0_fp
       cydi=-3.0_fp*ypi2+1.0_fp

       ans=hhyi*( &
            xpi*(-ff(1,1,1)  +ff(1,1,2))+ &
            xp*(-ff(1,2,1) +ff(1,2,2)))

       ans=ans+sixth*hhy*( &
            xpi*(cydi*ff(3,1,1) +cyd*ff(3,1,2))+ &
            xp*(cydi*ff(3,2,1)+cyd*ff(3,2,2)))


    else if((idcub2(1).eq.1).and.(idcub2(2).eq.2)) then

       !  evaluate d3f/dxdy2

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hhxi*( &
            -(ypi*ff(2,1,1)  +yp*ff(2,1,2)) &
            +(ypi*ff(2,2,1)+yp*ff(2,2,2)))

       ans=ans+sixth*hhx*( &
            cxdi*(ypi*ff(3,1,1)  +yp*ff(3,1,2))+ &
            cxd*(ypi*ff(3,2,1)+yp*ff(3,2,2)))

    else if((idcub2(1).eq.0).and.(idcub2(2).eq.3)) then

       !  evaluate d3f/dy3 (not continuous):

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=hhx*hhx

       ans=hhyi*( &
            xpi*(-ff(2,1,1)  +ff(2,1,2))+ &
            xp*(-ff(2,2,1) +ff(2,2,2)))

       ans=ans+sixth*hx2*hhyi*( &
            cxi*(-ff(3,1,1)  +ff(3,1,2))+ &
            cx*(-ff(3,2,1) +ff(3,2,2)))


    else if((idcub2(1).eq.3).and.(idcub2(2).eq.1)) then

       !  evaluate d4f/dx3dy (not continuous):

       cyd=3.0_fp*yp2-1.0_fp
       cydi=-3.0_fp*ypi2+1.0_fp

       ans=hhxi*hhyi*( &
            +( ff(1,1,1)  -ff(1,1,2)) &
            +(-ff(1,2,1)+ff(1,2,2)))

       ans=ans+sixth*hhy*hhxi*( &
            -(cydi*ff(3,1,1)  +cyd*ff(3,1,2)) &
            +(cydi*ff(3,2,1)+cyd*ff(3,2,2)))


    else if((idcub2(1).eq.2).and.(idcub2(2).eq.2)) then

       !  evaluate d4f/dx2dy2

       ans=xpi*(ypi*ff(3,1,1)  +yp*ff(3,1,2))+ &
            xp*(ypi*ff(3,2,1)  +yp*ff(3,2,2))

    else if((idcub2(1).eq.1).and.(idcub2(2).eq.3)) then

       !  evaluate d4f/dxdy3 (not continuous):

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hhyi*hhxi*( &
            +( ff(2,1,1)  -ff(2,1,2)) &
            +(-ff(2,2,1)+ff(2,2,2)))

       ans=ans+sixth*hhx*hhyi*( &
            cxdi*(-ff(3,1,1)  +ff(3,1,2))+ &
            cxd*(-ff(3,2,1) +ff(3,2,2)))


    else if((idcub2(1).eq.3).and.(idcub2(2).eq.2)) then

       !  evaluate d5f/dx3dy2 (not continuous):

       ans=hhxi*( &
            -(ypi*ff(3,1,1)  +yp*ff(3,1,2)) &
            +(ypi*ff(3,2,1)+yp*ff(3,2,2)))

    else if((idcub2(1).eq.2).and.(idcub2(2).eq.3)) then

       !  evaluate d5f/dx2dy3 (not continuous):

       ans=hhyi*( &
            xpi*(-ff(3,1,1)  +ff(3,1,2))+ &
            xp*(-ff(3,2,1)+ff(3,2,2)))


    else if((idcub2(1).eq.3).and.(idcub2(2).eq.3)) then

       !  evaluate d6f/dx3dy3 (not continuous):

       ans=hhxi*hhyi*( &
            +( ff(3,1,1)  -ff(3,1,2)) &
            +(-ff(3,2,1)  +ff(3,2,2)))

    end if

  end subroutine sp2d

  !===========================================================================
  subroutine hm2d(ans,ff)
    real(fp), intent(in) :: ff(0:3,2,2)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 2d hermite evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,ax,axbar,bx,bxbar
    real(fp) :: axp,axbarp,bxp,bxbarp

    real(fp) :: ypi,yp2,ypi2,ay,aybar,by,bybar
    real(fp) :: ayp,aybarp,byp,bybarp

    xpi=1.0_fp-xp
    xp2=xp*xp
    xpi2=xpi*xpi

    ypi=1.0_fp-yp
    yp2=yp*yp
    ypi2=ypi*ypi

    if((idcub2(1).eq.0).and.(idcub2(2).eq.0)) then
       !  evaluation

       ax=xp2*(3.0_fp-2.0_fp*xp)
       axbar=1.0_fp-ax
       bx=-xp2*xpi
       bxbar=xpi2*xp

       ay=yp2*(3.0_fp-2.0_fp*yp)
       aybar=1.0_fp-ay
       by=-yp2*ypi
       bybar=ypi2*yp

       ans=axbar*(aybar*ff(0,1,1)  +ay*ff(0,1,2))+ &
            ax*(aybar*ff(0,2,1)+ay*ff(0,2,2))

       ans=ans+hhx*( &
            bxbar*(aybar*ff(1,1,1)  +ay*ff(1,1,2))+ &
            bx*(aybar*ff(1,2,1)+ay*ff(1,2,2)))

       ans=ans+hhy*( &
            axbar*(bybar*ff(2,1,1)  +by*ff(2,1,2))+ &
            ax*(bybar*ff(2,2,1)+by*ff(2,2,2)))

       ans=ans+hhx*hhy*( &
            bxbar*(bybar*ff(3,1,1)  +by*ff(3,1,2))+ &
            bx*(bybar*ff(3,2,1)+by*ff(3,2,2)))

    else if((idcub2(1).eq.1).and.(idcub2(2).eq.0)) then
       !  1st deriv, 1st dim

       axp=6.0_fp*xp*xpi
       axbarp=-axp
       bxp=xp*(3.0_fp*xp-2.0_fp)
       bxbarp=xpi*(3.0_fp*xpi-2.0_fp)

       ay=yp2*(3.0_fp-2.0_fp*yp)
       aybar=1.0_fp-ay
       by=-yp2*ypi
       bybar=ypi2*yp

       ans=hhxi*( &
            axbarp*(aybar*ff(0,1,1)  +ay*ff(0,1,2))+ &
            axp*(aybar*ff(0,2,1)+ay*ff(0,2,2)))

       ans=ans+ &
            bxbarp*(aybar*ff(1,1,1)  +ay*ff(1,1,2))+ &
            bxp*(aybar*ff(1,2,1)+ay*ff(1,2,2))

       ans=ans+hhxi*hhy*( &
            axbarp*(bybar*ff(2,1,1)  +by*ff(2,1,2))+ &
            axp*(bybar*ff(2,2,1)+by*ff(2,2,2)))

       ans=ans+hhy*( &
            bxbarp*(bybar*ff(3,1,1)  +by*ff(3,1,2))+ &
            bxp*(bybar*ff(3,2,1)+by*ff(3,2,2)))

    else if((idcub2(1).eq.0).and.(idcub2(2).eq.1)) then
       !  1st deriv, 2nd dim

       ax=xp2*(3.0_fp-2.0_fp*xp)
       axbar=1.0_fp-ax
       bx=-xp2*xpi
       bxbar=xpi2*xp

       ayp=6.0_fp*yp*ypi
       aybarp=-ayp
       byp=yp*(3.0_fp*yp-2.0_fp)
       bybarp=ypi*(3.0_fp*ypi-2.0_fp)

       ans=hhyi*( &
            axbar*(aybarp*ff(0,1,1)  +ayp*ff(0,1,2))+ &
            ax*(aybarp*ff(0,2,1)+ayp*ff(0,2,2)))

       ans=ans+hhx*hhyi*( &
            bxbar*(aybarp*ff(1,1,1)  +ayp*ff(1,1,2))+ &
            bx*(aybarp*ff(1,2,1)+ayp*ff(1,2,2)))

       ans=ans+ &
            axbar*(bybarp*ff(2,1,1)  +byp*ff(2,1,2))+ &
            ax*(bybarp*ff(2,2,1)+byp*ff(2,2,2))

       ans=ans+hhx*( &
            bxbar*(bybarp*ff(3,1,1)  +byp*ff(3,1,2))+ &
            bx*(bybarp*ff(3,2,1)+byp*ff(3,2,2)))

    else if((idcub2(1).eq.1).and.(idcub2(2).eq.1)) then
       !  1st deriv, in both dimensions

       axp=6.0_fp*xp*xpi
       axbarp=-axp
       bxp=xp*(3.0_fp*xp-2.0_fp)
       bxbarp=xpi*(3.0_fp*xpi-2.0_fp)

       ayp=6.0_fp*yp*ypi
       aybarp=-ayp
       byp=yp*(3.0_fp*yp-2.0_fp)
       bybarp=ypi*(3.0_fp*ypi-2.0_fp)

       ans=hhxi*hhyi*( &
            axbarp*(aybarp*ff(0,1,1)  +ayp*ff(0,1,2))+ &
            axp*(aybarp*ff(0,2,1)+ayp*ff(0,2,2)))

       ans=ans+hhyi*( &
            bxbarp*(aybarp*ff(1,1,1)  +ayp*ff(1,1,2))+ &
            bxp*(aybarp*ff(1,2,1)+ayp*ff(1,2,2)))

       ans=ans+hhxi*( &
            axbarp*(bybarp*ff(2,1,1)  +byp*ff(2,1,2))+ &
            axp*(bybarp*ff(2,2,1)+byp*ff(2,2,2)))

       ans=ans+ &
            bxbarp*(bybarp*ff(3,1,1)  +byp*ff(3,1,2))+ &
            bxp*(bybarp*ff(3,2,1)+byp*ff(3,2,2))

    end if

  end subroutine hm2d

end subroutine fvintrp3d

subroutine herm1ev(xget,x,nx,ilinx,f,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a 1d cubic Hermite interpolant -- this is C1.
  !
  !  this subroutine calls two subroutines:
  !     herm1x   -- find cell containing (xget,yget)
  !     herm1fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer nx
  !============
  real(fp) :: xget                         ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  !
  real(fp) :: f(0:1,nx)                    ! function data
  !
  !       contents of f:
  !
  !  f(0,i) = f @ x(i)
  !  f(1,i) = df/dx @ x(i)
  !
  integer ict(2)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1]
  !   on output fval= [f,df/dx]
  !
  !    on input ict = [1,0]
  !   on output fval= [f] ... element 2 never referenced
  !
  !    on input ict = [0,1]
  !   on output fval= [df/dx] ... element 2 never referenced
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i   ! cell index
  !
  !  normalized displacement from (x(i)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !
  real(fp), dimension(1) :: xparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i))
  !
  real(fp), dimension(1) :: hx
  real(fp), dimension(1) :: hxi
  !
  !  0 .le. xparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm1x(xget,x,nx,ilinx,i(1),xparam(1),hx(1),hxi(1),ier)
  if(ier.ne.0) return
  !
  call herm1fcn(ict,1,1,fval,i,xparam,hx,hxi,f,nx)
  !
  return
end subroutine herm1ev
!---------------------------------------------------------------------
!  herm1xy -- look up x zone
!
!  this is the "first part" of herm1ev, see comments, above.
!
subroutine herm1x(xget,x,nx,ilinx,i,xparam,hx,hxi,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  input of herm1x
  !  ===============
  !
  !============
  implicit none
  integer nxm,ii
  !============
  real(fp) :: zxget,zxtol
  !============
  integer nx                        ! x array dimension
  !
  real(fp) :: xget                         ! target point
  real(fp) :: x(nx)                        ! indep. coordinate, strict ascending
  !
  integer ilinx                     ! =1:  x evenly spaced
  !
  !  output of herm1x
  !  =================
  integer i                         ! index to cell containing target pt
  !          on exit:  1.le.i.le.nx-1
  !
  !  normalized position w/in (i) cell (always btw 0 and 1):
  !
  real(fp) :: xparam                       ! (xget-x(i))/(x(i+1)-x(i))
  !
  !  grid spacing
  !
  real(fp) :: hx                           ! hx = x(i+1)-x(i)
  !
  !  inverse grid spacing:
  !
  real(fp) :: hxi                          ! 1/hx = 1/(x(i+1)-x(i))
  !
  integer ier                       ! return ier.ne.0 on error
  !
  !------------------------------------
  !
  ier=0
  !
  !  range check
  !
  zxget=xget
  if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
     zxtol=4.0E-7_fp*max(abs(x(1)),abs(x(nx)))
     if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
        ier=1
        write(6,1001) xget,x(1),x(nx)
1001    format(' ?herm1ev:  xget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((xget.lt.x(1)-0.5_fp*zxtol).or. &
             (xget.gt.x(nx)+0.5_fp*zxtol)) &
             write(6,1011) xget,x(1),x(nx)
1011    format(' %herm1ev:  xget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(xget.lt.x(1)) then
           zxget=x(1)
        else
           zxget=x(nx)
        end if
     end if
  end if
  if(ier.ne.0) return
  !
  !  now find interval in which target point lies..
  !
  nxm=nx-1
  !
  if(ilinx.eq.1) then
     ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
     i=min(nxm, ii)
     if(zxget.lt.x(i)) then
        i=i-1
     else if(zxget.gt.x(i+1)) then
        i=i+1
     end if
  else
     if((1.le.i).and.(i.lt.nxm)) then
        if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
           continue  ! already have the zone
        else
           call zonfind(x,nx,zxget,i)
        end if
     else
        i=nx/2
        call zonfind(x,nx,zxget,i)
     end if
  end if
  !
  hx=(x(i+1)-x(i))
  !
  hxi=1.0_fp/hx
  !
  xparam=(zxget-x(i))*hxi
  !
  return
end subroutine herm1x
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 1d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine herm1fcn(ict,ivec,ivecd, &
     fval,ii,xparam,hx,hxi,fin,nx)
  use iso_c_binding, only: fp => c_double
  !
  !  input:
  !
  !============
  implicit none
  integer nx,i,iadr
  !============
  real(fp) :: xp,xpi,xp2,xpi2,ax,axbar,bx,bxbar,axp,axbarp,bxp,bxbarp
  !============
  integer ict(2)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec)                  ! target cells
  real(fp) :: xparam(ivec)
  ! normalized displacements in cells
  !
  real(fp) :: hx(ivec)                     ! grid spacing, and
  real(fp) :: hxi(ivec)                    ! inverse grid spacing 1/(x(i+1)-x(i))
  !
  real(fp) :: fin(0:1,nx)                  ! Hermite dataset
  !
  !  output:
  !
  real(fp) :: fval(ivecd,*)                ! interpolation results
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  herm1ev comments.  Note ict is not vectorized -- the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument; ivecd.ge.ivec
  !     expected!
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Hermite cubic basis functions
  !  -->for function value matching
  !     a(0)=0 a(1)=1        a'(0)=0 a'(1)=0
  !   abar(0)=1 abar(1)=0  abar'(0)=0 abar'(1)=0
  !
  !   a(x)=-2*x**3 + 3*x**2    = x*x*(-2.0*x+3.0)
  !   abar(x)=1-a(x)
  !   a'(x)=-abar'(x)          = 6.0*x*(1.0-x)
  !
  !  -->for derivative matching
  !     b(0)=0 b(1)=0          b'(0)=0 b'(1)=1
  !   bbar(0)=0 bbar(1)=0  bbar'(0)=1 bbar'(1)=0
  !
  !     b(x)=x**3-x**2         b'(x)=3*x**2-2*x
  !     bbar(x)=x**3-2*x**2+x  bbar'(x)=3*x**2-4*x+1
  !
  !   ...in x direction
  !
  real(fp) :: sum
  integer v
  !
  do v=1,ivec
     i=ii(v)
     xp=xparam(v)
     xpi=1.0_fp-xp
     xp2=xp*xp
     xpi2=xpi*xpi
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        !
        !  Hermite basis functions
        !
        ax=xp2*(3.0_fp-2.0_fp*xp)
        axbar=1.0_fp-ax
        bx=-xp2*xpi
        bxbar=xpi2*xp
        !
        sum=axbar*fin(0,i) + ax*fin(0,i+1)
        !
        sum=sum+hx(v)*(bxbar*fin(1,i) + bx*fin(1,i+1))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        !
        axp=6.0_fp*xp*xpi
        axbarp=-axp
        bxp=xp*(3.0_fp*xp-2.0_fp)
        bxbarp=xpi*(3.0_fp*xpi-2.0_fp)
        !
        sum=hxi(v)*(axbarp*fin(0,i) +axp*fin(0,i+1))
        !
        sum=sum+ bxbarp*fin(1,i) + bxp*fin(1,i+1)
        !
        fval(v,iadr)=sum
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine herm1fcn

      integer function max_reclen(filename)
c
c  return the maximum record length of a (sequential ascii) file.
c  if the file cannot be opened, return (-1)
c
c  use a c subroutine
c
#include "fpreproc/byte_declare.h"
c
      implicit none
c
      character*(*) filename
c
      byte_declare, dimension(:), allocatable :: c_filename
      integer ilen
      integer max_crec
      integer str_length
c
c---------------------
c
      if(filename.eq.' ') then
         max_reclen=-2
         return
      endif
c
      ilen=max(1,str_length(filename))
      allocate(c_filename(ilen+1))
c
c  make null terminated byte string from filename & call c routine
c
      call cstring(filename(1:ilen),c_filename,'2C')
c
      max_reclen=max_crec(c_filename)
c
      deallocate(c_filename)
 
      return
      end

      subroutine c24date(zdate)
      character*(*) zdate
C
C  get a 24 character date -- portably -- by calling C code
C
#include "fpreproc/byte_declare.h"
C
      BYTE_DECLARE z24date(24)
C
      ilen=24
      call c24dat0(z24date,ilen)
C
      call cstring(zdate,z24date,'2F')
C
      return
      end

subroutine gridherm1(x_newgrid,nx_new,f_new,nx,xpkg,fspl, &
     iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  regrid a hermite function f defined vs. x as in xpkg
  !  to a new grid, given by x_newgrid.
  !
  !  set warning flag if the range x_newgrid exceeds the range of the
  !  original xpkg.
  !
  !  (xpkg -- see genxpkg subroutine)
  !
  !  input:
  !
  !============
  implicit none
  integer nx_new
  !============
  real(fp) :: x_newgrid(nx_new)            ! new grid
  !
  !  output:
  !
  real(fp) :: f_new(nx_new)                ! f evaluated on this grid
  !
  !  input:
  !
  integer nx                        ! size of old grid
  real(fp) :: xpkg(nx,4)                   ! old grid "package"
  real(fp) :: fspl(nx,2)                   ! compact spline coefficients of f
  !
  !  output:
  !  condition codes, =0 for normal exit
  !
  integer iwarn                     ! =1 if new grid points out of range
  integer ier                       ! =1 if there is an argument error
  !
  !--------------------------------------------
  !  local
  !
  integer ict(2)
  !
  data ict/1,0/
  !
  !--------------------------------------------
  !
  call vecherm1(ict,nx_new,x_newgrid,nx_new,f_new,nx,xpkg,fspl, &
       iwarn,ier)
  !
  return
end subroutine gridherm1

!--------------------------------------------------------------------
!  SPLBRK -- make a spline with a break (C0 only) at specified locn
!
subroutine splbrk (IOPT, N, NBRK, X, Y, B, C, D)
  use iso_c_binding, only: fp => c_double
  !
  !  Spline the whole interval, and then respline a subinterval, saving
  !  the endpt coeffs from the original spline.
  !
  !  Result is a spline that is C2 everywhere except C0 only at one
  !  interior break point.
  !
  !  IOPT=0  use SPLAAN for dy/dx=0 at LHS bc
  !  IOPT=1  use SPLINE for standard bc
  !
  !  N -- no. of data pts
  !  NBRK -- break point
  !
  !============
  implicit none
  integer n,nbrk,iopt
  !============
  real(fp) :: bsave,csave,dsave
  !============
  real(fp) :: X(N),Y(N),B(N),C(N),D(N)
  !
  if(iopt.eq.0) then
     call splaan(n, x, y, b, c, d)
  else
     call spline(n, x, y, b, c, d)
  end if
  !
  bsave=b(nbrk)
  csave=c(nbrk)
  dsave=d(nbrk)
  !
  call nspline(nbrk, x, y, b, c, d)
  !
  b(nbrk)=bsave
  c(nbrk)=csave
  d(nbrk)=dsave
  !
  return
end subroutine splbrk

C  tmpfile -- create a temporary filename, based on the current process id
C   mod dmc 5.11.98:  use pid instead of date-time
C
      subroutine tmpfile(zprefix,zfile,ilz)
c
      character*(*) zprefix  ! filename prefix (input)
      character*(*) zfile    ! temp filename (output)
      integer ilz            ! length of temp filename (output)
C
C  zprefix can just be the first part of a filename, or a
C  complete path spefication followed (optionally) by the first part
C  of a filename.
C----------------
C  local
C
      character*12 cpid
      integer str_length
C
C----------------
C
      zfile=' '
      ilzf=len(zfile)
C
      if(zprefix.eq.' ') then
         ilzp=0
      else
         ilzp=str_length(zprefix)
      endif
C
      call sget_pid_str(cpid,ilcp)
C
      if(ilzp.eq.0) then
         zfile = cpid(1:ilcp)//'.tmp'
      else
         zfile = zprefix(1:ilzp)//cpid(1:ilcp)//'.tmp'
      endif
C
      ilz=str_length(zfile)
C
      return
      end
C-----------------------------------------------------------------
      subroutine tmpfile_d(zprefix,zfile,ilz)
C
C  create a temporary file in a temporary files directory:
C
C  UNIX:  TMPDIR_TR if defined, or else ./tmp/
C  VMS:   JUNK   if defined, or else SYS$LOGIN
C
      character*(*) zprefix  ! filename prefix (input)
      character*(*) zfile    ! temp filename (output)
      integer ilz            ! length of temp filename (output)
C
C  local:
C
      character*200 zpath
C
      integer str_length,istat
C--------------
C
      zfile=' '
C
#ifdef __UNIX
      call mpi_sget_env('TMPDIR_TR',zpath,iertmp)
      ilpath=str_length(zpath)
      if(ilpath.eq.0) then
         call gmkdir('.','tmp',istat) ! istat not checked
         zpath(1:6)='./tmp/'
         ilpath=6
      else
         if(zpath(ilpath:ilpath).ne.'/') then
            ilpath=ilpath+1
            zpath(ilpath:ilpath)='/'
         endif
      endif
#endif
C
#ifdef __VMS
      call sget_env('JUNK',zpath)
      ilpath=str_length(zpath)
      if(ilpath.eq.0) then
         call sget_env('SYS$LOGIN',zpath)
         ilpath=str_length(zpath)
      endif
#endif
C
      ilzp=str_length(zprefix)
      if(ilzp.gt.0) then
         zpath=zpath(1:ilpath)//zprefix(1:ilzp)
         ilpath=str_length(zpath)
      endif
C
      call tmpfile(zpath(1:ilpath),zfile,ilz)
C
      return
      end

subroutine ezspline_cdfput3(ncid,zname,fspl,idim1,idim2,idim3,ifail)
  use iso_c_binding, only: fp => c_double
  use EZcdf
  implicit NONE

  ! (due to ezspline rank limitation) write 4d object as 3d object
  ! use f77 interface style, should prevent unnecessary array copy.

  integer, intent(in) :: ncid             ! opened NetCDF file
  character(len=*),intent(in) :: zname       ! name to us for writing
  integer, intent(in) :: idim1,idim2,idim3   ! spline data dimensions
  real(fp), intent(in) :: fspl(idim1,idim2,idim3)  ! spline data & coefficients
  integer, intent(out) :: ifail           ! status retruned from NetCDF

  call cdfPutVar(ncid, trim(zname), fspl, ifail)

end subroutine ezspline_cdfput3

 subroutine fnmdf( cfnm, cext )
!
!  complete filename in cfnm with cext, if not already given -
!
!  eg
!  cfnm = 'work/54321C23'
!  call fnmdf( cfnm, 'TR.DAT' )
!
!  would return cfnm = 'work/54321C23/54321C23TR.DAT'
!
!  Mods
!    29Mar2009   jim.conboy@jet.uk
!                New at build date 'Jan 24 04:30:36', JET vn 44
!
!--------------------------------------------------------------------
!
!..Args :-
!
 character(len=*), intent(inout)  ::  cfnm       ! (part of ? ) filename
 character(len=*), intent(in)     ::  cext       ! requested extension
!
 integer                          ::  lfnm &     ! length of cfnm
                                     ,lfnt &     ! ..  w/out trailing spaces
                                     ,lastdot  & ! ix of last dot
                                     ,lastslash &! ix of last slash
                                     ,ncdir    & ! nchar in directory name
                                     ,ncap       ! nchar to append
!
 character(len=1)                 ::  cdot='.' &
                                    , cbl =' ' &
                                    , cslash='/' !  filename furniture

!--------------------------------------------------------------------
!
 lfnm      =  len(cfnm)
 lfnt      =  len_trim(cfnm)
 lastdot   =  index( cfnm, cdot, .true. )
 if( cfnm(lfnt:lfnt) == cslash )   then
     cfnm(lfnt:lfnt) = cbl
     lfnt = lfnt - 1
 endif
 lastslash =  index( cfnm, cslash, .true. )
!
!d-  print *,'fnmdf :',lastslash,lastdot,lfnt,lfnm
!
 if ( lastdot > 1 .and. lastdot > lastslash )  return
!
 ncdir = lfnt  - lastslash
 ncap  = ncdir + 1 + len_trim(cext)
 if( lfnt + ncap > lfnm )                       then
    print *,'portlib%fnmdf -E- buffer too short ',lfnm
    ix = min(lfnm,lfnt+1)
    cfnm(ix:ix) = '*'
                                                return 
                                                endif
!
 cfnm(lfnt+1:lfnt+1)  = cslash
 cfnm(lfnt+2:)        = cfnm(lastslash+1:lfnt)
 cfnm(lfnt+2+ncdir:)  = trim(cext)
!
!d-  print *,'fnmdf : "',trim(cfnm),'"'
 return
 end

integer function system_call_echo(cmd)
  implicit none
  character(len=*), intent(in) :: cmd   ! input shell command

  ! issue a system command and capture its output with ">" to a
  ! temporary file.  Print the contents of the file to standard output
  ! and then delete the file.

  character(len=40) :: tmpfile
  character(len=20) :: pidstr
  character(len=120) :: lbuf
  integer :: ilenp,ilun,istat

  !--------------------------------
  ! form temporary filename

  call sget_pid_str(pidstr,ilenp)

  tmpfile = pidstr(1:ilenp)//'_sys.err'

  ! execute

  call execute_command_line(trim(cmd)//' > '//trim(tmpfile),exitstat=istat)

  ! return system call status
  system_call_echo = istat

  ! try to open file 

  write(6,*) ' '
  write(6,*) ' %system_call_echo: '//trim(cmd)
  write(6,*) ' %system_call_echo: status: ',istat
  write(6,*) ' %system_call_echo: stdout:'
  write(6,*) ' '

  call find_io_unit(ilun)

  open(unit=ilun,file=trim(tmpfile),status='old',iostat=istat)
  if(istat.eq.0) then
    ! echo file contents
    do
      read(ilun,'(A)',iostat=istat) lbuf
      if(istat.ne.0) exit
      write(6,'(1x,A)') trim(lbuf)
    end do
    ! close and delete file
    close(unit=ilun,status='delete')
  endif

end function system_call_echo

subroutine ibc_ck(ibc,slbl,xlbl,imin,imax,ier)
  use iso_c_binding, only: fp => c_double
  implicit none
  ! Check that spline routine ibc flag is in range
  integer, intent(in)  :: ibc          ! flag value
  character(len=*), intent(in) :: slbl ! subroutine name
  character(len=*), intent(in) :: xlbl ! axis label
  integer, intent(in)  :: imin         ! min allowed value
  integer, intent(in)  :: imax         ! max allowed value
  integer, intent(out) :: ier          ! output -- set =1 if error detected

  if((ibc.lt.imin).or.(ibc.gt.imax)) then
     ier=1
     write(6,1001) slbl,xlbl,ibc,imin,imax
1001 format(' ?',a,' -- ibc',a,' = ',i9,' out of range ',i2,' to ',i2)
  end if

  return
end subroutine ibc_ck

      subroutine sget_pid(ipid)
C
#ifdef __NAGWARE
      use f90_unix
#endif
C
      implicit none
C
      integer ipid                      ! process id number (output)
C
C  vms/unix portable routine -- return the process id number
C
#ifdef __VMS
      include '($JPIDEF)'
#endif
C
#ifdef __UNIX
#if __X1
      integer ierror
#elif !__NAGWARE
      integer getpid
#endif
#endif
C
#ifdef __VMS
      call lib$getjpi(JPI$_PID,,,ipid,,)
#endif
C

#ifdef __UNIX
#if __X1
      CALL PXFGETPID(ipid, ierror)
#else
      ipid = getpid()
#endif
#endif
C
      return
      end
C------------------------
      subroutine sget_pid_str(pidstr,ilen)
C
      implicit none
C
C  vms/unix portable routine -- return the process id number
C  as a character string
C
C  output:
      character*(*) pidstr      ! the PID, left justified, blank padded
      integer ilen              ! the non-blank length of pidstr returned.
C
C----------
C  local:
      integer ilenstr,ipid,icp,icz
      character*12 zbuf
C----------
C
      pidstr=' '
      ilenstr=len(pidstr)
C
      call sget_pid(ipid)
C
      write(zbuf,'(I12)') ipid
C
      icp=0
      do icz=1,12
         if(zbuf(icz:icz).ne.' ') then
            icp=icp+1
            if(icp.le.ilenstr) pidstr(icp:icp)=zbuf(icz:icz)
         endif
      enddo
      ilen=icp
C
      return
      end

      Subroutine err_end
C
C  code provided to arrange for portability to SUN with
C  desired floating point error handling
C
#if __SUN || __SUNOS
 
      Integer  ieee_handler
      External ieee_handler
      Integer  ieee_flags
      External ieee_flags
      Integer  istat
      Character*16 str
C
      istat=ieee_flags('clear','exception','all',str)
      If (istat.Ne.0) 
     >     Call Errmsg_Exit('Error in clearing ieee flags')
C
      istat=ieee_handler('clear','division',str)
      If (istat.Ne.0) 
     >     Call Errmsg_Exit('Error in clearing ieee division')
      istat=ieee_handler('clear','invalid' ,str)
      If (istat.Ne.0) 
     >     Call Errmsg_Exit('Error in clearing ieee invalid')
      istat=ieee_handler('clear','overflow',str)
      If (istat.Ne.0) 
     >     Call Errmsg_Exit('Error in clearing ieee overflow')
      Call standard_arithmetic()
#endif
C
#ifndef __NOF90
      call f90_link1
#endif
      return
      End

subroutine mkbicub(x,nx,y,ny,f,nf2, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcymin,bcymin,ibcymax,bcymax, &
     ilinx,iliny,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup bicubic spline, dynamic allocation of workspace
  !  fortran-90 fixed form source
  !
  !  ** see mkbicubw.f90 **
  !  arguments are identical, except the workspace argument is
  !  omitted (created here)
  !
  !  --NOTE-- dmc 22 Feb 2004 -- rewrite for direct calculation of
  !  coefficients, to avoid large transient use of memory.  mkbicubw is
  !  no longer called (but reference to mkbicubw comments is still correct).
  !
  !  abbreviated description of arguments, mkbicubw has details:
  !
  !
  !  input:
  implicit none
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  real(fp) :: x(nx)                        ! x vector, strict ascending
  real(fp) :: y(ny)                        ! y vector, strict ascending
  !
  integer nf2                       ! 2nd dimension of f, nf2.ge.nx
  !  input/output:
  real(fp) :: f(4,nf2,ny)                  ! data & spline coefficients
  !
  !  input bdy condition data:
  integer ibcxmin                   ! bc flag for x=xmin
  real(fp) :: bcxmin(ny)                   ! bc data vs. y at x=xmin
  integer ibcxmax                   ! bc flag for x=xmax
  real(fp) :: bcxmax(ny)                   ! bc data vs. y at x=xmax
  !
  integer ibcymin                   ! bc flag for y=ymin
  real(fp) :: bcymin(nx)                   ! bc data vs. x at y=ymin
  integer ibcymax                   ! bc flag for y=ymax
  real(fp) :: bcymax(nx)                   ! bc data vs. x at y=ymax
  !
  !  output linear grid flags and completion code (ier=0 is normal):
  !
  integer ilinx                     ! =1: x grid is "nearly" equally spaced
  integer iliny                     ! =1: y grid is "nearly" equally spaced
  !
  integer ier                       ! =0 on exit if there is no error.
  !
  !-----------------------
  integer ierx,iery
  !
  real(fp), dimension(:,:), allocatable :: fwk
  real(fp) :: zbcmin,zbcmax
  integer ix,iy,ibcmin,ibcmax
  !
  real(fp), dimension(:,:,:), allocatable :: fcorr
  integer iflg2
  real(fp) :: zdiff(2),hy
  !
  !-----------------------
  !
  !  see if 2nd pass is needed due to inhomogeneous d/dy bdy cond.
  !
  iflg2=0
  if(ibcymin.ne.-1) then
     if((ibcymin.eq.1).or.(ibcymin.eq.2)) then
        do ix=1,nx
           if (bcymin(ix).ne.0.0_fp) iflg2=1
        end do
     end if
     if((ibcymax.eq.1).or.(ibcymax.eq.2)) then
        do ix=1,nx
           if (bcymax(ix).ne.0.0_fp) iflg2=1
        end do
     end if
  end if
  !
  !  check boundary condition specifications
  !
  ier=0
  !
  call ibc_ck(ibcxmin,'bcspline','xmin',-1,7,ier)
  if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'bcspline','xmax',0,7,ier)
  call ibc_ck(ibcymin,'bcspline','ymin',-1,7,ier)
  if(ibcymin.ge.0) call ibc_ck(ibcymax,'bcspline','ymax',0,7,ier)
  !
  !  check ilinx & x vector
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?bcspline:  x axis not strict ascending'')')
  end if
  !
  !  check iliny & y vector
  !
  call splinck(y,ny,iliny,1.0E-3_fp,iery)
  if(iery.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?bcspline:  y axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  allocate(fwk(2,max(nx,ny)))
  !
  !  evaluate fxx (spline in x direction)
  !
  zbcmin=0
  zbcmax=0
  do iy=1,ny
     fwk(1,1:nx) = f(1,1:nx,iy)
     if((ibcxmin.eq.1).or.(ibcxmin.eq.2)) zbcmin=bcxmin(iy)
     if((ibcxmax.eq.1).or.(ibcxmax.eq.2)) zbcmax=bcxmax(iy)
     call mkspline(x,nx,fwk, &
          ibcxmin,zbcmin,ibcxmax,zbcmax,ilinx,ier)
     if(ier.ne.0) return
     f(2,1:nx,iy)=fwk(2,1:nx)
  end do
  !
  !  evaluate fyy (spline in y direction)
  !  use homogeneous boundary condition; correction done later if necessary
  !
  zbcmin=0
  zbcmax=0
  ibcmin=ibcymin
  ibcmax=ibcymax
  do ix=1,nx
     fwk(1,1:ny) = f(1,ix,1:ny)
     if(iflg2.eq.1) then
        if((ibcymin.eq.1).or.(ibcymin.eq.2)) ibcmin=0
        if((ibcymax.eq.1).or.(ibcymax.eq.2)) ibcmax=0
     end if
     call mkspline(y,ny,fwk, &
          ibcmin,zbcmin,ibcmax,zbcmax,iliny,ier)
     if(ier.ne.0) return
     f(3,ix,1:ny)=fwk(2,1:ny)
  end do
  !
  !  evaluate fxxyy (spline fxx in y direction; BC simplified; avg
  !  d2(d2f/dx2)/dy2 and d2(df2/dy2)/dx2
  !
  zbcmin=0
  zbcmax=0
  ibcmin=ibcymin
  ibcmax=ibcymax
  do ix=1,nx
     fwk(1,1:ny) = f(2,ix,1:ny)
     if(iflg2.eq.1) then
        if((ibcymin.eq.1).or.(ibcymin.eq.2)) ibcmin=0
        if((ibcymax.eq.1).or.(ibcymax.eq.2)) ibcmax=0
     end if
     call mkspline(y,ny,fwk, &
          ibcmin,zbcmin,ibcmax,zbcmax,iliny,ier)
     if(ier.ne.0) return
     f(4,ix,1:ny)= fwk(2,1:ny)
  end do
  !
  if(iflg2.eq.1) then
     allocate(fcorr(2,nx,ny))
     !
     !  correct for inhomogeneous y boundary condition
     !
     do ix=1,nx
        !  the desired inhomogenous BC is the difference btw the
        !  requested derivative (1st or 2nd) and the current value

        zdiff(1)=0.0_fp
        if(ibcymin.eq.1) then
           hy=y(2)-y(1)
           zdiff(1)=(f(1,ix,2)-f(1,ix,1))/hy + &
                hy*(-2*f(3,ix,1)-f(3,ix,2))/6
           zdiff(1)=bcymin(ix)-zdiff(1)
        else if(ibcymin.eq.2) then
           zdiff(1)=bcymin(ix)-f(3,ix,1)
        end if

        zdiff(2)=0.0_fp
        if(ibcymax.eq.1) then
           hy=y(ny)-y(ny-1)
           zdiff(2)=(f(1,ix,ny)-f(1,ix,ny-1))/hy + &
                hy*(2*f(3,ix,ny)+f(3,ix,ny-1))/6
           zdiff(2)=bcymax(ix)-zdiff(2)
        else if(ibcymax.eq.2) then
           zdiff(2)=bcymax(ix)-f(3,ix,ny)
        end if
        !
        fwk(1,1:ny)=0.0_fp  ! values are zero; only BC is not
        call mkspline(y,ny,fwk,ibcymin,zdiff(1),ibcymax,zdiff(2), &
             iliny,ier)
        if(ier.ne.0) return
        fcorr(1,ix,1:ny)=fwk(2,1:ny)  ! fyy-correction
     end do
     !
     zbcmin=0
     zbcmax=0
     do iy=1,ny
        fwk(1,1:nx)=fcorr(1,1:nx,iy)
        call mkspline(x,nx,fwk,ibcxmin,zbcmin,ibcxmax,zbcmax, &
             ilinx,ier)
        if(ier.ne.0) return
        fcorr(2,1:nx,iy)=fwk(2,1:nx)  ! fxxyy-correction
     end do
     !
     f(3:4,1:nx,1:ny)=f(3:4,1:nx,1:ny)+fcorr(1:2,1:nx,1:ny)
     !
     deallocate(fcorr)
  end if
  !
  !  correction spline -- f=fxx=zero; fyy & fxxyy are affected
  !
  deallocate(fwk)
  !------------------------------------
  !
  !  thats all
  !
  return
end subroutine mkbicub

subroutine cmpi_sget_env(cname_in,cvalue_out,ierr)

  ! C callable mpi_sget_env
  !
  ! Mods
  !    22Dec2009    Jim.Conboy@cffe.ac.uk
  !                 cstring(trim(),  => cstr_2C(trim(), 
  !                 [ Former invalid under debug compilation ]
  !

  use mpi_env_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  BYTE_DECLARE cname_in(*), cvalue_out(*)
  integer, intent(out) :: ierr

  !-------------------------------

  character*(maxlen_name) :: name_in
  character*(maxlen_val) :: value_out

  !-------------------------------

  call cstring(name_in,cname_in,'2F')  ! cname_in -> name_in

  call mpi_sget_env(name_in,value_out,ierr)

  call cstr_2C(trim(value_out),cvalue_out,'2C')  ! value -> cvalue_out

end subroutine cmpi_sget_env

subroutine mpi_sget_env(name_in,value_out,ierr)

  use mpi_env_mod
  implicit NONE

  !  return value associated with name_in:
  !    1st look in mpi_env_mod; if not found there, from OS environment
  !    in which case value found from OS environment is stored in the module.

  character*(*), intent(in) :: name_in
  character*(*), intent(out) :: value_out
  integer, intent(out) :: ierr

  !--------------------------------------------
  integer :: ilen,iadr
  logical :: inew
  !--------------------------------------------

  call get_loc_myid
  if(mdebug) write(0,*) ' proc #',loc_myid,' entering mpi_sget_env: ', &
       'name_in: ',name_in

  call legal_name(name_in,ilen,ierr)
  if(ierr.ne.0) return

  call lookup_alloc(name_in,iadr,inew)

  if(.not.inew) then
     ! use module value

     value_out = mpi_env_vals(iadr)

  else
     ! get from OS environment; load module value
     mpi_env_names(iadr)=name_in
     call sget_env(name_in,value_out)
     mpi_env_vals(iadr) = value_out

  endif

  if(mdebug) write(0,*) ' proc #',loc_myid,' exiting mpi_sget_env: ', &
       'value, ierr: ',value_out,' ',ierr

end subroutine mpi_sget_env

subroutine util_bcherm1(fherm,idimx1, &
     jbcxa,jbcxb, &
     zbcxa,zbcxb, &
     x1)
  use iso_c_binding, only: fp => c_double

  !...  insert BCs as needed for Hermite interpolation setup


  implicit none
  integer :: idimx1         ! array dimensions
  real(fp) :: fherm(0:1,idimx1)

  integer :: jbcxa,jbcxb    ! x BC controls
  real(fp) :: zbcxa            ! x(1) BC data
  real(fp) :: zbcxb            ! x(idimx1) BC data

  real(fp) :: x1(idimx1)

  !-------------------------------------------------------------
  integer :: ix
  real(fp) :: zdx
  !-------------------------------------------------------------

  if((jbcxa.eq.1).or.(jbcxb.eq.1)) then

     if(jbcxa.eq.1) then
        fherm(1,1)=zbcxa
     else
        zdx = x1(2)-x1(1)
        fherm(1,1)=(fherm(0,2)-fherm(0,1))/zdx
     end if

     if(jbcxb.eq.1) then
        fherm(1,idimx1)=zbcxb
     else
        zdx = x1(idimx1)-x1(idimx1-1)
        fherm(1,idimx1)=(fherm(0,idimx1)-fherm(0,idimx1-1))/zdx
     end if

  end if

end subroutine util_bcherm1

!  cspline -- dmc 15 Feb 1999
!
!  a standard interface to the 1d spline setup routine
!    modified dmc 3 Mar 2000 -- to use Wayne Houlberg's v_spline code.
!    new BC options added.
!
subroutine cspline(x,nx,fspl,ibcxmin,bcxmin,ibcxmax,bcxmax, &
     wk,iwk,ilinx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer iwk,nx,ierx,inum,i
  !============
  real(fp) :: half,sixth
  !============
  real(fp) :: x(nx)                        ! x axis (in)
  real(fp) :: fspl(4,nx)                   ! spline data (in/out)
  integer ibcxmin                   ! x(1) BC flag (in, see comments)
  real(fp) :: bcxmin                       ! x(1) BC data (in, see comments)
  integer ibcxmax                   ! x(nx) BC flag (in, see comments)
  real(fp) :: bcxmax                       ! x(nx) BC data (in, see comments)
  real(fp) :: wk(iwk)                      ! workspace of size at least nx
  integer ilinx                     ! even spacing flag (out)
  integer ier                       ! output, =0 means OK
  !
  !  ** note wk(...) array is not used unless ibcxmin=-1 (periodic spline
  !  evaluation)
  !
  !  this routine computes spline coefficients for a 1d spline --
  !  evaluation of the spline can be done by cspeval.f90 subroutines
  !  or directly by inline code.
  !
  !  the input x axis x(1...nx) must be strictly ascending, i.e.
  !  x(i+1).gt.x(i) is required for i=1 to nx-1.  This is checked and
  !  ier=1 is set and the routine exits if the test is not satisfied.
  !
  !  on output, ilinx=1 is set if, to a reasonably close tolerance,
  !  all grid spacings x(i+1)-x(i) are equal.  This allows a speedier
  !  grid lookup algorithm on evaluation of the spline.  If on output
  !  ilinx=2, this means the spline x axis is not evenly spaced.
  !
  !  the input data for the spline are given in f[j] = fspl(1,j).  The
  !  output data are the spline coefficients fspl(2,j),fspl(3,j), and
  !  fspl(4,j), j=1 to nx.  The result is a spline s(x) satisfying the
  !  boundary conditions and with the properties
  !
  !     s(x(j)) = fspl(1,j)
  !     s'(x) is continuous even at the grid points x(j)
  !     s''(x) is continuous even at the grid points x(j)
  !
  !  the formula for evaluation of s(x) is:
  !
  !     let dx = x-x(i), where x(i).le.x.le.x(i+1).  Then,
  !     s(x)=fspl(1,i) + dx*(fspl(2,i) +dx*(fspl(3,i) + dx*fspl(4,i)))
  !
  !  ==>boundary conditions.  Complete specification of a 1d spline
  !  requires specification of boundary conditions at x(1) and x(nx).
  !
  !  this routine provides 4 options:
  !
  ! -1 ***** PERIODIC BC
  !  ibcxmin=-1  --  periodic boundary condition.  This means the
  !    boundary conditions s'(x(1))=s'(x(nx)) and s''(x(1))=s''(x(nx))
  !    are imposed.  Note that s(x(1))=s(x(nx)) (i.e. fspl(1,1)=fspl(1,nx))
  !    is not required -- that is determined by the fspl array input data.
  !    The periodic boundary condition is to be preferred for periodic
  !    data.  When splining periodic data f(x) with period P, the relation
  !    x(nx)=x(1)+n*P, n = the number of periods (usually 1), should hold.
  !    (ibcxmax, bcxmin, bcxmax are ignored).
  !
  !  if a periodic boundary condition is set, this covers both boundaries.
  !  for the other types of boundary conditions, the type of condition
  !  chosen for the x(1) boundary need not be the same as the type chosen
  !  for the x(nx) boundary.
  !
  !  0 ***** NOT A KNOT BC
  !  ibcxmin=0 | ibcxmax=0 -- this specifies a "not a knot" boundary
  !    condition -- see cubsplb.f90.  This is a common way for inferring
  !    a "good" spline boundary condition automatically from data in the
  !    vicinity of the boundary.  (bcxmin | bcxmax are ignored).
  !
  !  1 ***** BC:  SPECIFIED SLOPE
  !  ibcxmin=1 | ibcxmax=1 -- boundary condition is to have s'(x(1)) |
  !    s'(x(nx)) match the passed value (bcxmin | bcxmax).
  !
  !  2 ***** BC:  SPECIFIED 2nd DERIVATIVE
  !  ibcxmin=2 | ibcxmax=2 -- boundary condition is to have s''(x(1)) |
  !    s''(x(nx)) match the passed value (bcxmin | bcxmax).
  !
  !  3 ***** BC:  SPECIFIED SLOPE = 0.0
  !  ibcxmin=3 | ibcxmax=3 -- boundary condition is to have s'(x(1)) |
  !    s'(x(nx)) equal to ZERO.
  !
  !  4 ***** BC:  SPECIFIED 2nd DERIVATIVE = 0.0
  !  ibcxmin=4 | ibcxmax=4 -- boundary condition is to have s''(x(1)) |
  !    s''(x(nx)) equal to ZERO.
  !
  !  5 ***** BC:  1st DIVIDED DIFFERENCE
  !  ibcxmin=5 | ibcxmax=5 -- boundary condition is to have s'(x(1)) |
  !    s'(x(nx)) equal to the slope from the 1st|last 2 points
  !
  !  6 ***** BC:  2nd DIVIDED DIFFERENCE
  !  ibcxmin=6 | ibcxmax=6 -- boundary condition is to have s''(x(1)) |
  !    s''(x(nx)) equal to the 2nd derivative from the 1st|last 3 points
  !
  !  7 ***** BC:  3rd DIVIDED DIFFERENCE
  !  ibcxmin=7 | ibcxmax=7 -- boundary condition is to have s'''(x(1)) |
  !    s'''(x(nx)) equal to the 3rd derivative from the 1st|last 4 points
  !
  !---------------------------------------------------------------------
  data half/0.5_fp/
  data sixth/0.166666666666666667_fp/
  !
  !  error checks
  !
  ier = 0
  if(nx.lt.2) then
     write(6,'('' ?cspline:  at least 2 x points required.'')')
     ier=1
  end if
  call ibc_ck(ibcxmin,'cspline','xmin',-1,7,ier)
  if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'cspline','xmax',0,7,ier)
  !
  !  x axis check
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?cspline:  x axis not strict ascending'')')
  end if
  !
  if(ibcxmin.eq.-1) then
     inum=nx
     if(iwk.lt.inum) then
        write(6,1009) inum,iwk,nx
1009    format( &
             ' ?cspline:  workspace too small.  need:  ',i6,' got:  ',i6/ &
             '  (need = nx, nx=',i6)
        ier=3
     end if
  end if
  !
  if(ier.ne.0) return
  !
  !  OK -- evaluate spline
  !
  if(ibcxmin.eq.1) then
     fspl(2,1)=bcxmin
  else if(ibcxmin.eq.2) then
     fspl(3,1)=bcxmin
  end if
  !
  if(ibcxmax.eq.1) then
     fspl(2,nx)=bcxmax
  else if(ibcxmax.eq.2) then
     fspl(3,nx)=bcxmax
  end if
  !
  call v_spline(ibcxmin,ibcxmax,nx,x,fspl,wk)
  !
  do i=1,nx
     fspl(3,i)=half*fspl(3,i)
     fspl(4,i)=sixth*fspl(4,i)
  end do
  !
  return
end subroutine cspline

! error check routine for 2d hybrid interpolation
subroutine vecin3d_argchk(subname,jspline,icoeff,nx,ny,nz,ixdim,iydim,izdim,ier)
  use iso_c_binding, only: fp => c_double
  implicit none

  character(len=*), intent(in) :: subname   ! name of caller, for messages
  integer, intent(in) :: jspline(3)      ! interp. type, by dimension
  integer, intent(in) :: icoeff          ! coeffs per data point
  integer, intent(in) :: nx,ny,nz        ! grid sizes
  integer, intent(in) :: ixdim,iydim,izdim     ! coeff array dimensions

  integer, intent(out) :: ier            ! status coder (0=OK)

  !----------------------------------------
  !  local
  integer :: i,itest,jcoeff,ipcub
  !----------------------------------------

  ier=0

  jcoeff=1
  ipcub=-99

  do i=1,3
     if((jspline(i).lt.-1).or.(jspline(i).gt.2)) then
        write(6,*) ' ?'//trim(subname)// &
             ': jspline(',i,')=',jspline(i)
        write(6,*) '  not in expected range -1:2.'
        ier=1

     else if(jspline(i).ge.1) then
        jcoeff=jcoeff*2
        if(ipcub.eq.-99) then
           ipcub=jspline(i)
        else
           if(ipcub.ne.jspline(i)) then
              write(6,*) ' ?'//trim(subname)// &
                   ': more than one cubic method: jspline=',jspline
           end if
        end if

     end if
  end do

  if(ier.eq.0) then
     if(jcoeff.ne.icoeff) then
        write(6,*) ' ?'//trim(subname)// &
             ': incorrect #coefficients per data point.'
        write(6,*) '  expected: ',jcoeff,'  received: ',icoeff
        write(6,*) '  jspline: ',jspline
        ier=1
     end if

     itest=nx
     if(jspline(1).eq.-1) itest=nx-1
     if(ixdim.ne.itest) then
        write(6,*) ' ?'//trim(subname)//': ixdim dimension error:'
        write(6,*) '  nx=',nx,' ixdim=',ixdim,' expected: ',itest
        write(6,*) '  jspline(1)=',jspline(1),'; -1 for zonal.'
        ier=1 
     end if

     itest=ny
     if(jspline(2).eq.-1) itest=ny-1
     if(iydim.ne.itest) then
        write(6,*) ' ?'//trim(subname)//': iydim dimension error:'
        write(6,*) '  ny=',ny,' iydim=',iydim,' expected: ',itest
        write(6,*) '  jspline(2)=',jspline(2),'; -1 for zonal.'
        ier=1
     end if

     itest=nz
     if(jspline(1).eq.-1) itest=nz-1
     if(izdim.ne.itest) then
        write(6,*) ' ?'//trim(subname)//': izdim dimension error:'
        write(6,*) '  nz=',nz,' izdim=',izdim,' expected: ',itest
        write(6,*) '  jspline(3)=',jspline(3),'; -1 for zonal.'
        ier=1 
     end if

  end if

  return
end subroutine vecin3d_argchk

      subroutine sget_dsk(dsk)
      character*(*) dsk
C
C  get current working disk (intended for VMS)
C
      character*32 zdir
C
      call showdefl(dsk,ildisk,zdir,ildir)
C
      return
      end
 

subroutine mkspl3pb(fun,x,nx,th,nth,ph,nph,fspl,nf4,nf5, &
     ibcxmin,bcxmin,ibcxmax,bcxmax,nb1, &
     wk,inwk,ilinx,ilinth,ilinph,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a tricubic biperiodic spline with knots at grid points and
  !  function values from the callable function `fun' passed.
  !
  !  use tpsplinb to setup the spline coefficients
  !
  !  periodic boundary condition for theta & phi grids.
  !  boundary condition data may be specified at x(1) and x(nx) for each
  !  theta & phi:
  !     ibcxmin=0 ==> "not a knot" boundary condition, cf cubspl.f90
  !     ibcxmin=1 ==> match slope, bcxmin(ith,iph) gives df/dx at
  !         x(1),th(ith),ph(iph)
  !     ibcxmin=2 ==> match 2nd derivative, given at x(1),th(ith),ph(iph)
  !          by bcxmin(ith,iph)
  !
  !     ibcxmax,bcxmax have analogous interpretation -- at x(nx).
  !
  !============
  implicit none
  integer nth,nph,nf4,nf5,nb1,inwk,nx,iph,ith,ix
  !============
  real(fp) :: fun
  !============
  external fun                      ! passed real function(x,th)
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: th(nth)                      ! th coordinate array
  real(fp) :: ph(nph)                      ! ph coordinate array
  !
  real(fp) :: fspl(4,4,4,nf4,nf5,nph)      ! function data / spline coeff array
  real(fp) :: wk(inwk)                     ! workspace for bpsplinb
  !
  integer ibcxmin                   ! boundary condition indicator
  real(fp) :: bcxmin(nb1,nph)              ! boundary condition data
  integer ibcxmax                   ! boundary condition indicator
  real(fp) :: bcxmax(nb1,nph)              ! boundary condition data
  !
  integer ilinx                     ! output =1 if x(...) evenly spaced
  integer ilinth                    ! output =1 if th(...) evenly spaced
  integer ilinph                    ! output =1 if ph(...) evenly spaced
  !
  integer ier                       ! completion code from bpspline
  !
  !----------------------------
  !
  ier=0
  if(nf4.lt.nx) then
     write(6,'('' ?mkspl3pb -- array dim error, nf4 .lt. nx'')')
     ier=1
  end if
  if(nf5.lt.nth) then
     write(6,'('' ?mkspl3pb -- array dim error, nf5 .lt. nth'')')
     ier=2
  end if
  if(nb1.lt.nth) then
     write(6,'('' ?mkspl3pb -- array dim error, nb1 .lt. nth'')')
     ier=3
  end if
  if(inwk.lt.5*max(nx,nth,nph)) then
     write(6,'('' ?mkspl3pb -- array dim error, inwk too small'')')
     ier=4
  end if

  if(ier.ne.0) return
  !
  do iph=1,nph
     do ith=1,nth
        do ix=1,nx
           fspl(1,1,1,ix,ith,iph)=fun(x(ix),th(ith),ph(iph))
        end do
     end do
  end do
  !
  call tpsplinb(x,nx,th,nth,ph,nph,fspl,nf4,nf5, &
       ibcxmin,bcxmin,ibcxmax,bcxmax,nb1, &
       wk,inwk,ilinx,ilinth,ilinph,ier)
  !
  return
end subroutine mkspl3pb

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Return error if any of the target points lie outside the domain

#include "cpp/czspline_handle_size.h"

  !point
#define _S czspline_isindomain1
#define _O czspline1
  subroutine _S(handle, p1, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in) :: p1
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, p1, ier)
  end subroutine _S
#undef _S
#undef _O

  !cloud
#define _S czspline_isindomain1_cloud
#define _O czspline1
  subroutine _S(handle, k, p1, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k
    real(fp), intent(in) :: p1(k)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k, p1, ier)
  end subroutine _S
#undef _S
#undef _O

  !array
#define _S czspline_isindomain1_array
#define _O czspline1
  subroutine _S(handle, k1, p1, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k1
    real(fp), intent(in) :: p1(k1)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k1, p1, ier)
  end subroutine _S
#undef _S
#undef _O

  !point
#define _S czspline_isindomain2
#define _O czspline2
  subroutine _S(handle, p1, p2, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in) :: p1, p2
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, p1, p2, ier)
  end subroutine _S
#undef _S
#undef _O

  !cloud
#define _S czspline_isindomain2_cloud
#define _O czspline2
  subroutine _S(handle, k, p1, p2, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k
    real(fp), intent(in) :: p1(k), p2(k)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k, p1, p2, ier)
  end subroutine _S
#undef _S
#undef _O

  !array
#define _S czspline_isindomain2_array
#define _O czspline2
  subroutine _S(handle, k1, k2, p1, p2, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k1, k2
    real(fp), intent(in)  :: p1(k1), p2(k2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k1, k2, p1, p2, ier)
  end subroutine _S
#undef _S
#undef _O

  !point
#define _S czspline_isindomain3
#define _O czspline3
  subroutine _S(handle, p1, p2, p3, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    real(fp), intent(in) :: p1, p2, p3
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, p1, p2, p3, ier)
  end subroutine _S
#undef _S
#undef _O

  !cloud
#define _S czspline_isindomain3_cloud
#define _O czspline3
  subroutine _S(handle, k, p1, p2, p3, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k
    real(fp), intent(in) :: p1(k), p2(k), p3(k)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k, p1, p2, p3, ier)
  end subroutine _S
#undef _S
#undef _O

  !array
#define _S czspline_isindomain3_array
#define _O czspline3
  subroutine _S(handle, k1, k2, k3, p1, p2, p3, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: k1, k2, k3
    real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_isindomain(self % ptr, k1, k2, k3, p1, p2, p3, ier)
  end subroutine _S
#undef _S
#undef _O

subroutine v_spline(k_bc1,k_bcn,n,x,f,wk)
  use iso_c_binding, only: fp => c_double
  !***********************************************************************
  !V_SPLINE evaluates the coefficients for a 1d cubic interpolating spline
  !References:
  !  Forsythe, Malcolm, Moler, Computer Methods for Mathematical
  !    Computations, Prentice-Hall, 1977, p.76
  !  Engeln-Muellges, Uhlig, Numerical Algorithms with Fortran, Springer,
  !    1996, p.251
  !  W.A.Houlberg, D.McCune 3/2000
  !Input:
  !  k_bc1-option for BC at x1 = x(1)
  !       =-1 periodic, ignore k_bcn
  !       =0 not-a-knot
  !       =1 s'(x1) = input value of f(2,1)
  !       =2 s''(x1) = input value of f(3,1)
  !       =3 s'(x1) = 0.0
  !       =4 s''(x1) = 0.0
  !       =5 match first derivative to first 2 points
  !       =6 match second derivative to first 3 points
  !       =7 match third derivative to first 4 points
  !       =else use not-a-knot
  !  k_bcn-option for boundary condition at xn = x(n)
  !       =0 not-a-knot
  !       =1 s'(xn) = input value of f(2,n)
  !       =2 s''(xn) = input value of f(3,n)
  !       =3 s'(xn) = 0.0
  !       =4 s''(xn) = 0.0
  !       =5 match first derivative to last 2 points
  !       =6 match second derivative to lasst 3 points
  !       =7 match third derivative to last 4 points
  !       =else use knot-a-knot
  !  n-number of data points or knots-(n.ge.2)
  !  x(n)-abscissas of the knots in strictly increasing order
  !  f(1,i)-ordinates of the knots
  !  f(2,1)-input value of s'(x1) for k_bc1=1
  !  f(2,n)-input value of s'(xn) for k_bcn=1
  !  f(3,1)-input value of s''(x1) for k_bc1=2
  !  f(3,n)-input value of s''(xn) for k_bcn=2
  !  wk(n)-scratch work area for periodic BC
  !Output:
  !  f(2,i)=s'(x(i))
  !  f(3,i)=s''(x(i))
  !  f(4,i)=s'''(x(i))
  !Comments:
  !  s(x)=f(1,i)+f(2,i)*(x-x(i))+f(3,i)*(x-x(i))**2/2!
  !       +f(4,i)*(x-x(i))**3/3! for x(i).le.x.le.x(i+1)
  !  W_SPLINE can be used to evaluate the spline and its derivatives
  !  The cubic spline is twice differentiable (C2)
  !
  !  modifications -- dmc 18 Feb 2010:
  !    Deal with n.lt.4 -- the general tridiagonal spline method
  !    does not have the right formulation for n.eq.3 "not a knot" or periodic
  !    boundary conditions, nor for n.eq.2 with any boundary conditions.
  !
  !    Apply boundary conditions even for n=2, when the "spline" is really
  !    just a single cubic polynomial.
  !    In this case, several boundary condition (BC) options are mapped to
  !      BC option 5, 1st divided difference.  If 5 is used on both sides
  !      of an n=2 "spline" you get a linear piece which is what the old
  !      code always gave, regardless of BC option settings.  The following
  !      BC controls are mapped to 5:
  !        periodic (-1)
  !        not a knot (0) (for n=2 no grid point exists for knot location).
  !        option (5) is preserved
  !        options 6 and 7 -- mapped to (5); higher divided differences
  !          need n>2; in fact 7 needs n>3; for n=3 option 6 is substituted.
  !
  !    The boundary condition screening is done at the start of the code;
  !    passed controls k_bc1 and k_bcn are mapped to i_bc1 and i_bcn.
  !
  !    ALSO: for n=3, "not a knot" from both left and right needs special
  !      interpretation, since the 2 boundary conditions overlap.  The
  !      chosen interpretation is a parabolic fit to the 3 given data points.
  !      and so f''' = 0 and f'' = constant.  If "not a knot" is used on
  !      one side only, the solution is a single cubic piece and special
  !      code is also needed.
  !    ALSO: for n=3, "periodic" boundary condition needs special code; this
  !      is added.
  !
  !  bugfixes -- dmc 24 Feb 2004:
  !    (a) fixed logic for not-a-knot:
  !          !    Set f(3,1) for not-a-knot
  !                    IF(k_bc1.le.0.or.k_bc1.gt.7) THEN ...
  !        instead of
  !          !    Set f(3,1) for not-a-knot
  !                    IF(k_bc1.le.0.or.k_bc1.gt.5) THEN ...
  !        and similarly for logic after cmt
  !          !    Set f(3,n) for not-a-knot
  !        as required since k_bc*=6 and k_bc*=7 are NOT not-a-knot BCs.
  !
  !    (b) the BCs to fix 2nd derivative at end points did not work if that
  !        2nd derivative were non-zero.  The reason is that in those cases
  !        the off-diagonal matrix elements nearest the corners are not
  !        symmetric; i.e. elem(1,2).ne.elem(2,1) and
  !        elem(n-1,n).ne.elem(n,n-1) where I use "elem" to refer to
  !        the tridiagonal matrix elements.  The correct values for the
  !        elements is:   elem(1,2)=0, elem(2,1)=x(2)-x(1)
  !                       elem(n,n-1)=0, elem(n-1,n)=x(n)-x(n-1)
  !        the old code in effect had these as all zeroes.  Since this
  !        meant the wrong set of linear equations was solved, the
  !        resulting spline had a discontinuity in its 1st derivative
  !        at x(2) and x(n-1).  Fixed by introducing elem21 and elemnn1
  !        to represent the non-symmetric lower-diagonal values.  Since
  !        elem21 & elemnn1 are both on the lower diagonals, logic to
  !        use them occurs in the non-periodic forward elimination loop
  !        only.  DMC 24 Feb 2004.
  !***********************************************************************
  !Declaration of input variables
  implicit none
  integer :: k_bc1, k_bcn, n
  real(fp) ::  x(*), wk(*), f(4,*)
  !Declaration in local variables
  integer :: i, ib, imax, imin
  real(fp) :: a1, an, b1, bn, q, t, hn
  real(fp) ::       elem21,                  elemnn1

  integer :: i_bc1,i_bcn  ! screened BC controls

  integer :: iord1,iord2  ! used for n=2 only
  real(fp) :: h,f0,fh         ! used for n=2,3 only
  real(fp) :: h1,h2,h3,dels   ! used for n=3 special cases
  real(fp) :: f1,f2,f3,aa,bb  ! used for n=3

  integer :: i3knots      ! for n=3, number of not-a-knot BCs
  integer :: i3perio      ! for n=3, periodic BC

  !------------------------------------------------------------
  !  screen the BC options (DMC Feb. 2010...)

  i_bc1=k_bc1
  i_bcn=k_bcn

  if((i_bc1.lt.-1).or.(i_bc1.gt.7)) i_bc1=0  ! outside [-1:7] -> not-a-knot
  if((i_bcn.lt.0).or.(i_bcn.gt.7)) i_bcn=0   ! outside [0:7] -> not-a-knot

  if(i_bc1.eq.-1) i_bcn=-1  ! periodic BC

  i3knots=0
  i3perio=0
  if(n.eq.3) then
     i_bc1=min(6,i_bc1)
     i_bcn=min(6,i_bcn)
     if(i_bc1.eq.0) i3knots = i3knots + 1
     if(i_bcn.eq.0) i3knots = i3knots + 1
     if(i_bc1.eq.-1) i3perio = 1
  end if

  if(n.eq.2) then
     if(i_bc1.eq.-1) then
        i_bc1=5
        i_bcn=5
     end if
     if((i_bc1.eq.0).or.(i_bc1.gt.5)) i_bc1=5
     if((i_bcn.eq.0).or.(i_bcn.gt.5)) i_bcn=5

     if((i_bc1.eq.1).or.(i_bc1.eq.3).or.(i_bc1.eq.5)) then
        iord1=1  ! 1st derivative match on LHS
     else
        iord1=2  ! 2nd derivative match on LHS
     end if

     if((i_bcn.eq.1).or.(i_bcn.eq.3).or.(i_bcn.eq.5)) then
        iord2=1  ! 1st derivative match on RHS
     else
        iord2=2  ! 2nd derivative match on RHS
     end if
  end if

  !Set default range
  imin=1
  imax=n
  !Set first and second BC values
  a1=0.0_fp
  b1=0.0_fp
  an=0.0_fp
  bn=0.0_fp
  IF(i_bc1.eq.1) THEN
     a1=f(2,1)
  ELSEIF(i_bc1.eq.2) THEN
     b1=f(3,1)
  ELSEIF(i_bc1.eq.5) THEN
     a1=(f(1,2)-f(1,1))/(x(2)-x(1))
  ELSEIF(i_bc1.eq.6) THEN
     b1=2.0_fp*((f(1,3)-f(1,2))/(x(3)-x(2)) &
          -(f(1,2)-f(1,1))/(x(2)-x(1)))/(x(3)-x(1))
  end if
  IF(i_bcn.eq.1) THEN
     an=f(2,n)
  ELSEIF(i_bcn.eq.2) THEN
     bn=f(3,n)
  ELSEIF(i_bcn.eq.5) THEN
     an=(f(1,n)-f(1,n-1))/(x(n)-x(n-1))
  ELSEIF(i_bcn.eq.6) THEN
     bn=2.0_fp*((f(1,n)-f(1,n-1))/(x(n)-x(n-1)) &
          -(f(1,n-1)-f(1,n-2))/(x(n-1)-x(n-2)))/(x(n)-x(n-2))
  end if
  !Clear f(2:4,n)
  f(2,n)=0.0_fp
  f(3,n)=0.0_fp
  f(4,n)=0.0_fp
  IF(n.eq.2) THEN
     if((i_bc1.eq.5).and.(i_bcn.eq.5)) then
        !Coefficients for n=2 (this was the original code)
        f(2,1)=(f(1,2)-f(1,1))/(x(2)-x(1))
        f(3,1)=0.0_fp
        f(4,1)=0.0_fp
        f(2,2)=f(2,1)
        f(3,2)=0.0_fp
        f(4,2)=0.0_fp
     else if((iord1.eq.1).and.(iord2.eq.1)) then
        ! LHS: match a1 for 1st deriv; RHS: match an for 1st deriv.
        f(2,1)=a1
        f(2,2)=an
        h = (x(2)-x(1))
        f0 = f(1,1)
        fh = f(1,2)

        ! setting xx = x-x(1),
        ! f = c1*xx**3 + c2*xx**2 + a1*xx + f0
        !   -->  c1*h**3   + c2*h**2 = fh - f0 - a1*h
        !   and  3*c1*h**2 + 2*c2*h  = an - a1
        ! f' = 3*c1*xx*2 + 2*c2*xx + a1
        ! f'' = 6*c1*xx + 2*c2
        ! f''' = 6*c1

        ! solve 2x2 system for c1 -> f(4,1)/6 and c2 -> f(3,1)/2

        f(3,1) = (3*(fh-f0)/(h*h) - (2*a1 + an)/h)*2       ! 2*c2
        f(4,1) = (-2*(fh-f0)/(h*h*h) + (a1 + an)/(h*h))*6  ! 6*c1

        f(4,2) = f(4,1)
        f(3,2) = f(4,1)*h + f(3,1)

     else if((iord1.eq.1).and.(iord2.eq.2)) then
        ! LHS: match a1 for 1st deriv; RHS: match bn for 2nd deriv.
        f(2,1)=a1
        f(3,2)=bn
        h = (x(2)-x(1))
        f0 = f(1,1)
        fh = f(1,2)

        ! setting xx = x-x(1),
        ! f = c1*xx**3 + c2*xx**2 + a1*xx + f0
        !   -->  c1*h**3   + c2*h**2 = fh - f0 - a1*h
        !   and  6*c1*h    + 2*c2    = bn
        ! f' = 3*c1*xx*2 + 2*c2*xx + a1
        ! f'' = 6*c1*xx + 2*c2
        ! f''' = 6*c1

        ! solve 2x2 system for c1 -> f(4,1)/6 and c2 -> f(3,1)/2

        f(3,1) = (-bn/4 + 3*(fh-f0)/(2*h*h) - 3*a1/(2*h))*2       ! 2*c2
        f(4,1) = (bn/(4*h) - (fh-f0)/(2*h*h*h) + a1/(2*h*h))*6    ! 6*c1

        f(4,2) = f(4,1)
        f(2,2) = f(4,1)*h*h/2 + f(3,1)*h + a1
     else if((iord1.eq.2).and.(iord2.eq.1)) then
        ! LHS: match b1 for 2nd deriv; RHS: match an for 1st deriv.
        f(3,1)=b1
        f(2,2)=an
        h = (x(2)-x(1))
        f0 = f(1,1)
        fh = f(1,2)

        ! setting xx = x-x(1),
        ! f = c1*xx**3 + (b1/2)*xx**2 + c3*xx + f0
        !   -->  c1*h**3   + c3*h = fh - f0 - b1*h**2/2
        !   and  3*c1*h**2 + c3   = an - b1*h
        ! f' = 3*c1*xx*2 + b1*xx + c3
        ! f'' = 6*c1*xx + b1
        ! f''' = 6*c1

        ! solve 2x2 system for c1 -> f(4,1)/6 and c2 -> f(3,1)/2

        f(2,1) = 3*(fh-f0)/(2*h) - b1*h/4 - an/2                  ! c3
        f(4,1) = (an/(2*h*h) - (fh-f0)/(2*h*h*h) - b1/(4*h))*6    ! 6*c1

        f(4,2) = f(4,1)
        f(3,2) = f(4,1)*h + f(3,1)
     else if((iord1.eq.2).and.(iord2.eq.2)) then
        ! LHS: match b1 for 2nd deriv; RHS: match bn for 2nd deriv.
        f(3,1)=b1
        f(3,2)=bn
        h = (x(2)-x(1))
        f0 = f(1,1)
        fh = f(1,2)

        ! setting xx = x-x(1),
        ! f = c1*xx**3 + (b1/2)*xx**2 + c3*xx + f0
        !   -->  c1*h**3   + c3*h = fh - f0 - b1*h**2/2
        !   and  6*c1*h           = bn - b1
        ! f' = 3*c1*xx*2 + b1*xx + c3
        ! f'' = 6*c1*xx + b1
        ! f''' = 6*c1

        ! solve 2x2 system for c1 -> f(4,1)/6 and c2 -> f(3,1)/2

        f(2,1) = (fh-f0)/h -b1*h/3 -bn*h/6                 ! c3
        f(4,1) = (bn-b1)/h                                 ! 6*c1

        f(4,2) = f(4,1)
        f(2,2) = f(4,1)*h*h/2 + b1*h + f(2,1)
     end if

  ELSE IF(i3perio.eq.1) then
     !Special case: nx=3 periodic spline
     h1=x(2)-x(1)
     h2=x(3)-x(2)
     h=h1+h2

     dels=(f(1,3)-f(1,2))/h2 - (f(1,2)-f(1,1))/h1

     f(2,1)= (f(1,2)-f(1,1))/h1 + (h1*dels)/h
     f(3,1)= -6*dels/h
     f(4,1)= 12*dels/(h1*h)

     f(2,2)= (f(1,3)-f(1,2))/h2 - (h2*dels)/h
     f(3,2)= 6*dels/h
     f(4,2)= -12*dels/(h2*h)

     f(2,3)=f(2,1)
     f(3,3)=f(3,1)
     f(4,3)=f(4,1)


  ELSE IF(i3knots.eq.2) then
     !Special case: nx=3, not-a-knot on both sides
     h1=x(2)-x(1)
     h2=x(3)-x(2)
     h=h1+h2
     ! this is just a quadratic fit through 3 pts
     f1=f(1,1)-f(1,2)
     f2=f(1,3)-f(1,2)

     !  quadratic around origin at (x(2),f(1,2))
     !          aa*h1**2 - bb*h1 = f1
     !          aa*h2**2 + bb*h2 = f2

     aa = (f2*h1 + f1*h2)/(h1*h2*h)
     bb = (f2*h1*h1 - f1*h2*h2)/(h1*h2*h)

     f(4,1:3)=0.0_fp  ! f''' = 0 (quadratic polynomial)
     f(3,1:3)=2*aa  ! f'' = const

     f(2,1)=bb-2*aa*h1
     f(2,2)=bb
     f(2,3)=bb+2*aa*h2

  ELSE IF(i3knots.eq.1) then
     !Special cases: nx=3, not-a-knot on single side
     if((i_bc1.eq.1).or.(i_bc1.eq.3).or.(i_bc1.eq.5)) then
        ! f' LHS condition; not-a-knot RHS
        !  a1 = f' LHS BC
        h2=x(2)-x(1)
        h3=x(3)-x(1)

        f2=f(1,2)-f(1,1)
        f3=f(1,3)-f(1,1)

        !  find cubic aa*xx**3 + bb*xx**2 + a1*xx
        !    satisfying aa*h2**3 + bb*h2**2 + a1*h2 = f2
        !           and aa*h3**3 + bb*h3**2 + a1*h3 = f3

        aa=a1/(h2*h3) + f3/(h3*h3*(h3-h2)) - f2/(h2*h2*(h3-h2))
        bb=-a1*(h3*h3-h2*h2)/(h2*h3*(h3-h2)) &
             + f2*h3/(h2*h2*(h3-h2)) - f3*h2/(h3*h3*(h3-h2))

        f(2,1)=a1
        f(3,1)=2*bb
        f(4,1)=6*aa

        f(2,2)=3*aa*h2*h2 + 2*bb*h2 + a1
        f(3,2)=6*aa*h2 + 2*bb
        f(4,2)=6*aa

        f(2,3)=3*aa*h3*h3 + 2*bb*h3 + a1
        f(3,3)=6*aa*h3 + 2*bb
        f(4,3)=6*aa

     else if((i_bc1.eq.2).or.(i_bc1.eq.4).or.(i_bc1.eq.6)) then
        ! f'' LHS condition; not-a-knot RHS
        !  b1 = f'' LHS BC
        h2=x(2)-x(1)
        h3=x(3)-x(1)

        f2=f(1,2)-f(1,1)
        f3=f(1,3)-f(1,1)

        !  find cubic aa*xx**3 + (b1/2)*xx**2 + bb*xx
        !    satisfying aa*h2**3 + bb*h2 = f2 -(b1/2)*h2**2
        !           and aa*h3**3 + bb*h3 = f3 -(b1/2)*h3**2

        aa= -(b1/2)*(h3-h2)/(h3*h3-h2*h2) &
             -f2/(h2*(h3*h3-h2*h2)) + f3/(h3*(h3*h3-h2*h2))
        bb= -(b1/2)*h2*h3*(h3-h2)/(h3*h3-h2*h2) &
             +f2*h3*h3/(h2*(h3*h3-h2*h2)) &
             -f3*h2*h2/(h3*(h3*h3-h2*h2))

        f(2,1)=bb
        f(3,1)=b1
        f(4,1)=6*aa

        f(2,2)=3*aa*h2*h2 + b1*h2 + bb
        f(3,2)=6*aa*h2 + b1
        f(4,2)=6*aa

        f(2,3)=3*aa*h3*h3 + b1*h3 + bb
        f(3,3)=6*aa*h3 + b1
        f(4,3)=6*aa

     else if((i_bcn.eq.1).or.(i_bcn.eq.3).or.(i_bcn.eq.5)) then
        ! f' RHS condition; not-a-knot LHS
        !  an = f' RHS BC
        h2=x(2)-x(3)
        h3=x(1)-x(3)

        f2=f(1,2)-f(1,3)
        f3=f(1,1)-f(1,3)

        !  find cubic aa*xx**3 + bb*xx**2 + an*xx
        !    satisfying aa*h2**3 + bb*h2**2 + an*h2 = f2
        !           and aa*h3**3 + bb*h3**2 + an*h3 = f3

        aa=an/(h2*h3) + f3/(h3*h3*(h3-h2)) - f2/(h2*h2*(h3-h2))
        bb=-an*(h3*h3-h2*h2)/(h2*h3*(h3-h2)) &
             + f2*h3/(h2*h2*(h3-h2)) - f3*h2/(h3*h3*(h3-h2))

        f(2,3)=an
        f(3,3)=2*bb
        f(4,3)=6*aa

        f(2,2)=3*aa*h2*h2 + 2*bb*h2 + an
        f(3,2)=6*aa*h2 + 2*bb
        f(4,2)=6*aa

        f(2,1)=3*aa*h3*h3 + 2*bb*h3 + an
        f(3,1)=6*aa*h3 + 2*bb
        f(4,1)=6*aa

     else if((i_bcn.eq.2).or.(i_bcn.eq.4).or.(i_bcn.eq.6)) then
        ! f'' RHS condition; not-a-knot LHS
        !  bn = f'' RHS BC
        h2=x(2)-x(3)
        h3=x(1)-x(3)

        f2=f(1,2)-f(1,3)
        f3=f(1,1)-f(1,3)

        !  find cubic aa*xx**3 + (bn/2)*xx**2 + bb*xx
        !    satisfying aa*h2**3 + bb*h2 = f2 -(bn/2)*h2**2
        !           and aa*h3**3 + bb*h3 = f3 -(bn/2)*h3**2

        aa= -(bn/2)*(h3-h2)/(h3*h3-h2*h2) &
             -f2/(h2*(h3*h3-h2*h2)) + f3/(h3*(h3*h3-h2*h2))
        bb= -(bn/2)*h2*h3*(h3-h2)/(h3*h3-h2*h2) &
             +f2*h3*h3/(h2*(h3*h3-h2*h2)) &
             -f3*h2*h2/(h3*(h3*h3-h2*h2))

        f(2,3)=bb
        f(3,3)=bn
        f(4,3)=6*aa

        f(2,2)=3*aa*h2*h2 + bn*h2 + bb
        f(3,2)=6*aa*h2 + bn
        f(4,2)=6*aa

        f(2,1)=3*aa*h3*h3 + bn*h3 + bb
        f(3,1)=6*aa*h3 + bn
        f(4,1)=6*aa

     end if
  ELSE IF(n.gt.2) THEN
     !Set up tridiagonal system for A*y=B where y(i) are the second
     !  derivatives at the knots
     !  f(2,i) are the diagonal elements of A
     !  f(4,i) are the off-diagonal elements of A
     !  f(3,i) are the B elements/3, and will become c/3 upon solution
     f(4,1)=x(2)-x(1)
     f(3,2)=(f(1,2)-f(1,1))/f(4,1)
     DO i=2,n-1
        f(4,i)=x(i+1)-x(i)
        f(2,i)=2.0_fp*(f(4,i-1)+f(4,i))
        f(3,i+1)=(f(1,i+1)-f(1,i))/f(4,i)
        f(3,i)=f(3,i+1)-f(3,i)
     end do
     !
     !  (dmc): save now:
     !
     elem21=f(4,1)
     elemnn1=f(4,n-1)
     !
     !  BC's
     !    Left
     IF(i_bc1.eq.-1) THEN
        f(2,1)=2.0_fp*(f(4,1)+f(4,n-1))
        f(3,1)=(f(1,2)-f(1,1))/f(4,1)-(f(1,n)-f(1,n-1))/f(4,n-1)
        wk(1)=f(4,n-1)
        DO i=2,n-3
           wk(i)=0.0_fp
        end do
        wk(n-2)=f(4,n-2)
        wk(n-1)=f(4,n-1)
     ELSEIF(i_bc1.eq.1.or.i_bc1.eq.3.or.i_bc1.eq.5) THEN
        f(2,1)=2.0_fp*f(4,1)
        f(3,1)=(f(1,2)-f(1,1))/f(4,1)-a1
     ELSEIF(i_bc1.eq.2.or.i_bc1.eq.4.or.i_bc1.eq.6) THEN
        f(2,1)=2.0_fp*f(4,1)
        f(3,1)=f(4,1)*b1/3.0_fp
        f(4,1)=0.0_fp  ! upper diagonal only (dmc: cf elem21)
     ELSEIF(i_bc1.eq.7) THEN
        f(2,1)=-f(4,1)
        f(3,1)=f(3,3)/(x(4)-x(2))-f(3,2)/(x(3)-x(1))
        f(3,1)=f(3,1)*f(4,1)**2/(x(4)-x(1))
     ELSE                             ! not a knot:
        imin=2
        f(2,2)=f(4,1)+2.0_fp*f(4,2)
        f(3,2)=f(3,2)*f(4,2)/(f(4,1)+f(4,2))
     end if
     !    Right
     IF(i_bcn.eq.1.or.i_bcn.eq.3.or.i_bcn.eq.5) THEN
        f(2,n)=2.0_fp*f(4,n-1)
        f(3,n)=-(f(1,n)-f(1,n-1))/f(4,n-1)+an
     ELSEIF(i_bcn.eq.2.or.i_bcn.eq.4.or.i_bcn.eq.6) THEN
        f(2,n)=2.0_fp*f(4,n-1)
        f(3,n)=f(4,n-1)*bn/3.0_fp
        !xxx          f(4,n-1)=0.0  ! dmc: preserve f(4,n-1) for back subst.
        elemnn1=0.0_fp  !  lower diaganol only (dmc)
     ELSEIF(i_bcn.eq.7) THEN
        f(2,n)=-f(4,n-1)
        f(3,n)=f(3,n-1)/(x(n)-x(n-2))-f(3,n-2)/(x(n-1)-x(n-3))
        f(3,n)=-f(3,n)*f(4,n-1)**2/(x(n)-x(n-3))
     ELSEIF(i_bc1.ne.-1) THEN         ! not a knot:
        imax=n-1
        f(2,n-1)=2.0_fp*f(4,n-2)+f(4,n-1)
        f(3,n-1)=f(3,n-1)*f(4,n-2)/(f(4,n-1)+f(4,n-2))
     end if
     IF(i_bc1.eq.-1) THEN
        !Solve system of equations for second derivatives at the knots
        !  Periodic BC
        !    Forward elimination
        DO i=2,n-2
           t=f(4,i-1)/f(2,i-1)
           f(2,i)=f(2,i)-t*f(4,i-1)
           f(3,i)=f(3,i)-t*f(3,i-1)
           wk(i)=wk(i)-t*wk(i-1)
           q=wk(n-1)/f(2,i-1)
           wk(n-1)=-q*f(4,i-1)
           f(2,n-1)=f(2,n-1)-q*wk(i-1)
           f(3,n-1)=f(3,n-1)-q*f(3,i-1)
        end do
        !    Correct the n-1 element
        wk(n-1)=wk(n-1)+f(4,n-2)
        !    Complete the forward elimination
        !    wk(n-1) and wk(n-2) are the off-diag elements of the lower corner
        t=wk(n-1)/f(2,n-2)
        f(2,n-1)=f(2,n-1)-t*wk(n-2)
        f(3,n-1)=f(3,n-1)-t*f(3,n-2)
        !    Back substitution
        f(3,n-1)=f(3,n-1)/f(2,n-1)
        f(3,n-2)=(f(3,n-2)-wk(n-2)*f(3,n-1))/f(2,n-2)
        DO ib=3,n-1
           i=n-ib
           f(3,i)=(f(3,i)-f(4,i)*f(3,i+1)-wk(i)*f(3,n-1))/f(2,i)
        end do
        f(3,n)=f(3,1)
     ELSE
        !  Non-periodic BC
        !    Forward elimination
        !    For Not-A-Knot BC the off-diagonal end elements are not equal
        DO i=imin+1,imax
           IF((i.eq.n-1).and.(imax.eq.n-1)) THEN
              t=(f(4,i-1)-f(4,i))/f(2,i-1)
           ELSE
              if(i.eq.2) then
                 t=elem21/f(2,i-1)
              else if(i.eq.n) then
                 t=elemnn1/f(2,i-1)
              else
                 t=f(4,i-1)/f(2,i-1)
              end if
           end if
           IF((i.eq.imin+1).and.(imin.eq.2)) THEN
              f(2,i)=f(2,i)-t*(f(4,i-1)-f(4,i-2))
           ELSE
              f(2,i)=f(2,i)-t*f(4,i-1)
           end if
           f(3,i)=f(3,i)-t*f(3,i-1)
        end do
        !    Back substitution
        f(3,imax)=f(3,imax)/f(2,imax)
        DO ib=1,imax-imin
           i=imax-ib
           IF((i.eq.2).and.(imin.eq.2)) THEN
              f(3,i)=(f(3,i)-(f(4,i)-f(4,i-1))*f(3,i+1))/f(2,i)
           ELSE
              f(3,i)=(f(3,i)-f(4,i)*f(3,i+1))/f(2,i)
           end if
        end do
        !    Reset d array to step size
        f(4,1)=x(2)-x(1)
        f(4,n-1)=x(n)-x(n-1)
        !    Set f(3,1) for not-a-knot
        IF(i_bc1.le.0.or.i_bc1.gt.7) THEN
           f(3,1)=(f(3,2)*(f(4,1)+f(4,2))-f(3,3)*f(4,1))/f(4,2)
        end if
        !    Set f(3,n) for not-a-knot
        IF(i_bcn.le.0.or.i_bcn.gt.7) THEN
           f(3,n)=f(3,n-1)+(f(3,n-1)-f(3,n-2))*f(4,n-1)/f(4,n-2)
        end if
     end if
     !f(3,i) is now the sigma(i) of the text and f(4,i) is the step size
     !Compute polynomial coefficients
     DO i=1,n-1
        f(2,i)=(f(1,i+1)-f(1,i))/f(4,i)-f(4,i)*(f(3,i+1)+2.0_fp*f(3,i))
        f(4,i)=(f(3,i+1)-f(3,i))/f(4,i)
        f(3,i)=6.0_fp*f(3,i)
        f(4,i)=6.0_fp*f(4,i)
     end do
     IF(i_bc1.eq.-1) THEN
        f(2,n)=f(2,1)
        f(3,n)=f(3,1)
        f(4,n)=f(4,1)
     ELSE
        hn=x(n)-x(n-1)
        f(2,n)=f(2,n-1)+hn*(f(3,n-1)+0.5_fp*hn*f(4,n-1))
        f(3,n)=f(3,n-1)+hn*f(4,n-1)
        f(4,n)=f(4,n-1)
        IF(i_bcn.eq.1.or.i_bcn.eq.3.or.i_bcn.eq.5) THEN
           f(2,n)=an
        ELSE IF(i_bcn.eq.2.or.i_bcn.eq.4.or.i_bcn.eq.6) THEN
           f(3,n)=bn
        end if
     end if
  end if
  RETURN
END subroutine v_spline

subroutine akherm1(x,nx,fherm,ilinx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on Akima's method
  !  [Hiroshi Akima, Communications of the ACM, Jan 1974, Vol. 17 No. 1]
  !
  !  1d routine -- default boundary condition (based on divided differences)
  !
  !  input:
  !
  !============
  implicit none
  integer ier,ilinx
  !============
  integer nx                        ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: fherm(0:1,nx)                ! data/Hermite array
  !
  !  fherm(0,i) = function value f at x(i)       **on input**
  !
  !  fherm(1,i) = derivative df/dx at x(i)       **on output**
  !
  ! addl output:
  !  ilinx=1 if x is "evenly spaced" ier=0 if no errors
  !
  !  ** x must be strict ascending **
  !
  ! work by calling akherm1p; no periodic boundary condition
  !
  call akherm1p(x,nx,fherm,ilinx,0,ier)
  !
  return
end subroutine akherm1
!----------------------------
subroutine akherm1p(x,nx,fherm,ilinx,ipx,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  Akima subroutine with boundary condition option:
  !
  !  =>ipx=1 for periodic boundary condition
  !
  !  =>ipx=2 for user specified boundary condition:
  !    in which case fherm(1,1) and fherm(1,nx) must contain
  !    the derivatives fx(x(1)) and fx(x(nx)), respectively, and these
  !    will not be modified on output.
  !
  !  =>ipx=0: default boundary conditions
  !
  !  other arguments as with akherm1.
  !
  !  input:
  !
  !============
  implicit none
  integer ier,ilinx,ierbc,ix,ixm2,ixm1,ixmm2,ixmm1,ixp2,ixp1
  integer ixpp2,ixpp1
  !============
  real(fp) :: ztol,cxp,cxm,cxpp,cxmm,cxtrap0,cxtrap1
  !============
  integer nx                        ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: fherm(0:1,nx)                ! data/Hermite array
  integer ipx                       ! =1:  f' periodic in x
  !
  !----------------------------
  !
  real(fp) :: wx(2)
  !
  !  error checks...
  !
  ztol=1.0E-3_fp
  ier=0
  !
  call splinck(x,nx,ilinx,ztol,ier)
  if(ier.ne.0) then
     write(6,*) '?akherm1:  x axis not strict ascending.'
     ier=ier+1
  end if
  !
  ierbc=0
  call ibc_ck(ipx,'akherm1','Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  if(ier.gt.0) return
  !
  !  deal with boundary region.  The boundary derivatives are set
  !  and "ghost" points are provided...
  !
  !  all paths need the 1st div. diffs at the bdy...
  !
  cxp=(fherm(0,2)-fherm(0,1))/(x(2)-x(1))
  cxm=(fherm(0,nx)-fherm(0,nx-1))/(x(nx)-x(nx-1))
  !
  if(ipx.eq.1) then
     !
     !  periodic BC
     !
     !  LHS/RHS
     !
     if(nx.gt.2) then
        cxpp=(fherm(0,3)-fherm(0,2))/(x(3)-x(2))
        cxmm=(fherm(0,nx-1)-fherm(0,nx-2))/(x(nx-1)-x(nx-2))
        !
        call akherm0(cxmm,cxm,cxp,cxpp,wx,fherm(1,1))
        fherm(1,nx)=fherm(1,1)
     else
        ! nx=2
        fherm(1,1)=cxp  ! =cxm
        fherm(1,nx)=cxm ! =cxp
     end if
     !
     cxtrap0=cxm
     cxtrap1=cxp
     !
  else if(ipx.eq.0) then
     !
     !  default BC -- standard numeric extrapolation
     !
     if(nx.gt.2) then
        cxpp=(fherm(0,3)-fherm(0,2))/(x(3)-x(2))
        fherm(1,1)=1.5_fp*cxp-0.5_fp*cxpp
        !
        cxmm=(fherm(0,nx-1)-fherm(0,nx-2))/(x(nx-1)-x(nx-2))
        fherm(1,nx)=1.5_fp*cxm-0.5_fp*cxmm
        !
     else
        ! nx=2
        fherm(1,1)=cxp  ! =cxm
        fherm(1,nx)=cxm ! =cxp
     end if
     !
     !  extrapolate to slope to ghost points just past bdy...
     !
     cxtrap0=2.0_fp*fherm(1,1)-cxp
     cxtrap1=2.0_fp*fherm(1,nx)-cxm
     !
  else
     !
     !  BC supplied by user.  Also use this for extrapolation...
     !  extrapolate to slope to ghost points just past bdy...
     !
     cxtrap0=2.0_fp*fherm(1,1)-cxp
     cxtrap1=2.0_fp*fherm(1,nx)-cxm
     !
  end if
  !
  ! NOTE: this loop is inactive if nx=2
  !
  do ix=2,nx-1
     !
     !  x div. diffs in vicinity
     !
     ixm2=ix
     ixm1=ixm2-1
     ixmm2=ixm1
     ixmm1=ixm1-1
     !
     ixp2=ix+1
     ixp1=ix
     ixpp2=ix+2
     ixpp1=ixp2
     !
     if(ix.eq.2) then
        cxmm=cxtrap0
     else
        cxmm=(fherm(0,ixmm2)-fherm(0,ixmm1))/(x(ixmm2)-x(ixmm1))
     end if
     !
     if(ix.eq.nx-1) then
        cxpp=cxtrap1
     else
        cxpp=(fherm(0,ixpp2)-fherm(0,ixpp1))/(x(ixpp2)-x(ixpp1))
     end if
     !
     cxm=(fherm(0,ixm2)-fherm(0,ixm1))/(x(ixm2)-x(ixm1))
     cxp=(fherm(0,ixp2)-fherm(0,ixp1))/(x(ixp2)-x(ixp1))
     !
     call akherm0(cxmm,cxm,cxp,cxpp,wx,fherm(1,ix))
     !
  end do
  !
  return
end subroutine akherm1p
!--------------------------------------
subroutine akherm0(cxmm,cxm,cxp,cxpp,wx,slp)
  use iso_c_binding, only: fp => c_double
  !
  !  basic akima formula for 1st derivative at pt p:
  !
  !     cxmm = numerical slope 2 zones to left
  !     cxm  = numerical slope 1 zone to left
  !     cxp  = numerical slope 1 zone to right
  !     cxpp = numerical slope 2 zones to right
  !
  !  return slope at point p and weighting factors
  !
  implicit none
  real(fp) :: cxmm,cxm,cxp,cxpp            ! nearby slopes (in)
  real(fp) :: wx(2)                        ! weights (out)
  real(fp) :: slp                          ! Akima nominal slope (out)
  !
  wx(2)=abs(cxm-cxmm)
  wx(1)=abs(cxp-cxpp)
  if(wx(1)+wx(2).eq.0.0_fp) then
     wx(1)=1.0_fp
     wx(2)=1.0_fp
  end if
  !
  !  the derivative -- weighted average of neighbouring slopes
  !
  slp=(wx(1)*cxm+wx(2)*cxp)/(wx(1)+wx(2))
  !
  return
end subroutine akherm0

!  bpsplinb -- dmc 30 May 1996
!
!  set up coefficients for bicubic spline with following BC's:
!  * LHS and RHS BC under user control (see comments)
!  * derivatives periodic in second coordinate (use pspline.f90)
!
subroutine bpsplinb(x,inx,th,inth,fspl,inf3, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     wk,nwk,ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  implicit none
  integer inx,inth,inf3,nwk
  real(fp) :: x(inx),th(inth),fspl(4,4,inf3,inth),wk(nwk)
  integer ibcxmin,ibcxmax
  real(fp) :: bcxmin(inth),bcxmax(inth)
  !
  !  input:
  !    x(1...inx) -- abscissae, first dimension of data
  !   th(1...inth) -- abscissae, second (periodic) dimension of data
  !   fspl(1,1,1..inx,1..inth) -- function values
  !   inf3 -- fspl dimensioning, inf3.ge.inx required.
  !
  !  boundary conditions input:
  !   ibcxmin -- indicator for boundary condition at x(1):
  !    bcxmin(...) -- boundary condition data
  !     =0 -- use "not a knot", bcxmin(...) ignored
  !     =1 -- match slope, specified at x(1),th(ith) by bcxmin(ith)
  !     =2 -- match 2nd derivative, specified at x(1),th(ith) by bcxmin(ith)
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
  !     =5 -- match 1st derivative to 1st divided difference
  !     =6 -- match 2nd derivative to 2nd divided difference
  !     =7 -- match 3rd derivative to 3rd divided difference
  !           (for more detailed definition of BCs 5-7, see the
  !           comments of subroutine mkspline)
  !   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpolation as with ibcxmin, bcxmin)
  !
  !  output:
  !   fspl(*,*,1..inx,1..inth) -- bicubic spline coeffs (4x4)
  !   ...fspl(1,1,*,*) is not replaced.
  !
  integer ilinx,ilinth,ier
  !
  !   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
  !   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
  !
  !   ier -- completion code, 0 for normal
  !
  !  workspace:
  !   wk -- must be at least 5*max(inx,inth) large
  !  nwk -- size of workspace
  !
  !---------------------------------
  !  compute bicubic spline of 2d function, given values at the grid
  !  grid crossing points, f(1,1,i,j)=f(x(i),th(j)).
  !
  !  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !                       and th btw th(j) and th(j+1), dt=th-th(j),
  !
  !      spline =
  !        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
  !   +dt*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
  !   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
  !   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
  !
  !      where d2=dt**2 and d3=dt**3.
  !
  !---------------------------------
  !
  integer ierx,ierth
  real(fp) :: zdum(1)
  !
  !---------------------------------
  !
  ier=0
  if(nwk.lt.5*max(inx,inth)) then
     write(6,'('' ?bpsplinb:  workspace too small.'')')
     ier=1
  end if
  if(inx.lt.2) then
     write(6,'('' ?bpsplinb:  at least 2 x points required.'')')
     ier=1
  end if
  if(inth.lt.2) then
     write(6,'('' ?bpsplinb:  need at least 2 theta points.'')')
     ier=1
  end if
  !
  call ibc_ck(ibcxmin,'bcspline','xmin',0,7,ier)
  call ibc_ck(ibcxmax,'bcspline','xmax',0,7,ier)
  !
  !  check ilinx & x vector
  !
  call splinck(x,inx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?bpsplinb:  x axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(th,inth,ilinth,1.0E-3_fp,ierth)
  if(ierth.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?bpsplinb:  th axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  zdum=0.0_fp
  !
  call bcspline(x,inx,th,inth,fspl,inf3, &
       ibcxmin,bcxmin,ibcxmax,bcxmax, &
       -1,zdum,-1,zdum, &
       wk,nwk,ilinx,ilinth,ier)
  !
end subroutine bpsplinb

c------------------------------------------------------------/usr$trnlog
C
C  ADAPTED FROM SGLIB "usr$trnlog" ROUTINE -- DMC 6 SEP 1991
C   FOR "VAXONLY" LIBRARY IN CMSMMS SYSTEM
C
C  UNIX code is added -- substitute concept of environment
C  variable translation for concept of logical name translation
C  DMC Oct 1991
C
      subroutine UTRNLOG(table,loglnam,physnam,lphys,istat)
c
#ifdef __NAGWARE
      use f90_unix_env
#endif
c
c  translate logical name to physical name
c
c  arguments:
      character*(*) table	!table to search
      character*(*) loglnam	!logical name to be translated
      character*(*) physnam	!(return) physical name
      integer       lphys	!(return) length of physical name
      integer       istat	!(return) status code
C
C  ISTAT=1 DENOTES SUCCESS
C
C  on UNIX system:
C   table is ignored
C   loglnam is the environment variable name
C   physnam is the value returned
C   lphys is the length w/o trailing blanks of the value returned
C   istat is 1 unless lphys=0, in which case istat is 2 on exit.
C
C-----------------------------------------------------------------------
C  VAX ONLY CODE:
C
c  local variables:
      integer str_length
c
#ifdef __VMS
      include '($LNMDEF)'     ! VAX-ONLY CODE
c
      integer sys$trnlnm	!replaced sys$trnlog
      character*64 holdnam
      character*16 ttabl
      integer*4 lhold		!length of logical name
      integer*4 kattr		!string attributes
c
      structure /itmlst/
        integer*2 att_leng /4/	!length
        integer*2 att_code /lnm$_attributes/	!code
        integer*4 att_addr /0/
        integer*4 att_desc /0/
        integer*2 str_leng /64/	!length
        integer*2 str_code /lnm$_string/	!code
        integer*4 str_addr /0/
        integer*4 str_desc /0/
        integer*4 lnm_end  /0/
      endstructure
      record /itmlst/ trn
      logical more
c
c-----------------------------------------------------------------------
c
      ttabl = table			!set table name for translation
      if(ttabl.eq.' ') ttabl = 'LNM$FILE_DEV'
      ltabl = STR_LENGTH(ttabl)
      holdnam = loglnam		!copy logical name to local
      lhold = STR_LENGTH(holdnam)	!get length
c
      trn.att_addr=%loc(kattr)	!first item returns attributes
      trn.str_addr=%loc(physnam)	!second item returns name
      trn.str_desc=%loc(lphys)
      physnam=' '
      lphys=0
      istat=0
      more=.true.
c
      do while (more)
        igood = sys$trnlnm(lnm$m_case_blind,ttabl(1:ltabl),
     >		holdnam(1:lhold),,trn)
        if(istat.eq.0) istat=igood	!return status from first trans
c
        if(igood) then		!if success
          holdnam = physnam(1:lphys)	!set up to iterate
          lhold = lphys
          if((kattr.and.lnm$m_terminal).ne.0) more=.false.
        else
          more=.false.
        endif
      enddo
c	  	  	  	  check for process perm file
      if(ichar(physnam(1:1)) .eq. '1b'x) then
        physnam = physnam(5:lphys)	 !adjust length
        lphys = lphys - 4
      endif
c
      continue	    ! END VAX ONLY CODE
#endif
C-----------------------------------------------------------------------
C  UNIX CODE:
C
#ifdef __UNIX
      ist=1
      if(loglnam(1:1).eq.'$') ist=2
      call mpi_sget_env(loglnam(ist:),physnam,iertmp)
      lphys=STR_LENGTH(physnam)
      if(lphys.eq.0) then
        istat=2
      else
        istat=1
      endif
#endif
C
      return
C
      end

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Initialization of ezspline

#include "cpp/czspline_handle_size.h"

#define _S czspline_init1
#define _O czspline1
  subroutine _S(handle, n1, BCS1, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1
    integer, intent(in) :: BCS1(2)
    integer, intent(out) :: ier
    type(_O) :: self
    allocate(self % ptr)
    call ezspline_init(self % ptr, n1, BCS1, ier)
    handle = 0
    handle = transfer(self, handle)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_init2
#define _O czspline2
  subroutine _S(handle, n1, n2, BCS1, BCS2, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1, n2
    integer, intent(in) :: BCS1(2), BCS2(2)
    integer, intent(out) :: ier
    type(_O) :: self
    allocate(self % ptr)
    call ezspline_init(self % ptr, n1, n2, BCS1, BCS2, ier)
    handle = 0
    handle = transfer(self, handle)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_init3
#define _O czspline3
  subroutine _S(handle, n1, n2, n3, BCS1, BCS2, BCS3, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1, n2, n3
    integer, intent(in) :: BCS1(2), BCS2(2), BCS3(2)
    integer, intent(out) :: ier
    type(_O) :: self
    allocate(self % ptr)
    call ezspline_init(self % ptr, n1, n2, n3, BCS1, BCS2, BCS3, ier)
    handle = 0
    handle = transfer(self, handle)
  end subroutine _S
#undef _S
#undef _O

subroutine EZlinear_init1(spline_o, n1, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: n1
  ! ier:
  ! 0=ok
  ! 1=allocation error
  ! 99=something strange happened in EZlinear_init
  integer, intent(out) :: ier
  integer i, iok

  ier = 0

  if(EZspline_allocated(spline_o)) then
     ier = 100  ! allocated already
     return
  else
     call EZspline_preInit(spline_o)
  end if

  spline_o%n1 = n1

  spline_o%klookup1 = 3    ! default lookup algorithm selection

  spline_o%isHermite = 0 ! no Hermite interpolation; this is EZlinear_init
  spline_o%isLinear  = 1 ! piecewise linear interpolation

  iok = 0
  allocate(spline_o%x1(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%fspl(1,n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x1pkg(n1, 4), stat=iok)
  if(iok /= 0) ier = 1

  ! default grid
  spline_o%x1min = 0.0_fp
  spline_o%x1max = 1.0_fp

  spline_o%x1 = spline_o%x1min + (spline_o%x1max - spline_o%x1min)* &
       & (/ (real(i-1,fp)/real(spline_o%n1-1, fp), i=1,spline_o%n1 ) /)

  spline_o%isReady = 0

  return
end subroutine EZlinear_init1



subroutine EZlinear_init2(spline_o, n1, n2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: n1, n2
  ! ier:
  ! 0=ok
  ! 1=allocation error
  ! 99=something strange happened in EZlinear_init
  integer, intent(out) :: ier
  integer i, iok

  ier = 0

  if(EZspline_allocated(spline_o)) then
     ier = 100  ! allocated already
     return
  else
     call EZspline_preInit(spline_o)
  end if

  spline_o%n1 = n1
  spline_o%n2 = n2

  spline_o%klookup1 = 3    ! default lookup algorithm selection
  spline_o%klookup2 = 3    ! default lookup algorithm selection

  spline_o%isHermite = 0 ! no Hermite interpolation; this is EZlinear_init
  spline_o%isLinear  = 1 ! piecewise linear interpolation
  spline_o%isHybrid  = 0
  spline_o%hspline = 0

  iok = 0
  allocate(spline_o%x1(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%fspl(1,n1,n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1min(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1max(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2min(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2max(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x1pkg(n1, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2pkg(n2, 4), stat=iok)
  if(iok /= 0) ier = 1

  ! default grid
  spline_o%x1min = 0.0_fp
  spline_o%x1max = 1.0_fp

  spline_o%x1 = spline_o%x1min + (spline_o%x1max - spline_o%x1min)* &
       & (/ (real(i-1,fp)/real(spline_o%n1-1, fp), i=1,spline_o%n1 ) /)
  spline_o%x2min = 0.0_fp
  spline_o%x2max = 1.0_fp
  spline_o%x2 = spline_o%x2min + (spline_o%x2max - spline_o%x2min)* &
       & (/ (real(i-1,fp)/real(spline_o%n2-1, fp), i=1,spline_o%n2 ) /)

  spline_o%isReady = 0

  return
end subroutine EZlinear_init2




subroutine EZlinear_init3(spline_o, n1, n2, n3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: n1, n2, n3
  ! ier:
  ! 0=ok
  ! 1=allocation error
  ! 99=something strange happened in EZlinear_init
  integer, intent(out) :: ier
  integer i, iok

  ier = 0

  if(EZspline_allocated(spline_o)) then
     ier = 100  ! allocated already
     return
  else
     call EZspline_preInit(spline_o)
  end if

  spline_o%n1 = n1
  spline_o%n2 = n2
  spline_o%n3 = n3

  spline_o%klookup1 = 3    ! default lookup algorithm selection
  spline_o%klookup2 = 3    ! default lookup algorithm selection
  spline_o%klookup3 = 3    ! default lookup algorithm selection

  spline_o%isHermite = 0 ! no Hermite interpolation; this is EZlinear_init
  spline_o%isLinear  = 1 ! piecewise linear interpolation
  spline_o%isHybrid  = 0
  spline_o%hspline = 0

  iok = 0
  allocate(spline_o%x1(n1), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2(n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x3(n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%fspl(1,n1,n2,n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1min(n2, n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval1max(n2, n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2min(n1, n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval2max(n1, n3), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval3min(n1, n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%bcval3max(n1, n2), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x1pkg(n1, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x2pkg(n2, 4), stat=iok)
  if(iok /= 0) ier = 1
  allocate(spline_o%x3pkg(n3, 4), stat=iok)
  if(iok /= 0) ier = 1

  ! default grid
  spline_o%x1min = 0.0_fp
  spline_o%x1max = 1.0_fp
  spline_o%x1 = spline_o%x1min + (spline_o%x1max - spline_o%x1min)* &
       & (/ (real(i-1,fp)/real(spline_o%n1-1, fp), i=1,spline_o%n1 ) /)

  spline_o%x2min = 0.0_fp
  spline_o%x2max = 1.0_fp
  spline_o%x2 = spline_o%x2min + (spline_o%x2max - spline_o%x2min)* &
       & (/ (real(i-1,fp)/real(spline_o%n2-1, fp), i=1,spline_o%n2 ) /)

  spline_o%x3min = 0.0_fp
  spline_o%x3max = 1.0_fp
  spline_o%x3 = spline_o%x3min + (spline_o%x3max - spline_o%x3min)* &
       & (/ (real(i-1,fp)/real(spline_o%n3-1, fp), i=1,spline_o%n3 ) /)

  spline_o%isReady = 0

  return
end subroutine EZlinear_init3

  subroutine lunck( lunmsg, lun, lun2 )
  !.. lunck                            print lun / file association 
  !                                    codesys/source/portlib/lunck.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  11Nov2011
  !  Modifications
  !
  !  1.00  11Nov2011                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  use logmod
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  integer, intent(in)                :: lunmsg      &  ! write to , -1 => infolog
                                       ,lun            ! unit to examine
  integer, intent(in), optional      :: lun2           ! .. lun to lun2, if present
  !
  !..local
  integer                            :: ilun        &  ! loop index 
                                       ,ilun1,ilun2    !      limits
  logical                            :: connected      ! obvious
  character(len=512)                 :: cbuf           ! output
  !
  character(len=*),parameter         :: cSr='portlib/lunck'
  !----------------------------------::================!.........................|
  !
  ilun1 = max(0, lun )
  if( present(lun2) )                  then
     ilun2 = max( lun2, ilun1 )
                                       else
     ilun2 = ilun1
                                       endif
!
  write(cbuf,'(i4,a,i4)') ilun1,' to ',ilun2
  if( lunmsg > -1 )                    then
     write(lunmsg,*) cSr,trim(cbuf)
                                       else
     call infolog( cSr, trim(cbuf) )
                                       endif
!
  do ilun=ilun1,ilun2
     inquire( ilun, opened=connected )
     if( connected )                   then
       write( cbuf,'(1x,a,i4,a)') 'Lun ',ilun,':'
       inquire(ilun, name=cbuf(11:) )
       if( lunmsg > -1 )            then
         write(lunmsg, * )  trim(cbuf)
                                    else
         call infolog( trim(cbuf) )
                                    endif
                                        endif
  enddo
!
  end subroutine lunck

subroutine tcspgrid( &
     x_newgrid,nx_new,y_newgrid,ny_new,z_newgrid,nz_new, &
     f_new,if1,if2, &
     nx,xpkg,ny,ypkg,nz,zpkg,fspl,inf4,inf5,iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  regrid a spline function f defined vs. x,y,z as in xpkg,ypkg,zpkg
  !  to a new grid, given by x_newgrid, y_newgrid, z_newgrid
  !
  !  set warning flag if the range of x_newgrid or y_newgrid or z_newgrid
  !   exceeds the range of the original xpkg or ypkg or zpkg.
  !
  !  (xpkg,ypkg,zpkg arrays  -- axis data, see genxpkg subroutine)
  !
  !  input:
  !
  !============
  implicit none
  integer ny_new,nz_new,nx_new,iz,iy
  !============
  real(fp) :: x_newgrid(nx_new)            ! new x grid
  real(fp) :: y_newgrid(ny_new)            ! new y grid
  real(fp) :: z_newgrid(nz_new)            ! new z grid
  !
  !  output:
  !
  integer if1,if2                   ! 1st dimensions of f_new
  real(fp) :: f_new(if1,if2,nz_new)        ! f evaluated on this grid
  !
  !  input:
  !
  integer nx                        ! size of old grid
  real(fp) :: xpkg(nx,4)                   ! old grid "package"
  integer ny                        ! size of old grid
  real(fp) :: ypkg(ny,4)                   ! old grid "package"
  integer nz                        ! size of old grid
  real(fp) :: zpkg(nz,4)                   ! old grid "package"
  !
  integer inf4                      ! array dimension
  integer inf5                      ! array dimension
  real(fp) :: fspl(4,4,4,inf4,inf5,nz)     ! spline coefficients of f
  !
  !  output:
  !  condition codes, =0 for normal exit
  !
  integer iwarn                     ! =1 if new grid points out of range
  integer ier                       ! =1 if there is an argument error
  !
  !--------------------------------------------
  !  local
  !
  real(fp) :: ytmp(nx_new),ztmp(nx_new)
  integer ict(10)
  !
  data ict/1,0,0,0,0,0,0,0,0,0/
  !
  !--------------------------------------------
  !
  do iz=1,nz_new
     ztmp=y_newgrid(iz)
     do iy=1,ny_new
        ytmp=y_newgrid(iy)
        call tcspvec(ict,nx_new,x_newgrid,ytmp,ztmp, &
             nx_new,f_new(1,iy,iz), &
             nx,xpkg,ny,ypkg,nz,zpkg,fspl,inf4,inf5,iwarn,ier)
     end do
  end do
  !
  return
end subroutine tcspgrid

!
!  bcspeval -- eval bicubic spline function and/or derivatives
!
subroutine bcspeval(xget,yget,iselect,fval, &
     x,nx,y,ny,ilinx,iliny,f,inf3,ier)
  use iso_c_binding, only: fp => c_double
  !
  implicit none
  integer iselect(6)
  integer ilinx,iliny,nx,ny,inf3,ier
  !
  real(fp) :: xget,yget
  real(fp) :: fval(*)
  real(fp) :: x(nx),y(ny),f(4,4,inf3,ny)
  !
  !  modification -- dmc 11 Jan 1999 -- remove SAVE stmts; break routine
  !    into these parts:
  !
  !    bcspevxy -- find grid cell of target pt.
  !    bcspevfn -- evaluate function using output of bcpsevxy
  !
  !    in cases where multiple functions are defined on the same grid,
  !    time can be saved by using bcspevxy once and then bcspevfn
  !    multiple times.
  !
  !  input:
  !     (xget,yget)   location where interpolated value is desired
  !                   x(1).le.xget.le.x(nx) expected
  !                   y(1).le.yget.le.y(ny) expected
  !
  !     iselect       select desired output
  !
  !                     iselect(1)=1 -- want function value (f) itself
  !                     iselect(2)=1 -- want  df/dx
  !                     iselect(3)=1 -- want  df/dy
  !                     iselect(4)=1 -- want  d2f/dx2
  !                     iselect(5)=1 -- want  d2f/dy2
  !                     iselect(6)=1 -- want  d2f/dxdy
  !
  !              example:  iselect(1)=iselect(2)=iselect(3)=1
  !                            f, df/dx, and df/dy all evaluated
  !                        iselect(4)=iselect(5)=iselect(6)=0
  !                            2nd derivatives not evaluated.
  !
  !                   the number of non zero values iselect(1:6)
  !                   determines the number of outputs...
  !                   see fval (output) description.
  !
  !  new dmc December 2005 -- access to higher derivatives (even if not
  !  continuous-- but can only go up to 3rd derivatives on any one coordinate.
  !     if iselect(1)=3 -- want 3rd derivatives
  !          iselect(2)=1 for d3f/dx3
  !          iselect(3)=1 for d3f/dx2dy
  !          iselect(4)=1 for d3f/dxdy2
  !          iselect(5)=1 for d3f/dy3
  !               number of non-zero values iselect(2:5) gives no. of outputs
  !     if iselect(1)=4 -- want 4th derivatives
  !          iselect(2)=1 for d4f/dx3dy
  !          iselect(3)=1 for d4f/dx2dy2
  !          iselect(4)=1 for d4f/dxdy3
  !               number of non-zero values iselect(2:4) gives no. of outputs
  !     if iselect(1)=5 -- want 5th derivatives
  !          iselect(2)=1 for d5f/dx3dy2
  !          iselect(3)=1 for d5f/dx2dy3
  !               number of non-zero values iselect(2:3) gives no. of outputs
  !     if iselect(1)=6 -- want 6th derivatives
  !          d6f/dx3dy3 -- one value is returned.
  !
  !     x(1...nx)     independent coordinate x, strict ascending
  !     y(1...ny)     independent coordinate y, strict ascending
  !
  !     ilinx  --  =1: flag that x is linearly spaced (avoid search for speed)
  !     iliny  --  =1: flag that y is linearly spaced (avoid search for speed)
  !
  !  **CAUTION** actual even spacing of x, y is NOT CHECKED HERE!
  !
  !
  !     f             the function values (at grid points) and spline coefs
  !
  !  evaluation formula:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !                             and y btw y(j) and y(j+1), dy=y-y(j),
  !
  !      spline value =
  !        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
  !   +dy*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
  !   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
  !   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
  !
  !      where d2=dy**2 and d3=dy**3.
  !
  !  output:
  !      up to 6 elements of fval, ordered as follows:
  !        fval(1)=function value or lowest order derivative requested
  !        fval(2)=next order derivative
  !             etc
  !        the ordering is a subset of the sequence given under the "iselect"
  !        description.
  !
  !      ier = 0 -- successful completion; = 1 -- an error occurred.
  !
  !-------------------------------------------------------------------
  !  local
  !
  integer :: i(1)
  integer :: j(1)
  !
  real(fp) :: dx(1),dy(1)
  !
  !--------------------------
  !
  i(1)=0
  j(1)=0
  !
  call bcspevxy(xget,yget,x,nx,y,ny,ilinx,iliny, &
       i(1),j(1),dx(1),dy(1),ier)
  if(ier.ne.0) return
  !
  call bcspevfn(iselect,1,1,fval,i,j,dx,dy,f,inf3,ny)
  !
  return
end subroutine bcspeval
!
!-------------------------------------------------------------------------
!  bcspevxy -- look up x-y zone
!
!  this is the "first part" of bcspeval, see comments, above.
!
subroutine bcspevxy(xget,yget,x,nx,y,ny,ilinx,iliny, &
     i,j,dx,dy,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nxm,nym,ii,jj
  !============
  real(fp) :: zxget,zyget,zxtol,zytol
  !============
  integer nx,ny                     ! array dimensions
  !
  real(fp) :: xget,yget                    ! target point
  real(fp) :: x(nx),y(ny)                  ! indep. coords.
  !
  integer ilinx                     ! =1:  assume x evenly spaced
  integer iliny                     ! =1:  assume y evenly spaced
  !
  !  output of bcspevxy
  !
  integer i,j                       ! index to cell containing target pt
  real(fp) :: dx,dy                        ! displacement of target pt w/in cell
  ! dx=x-x(i)  dy=y-y(j)
  !
  integer ier                       ! return ier.ne.0 on error
  !
  !------------------------------------
  !
  ier=0
  !
  !  range check
  !
  zxget=xget
  zyget=yget

  if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
     zxtol=4.0E-7_fp*max(abs(x(1)),abs(x(nx)))
     if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
        ier=1
        write(6,1001) xget,x(1),x(nx)
1001    format(' ?bcspeval:  xget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((xget.lt.x(1)-0.5_fp*zxtol).or. &
             (xget.gt.x(nx)+0.5_fp*zxtol)) &
             write(6,1011) xget,x(1),x(nx)
1011    format(' %bcspeval:  xget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(xget.lt.x(1)) then
           zxget=x(1)
        else
           zxget=x(nx)
        end if
     end if
  end if
  if((yget.lt.y(1)).or.(yget.gt.y(ny))) then
     zytol=4.0E-7_fp*max(abs(y(1)),abs(y(ny)))
     if((yget.lt.y(1)-zytol).or.(yget.gt.y(ny)+zytol)) then
        ier=1
        write(6,1002) yget,y(1),y(ny)
1002    format(' ?bcspeval:  yget=',1pe11.4,' out of range ', &
             1pe11.4,' to ',1pe11.4)
     else
        if((yget.lt.y(1)-0.5_fp*zytol).or.(yget.gt.y(ny)+0.5_fp*zytol)) &
             write(6,1012) yget,y(1),y(ny)
1012    format(' %bcspeval:  yget=',1pe15.8,' beyond range ', &
             1pe15.8,' to ',1pe15.8,' (fixup applied)')
        if(yget.lt.y(1)) then
           zyget=y(1)
        else
           zyget=y(ny)
        end if
     end if
  end if
  if(ier.ne.0) return
  !
  !  now find interval in which target point lies..
  !
  nxm=nx-1
  nym=ny-1
  !
  if(ilinx.eq.1) then
     ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
     i=min(nxm, ii)
     if(zxget.lt.x(i)) then
        i=i-1
     else if(zxget.gt.x(i+1)) then
        i=i+1
     end if
  else
     if((1.le.i).and.(i.lt.nxm)) then
        if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
           continue  ! already have the zone
        else
           call zonfind(x,nx,zxget,i)
        end if
     else
        i=nx/2
        call zonfind(x,nx,zxget,i)
     end if
  end if
  !
  if(iliny.eq.1) then
     jj=1+nym*(zyget-y(1))/(y(ny)-y(1))
     j=min(nym, jj)
     if(zyget.lt.y(j)) then
        j=j-1
     else if(zyget.gt.y(j+1)) then
        j=j+1
     end if
  else
     if((1.le.j).and.(j.lt.nym)) then
        if((y(j).le.zyget).and.(zyget.le.y(j+1))) then
           continue  ! already have the zone
        else
           call zonfind(y,ny,zyget,j)
        end if
     else
        j=ny/2
        call zonfind(y,ny,zyget,j)
     end if
  end if
  !
  dx=zxget-x(i)
  dy=zyget-y(j)
  !
  return
end subroutine bcspevxy
!------------------------------------------------------------------------
!  bcspevfn -- OK now evaluate the bicubic spline
!
subroutine bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,f,inf3,ny)
  use iso_c_binding, only: fp => c_double
  !
  !  input:
  !============
  implicit none
  integer ny,iaval,i,j
  !============
  real(fp) :: dx,dy
  !============
  integer ict(6)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate f if ict(1)=0)
  !        ict(2)=1 for df/dx   ""
  !        ict(3)=1 for df/dy   ""
  !        ict(4)=1 for d2f/dx2
  !        ict(5)=1 for d2f/dy2
  !        ict(6)=1 for d2f/dxdy
  !
  !    note:  if ict(1)=-1, evaluate f,d2f/dx2,d2f/dy2,d4f/dx2dy2
  !
  !                   the number of non zero values ict(1:6)
  !                   determines the number of outputs...
  !
  !  new dmc December 2005 -- access to higher derivatives (even if not
  !  continuous-- but can only go up to 3rd derivatives on any one coordinate.
  !     if ict(1)=3 -- want 3rd derivatives
  !          ict(2)=1 for d3f/dx3
  !          ict(3)=1 for d3f/dx2dy
  !          ict(4)=1 for d3f/dxdy2
  !          ict(5)=1 for d3f/dy3
  !               number of non-zero values ict(2:5) gives no. of outputs
  !     if ict(1)=4 -- want 4th derivatives
  !          ict(2)=1 for d4f/dx3dy
  !          ict(3)=1 for d4f/dx2dy2
  !          ict(4)=1 for d4f/dxdy3
  !               number of non-zero values ict(2:4) gives no. of outputs
  !     if ict(1)=5 -- want 5th derivatives
  !          ict(2)=1 for d5f/dx3dy2
  !          ict(3)=1 for d5f/dx2dy3
  !               number of non-zero values ict(2:3) gives no. of outputs
  !     if ict(1)=6 -- want 6th derivatives
  !          d6f/dx3dy3 -- one value is returned.
  !
  integer ivec,ivd                  ! vector dimensioning
  !
  !    ivec-- number of vector pts (spline values to look up)
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                 ! output array
  !
  !    v = index to element in vector;
  !  fval(v,1) = first item requested by ict(...),
  !  fval(v,2) = 2nd item requested,  ...etc...
  !
  !  input:
  integer iv(ivec),jv(ivec)         ! grid cell indices -- vectors
  real(fp) :: dxv(ivec),dyv(ivec)          ! displacements w/in cell -- vectors
  !
  integer inf3                      ! 3rd dimension of f -- .ge. nx
  real(fp) :: f(4,4,inf3,ny)               ! bicubic fcn spline coeffs array
  !
  !  usage example:
  !
  !  1.  for each element (xx(v),yy(v)) in a vector of (x,y) pairs,
  !    find the x and y zone indices and displacements with respect
  !    to the "lower left corner" of the zone; store these in vectors
  !    iv,jv and dxv,dyv.
  !
  !  2.  set ict(1)=0, ict(2)=1, ict(3)=1, the rest zero -- get only
  !      the 1st derivatives.
  !
  !  3.  ivec is the length of the vector; ivd is the 1st dimension
  !      of the array fval to receive the output
  !
  !      real fval(ivd,6)
  !      real xv(ivd),yv(ivd)
  !      integer iv(ivd),jv(ivd)
  !      real dxv(ivd),dyv(ivd)
  !      integer ict(6)
  !
  !      real fspline(4,4,nx,ny)  ! spline coeffs
  !      data ict/0,1,1,0,0,0/    ! this call:  want 1st derivatives
  !                               ! only ... these will be output to
  !                               ! fval(*,1) fval(*,2)
  !      ...
  !      do iv=1,ivec
  !        ...                    ! find indices and displacements
  !      end do
  !      call bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,fspline,nx,ny)
  !
  !-------------------------------------------------------------------
  !  local:
  !
  integer v                         ! vector element index
  !
  !  OK can now do evaluations
  !
  iaval=0  ! fval addressing
  !
  if(ict(1).le.2) then
     if((ict(1).gt.0).or.(ict(1).eq.-1)) then
        !  evaluate f
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                f(1,1,i,j)+dy*(f(1,2,i,j)+dy*(f(1,3,i,j)+dy*f(1,4,i,j))) &
                +dx*(f(2,1,i,j)+dy*(f(2,2,i,j)+dy*(f(2,3,i,j)+dy*f(2,4,i,j))) &
                +dx*(f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j))) &
                +dx*(f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))))))
        end do
     end if
     !
     if((ict(2).gt.0).and.(ict(1).ne.-1)) then
        !  evaluate df/dx
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                f(2,1,i,j)+dy*(f(2,2,i,j)+dy*(f(2,3,i,j)+dy*f(2,4,i,j))) &
                +2.0_fp*dx*( &
                f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j))) &
                +1.5_fp*dx*( &
                f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))) &
                ))
        end do
     end if
     !
     if((ict(3).gt.0).and.(ict(1).ne.-1)) then
        !  evaluate df/dy
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                f(1,2,i,j)+dy*(2.0_fp*f(1,3,i,j)+dy*3.0_fp*f(1,4,i,j)) &
                +dx*(f(2,2,i,j)+dy*(2.0_fp*f(2,3,i,j)+dy*3.0_fp*f(2,4,i,j)) &
                +dx*(f(3,2,i,j)+dy*(2.0_fp*f(3,3,i,j)+dy*3.0_fp*f(3,4,i,j)) &
                +dx*(f(4,2,i,j)+dy*(2.0_fp*f(4,3,i,j)+dy*3.0_fp*f(4,4,i,j)) &
                )))
        end do
     end if
     !
     if((ict(4).gt.0).or.(ict(1).eq.-1)) then
        !  evaluate d2f/dx2
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                2.0_fp*( &
                f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j)))) &
                +6.0_fp*dx*( &
                f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))))
        end do
     end if
     !
     if((ict(5).gt.0).or.(ict(1).eq.-1)) then
        !  evaluate d2f/dy2
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                2.0_fp*f(1,3,i,j)+6.0_fp*dy*f(1,4,i,j) &
                +dx*(2.0_fp*f(2,3,i,j)+6.0_fp*dy*f(2,4,i,j) &
                +dx*(2.0_fp*f(3,3,i,j)+6.0_fp*dy*f(3,4,i,j) &
                +dx*(2.0_fp*f(4,3,i,j)+6.0_fp*dy*f(4,4,i,j))))
        end do
     end if
     !
     if((ict(6).gt.0).and.(ict(1).ne.-1)) then
        !  evaluate d2f/dxdy
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                f(2,2,i,j)+dy*(2.0_fp*f(2,3,i,j)+dy*3.0_fp*f(2,4,i,j)) &
                +2._fp*dx*(f(3,2,i,j)+dy*(2.0_fp*f(3,3,i,j)+dy*3.0_fp*f(3,4,i,j)) &
                +1.5_fp*dx*(f(4,2,i,j)+dy*(2.0_fp*f(4,3,i,j)+dy*3.0_fp*f(4,4,i,j)) &
                ))
        end do
     end if
     !
     if(ict(1).eq.-1) then
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                4.0_fp*f(3,3,i,j)+12.0_fp*dy*f(3,4,i,j) &
                +dx*(12.0_fp*f(4,3,i,j)+36.0_fp*dy*f(4,4,i,j))
        end do
     end if
     !
     !-----------------------------------
     !  access to 3rd derivatives
     !
  else if(ict(1).eq.3) then
     if(ict(2).eq.1) then
        !  evaluate d3f/dx3 (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                +6.0_fp*( &
                f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))))
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d3f/dx2dy
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                2.0_fp*( &
                f(3,2,i,j)+dy*(2.0_fp*f(3,3,i,j)+dy*3.0_fp*f(3,4,i,j))) &
                +6.0_fp*dx*( &
                f(4,2,i,j)+dy*(2.0_fp*f(4,3,i,j)+dy*3.0_fp*f(4,4,i,j)))
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d3f/dxdy2
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                (2.0_fp*f(2,3,i,j)+6.0_fp*dy*f(2,4,i,j) &
                +2.0_fp*dx*(2.0_fp*f(3,3,i,j)+6.0_fp*dy*f(3,4,i,j) &
                +1.5_fp*dx*(2.0_fp*f(4,3,i,j)+6.0_fp*dy*f(4,4,i,j)) &
                ))
        end do
     end if

     if(ict(5).eq.1) then
        !  evaluate d3f/dy3 (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           fval(v,iaval)=6.0_fp*(f(1,4,i,j)+ &
                dx*(f(2,4,i,j)+dx*(f(3,4,i,j)+dx*f(4,4,i,j))))
        end do
     end if
     !
     !-----------------------------------
     !  access to 4th derivatives
     !
  else if(ict(1).eq.4) then
     if(ict(2).eq.1) then
        !  evaluate d4f/dx3dy (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                +6.0_fp*( &
                f(4,2,i,j)+dy*2.0_fp*(f(4,3,i,j)+dy*1.5_fp*f(4,4,i,j)))
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d4f/dx2dy2
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                4.0_fp*f(3,3,i,j)+12.0_fp*dy*f(3,4,i,j) &
                +dx*(12.0_fp*f(4,3,i,j)+36.0_fp*dy*f(4,4,i,j))
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d4f/dxdy3 (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           fval(v,iaval)= &
                6.0_fp*(f(2,4,i,j) &
                +2.0_fp*dx*(f(3,4,i,j)+1.5_fp*dx*f(4,4,i,j)))
        end do
     end if
     !
     !-----------------------------------
     !  access to 5th derivatives
     !
  else if(ict(1).eq.5) then
     if(ict(2).eq.1) then
        !  evaluate d5f/dx3dy2 (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dy=dyv(v)
           fval(v,iaval)= &
                +12.0_fp*(f(4,3,i,j)+dy*3.0_fp*f(4,4,i,j))
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d5f/dx3dy2 (not continuous)
        iaval=iaval+1
        do v=1,ivec
           i=iv(v)
           j=jv(v)
           dx=dxv(v)
           fval(v,iaval)= &
                12.0_fp*(f(3,4,i,j)+dx*3.0_fp*f(4,4,i,j))
        end do
     end if
     !
     !-----------------------------------
     !  access to 6th derivatives
     !
  else if(ict(1).eq.6) then
     !  evaluate d6f/dx3dy3 (not continuous)
     iaval=iaval+1
     do v=1,ivec
        i=iv(v)
        j=jv(v)
        fval(v,iaval)= &
             36.0_fp*f(4,4,i,j)
     end do
  end if
  !
  return
end subroutine bcspevfn
!----------------------

#define BUFSIZ 300
!
      subroutine gmkdir(root_in,rpath_in,ier)
!
!  make a multi-level subdirectory starting from root
!
!  unix example:  call gmkdir('HOME','.cache/sub1/sub2/sub3',ier)
!    => $HOME/.cache/sub1/sub2/sub3 directory is created (if it does
!       not already exist).  Each higher level directory is also created
!       as needed.
!
!  vms example:  call gmkdir('SYS$LOGIN','[zcache.sub1.sub2.sub3]',ier)
!    => subdirectory chain [zcache.sub1.sub2.sub3] is created under the
!       user's login directory (SYS$LOGIN) -- each subdirectory level is
!       created as needed.
!
      implicit NONE
!
!  input:
!
      character*(*) root_in             ! root -- start point (must exist)
      character*(*) rpath_in            ! subdirectory chain
!
!  output:
      integer ier                       ! error code, 0 = OK
!
!-------------------------------------------------------------
!
      character*BUFSIZ start
      character*BUFSIZ next
!
      character*250 root,rpath
!
!  DMC -- procedure to check directories /u & /p can be unreliable
!  and is not needed.  If ' ' is passed for root, start check a 
!  little further down the path than "/".
!
      integer, parameter :: iroot_param_srch = 6
      integer :: ii,istat
!
      character*512 zcmd
!-------------------------------------------------------------
!
      if(root_in.ne.' ') then
         root = root_in
         rpath = rpath_in
      else
         if(rpath_in(1:1).eq.'/') then
            do ii=iroot_param_srch,1,-1
               if(rpath_in(ii:ii).eq.'/') then
                  root=rpath_in(1:ii)
                  rpath=rpath_in(ii+1:)
                  exit
               endif
            enddo
         else if(rpath_in(1:1).eq.'~') then
            if(rpath_in(2:2).eq.'/') then
               root='HOME'
               rpath=rpath_in(3:)
            else
               ! (I don't think this can work: ~<username>)
               root=' '
               rpath = rpath_in
            endif
         else
            call sget_cwd(root)
            rpath = rpath_in    ! path relative to $cwd
         endif
      endif

!!      write(0,*) ' ** root_in = "',trim(root_in),'"'
!!      write(0,*) ' ** rpath_in = "',trim(rpath_in),'"'
!!      write(0,*) ' ** root = "',trim(root),'"'
!!      write(0,*) ' ** rpath = "',trim(rpath),'"'

      ier=0
      call gmkdir_init(root,start,rpath,next)

!!      write(0,*) ' gmkdir_init: '
!!      write(0,*) '   root = "',trim(root),'"'
!!      write(0,*) '   start = "',trim(start),'"'
!!      write(0,*) '   rpath = "',trim(rpath),'"'
!!      write(0,*) '   next = "',trim(next),'"'

 10   continue
      if((ier.eq.0).and.(next.ne.' ')) then
         call gmkdir_next(start,next,ier)

!!!         write(0,*) ' gmkdir_next: '
!!!         write(0,*) '   start = "',trim(start),'"'
!!!         write(0,*) '   next = "',trim(next),'"'
!!!         write(0,*) '   ier = ',ier

         go to 10
      endif
!
      return
      end
!
!-------------------------------------------------------------
!
      subroutine gmkdir_init(root,start,rpath,next)
!
      implicit NONE
!
      character*(*) root                ! root (as passed)
      character*(*) start               ! starting directory (standardized)
!
      character*(*) rpath               ! relative path (as passed)
      character*(*) next                ! starting rel. path (standardized)
!-------------
      integer str_length
      integer :: iclen,ic,ic1,ic2,istat,iplen,io
!
      character*BUFSIZ ztest
      character*15 cpid
      character*30 tmpfile
!---------------------------------
!
      start=' '
      next=' '
!
#ifdef __UNIX
!
!  root directory...
!
      call sget_pid_str(cpid,iplen)
      tmpfile = 'gmkdir_'//cpid(1:iplen)//'.tmp'
!
      if(root.ne.' ') call ufilnam(root,' ',start)
!
!  relative path from there...
!
      iclen=str_length(rpath)
!
!  does requested directory already exist?
!
      call find_io_unit(io)
!
      ztest = trim(start)//'/'//trim(rpath)//'/'//trim(tmpfile)
      open(unit=io,file=trim(ztest),status='unknown',iostat=istat)
      if(istat.eq.0) then
                                !  open successful; directory must exist.
         close(unit=io,status='delete',iostat=istat)
         start = trim(start)//'/'//trim(rpath)
         next = ' '
         return
      endif
!
!  work up through rpath parents...
!
      ic=iclen
      do
         ic=ic-1
         if(ic.le.0) exit
         if(rpath(ic:ic).ne.'/') cycle

         ztest = trim(start)//'/'//rpath(1:ic)//'/'//trim(tmpfile)
         open(unit=io,file=trim(ztest),status='unknown',iostat=istat)
         if(istat.eq.0) then
                                !  open successful; directory must exist.
            close(unit=io,status='delete',iostat=istat)
            start = trim(start)//'/'//rpath(1:ic)
            next = rpath(ic+1:)
            return
         endif
      enddo
!
!  try start directory
!
      ztest = trim(start)//'/'//trim(tmpfile)
      open(unit=io,file=trim(ztest),status='unknown',iostat=istat)
      if(istat.eq.0) then
                                !  open successful; directory must exist.
         close(unit=io,status='delete',iostat=istat)
         next=rpath
         return
      endif
!
!  this code reached if directory path (start) is not fully in place.
!  (this would be unusual).
!
      ic=0
 10   continue
      ic=ic+1
      if(ic.gt.iclen) go to 1000        ! reached the end
      if((ichar(rpath(ic:ic)).ne.0).and.(rpath(ic:ic).ne.' ').and.
     >   (rpath(ic:ic).ne.'~').and.(rpath(ic:ic).ne.'/')) then
         ic1=ic
      else
         go to 10
      endif
!
      ic=iclen+1
 20   continue
      ic=ic-1
      if(rpath(ic:ic).ne.'/') then
         ic2=ic
      else
         go to 20
      endif
!
      next=rpath(ic1:ic2)
      go to 1000
#endif
!-------------------
#ifdef __VMS
!
!  root directory...
!
      if(root.ne.' ') then
         itest=index(root,'[')
         if(itest.eq.0) itest=index(root,']')
         if(itest.eq.0) itest=index(root,'<')
         if(itest.eq.0) itest=index(root,'>')
         if(itest.ne.0) then
            start=root                  ! use "as is"
            go to 500
         endif
!
!  may be a logical name that has to be translated (e.g. SYS$LOGIN)
!
         iclen=str_length(root)
         ic=0
 110     continue
         ic=ic+1
         if((ichar(root(ic:ic)).ne.0).and.(root(ic:ic).ne.' ')) then
            ic1=ic
         else
            go to 110
         endif
!
         ic2=iclen
         if(root(ic2:ic2).eq.':') ic2=ic2-1
         call mpi_sget_env(root(ic1:ic2),ztest,iertmp)
         if(ztest.eq.' ') then
            start=root                  ! translation failed, use "as is"
         else
            ilz=str_length(ztest)
            if(ilz.gt.2) then
               if(ztest(ilz-1:ilz).eq.'.]') then
                  start=ztest(1:ilz-2)//']' ! rooted name, omit trailing .
               else if(ztest(ilz-1:ilz).eq.'.>') then
                  start=ztest(1:ilz-2)//'>' ! rooted name, omit trailing .
               else
                  start=ztest(1:ilz)    ! use translated value verbatim
               endif
            else
               start=ztest(1:ilz)       ! use translated value verbatim
            endif
         endif
      endif
!
!  relative path subdirectory...
!
 500  continue
      iclen=str_length(rpath)
      ic=0
!
 510  continue
      ic=ic+1
      if(ic.gt.iclen) go to 1000        ! reached the end
      if((ichar(rpath(ic:ic)).ne.0).and.(rpath(ic:ic).ne.' ').and.
     >   (rpath(ic:ic).ne.'[').and.(rpath(ic:ic).ne.'<').and.
     >   (rpath(ic:ic).ne.'.')) then
         ic1=ic
      else
         go to 510
      endif
!
      ic=iclen+1
 520  continue
      ic=ic-1
      if((rpath(ic:ic).ne.']').and.(rpath(ic:ic).ne.'>').and.
     >   (rpath(ic:ic).ne.'.')) then
         ic2=ic
      else
         go to 520
      endif
!
      next=rpath(ic1:ic2)
#endif
 1000 continue
      return
      end
!----------------------------------------------------------------------
!
      subroutine gmkdir_next(start,next,ier)
!
! check the next directory
!
      implicit NONE
!
      character*BUFSIZ start            ! current root
      character*BUFSIZ next             ! current relative path
!
      integer ier
!
!-----------------
#include "fpreproc/byte_declare.h"
!
      integer str_length,cmkdir
      integer :: ils,ilx,inext,ild,iln,istat
!
      character*1 zdelim,zterm
      character*BUFSIZ dirfile,newdir
!
      character*512 zcmd
      byte_declare, dimension(:), allocatable :: cpath
!-----------------
!
#ifdef __UNIX
      zdelim='/'
#else
      zdelim='.'
#endif
!
      ils=str_length(start)
      ilx=str_length(next)
!
      inext=index(next,zdelim)-1
      if(inext.le.0) then
         inext=ilx
      endif
!
      if(start.ne.' ') then
#ifdef __UNIX
         dirfile=start(1:ils)//next(1:inext)
#else
         dirfile=start(1:ils)//next(1:inext)//'.DIR'
         zterm=start(ils:ils)
         newdir=start(1:ils-1)//zdelim//next(1:inext)//zterm
#endif
      else
!
!  blank root
!
#ifdef __UNIX
         dirfile=next(1:inext)
#else
         dirfile=next(1:inext)//'.DIR'
         zterm=']'
         newdir='['//zdelim//next(1:inext)//zterm
#endif
      endif
      ild=str_length(dirfile)
#ifdef __UNIX
      newdir=dirfile(1:ild)//'/'
      ild=ild+1
#endif
      iln=str_length(newdir)
!-------------------------------------------
! make the shell command
!   ...mod DMC: call cmkdir(<path>)
#ifdef __UNIX
      if(allocated(cpath)) deallocate(cpath)
      allocate(cpath(ild+1))
      call cstring(newdir(1:ild),cpath,'2C')
      istat = cmkdir(cpath)
#else
      zcmd='if f$search("'//dirfile(1:ild)//'").eqs."" then $ '//
     >   'create/directory '//newdir(1:ild)
      call execute_command_line(zcmd,exitstat=istat) !VMS
#endif
!
#ifdef __UNIX
      ier=istat
#else
      if(mod(istat,2).ne.1) then
         ier=istat
      else
         ier=0
      endif
#endif
!--------------------------------------------
!  new root and rel. path
!
      start=newdir
      if(inext.lt.ilx) then
         next=next(inext+2:ilx)
      else
         next=' '
      endif
!
      return
      end
 

subroutine util_bcherm2(fherm,idimx1,idimx2, &
     jbcx1a,jbcx1b,   jbcx2a,jbcx2b, &
     zbcx1a,zbcx1b,   zbcx2a,zbcx2b, &
     x1, x2)
  use iso_c_binding, only: fp => c_double

  !...  insert BCs as needed for Hermite interpolation setup


  implicit none
  integer :: idimx1,idimx2  ! array dimensions
  real(fp) :: fherm(0:3,idimx1,idimx2)

  integer :: jbcx1a,jbcx1b  ! x1 BC controls
  real(fp) :: zbcx1a(idimx2)    ! x1(1) BC data
  real(fp) :: zbcx1b(idimx2)    ! x1(idimx1) BC data

  integer :: jbcx2a,jbcx2b  ! x2 BC controls
  real(fp) :: zbcx2a(idimx1)    ! x2(1) BC data
  real(fp) :: zbcx2b(idimx1)    ! x2(idimx2) BC data

  real(fp) :: x1(idimx1),x2(idimx2)

  !-------------------------------------------------------------
  integer :: ix
  real(fp) :: zdx
  !-------------------------------------------------------------

  if((jbcx1a.eq.1).or.(jbcx1b.eq.1)) then

     if(jbcx1a.eq.1) then
        fherm(1,1,1:idimx2)=zbcx1a(1:idimx2)
     else
        zdx = x1(2)-x1(1)
        do ix=1,idimx2
           fherm(1,1,ix)=(fherm(0,2,ix)-fherm(0,1,ix))/zdx
        end do
     end if

     if(jbcx1b.eq.1) then
        fherm(1,idimx1,1:idimx2)=zbcx1b(1:idimx2)
     else
        zdx = x1(idimx1)-x1(idimx1-1)
        do ix=1,idimx2
           fherm(1,idimx1,ix)= &
                (fherm(0,idimx1,ix)-fherm(0,idimx1-1,ix))/zdx
        end do
     end if

  end if

  if((jbcx2a.eq.1).or.(jbcx2b.eq.1)) then

     if(jbcx2a.eq.1) then
        fherm(2,1:idimx1,1)=zbcx2a(1:idimx1)
     else
        zdx=x2(2)-x2(1)
        do ix=1,idimx1
           fherm(2,ix,1)=(fherm(0,ix,2)-fherm(0,ix,1))/zdx
        end do
     end if

     if(jbcx2b.eq.1) then
        fherm(2,1:idimx1,idimx2)=zbcx2b(1:idimx1)
     else
        zdx=x2(idimx2)-x2(idimx2-1)
        do ix=1,idimx1
           fherm(2,ix,idimx2)= &
                (fherm(0,ix,idimx2)-fherm(0,ix,idimx2-1))/zdx
        end do
     end if
  end if

end subroutine util_bcherm2

subroutine text_copy(path1,path2,ierr)

  ! copy a text file (path1) to a new text file (path2).
  !   done line-by-line with fortran I/O, the output file could have
  !   have different trailing white space than the original
  !   **line width limit: 200 characters**

  implicit NONE

  character*(*), intent(in) :: path1  ! file to copy *from*
  character*(*), intent(in) :: path2  ! file to copy *to*

  integer, intent(out) :: ierr  ! completion status, 0=OK
  !  ierr = 1 means: read-access to (path1) failed
  !  ierr = 2 means: write-access to (path2) failed

  !--------------------
  integer :: iluns(2),istat
  character*200 :: line
  !--------------------

  ierr = 0

  call find_io_unit_list(2,iluns)

  open(unit=iluns(1),file=path1,status='old',action='read',iostat=istat)
  if(istat.ne.0) then
     ierr=1
     return
  endif

  open(unit=iluns(2),file=path2,status='unknown',iostat=istat)
  if(istat.ne.0) then
     ierr=2
     close(unit=iluns(1))
     return
  endif

  do
     line=' '
     read(iluns(1),'(A)',end=99) line
     write(iluns(2),'(A)') trim(line)
  enddo

99 continue
  close(unit=iluns(1))
  close(unit=iluns(2))
  return

end subroutine text_copy

!  bcspline -- dmc 30 May 1996
!
!  set up coefficients for bicubic spline with following BC's:
!  FULL BC CONTROL at all bdys
!
!  inhomogeneous explicit BCs -- this means setting of 1st or 2nd
!  derivative at boundary to a non-zero value.
!
!  periodic, not-a-knot, zero derivative, and divided-difference based
!  BCs are "homogeneous"-- i.e. if splines s & t satisfy the BC then
!  the spline (c*s + t) formed as a linear combination of these two
!  splines, also satisfies the BC.
!
!  algorithm note -- handling of inhomogeneous explicit BC's while
!  maintaining full C2 differentiability is delicate.  Basic method:  use
!  a fully C2 method based on the "not-a-knot" BC, and then, correct to
!  meet each user BC by calculating a C2 spline that is zero at all grid
!  points but satisfies a BC which is the difference btw the user spec
!  and the not-a-knot result; add the coeffs of this into the original.
!
!  for this more workspace is needed: nwk .ge. 4*inx*inth +5*max(inx,inth)
!
subroutine bcspline(x,inx,th,inth,fspl,inf3, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcthmin,bcthmin,ibcthmax,bcthmax, &
     wk,nwk,ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inth,inf3,ibcxmin,ibcxmax,ibcthmin,ibcthmax,nwk,ilinx
  integer ilinth,ier,inx,iflg2,ix,itest,ierx,ierth,inxo,ith
  integer intho,ic,ibcthmina,ibcthmaxa,iasc,iinc,iawk,jx,jth,ii
  integer iadr,ia5w,iaspl
  !============
  real(fp) :: xo2,xo6,zhxn,zhth,zdiff1,zdiff2
  !============
  real(fp) :: x(inx),th(inth),fspl(4,4,inf3,inth),wk(nwk)
  real(fp) :: bcxmin(*),bcxmax(*)      ! (inth) if used
  real(fp) :: bcthmin(*),bcthmax(*)    ! (inx) if used
  !
  !  input:
  !    x(1...inx) -- abscissae, first dimension of data
  !   th(1...inth) -- abscissae, second dimension of data  f(x,th)
  !   fspl(1,1,1..inx,1..inth) -- function values
  !   inf3 -- fspl dimensioning, inf3.ge.inx required.
  !
  !  boundary conditions input:
  !   ibcxmin -- indicator for boundary condition at x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- periodic boundary condition
  !     =0 -- use "not a knot", bcxmin(...) ignored
  !     =1 -- match slope, specified at x(1),th(ith) by bcxmin(ith)
  !     =2 -- match 2nd derivative, specified at x(1),th(ith) by bcxmin(ith)
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
  !     =5 -- match 1st derivative df/dx to 1st divided difference
  !     =6 -- match 2nd derivative d2f/dx2 to 2nd divided difference
  !     =7 -- match 3rd derivative d3f/dx3 3rd divided difference
  !           (for more detailed definition of BCs 5-7, see the
  !           comments of subroutine mkspline)
  !   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !   NOTE:  if ibcxmin=-1, ibcxmax is ignored! ...and the BC is periodic.
  !
  !   ibcthmin -- indicator for boundary condition at th(1):
  !    bcthmin(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !   ibcthmax -- indicator for boundary condition at th(inth):
  !    bcthmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !   NOTE:  if ibcthmin=-1, ibcthmax is ignored! ...and the BC is periodic.
  !
  !   NOTE the bcxmin,bcxmax,bcthmin,bcthmax arrays are only used if the
  !     corresponding boundary condition flags are set to 1 or 2.
  !     Carefully note the dimensioning of these arrays!
  !
  !  output:
  !   fspl(*,*,1..inx,1..inth) -- bicubic spline coeffs (4x4)
  !   ...fspl(1,1,*,*) is not replaced.
  !
  !   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
  !   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
  !
  !   ier -- completion code, 0 for normal
  !
  !  workspace:
  !   wk -- must be at least 5*max(inx,inth) large
  !                          5*max(inx,inth) + 4*inx*inth large
  !                          if explicit non-zero d/dth or d2/dth2 BC's
  !                          are supplied.
  !  nwk -- size of workspace of workspace provided
  !
  !---------------------------------
  !  in what follows, "f" is an abbreviation for "fspl"...
  !
  !  compute bicubic spline of 2d function, given values at the grid
  !  grid crossing points, f(1,1,i,j)=f(x(i),th(j)).
  !
  !  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !                       and th btw th(j) and th(j+1), dt=th-th(j),
  !
  !      spline =
  !        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
  !   +dt*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
  !   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
  !   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
  !
  !      where d2=dt**2 and d3=dt**3.
  !
  integer iselect1(10)
  integer iselect2(10)
  !
  real(fp) :: zcur(1)
  !---------------------------------
  !
  !  see if 2nd pass is needed due to "non-linear" d/dth bdy cond.
  !
  iflg2=0
  if(ibcthmin.ne.-1) then
     if((ibcthmin.eq.1).or.(ibcthmin.eq.2)) then
        do ix=1,inx
           if (bcthmin(ix).ne.0.0_fp) iflg2=1
        end do
     end if
     if((ibcthmax.eq.1).or.(ibcthmax.eq.2)) then
        do ix=1,inx
           if (bcthmax(ix).ne.0.0_fp) iflg2=1
        end do
     end if
  end if
  !
  ier=0
  itest=5*max(inx,inth)
  if(iflg2.eq.1) then
     itest=itest +4*inx*inth
  end if
  !
  if(nwk.lt.itest) then
     write(6,9901) nwk,itest
9901 format(' ?bcspline:  workspace too small:'/ &
          '  user supplied:  nwk=',i6,'; need at least:  ',i6/ &
          '  nwk=4*nx*ny +5*max(nx,ny) will work for any user'/ &
          '  choice of bdy conditions.')
     ier=1
  end if
  if(inx.lt.2) then
     write(6,'('' ?bcspline:  at least 2 x points required.'')')
     ier=1
  end if
  if(inth.lt.2) then
     write(6,'('' ?bcspline:  need at least 2 theta points.'')')
     ier=1
  end if
  !
  call ibc_ck(ibcxmin,'bcspline','xmin',-1,7,ier)
  if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'bcspline','xmax',0,7,ier)
  call ibc_ck(ibcthmin,'bcspline','thmin',-1,7,ier)
  if(ibcthmin.ge.0) call ibc_ck(ibcthmax,'bcspline','thmax',0,7,ier)
  !
  !  check ilinx & x vector
  !
  call splinck(x,inx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?bcspline:  x axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(th,inth,ilinth,1.0E-3_fp,ierth)
  if(ierth.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?bcspline:  th axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  !
  xo2=0.5_fp
  xo6=1.0_fp/6.0_fp
  !
  !  spline in x direction
  !
  inxo=4*(inx-1)
  do ith=1,inth
     !
     !  copy the function in
     !
     do ix=1,inx
        wk(4*(ix-1)+1)=fspl(1,1,ix,ith)
     end do
     !
     if(ibcxmin.eq.1) then
        wk(2)=bcxmin(ith)
     else if(ibcxmin.eq.2) then
        wk(3)=bcxmin(ith)
     end if
     !
     if(ibcxmax.eq.1) then
        wk(inxo+2)=bcxmax(ith)
     else if(ibcxmax.eq.2) then
        wk(inxo+3)=bcxmax(ith)
     end if
     !
     !  use Wayne's routine
     !
     call v_spline(ibcxmin,ibcxmax,inx,x,wk,wk(4*inx+1))
     !
     !  copy the coefficients out
     !
     do ix=1,inx
        fspl(2,1,ix,ith)=wk(4*(ix-1)+2)
        fspl(3,1,ix,ith)=wk(4*(ix-1)+3)*xo2
        fspl(4,1,ix,ith)=wk(4*(ix-1)+4)*xo6
     end do
     !
  end do
  !
  !-----------------------------------
  !
  !  spline in theta direction
  !
  intho=4*(inth-1)
  do ix=1,inx
     !
     !  spline each x coeff
     !
     do ic=1,4
        !
        !  copy ordinates in
        !
        do ith=1,inth
           wk(4*(ith-1)+1)=fspl(ic,1,ix,ith)
        end do
        !
        !  first pass:  use a linear BC -- if flag indicates BC correction
        !  will be needed, it will be done later
        !
        wk(2)=0.0_fp
        wk(3)=0.0_fp
        wk(intho+2)=0.0_fp
        wk(intho+3)=0.0_fp
        !
        ibcthmina=ibcthmin
        ibcthmaxa=ibcthmax
        if(iflg2.eq.1) then
           if((ibcthmin.eq.1).or.(ibcthmin.eq.2)) ibcthmina=0
           if((ibcthmax.eq.1).or.(ibcthmax.eq.2)) ibcthmaxa=0
        end if
        !
        call v_spline(ibcthmina,ibcthmaxa,inth,th,wk,wk(4*inth+1))
        !
        !  copy coeffs out
        !
        do ith=1,inth
           fspl(ic,2,ix,ith)=wk(4*(ith-1)+2)
           fspl(ic,3,ix,ith)=wk(4*(ith-1)+3)*xo2
           fspl(ic,4,ix,ith)=wk(4*(ith-1)+4)*xo6
        end do
        !
     end do
     !
  end do
  !
  !  now make correction for user BC's if needed
  !
  if(iflg2.eq.1) then
     !
     iasc=1                         ! wk addr for correction splines
     iinc=4*inth                    ! spacing btw correction splines
     iawk=iasc+4*inth*inx
     !
     !  last grid zone widths
     !
     zhxn=x(inx)-x(inx-1)
     jx=inx-1
     zhth=th(inth)-th(inth-1)
     jth=inth-1
     !
     do ii=1,10
        iselect1(ii)=0
        iselect2(ii)=0
     end do
     if(ibcthmin.eq.1) iselect1(3)=1
     if(ibcthmin.eq.2) iselect1(5)=1
     if(ibcthmax.eq.1) iselect2(3)=1
     if(ibcthmax.eq.2) iselect2(5)=1
     !
     !  loop over BC's
     !
     do ix=1,inx
        !
        !  (a) d/dth @ th(1) difference btw current BC and user request
        !
        if(ibcthmin.eq.1) then
           if(ix.lt.inx) then
              zcur(1)=fspl(1,2,ix,1)   ! 1st deriv.
           else
              zcur(1)=fspl(1,2,jx,1)+zhxn*(fspl(2,2,jx,1)+zhxn* &
                   (fspl(3,2,jx,1)+zhxn*fspl(4,2,jx,1)))
           end if
           zdiff1=bcthmin(ix)-zcur(1)
        else if(ibcthmin.eq.2) then
           if(ix.lt.inx) then
              zcur(1)=2.0_fp*fspl(1,3,ix,1) ! 2nd deriv.
           else
              zcur(1)=2.0_fp* &
                   (fspl(1,3,jx,1)+zhxn*(fspl(2,3,jx,1)+zhxn* &
                   (fspl(3,3,jx,1)+zhxn*fspl(4,3,jx,1))))
           end if
           zdiff1=bcthmin(ix)-zcur(1)
        else
           zdiff1=0.0_fp
        end if
        !
        !  (b) d/dth @ th(inth) difference btw current BC and user request
        !
        if(ibcthmax.eq.1) then
           if(ix.lt.inx) then
              !  1st deriv.
              zcur(1)= &
                   fspl(1,2,ix,jth)+zhth*(2.0_fp*fspl(1,3,ix,jth)+ &
                   zhth*3.0_fp*fspl(1,4,ix,jth))
           else
              call bcspeval(x(inx),th(inth),iselect2,  zcur, &
                   x,inx,th,inth,ilinx,ilinth,fspl,inf3,ier)
              if(ier.ne.0) return
           end if
           zdiff2=bcthmax(ix)-zcur(1)
        else if(ibcthmax.eq.2) then
           if(ix.lt.inx) then
              !  2nd deriv.
              zcur(1)=2.0_fp*fspl(1,3,ix,jth)+ &
                   6.0_fp*zhth*fspl(1,4,ix,jth)
           else
              call bcspeval(x(inx),th(inth),iselect2,  zcur(1), &
                   x,inx,th,inth,ilinx,ilinth,fspl,inf3,ier)
              if(ier.ne.0) return
           end if
           zdiff2=bcthmax(ix)-zcur(1)
        else
           zdiff2=0.0_fp
        end if
        !
        !  ok compute the theta spline with BC's to span the difference(s)
        !  these theta "correction splines" are zero at all the grid points
        !  but have at least one non-zero 1st or 2nd derivative BC
        !
        iadr=iasc+(ix-1)*iinc
        do ith=1,inth
           wk(iadr+4*(ith-1))=0.0_fp
        end do
        !
        wk(iadr+1)=0.0_fp
        wk(iadr+2)=0.0_fp
        wk(iadr+intho+1)=0.0_fp
        wk(iadr+intho+2)=0.0_fp
        !
        if(ibcthmin.eq.1) then
           wk(iadr+1)=zdiff1
        else if(ibcthmin.eq.2) then
           wk(iadr+2)=zdiff1
        end if
        !
        if(ibcthmax.eq.1) then
           wk(iadr+intho+1)=zdiff2
        else if(ibcthmax.eq.2) then
           wk(iadr+intho+2)=zdiff2
        end if
        !
        call v_spline(ibcthmin,ibcthmax,inth,th,wk(iadr),wk(iawk))
     end do
     !
     !  add in results to main array -- th spline coef corrections
     !
     do ix=1,inx
        iadr=iasc+(ix-1)*iinc
        do ith=1,inth-1
           wk(iadr+4*(ith-1)+2)=wk(iadr+4*(ith-1)+2)*xo2
           wk(iadr+4*(ith-1)+3)=wk(iadr+4*(ith-1)+3)*xo6
           if(ix.lt.inx) then
              fspl(1,2,ix,ith)=fspl(1,2,ix,ith)+wk(iadr+4*(ith-1)+1)
              fspl(1,3,ix,ith)=fspl(1,3,ix,ith)+wk(iadr+4*(ith-1)+2)
              fspl(1,4,ix,ith)=fspl(1,4,ix,ith)+wk(iadr+4*(ith-1)+3)
           end if
        end do
     end do
     !
     !  compute the x splines of the th spline correction coeffs
     !
     ia5w=iawk+4*inx
     !
     do ith=1,inth-1
        do ic=2,4
           do ix=1,inx
              iaspl=iasc+iinc*(ix-1)
              wk(iawk+4*(ix-1))=wk(iaspl+4*(ith-1)+(ic-1))
           end do
           !
           !  use zero BCs for this correction spline
           !
           wk(iawk+1)=0.0_fp
           wk(iawk+2)=0.0_fp
           wk(iawk+inxo+1)=0.0_fp
           wk(iawk+inxo+2)=0.0_fp
           !
           !  periodic spline of correction spline higher coeffs (1st coeffs are
           !  all zero by defn of the correction spline
           !
           call v_spline(ibcxmin,ibcxmax,inx,x,wk(iawk),wk(ia5w))
           !
           do ix=1,inx-1
              fspl(2,ic,ix,ith)=fspl(2,ic,ix,ith)+ &
                   wk(iawk+4*(ix-1)+1)
              fspl(3,ic,ix,ith)=fspl(3,ic,ix,ith)+ &
                   wk(iawk+4*(ix-1)+2)*xo2
              fspl(4,ic,ix,ith)=fspl(4,ic,ix,ith)+ &
                   wk(iawk+4*(ix-1)+3)*xo6
           end do
           !
        end do
     end do                          ! ith
     !
  end if                             ! BC correction needs test
  !
  return
end subroutine bcspline

subroutine vecherm2(ict,ivec,xvec,yvec,ivd,fval, &
     nx,xpkg,ny,ypkg,fspl,inf2, &
     iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  vectorized hermite evaluation routine -- 2d
  !  1.  call vectorized zone lookup routine
  !  2.  call vectorized hermite evaluation routine
  !
  !--------------------------
  !  input:
  !============
  implicit none
  integer iwarn1,iwarn2
  !============
  integer ict(4)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate if ict(1)=0)
  !        ict(2)=1 for df/dx  (don't evaluate if ict(2)=0)
  !        ict(3)=1 for df/dy  (don't evaluate if ict(3)=0)
  !        ict(4)=1 for d2f/dxdy (don't evaluate if ict(4)=0)
  !
  integer ivec                      ! vector dimensioning
  !
  !    ivec-- number of vector pts (hermite values to look up)
  !
  !  list of (x,y) pairs:
  !
  real(fp) :: xvec(ivec)                   ! x-locations at which to evaluate
  real(fp) :: yvec(ivec)                   ! y-locations at which to evaluate
  !
  integer ivd                       ! 1st dimension of output array
  !
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                  ! output array
  !
  !  fval(1:ivec,1) -- values as per 1st non-zero ict(...) element
  !  fval(1:ivec,2) -- values as per 2nd non-zero ict(...) element
  !   --etc--
  !
  ! input:
  integer nx,ny                     ! dimension of hermite grids
  real(fp) :: xpkg(nx,4)                   ! x grid "package" (cf genxpkg)
  real(fp) :: ypkg(ny,4)                   ! y grid "package" (cf genxpkg)
  integer inf2                      ! fspl 3rd array dimension, .ge.nx
  real(fp) :: fspl(0:3,inf2,ny)            ! Hermite coefficients, cf herm2ev
  !
  ! output:
  ! condition codes, 0 = normal return
  integer iwarn                     ! =1 if an x value was out of range
  integer ier                       ! =1 if argument error detected
  !
  !---------------------------------------------------------------
  !  local arrays
  !
  integer ix(ivec)                  ! zone indices {j}
  real(fp) :: dxn(ivec)                    ! normalized displacements w/in zones
  real(fp) :: hx(ivec)                     ! h(j) vector
  real(fp) :: hxi(ivec)                    ! 1/h(j) vector
  !
  integer iy(ivec)                  ! zone indices {j}
  real(fp) :: dyn(ivec)                    ! normalized displacements w/in zones
  real(fp) :: hy(ivec)                     ! h(j) vector
  real(fp) :: hyi(ivec)                    ! 1/h(j) vector
  !
  !---------------------------------------------------------------
  !
  !  error checks
  !
  ier=0
  !
  if(nx.lt.2) then
     write(6,*) ' ?vecherm2:  nx.lt.2:  nx = ',nx
     ier=1
  end if
  !
  if(ny.lt.2) then
     write(6,*) ' ?vecherm2:  ny.lt.2:  ny = ',ny
     ier=1
  end if
  !
  if(ivec.le.0) then
     write(6,*) ' ?vecherm2:  vector dimension .le. 0:  ivec = ', &
          ivec
     ier=1
  end if
  !
  if(ivd.lt.ivec) then
     write(6,*) &
          ' ?vecherm2:  output vector dimension less than input ', &
          'vector dimension.'
     write(6,*) ' ivec=',ivec,' ivd=',ivd
     ier=1
  end if
  !
  if(ier.ne.0) return
  !
  !  vectorized lookup
  !
  ix=0
  iy=0
  call xlookup(ivec,xvec,nx,xpkg,2,ix,dxn,hx,hxi,iwarn1)
  call xlookup(ivec,yvec,ny,ypkg,2,iy,dyn,hy,hyi,iwarn2)
  iwarn=iwarn1+iwarn2
  !
  !  vectorized evaluation
  !
  call herm2fcn(ict,ivec,ivd,fval,ix,iy,dxn,dyn, &
       hx,hxi,hy,hyi,fspl,inf2,ny)
  !
  return
end subroutine vecherm2

!!!
!!! 1-d
!!!

subroutine EZspline_interp1(spline_o, p1, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  real(fp) p1  ! the location where the interpolation is sought
  real(fp) f   ! the interpolation
  integer, intent(out) :: ier

  integer ifail
  integer, parameter :: ict(3)=(/1, 0, 0/)
  real(fp) ansr(1)

  ier = 0
  ifail = 0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier =94
     return
  end if

  if (spline_o%isLinear == 1) then

     call pc1ev(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, ansr, ifail)

  else if (spline_o%isHermite == 0) then

     call evspline(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, ansr, ifail)

  else

     call herm1ev(p1, &
          &         spline_o%x1(1), spline_o%n1, &
          &         spline_o%ilin1,&
          &         spline_o%fspl(1,1),  &
          &         ict, ansr, ifail)

  end if

  f=ansr(1)

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp1


subroutine EZspline_interp1_array(spline_o, k, p1, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k) ! location arrays
  real(fp), intent(out):: f(k)  ! interpolant array
  integer, intent(out) :: ier

  integer :: i, ifail
  integer, parameter :: ict(3)=(/1,0,0/)
  integer:: iwarn=0

  ier = 0
  ifail = 0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isLinear == 1) then

     call vecpc1(ict, k, p1, k, f, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)

  else if (spline_o%isHermite == 0) then

     call vecspline(ict, k, p1, k, f, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)

  else

     call vecherm1(ict, k, p1, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn,ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp1_array

!!!
!!! 2-d
!!!

subroutine EZspline_interp2(spline_o, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) :: spline_o
  real(fp) :: p1, p2  ! the location where the interpolation is sought
  real(fp) :: f       ! the interpolation
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(6)=(/1, 0, 0, 0, 0, 0 /)
  real(fp) ansr(1)

  ier = 0
  ifail = 0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier =94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call evintrp2d(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%hspline, spline_o%fspl(1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3),  &
          &   ict, ansr, ifail)

  else if (spline_o%isLinear == 1) then

     call pc2ev(p1, p2,  &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, ansr, ifail)

  else if (spline_o%isHermite == 0) then

     call evbicub(p1, p2,  &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, ansr, ifail)

  else

     call herm2ev(p1, p2,  &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, ansr, ifail)

  end if

  f=ansr(1)

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp2

subroutine EZspline_interp2_array(spline_o, k1, k2, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k1, k2
  real(fp) :: p1(k1), p2(k2) ! location arrays
  real(fp) :: f(k1,k2)  ! interpolated function array
  integer, intent(out) :: ier

  integer ifail
  integer:: iwarn=0

  ier = 0
  ifail = 0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier =94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call gridintrp2d( &
          & p1, k1, &
          & p2, k2, &
          & f, k1, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if (spline_o%isLinear == 1) then

     call gridpc2( &
          & p1, k1, &
          & p2, k2, &
          & f, k1, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else if (spline_o%isHermite == 0) then

     call gridbicub( &
          & p1, k1, &
          & p2, k2, &
          & f, k1, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else

     call gridherm2( &
          & p1, k1, &
          & p2, k2, &
          & f, k1, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp2_array

subroutine EZspline_interp2_cloud(spline_o, k, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  ! list of coordinate doublets
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k) ! location arrays
  real(fp), intent(out):: f(k)  ! interpolant array
  integer, intent(out) :: ier
  integer :: ifail
  integer, parameter :: ict(6) = (/1,0,0,0,0,0/)
  integer:: iwarn = 0

  ier = 0
  ifail = 0

  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if


  if (spline_o%isHybrid == 1) then

     call vecintrp2d(ict, k, p1, p2, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if (spline_o%isLinear == 1) then

     call vecpc2(ict, k, p1, p2, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else if (spline_o%isHermite == 0) then
     !
     call vecbicub(ict, k, p1, p2, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else

     call vecherm2(ict, k, p1, p2, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp2_cloud


!!!
!!! 3-d
!!!

subroutine EZspline_interp3(spline_o, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  real(fp) p1, p2, p3 ! the location where the interpolation is sought
  real(fp) f          ! the interpolation

  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(10)=(/1,0,0,0,0,0,0,0,0,0/)
  real(fp) ansr(1)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier =94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call evintrp3d(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%hspline, spline_o%fspl(1,1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3), size(spline_o%fspl,4), &
          &   ict, ansr, ifail)

  else if (spline_o%isLinear == 1) then

     call pc3ev(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, ansr, ifail)

  else if (spline_o%isHermite == 0) then

     call evtricub(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, ansr, ifail)

  else

     call herm3ev(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, ansr, ifail)

  end if

  f=ansr(1)

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp3

subroutine EZspline_interp3_array(spline_o, k1, k2, k3, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer :: k1, k2, k3
  real(fp) :: p1(k1), p2(k2), p3(k3)  ! location arrays
  real(fp) :: f(k1,k2,k3)  ! interpolant array
  integer, intent(out) :: ier

  integer ifail
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier =94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call gridintrp3d( &
          & p1, k1, &
          & p2, k2, &
          & p3, k3, &
          & f, k1, k2, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if (spline_o%isLinear == 1) then

     call gridpc3( &
          & p1, k1, &
          & p2, k2, &
          & p3, k3, &
          & f, k1, k2, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  else if (spline_o%isHermite == 0) then
     !
     call gridtricub( &
          & p1, k1, &
          & p2, k2, &
          & p3, k3, &
          & f, k1, k2, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  else

     call gridherm3( &
          & p1, k1, &
          & p2, k2, &
          & p3, k3, &
          & f, k1, k2, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp3_array

subroutine EZspline_interp3_cloud(spline_o, k, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  ! list of coordinate triplets
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k), p3(k)  ! location arrays
  real(fp), intent(out):: f(k)  ! interpolant array
  integer, intent(out) :: ier

  integer :: ifail
  integer, parameter :: ict(10)=(/1,0,0,0,0,0,0,0,0,0/)
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call vecintrp3d(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if (spline_o%isLinear == 1) then

     call vecpc3(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  else if (spline_o%isHermite == 0) then
     !
     call vectricub(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%n3,spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  else

     call vecherm3(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_interp3_cloud

!/////
! R8 !
!/////
program drive2
  !
  ! performance test
  !
  use EZspline_obj
  use EZspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8) t(12)
  type(ezspline1_r8) :: spl1
  type(ezspline2_r8) :: spl2
  type(ezspline3_r8) :: spl3
  integer n, ier, i

  write(*,*)' '
  write(*,*)' 1-D'
  write(*,*)' '

  n = 4096
  call setup1d(spl1, n, t(1))
  write(*,'(a,i7,a,f10.3)')'time for setup [s] (',n,')=>',&
       & t(1)

  n=1000000
  call interp1d_point(spl1, n, t(2))
  write(*,'(a,i7,a,f10.3)')'time for point interp [s] (',n,')=>',&
       & t(2)


  call interp1d_cloud(spl1, n, t(3))
  write(*,'(a,i7,a,f10.3)')'time for cloud interp [s] (',n,')=>',&
       & t(3)


  call interp1d_array(spl1, n, t(4))
  write(*,'(a,i7,a,f10.3)')'time for array interp [s] (',n,')=>',&
       & t(4)

  call ezspline_free(spl1, ier)

  write(*,*)' '
  write(*,*)' 2-D'
  write(*,*)' '

  n = 64
  call setup2d(spl2, n, t(5))
  write(*,'(a,i7,a,f10.3)')'time for setup [s] (',n,'^2)=>',&
       & t(5)

  n=1000
  call interp2d_point(spl2, n, t(6))
  write(*,'(a,i7,a,f10.3)')'time for point interp [s] (',n,'^2)=>',&
       & t(6)


  call interp2d_cloud(spl2, n, t(7))
  write(*,'(a,i7,a,f10.3)')'time for cloud interp [s] (',n,'^2)=>',&
       & t(7)


  call interp2d_array(spl2, n, t(8))
  write(*,'(a,i7,a,f10.3)')'time for array interp [s] (',n,'^2)=>',&
       & t(8)

  call ezspline_free(spl2, ier)

  write(*,*)' '
  write(*,*)' 3-D'
  write(*,*)' '

  n = 16
  call setup3d(spl3, n, t(9))
  write(*,'(a,i7,a,f10.3)')'time for setup [s] (',n,'^3)=>',&
       & t(9)

  n=100
  call interp3d_point(spl3, n, t(10))
  write(*,'(a,i7,a,f10.3)')'time for point interp [s] (',n,'^3)=>',&
       & t(10)


  call interp3d_cloud(spl3, n, t(11))
  write(*,'(a,i7,a,f10.3)')'time for cloud interp [s] (',n,'^3)=>',&
       & t(11)


  call interp3d_array(spl3, n, t(12))
  write(*,'(a,i7,a,f10.3)')'time for array interp [s] (',n,'^3)=>',&
       & t(12)

  call ezspline_free(spl3, ier)

  write(*,*)'All cpu times [s]'
  write(*,'(12f7.2)') t(1:12)

  stop '* successful termination of drive2'
end program drive2


!
! 1-D
!

subroutine setup1d(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline1_r8), intent(inout) :: spl
  integer, intent(in) :: ki

  real(r8) :: x1(ki), f(ki)
  integer :: bcs1(2)
  real(r8) :: x_pt, t
  integer tics_per_second, tic, toc

  integer :: n1, i, ier

  n1 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)

        do i = 1, n1
           x_pt = 1.0_r8 + cos( x1(i) )
           f(i) = (x_pt-1.0_r8)**2
        enddo

  bcs1 = (/ -1, -1 /) ! periodic

  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1 coincides 
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call system_clock(tic, tics_per_second)
  call EZspline_setup(spl, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)
  call EZspline_error(ier)
  if(ier /= 0) return

end subroutine setup1d

subroutine interp1d_point(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline1_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8) :: x1(ki), f(ki)
  integer i, ier, n1
  integer tics_per_second, tic, toc

  n1 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)

  call ezspline_isindomain(spl, n1, x1, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
        do i=1, n1
           call ezspline_interp(spl, x1(i), f(i), ier)
        enddo
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

end subroutine interp1d_point


subroutine interp1d_cloud(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline1_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1, f
  integer i, ier, icount, n1, n, iok
  integer tics_per_second, tic, toc

  n1 = ki

  allocate(x1(ki), f(ki), stat=iok)
  if(iok/=0) stop 'allocation error'
  
  icount = 1
        do i=1, n1
           x1(icount) = spl%x1min + &
                & (spl%x1max-spl%x1min)*real(i-1,r8)/real(n1-1,r8)
           icount = icount + 1
        enddo

  n = n1
  call ezspline_isindomain(spl, n, x1, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n, x1, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1, f)

end subroutine interp1d_cloud

subroutine interp1d_array(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline1_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1
  real(r8), dimension(:), allocatable ::  f
  integer i, ier, n1, iok
  integer tics_per_second, tic, toc

  n1 = ki

  allocate(x1(n1), stat=iok)
  if(iok/=0) stop 'allocation error'
  allocate(f(n1), stat=iok)
  if(iok/=0) stop 'allocation error'

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)

  call ezspline_isindomain(spl, n1, x1, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n1, x1, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1,f)

end subroutine interp1d_array

!!
!! 2-D
!!

subroutine setup2d(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline2_r8), intent(inout) :: spl
  integer, intent(in) :: ki

  real(r8) :: x1(ki), x2(ki), f(ki,ki)
  integer :: bcs1(2), bcs2(2)
  real(r8) :: x_pt, y_pt, t
  integer tics_per_second, tic, toc

  integer :: n1, n2, i, j, ier

  n1 = ki
  n2 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ -1, -1 /) ! periodic
  bcs2 = (/ -1, -1 /) ! periodic

  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1, x2 coincide 
  spl%x2 = x2 ! with default mesh
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call system_clock(tic, tics_per_second)
  call EZspline_setup(spl, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)
  call EZspline_error(ier)
  if(ier /= 0) return

end subroutine setup2d

subroutine interp2d_point(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline2_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8) :: x1(ki), x2(ki), f(ki,ki)
  integer i, j, ier, n1, n2
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

  call ezspline_isindomain(spl, n1, n2, x1, x2, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
     do j=1, n2
        do i=1, n1
           call ezspline_interp(spl, x1(i), x2(j), f(i,j), ier)
        enddo
     enddo
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

end subroutine interp2d_point


subroutine interp2d_cloud(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline2_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1, x2, f
  integer i, j, k, ier, icount, n1, n2, n, iok
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki

  allocate(x1(ki**2), x2(ki**2), f(ki**2), stat=iok)
  if(iok/=0) stop 'allocation error'
  
  icount = 1
     do j=1, n2
        do i=1, n1
           x1(icount) = spl%x1min + &
                & (spl%x1max-spl%x1min)*real(i-1,r8)/real(n1-1,r8)
           x2(icount) = spl%x2min + &
                & (spl%x2max-spl%x2min)*real(i-1,r8)/real(n2-1,r8)
           icount = icount + 1
        enddo
     enddo

  n = n1*n2
  call ezspline_isindomain(spl, n, x1, x2, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n, x1, x2, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1, x2, f)

end subroutine interp2d_cloud

subroutine interp2d_array(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline2_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1, x2
  real(r8), dimension(:,:), allocatable ::  f
  integer i, j, ier, n1, n2, iok
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki

  allocate(x1(n1), x2(n2), stat=iok)
  if(iok/=0) stop 'allocation error'
  allocate(f(n1,n2), stat=iok)
  if(iok/=0) stop 'allocation error'

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

  call ezspline_isindomain(spl, n1, n2, x1, x2, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n1, n2, x1, x2, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1,x2,f)

end subroutine interp2d_array


!!!
!!! 3-D
!!!

subroutine setup3d(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline3_r8), intent(inout) :: spl
  integer, intent(in) :: ki

  real(r8) :: x1(ki), x2(ki), x3(ki), f(ki,ki,ki)
  integer :: bcs1(2), bcs2(2), bcs3(2)
  real(r8) :: x_pt, y_pt, z_pt, t
  integer tics_per_second, tic, toc

  integer :: n1, n2, n3, i, j, k, ier

  n1 = ki
  n2 = ki
  n3 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  do k = 1, n3
     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*sin( x2(j) )
           z_pt = x3(k)*sin( x1(i) )
           f(i,j,k) = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
        enddo
     enddo
  enddo

  bcs1 = (/ -1, -1 /) ! periodic
  bcs2 = (/ -1, -1 /) ! periodic
  bcs3 = (/  0,  0 /) ! not a knot

  call EZspline_init(spl, n1, n2, n3, bcs1, bcs2, bcs3, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1, x2, x3 coincide 
  spl%x2 = x2 ! with default mesh
  spl%x3 = x3
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call system_clock(tic, tics_per_second)
  call EZspline_setup(spl, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)
  call EZspline_error(ier)
  if(ier /= 0) return

end subroutine setup3d

subroutine interp3d_point(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline3_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8) :: x1(ki), x2(ki), x3(ki), f(ki,ki,ki)
  integer i, j, k, ier, n1, n2, n3
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki
  n3 = ki

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  call ezspline_isindomain(spl, n1, n2, n3, x1, x2, x3, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  do k=1, n3
     do j=1, n2
        do i=1, n1
           call ezspline_interp(spl, x1(i), x2(j), x3(k), f(i,j,k), ier)
        enddo
     enddo
  enddo
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

end subroutine interp3d_point


subroutine interp3d_cloud(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline3_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1, x2, x3, f
  integer i, j, k, ier, icount, n1, n2, n3, n, iok
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki
  n3 = ki

  allocate(x1(ki**3), x2(ki**3), x3(ki**3), f(ki**3), stat=iok)
  if(iok/=0) stop 'allocation error'
  
  icount = 1
  do k=1, n3
     do j=1, n2
        do i=1, n1
           x1(icount) = spl%x1min + &
                & (spl%x1max-spl%x1min)*real(i-1,r8)/real(n1-1,r8)
           x2(icount) = spl%x2min + &
                & (spl%x2max-spl%x2min)*real(i-1,r8)/real(n2-1,r8)
           x3(icount) = spl%x3min + &
                & (spl%x3max-spl%x3min)*real(i-1,r8)/real(n3-1,r8)
           icount = icount + 1
        enddo
     enddo
  enddo

  n = n1*n2*n3
  call ezspline_isindomain(spl, n, x1, x2, x3, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n, x1, x2, x3, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1, x2, x3, f)

end subroutine interp3d_cloud

subroutine interp3d_array(spl, ki, t)
  use ezspline_obj
  use ezspline
  implicit none
  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865

  type(ezspline3_r8), intent(in) :: spl
  integer, intent(in) :: ki
  real(r8), intent(out) :: t

  real(r8), dimension(:), allocatable :: x1, x2, x3
  real(r8), dimension(:,:,:), allocatable ::  f
  integer i, j, k, ier, n1, n2, n3, iok
  integer tics_per_second, tic, toc

  n1 = ki
  n2 = ki
  n3 = ki

  allocate(x1(n1), x2(n2), x3(n3), stat=iok)
  if(iok/=0) stop 'allocation error'
  allocate(f(n1,n2,n3), stat=iok)
  if(iok/=0) stop 'allocation error'

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  call ezspline_isindomain(spl, n1, n2, n3, x1, x2, x3, ier)
  if(ier/=0) print*,'out of domain error'

  call system_clock(tic, tics_per_second)
  call ezspline_interp(spl, n1, n2, n3, x1, x2, x3, f, ier)
  call system_clock(toc, tics_per_second)
  t = real(toc-tic)/real(tics_per_second)

  deallocate(x1,x2,x3,f)

end subroutine interp3d_array

!
! 1-D
!

subroutine EZspline_gradient1(spline_o, &
     p1, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  real(fp), intent(in) :: p1
  real(fp), intent(out) :: df
  integer, intent(out) :: ier

  integer ifail
  integer, parameter :: ict(3) = (/0, 1, 0/)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if(spline_o%isLinear == 1) then

     call pc1ev(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, df, ifail)

  else if(spline_o%isHermite == 0) then

     call evspline(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, df, ifail)

  else

     call herm1ev(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, df, ifail)

  end if
  if(ifail/=0) ier = 95

end subroutine EZspline_gradient1


subroutine EZspline_gradient1_array(spline_o, k1, &
     p1, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: k1
  real(fp), intent(in) :: p1(k1)
  real(fp), intent(out) :: df(k1) 
  !
  ! ier=95 some error occurred in EZspline_gradient
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(3) = (/0, 1, 0/)
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if(spline_o%isLinear == 1) then

     call vecpc1(ict, k1, p1, k1, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)

  else if(spline_o%isHermite == 0) then

     call vecspline(ict, k1, p1, k1, df, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)


  else

     call vecherm1(ict, k1, p1, k1, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 95
end subroutine EZspline_gradient1_array


!!
!! 2-D
!!

subroutine EZspline_gradient2(spline_o, &
     p1, p2, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  real(fp), intent(in) :: p1, p2
  real(fp), intent(out) :: df(2) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(6) = (/0, 1, 1, 0, 0, 0/)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call evintrp2d(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%hspline, spline_o%fspl(1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3),  &
          &   ict, df, ifail)

  else if(spline_o%isLinear == 1) then

     call pc2ev(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, df, ifail)

  else if(spline_o%isHermite == 0) then

     call evbicub(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, df, ifail)

  else

     call herm2ev(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, df, ifail)
  end if

  if(ifail/=0) ier = 95

end subroutine EZspline_gradient2

subroutine EZspline_gradient2_cloud(spline_o, k, &
     p1, p2, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k)
  real(fp), intent(out) :: df(k,2) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(6) = (/0, 1, 1, 0, 0, 0/)
  integer::  iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call vecintrp2d(ict, k, p1, p2, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if(spline_o%isLinear == 1) then

     call vecpc2(ict, k, p1, p2, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn,ifail)

  else if(spline_o%isHermite == 0) then

     call vecbicub(ict, k, p1, p2, k, df, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else

     call vecherm2(ict, k, p1, p2, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn,ifail)

  end if
  if(ifail /= 0) ier = 95

end subroutine EZspline_gradient2_cloud


subroutine EZspline_gradient2_array(spline_o, k1, k2, &
     p1, p2, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k1, k2
  real(fp), intent(in) :: p1(k1), p2(k2)
  real(fp), intent(out) :: df(k1, k2, 2) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(6) = (/0, 1, 1, 0, 0, 0/)
  integer:: iwarn=0
  real(fp), dimension(:), allocatable :: p1_cloud, p2_cloud
  integer k12

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if


  k12 = k1*k2
  allocate(p1_cloud(k12), p2_cloud(k12), stat=ifail)
  if(ifail /= 0) then
     ier = 30
     return
  end if

  p1_cloud = reshape( &
       & source=spread(source=p1, dim=2, ncopies=k2), shape=(/k12/))
  p2_cloud = reshape( &
       & source=spread(source=p2, dim=1, ncopies=k1), shape=(/k12/))

  if(spline_o%isHybrid == 1) then

     call vecintrp2d(ict, k12, p1_cloud, p2_cloud, k12, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if(spline_o%isLinear == 1) then

     call vecpc2(ict, k12, p1_cloud, p2_cloud, k12, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else if(spline_o%isHermite == 0) then

     call vecbicub(ict, k12, p1_cloud, p2_cloud, k12, df, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  else

     call vecherm2(ict, k12, p1_cloud, p2_cloud, k12, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  end if

  deallocate(p1_cloud, p2_cloud, stat=ifail)
  if(ifail /= 0) then
     ier = 31
     return
  end if

  if(ifail /= 0) ier = 95

end subroutine EZspline_gradient2_array


!!!
!!! 3-D
!!!

subroutine EZspline_gradient3(spline_o, &
     p1, p2, p3, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  real(fp), intent(in) :: p1, p2, p3
  real(fp), intent(out) :: df(3) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(10) = (/0, 1, 1, 1, 0, 0, 0, 0, 0, 0/)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call evintrp3d(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%hspline, spline_o%fspl(1,1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3), size(spline_o%fspl,4), &
          &   ict, df, ifail)

  else if(spline_o%isLinear == 1) then

     call pc3ev(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, df, ifail)

  else if(spline_o%isHermite == 0) then

     call evtricub(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, df, ifail)

  else

     call herm3ev(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, df, ifail)

  end if

  if(ifail/=0) ier = 95

end subroutine EZspline_gradient3

subroutine EZspline_gradient3_cloud(spline_o, k, &
     p1, p2, p3, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k), p3(k)
  real(fp), intent(out) :: df(k, 3) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(10) = (/0, 1, 1, 1, 0, 0, 0, 0, 0, 0/)
  integer :: iwarn=0

  ier = 0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isHybrid == 1) then

     call vecintrp3d(ict, k, p1, p2, p3, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if(spline_o%isLinear == 1) then

     call vecpc3(ict, k, p1, p2, p3, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  else if(spline_o%isHermite == 0) then

     call vectricub(ict, k, p1, p2, p3, k, df, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%n3,spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  else

     call vecherm3(ict, k, p1, p2, p3, k, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  end if

  if(ifail /= 0) ier = 95


end subroutine EZspline_gradient3_cloud


subroutine EZspline_gradient3_array(spline_o, k1, k2, k3, &
     p1, p2, p3, df, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k1, k2, k3
  real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
  real(fp), intent(out) :: df(k1, k2, k3, 3) 
  !
  integer, intent(out) :: ier
  integer ifail
  integer, parameter :: ict(10) = (/0, 1, 1, 1, 0, 0, 0, 0, 0, 0/)
  integer:: iwarn=0
  real(fp), dimension(:), allocatable :: p1_cloud, p2_cloud, p3_cloud
  integer k123

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  k123 = k1*k2*k3
  allocate(p1_cloud(k123), p2_cloud(k123), p3_cloud(k123), stat=ifail)
  if(ifail /= 0) then
     ier = 30
     return
  end if

  p1_cloud = reshape(source=spread( &
       & source=spread(source=p1, dim=2, ncopies=k2), &
       & dim=3, ncopies=k3), shape=(/k123/))
  p2_cloud = reshape(source=spread( &
       & source=spread(source=p2, dim=1, ncopies=k1), &
       & dim=3, ncopies=k3), shape=(/k123/))
  p3_cloud = reshape(source=spread( &
       & source=spread(source=p3, dim=1, ncopies=k1), &
       & dim=2, ncopies=k2), shape=(/k123/))

  if (spline_o%isHybrid == 1) then

     call vecintrp3d(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if(spline_o%isLinear == 1) then

     call vecpc3(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  else if(spline_o%isHermite == 0) then

     call vectricub(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, df, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%n3,spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  else

     call vecherm3(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, df, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  end if

  if(ifail /= 0) ier = 95

  deallocate(p1_cloud, p2_cloud, p3_cloud, stat=ifail)
  if(ifail /= 0) then
     ier = 31
     return
  end if

end subroutine EZspline_gradient3_array

subroutine tcspvec(ict,ivec,xvec,yvec,zvec,ivd,fval, &
     nx,xpkg,ny,ypkg,nz,zpkg,fspl,inf4,inf5, &
     iwarn,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  vectorized spline evaluation routine -- 3d spline
  !  1.  call vectorized zone lookup routine
  !  2.  call vectorized spline evaluation routine
  !
  !--------------------------
  !  input:
  !============
  implicit none
  integer iwarn1,iwarn2,iwarn3
  !============
  real(fp) :: stat
  !============
  integer ict(10)                    ! selector:
  !        ict(1)=1 for f      (don't evaluate if ict(1)=0)
  !        ict(2)=1 for df/dx  (don't evaluate if ict(2)=0)
  !        ict(3)=1 for df/dy  (don't evaluate if ict(3)=0)
  !        ict(4)=1 for df/dy  (don't evaluate if ict(4)=0)
  !        ict(5)=1 for d2f/dx2 (don't evaluate if ict(5)=0)
  !        ict(6)=1 for d2f/dy2 (don't evaluate if ict(6)=0)
  !        ict(7)=1 for d2f/dz2 (don't evaluate if ict(7)=0)
  !        ict(8)=1 for d2f/dxdy (don't evaluate if ict(8)=0)
  !        ict(9)=1 for d2f/dxdz (don't evaluate if ict(9)=0)
  !        ict(10)=1 for d2f/dydz (don't evaluate if ict(10)=0)
  !
  integer ivec                      ! vector dimensioning
  !
  !    ivec-- number of vector pts (spline values to look up)
  !
  !  list of (x,y,z) triples:
  !
  real(fp) :: xvec(ivec)                   ! x-locations at which to evaluate
  real(fp) :: yvec(ivec)                   ! y-locations at which to evaluate
  real(fp) :: zvec(ivec)                   ! z-locations at which to evaluate
  !
  integer ivd                       ! 1st dimension of output array
  !
  !    ivd -- 1st dimension of fval, .ge.ivec
  !
  ! output:
  real(fp) :: fval(ivd,*)                  ! output array
  !
  !  fval(1:ivec,1) -- values as per 1st non-zero ict(...) element
  !  fval(1:ivec,2) -- values as per 2nd non-zero ict(...) element
  !   --etc--
  !
  ! input:
  integer nx,ny,nz                  ! dimension of spline grids
  real(fp) :: xpkg(nx,4)                   ! x grid "package" (cf genxpkg)
  real(fp) :: ypkg(ny,4)                   ! y grid "package" (cf genxpkg)
  real(fp) :: zpkg(nz,4)                   ! z grid "package" (cf genxpkg)
  integer inf4                      ! fspl 4th array dimension, .ge.nx
  integer inf5                      ! fspl 5th array dimension, .ge.ny
  real(fp) :: fspl(4,4,4,inf4,inf5,nz)     ! (non-compact) spline coefficients
  !
  ! output:
  ! condition codes, 0 = normal return
  integer iwarn                     ! =1 if an x value was out of range
  integer ier                       ! =1 if argument error detected
  !
  !---------------------------------------------------------------
  !  local arrays
  !
  integer, dimension(:), allocatable :: ix,iy,iz
  real(fp), dimension(:), allocatable :: dxv,dyv,dzv
  !
  !---------------------------------------------------------------
  !
  !  error checks
  !
  ier=0
  !
  if(nx.lt.2) then
     write(6,*) ' ?tcspvec:  nx.lt.2:  nx = ',nx
     ier=1
  end if
  !
  if(ny.lt.2) then
     write(6,*) ' ?tcspvec:  ny.lt.2:  ny = ',ny
     ier=1
  end if
  !
  if(nz.lt.2) then
     write(6,*) ' ?tcspvec:  nz.lt.2:  nz = ',nz
     ier=1
  end if
  !
  if(ivec.le.0) then
     write(6,*) ' ?tcspvec:  vector dimension .le. 0:  ivec = ', &
          ivec
     ier=1
  end if
  !
  if(ivd.lt.ivec) then
     write(6,*) &
          ' ?tcspvec:  output vector dimension less than input ', &
          'vector dimension.'
     write(6,*) ' ivec=',ivec,' ivd=',ivd
     ier=1
  end if
  !
  if(ier.ne.0) return
  !
  allocate(ix(ivec), iy(ivec), iz(ivec), &
       dxv(ivec), dyv(ivec), dzv(ivec), stat=ier)
  !
  if(ier.ne.0) then
     write(6,*) &
          ' ?tcspvec: memory allocation failure.'
     ier=99
  end if
  !
  if(ier.ne.0) return
  !
  !  vectorized lookups
  !
  ix=0; iy=0; iz=0
  call xlookup(ivec,xvec,nx,xpkg,1,ix,dxv,dxv,dxv,iwarn1)
  call xlookup(ivec,yvec,ny,ypkg,1,iy,dyv,dyv,dyv,iwarn2)
  call xlookup(ivec,zvec,nz,zpkg,1,iz,dzv,dzv,dzv,iwarn3)
  iwarn=max(iwarn1,iwarn2,iwarn3)
  !
  !  vectorized evaluation
  !
  call tcspevfn(ict,ivec,ivd,fval,ix,iy,iz,dxv,dyv,dzv, &
       fspl,inf4,inf5,nz)
  !
  deallocate(ix,iy,iz,dxv,dyv,dzv)
  !
  return
end subroutine tcspvec

C-----------------------------------------------------------------------
C  IERFNOF -- return the integer error code (IOSTAT) for file not found
C    on this machine
C
C    it is "29" only on DEC machines!
C
      integer function IERFNOF(lun)
C
      data iansr/0/
C
      if(iansr.eq.0) then
          open(unit=lun,file='Xyz.GarbageFile',status='old',
     >        iostat= iansr )
          close(unit=lun,err=10)
 10       continue
      endif
C
      ierfnof = iansr
C
      return
      end

subroutine evbicub(xget,yget,x,nx,y,ny,ilinx,iliny, &
     f,inf2,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a 2d cubic Spline interpolant on a rectilinear
  !  grid -- this is C2 in both directions.
  !
  !  this subroutine calls two subroutines:
  !     herm2xy  -- find cell containing (xget,yget)
  !     fvbicub  -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer inf2
  !============
  integer nx,ny                     ! grid sizes
  real(fp) :: xget,yget                    ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  integer iliny                     ! iliny=1 => assume y evenly spaced
  !
  real(fp) :: f(0:3,inf2,ny)               ! function data
  !
  !       f 2nd dimension inf2 must be .ge. nx
  !       contents of f:
  !
  !  f(0,i,j) = f @ x(i),y(j)
  !  f(1,i,j) = d2f/dx2 @ x(i),y(j)
  !  f(2,i,j) = d2f/dy2 @ x(i),y(j)
  !  f(3,i,j) = d4f/dx2dy2 @ x(i),y(j)
  !
  !      (these are spline coefficients selected for continuous 2-
  !      diffentiability, see mkbicub[w].f90)
  !
  integer ict(6)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return d2f/dx2  (0, don't)
  !  ict(5)=1 -- return d2f/dy2  (0, don't)
  !  ict(6)=1 -- return d2f/dxdy (0, don't)
  !                   the number of non zero values ict(1:6)
  !                   determines the number of outputs...
  !
  !  new dmc December 2005 -- access to higher derivatives (even if not
  !  continuous-- but can only go up to 3rd derivatives on any one coordinate.
  !     if ict(1)=3 -- want 3rd derivatives
  !          ict(2)=1 for d3f/dx3
  !          ict(3)=1 for d3f/dx2dy
  !          ict(4)=1 for d3f/dxdy2
  !          ict(5)=1 for d3f/dy3
  !               number of non-zero values ict(2:5) gives no. of outputs
  !     if ict(1)=4 -- want 4th derivatives
  !          ict(2)=1 for d4f/dx3dy
  !          ict(3)=1 for d4f/dx2dy2
  !          ict(4)=1 for d4f/dxdy3
  !               number of non-zero values ict(2:4) gives no. of outputs
  !     if ict(1)=5 -- want 5th derivatives
  !          ict(2)=1 for d5f/dx3dy2
  !          ict(3)=1 for d5f/dx2dy3
  !               number of non-zero values ict(2:3) gives no. of outputs
  !     if ict(1)=6 -- want 6th derivatives
  !          d6f/dx3dy3 -- one value is returned.
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the fourth output (depends on ict(...) spec)
  !  fval(5) receives the fourth output (depends on ict(...) spec)
  !  fval(6) receives the fourth output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,0,0,1]
  !   on output fval= [f,df/dx,df/dy,d2f/dxdy], elements 5 & 6 not referenced.
  !
  !    on input ict = [1,0,0,0,0,0]
  !   on output fval= [f] ... elements 2 -- 6 never referenced.
  !
  !    on input ict = [0,0,0,1,1,0]
  !   on output fval= [d2f/dx2,d2f/dy2] ... elements 3 -- 6 never referenced.
  !
  !    on input ict = [0,0,1,0,0,0]
  !   on output fval= [df/dy] ... elements 2 -- 6 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer i(1),j(1)                       ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !
  real(fp) :: xparam(1),yparam(1)
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp) :: hx(1),hy(1)
  real(fp) :: hxi(1),hyi(1)
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !
  !  ** the interface is very similar to herm2ev.f90; can use herm2xy **
  !---------------------------------------------------------------------
  !
  i(1)=0
  j(1)=0
  call herm2xy(xget,yget,x,nx,y,ny,ilinx,iliny, &
       i(1),j(1),xparam(1),yparam(1),hx(1),hxi(1),hy(1),hyi(1),ier)
  if(ier.ne.0) return
  !
  call fvbicub(ict,1,1, &
       fval,i,j,xparam,yparam,hx,hxi,hy,hyi,f,inf2,ny)
  !
  return
end subroutine evbicub
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine fvbicub(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,iadr,i,j
  !============
  real(fp) :: z36th,xp,xpi,xp2,xpi2,cx,cxi,hx2,yp,ypi,yp2,ypi2,cy
  real(fp) :: cyi,hy2,cxd,cxdi,cyd,cydi
  !============
  integer ict(6)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec)         ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam(ivec)
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy(ivec)            ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec)          ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(0:3,inf2,ny)             ! interpolant data (cf "evbicub")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  evbicub comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Spline evaluation consists of a "mixing" of the interpolant
  !  data using the linear functionals xparam, xpi = 1-xparam,
  !  yparam, ypi = 1-yparam, and the cubic functionals
  !  xparam**3-xparam, xpi**3-xpi, yparam**3-yparam, ypi**3-ypi ...
  !  and their derivatives as needed.
  !
  integer v
  real(fp) :: sum
  !
  real(fp), parameter :: sixth = 0.166666666666666667_fp
  !
  !---------------
  !   ...in x direction
  !
  z36th=sixth*sixth
  iadr=0
  !
  if(ict(1).le.2) then
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           !
           cy=yp*(yp2-1.0_fp)
           cyi=ypi*(ypi2-1.0_fp)
           hy2=hy(v)*hy(v)
           !
           sum=xpi*(ypi*fin(0,i,j)  +yp*fin(0,i,j+1))+ &
                xp*(ypi*fin(0,i+1,j)+yp*fin(0,i+1,j+1))
           !
           sum=sum+sixth*hx2*( &
                cxi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                cx*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*( &
                xpi*(cyi*fin(2,i,j)  +cy*fin(2,i,j+1))+ &
                xp*(cyi*fin(2,i+1,j)+cy*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx2*hy2*( &
                cxi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                cx*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi

           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           !
           cy=yp*(yp2-1.0_fp)
           cyi=ypi*(ypi2-1.0_fp)
           hy2=hy(v)*hy(v)
           !
           sum=hxi(v)*( &
                -(ypi*fin(0,i,j)  +yp*fin(0,i,j+1)) &
                +(ypi*fin(0,i+1,j)+yp*fin(0,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*( &
                cxdi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                cxd*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hxi(v)*hy2*( &
                -(cyi*fin(2,i,j)  +cy*fin(2,i,j+1)) &
                +(cyi*fin(2,i+1,j)+cy*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx(v)*hy2*( &
                cxdi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                cxd*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi

           cyd=3.0_fp*yp2-1.0_fp
           cydi=-3.0_fp*ypi2+1.0_fp
           !
           sum=hyi(v)*( &
                xpi*(-fin(0,i,j)  +fin(0,i,j+1))+ &
                xp*(-fin(0,i+1,j)+fin(0,i+1,j+1)))
           !
           sum=sum+sixth*hx2*hyi(v)*( &
                cxi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                cx*(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy(v)*( &
                xpi*(cydi*fin(2,i,j)  +cyd*fin(2,i,j+1))+ &
                xp*(cydi*fin(2,i+1,j)+cyd*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx2*hy(v)*( &
                cxi*(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1))+ &
                cx*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dx2:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           !
           cy=yp*(yp2-1.0_fp)
           cyi=ypi*(ypi2-1.0_fp)
           hy2=hy(v)*hy(v)
           !
           sum=( &
                xpi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                xp*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*( &
                xpi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                xp*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dy2:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           !
           sum=( &
                xpi*(ypi*fin(2,i,j)  +yp*fin(2,i,j+1))+ &
                xp*(ypi*fin(2,i+1,j)+yp*fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx2*( &
                cxi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                cx*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi

           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           !   ...and in y direction
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi

           cyd=3.0_fp*yp2-1.0_fp
           cydi=-3.0_fp*ypi2+1.0_fp
           !
           sum=hxi(v)*hyi(v)*( &
                fin(0,i,j)  -fin(0,i,j+1) &
                -fin(0,i+1,j)+fin(0,i+1,j+1))
           !
           sum=sum+sixth*hx(v)*hyi(v)*( &
                cxdi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                cxd*(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hxi(v)*hy(v)*( &
                -(cydi*fin(2,i,j)  +cyd*fin(2,i,j+1)) &
                +(cydi*fin(2,i+1,j)+cyd*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx(v)*hy(v)*( &
                cxdi*(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1))+ &
                cxd*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-------------------------------------------------
     !
  else if(ict(1).eq.3) then
     if(ict(2).eq.1) then
        !  evaluate d3f/dx3 (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           cy=yp*(yp2-1.0_fp)
           cyi=ypi*(ypi2-1.0_fp)
           hy2=hy(v)*hy(v)
           sum=hxi(v)*( &
                -(ypi*fin(1,i,j)  +yp*fin(1,i,j+1)) &
                +(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*hxi(v)*( &
                -(cyi*fin(3,i,j)  +cy*fin(3,i,j+1)) &
                +(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d3f/dx2dy
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           xp=xparam(v)
           xpi=1.0_fp-xp
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           cyd=3.0_fp*yp2-1.0_fp
           cydi=-3.0_fp*ypi2+1.0_fp
           !
           sum=hyi(v)*( &
                xpi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                xp*(-fin(1,i+1,j) +fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy(v)*( &
                xpi*(cydi*fin(3,i,j) +cyd*fin(3,i,j+1))+ &
                xp*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d3f/dxdy2
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           yp=yparam(v)
           ypi=1.0_fp-yp
           !
           sum=hxi(v)*( &
                -(ypi*fin(2,i,j)  +yp*fin(2,i,j+1)) &
                +(ypi*fin(2,i+1,j)+yp*fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*( &
                cxdi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                cxd*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if

     if(ict(5).eq.1) then
        !  evaluate d3f/dy3 (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           sum=hyi(v)*( &
                xpi*(-fin(2,i,j)  +fin(2,i,j+1))+ &
                xp*(-fin(2,i+1,j) +fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx2*hyi(v)*( &
                cxi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                cx*(-fin(3,i+1,j) +fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 4th derivatives
     !
  else if(ict(1).eq.4) then
     if(ict(2).eq.1) then
        !  evaluate d4f/dx3dy (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           yp=yparam(v)
           ypi=1.0_fp-yp
           yp2=yp*yp
           ypi2=ypi*ypi
           cyd=3.0_fp*yp2-1.0_fp
           cydi=-3.0_fp*ypi2+1.0_fp
           !
           sum=hxi(v)*hyi(v)*( &
                +( fin(1,i,j)  -fin(1,i,j+1)) &
                +(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy(v)*hxi(v)*( &
                -(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1)) &
                +(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d4f/dx2dy2
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           yp=yparam(v)
           ypi=1.0_fp-yp
           !
           sum=xpi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                xp*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d4f/dxdy3 (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           sum=hyi(v)*hxi(v)*( &
                +( fin(2,i,j)  -fin(2,i,j+1)) &
                +(-fin(2,i+1,j)+fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*hyi(v)*( &
                cxdi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                cxd*(-fin(3,i+1,j) +fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 5th derivatives
     !
  else if(ict(1).eq.5) then
     if(ict(2).eq.1) then
        !  evaluate d5f/dx3dy2 (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           yp=yparam(v)
           ypi=1.0_fp-yp
           !
           sum=hxi(v)*( &
                -(ypi*fin(3,i,j)  +yp*fin(3,i,j+1)) &
                +(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d5f/dx2dy3 (not continuous)
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           sum=hyi(v)*( &
                xpi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                xp*(-fin(3,i+1,j)+fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 6th derivatives
     !
  else if(ict(1).eq.6) then
     !  evaluate d6f/dx3dy3 (not continuous)
     iadr=iadr+1
     do v=1,ivec
        i=ii(v)
        j=jj(v)
        sum=hxi(v)*hyi(v)*( &
             +( fin(3,i,j)  -fin(3,i,j+1)) &
             +(-fin(3,i+1,j)+fin(3,i+1,j+1)))
        fval(v,iadr)=sum
     end do
  end if
  !
  return
end subroutine fvbicub
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!    --optimized for VARIATION along x axis ONLY--
!
subroutine fvbicubx(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     fin,inf2,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer ny,inf2,iadr,j,i
  !============
  real(fp) :: z36th,yp,ypi,yp2,ypi2,cy,cyi,hy2,xp,xpi,xp2,xpi2,cx
  real(fp) :: cxi,hx2,cxd,cxdi,cyd,cydi
  !============
  integer ict(6)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj               ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy                  ! grid spacing, and
  real(fp) :: hxi(ivec),hyi                ! inverse grid spacing 1/(x(i+1)-x(i))
  ! & 1/(y(j+1)-y(j))
  !
  real(fp) :: fin(0:3,inf2,ny)             ! interpolant data (cf "evbicub")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  evbicub comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Spline evaluation consists of a "mixing" of the interpolant
  !  data using the linear functionals xparam, xpi = 1-xparam,
  !  yparam, ypi = 1-yparam, and the cubic functionals
  !  xparam**3-xparam, xpi**3-xpi, yparam**3-yparam, ypi**3-ypi ...
  !  and their derivatives as needed.
  !
  integer v
  real(fp) :: sum
  !
  real(fp), parameter :: sixth = 0.166666666666666667_fp
  !
  !---------------
  !   ...in x direction
  !
  z36th=sixth*sixth
  iadr=0
  !
  if(ict(1).le.2) then
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        !
        cy=yp*(yp2-1.0_fp)
        cyi=ypi*(ypi2-1.0_fp)
        hy2=hy*hy
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           sum=xpi*(ypi*fin(0,i,j)  +yp*fin(0,i,j+1))+ &
                xp*(ypi*fin(0,i+1,j)+yp*fin(0,i+1,j+1))
           !
           sum=sum+sixth*hx2*( &
                cxi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                cx*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*( &
                xpi*(cyi*fin(2,i,j)  +cy*fin(2,i,j+1))+ &
                xp*(cyi*fin(2,i+1,j)+cy*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx2*hy2*( &
                cxi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                cx*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        !
        cy=yp*(yp2-1.0_fp)
        cyi=ypi*(ypi2-1.0_fp)
        hy2=hy*hy
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi

           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           sum=hxi(v)*( &
                -(ypi*fin(0,i,j)  +yp*fin(0,i,j+1)) &
                +(ypi*fin(0,i+1,j)+yp*fin(0,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*( &
                cxdi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                cxd*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hxi(v)*hy2*( &
                -(cyi*fin(2,i,j)  +cy*fin(2,i,j+1)) &
                +(cyi*fin(2,i+1,j)+cy*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx(v)*hy2*( &
                cxdi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                cxd*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi

        cyd=3.0_fp*yp2-1.0_fp
        cydi=-3.0_fp*ypi2+1.0_fp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           sum=hyi*( &
                xpi*(-fin(0,i,j)  +fin(0,i,j+1))+ &
                xp*(-fin(0,i+1,j)+fin(0,i+1,j+1)))
           !
           sum=sum+sixth*hx2*hyi*( &
                cxi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                cx*(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy*( &
                xpi*(cydi*fin(2,i,j)  +cyd*fin(2,i,j+1))+ &
                xp*(cydi*fin(2,i+1,j)+cyd*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx2*hy*( &
                cxi*(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1))+ &
                cx*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !
        !  d2f/dx2:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        !
        cy=yp*(yp2-1.0_fp)
        cyi=ypi*(ypi2-1.0_fp)
        hy2=hy*hy
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           sum=( &
                xpi*(ypi*fin(1,i,j)  +yp*fin(1,i,j+1))+ &
                xp*(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*( &
                xpi*(cyi*fin(3,i,j)  +cy*fin(3,i,j+1))+ &
                xp*(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dy2:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           sum=( &
                xpi*(ypi*fin(2,i,j)  +yp*fin(2,i,j+1))+ &
                xp*(ypi*fin(2,i+1,j)+yp*fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx2*( &
                cxi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                cx*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdy:
        !
        j=jj
        !
        !   ...and in y direction
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi

        cyd=3.0_fp*yp2-1.0_fp
        cydi=-3.0_fp*ypi2+1.0_fp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           !  in x direction...
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi

           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           sum=hxi(v)*hyi*( &
                fin(0,i,j)  -fin(0,i,j+1) &
                -fin(0,i+1,j)+fin(0,i+1,j+1))
           !
           sum=sum+sixth*hx(v)*hyi*( &
                cxdi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                cxd*(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hxi(v)*hy*( &
                -(cydi*fin(2,i,j)  +cyd*fin(2,i,j+1)) &
                +(cydi*fin(2,i+1,j)+cyd*fin(2,i+1,j+1)))
           !
           sum=sum+z36th*hx(v)*hy*( &
                cxdi*(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1))+ &
                cxd*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-------------------------------------------------
     !
  else if(ict(1).eq.3) then
     if(ict(2).eq.1) then
        !  evaluate d3f/dx3 (not continuous)
        j=jj
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        cy=yp*(yp2-1.0_fp)
        cyi=ypi*(ypi2-1.0_fp)
        hy2=hy*hy
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           sum=hxi(v)*( &
                -(ypi*fin(1,i,j)  +yp*fin(1,i,j+1)) &
                +(ypi*fin(1,i+1,j)+yp*fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy2*hxi(v)*( &
                -(cyi*fin(3,i,j)  +cy*fin(3,i,j+1)) &
                +(cyi*fin(3,i+1,j)+cy*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d3f/dx2dy
        j=jj
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        cyd=3.0_fp*yp2-1.0_fp
        cydi=-3.0_fp*ypi2+1.0_fp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           sum=hyi*( &
                xpi*(-fin(1,i,j)  +fin(1,i,j+1))+ &
                xp*(-fin(1,i+1,j) +fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy*( &
                xpi*(cydi*fin(3,i,j) +cyd*fin(3,i,j+1))+ &
                xp*(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d3f/dxdy2
        j=jj
        yp=yparam
        ypi=1.0_fp-yp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           sum=hxi(v)*( &
                -(ypi*fin(2,i,j)  +yp*fin(2,i,j+1)) &
                +(ypi*fin(2,i+1,j)+yp*fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*( &
                cxdi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                cxd*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if

     if(ict(5).eq.1) then
        !  evaluate d3f/dy3 (not continuous)
        iadr=iadr+1
        j=jj
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           sum=hyi*( &
                xpi*(-fin(2,i,j)  +fin(2,i,j+1))+ &
                xp*(-fin(2,i+1,j) +fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx2*hyi*( &
                cxi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                cx*(-fin(3,i+1,j) +fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 4th derivatives
     !
  else if(ict(1).eq.4) then
     if(ict(2).eq.1) then
        !  evaluate d4f/dx3dy (not continuous)
        iadr=iadr+1
        j=jj
        !
        yp=yparam
        ypi=1.0_fp-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        cyd=3.0_fp*yp2-1.0_fp
        cydi=-3.0_fp*ypi2+1.0_fp
        !
        do v=1,ivec
           i=ii(v)
           !
           sum=hxi(v)*hyi*( &
                +( fin(1,i,j)  -fin(1,i,j+1)) &
                +(-fin(1,i+1,j)+fin(1,i+1,j+1)))
           !
           sum=sum+sixth*hy*hxi(v)*( &
                -(cydi*fin(3,i,j)  +cyd*fin(3,i,j+1)) &
                +(cydi*fin(3,i+1,j)+cyd*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d4f/dx2dy2
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           j=jj
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           yp=yparam
           ypi=1.0_fp-yp
           !
           sum=xpi*(ypi*fin(3,i,j)  +yp*fin(3,i,j+1))+ &
                xp*(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(4).eq.1) then
        !  evaluate d4f/dxdy3 (not continuous)
        j=jj
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp
           !
           sum=hyi*hxi(v)*( &
                +( fin(2,i,j)  -fin(2,i,j+1)) &
                +(-fin(2,i+1,j)+fin(2,i+1,j+1)))
           !
           sum=sum+sixth*hx(v)*hyi*( &
                cxdi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                cxd*(-fin(3,i+1,j) +fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 5th derivatives
     !
  else if(ict(1).eq.5) then
     if(ict(2).eq.1) then
        !  evaluate d5f/dx3dy2 (not continuous)
        j=jj
        !
        yp=yparam
        ypi=1.0_fp-yp
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           sum=hxi(v)*( &
                -(ypi*fin(3,i,j)  +yp*fin(3,i,j+1)) &
                +(ypi*fin(3,i+1,j)+yp*fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !  evaluate d5f/dx2dy3 (not continuous)
        j=jj
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           sum=hyi*( &
                xpi*(-fin(3,i,j)  +fin(3,i,j+1))+ &
                xp*(-fin(3,i+1,j)+fin(3,i+1,j+1)))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     !-----------------------------------
     !  access to 6th derivatives
     !
  else if(ict(1).eq.6) then
     !  evaluate d6f/dx3dy3 (not continuous)
     iadr=iadr+1
     j=jj
     do v=1,ivec
        i=ii(v)
        sum=hxi(v)*hyi*( &
             +( fin(3,i,j)  -fin(3,i,j+1)) &
             +(-fin(3,i+1,j)+fin(3,i+1,j+1)))
        fval(v,iadr)=sum
     end do
  end if
  !
  return
end subroutine fvbicubx

!  tpspline -- dmc 20 Jan 1999
!
!  set up coefficients for bicubic spline with following BC's:
!  * 1st dimension:  3rd divided difference
!  * derivatives periodic in second coordinate
!  * derivatives periodic in third coordinate
!
!  for more control over boundary conditions, use tpspline or tcspline.
!
!  for evaluation of interpolant, see tcspeval.f90
!
subroutine tpspline(x,inx,th,inth,ph,inph,fspl,inf4,inf5, &
     wk,nwk,ilinx,ilinth,ilinph,ier)
  use iso_c_binding, only: fp => c_double
  !
  implicit none
  integer inx,inth,inph,inf4,inf5,nwk
  real(fp) :: x(inx),th(inth),ph(inph)
  real(fp) :: fspl(4,4,4,inf4,inf5,inph),wk(nwk)
  integer ilinx,ilinth,ilinph,ier
  !
  !  input:
  !    x(1...inx) -- abscissae, first dimension of data
  !   th(1...inth) -- abscissae, second (periodic) dimension of data
  !   ph(1...inph) -- abscissae, third (periodic) dimension of data
  !   fspl(1,1,1,1..inx,1..inth,1..inph) -- function values
  !   inf4 -- fspl dimensioning, inf4.ge.inx required.
  !   inf5 -- fspl dimensioning, inf5.ge.inth required.
  !
  !  output:
  !   fspl(*,*,*,1..inx,1..inth,1..inph) -- bicubic spline coeffs (4x4)
  !   ...fspl(1,1,1,*,*,*) is not replaced.
  !
  !   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
  !   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
  !   ilinph-- =1 on output if ph(inph) evenly spaced (tol=1e-3)
  !
  !   ier -- completion code, 0 for normal
  !
  !  workspace:
  !   wk -- must be at least 5*max(inx,inth,inph) large
  !  nwk -- size of workspace
  !
  !---------------------------------
  !  compute tricubic spline of 3d function, given values at the
  !  grid crossing points, f(1,1,1,i,j,k)=f(x(i),th(j),ph(k)).
  !
  !  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !                       and th btw th(j) and th(j+1), dt=th-th(j),
  !                       and ph btw ph(k) and ph(k+1), dp=ph-ph(k),
  !
  !   spline =
  !       f(1,1,1,i,j,k)+dx*f(2,1,1,i,j,k)+dx2*f(3,1,1,i,j,k)+dx3*f(4,1,1,i,j,k)
  !  +dt*(f(1,2,1,i,j,k)+dx*f(2,2,1,i,j,k)+dx2*f(3,2,1,i,j,k)+dx3*f(4,2,1,i,j,k))
  ! +dt2*(f(1,3,1,i,j,k)+dx*f(2,3,1,i,j,k)+dx2*f(3,3,1,i,j,k)+dx3*f(4,3,1,i,j,k))
  ! +dt3*(f(1,4,1,i,j,k)+dx*f(2,4,1,i,j,k)+dx2*f(3,4,1,i,j,k)+dx3*f(4,4,1,i,j,k))
  !        +dp*(
  !       f(1,1,2,i,j,k)+dx*f(2,1,2,i,j,k)+dx2*f(3,1,2,i,j,k)+dx3*f(4,1,2,i,j,k)
  !  +dt*(f(1,2,2,i,j,k)+dx*f(2,2,2,i,j,k)+dx2*f(3,2,2,i,j,k)+dx3*f(4,2,2,i,j,k))
  ! +dt2*(f(1,3,2,i,j,k)+dx*f(2,3,2,i,j,k)+dx2*f(3,3,2,i,j,k)+dx3*f(4,3,2,i,j,k))
  ! +dt3*(f(1,4,2,i,j,k)+dx*f(2,4,2,i,j,k)+dx2*f(3,4,2,i,j,k)+dx3*f(4,4,2,i,j,k)))
  !        +dp2*(
  !       f(1,1,3,i,j,k)+dx*f(2,1,3,i,j,k)+dx2*f(3,1,3,i,j,k)+dx3*f(4,1,3,i,j,k)
  !  +dt*(f(1,2,3,i,j,k)+dx*f(2,2,3,i,j,k)+dx2*f(3,2,3,i,j,k)+dx3*f(4,2,3,i,j,k))
  ! +dt2*(f(1,3,3,i,j,k)+dx*f(2,3,3,i,j,k)+dx2*f(3,3,3,i,j,k)+dx3*f(4,3,3,i,j,k))
  ! +dt3*(f(1,4,3,i,j,k)+dx*f(2,4,3,i,j,k)+dx2*f(3,4,3,i,j,k)+dx3*f(4,4,3,i,j,k)))
  !        +dp3*(
  !       f(1,1,4,i,j,k)+dx*f(2,1,4,i,j,k)+dx2*f(3,1,4,i,j,k)+dx3*f(4,1,4,i,j,k)
  !  +dt*(f(1,2,4,i,j,k)+dx*f(2,2,4,i,j,k)+dx2*f(3,2,4,i,j,k)+dx3*f(4,2,4,i,j,k))
  ! +dt2*(f(1,3,4,i,j,k)+dx*f(2,3,4,i,j,k)+dx2*f(3,3,4,i,j,k)+dx3*f(4,3,4,i,j,k))
  ! +dt3*(f(1,4,4,i,j,k)+dx*f(2,4,4,i,j,k)+dx2*f(3,4,4,i,j,k)+dx3*f(4,4,4,i,j,k)))
  !
  !      where dx2=dx**2 and dx3=dx**3.
  !      where dt2=dt**2 and dt3=dt**3.
  !      where dp2=dp**2 and dp3=dp**3.
  !
  !---------------------------------
  integer ierx,ierth,ierph
  real(fp) :: zdumth(inth),zdumx(inx)
  !---------------------------------
  !
  ier=0
  if(nwk.lt.5*max(inx,inth,inph)) then
     write(6,'('' ?tpspline:  workspace too small.'')')
     ier=1
  end if
  if(inx.lt.2) then
     write(6,'('' ?tpspline:  at least 2 x points required.'')')
     ier=1
  end if
  if(inth.lt.2) then
     write(6,'('' ?tpspline:  need at least 2 theta points.'')')
     ier=1
  end if
  if(inph.lt.2) then
     write(6,'('' ?tpspline:  need at least 2 phi points.'')')
     ier=1
  end if
  !
  !  check ilinx & x vector
  !
  call splinck(x,inx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?tpspline:  x axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(th,inth,ilinth,1.0E-3_fp,ierth)
  if(ierth.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?tpspline:  theta axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(ph,inph,ilinph,1.0E-3_fp,ierph)
  if(ierph.ne.0) ier=4
  !
  if(ier.eq.4) then
     write(6,'('' ?tpspline:  phi axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  !
  call tcspline(x,inx,th,inth,ph,inph,fspl,inf4,inf5, &
       7,zdumth,7,zdumth,inth, &
       -1,zdumx,-1,zdumx,inx, &
       -1,zdumx,-1,zdumx,inx, &
       wk,nwk,ilinx,ilinth,ilinph,ier)
  !
  return
end subroutine tpspline

!  utility routines for pspltsub

subroutine psp_tolsum(refval,tolval,sum)
  use iso_c_binding, only: fp => c_double

  !  difference will be detectable
  !  refval =~ 1.0; tolval =~1.0e-6

  implicit none
  real(fp) :: refval, tolval  ! input
  real(fp) :: sum             ! output

  sum = refval + tolval*tolval

  return
end subroutine psp_tolsum

      subroutine cstring(fstr,cstr,cmd)
C
C  Fortran-77 <-> C string converter
C
C  usage:  call cstring('this is a string',cstr,'2C')
C          ...fills the byte array cstr with a null terminated string
C             suitable for being passed to a C routine
C
C               **caution**
C               in  "call cstring(fstr,cstr,'2C')" trailing blanks in
C               fstr are also copied; if this is not desired use something
C               like
C                     ilstr=max(1,str_length(fstr))
C                     call cstring(fstr(1:ilstr),cstr,'2C')
C
C
C          call cstring(fstr,cstr,'2F') copies the contents of the
C                byte array cstr into fstr, stopping when a terminating
C                null is encountered or the end of fstr is reached,
C                whichever happens first.  fstr is padded with blanks.
C
C==  NB 
C     call cstring( trim(fs), cs, '2C' )
C                                       IS INVALID & WILL FAIL if compiled in debug mode-
C     "There is an assignment to dummy argument 1, which is associated with a constant, 
C     "an expression that is not a variable..." 
C
C     Use cstr_2C( trim(fs), cs, '2C' )  instead..
C
      implicit none
C
#include "fpreproc/byte_declare.h"
 
C
C  fortran string:
C
      character*(*) fstr
C
C  C string (null terminated byte array)
C
      byte_declare cstr(*)
C
C  cmd string:  "2F" for cstr->fstr copy, "2C" for fstr->cstr copy.
C
      character*2 cmd
C
C--------------------------
C  local:
C
      integer i,ilen
C------------------------------------------------
C
C
      if(cmd.eq.'2F')                             then
         fstr=' '
         do i=1,len(fstr)
#if __CRAY || __SX
            if(cstr(i).eq. char(0)) go to 10      ! stop at terminating null
            fstr(i:i)=cstr(i)
#else
            if(cstr(i).eq.0) go to 10             ! stop at terminating null
            fstr(i:i)=char(cstr(i))
#endif
         enddo
 10      continue
C
      elseif(cmd.eq.'2C')                         then
         call cstr_2C( fstr, cstr, cmd )
                                                  else
         call errmsg_exit(' ??cstring:  invalid cmd value:  '//cmd)
         call bad_exit
      endif
C
      return
      end
      subroutine cstr_2C( fstr, cstr, cmd )
C.. cstr_2C                             Legally convert trim(fstr) to cstr
C                                       codesys/source/portlib/cstring
C
C
C     Author                            Jim.Conboy@ccfe.ac.uk
C     Version                           1.00,  22Dec2008
C     Modifications
C
C     1.00  22Dec2008                   Jim.Conboy@ccfe.ac.uk
C                                       Extracted from cstring
C----_^---------------------------------=========================================|
C
      implicit  none
C
C
C..Arguments
C
      character(len=*), intent(in)   :: fstr           ! the fortran string
      byte_declare                      cstr(*)        ! the 0 terminated c string
      character(len=2), intent(in)   :: cmd            ! bkwd compatible..
C
C..local
      integer                        :: i              ! loop index 
     +                                 ,ilen           ! len string
C
C     character(len=*),parameter     :: $cr='cstr_2C'
C----_^------------------------------::================!.........................|
C
C     if( present(cmd))                then
C--      Check cmd if present, in case of editing error..
         if( cmd .ne. '2C')        then
         call errmsg_exit(' ??cstr_2C:  invalid cmd value:  '//cmd)
         call bad_exit
                                   endif
C                                      endif
C
         ilen=len(fstr)
         do i=1,ilen
#if __CRAY || __SX
            cstr(i)=fstr(i:i)
         enddo
            cstr(ilen+1)=char(0)
#else
            cstr(i)=ichar(fstr(i:i))
         enddo
         cstr(ilen+1)=0
#endif
         return
      end subroutine cstr_2C

      subroutine sget_env(varname,value)
C
C  get the value of an environment variable (UNIX) or logical name (VMS)
C
C  14Mar2005   jim.conboy@jet.uk
C              if __IDL6_FIX, use cget_env ; w/around for name conflict between
C              IDL Vn 6 & Lahey/F90 getenv functions
C
#ifdef __NAGWARE
      use f90_unix_env
#endif
C
      implicit none
C
C  input:
      character*(*) varname             ! name to be translated
C  output:
      character*(*) value               ! translation returned
C
C  local:
#if __CRAY || __NAGWARE || __VMS
      integer length,ierr
#endif
#if __IBM || __RS6000 || __IDL6_FIX || __X1
      integer iret, cget_env
#endif
C
C  value=' ' on exit, if the environment variable (logical name) is
C  undefined.
C
      integer ilvar,str_length
C
      ilvar=max(1,str_length(varname))
C
      value=' '
C
#if __IBM || __RS6000 || __IDL6_FIX || __X1
      iret = cget_env(varname(1:ilvar),value)
      if( iret.eq.0 ) value=' '
#elif __CRAY
      call pxfgetenv(varname(1:ilvar),0,value,length,ierr)
      if(ierr.ne.0) value=' '
#elif __NAGWARE
      call getenv(varname(1:ilvar),value,length,ierr)
      if(ierr.ne.0) value=' '
#elif __VMS
      call utrnlog(' ',varname(1:ilvar),value,length,ierr)
      if(ierr.ne.1) value=' '   ! 1 denotes success in VMS utrnlog
#elif __ABS
      call getenv_(varname(1:ilvar),value)
#else
      call getenv(varname(1:ilvar),value)
#endif
      call str_pad(value)
      return
      end

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Compute spline coefficients

#include "cpp/czspline_handle_size.h"

#define _S czspline_setup1
#define _O czspline1
  subroutine _S(handle, n1, f, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1
    real(fp), intent(in) :: f(n1)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_setup(self % ptr, f, ier)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_setup2
#define _O czspline2
  subroutine _S(handle, n1, n2, f, ier)
    use iso_c_binding, only: fp => c_double
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1, n2
    real(fp), intent(in) :: f(n1, n2)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_setup(self % ptr, f, ier)
  end subroutine _S
#undef _S
#undef _O

#define _S czspline_setup3
#define _O czspline3
  subroutine _S(handle, n1, n2, n3, f, ier)
    use ezspline_obj
    use ezspline
    use czspline_pointer_types
    implicit none
    integer, intent(inout) :: handle(_ARRSZ)
    integer, intent(in) :: n1, n2, n3
    real(fp), intent(in) :: f(n1, n2, n3)
    integer, intent(out) :: ier
    type(_O) :: self
    self = transfer(handle, self)
    call ezspline_setup(self % ptr, f, ier)
  end subroutine _S
#undef _S
#undef _O

C *****************************
C  DUMMY HDF Library Routines *
C *****************************
C
C These routines are linked in, unless
C LOADER_TRAILER is defined to point to netcdf libraries
C e.g.  export LOADER_TRAILER='-L/usr/local/lib -lnetcdf'
C
C 08/13/97 CAL
C
C  4/8/99 dmc -- GTRNLOG call removed (portability problem)
C                nf_open errror message shortened.
C
C
C   modification to return special error code on dummy open call
C
C Contents:
 
      integer function nf_open(filename, access, id)
      character*(*) filename
      integer       access, id
      integer  l, istat
      character*(10) tnam
 
      write(6,1001)
 1001 format(' %cdf_dummy:  NetCDF library not linked.')
 
      nf_open = -7777
      return
      end
 
      integer function nf_create(filename, access, id)
      character*(*) filename
      integer       access, id
 
      write(6,1001)
 1001     FORMAT(/
     >  '? cdf_dummy called: source/generic_dummy/cdf_dummy.for    '/
     >  '                                                          '/
     >  '      To link with ''real'' netCDF library                '/
     >  '      define LOADER_TRAILER in .transprc (or equiv)       '/
     >  '                                                          '/
     >  '      On Unix:                                            '/
     >  '      e.g.:                                               '/
     >  '      export LOADER_TRAILER=''-L/usr/local/lib -lnetcdf'' '/
     >  '                                                          '/
     >  '      On VMS:                                             '/
     >  '      re-define logical TRAILER_OPTFILE in login.com (etc)'/
     >  '      e.g.                                                '/
     >  '      assign MY_TRAILER.OPT  TRAILER_OPTFILE              '/
     >  '                                                          '/
     >  '                 ( CAL  08/13/97  )                       ')
 
      nf_create = -7777
      return
      end
C
      integer function nf_close(file_id)
      nf_close = -1
      return
      end
C
      integer function nf_inq(id, dim, nvars, ngatts, unlimid)

      nf_inq = -1
      return
      end
C
      integer function nf_inq_var(id,varid,name,xtype,ndims,dimids,nat)
      character(*)        name
      integer             dimids(1)

      nf_inq_var = -1
      return
      end
C
      integer function nf_inq_dim(id, did, dimnam, len)
      nf_inq_dim = -1
      return
      end
C
      integer function nf_inq_dimlen(id, did, len)
      nf_inq_dimlen = -1
      return
      end
C
      integer function nf_inq_dimid(id, did, len)
      nf_inq_dimid = -1
      return
      end
C
      integer function nf_inq_unlimdim(id, did)
      nf_inq_unlimdim = -1
      return
      end
C
      integer function nf_inq_varname(id, varid, nam)
      nf_inq_varname = -1
      return
      end
C
      integer function nf_inq_vardimid(id, varid, did)
      nf_inq_vardimid = -1
      return
      end
C
      integer function nf_inq_varid(id, nam, varid)
      character(*)        nam
      nf_inq_varid = -1
      return
      end
C
      integer function nf_inq_attlen(id, varid, nam, l)
      character(*)        nam
      nf_inq_attlen = -1
      return
      end
C
      integer function nf_def_var(id,nam,xtyp,ndim,vdim,vals)
      character(*)        nam
      nf_def_var = -1
      return
      end
C
      integer function  nf_def_dim(id,nam,ndim,vdim)
      character(*)        nam
      nf_def_dim = -1
      return
      end
C
      integer function nf_put_att_int(id,varid,nam,xtyp,l,ivals)
      character(*)        nam
      nf_put_att_int = -1
      return
      end
C
      integer function nf_put_att_real(id,varid,nam,xtyp,l,xvals)
      character(*)        nam
      nf_put_att_real = -1
      return
      end
C
      integer function nf_put_att_double(id,varid,nam,xtyp,l,xvals)
      character(*)        nam
      nf_put_att_double = -1
      return
      end
C
      integer function nf_put_att_text(id,varid,nam,l,text)
      character(*)        nam
      nf_put_att_text = -1
      return
      end
C
      integer function nf_put_att_int2(id,varid,nam,t,l,ival)
      character(*)        nam
      nf_put_att_int2 = -1
      return
      end
C
      integer function nf_put_var_real(id, varid, val)
      nf_put_var_real = -1
      return
      end
C
      integer function nf_put_var_int(id,varid,val)
      nf_put_var_int = -1
      return
      end
C
      integer function nf_put_var_int1(id, varid, val)
      nf_put_var_int1 = -1
      return
      end
C
      integer function nf_put_var_double(id,varid,val)
      nf_put_var_double = -1
      return
      end
C
      integer function nf_put_var_text(id,varid,val)
      nf_put_var_text = -1
      return
      end
C
      integer function nf_put_vara_int(id, varid, st,cnt,val)
      nf_put_vara_int = -1
      return
      end
C
      integer function nf_put_vara_double(id, varid, st,cnt,val)
      nf_put_vara_double = -1
      return
      end
C
      integer function nf_put_vara_text(id, varid, st, cnt, text)
      nf_put_vara_text = -1
      return
      end
C
      integer function nf_put_vara_real(id, varid, st,cnt,val)
      nf_put_vara_real = -1
      return
      end
C
      integer function nf_get_att_real(id,varid,nam,xvals)
      character(*)        nam
      nf_ get_att_real = -1
      return
      end
C
      integer function nf_get_att_double(id,varid,nam,xvals)
      character(*)        nam
      nf_ get_att_double = -1
      return
      end
C
      integer function nf_get_att_int(id,varid,nam,ivals)
      character(*)        nam
      nf_ get_att_int = -1
      return
      end
C
      integer function nf_get_att_int2(id,varid,nam,ivals)
      character(*)        nam
      nf_ get_att_int2 = -1
      return
      end
C
      integer function nf_get_att_text(id,varid,nam,text)
      character(*)        nam
      nf_get_att_text = -1
      return
      end
c
      integer function nf_get_var_real(id, vid, vals)
      nf_get_var_real = -1
      return
      end
C
      integer function nf_get_var_int1(id, vid, vals)
      nf_get_var_int1 = -1
      return
      end
C
      integer function nf_get_vara_text(id, vid, st, cnt, text)
      nf_get_vara_text = -1
      return
      end
C
      integer function nf_get_vara_real(id, vid, st, cnt, vals)
      nf_get_vara_real = -1
      return
      end
C
      integer function  nf_enddef(id)
      nf_enddef = -1
      return
      end
C
      integer function  nf_redef(id)
      nf_redef = -1
      return
      end
C
      integer function  nf_strerror(ierr)
      nf_strerror = -1
      return
      end
C
      integer function  nf_noerr(ierr)
      nf_noerr = -1
      return
      end
C
      integer function nf_inq_att(id,vid,name,itype,ilen)
      character(*)        name
      nf_inq_att = -1
      return
      end
C
      integer function nf_inq_varnatts(id,vid,inatt)
      nf_inq_varnatts = -1
      return
      end
C
      integer function nf_inq_attname(id,vid,aid,name)
      character(*)        name
      nf_inq_attname = -1
      return
      end
C
      integer function nf_rename_att(id,vid,oldname,newname)
      character(*)        oldname, newname
      nf_rename_att = -1
      return
      end
C
      integer function nf_rename_var(id,vid,newname)
      character(*)        newname
      nf_rename_var = -1
      return
      end
C
      integer function nf_inq_varndims(id,vid,ndims)
      nf_inq_varndims = -1
      return
      end
C
      integer function nf_get_var_double(id,vid,vals)
      nf_get_var_double = -1
      return
      end
C
      integer function nf_get_var_int(id,vid,ivals)
      nf_get_var_int = -1
      return
      end
C
      integer function nf_get_var_text(id,vid,cvals)
      nf_get_var_text = -1
      return
      end
C
      integer function nf_get_vara_double(id,vid,vals)
      nf_get_vara_double = -1
      return
      end
C
      integer function nf_get_vara_int(id,vid,ivals)
      nf_get_vara_int = -1
      return
      end

      subroutine null_termin(str)
      character*(*) str
C
C  append a null character to the end of a string
C  ("end" defined as in str_length:  the last non-blank character).
C
      k=str_length(str)
      if(k.lt.len(str)) then
         str(k+1:k+1)=char(0)
      endif
C
      return
      end

      subroutine isbatch(iret)
C
C  DMC 9 SEP 1991
C
c
c  this fortran routine replaces the old macro "isbatch".  This routine
c  returns IRET=1 if the current process is a batch job or spawned
c  subprocess not receiving input from a terminal; it returns IRET=0
c  if an interactive terminal is in control.
c
c  the VAX code is lifted out of SGIOF.FOR (SGLIB) by M. Thompson
c  the subroutines are lifted out of the same source -- installed in
c  the TRANSP CMSMMS system with change of name and other changes to
c  support portability of code to unix and elsewhere off the VAXs.
c
c  the UNIX code just makes its determination by calling the system
c  routine "isatty".
c
 
C  VAX CODE:
#ifdef __VMS
      character*64 trmnam
 
        IRET = 0
 
        call utrnlog(' ','SYS$COMMAND',trmnam,lnam,igood)
        if(.not.igood) then	!trmnam.eq.' '
          type *, ' %ISBATCH:  Can''t translate SYS$COMMAND'
          go to 9000
        endif
c				check device type
        call ugetdvi(trmnam(1:lnam),klass,igood)
c
        if (klass.eq.0) then
 
          IRET = 0
          type *, ' %ISBATCH:  SYS$COMMAND device type unknown'
          type 1001, trmnam(1:lnam)
 1001     format(' %ISBATCH:  SYS$COMMAND was translated as:  ',A)
 
        else if(klass.eq.2) then
 
          IRET = 0
 
        else
 
          IRET = 1
 
        endif
#endif
C
C  END VAX CODE.
C
C  UNIX CODE:
C
#ifdef __UNIX
      INTEGER FISATTY
C
      IANS=FISATTY(0)
C
      IF(IANS.EQ.1) THEN
        IRET = 0
      ELSE
        IRET = 1
      ENDIF
C
#endif
C
 9000 continue
      return
      end

  subroutine logmod_test( cFile, cLvl, istat )
  !.. logmod_test                      test logmod
  !                                    codesys/source/porttest/porttest.logmod_test.
  !
  !
  !  Author                            jim.conboy@ccfe.ak.uk
  !  Version                           1.00,  25Jan2010
  !  Modifications
  !
  !  1.00   25Jan2010                  jim.conboy@ccfe.ak.uk
  !                                    From comments in logmod.f90
  !----_^---------------------------------=========================================|
  !
  use logmod
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*),intent(in)        :: cFile          ! Name of File to open, else 'None' to skip
  character(len=*),intent(in)        :: cLvl           ! Info level, or 'df' for default
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  integer                            :: i = 47
  real*8                             :: d = 3.14159e17
  character(len=32)                  :: cBuf           ! value of $LOG_LEVEL
  !
  character(len=*),parameter         :: cSr='logmod_test'
  !----------------------------------::================!.........................|
  !
  write(*,'(3a)') cSr,' -I- testing logmod, file ',trim(cFile),' level ',trim(cLvl)
  !
  if (isOpenLog()) then
     write(*,'(a)') '!logmod_test: The log file is OPEN'
  else
     write(*,'(a)') '!logmod_test: The log file is CLOSED'
  end if

  cBuf   = cFile(:4)
  call ulower(cBuf)
  if( cBuf(:4) /= 'none' )  &
     call openLog(cFile,status='REPLACE',icpu=7,numcpu=16)     ! if not opened, logging goes to portlib_<pid>.log
  !
  cBuf = cLvl
  call ulower(cBuf) 
  if( cBuf(:2) == 'df' )                          then
     call sget_env( 'LOG_LEVEL', cBuf    )
     write(*,'(3a)') cSr,' -I- Env. Var $LOG_LEVEL = ',cBuf 
  else
     call setLogLevel(cLvl)   ! default log level = WARN_LEVEL to show warnings and errors only
  endif
  !
  write(6,'(2a,i2)')  cSr,' -I- File Log level is ', loglevel()
  !
  call infoLog("just an info message")
  call infoLog("just an info message with i = ",i)
  call infoLog("just an info message with d = ",d)
  !
  call enterLog("logmod_test")    ! convenient place to put this
  !
  call infolog( cSr, 'Info with routine name ' )
  call infolog( cSr, 'Info with routine name, i = ',i )
  !
  call warnLog("just a warn message")
  call enterLog("logmod_test::short_section")   
  call gosleep(1)
  call warnLog("just a warn message with i = ",i)
  call warnLog("just a warn message with d = ",d)
  !
  call errorLog("just an error message")
  call errorLog("just an error message with i = ",i)
  call gosleep(1)
  call errorLog("just an error message with d = ",d)
  call exitLog("logmod_test::short_section")   
  !
  call exitLog("logmod_test")    ! convenient place to put this
  !   
  call warnLog("enable buffering and no time stamps")
  !
  if (logLevel()>=INFO_LEVEL) then
    call setLogBuffered(.true.)     ! do not flush after each log message
    call setLogTime(.false.)        ! do not time stamp log messages
  !
    call infoLog("some more detailed messages")
  !
    write(logline,'(a,i2,a,e12.4)') 'vec(',i,') = ',d
    call infoLog(logline)
  !
    call setLogTime(.true.)
    call setLogBuffered(.false.)     ! flush buffers
  end if
  !   
  call warnLog("time stamps enabled")
  !
  end subroutine logmod_test

program qk_pspline

  !  ad hoc test program for pspline -- evaluate all fcn values and
  !  derivatives via ezspline and f77 traditional interfaces

  use iso_c_binding, only: fp => c_double
  use ezspline_obj
  use ezspline
  implicit NONE

  integer, parameter :: nx=51, ny=61,nz=31

  real(fp) :: x(nx),y(ny),z(nz),f(nx),ff(nx,ny),fff(nx,ny,nz)
  real(fp) :: xpkg(nx,4),ypkg(ny,4),zpkg(nz,4),zwk(16*nx*ny*nz)

  real(fp) :: fspl(4,nx),ffspl(4,4,nx,ny),fffspl(4,4,4,nx,ny,nz)

  real(fp), parameter :: c2pi = 6.2831853071795862_fp

  integer :: iper,ialg,itol,imsg

  integer :: ix,iy,iz,ier,iwarn,iwksize,idum,ilinx,iliny,ilinz
  real(fp) :: xr,yr,ztol,zdum

  type(ezspline1) :: s1
  type(ezspline2) :: s2,h20,h02
  type(ezspline3) :: s3,h220,h202,h022

  integer :: ibdy(2)

  !---------------------------------------------------------------------
  !  test data -- choose zones & offsets for tests
  !    if offsets are too close to a grid boundary, then finite-difference
  !    evaluation comparisons will fail for 3rd derivatives which are not
  !    continuous.

  integer, parameter :: ixtest = 36  ! avoid bdy zones -- continuity test...
  integer, parameter :: iytest = 15  ! avoid bdy zones -- continuity test...
  integer, parameter :: iztest = 12  ! avoid bdy zones -- continuity test...

  real(fp), parameter :: xoff = 0.9_fp
  real(fp), parameter :: yoff = 0.2_fp
  real(fp), parameter :: zoff = 0.5_fp

  real(fp) :: xtarg,ytarg,ztarg,xbrak(6),ybrak(6),zbrak(6),delx,dely,delz
  real(fp) :: zval,zvec(6),zvalp

  integer :: i1,i2,i3,itest
  integer :: ict(10)
  character(len=60) :: zlbl0,zlbl(3)
  character(len=8) :: zhdr

  real(fp) :: zsum,zorig,zdiff
  real(fp),parameter :: zsumtol8 = 1.0d-4
  real(fp),parameter :: zsumtol4 = 1.0d-3
  real(fp),parameter :: epslon = 1.0d-34

  !---------------------------------------------------------------------
  !  continuity test for values and derivatives...

  real(fp) :: xctest(9),yctest(9),zctest(9),fctest(9)
  real(fp) :: xconst(9),yconst(9),zconst(9)

  real(fp) :: ccbld(4) = (/ 0.05_fp, 0.35_fp, 0.65_fp, 0.95_fp /)

  character(len=12) :: cresult
  logical :: cflag,ccflag

  !---------------------------------------------------------------------
  !  initialization of spline objects

  call ezspline_preInit(s1)
  call ezspline_preInit(s2)
  call ezspline_preInit(s3)

  call ezspline_preInit(h20)
  call ezspline_preInit(h02)

  call ezspline_preInit(h220)
  call ezspline_preInit(h202)
  call ezspline_preInit(h022)

  ibdy=0  ! non-a-knot boundary conditions

  call ezspline_init(s1,nx,ibdy,ier)
  if(ier.ne.0) stop 101

  call ezspline_init(s2,nx,ny,ibdy,ibdy,ier)
  if(ier.ne.0) stop 102

  call ezspline_init(s3,nx,ny,nz,ibdy,ibdy,ibdy,ier)
  if(ier.ne.0) stop 103

  call ezhybrid_init(h02,nx,ny,(/0,2/), ier)  ! linear-spline
  if(ier.ne.0) stop 104

  call ezhybrid_init(h20,nx,ny,(/2,0/), ier)  ! spline-linear
  if(ier.ne.0) stop 105

  call ezhybrid_init(h022,nx,ny,nz,(/0,2,2/), ier)  ! linear-spline-spline
  if(ier.ne.0) stop 106

  call ezhybrid_init(h202,nx,ny,nz,(/2,0,2/), ier)  ! spline-linear-spline
  if(ier.ne.0) stop 107

  call ezhybrid_init(h220,nx,ny,nz,(/2,2,0/), ier)  ! spline-spline-linear
  if(ier.ne.0) stop 108

  !---------------------------------------------------------------------
  !  make grids, define fcns, make explicit splines

  iper=0  ! treat functions as non-periodic
  imsg=1  ! warn on out of bounds interpolation calls
  itol=1  ! set tolerance for even spacing & out of range errors...
  ztol=1.0e-9_fp
  idum=0
  zdum=0
  iwksize=16*nx*ny*nz

  !  make grids & associated lookup packages...

  call makex(x,nx)
  ialg=-1
  call genxpkg(nx,x,xpkg,iper,imsg,itol,ztol,ialg,ier)
  if(ier.ne.0) stop 109

  s1%x1 = x
  s2%x1 = x
  s3%x1 = x

  h02%x1 = x
  h20%x1 = x

  h022%x1 = x
  h202%x1 = x
  h220%x1 = x

  call makex(y,ny)
  ialg=-2
  call genxpkg(ny,y,ypkg,iper,imsg,itol,ztol,ialg,ier)
  if(ier.ne.0) stop 110

  s2%x2 = y
  s3%x2 = y

  h02%x2 = y
  h20%x2 = y

  h022%x2 = y
  h202%x2 = y
  h220%x2 = y

  call makex(z,nz)
  ialg=3
  call genxpkg(nz,z,zpkg,iper,imsg,itol,ztol,ialg,ier)
  if(ier.ne.0) stop 111

  s3%x3 = z

  h022%x3 = z
  h202%x3 = z
  h220%x3 = z

  !----------------------------------------------------------------
  !  make target evaluation points

  xtarg = x(ixtest)+xoff*(x(ixtest+1)-x(ixtest))
  ytarg = y(iytest)+yoff*(y(iytest+1)-y(iytest))
  ztarg = z(iztest)+zoff*(z(iztest+1)-z(iztest))

  xconst = xtarg
  yconst = ytarg
  zconst = ztarg

  delx=2*(x(ixtest+1)-x(ixtest))/100
  xbrak(1)=xtarg-delx/2
  xbrak(2)=xtarg+delx/2
  xbrak(3:6)=xtarg

  dely=2*(y(iytest+1)-y(iytest))/100
  ybrak(1:2)=ytarg
  ybrak(3)=ytarg-dely/2
  ybrak(4)=ytarg+dely/2
  ybrak(5:6)=ytarg

  delz=2*(z(iztest+1)-z(iztest))/100
  zbrak(1:4)=ztarg
  zbrak(5)=ztarg-delz/2
  zbrak(6)=ztarg+delz/2

  xctest(5)=x(ixtest)
  do ix=1,4
     xctest(ix)=(1-ccbld(ix))*x(ixtest-1)+ccbld(ix)*x(ixtest)
     xctest(5+ix)=(1-ccbld(ix))*x(ixtest)+ccbld(ix)*x(ixtest+1)
  enddo

  yctest(5)=y(iytest)
  do iy=1,4
     yctest(iy)=(1-ccbld(iy))*y(iytest-1)+ccbld(iy)*y(iytest)
     yctest(5+iy)=(1-ccbld(iy))*y(iytest)+ccbld(iy)*y(iytest+1)
  enddo

  zctest(5)=z(iztest)
  do iz=1,4
     zctest(iz)=(1-ccbld(iz))*z(iztest-1)+ccbld(iz)*z(iztest)
     zctest(5+iz)=(1-ccbld(iz))*z(iztest)+ccbld(iz)*z(iztest+1)
  enddo

  !----------------------------------------------------------------
  !  make fcns; load explicit spline arrays' data elements

  do iz=1,nz
     do iy=1,ny
        do ix=1,nx
           xr=(sqrt(3.0_fp)/2)*x(ix) - (1.0_fp/2)*y(iy)
           yr=(1.0_fp/2)*x(ix) + (sqrt(3.0_fp)/2)*y(iy)
           if(iz.eq.1) then
              if(iy.eq.1) then
                 f(ix)=cos(2*x(ix))
                 fspl(1,ix)=f(ix)
              end if
              ff(ix,iy)=sin(3*xr)*cos(2*yr)
              ffspl(1,1,ix,iy)=ff(ix,iy)
           end if
           fff(ix,iy,iz)=(cos(2*(2*z(iz)-1)*xr))**2*sin(2*(1-2*z(iz))*yr)
           fffspl(1,1,1,ix,iy,iz)=fff(ix,iy,iz)
        enddo
     enddo
  enddo

  !  make explicit spline coefficients

  call cspline(x,nx,fspl,ibdy(1),zdum,ibdy(2),zdum,zwk,iwksize,ilinx,ier)
  if(ier.ne.0) stop 112

  call bcspline(x,nx,y,ny,ffspl,nx, &
       ibdy(1),zdum,ibdy(2),zdum, &
       ibdy(1),zdum,ibdy(2),zdum, &
       zwk,iwksize,ilinx,iliny,ier)
  if(ier.ne.0) stop 113

  call tcspline(x,nx,y,ny,z,nz,fffspl,nx,ny, &
       ibdy(1),zdum,ibdy(2),zdum,idum, &
       ibdy(1),zdum,ibdy(2),zdum,idum, &
       ibdy(1),zdum,ibdy(2),zdum,idum, &
       zwk,iwksize,ilinx,iliny,ilinz,ier)
  if(ier.ne.0) stop 114

  !  set up spline objects

  call ezspline_setup(s1,f,ier); if(ier.ne.0) stop 115
  call ezspline_setup(s2,ff,ier); if(ier.ne.0) stop 116
  call ezspline_setup(s3,fff,ier); if(ier.ne.0) stop 117

  call ezspline_setup(h02,ff,ier); if(ier.ne.0) stop 118
  call ezspline_setup(h20,ff,ier); if(ier.ne.0) stop 119

  call ezspline_setup(h022,fff,ier); if(ier.ne.0) stop 120
  call ezspline_setup(h202,fff,ier); if(ier.ne.0) stop 121
  call ezspline_setup(h220,fff,ier); if(ier.ne.0) stop 122

  !---------------------------------------------------------------
  !  1d tests

  i2=0
  i3=0
  do i1=0,3
    zlbl0=' '
    zlbl=' '
    call maklbl(' <-- ',i1,i2,i3,zlbl0)

    itest=0
    if(i1.gt.0) then
      itest=itest+1
      call maklbl(' <-- finite diff. ',i1-1,i2,i3,zlbl(itest))
    end if

    !----------------
    ! 1d ezspline

    itest=0
    write(6,*) ' '
    write(6,*) ' 1d ezspline:'

    !  test continuity across grid cell bdy:
    !  continuity not expected for 3rd derivatives.

    cresult = ' '
    ccflag=.true.

    call ezspline_derivative(s1,i1,9,xctest,fctest,ier)
    if(ier.ne.0) stop 123
    call cont_eval(xctest,fctest,cresult,cflag)
    if(i1.lt.3) ccflag = ccflag.and.cflag

    if(.not.ccflag) then
      write(6,*) '...continuity: ',trim(cresult),' ???????????????????'
    else
      write(6,*) '...continuity: ',trim(cresult)
    end if

    call ezspline_derivative(s1,i1,xtarg,zval,ier)
    if(ier.ne.0) stop 124
    write(6,1001) ' value: ',zval,trim(zlbl0)
    zorig=zval

    if(i1.gt.0) then
      itest=itest+1
      write(zhdr,'(" test",i1,": ")') itest

      call ezspline_derivative(s1,i1-1,6,xbrak,zvec,ier)
      if(ier.ne.0) stop 125
      zdum=(zvec(2)-zvec(1))/delx
      write(6,1001) zhdr,zdum,trim(zlbl(itest))
      zsum=(zorig+zdum)/2
      zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
      if(zdiff.gt.zsumtol8) write(6,*) &
           ' ------> relative difference: ',zdiff,' ********************* '
    end if

    !----------------
    ! 1d non-compact spline test

    zvalp = zval

    itest=0
    write(6,*) ' '
    write(6,*) ' 1d non-compact spline:'

    call ezmake_ict1(i1,ict(1:3))
    call cspeval(xtarg,ict,zval,x,nx,ilinx,fspl,ier)
    if(ier.ne.0) stop 126
    write(6,1001) ' value: ',zval,trim(zlbl0)
    zorig=zval

    if(abs(zval-zvalp)/max(1.0_fp,abs(zval)).gt.1.0d-10) then
      write(6,*) ' +++++++++> variation: ezspline, non-compact: ', &
           zvalp,zval
    end if

    if(i1.gt.0) then
      itest=itest+1
      write(zhdr,'(" test",i1,": ")') itest

      call ezmake_ict1(i1-1,ict(1:3))
      call spvec(ict,6,xbrak,6,zvec,nx,xpkg,fspl,iwarn,ier)
      if(ier.ne.0) stop 127
      zdum=(zvec(2)-zvec(1))/delx
      write(6,1001) zhdr,zdum,trim(zlbl(itest))
      zsum=(zorig+zdum)/2
      zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
      if(zdiff.gt.zsumtol8) write(6,*) &
           ' ------> relative difference: ',zdiff,' ********************* '
    end if

  enddo

  write(6,*) ' '
  write(6,*) ' ---------------------------- '

  !---------------------------------------------------------------
  !  2d tests

  i3=0
  do i2=0,3
     do i1=0,3
        zlbl0=' '
        zlbl=' '
        call maklbl(' <-- ',i1,i2,i3,zlbl0)

        itest=0

        if(i1.gt.0) then
           itest=itest+1
           call maklbl(' <-- finite diff. ',i1-1,i2,i3,zlbl(itest))
        end if

        if(i2.gt.0) then
           itest=itest+1
           call maklbl(' <-- finite diff. ',i1,i2-1,i3,zlbl(itest))
        end if

        !----------------
        ! 2d hybrid ezspline

        if(i1.le.1) then

           itest=0
           write(6,*) ' '
           write(6,*) ' 2d ezspline (0,2) hybrid:'

           !  test continuity across grid cell bdy:
           !  continuity not expected for 3rd derivatives.

           cresult = ' '
           ccflag=.true.

           call ezspline_derivative(h02,i1,i2,9,xctest,yconst,fctest,ier)
           if(ier.ne.0) stop 128
           call cont_eval(xctest,fctest,cresult,cflag)
           if(i1.lt.1) ccflag = ccflag.and.cflag

           call ezspline_derivative(h02,i1,i2,9,xconst,yctest,fctest,ier)
           if(ier.ne.0) stop 129
           call cont_eval(yctest,fctest,cresult,cflag)
           if(i2.lt.3) ccflag = ccflag.and.cflag

           if(.not.ccflag) then
              write(6,*) '...continuity: ',trim(cresult),' ???????????????????'
           else
              write(6,*) '...continuity: ',trim(cresult)
           end if

           call ezspline_derivative(h02,i1,i2,xtarg,ytarg,zval,ier)
           if(ier.ne.0) stop 130
           write(6,1001) ' value: ',zval,trim(zlbl0)
           zorig=zval

           if(i1.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(h02,i1-1,i2,6,xbrak,ybrak,zvec,ier)
              if(ier.ne.0) stop 131
              zdum=(zvec(2)-zvec(1))/delx
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) write(6,*) &
                   ' ------> relative difference: ',zdiff,' ******************'
           end if

           if(i2.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(h02,i1,i2-1,6,xbrak,ybrak,zvec,ier)
              if(ier.ne.0) stop 132
              zdum=(zvec(4)-zvec(3))/dely
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) write(6,*) &
                   ' ------> relative difference: ',zdiff,' ******************'
           end if
        end if

        !----------------
        ! 2d hybrid ezspline

        if(i2.le.1) then

           itest=0
           write(6,*) ' '
           write(6,*) ' 2d ezspline (2,0) hybrid:'

           !  test continuity across grid cell bdy:
           !  continuity not expected for 3rd derivatives.

           cresult = ' '
           ccflag=.true.

           call ezspline_derivative(h20,i1,i2,9,xctest,yconst,fctest,ier)
           if(ier.ne.0) stop 133
           call cont_eval(xctest,fctest,cresult,cflag)
           if(i1.lt.3) ccflag = ccflag.and.cflag

           call ezspline_derivative(h20,i1,i2,9,xconst,yctest,fctest,ier)
           if(ier.ne.0) stop 134
           call cont_eval(yctest,fctest,cresult,cflag)
           if(i2.lt.1) ccflag = ccflag.and.cflag

           if(.not.ccflag) then
              write(6,*) '...continuity: ',trim(cresult),' ???????????????????'
           else
              write(6,*) '...continuity: ',trim(cresult)
           end if

           call ezspline_derivative(h20,i1,i2,xtarg,ytarg,zval,ier)
           if(ier.ne.0) stop 135
           write(6,1001) ' value: ',zval,trim(zlbl0)
           zorig=zval

           if(i1.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(h20,i1-1,i2,6,xbrak,ybrak,zvec,ier)
              if(ier.ne.0) stop 136
              zdum=(zvec(2)-zvec(1))/delx
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) write(6,*) &
                   ' ------> relative difference: ',zdiff,' ******************'
           end if

           if(i2.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(h20,i1,i2-1,6,xbrak,ybrak,zvec,ier)
              if(ier.ne.0) stop 137
              zdum=(zvec(4)-zvec(3))/dely
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) write(6,*) &
                   ' ------> relative difference: ',zdiff,' ******************'
           end if
        end if

        !----------------
        ! 2d ezspline

        itest=0
        write(6,*) ' '
        write(6,*) ' 2d ezspline:'

        !  test continuity across grid cell bdy:
        !  continuity not expected for 3rd derivatives.

        cresult = ' '
        ccflag=.true.

        call ezspline_derivative(s2,i1,i2,9,xctest,yconst,fctest,ier)
        if(ier.ne.0) stop 138
        call cont_eval(xctest,fctest,cresult,cflag)
        if(i1.lt.3) ccflag = ccflag.and.cflag

        call ezspline_derivative(s2,i1,i2,9,xconst,yctest,fctest,ier)
        if(ier.ne.0) stop 139
        call cont_eval(yctest,fctest,cresult,cflag)
        if(i2.lt.3) ccflag = ccflag.and.cflag


        if(.not.ccflag) then
           write(6,*) '...continuity: ',trim(cresult),' ???????????????????'
        else
           write(6,*) '...continuity: ',trim(cresult)
        end if

        call ezspline_derivative(s2,i1,i2,xtarg,ytarg,zval,ier)
        if(ier.ne.0) stop 140
        write(6,1001) ' value: ',zval,trim(zlbl0)
        zorig=zval

        if(i1.gt.0) then
           itest=itest+1
           write(zhdr,'(" test",i1,": ")') itest

           call ezspline_derivative(s2,i1-1,i2,6,xbrak,ybrak,zvec,ier)
           if(ier.ne.0) stop 141
           zdum=(zvec(2)-zvec(1))/delx
           write(6,1001) zhdr,zdum,trim(zlbl(itest))
           zsum=(zorig+zdum)/2
           zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
           if(zdiff.gt.zsumtol4) write(6,*) &
                ' ------> relative difference: ',zdiff,' ******************'
        end if

        if(i2.gt.0) then
           itest=itest+1
           write(zhdr,'(" test",i1,": ")') itest

           call ezspline_derivative(s2,i1,i2-1,6,xbrak,ybrak,zvec,ier)
           if(ier.ne.0) stop 142
           zdum=(zvec(4)-zvec(3))/dely
           write(6,1001) zhdr,zdum,trim(zlbl(itest))
           zsum=(zorig+zdum)/2
           zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
           if(zdiff.gt.zsumtol4) write(6,*) &
                ' ------> relative difference: ',zdiff,' ******************'
        end if

        !----------------
        ! 2d non-compact spline test

        zvalp = zval
        itest=0
        write(6,*) ' '
        write(6,*) ' 2d non-compact spline:'

        call ezmake_ict2(i1,i2,ict(1:6))
        call bcspeval(xtarg,ytarg,ict,zval,x,nx,y,ny, &
             ilinx,iliny,ffspl,nx,ier)
        if(ier.ne.0) stop 143
        write(6,1001) ' value: ',zval,trim(zlbl0)
        zorig=zval

        if(abs(zval-zvalp)/max(1.0_fp,abs(zval)).gt.1.0e-10_fp) then
           write(6,*) ' +++++++++> variation: ezspline, non-compact: ', &
                zvalp,zval
        end if

        if(i1.gt.0) then
           itest=itest+1
           write(zhdr,'(" test",i1,": ")') itest

           call ezmake_ict2(i1-1,i2,ict(1:6))
           call bcspvec(ict,6,xbrak,ybrak,6,zvec, &
                nx,xpkg,ny,ypkg,ffspl,nx,iwarn,ier)
           if(ier.ne.0) stop 144
           zdum=(zvec(2)-zvec(1))/delx
           write(6,1001) zhdr,zdum,trim(zlbl(itest))
           zsum=(zorig+zdum)/2
           zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
           if(zdiff.gt.zsumtol4) write(6,*) &
                ' ------> relative difference: ',zdiff,' ******************'
        end if

        if(i2.gt.0) then
           itest=itest+1
           write(zhdr,'(" test",i1,": ")') itest

           call ezmake_ict2(i1,i2-1,ict(1:6))
           call bcspvec(ict,6,xbrak,ybrak,6,zvec, &
                nx,xpkg,ny,ypkg,ffspl,nx,iwarn,ier)
           if(ier.ne.0) stop 145
           zdum=(zvec(4)-zvec(3))/dely
           write(6,1001) zhdr,zdum,trim(zlbl(itest))
           zsum=(zorig+zdum)/2
           zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
           if(zdiff.gt.zsumtol4) write(6,*) &
                ' ------> relative difference: ',zdiff,' ******************'
        end if

     enddo
  enddo

  write(6,*) ' '
  write(6,*) ' ---------------------------- '

  !---------------------------------------------------------------
  !  3d tests

  do i3=0,3
     do i2=0,3
        do i1=0,3
           zlbl0=' '
           zlbl=' '
           call maklbl(' <-- ',i1,i2,i3,zlbl0)

           itest=0

           if(i1.gt.0) then
              itest=itest+1
              call maklbl(' <-- finite diff. ',i1-1,i2,i3,zlbl(itest))
           end if

           if(i2.gt.0) then
              itest=itest+1
              call maklbl(' <-- finite diff. ',i1,i2-1,i3,zlbl(itest))
           end if

           if(i3.gt.0) then
              itest=itest+1
              call maklbl(' <-- finite diff. ',i1,i2,i3-1,zlbl(itest))
           end if

           !----------------
           ! 3d hybrid ezspline

           if(i1.le.1) then

              itest=0
              write(6,*) ' '
              write(6,*) ' 3d ezspline (0,2,2) hybrid:'

              !  test continuity across grid cell bdy:
              !  continuity not expected for 3rd derivatives.

              cresult = ' '
              ccflag=.true.

              call ezspline_derivative(h022,i1,i2,i3,9,xctest,yconst,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 146
              call cont_eval(xctest,fctest,cresult,cflag)
              if(i1.lt.1) ccflag = ccflag.and.cflag

              call ezspline_derivative(h022,i1,i2,i3,9,xconst,yctest,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 147
              call cont_eval(yctest,fctest,cresult,cflag)
              if(i2.lt.3) ccflag = ccflag.and.cflag

              call ezspline_derivative(h022,i1,i2,i3,9,xconst,yconst,zctest, &
                   fctest,ier)
              if(ier.ne.0) stop 148
              call cont_eval(zctest,fctest,cresult,cflag)
              if(i3.lt.3) ccflag = ccflag.and.cflag

              if(.not.ccflag) then
                 write(6,*) '...continuity: ',trim(cresult), &
                      ' ???????????????????'
              else
                 write(6,*) '...continuity: ',trim(cresult)
              end if

              call ezspline_derivative(h022,i1,i2,i3,xtarg,ytarg,ztarg,zval, &
                   ier)
              if(ier.ne.0) stop 149
              write(6,1001) ' value: ',zval,trim(zlbl0)
              zorig=zval

              if(i1.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h022,i1-1,i2,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 150
                 zdum=(zvec(2)-zvec(1))/delx
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i2.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h022,i1,i2-1,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 151
                 zdum=(zvec(4)-zvec(3))/dely
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i3.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h022,i1,i2,i3-1,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 152
                 zdum=(zvec(6)-zvec(5))/delz
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if
           end if

           !----------------
           ! 3d hybrid ezspline

           if(i2.le.1) then

              itest=0
              write(6,*) ' '
              write(6,*) ' 3d ezspline (2,0,2) hybrid:'

              !  test continuity across grid cell bdy:
              !  continuity not expected for 3rd derivatives.

              cresult = ' '
              ccflag=.true.

              call ezspline_derivative(h202,i1,i2,i3,9,xctest,yconst,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 153
              call cont_eval(xctest,fctest,cresult,cflag)
              if(i1.lt.3) ccflag = ccflag.and.cflag

              call ezspline_derivative(h202,i1,i2,i3,9,xconst,yctest,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 154
              call cont_eval(yctest,fctest,cresult,cflag)
              if(i2.lt.1) ccflag = ccflag.and.cflag

              call ezspline_derivative(h202,i1,i2,i3,9,xconst,yconst,zctest, &
                   fctest,ier)
              if(ier.ne.0) stop 155
              call cont_eval(zctest,fctest,cresult,cflag)
              if(i3.lt.3) ccflag = ccflag.and.cflag

              if(.not.ccflag) then
                 write(6,*) '...continuity: ',trim(cresult), &
                      ' ???????????????????'
              else
                 write(6,*) '...continuity: ',trim(cresult)
              end if

              call ezspline_derivative(h202,i1,i2,i3,xtarg,ytarg,ztarg,zval, &
                   ier)
              if(ier.ne.0) stop 156
              write(6,1001) ' value: ',zval,trim(zlbl0)
              zorig=zval

              if(i1.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h202,i1-1,i2,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 157
                 zdum=(zvec(2)-zvec(1))/delx
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i2.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h202,i1,i2-1,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 158
                 zdum=(zvec(4)-zvec(3))/dely
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i3.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h202,i1,i2,i3-1,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 159
                 zdum=(zvec(6)-zvec(5))/delz
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if
           end if

           !----------------
           ! 3d hybrid ezspline

           if(i3.le.1) then

              itest=0
              write(6,*) ' '
              write(6,*) ' 3d ezspline (2,2,0) hybrid:'

              !  test continuity across grid cell bdy:
              !  continuity not expected for 3rd derivatives.

              cresult = ' '
              ccflag=.true.

              call ezspline_derivative(h220,i1,i2,i3,9,xctest,yconst,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 160
              call cont_eval(xctest,fctest,cresult,cflag)
              if(i1.lt.3) ccflag = ccflag.and.cflag

              call ezspline_derivative(h220,i1,i2,i3,9,xconst,yctest,zconst, &
                   fctest,ier)
              if(ier.ne.0) stop 161
              call cont_eval(yctest,fctest,cresult,cflag)
              if(i2.lt.3) ccflag = ccflag.and.cflag

              call ezspline_derivative(h220,i1,i2,i3,9,xconst,yconst,zctest, &
                   fctest,ier)
              if(ier.ne.0) stop 162
              call cont_eval(zctest,fctest,cresult,cflag)
              if(i3.lt.1) ccflag = ccflag.and.cflag

              if(.not.ccflag) then
                 write(6,*) '...continuity: ',trim(cresult), &
                      ' ???????????????????'
              else
                 write(6,*) '...continuity: ',trim(cresult)
              end if

              call ezspline_derivative(h220,i1,i2,i3,xtarg,ytarg,ztarg,zval, &
                   ier)
              if(ier.ne.0) stop 163
              write(6,1001) ' value: ',zval,trim(zlbl0)
              zorig=zval

              if(i1.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h220,i1-1,i2,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 164
                 zdum=(zvec(2)-zvec(1))/delx
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i2.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h220,i1,i2-1,i3,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 165
                 zdum=(zvec(4)-zvec(3))/dely
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if

              if(i3.gt.0) then
                 itest=itest+1
                 write(zhdr,'(" test",i1,": ")') itest

                 call ezspline_derivative(h220,i1,i2,i3-1,6,xbrak,ybrak,zbrak,&
                      zvec,ier)
                 if(ier.ne.0) stop 166
                 zdum=(zvec(6)-zvec(5))/delz
                 write(6,1001) zhdr,zdum,trim(zlbl(itest))
                 zsum=(zorig+zdum)/2
                 zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
                 if(zdiff.gt.zsumtol4) then
                    write(6,*) &
                         ' ------> relative difference: ',zdiff, &
                         ' ******************'
                 end if
              end if
           end if

           !----------------
           ! 3d ezspline

           itest=0
           write(6,*) ' '
           write(6,*) ' 3d ezspline:'

           !  test continuity across grid cell bdy:
           !  continuity not expected for 3rd derivatives.

           cresult = ' '
           ccflag=.true.

           call ezspline_derivative(s3,i1,i2,i3,9,xctest,yconst,zconst, &
                fctest,ier)
           if(ier.ne.0) stop 167
           call cont_eval(xctest,fctest,cresult,cflag)
           if(i1.lt.3) ccflag = ccflag.and.cflag

           call ezspline_derivative(s3,i1,i2,i3,9,xconst,yctest,zconst, &
                fctest,ier)
           if(ier.ne.0) stop 168
           call cont_eval(yctest,fctest,cresult,cflag)
           if(i2.lt.3) ccflag = ccflag.and.cflag

           call ezspline_derivative(s3,i1,i2,i3,9,xconst,yconst,zctest, &
                fctest,ier)
           if(ier.ne.0) stop 169
           call cont_eval(zctest,fctest,cresult,cflag)
           if(i3.lt.3) ccflag = ccflag.and.cflag

           if(.not.ccflag) then
              write(6,*) '...continuity: ',trim(cresult),' ???????????????????'
           else
              write(6,*) '...continuity: ',trim(cresult)
           end if

           call ezspline_derivative(s3,i1,i2,i3,xtarg,ytarg,ztarg,zval,ier)
           if(ier.ne.0) stop 170
           write(6,1001) ' value: ',zval,trim(zlbl0)
           zorig=zval

           if(i1.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(s3,i1-1,i2,i3,6,xbrak,ybrak,zbrak, &
                   zvec,ier)
              if(ier.ne.0) stop 171
              zdum=(zvec(2)-zvec(1))/delx
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

           if(i2.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(s3,i1,i2-1,i3,6,xbrak,ybrak,zbrak, &
                   zvec,ier)
              if(ier.ne.0) stop 172
              zdum=(zvec(4)-zvec(3))/dely
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

           if(i3.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezspline_derivative(s3,i1,i2,i3-1,6,xbrak,ybrak,zbrak, &
                   zvec,ier)
              if(ier.ne.0) stop 173
              zdum=(zvec(6)-zvec(5))/delz
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

           !----------------
           ! 3d non-compact spline test

           zvalp = zval

           itest=0
           write(6,*) ' '
           write(6,*) ' 3d non-compact spline:'

           call ezmake_ict3(i1,i2,i3,ict(1:10))
           call tcspeval(xtarg,ytarg,ztarg,ict,zval,x,nx,y,ny,z,nz, &
                ilinx,iliny,ilinz,fffspl,nx,ny,ier)
           if(ier.ne.0) stop 174
           write(6,1001) ' value: ',zval,trim(zlbl0)
           zorig=zval

           if(abs(zval-zvalp)/max(1.0_fp,abs(zval)).gt.1.0d-10) then
              write(6,*) ' +++++++++> variation: ezspline, non-compact: ', &
                   zvalp,zval
           end if

           if(i1.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezmake_ict3(i1-1,i2,i3,ict(1:10))
              call tcspvec(ict,6,xbrak,ybrak,zbrak,6,zvec, &
                   nx,xpkg,ny,ypkg,nz,zpkg,fffspl,nx,ny,iwarn,ier)
              if(ier.ne.0) stop 175
              zdum=(zvec(2)-zvec(1))/delx
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

           if(i2.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezmake_ict3(i1,i2-1,i3,ict(1:10))
              call tcspvec(ict,6,xbrak,ybrak,zbrak,6,zvec, &
                   nx,xpkg,ny,ypkg,nz,zpkg,fffspl,nx,ny,iwarn,ier)
              if(ier.ne.0) stop 176
              zdum=(zvec(4)-zvec(3))/dely
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

           if(i3.gt.0) then
              itest=itest+1
              write(zhdr,'(" test",i1,": ")') itest

              call ezmake_ict3(i1,i2,i3-1,ict(1:10))
              call tcspvec(ict,6,xbrak,ybrak,zbrak,6,zvec, &
                   nx,xpkg,ny,ypkg,nz,zpkg,fffspl,nx,ny,iwarn,ier)
              if(ier.ne.0) stop 177
              zdum=(zvec(6)-zvec(5))/delz
              write(6,1001) zhdr,zdum,trim(zlbl(itest))
              zsum=(zorig+zdum)/2
              zdiff=abs(zdum-zorig)/max(epslon,abs(zsum))
              if(zdiff.gt.zsumtol4) then
                 write(6,*) &
                      ' ------> relative difference: ',zdiff,' ******************'
              end if
           end if

        enddo
     enddo
  enddo

1001 format(1x,a,1x,1pe13.6,1x,a)

contains
  subroutine makex(grid,ngrid)

    integer, intent(in) :: ngrid  ! ** should be odd number **
    real(fp), intent(out) :: grid(ngrid)

    !  make unevenly spaced grid...

    integer :: inm1,igrid,ii,ictr,ilocal

    !-----------------------------

    grid(1)=0.0_fp
    grid(ngrid)=c2pi

    inm1=ngrid-1  ! even number
    ilocal=3*(inm1/2)

    ictr=0
    igrid=1

    do ii=1,ilocal-1
      ictr=ictr+1
      if(ictr.eq.3) then
        ictr=0
        cycle
      else
        igrid=igrid+1
        if(igrid.ge.ngrid) cycle
        grid(igrid)=ii*c2pi/ilocal
      end if
    enddo

  end subroutine makex

  subroutine maklbl(prefix,i1,i2,i3,res)
    character(len=*), intent(in) :: prefix  ! first part of label
    integer,intent(in) :: i1,i2,i3 ! differentiations per coordinate (0:3)
    character(len=*), intent(out) :: res

    !------------------------
    ! local:
    integer :: isum,ilen
    character(len=3) :: cdx,cdy,cdz
    !------------------------

    isum=i1+i2+i3

    cdx=' '
    if(i1.eq.1) cdx='dx'
    if(i1.gt.1) write(cdx,'("dx",i1)') i1
    cdy=' '
    if(i2.eq.1) cdy='dy'
    if(i2.gt.1) write(cdy,'("dy",i1)') i2
    cdz=' '
    if(i3.eq.1) cdz='dz'
    if(i3.gt.1) write(cdz,'("dz",i1)') i3

    res=' '
    if(isum.eq.0) then
      res = prefix//'f'
    else if(isum.eq.1) then
      res = prefix//'df/'
    else
      write(res,'(a,"d",i1,"f/")') prefix,isum
    end if

    ilen=len(trim(res))

    if(cdx.ne.' ') then
      res(ilen+1:)=cdx
      ilen=len(trim(res))
    end if

    if(cdy.ne.' ') then
      res(ilen+1:)=cdy
      ilen=len(trim(res))
    end if

    if(cdz.ne.' ') then
      res(ilen+1:)=cdz
      ilen=len(trim(res))
    end if

  end subroutine maklbl

  subroutine cont_eval(x,f,clbl,flag)

    !  continuity tester:
    !    cubic extrapolation of f(1:4) to f(5) and 
    !     back extrapolation of f(6:9) to f(5) should match for derivatives
    !     of max order 2 or less; if match occurs append "Yes" else "No" to
    !     the result string "clbl"; also set "flag" accordingly...

    real(fp), intent(in) :: x(9),f(9)
    character(len=*), intent(inout) :: clbl
    logical, intent(out) :: flag

    !--------
    !  local:

    integer :: insert
    real(fp) :: ans1,ans2,ans3,zdenom,zdiff
    !--------
    !  clear clbl to end; prepare to insert result string

    if(clbl.eq.' ') then
      insert=1
    else
      insert=2+len(trim(clbl))  ! leave a blank space
    end if
    clbl(insert:len(clbl))=' '

    ans3 = f(5)

    !--------
    !  compute 1st cubic extrapolation

    call extrap(f(1),x(2)-x(1),f(2),x(3)-x(1),f(3),x(4)-x(1),f(4), &
         x(5)-x(1),ans1)

    !--------
    !  compute 2nd cubic extrapolation

    call extrap(f(9),x(9)-x(8),f(8),x(9)-x(7),f(7),x(9)-x(6),f(6), &
         x(9)-x(5),ans2)

    !--------
    zdenom=max(1.0_fp,abs(ans1),abs(ans2),abs(ans3))

    zdiff=max(abs(ans1-ans2),abs(ans1-ans3),abs(ans2-ans3))

    if((zdiff/zdenom).gt.1.0e-10_fp) then
      clbl(insert:insert+1)='No'
      flag=.false.
    else
      clbl(insert:insert+2)='Yes'
      flag=.true.
    end if

  end subroutine cont_eval

  subroutine extrap(f0,x1,f1,x2,f2,x3,f3,xans,ans)
    ! cubic extrapolation
    !   (0,f0),(x1,f1),(x2,f2),(x3,f3) --> (xans,ans)

    real(fp), intent(in) :: f0,x1,f1,x2,f2,x3,f3,xans
    real(fp), intent(out) :: ans

    real(fp) :: d1,d2,d3,a,b,c,r1,r2,s

    d1=f1-f0
    d2=f2-f0
    d3=f3-f0

    !  f(x) = a*x**3 + b*x**2 + c*x + f0  --  3 unknowns to solve for...

    r1=x2/x1; r1=r1*r1*r1
    r2=x3/x1; r2=r2*r2*r2

    s=(x3*x3-r2*x1*x1)/(x2*x2-r1*x1*x1)

    c=(d3-r2*d1-s*d2+s*r1*d1)/(x3-r2*x1-s*x2+s*r1*x1)
    b=(d2-r1*d1-c*(x2-r1*x1))/(x2*x2-r1*x1*x1)
    a=(d1-c*x1-b*x1*x1)/(x1*x1*x1)

    !! write(6,*) ' f(x1)=',f0+x1*(c+x1*(b+x1*a)),' = ',f1
    !! write(6,*) ' f(x2)=',f0+x2*(c+x2*(b+x2*a)),' = ',f2
    !! write(6,*) ' f(x3)=',f0+x3*(c+x3*(b+x3*a)),' = ',f3

    !  done.
    !  compute answer

    ans = f0 + xans*(c + xans*(b + xans*a))

  end subroutine extrap

end program qk_pspline

      subroutine sset_cwd(dir,ierr)
      character*(*) dir                 ! directory to cd to...
      integer ierr                      ! error status code, 0 = normal
 
#include "fpreproc/byte_declare.h"
      byte_declare dirbuf(256)
 
      integer chdir
      integer str_length,ild
C
      ild=max(1,str_length(dir))
#ifdef __VMS
      write(6,*) ' ?sset_cwd:  VMS:  cannot change directory.'
      ierr = 1                          ! VMS:  no can do
#endif
#ifdef __UNIX
 
#ifdef __CRAY
      call pxfchdir(dir,0,ierr)
#elif __HP || __IBM || __RS6000
      ierr = chdir(dir(1:ild)//char(0))
#else
      if(ild.le.255) then
         call cstring(dir(1:ild),dirbuf,'2C')
         ierr = linux_chdir(dirbuf)
      else
         write(6,*) ' ?sset_ccwd:  directory path too long:'
         write(6,*) dir(1:ild)
         ierr=1
      endif
#endif
 
#endif  /*  __UNIX  */
 
      return
      end
 

subroutine pc3ev(xget,yget,zget,x,nx,y,ny,z,nz, &
     ilinx,iliny,ilinz, &
     f,inf2,inf3,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  evaluate a trilinear interpolant on a rectilinear grid
  !  derivatives are available, but, not continuous across grid planes.
  !
  !  this subroutine calls two subroutines:
  !     herm3xyz  -- find cell containing (xget,yget,zget)
  !     pc3fcn -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  !============
  implicit none
  integer ny,nz,inf2,inf3,nx
  !============
  real(fp) :: xget,yget,zget               ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  real(fp) :: z(nz)                        ! ordered z grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  integer iliny                     ! iliny=1 => assume y evenly spaced
  integer ilinz                     ! ilinz=1 => assume z evenly spaced
  !
  real(fp) :: f(inf2,inf3,nz)              ! function data
  !
  !       f 2nd dimension inf2 must be .ge. nx; 3rd dim inf3 .ge. ny
  !       contents of f:
  !
  !  f(i,j,k) = f @ x(i),y(j),z(k)
  !
  integer ict(8)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return df/dz  (0, don't)
  !  ict(5)=1 -- return d2f/dxdy  (0, don't)
  !  ict(6)=1 -- return d2f/dxdz  (0, don't)
  !  ict(7)=1 -- return d2f/dydz  (0, don't)
  !  ict(8)=1 -- return d3f/dxdydz  (0, don't)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the 4th output (depends on ict(...) spec)
  !  fval(5-8) receive 5th thru 8th outputs (if required by ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,1,0,0,0,0]
  !   on output fval= [f,df/dx,df/dy,df/dz]
  !
  !    on input ict = [1,0,0,0,0,0,0,0]
  !   on output fval= [f] ... elements 2-8 never referenced
  !
  !    on input ict = [0,1,1,0,0,0,0,0]
  !   on output fval= [df/dx,df/dy] ... elements 3-8 never referenced
  !
  !    on input ict = [0,0,0,0,1,0,0,0]
  !   on output fval= [d2f/dxdy] ... elements 2-8 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j,k  ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !    zparam=0 @z(k)  zparam=1 @z(k+1)
  !
  real(fp), dimension(1) :: xparam,yparam,zparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy,hz
  real(fp), dimension(1) :: hxi,hyi,hzi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !  0 .le. zparam .le. 1
  !
  !---------------------------------------------------------------------
  !
  call herm3xyz(xget,yget,zget,x,nx,y,ny,z,nz,ilinx,iliny,ilinz, &
       i(1),j(1),k(1),xparam(1),yparam(1),zparam(1), &
       hx(1),hxi(1),hy(1),hyi(1),hz(1),hzi(1),ier)
  if(ier.ne.0) return
  !
  call pc3fcn(ict,1,1, &
       fval,i,j,k,xparam,yparam,zparam, &
       hx,hxi,hy,hyi,hz,hzi, &
       f,inf2,inf3,nz)
  !
  return
end subroutine pc3ev
!---------------------------------------------------------------------
!  evaluate trilinear function interpolation -- 3d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine pc3fcn(ict,ivec,ivecd, &
     fval,ii,jj,kk,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi, &
     fin,inf2,inf3,nz)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inf3,nz,inf2,i,j,k,iadr
  !============
  real(fp) :: xp,xpi,yp,ypi,zp,zpi
  !============
  integer ict(8)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec),kk(ivec) ! target cells (i,j,k)
  real(fp) :: xparam(ivec),yparam(ivec),zparam(ivec)
  ! normalized displacements from (i,j,k) corners
  !
  real(fp) :: hx(ivec),hy(ivec),hz(ivec)   ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec),hzi(ivec) ! inverse grid spacing
  ! 1/(x(i+1)-x(i)) & 1/(y(j+1)-y(j)) & 1/(z(k+1)-z(i))
  !
  real(fp) :: fin(inf2,inf3,nz)            ! interpolant data (cf "pc3ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine pc3ev
  !  comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj,kk and parameter inputs
  !     xparam,yparam,zparam,hx,hxi,hy,hyi,hz,hzi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !
  real(fp) :: sum
  integer v
  !
  do v=1,ivec
     i=ii(v)
     j=jj(v)
     k=kk(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     !
     !   ...in y direction
     !
     yp=yparam(v)
     ypi=1.0_fp-yp
     !
     !   ...in z direction
     !
     zp=zparam(v)
     zpi=1.0_fp-zp
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=zpi*( &
             xpi*(ypi*fin(i,j,k)  +yp*fin(i,j+1,k))+ &
             xp*(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +zp*( &
             xpi*(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1))+ &
             xp*(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        sum=zpi*( &
             -(ypi*fin(i,j,k)  +yp*fin(i,j+1,k)) &
             +(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +zp*( &
             -(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1)) &
             +(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        sum=zpi*( &
             xpi*(-fin(i,j,k)  +fin(i,j+1,k))+ &
             xp*(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +zp*( &
             xpi*(-fin(i,j,k+1)  +fin(i,j+1,k+1))+ &
             xp*(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hyi(v)
     end if
     !
     if(ict(4).eq.1) then
        !
        !  df/dz:
        !
        iadr=iadr+1
        sum=   -( &
             xpi*(ypi*fin(i,j,k)  +yp*fin(i,j+1,k))+ &
             xp*(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +( &
             xpi*(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1))+ &
             xp*(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hzi(v)
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        sum=zpi*( &
             -(-fin(i,j,k)  +fin(i,j+1,k)) &
             +(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +zp*( &
             -(-fin(i,j,k+1)  +fin(i,j+1,k+1)) &
             +(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hyi(v)
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdz:
        !
        iadr=iadr+1
        sum=  -( &
             -(ypi*fin(i,j,k)  +yp*fin(i,j+1,k)) &
             +(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +( &
             -(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1)) &
             +(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hzi(v)
     end if
     !
     if(ict(7).eq.1) then
        !
        !  d2f/dydz:
        !
        iadr=iadr+1
        sum=  -( &
             xpi*(-fin(i,j,k)  +fin(i,j+1,k))+ &
             xp*(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +( &
             xpi*(-fin(i,j,k+1)  +fin(i,j+1,k+1))+ &
             xp*(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hyi(v)*hzi(v)
     end if
     !
     if(ict(8).eq.1) then
        !
        !  d3f/dxdydz:
        !
        iadr=iadr+1
        sum=  -( &
             -(-fin(i,j,k)  +fin(i,j+1,k)) &
             +(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +( &
             -(-fin(i,j,k+1)  +fin(i,j+1,k+1)) &
             +(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hyi(v)*hzi(v)
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine pc3fcn
!---------------------------------------------------------------------
!  evaluate trilinear function interpolation -- 3d fcn
!   --vectorized-- dmc 10 Feb 1999
!    --optimized for VARIATION along x axis ONLY--
!
subroutine pc3fcnx(ict,ivec,ivecd, &
     fval,ii,jj,kk,xparam,yparam,zparam, &
     hx,hxi,hy,hyi,hz,hzi, &
     fin,inf2,inf3,nz)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inf3,nz,inf2,j,k,i,iadr
  !============
  real(fp) :: yp,ypi,zp,zpi,xp,xpi
  !============
  integer ict(8)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj,kk ! target cells (i,j,k)
  real(fp) :: xparam(ivec),yparam,zparam
  ! normalized displacements from (i,j,k) corners
  !
  real(fp) :: hx(ivec),hy,hz               ! grid spacing, and
  real(fp) :: hxi(ivec),hyi,hzi            ! inverse grid spacing
  ! 1/(x(i+1)-x(i)) & 1/(y(j+1)-y(j)) & 1/(z(k+1)-z(i))
  !
  real(fp) :: fin(inf2,inf3,nz)            ! interpolant data (cf "pc3ev")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine pc3ev
  !  comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj,kk and parameter inputs
  !     xparam,yparam,zparam,hx,hxi,hy,hyi,hz,hzi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !
  real(fp) :: sum
  integer v
  !
  j=jj
  k=kk
  !
  !   ...in y direction
  !
  yp=yparam
  ypi=1.0_fp-yp
  !
  !   ...in z direction
  !
  zp=zparam
  zpi=1.0_fp-zp

  do v=1,ivec
     i=ii(v)
     !
     !   ...in x direction
     !
     xp=xparam(v)
     xpi=1.0_fp-xp
     !
     iadr=0
     !
     !  get desired values:
     !
     if(ict(1).eq.1) then
        !
        !  function value:
        !
        iadr=iadr+1
        sum=zpi*( &
             xpi*(ypi*fin(i,j,k)  +yp*fin(i,j+1,k))+ &
             xp*(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +zp*( &
             xpi*(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1))+ &
             xp*(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        sum=zpi*( &
             -(ypi*fin(i,j,k)  +yp*fin(i,j+1,k)) &
             +(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +zp*( &
             -(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1)) &
             +(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)
     end if
     !
     if(ict(3).eq.1) then
        !
        !  df/dy:
        !
        iadr=iadr+1
        sum=zpi*( &
             xpi*(-fin(i,j,k)  +fin(i,j+1,k))+ &
             xp*(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +zp*( &
             xpi*(-fin(i,j,k+1)  +fin(i,j+1,k+1))+ &
             xp*(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hyi
     end if
     !
     if(ict(4).eq.1) then
        !
        !  df/dz:
        !
        iadr=iadr+1
        sum=   -( &
             xpi*(ypi*fin(i,j,k)  +yp*fin(i,j+1,k))+ &
             xp*(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +( &
             xpi*(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1))+ &
             xp*(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hzi
     end if
     !
     if(ict(5).eq.1) then
        !
        !  d2f/dxdy:
        !
        iadr=iadr+1
        sum=zpi*( &
             -(-fin(i,j,k)  +fin(i,j+1,k)) &
             +(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +zp*( &
             -(-fin(i,j,k+1)  +fin(i,j+1,k+1)) &
             +(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hyi
     end if
     !
     if(ict(6).eq.1) then
        !
        !  d2f/dxdz:
        !
        iadr=iadr+1
        sum=  -( &
             -(ypi*fin(i,j,k)  +yp*fin(i,j+1,k)) &
             +(ypi*fin(i+1,j,k)+yp*fin(i+1,j+1,k))) &
             +( &
             -(ypi*fin(i,j,k+1)  +yp*fin(i,j+1,k+1)) &
             +(ypi*fin(i+1,j,k+1)+yp*fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hzi
     end if
     !
     if(ict(7).eq.1) then
        !
        !  d2f/dydz:
        !
        iadr=iadr+1
        sum=  -( &
             xpi*(-fin(i,j,k)  +fin(i,j+1,k))+ &
             xp*(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +( &
             xpi*(-fin(i,j,k+1)  +fin(i,j+1,k+1))+ &
             xp*(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hyi*hzi
     end if
     !
     if(ict(8).eq.1) then
        !
        !  d3f/dxdydz:
        !
        iadr=iadr+1
        sum=  -( &
             -(-fin(i,j,k)  +fin(i,j+1,k)) &
             +(-fin(i+1,j,k)+fin(i+1,j+1,k))) &
             +( &
             -(-fin(i,j,k+1)  +fin(i,j+1,k+1)) &
             +(-fin(i+1,j,k+1)+fin(i+1,j+1,k+1)))
        !
        fval(v,iadr)=sum*hxi(v)*hyi*hzi
     end if
     !
  end do                             ! vector loop
  !
  return
end subroutine pc3fcnx

subroutine evintrp2d(xget,yget,x,nx,y,ny,jspline, &
     f,icoeff,ixdim,iydim,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !
  !  evaluate a 2d Hybrid interpolant on a rectilinear grid
  !
  !  this subroutine calls three subroutines:
  !     vecin2d_argchk -- error check
  !     herm2xy  -- find cell containing (xget,yget)
  !     fvintrp2d  -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  implicit none
  real(fp) :: xget,yget                    ! target of this interpolation
  integer nx,ny                     ! grid sizes
  real(fp) :: x(nx)                        ! ordered x grid
  real(fp) :: y(ny)                        ! ordered y grid
  !
  integer :: jspline(2)             ! interpolation method for each
  !           dimension: jspline(1) for x; jspline(2) for y
  !           =-1: zonal step function; =0: pc lin; =1: Hermite; =2: Spline
  !
  integer :: icoeff                 ! no. of coefficients per data point

  integer :: ixdim,iydim            ! dimensioning:
  !  ixdim=nx-1 for zonal step in x; otherwise nx
  !  iydim=ny-1 for zonal step in y; otherwise ny

  real(fp) :: f(icoeff,ixdim,iydim)        ! function data w/coefficients
  !
  integer ict(6)                    ! code specifying output desired
  !
  !  Note on derivatives: for dimensions along which zonal step function
  !    interpolation is done, ANY derivative request returns ZERO.
  !    For dimensions along which piecewise linear or Hermite interpolation
  !    are done, more than one differentiation returns ZERO!
  !
  !  Derivative controls are the same as for the compact 2d spline evaluation
  !  routine (evbicub):
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return df/dy  (0, don't)
  !  ict(4)=1 -- return d2f/dx2  (0, don't)
  !  ict(5)=1 -- return d2f/dy2  (0, don't)
  !  ict(6)=1 -- return d2f/dxdy (0, don't)
  !                   the number of non zero values ict(1:6)
  !                   determines the number of outputs...
  !
  !  new dmc December 2005 -- access to higher derivatives (even if not
  !  continuous-- but can only go up to 3rd derivatives on any one coordinate.
  !     if ict(1)=3 -- want 3rd derivatives
  !          ict(2)=1 for d3f/dx3
  !          ict(3)=1 for d3f/dx2dy
  !          ict(4)=1 for d3f/dxdy2
  !          ict(5)=1 for d3f/dy3
  !               number of non-zero values ict(2:5) gives no. of outputs
  !     if ict(1)=4 -- want 4th derivatives
  !          ict(2)=1 for d4f/dx3dy
  !          ict(3)=1 for d4f/dx2dy2
  !          ict(4)=1 for d4f/dxdy3
  !               number of non-zero values ict(2:4) gives no. of outputs
  !     if ict(1)=5 -- want 5th derivatives
  !          ict(2)=1 for d5f/dx3dy2
  !          ict(3)=1 for d5f/dx2dy3
  !               number of non-zero values ict(2:3) gives no. of outputs
  !     if ict(1)=6 -- want 6th derivatives
  !          d6f/dx3dy3 -- one value is returned.
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(6)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !  fval(4) receives the fourth output (depends on ict(...) spec)
  !  fval(5) receives the fifth output (depends on ict(...) spec)
  !  fval(6) receives the sixth output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1,0,0,1]
  !   on output fval= [f,df/dx,df/dy,d2f/dxdy], elements 5 & 6 not referenced.
  !
  !    on input ict = [1,0,0,0,0,0]
  !   on output fval= [f] ... elements 2 -- 6 never referenced.
  !
  !    on input ict = [0,0,0,1,1,0]
  !   on output fval= [d2f/dx2,d2f/dy2] ... elements 3 -- 6 never referenced.
  !
  !    on input ict = [0,0,1,0,0,0]
  !   on output fval= [df/dy] ... elements 2 -- 6 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer, dimension(1) :: i,j  ! cell indices
  !
  !  normalized displacement from (x(i),y(j)) corner of cell.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !    yparam=0 @y(j)  yparam=1 @y(j+1)
  !
  real(fp), dimension(1) :: xparam,yparam
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i)), hyi = 1/(y(j+1)-y(j))
  !
  real(fp), dimension(1) :: hx,hy
  real(fp), dimension(1) :: hxi,hyi
  !
  !  0 .le. xparam .le. 1
  !  0 .le. yparam .le. 1
  !
  !  ** the interface is very similar to herm2ev.f90; can use herm2xy **
  !---------------------------------------------------------------------
  !
  call vecin2d_argchk('evintrp2d',jspline, &
       icoeff,nx,ny,ixdim,iydim,ier)
  if(ier.ne.0) return
  !
  call herm2xy(xget,yget,x,nx,y,ny,0,0, &
       i(1),j(1),xparam(1),yparam(1), &
       hx(1),hxi(1),hy(1),hyi(1),ier)
  if(ier.ne.0) return
  !
  call fvintrp2d(ict,1,1, &
       fval,i,j,xparam,yparam,hx,hxi,hy,hyi, &
       jspline,f,icoeff,ixdim,iydim)
  !
  return
end subroutine evintrp2d
!---------------------------------------------------------------------
!  evaluate Hybrid function interpolation -- 2d fcn
!   NO ERROR CHECKING
!
subroutine fvintrp2d(ict,ivec,ivecd, &
     fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
     jspline,fin,icoeff,ixdim,iydim)
  use iso_c_binding, only: fp => c_double
  !
  !
  implicit none
  integer ict(6)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec),jj(ivec)         ! target cells (i,j)
  real(fp) :: xparam(ivec),yparam(ivec)
  ! normalized displacements from (i,j) corners
  !
  real(fp) :: hx(ivec),hy(ivec)     ! grid spacing, and
  real(fp) :: hxi(ivec),hyi(ivec)   ! inverse grid spacing 1/(x(i+1)-x(i)) and 1/(y(j+1)-y(j))
  !
  integer :: jspline(2)             ! interpolation type control
  integer :: icoeff                 ! coefficient dimension
  integer :: ixdim,iydim            ! x & y dimensions
  real(fp) :: fin(icoeff,ixdim,iydim)      ! data on which to interpolate...
  !
  real(fp) :: fval(ivecd,6)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  evintrp2d comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii,jj and parameter inputs
  !     xparam,yparam,hx,hxi,hy,hyi are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  local:
  !
  integer :: i,j,i1,i2,zonrank,linrank,cubrank
  integer :: imaxx,imaxy,imaxdlin,imaxdcub
  logical :: splin_flag
  !
  integer :: inum,indx
  integer :: iderivs(2,6),ict4(4),maxd_lin(4),maxd_cub(4)
  !
  integer :: idcub,idlin
  real(fp) :: xp,dxlin,dxlini,h,hi,ans1,ans2
  real(fp) :: f22(2,2)
  !
  real(fp), parameter :: ONE = 1.0_fp
  !---------------
  !
  linrank=0
  cubrank=0
  zonrank=0

  do i=1,2
     if(jspline(i).eq.-1) then
        zonrank = zonrank + 1

     else if(jspline(i).eq.0) then
        linrank = linrank + 1

     else
        splin_flag = jspline(i).eq.2
        cubrank = cubrank + 1
     end if
  end do
  !
  if(cubrank.eq.2) then
     if(splin_flag) then
        !  bicubic spline
        call fvbicub(ict,ivec,ivecd, &
             fval,ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
             fin,ixdim,iydim)

     else
        !  bicubic Hermite -- translate derivative code
        call dtrans
        do i=1,inum
           if(maxval(iderivs(1:2,i)).le.1) then
              ict4=0
              indx=2*iderivs(2,i) + iderivs(1,i) + 1
              ict4(indx)=1
              call herm2fcn(ict4,ivec,ivecd, &
                   fval(1,i),ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
                   fin,ixdim,iydim)

           else
              fval(1:ivec,i) = 0
           end if
        end do
     end if

     return
  end if

  call dtrans

  if(cubrank.eq.0) then
     if(jspline(1).eq.0) then
        imaxx=1
     else
        imaxx=0
     end if

     if(jspline(2).eq.0) then
        imaxy=1
     else
        imaxy=0
     end if

     do i=1,inum
        if((iderivs(1,i).le.imaxx).and.(iderivs(2,i).le.imaxy)) then
           if(linrank.eq.2) then
              !  bilinear interpolation
              ict4=0
              indx=2*iderivs(2,i) + iderivs(1,i) + 1
              ict4(indx)=1
              call pc2fcn(ict4,ivec,ivecd, &
                   fval(1,i),ii,jj,xparam,yparam,hx,hxi,hy,hyi, &
                   fin,ixdim,iydim)
           else if(zonrank.eq.2) then
              !  2d step function
              do j=1,ivec
                 fval(j,i)=fin(1,ii(j),jj(j))
              end do
           else
              !  linear-zone hybrid
              if(jspline(1).eq.0) then
                 ! linear in x, zonal in y
                 do j=1,ivec
                    if(iderivs(1,i).eq.0) then
                       fval(j,i)=(ONE-xparam(j))*fin(1,ii(j),jj(j)) &
                            +xparam(j)*fin(1,ii(j)+1,jj(j))
                    else
                       fval(j,i)=(fin(1,ii(j)+1,jj(j)) - &
                            fin(1,ii(j),jj(j)))*hxi(j)
                    end if
                 end do
              else
                 ! linear in y, zonal in x
                 do j=1,ivec
                    if(iderivs(2,i).eq.0) then
                       fval(j,i)=(ONE-yparam(j))*fin(1,ii(j),jj(j)) &
                            +yparam(j)*fin(1,ii(j),jj(j)+1)
                    else
                       fval(j,i)=(fin(1,ii(j),jj(j)+1) - &
                            fin(1,ii(j),jj(j)))*hyi(j)
                    end if
                 end do
              end if
           end if
        else
           fval(1:ivec,i) = 0
        end if
     end do

     return
  end if

  !  OK -- Hybrid: Hermite or Spline in one dimension
  !        pclin or step in the other dimension

  if(splin_flag) then
     imaxdcub=3
  else
     imaxdcub=1
  end if

  if(linrank.eq.1) then
     imaxdlin=1
  else
     imaxdlin=0
  end if

  do i=1,inum
     if(jspline(1).ge.1) then
        idcub=iderivs(1,i)
        idlin=iderivs(2,i)
     else
        idcub=iderivs(2,i)
        idlin=iderivs(1,i)
     end if

     if((maxd_lin(i).le.imaxdlin).and. &
          (maxd_cub(i).le.imaxdcub)) then
        if(linrank.eq.1) then
           !  spline or Hermite in 1 dimension; pclin in other.
           if(jspline(1).ge.1) then
              do j=1,ivec
                 xp=xparam(j)
                 dxlin=yparam(j)
                 dxlini=1.0_fp-dxlin
                 h=hx(j)
                 hi=hxi(j)
                 i1=ii(j)
                 i2=jj(j)
                 f22(1:2,1)=fin(1:2,i1,i2)
                 f22(1:2,2)=fin(1:2,i1+1,i2)
                 if(splin_flag) then
                    call sp1d(ans1)
                 else
                    call hm1d(ans1)
                 end if
                 f22(1:2,1)=fin(1:2,i1,i2+1)
                 f22(1:2,2)=fin(1:2,i1+1,i2+1)
                 if(splin_flag) then
                    call sp1d(ans2)
                 else
                    call hm1d(ans2)
                 end if
                 if(idlin.eq.1) then
                    fval(j,i)=(ans2-ans1)*hyi(j)
                 else
                    fval(j,i)=ans2*dxlin + ans1*dxlini
                 end if
              end do

           else
              do j=1,ivec
                 xp=yparam(j)
                 dxlin=xparam(j)
                 dxlini=1.0_fp-dxlin
                 h=hy(j)
                 hi=hyi(j)
                 i1=ii(j)
                 i2=jj(j)
                 f22(1:2,1)=fin(1:2,i1,i2)
                 f22(1:2,2)=fin(1:2,i1,i2+1)
                 if(splin_flag) then
                    call sp1d(ans1)
                 else
                    call hm1d(ans1)
                 end if
                 f22(1:2,1)=fin(1:2,i1+1,i2)
                 f22(1:2,2)=fin(1:2,i1+1,i2+1)
                 if(splin_flag) then
                    call sp1d(ans2)
                 else
                    call hm1d(ans2)
                 end if
                 if(idlin.eq.1) then
                    fval(j,i)=(ans2-ans1)*hxi(j)
                 else
                    fval(j,i)=ans2*dxlin + ans1*dxlini
                 end if
              end do
           end if

        else
           !  spline or Hermite in 1 dimension; step fcn in other.
           if(jspline(1).ge.1) then
              do j=1,ivec
                 xp=xparam(j)
                 h=hx(j)
                 hi=hxi(j)
                 i1=ii(j)
                 i2=jj(j)
                 f22(1:2,1)=fin(1:2,i1,i2)
                 f22(1:2,2)=fin(1:2,i1+1,i2)
                 if(splin_flag) then
                    call sp1d(ans1)
                 else
                    call hm1d(ans1)
                 end if
                 fval(j,i)=ans1
              end do
           else
              do j=1,ivec
                 xp=yparam(j)
                 h=hy(j)
                 hi=hyi(j)
                 i1=ii(j)
                 i2=jj(j)
                 f22(1:2,1)=fin(1:2,i1,i2)
                 f22(1:2,2)=fin(1:2,i1,i2+1)
                 if(splin_flag) then
                    call sp1d(ans1)
                 else
                    call hm1d(ans1)
                 end if
                 fval(j,i)=ans1
              end do
           end if
        end if
     else
        fval(1:ivec,i) = 0
     end if
  end do

  return

contains
  subroutine dtrans

    ! convert ict(...) codes into intermediate coding:
    !   iderivs(i,j) = number of differentiations in coordinate i
    !                  of the j'th value evaluated

    !   maxd_lin(j) = max # of differentiations for a linear dimension
    !   maxd_cub(j) = max # of differentiations for a spline dimension

    integer :: i

    inum=0   ! actual number of vectors to be evaluated (summed here)

    if(ict(1).le.(2)) then
       if(ict(1).eq.1) then
          call add1(0,0)
       end if
       if(ict(2).eq.1) then
          call add1(1,0)
       end if
       if(ict(3).eq.1) then
          call add1(0,1)
       end if
       if(ict(4).eq.1) then
          call add1(2,0)
       end if
       if(ict(5).eq.1) then
          call add1(0,2)
       end if
       if(ict(6).eq.1) then
          call add1(1,1)
       end if

    else if(ict(1).eq.3) then
       if(ict(2).eq.1) then
          call add1(3,0)
       end if
       if(ict(3).eq.1) then
          call add1(2,1)
       end if
       if(ict(4).eq.1) then
          call add1(1,2)
       end if
       if(ict(5).eq.1) then
          call add1(0,3)
       end if

    else if(ict(1).eq.4) then
       if(ict(2).eq.1) then
          call add1(3,1)
       end if
       if(ict(3).eq.1) then
          call add1(2,2)
       end if
       if(ict(4).eq.1) then
          call add1(1,3)
       end if

    else if(ict(1).eq.5) then
       if(ict(2).eq.1) then
          call add1(3,2)
       end if
       if(ict(3).eq.1) then
          call add1(2,3)
       end if

    else if(ict(1).eq.6) then
       if(ict(2).eq.1) then
          call add1(3,3)
       end if
    end if

  end subroutine dtrans

  subroutine add1(idx,idy)
    ! insert record of derivative d[idx+idy]f/dx[idx]dy[idy]

    integer, intent(in) :: idx,idy

    inum=inum+1

    iderivs(1,inum)=idx
    if(jspline(1).le.0) then
       maxd_lin(inum)=idx
       maxd_cub(inum)=0
    else
       maxd_lin(inum)=0
       maxd_cub(inum)=idx
    end if

    iderivs(2,inum)=idy
    if(jspline(2).le.0) then
       maxd_lin(inum)=max(maxd_lin(inum),idy)
    else
       maxd_cub(inum)=max(maxd_cub(inum),idy)
    end if

  end subroutine add1

  !===========================================================================
  subroutine sp1d(ans)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 1d spline evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,cx,cxi,hx2,cxd,cxdi
    !
    real(fp), parameter :: sixth = 0.166666666666666667_fp
    !----------------------

    if(idcub.eq.0) then
       ! value

       xpi=1.0_fp-xp
       xp2=xp*xp
       xpi2=xpi*xpi

       cx=xp*(xp2-1.0_fp)
       cxi=xpi*(xpi2-1.0_fp)
       hx2=h*h

       ans=xpi*f22(1,1) +xp*f22(1,2)
       ans=ans+sixth*hx2*(cxi*f22(2,1) +cx*f22(2,2))

    else if(idcub.eq.1) then
       ! 1st derivative

       xpi=1.0_fp-xp
       xp2=xp*xp
       xpi2=xpi*xpi

       cxd=3.0_fp*xp2-1.0_fp
       cxdi=-3.0_fp*xpi2+1.0_fp

       ans=hi*(f22(1,2)-f22(1,1))
       ans=ans+sixth*h*(cxdi*f22(2,1) +cxd*f22(2,2))

    else if(idcub.eq.2) then
       ! 2nd derivative

       xpi=1.0_fp-xp
       ans=xpi*f22(2,1) + xp*f22(2,2)

    else
       ! 3rd derivative

       ans = hi*(f22(2,2)-f22(2,1))

    end if

  end subroutine sp1d

  !===========================================================================
  subroutine hm1d(ans)
    real(fp), intent(out) :: ans

    !----------------------
    ! contained 1d hermite evaluation
    !----------------------

    real(fp) :: xpi,xp2,xpi2,ax,axbar,bx,bxbar
    real(fp) :: axp,axbarp,bxp,bxbarp

    xpi=1.0_fp-xp
    xp2=xp*xp
    xpi2=xpi*xpi

    if(idcub.eq.0) then
       ! value

       ax=xp2*(3.0_fp-2.0_fp*xp)
       axbar=1.0_fp-ax
       bx=-xp2*xpi
       bxbar=xpi2*xp

       ans=axbar*f22(1,1) + ax*f22(1,2)
       ans=ans + h*(bxbar*f22(2,1) + bx*f22(2,2))

    else
       ! 1st derivative

       axp=6.0_fp*xp*xpi
       axbarp=-axp
       bxp=xp*(3.0_fp*xp-2.0_fp)
       bxbarp=xpi*(3.0_fp*xpi-2.0_fp)

       ans=hi*(axbarp*f22(1,1) +axp*f22(1,2))
       ans=ans + bxbarp*f22(2,1) + bxp*f22(2,2)

    end if

  end subroutine hm1d

end subroutine fvintrp2d

!
! map point into (xmin, xmax) cell when boundary conditions are periodic.

subroutine EZspline_modulo1(spline_o, p1, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  real(fp) :: p1 ! the location
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1 = MOD( p1, spline_o%x1max - spline_o%x1min )
  end if

end subroutine EZspline_modulo1

subroutine EZspline_modulo_array1(spline_o, k1, p1, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: k1 
  real(fp) :: p1(k1) ! the points
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1(1:k1) = MOD( p1(1:k1), spline_o%x1max - spline_o%x1min )
  end if

end subroutine EZspline_modulo_array1


subroutine EZspline_modulo2(spline_o, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  real(fp) :: p1, p2 ! the location
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1 = MOD( p1, spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2 = MOD( p2, spline_o%x2max - spline_o%x2min )
  end if

end subroutine EZspline_modulo2

subroutine EZspline_modulo_array2(spline_o, k1, k2, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k1, k2
  real(fp) :: p1(k1), p2(k2) ! the points
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1(1:k1) = MOD( p1(1:k1), spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2(1:k2) = MOD( p2(1:k2), spline_o%x2max - spline_o%x2min )
  end if

end subroutine EZspline_modulo_array2

subroutine EZspline_modulo_cloud2(spline_o, k, p1, p2, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: k
  real(fp) :: p1(k), p2(k) ! the points
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1(1:k) = MOD( p1(1:k), spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2(1:k) = MOD( p2(1:k), spline_o%x2max - spline_o%x2min )
  end if

end subroutine EZspline_modulo_cloud2


subroutine EZspline_modulo3(spline_o, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  real(fp) :: p1, p2, p3 ! the location
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1 = MOD( p1, spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2 = MOD( p2, spline_o%x2max - spline_o%x2min )
  end if

  if(spline_o%ibctype3(1)==-1 .OR. spline_o%ibctype3(2)==-1) then
     p3 = MOD( p3, spline_o%x3max - spline_o%x3min )
  end if

end subroutine EZspline_modulo3

subroutine EZspline_modulo_array3(spline_o, k1, k2, k3, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k1, k2, k3
  real(fp) :: p1(k1), p2(k2), p3(k3) ! the points
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1(1:k1) = MOD( p1(1:k1), spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2(1:k2) = MOD( p2(1:k2), spline_o%x2max - spline_o%x2min )
  end if

  if(spline_o%ibctype3(1)==-1 .OR. spline_o%ibctype3(2)==-1) then
     p3(1:k3) = MOD( p3(1:k3), spline_o%x3max - spline_o%x3min )
  end if

end subroutine EZspline_modulo_array3

subroutine EZspline_modulo_cloud3(spline_o, k, p1, p2, p3, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k
  real(fp) :: p1(k), p2(k), p3(k) ! the points
  integer, intent(out) :: ier

  ier = 0
  if(spline_o%ibctype1(1)==-1 .OR. spline_o%ibctype1(2)==-1) then
     p1(1:k) = MOD( p1(1:k), spline_o%x1max - spline_o%x1min )
  end if

  if(spline_o%ibctype2(1)==-1 .OR. spline_o%ibctype2(2)==-1) then
     p2(1:k) = MOD( p2(1:k), spline_o%x2max - spline_o%x2min )
  end if

  if(spline_o%ibctype3(1)==-1 .OR. spline_o%ibctype3(2)==-1) then
     p3(1:k) = MOD( p3(1:k), spline_o%x3max - spline_o%x3min )
  end if

end subroutine EZspline_modulo_cloud3

C----------------------------------------------------------------------
C  IOPERH - CONDITION HANDLER FOR VMS FILE OPENS; MAKE SOME ERRORS
C    NONFATAL, BUT GIVE FULL SYSTEM MESSAGE.
C
C    NO MESSAGE FOR FILE-NOT-FOUND -- THIS IS TO BE HANDLED BY CALLER.
C
C  THIS IS VMS SPECIFIC CODE; USE OF THIS CONDITION HANDLER IS
C  RESTRICTED TO VMS SYSTEMS ...
C
C  invisible to UNIX
C
#ifdef __VMS
      INTEGER*4 FUNCTION IOPERH(SIGARGS,MECHARGS)
C
      INTEGER*4 SIGARGS(*)
      INTEGER*4 MECHARGS(*)
C
      INCLUDE '($FORDEF)' ! DECLARE FOR$_ symbols   VMS-ONLY
      INCLUDE '($SSDEF)'  ! DECLARE SS$_ symbols
      INCLUDE '($STSDEF)' ! DECLARE STS$_ symbols
C
C
      save ierct,iermax
C
      data ierct/0/
      data iermax/10/
C
C--------------
C
C
      INDEX=LIB$MATCH_COND(SIGARGS(2),SS$_UNWIND,FOR$_FILNOTFOU,
     >    FOR$_OPEFAI,FOR$_NO_SUCDEV,FOR$_FILNAMSPE)
C
      IF(INDEX.EQ.0) THEN
C
C  UNRECOGNIZED ERROR CONDITION CODE -- APPLY ERROR COUNT
C
        IERCT=IERCT+1
        IF(IERCT.LT.IERMAX) THEN
          IOPERH=SS$_CONTINUE
          SIGARGS(1)=SIGARGS(1)-2
          CALL SYS$PUTMSG(SIGARGS,,,)
          SIGARGS(1)=SIGARGS(1)+2
        ELSE
C
C  ERROR COUNT EXCEEDED ==> NOT HANDLED HERE ...
C
          WRITE(6,'('' %IOPERH:  MAX ERROR COUNT EXCEEDED: '',I3)')
     >        IERMAX
          IOPERH=SS$_RESIGNAL
          RETURN                 !  RETURN TO GET DEFAULT HANDLER ...
        ENDIF
C
      ELSE IF(INDEX.EQ.1) THEN
C
C  CONTINUE UNWIND ...
C
        IOPERH=SS$_CONTINUE
        RETURN
C
      ELSE IF(INDEX.EQ.2) THEN
C
C  FNOF:  NO MESSAGE ...
C
        IOPERH=SS$_CONTINUE
C
      ELSE IF(INDEX.GT.2) THEN
C
C  OTHER FILE OPEN ERROR:  ECHO MESSAGE ...
C
        IOPERH=SS$_CONTINUE
        SIGARGS(1)=SIGARGS(1)-2
        CALL SYS$PUTMSG(SIGARGS,,,)
        SIGARGS(1)=SIGARGS(1)+2
C
      ENDIF
C
C  UNWIND - EXECUTION TO CONTINUE UNCONDITIONALLY
C  ERROR MADE KNOWN TO OPEN SUBROUTINE VIA STATUS CODE.
C
      CALL LIB$SIG_TO_RET(SIGARGS,MECHARGS)
C
      RETURN               ! END VMS ONLY CODE
#endif
C---------------------------------------------------------------
C  DUMMY UNIX VERSION
C
#ifdef __UNIX
      INTEGER FUNCTION IOPERH(IDUMMY)
      WRITE(6,9991)
 9991 FORMAT(' ?IOPERH:  NOT CALLABLE ON UNIX SYSTEM'/
     >   '  PROGRAMMING ERROR IN CALLER'/)
      CALL bad_exit
      IOPERH=-99999
      RETURN
#endif
C
      end

      subroutine cptimer(ztime)
      real ztime
C
C  this routine returns the elapsed CPU time in seconds.
C  Valid for UNIX or VMS
C
      call cptimi(ztime)
      ztime=0.01*ztime
C
      return
      end

subroutine splinck(x,inx,ilinx,ztol,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  check if a grid is strictly ascending and if it is evenly spaced
  !  to w/in ztol
  !
  !============
  implicit none
  integer inx,ix
  !============
  real(fp) :: dxavg,zeps,zdiffx,zdiff
  !============
  real(fp) :: x(inx)                       ! input -- grid to check
  !
  integer ilinx                     ! output -- =1 if evenly spaced =2 O.W.
  !
  real(fp) :: ztol                         ! input -- spacing check tolerance
  !
  integer ier                       ! output -- =0 if OK
  !
  !  ier=1 is returned if x(1...inx) is NOT STRICTLY ASCENDING...
  !
  !-------------------------------
  !
  ier=0
  ilinx=1
  if(inx.le.1) return
  !
  dxavg=(x(inx)-x(1))/(inx-1)
  zeps=abs(ztol*dxavg)
  !
  do ix=2,inx
     zdiffx=(x(ix)-x(ix-1))
     if(zdiffx.le.0.0_fp) ier=2
     zdiff=zdiffx-dxavg
     if(abs(zdiff).gt.zeps) then
        ilinx=2
     end if
  end do
10 continue
  !
  return
end subroutine splinck

!
!  MOD DMC Apr 2007 -- support Hybrid spline objects.
!   these objects can have "zonal step function" dimensions 1 less than
!   the grid dimension; also, the number of spline coefficients varies
!   depending on how many dimensions are using cubic interpolation.  So,
!   local variables in0, in1, in2, in3 are defined to distinguish these
!   dimensions from the grid dimensions spline_o%n1, etc.
!
! 1-D
!

subroutine EZspline_save1(spline_o, filename, ier, &
     spl_name, fullsave)
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline1) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 17=could not save spline object in file filename
  integer, intent(out) :: ier

  !  if SPL_NAME is set, APPEND to file instead of creating new; prepend
  !  name to all NetCDF data items.  This allows one file to contain
  !  multiple items. (new dmc Mar 2006)
  character(len=*), intent(in), OPTIONAL :: SPL_NAME  ! optional spline "name"

  !  if FULLSAVE is set .TRUE., save derived coefficients along with data
  !  this saves recalculating the coefficients when file is read (Mar 2006)
  logical, intent(in), OPTIONAL :: FULLSAVE

  integer ncid, ifail, in0, in1
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'

  character(len=32) :: zpre
  logical :: fullsv,imodify

  ier = 0
  if(spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  in0 = size(spline_o%fspl,1)
  in1 = size(spline_o%fspl,2)

  if(present(spl_name)) then
     call ezspline_spl_name_chk(spl_name,ier)
     if(ier.ne.0) return
     zpre=spl_name
  else
     zpre=' '
  end if

  if(present(fullsave)) then
     fullsv=fullsave
  else
     fullsv=.FALSE.
  end if

  if(zpre.eq.' ') then
     call cdfOpn(ncid, filename, 'w') ! no error flag??
     imodify=.FALSE.
  else
     call cdfOpn(ncid, filename, 'v') ! Append if exists, else create new
     imodify=.TRUE.
  end if
  if(ncid==0) then
     ier = 39
     return
  end if

  dimlens = (/1, 1, 1/) ! scalar
  call ezspline_defVar(ncid, trim(zpre)//'n1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isHermite', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isLinear', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isReady', dimlens, int, imodify, ier)
  dimlens = (/2, 1, 1/) 
  call ezspline_defVar(ncid, trim(zpre)//'ibctype1', dimlens, int, imodify, ier)
  dimlens = (/spline_o%n1, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x1', dimlens, real8, imodify, ier)
  dimlens = (/1, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1max', dimlens, real8, imodify, ier)
  !
  ! save only the function values at the nodes
  !
  dimlens = (/spline_o%n1, 1, 1/)
  if(.not.fullsv) then
     call ezspline_defVar(ncid, trim(zpre)//'f', dimlens, real8, imodify, ier)
  else
     dimlens = (/1, 1, 1/) ! scalar
     call ezspline_defVar(ncid, trim(zpre)//'x1min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x1max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin1', dimlens, int, imodify, ier)
     dimlens = (/spline_o%n1, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x1pkg', dimlens, real8, imodify, ier)
     dimlens = (/2, spline_o%n1, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'fspl', dimlens, real8, imodify, ier)
  end if
  if(ier.ne.0) return

  call cdfPutVar(ncid, trim(zpre)//'n1', spline_o%n1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  if(ifail/=0) then
     ier=40
     return
  end if

  if(spline_o%isReady == 1) then
     if(.not.fullsv) then
        call cdfPutVar(ncid, trim(zpre)//'f', spline_o%fspl(1,:), ifail)
     else
        call cdfPutVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
        call cdfPutVar(ncid, trim(zpre)//'fspl', spline_o%fspl, ifail)
     end if
  else
     ier = 93
  end if

  call cdfCls(ncid)

  if(ifail /=0) ier = 17

  return
end subroutine EZspline_save1

!! 
!! 2-D
!!


subroutine EZspline_save2(spline_o, filename, ier, &
     spl_name, fullsave)
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline2) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 17=could not save spline object in file filename
  integer, intent(out) :: ier

  !  if SPL_NAME is set, APPEND to file instead of creating new; prepend
  !  name to all NetCDF data items.  This allows one file to contain
  !  multiple items. (new dmc Mar 2006)
  character(len=*), intent(in), OPTIONAL :: SPL_NAME  ! optional spline "name"

  !  if FULLSAVE is set .TRUE., save derived coefficients along with data
  !  this saves recalculating the coefficients when file is read (Mar 2006)
  logical, intent(in), OPTIONAL :: FULLSAVE

  integer ncid, ifail, in0, in1, in2
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'

  character(len=32) :: zpre
  logical :: fullsv,imodify

  ier = 0
  if(spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  in0 = size(spline_o%fspl,1)
  in1 = size(spline_o%fspl,2)
  in2 = size(spline_o%fspl,3)

  if(present(spl_name)) then
     call ezspline_spl_name_chk(spl_name,ier)
     if(ier.ne.0) return
     zpre=spl_name
  else
     zpre=' '
  end if

  if(present(fullsave)) then
     fullsv=fullsave
  else
     fullsv=.FALSE.
  end if

  if(zpre.eq.' ') then
     call cdfOpn(ncid, filename, 'w') ! no error flag??
     imodify=.FALSE.
  else
     call cdfOpn(ncid, filename, 'v') ! Append if exists, else create new
     imodify=.TRUE.
  end if
  if(ncid==0) then
     ier = 39
     return
  end if

  dimlens = (/1, 1, 1/) ! scalar
  call ezspline_defVar(ncid, trim(zpre)//'n1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'n2', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup2', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isHermite', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isLinear', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isHybrid', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isReady', dimlens, int, imodify, ier)
  dimlens = (/2, 1, 1/) 
  call ezspline_defvar(ncid, trim(zpre)//'hspline', dimlens, int, imodify, ier)
  dimlens = (/2, 1, 1/) 
  call ezspline_defVar(ncid, trim(zpre)//'ibctype1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'ibctype2', dimlens, int, imodify, ier)
  dimlens = (/spline_o%n1, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x1', dimlens, real8, imodify, ier)
  dimlens = (/spline_o%n2, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x2', dimlens, real8, imodify, ier)
  dimlens = (/in2, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1max', dimlens, real8, imodify, ier)
  dimlens = (/in1, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval2min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval2max', dimlens, real8, imodify, ier)
  !
  ! save only the function values at the nodes
  !
  dimlens = (/in1, in2, 1/)
  if(.not.fullsv) then
     call ezspline_defVar(ncid, trim(zpre)//'f', dimlens, real8, imodify, ier)
  else
     dimlens = (/1, 1, 1/) ! scalar
     call ezspline_defVar(ncid, trim(zpre)//'x1min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x1max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin1', dimlens, int, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x2min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x2max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin2', dimlens, int, imodify, ier)
     dimlens = (/spline_o%n1, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x1pkg', dimlens, real8, imodify, ier)
     dimlens = (/spline_o%n2, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x2pkg', dimlens, real8, imodify, ier)
     dimlens = (/in0, in1, in2/)
     call ezspline_defVar(ncid, trim(zpre)//'fspl', dimlens, real8, imodify, ier)
  end if
  if(ier.ne.0) return

  call cdfPutVar(ncid, trim(zpre)//'n1', spline_o%n1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'n2', spline_o%n2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup2', spline_o%klookup2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isHybrid', spline_o%isHybrid, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfPutVar(ncid, trim(zpre)//'hspline', spline_o%hspline, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype2', spline_o%ibctype2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x2', spline_o%x2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval2min', spline_o%bcval2min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval2max', spline_o%bcval2max, ifail)
  if(ifail/=0) then
     ier=40
     return
  end if

  if(spline_o%isReady == 1) then
     if(.not.fullsv) then
        call cdfPutVar(ncid, trim(zpre)//'f', spline_o%fspl(1,:,:), ifail)
     else
        call cdfPutVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2min', spline_o%x2min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2max', spline_o%x2max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin2', spline_o%ilin2, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2pkg', spline_o%x2pkg, ifail)
        call cdfPutVar(ncid, trim(zpre)//'fspl', spline_o%fspl, ifail)
     end if
  else
     ier = 93
  end if

  call cdfCls(ncid)

  if(ifail /=0) ier = 17

  return
end subroutine EZspline_save2





!!! 
!!! 3-D
!!!



subroutine EZspline_save3(spline_o, filename, ier, &
     spl_name, fullsave)
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline3) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 17=could not save spline object in file filename
  integer, intent(out) :: ier

  !  if SPL_NAME is set, APPEND to file instead of creating new; prepend
  !  name to all NetCDF data items.  This allows one file to contain
  !  multiple items. (new dmc Mar 2006)
  character(len=*), intent(in), OPTIONAL :: SPL_NAME  ! optional spline "name"

  !  if FULLSAVE is set .TRUE., save derived coefficients along with data
  !  this saves recalculating the coefficients when file is read (Mar 2006)
  logical, intent(in), OPTIONAL :: FULLSAVE

  integer ncid, ifail, in0, in1, in2, in3
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'

  character(len=32) zpre
  logical :: fullsv,imodify

  ier = 0
  if(spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  in0 = size(spline_o%fspl,1)
  in1 = size(spline_o%fspl,2)
  in2 = size(spline_o%fspl,3)
  in3 = size(spline_o%fspl,4)

  if(present(spl_name)) then
     call ezspline_spl_name_chk(spl_name,ier)
     if(ier.ne.0) return
     zpre=spl_name
  else
     zpre=' '
  end if

  if(present(fullsave)) then
     fullsv=fullsave
  else
     fullsv=.FALSE.
  end if

  if(zpre.eq.' ') then
     call cdfOpn(ncid, filename, 'w') ! no error flag??
     imodify=.FALSE.
  else
     call cdfOpn(ncid, filename, 'v') ! Append if exists, else create new
     imodify=.TRUE.
  end if
  if(ncid==0) then
     ier = 39
     return
  end if

  dimlens = (/1, 1, 1/) ! scalar
  call ezspline_defVar(ncid, trim(zpre)//'n1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'n2', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'n3', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup2', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'klookup3', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isHermite', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isLinear', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isHybrid', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'isReady', dimlens, int, imodify, ier)
  dimlens = (/3, 1, 1/) 
  call ezspline_defvar(ncid, trim(zpre)//'hspline', dimlens, int, imodify, ier)
  dimlens = (/2, 1, 1/) 
  call ezspline_defVar(ncid, trim(zpre)//'ibctype1', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'ibctype2', dimlens, int, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'ibctype3', dimlens, int, imodify, ier)
  dimlens = (/spline_o%n1, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x1', dimlens, real8, imodify, ier)
  dimlens = (/spline_o%n2, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x2', dimlens, real8, imodify, ier)
  dimlens = (/spline_o%n3, 1, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'x3', dimlens, real8, imodify, ier)
  dimlens = (/in2, in3, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval1max', dimlens, real8, imodify, ier)
  dimlens = (/in1, in3, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval2min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval2max', dimlens, real8, imodify, ier)
  dimlens = (/in1, in2, 1/)
  call ezspline_defVar(ncid, trim(zpre)//'bcval3min', dimlens, real8, imodify, ier)
  call ezspline_defVar(ncid, trim(zpre)//'bcval3max', dimlens, real8, imodify, ier)
  !
  ! save only the function values at the nodes
  !
  dimlens = (/in1, in2, in3/)
  if(.not.fullsv) then
     call ezspline_defVar(ncid, trim(zpre)//'f', dimlens, real8, imodify, ier)
  else
     dimlens = (/1, 1, 1/) ! scalar
     call ezspline_defVar(ncid, trim(zpre)//'x1min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x1max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin1', dimlens, int, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x2min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x2max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin2', dimlens, int, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x3min', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'x3max', dimlens, real8, imodify, ier)
     call ezspline_defVar(ncid, trim(zpre)//'ilin3', dimlens, int, imodify, ier)
     dimlens = (/spline_o%n1, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x1pkg', dimlens, real8, imodify, ier)
     dimlens = (/spline_o%n2, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x2pkg', dimlens, real8, imodify, ier)
     dimlens = (/spline_o%n3, 4, 1/)
     call ezspline_defVar(ncid, trim(zpre)//'x3pkg', dimlens, real8, imodify, ier)
     dimlens = (/in0*in1, in2, in3/)
     call ezspline_defVar(ncid, trim(zpre)//'fspl', dimlens, real8, imodify, ier)
  end if
  if(ier.ne.0) return

  call cdfPutVar(ncid, trim(zpre)//'n1', spline_o%n1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'n2', spline_o%n2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'n3', spline_o%n3, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup2', spline_o%klookup2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'klookup3', spline_o%klookup3, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isHybrid', spline_o%isHybrid, ifail)
  call cdfPutVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfPutVar(ncid, trim(zpre)//'hspline', spline_o%hspline, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype2', spline_o%ibctype2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'ibctype3', spline_o%ibctype3, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x2', spline_o%x2, ifail)
  call cdfPutVar(ncid, trim(zpre)//'x3', spline_o%x3, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval2min', spline_o%bcval2min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval2max', spline_o%bcval2max, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval3min', spline_o%bcval3min, ifail)
  call cdfPutVar(ncid, trim(zpre)//'bcval3max', spline_o%bcval3max, ifail)
  if(ifail/=0) then
     ier=40
     return
  end if

  if(spline_o%isReady == 1) then
     if(.not.fullsv) then
        call cdfPutVar(ncid, trim(zpre)//'f', spline_o%fspl(1,:,:,:), ifail)
     else
        call cdfPutVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2min', spline_o%x2min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2max', spline_o%x2max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin2', spline_o%ilin2, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x3min', spline_o%x3min, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x3max', spline_o%x3max, ifail)
        call cdfPutVar(ncid, trim(zpre)//'ilin3', spline_o%ilin3, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x2pkg', spline_o%x2pkg, ifail)
        call cdfPutVar(ncid, trim(zpre)//'x3pkg', spline_o%x3pkg, ifail)
        call ezspline_cdfput3(ncid, trim(zpre)//'fspl', spline_o%fspl, &
             in0*in1, in2, in3, ifail)
     end if
  else
     ier = 93
  end if

  call cdfCls(ncid)

  if(ifail /=0) ier = 17

  return
end subroutine EZspline_save3



subroutine ezspline_spl_name_chk(spl_name,ier)
  character(len=*), intent(in) :: spl_name
  integer, intent(out) :: ier

  !----------------
  integer :: ic,ilen,indx
  character(len=63) :: zlegal = &
       '0123456789_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
  !----------------
  ier=0

  ilen = len(trim(spl_name))

  if(ilen.le.0) then
     ier=50
  else if(ilen.gt.20) then
     ier=51
  else
     indx=index(zlegal,spl_name(1:1))
     if(indx.le.10) then
        ier=52
     else
        do ic=2,ilen
           indx=index(zlegal,spl_name(ic:ic))
           if(indx.le.0) ier=52
        end do
     end if
  end if

end subroutine ezspline_spl_name_chk

subroutine ezspline_defVar(ncid, name, dimlens, ztype, imodify, ier)

  use EZcdf
  implicit NONE

  ! inquire about variable with logic specific to ezspline_save

  integer, intent(in) :: ncid          ! NetCDF handle
  character(len=*), intent(in) :: name    ! item name to define
  integer, intent(in) :: dimlens(3)    ! dimensioning information
  character(len=*), intent(in) :: ztype   ! data type e.g. "R8"
  logical, intent(in) :: imodify       ! T if item may already exist

  integer, intent(inout) :: ier        ! status code, set iff a real error
  ! is detected...

  !-----------------------------
  character(len=10) :: ztype_loc
  integer :: dimlens_loc(3),id1,id2,ii
  integer :: ifail,ivarid
  !-----------------------------

  if(.not.imodify) then

     ! simply define the quantity...

     call cdfDefVar(ncid, name, dimlens, ztype, ifail)
     if(ifail.ne.0) ier=42

  else

     ifail = nf_inq_varid(ncid, name, ivarid)
     if(ifail.ne.0) then

        ! assume item does not exist, so, just define it...

        call cdfDefVar(ncid, name, dimlens, ztype, ifail)
        if(ifail.ne.0) ier=42

     else

        ! item DOES exist; require dimension & type match...

        call cdfInqVar(ncid, name, dimlens_loc, ztype_loc, ifail)
        if(ztype.ne.ztype_loc) then
           ier=53

        else
           do ii=1,3
              id1=max(1,dimlens(ii))
              id2=max(1,dimlens_loc(ii))
              if(id1.ne.id2) ier=53
           end do
        end if

        !  if ier= 0, no cdfDefVar is needed: object already defined
        !  and attributes are correct.

     end if
  end if

end subroutine ezspline_defVar

      subroutine cptimr8(ztime)
C
      IMPLICIT NONE
C
      REAL*8 ztime
      REAL zctime
C
C  this routine returns the elapsed CPU time.  Valid for UNIX or VMS
C  value returned is REAL*8.  Time in seconds.
C
      call cptimi(zctime)
      ztime=0.01*zctime   ! real -> real*8
C
      return
      end

subroutine f2test(fun1,fun2,inump,xmin,xmax,ymin,ymax, &
     name,namex,namey)
  use iso_c_binding, only: fp => c_double
  !
  !   test/compare 2 methods of evaluation of 2d function values and derivatives
  !
  !     passed:
  !       subroutine fun1(x,y,fget1(1..6))
  !       subroutine fun1(x,y,fget2(1..6))
  !
  !          (input x,y, return vector of 6 numbers containing, in order:
  !            f,df/dx,df/dy,d2f/dx2,d2f/dy2,d2f/dxdy)
  !
  !============
  implicit none
  integer icyc,i,ict,iy,ix
  !============
  real(fp) :: zy,zx,zdifa
  !============
  external fun1,fun2
  !
  integer inump                     ! #evals per dimension
  !
  real(fp) :: xmin,xmax                    ! x range
  real(fp) :: ymin,ymax                    ! y range
  !
  character(len=*) name                ! name/label for fcns --
  character(len=*) namex,namey         ! name/label for x & y dims
  !
  !  NOTE `name*' should be short with no leading or trailing blanks
  !
  !  local:
  !
  real(fp) :: fget1(6),fget2(6),fmin(6),fmax(6),fdifa(6)
  !
  !  output of routine:  stats written to unit 6
  !
  !--------------------------------
  !
  data icyc/100000/
  !
  do i=1,6
     fmin(i)=1.0E35_fp
     fmax(i)=-1.0E35_fp
     fdifa(i)=0.0_fp
  end do
  !
  ict=0
  !
  do iy=1,inump
     zy=ymin+real(iy-1,fp)*(ymax-ymin)/real(inump-1,fp)
     do ix=1,inump
        zx=xmin+real(ix-1,fp)*(xmax-xmin)/real(inump-1,fp)
        !
        ict=ict+1
        if(icyc*(ict/icyc).eq.ict) then
           write(6,1001) ix,zx,iy,zy,ict
1001       format('  ...f2test: evaluating at x(',i5,')=',1pe11.4, &
                ', y(',i5,')=',1pe11.4,' #=',i8)
        end if
        !
        call fun1(zx,zy,fget1)
        call fun2(zx,zy,fget2)
        !
        do i=1,6
           fmin(i)=min(fmin(i),fget1(i),fget2(i))
           fmax(i)=max(fmax(i),fget1(i),fget2(i))
           zdifa=abs(fget1(i)-fget2(i))
           fdifa(i)=max(fdifa(i),zdifa)
        end do
        !
     end do
  end do
  !
  write(6,1002) namex,namey,name, &
       (name,fmin(i),fmax(i),fdifa(i),i=1,6)
1002 format(/ &
       '  test function comparison:'/ &
       '     x stands for "',a,'";  y stands for "',a,'".'/ &
       '     (',a,')     min value   max value   max |diff|'/ &
       '   ',a,':      ',3(1pe11.3,2x)/ &
       '  d',a,'/dx:   ',3(1pe11.3,2x)/ &
       '  d',a,'/dy:   ',3(1pe11.3,2x)/ &
       ' d2',a,'/dx2:  ',3(1pe11.3,2x)/ &
       ' d2',a,'/dy2:  ',3(1pe11.3,2x)/ &
       ' d2',a,'/dxdy: ',3(1pe11.3,2x)/)
  !
  return
end subroutine f2test

subroutine genxpkg(nx,x,xpkg,iper,imsg,itol,ztol,ialg,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  from an x axis assemble a "package":
  !
  !  MOD DMC Feb 2010: handle very small grids: nx=2, nx=3...
  !  interchanged meaning of xpkg(1,4) and xpkg(3,4);
  !  xpkg(3,4) only set if nx.ge.3;
  !  xpkg(4,4) only set if nx.ge.4.
  !
  !  there are corresponding changes in xlookup: simplified code lookup
  !  code for the cases nx=2 and nx=3.
  !
  !     xpkg(j,1) = x(j), j = 1 to nx    ... nx.ge.2
  !
  !     if(abs(ialg).ne.3) then...
  !       for j=1:nx-1
  !       xpkg(j,2) = h(j) = x(j+1)-x(j), j=1 to nx-1
  !     else
  !       for j=1:nx-1
  !       xpkg(j,2) = index location, with linear offset, of
  !                   xpkg(1,1)+<h>*(j-1) in the original x(1:nx)
  !            (piecewise linear indexing function)
  !     end if
  !     xpkg(nx,2) = <h> = (x(nx)-x(1))/(nx-1)
  !
  !     xpkg(j,3) = 1/h(j)
  !     xpkg(nx,3) = 1/<h>
  !
  !     xpkg(1,4) = +/- tolerance epsilon for out-of-range warnings/errors
  !                 +if message is to be written on out of range errors
  !                 -if no message to be written.  In either case, a
  !                        warning flag is set.
  !
  !     xpkg(2,4) = 1.0 if x is *periodic*, else 0.0
  !
  !  only set if nx.ge.3:
  !     xpkg(3,4) = 0.0 if x is *evenly spaced* (to ztol or 5.e-7 rel) else:
  !                   = 1.0 => use (1/h) newton's method like search algorithm
  !                   = 2.0 => use binary search algorithm
  !                   = 3.0 => use piecewise-linear indexing function...
  !
  !  only set if nx.ge.4:
  !     xpkg(4,4) = 0.0 -- do not use past search result as start point
  !                        for next search;
  !               = 1.0 -- do use past search result as start point for
  !                        next search.
  !
  !  tolerance epsilon means:
  !     if xtest is within epsilon*max(abs(x(1)),abs(x(nx))) outside the
  !     range [x(1),x(nx)] treat xtest as being at the endpoint x(1) or
  !     x(nx) whichever is closer.
  !
  ! input arguments:
  !
  !============
  implicit none
  integer ialgu,iabs,ix,ixp,itest,i
  !============
  real(fp) :: ztolr,ztola,zh,xtest
  !============
  integer nx                        ! length of x, .ge.4
  real(fp) :: x(nx)                        ! x axis vector, strict ascending
  !
  integer iper                      ! =1 if x is periodic
  integer imsg                      ! =1 for range error messages
  integer itol                      ! =1 to specify tolerance, else default
  !
  ! default tolerance is 5.0e-7
  !
  real(fp) :: ztol                         ! range tolerance, if itol=1
  !
  ! lookup algorithm selection for uneven grids:
  !
  integer ialg                      ! = +/- 1:  <1/h(j)> "Newton" method
  !                                       ! = +/- 2:  binary search
  !                                       ! = +/- 3:  indexing function
  !
  !       to use past search result as init. cond. for next search, give
  !       ialg .lt. 0; otherwise give ialg .gt. 0.
  !
  ! output arguments:
  !
  real(fp) :: xpkg(nx,4)                   ! xpkg, as described above
  integer ier                       ! completion code, 0=OK
  !
  !------------------------------------------------
  !
  if(nx.lt.2) then
     write(6,*) ' %genxpkg:  nx.ge.2 required!'
     ier=1
     return
  else
     ier=0
  end if
  !
  ialgu=ialg
  if(ialgu.eq.0) ialgu=3
  if(iabs(ialgu).gt.3) ialgu=3
  !
  !  get tolerance for end point range check & even spacing check
  !
  if(itol.eq.1) then
     ztolr=abs(ztol)
  else
     ztolr=5.0E-7_fp
  end if
  !
  ztola=max(abs(x(1)),abs(x(nx)))*ztolr
  !
  !  assume even spacing for now...
  !
  if(nx.ge.3) then
     xpkg(3,4)=0.0_fp
  end if
  !
  !  mark if x axis is a periodic coordinate
  !
  if(iper.eq.1) then
     xpkg(2,4)=1.0_fp
  else
     xpkg(2,4)=0.0_fp
  end if
  !
  !  store tolerance parameter
  !
  xpkg(1,4)=ztola
  !
  !  mark if messages are to be written if range lookup errors occur
  !
  if(imsg.eq.1) then
     continue                       ! xpkg(1,4) left .gt. 0.0
  else
     xpkg(1,4)=-xpkg(1,4)
  end if
  !
  !  OK check linearity and spacing
  !
  ier=0
  !
  xpkg(nx,2)=(x(nx)-x(1))/(nx-1)    ! average spacing
  !
  do ix=1,nx
     xpkg(ix,1)=x(ix)
     if((ier.eq.0).and.(ix.lt.nx)) then
        if(x(ix+1).le.x(ix)) then
           ier=1
           write(6,*) ' %genxpkg:  x axis not strict ascending!'
        else
           zh=x(ix+1)-x(ix)
           !
           !  checking even spacing now...
           !
           if(nx.ge.3) then
              if(abs(zh-xpkg(nx,2)).gt.ztola) xpkg(3,4)=1.0_fp
           end if
           !
           xpkg(ix,2)=zh
           xpkg(ix,3)=1.0_fp/zh
           !
        end if
     end if
  end do
  !
  if(ier.ne.0) return
  !
  !  OK, store inverse average spacing
  !
  xpkg(nx,3)=1.0_fp/xpkg(nx,2)
  !
  !  if even spacing is detected, redefine x axis slightly, for
  !  improved regularity of behaviour
  !
  if(nx.ge.3) then
     !
     if(xpkg(3,4).eq.0.0_fp) then
        do ix=1,nx-2
           ixp=ix+1
           xpkg(ixp,1)=xpkg(1,1)+ix*xpkg(nx,2)
        end do
        if(nx.gt.3) then
           if(ialgu.lt.0) then
              xpkg(4,4)=1.0_fp ! check init guess
           else
              xpkg(4,4)=0.0_fp
           end if
        end if
     end if
     !
     !  if uneven spacing is detected, must use an algorithm...
     !
     if(xpkg(3,4).ne.0.0_fp) then
        xpkg(3,4)=abs(ialgu)
        if(nx.gt.3) then
           if(ialgu.lt.0) then
              xpkg(4,4)=1.0_fp ! check init guess
           else
              xpkg(4,4)=0.0_fp
           end if
        end if
        !
        if(abs(ialgu).eq.3) then
           !
           !  construct a piecewise linear indexing function
           !
           xpkg(1,2)=1.0_fp
           xtest=xpkg(1,1)
           itest=1
           do i=2,nx-1
              xtest=xtest+xpkg(nx,2) ! x1 + (i-1)*<h>
10            continue
              if((xpkg(itest,1).le.xtest).and. &
                   (xtest.le.xpkg(itest+1,1))) then
                 xpkg(i,2)=itest+(xtest-xpkg(itest,1))/ &
                      (xpkg(itest+1,1)-xpkg(itest,1))
              else
                 itest=itest+1
                 go to 10
              end if
           end do
           !
           !  (implicitly, xpkg(nx,2)=nx*1.0; but we leave <h> in xpkg(nx,2)
           !   instead...)
           !
        end if
     end if
     !
  end if  ! nx.ge.3
  !
  return
end subroutine genxpkg

subroutine mkbicubw(x,nx,y,ny,f,nf2, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcymin,bcymin,ibcymax,bcymax, &
     wk,nwk, &
     ilinx,iliny,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup a bicubic spline; store coefficients in compact form
  !  (as per suggestion of L. Zakharov, PPPL, Feb. 1999)
  !     4 coeffs per grid point:  f,fxx,fyy,fxxyy
  !
  !
  !  input:
  !============
  implicit none
  integer itest,iadfp,isiz1,iadfw,inwk
  !============
  real(fp) :: hxlast,hylast
  !============
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  real(fp) :: x(nx)                        ! x vector, strict ascending
  real(fp) :: y(ny)                        ! y vector, strict ascending
  !
  integer nf2                       ! 2nd dimension of f, nf2.ge.nx
  !  input/output:
  !
  real(fp) :: f(4,nf2,ny)                  ! data & spline coefficients
  !
  !  on input:  f(1,i,j) = f(x(i),y(j))
  !  on output:  f(1,i,j) unchanged
  !              f(2,i,j) = d2f/dx2(x(i),y(j))
  !              f(3,i,j) = d2f/dy2(x(i),y(j))
  !              f(4,i,j) = d4f/dx2dy2(x(i),y(j))
  !
  !  and the interpolation formula for (x,y) in (x(i),x(i+1))^(y(j),y(j+1))
  !  is:
  !        hx = x(i+1)-x(i)   hy = y(j+1)-y(j)
  !        dxp= (x-x(i))/hx   dxm= 1-dxp     dxp,dxm in (0,1)
  !        dyp= (x-x(i))/hx   dym= 1-dyp     dyp,dym in (0,1)
  !        dx3p = dxp**3-dxp  dx3m = dxm**3-dxm     dxp3,dxm3 in (0,1)
  !
  !   finterp = dxm*(dym*f(1,i,j)+dyp*f(1,i,j+1))
  !            +dxp*(dym*f(1,i+1,j)+dyp*f(1,i+1,j+1))
  !     +1/6*hx**2*
  !            dx3m*(dym*f(2,i,j)+dyp*f(2,i,j+1))
  !           +dx3p*(dym*f(2,i+1,j)+dyp*f(2,i+1,j+1))
  !     +1/6*hy**2*
  !            dxm*(dy3m*f(3,i,j)+dy3p*f(3,i,j+1))
  !           +dxp*(dy3m*f(3,i+1,j)+dy3p*f(3,i+1,j+1))
  !     +1/36*hx**2*hy**2*
  !            dx3m*(dym*f(4,i,j)+dyp*f(4,i,j+1))
  !           +dx3p*(dym*f(4,i+1,j)+dyp*f(4,i+1,j+1))
  !
  !  where the f(2:4,*,*) are cleverly evaluated to assure
  !  (a) finterp is continuous and twice differentiable across all
  !      grid cell boundaries, and
  !  (b) all boundary conditions are satisfied.
  !
  !  the boundary conditions specification options are:
  !  inputs:
  !
  integer ibcxmin                   ! bc flag for x=xmin
  real(fp) :: bcxmin(ny)                   ! bc data vs. y at x=xmin
  integer ibcxmax                   ! bc flag for x=xmax
  real(fp) :: bcxmax(ny)                   ! bc data vs. y at x=xmax
  !
  integer ibcymin                   ! bc flag for y=ymin
  real(fp) :: bcymin(nx)                   ! bc data vs. x at y=ymin
  integer ibcymax                   ! bc flag for y=ymax
  real(fp) :: bcymax(nx)                   ! bc data vs. x at y=ymax
  !
  !  with interpretation:
  !   ibcxmin -- indicator for boundary condition at x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- periodic boundary condition
  !     =0 -- use "not a knot"
  !     =1 -- match slope, specified at x(1),th(ith) by bcxmin(ith)
  !     =2 -- match 2nd derivative, specified at x(1),th(ith) by bcxmin(ith)
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
  !     =5 -- match 1st derivative to 1st divided difference
  !     =6 -- match 2nd derivative to 2nd divided difference
  !     =7 -- match 3rd derivative to 3rd divided difference
  !           (for more detailed definition of BCs 5-7, see the
  !           comments of subroutine mkspline)
  !   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !   NOTE:  if ibcxmin=-1, ibcxmax is ignored! ...and the BC is periodic.
  !
  !  and analogous interpretation for ibcymin,bcymin,ibcymax,bcymax
  !  (df/dy or d2f/dy2 boundary conditions at y=ymin and y=ymax).
  !
  !  *** workspace ***
  !  This FORTRAN-77 routine requires a workspace of
  !    nwk = (AT LEAST) 21*nx*ny
  !  *** for dynamic allocation of this workspace use subroutine mkbicub
  !    which has the same arguments as mkbicubw, except that the workspace
  !    does not have to be provided -- mkbicub is FORTRAN-90.
  !
  !  input:
  integer nwk                       ! size of workspace
  !  modified on output:
  real(fp) :: wk(nwk)                      ! workspace
  !
  !  and output arguments
  !
  integer ilinx                     ! =1: x grid is "nearly" equally spaced
  integer iliny                     ! =1: y grid is "nearly" equally spaced
  !
  !  ilinx and iliny are set to zero if corresponding grids are not equally
  !  spaced
  !
  !  and completion code
  !
  integer ier                       ! =0 on exit if there is no error.
  !
  !  if there is an error, ier is set and a message is output on unit 6.
  !  these are considered programming errors in the calling routine.
  !
  !  possible errors:
  !    x(...) not strict ascending
  !    y(...) not strict ascending
  !    nx .lt. 4
  !    ny .lt. 4
  !    invalid boundary condition flag
  !    workspace too small
  !
  !-----------------------------------------------------
  !  local arrays
  !
  integer iselect(10)
  integer zvalues(10)
  !
  data iselect/-1,0,0,0,0,0,0,0,0,0/
  !
  !-----------------------------------------------------
  !
  itest=21*nx*ny
  if(nwk.lt.itest) then
     write(6,9901) nwk,itest
9901 format(' ?mkbicubw:  workspace too small:'/ &
          '  user supplied:  nwk=',i7,'; need at least:  ',i7/ &
          '  nwk = at least 21*nx*ny is required.')
     ier=1
     return
  end if
  !
  iadfp=1
  isiz1=16*nx*ny
  iadfw=iadfp+isiz1
  inwk = nwk-isiz1
  !
  call mkbicop(f,nf2,wk(iadfp),nx,ny)
  !
  !  evaluate 4x4 continuous bicubic spline
  !
  call bcspline(x,nx,y,ny,wk(iadfp),nx, &
       ibcxmin,bcxmin,ibcxmax,bcxmax, &
       ibcymin,bcymin,ibcymax,bcymax, &
       wk(iadfw),inwk, &
       ilinx,iliny,ier)
  !
  if(ier.ne.0) return
  !
  !  convert to 4-coefficient (2nd/4th partials form)
  !
  hxlast=x(nx)-x(nx-1)
  hylast=y(ny)-y(ny-1)
  call mkbicon(f,nf2,wk(iadfp),nx,ny,hxlast,hylast)
  !
  return
end subroutine mkbicubw
!
!----------------------------------------------------------------
!  mkbicop -- copy spline function input data
!
subroutine mkbicop(fin,nf2,fwk,nx,ny)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nx,ny,nf2,iy,ix
  !============
  real(fp) :: fin(4,nf2,ny)
  real(fp) :: fwk(4,4,nx,ny)
  !
  do iy=1,ny
     do ix=1,nx
        fwk(1,1,ix,iy)=fin(1,ix,iy)
     end do
  end do
  !
  return
end subroutine mkbicop
!----------------------------------------------------------------
!  mkbicon -- create compact spline representation from 4x4
!             (bcspline) representation
!
subroutine mkbicon(fin,nf2,fwk,nx,ny,hxlast,hylast)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer nx,ny,nf2,iy,ix,iflag,ixuse,iyuse,j
  !============
  real(fp) :: hxlast,hylast,dxuse,dyuse
  !============
  real(fp) :: fin(4,nf2,ny)
  real(fp) :: fwk(4,4,nx,ny)
  !
  !-----------------------------------------------------
  !  local arrays
  !
  integer iselect(10)
  real(fp) :: zvalues(10)
  !
  data iselect/-1,0,0,0,0,0,0,0,0,0/
  !
  !-----------------------------------------------------
  !
  do iy=1,ny
     do ix=1,nx
        !
        !  copy derivatives from result.  Special treatment needed for end zones
        !
        iflag=0
        dxuse=0.0_fp
        dyuse=0.0_fp
        ixuse=ix
        iyuse=iy
        if(ix.eq.nx) then
           iflag=1
           dxuse=hxlast
           ixuse=ix-1
        end if
        if(iy.eq.ny) then
           iflag=1
           dyuse=hylast
           iyuse=iy-1
        end if
        !
        if(iflag.eq.1) then
           call bcspevfn(iselect,1,1,zvalues, &
                ixuse,iyuse,dxuse,dyuse, &
                fwk,nx,ny)
           do j=2,4
              fin(j,ix,iy)=zvalues(j)
           end do
        else
           fin(2,ix,iy)=2.0_fp*fwk(3,1,ix,iy)
           fin(3,ix,iy)=2.0_fp*fwk(1,3,ix,iy)
           fin(4,ix,iy)=4.0_fp*fwk(3,3,ix,iy)
        end if
        !
     end do
  end do
  !
  return
end subroutine mkbicon

program portlib_env_test

  ! test portlib modules to support MPI distribution of working directory
  ! and command line arguments and selected environment variables

  ! May 19, 2011: added testing of MPI proc/node information (mpi_proc_data)
  ! which for MPI_COMM_WORLD is set up on the first mpi_set_env or mpi_get_env
  ! call or by mpi_share_env

  use logmod
  use mpi_proc_data
  implicit none

#ifdef __MPI
  include 'mpif.h'
#endif

  ! local communicator
#ifdef __MPI
  integer :: nbi_comm = MPI_COMM_WORLD
#else
  integer :: nbi_comm = -1
#endif

  integer :: myid,ierr,iertmp,istat,jstat,iolun,idot,iost,ierloc,io
  integer :: num_nodes,maxlist,mylist_size,itest,mynode
  integer, dimension(:), allocatable :: myprocs,myproc2

  character*200 :: env_val,log_file,jobid
  
  character*32 runid
  character*200 :: log_file_prefix,zcmd,path_transl

  character*40 filexxx,filennn,zpbsid

  logical :: pflag,pexist
  integer :: izp,izleft,iotest

#ifdef __MPI
  character*(MPI_MAX_PROCESSOR_NAME) proc_name
  integer iresult
#endif
  integer :: numprocs = 1

  !-----------------------------------------
  ! executable code

#ifdef __MPI

  call MPI_INIT(ierr)
  if(ierr.ne.0) call errmsg_exit(' MPI_INIT failure! ')

  call MPI_COMM_RANK(nbi_comm,myid,ierr);   call ckerr('MPI_COMM_RANK')
  call MPI_COMM_SIZE(nbi_comm,numprocs,ierr);   call ckerr('MPI_COMM_SIZE')
  if(myid.eq.0) then
     write(0,*) ' mpi portlib_env_test:  numprocs = ',numprocs
     write(0,*) ' communicator ID:       nbi_comm = ',nbi_comm
  endif

  call MPI_GET_PROCESSOR_NAME(proc_name,iresult,ierr)
  call ckerr('MPI_GET_PROCESSOR_NAME')

  write(0,*) ' portlib_env_test: MPI, myid=',myid,' proc_name = "', &
       trim(proc_name),'"'
#else
  myid = 0
  write(0,*) ' portlib_env_test: serial operation (myid=0).'
#endif

  if(myid.eq.0) then
     call mpi_sget_env('PBS_JOBID',env_val,ierr); call ckerr('mpi_sget_env(1)')
     idot = index(env_val,".") - 1
     if(idot.gt.1) then
        call mpi_sset_env('PBS_JOBID',env_val(1:idot),ierr)
        call ckerr('mpi_sset_env(1)')
     endif
  endif
  call mpi_share_env(myid,ierr); call ckerr('mpi_share_env')
  if(myid.eq.0) then
     call mpi_printenv(myid,6)
  else
     
     call mpi_sget_env('PBS_JOBID',jobid,ierr); call ckerr('mpi_sget_env')
     
  endif
  log_file = "env_test.log"
  call openLog(file=trim(log_file),status='ONCE',iostat=iost, &
       comm_world=nbi_comm) 

  call setLogLevel('info') ! log file for info - error messages

  call infoLog('portlib_env_test log file opening')
  call infoLog('portlib_env_test log file opening')
  call infoLog('portlib_env_test log file opening')

  if(myid.eq.0) then

     ! uncomment this for extra debugging in mpi_share_env(...):
     !!! call mpi_sset_env('MPI_SHARE_ENV_DEBUG','TRUE',ierr)
     call mpi_sget_env('PBS_JOBID',env_val,ierr); call ckerr('mpi_sget_env(1)')
     idot = index(env_val,".") - 1
     if(idot.gt.1) then
        call mpi_sset_env('PBS_JOBID',env_val(1:idot),ierr)
        call ckerr('mpi_sset_env(1)')
     endif
     call mpi_sget_env('PREACTDIR',env_val,ierr); call ckerr('mpi_sget_env(2)')
     call mpi_sset_env('NUBEAM_ACTION','test',ierr); call ckerr('mpi_sset_env(2)')
     call mpi_sset_env('NUBEAM_WORKPATH','foo',ierr); call ckerr('mpi_sset_env(3)')

  endif

  call mpi_share_env(myid,ierr); call ckerr('mpi_share_env (1)')

  if(myid.eq.0) then
     call mpi_printenv(myid,6)   ! output the environment 
     call mpi_sset_env('NUBEAM_COMPONENT','TRUE',ierr); call ckerr('mpi_sset_env(4)')
     call mpi_sset_env('TORIC_COMPONENT','FALSE',ierr); call ckerr('mpi_sset_env(4)')
     call mpi_sset_env('PT_SOLVER_COMPONENT','FALSE',ierr); call ckerr('mpi_sset_env(4)')
  endif

  call mpi_share_env(myid,ierr); call ckerr('mpi_share_env (2)')

  if(myid.gt.0) then
     iolun=6  ! 6 is OK -- was tested
  else
     iolun=6
  endif

#ifdef __MPI
  if(myid.le.0) then
     write(iolun,*) &
          ' child logs written to: env_test_<jobid>.log_1, env_test_<jobid>.log_2, ... '
     write(iolun,*) '   in directory matching cwd of parent.'
  endif
#endif

  if(myid.gt.0) then

     call mpi_sget_env('PBS_JOBID',jobid,ierr); call ckerr('mpi_sget_env')
     log_file = ' '
     if(myid.le.9) then
        write(log_file,'(a,i1)') "env_test_"//trim(jobid)//".log_",myid
     else if(myid.le.99) then
        write(log_file,'(a,i2)') "env_test_"//trim(jobid)//".log_",myid
     else if(myid.le.999) then
        write(log_file,'(a,i3)') "env_test_"//trim(jobid)//".log_",myid
     else if(myid.le.9999) then
        write(log_file,'(a,i4)') "env_test_"//trim(jobid)//".log_",myid
     endif

     open(unit=iolun,file=trim(log_file),status='unknown',iostat=istat)
     if(istat.eq.0) then
        write(0,*) ' proc #',myid,' opened file OK: ',trim(log_file)
     else
        write(0,*) ' ?? proc #',myid,' file open failure: ',trim(log_file)
     endif
  endif

  call mpi_printenv(myid,iolun)   ! output the environment 

  if(myid.gt.0) then
     close(unit=iolun,iostat=istat)
     if(istat.eq.0) then
        write(0,*) ' proc #',myid,' closed file OK: ',trim(log_file)
     else
        write(0,*) ' ?? proc #',myid,' file close failure: ',trim(log_file)
     endif
  endif

#ifdef __MPI
  call MPI_BARRIER(nbi_comm,ierloc)
#endif

  call mpi_print_info(nbi_comm,0,ierloc)
  if(numprocs.gt.1) call mpi_print_info(nbi_comm,1,ierloc)
  if(numprocs.gt.2) call mpi_print_info(nbi_comm,numprocs-1,ierloc)

  itest = max(0,numprocs-1)

  if(myid.eq.itest) then
     call mpi_proc_info(nbi_comm,ierloc, num_nodes=num_nodes, &
          maxnode_numprocs=maxlist,mynode=mynode)

     allocate(myprocs(maxlist+1)) ! deliberately padded
     allocate(myproc2(maxlist+1)) ! deliberately padded

     call mpi_proc_info(nbi_comm,ierloc, node_proclist=myprocs, &
          node_numprocs = mylist_size)

     call mpi_proc_info(nbi_comm,ierloc, node_number=mynode, &
          node_proclist=myproc2, &
          parallel_file_system = pflag)

     write(0,*) ' '
     write(0,*) ' these should match: '
     write(0,*) '    myprocs: ',myprocs(1:mylist_size+1)
     write(0,*) '    myproc2: ',myproc2(1:mylist_size+1)
     write(0,*) ' '
     write(0,*) ' parallel_file_system: ',pflag
     write(0,*) ' '
  endif

  call closeLog

#ifdef __MPI
  call MPI_BARRIER(nbi_comm,ierr)
  if(ierr.ne.0) write(0,*) ' ?? proc#',myid,' MPI_BARRIER returned ierr=',ierr
#endif

  ! test file copying
  filexxx = 'testxxxxx.dat'
  call find_io_unit(io)
  if(myid.eq.0) then
     open(unit=io,file=filexxx,status='unknown')
     write(io,*) 'this is...'
     write(io,*) '  ...a test'
     close(unit=io)
  endif

  do io=0,numprocs-1
     filennn=' '
     write(filennn,'("test",i5.5,".dat")') io
     call mpi_file_bcast(nbi_comm,filexxx,ierr, newname=filennn)
     if(ierr.ne.0) write(0,*) ' ?? proc#',myid,' parcopy returned ierr=',ierr
  enddo

#ifdef __MPI
  !! write(0,*) ' enter final MPI_ALLREDUCE: myid = ',myid
  call MPI_ALLREDUCE(ierr,istat,1,MPI_INTEGER,MPI_MAX,nbi_comm,iertmp)
  !! write(0,*) ' after final MPI_ALLREDUCE: myid=',myid,' iertmp=',iertmp
  write(0,*) ' at MPI_FINALIZE: myid = ',myid,' ierr = ',ierr
  call MPI_FINALIZE(ierr);  call ckerr('MPI_FINALIZE')
#endif

  if(myid.eq.0) then

     call execute_command_line('mkdir -p foonzork',exitstat=istat)
     write(0,*) 'system command ("mkdir -p foonzork") status: ',istat
     call execute_command_line('rmdir foonzork',exitstat=istat)
     write(0,*) 'system command ("rmdir foonzork") status: ',istat

     inquire(file='/usr/pppl/bin/pbs_timeleft',exist=pexist,iostat=istat)
     pexist = pexist .AND. (istat.eq.0)
     if(.NOT.pexist) then
        write(0,*) ' pbs_timeleft command script not found: pexist=',pexist, &
             ' istat= ',istat
     else
        call sget_env('PBS_JOBID',zpbsid)
        if(zpbsid.eq.' ') then
           write(0,*) ' pbs_timeleft not attempted: PBS_JOBID not found.'
        else
           write(0,*) ' PBS_JOBID: '//trim(zpbsid)
           izp=index(zpbsid,'.')-1
           if(izp.le.0) izp=len_trim(zpbsid)

           zcmd = '/usr/pppl/bin/pbs_timeleft '//zpbsid(1:izp) &
                //' > loc_'//zpbsid(1:izp)//'.tmp'

           write(0,*) ' attempting: system command ("'//trim(zcmd)//'")'

           call execute_command_line(zcmd,exitstat=istat)

           if(istat.ne.0) then
              write(0,*) ' system command failed, error status: ',istat
           else
              !  read pbs_timeleft output
              call find_io_unit(iotest)
              open(unit=iotest,file='loc_'//zpbsid(1:izp)//'.tmp', &
                   status='old',iostat=jstat)
              if(jstat.ne.0) then
                 write(0,*) ' system command OK but no file: loc_'//zpbsid(1:izp)//'.tmp'
              else
                 read(iotest,*,iostat=jstat) izleft
                 if(jstat.ne.0) then
                    write(0,*) ' error reading:  loc_'//zpbsid(1:izp)//'.tmp'
                    close(iotest)
                 else
                    close(iotest,status='delete')
                    write(0,*) ' pbs_timeleft OK, seconds=',izleft, &
                         ' hours=',izleft/3600
                 endif  ! pbs_timeleft output file read OK
              endif  ! pbs_timeleft output file open OK
           endif  ! system command OK
        endif  ! PBS_JOBID defined
     endif  ! PPPL pbs_timeleft procedure found

     write(0,*) ' '
     call nodepath_translator('/u/dmccune',path_transl,nbi_comm,0)
     write(0,*) ' /u/dmccune path translation: '//trim(path_transl)
     call nodepath_translator('/local/dmccune',path_transl,nbi_comm,0)
     write(0,*) ' /local/dmccune path translation: '//trim(path_transl)

  endif  ! myid.eq.0

CONTAINS
  subroutine ckerr(callnam)

    character*(*) :: callnam

    if(ierr.ne.0) then
       write(0,*) ' error ierr=',ierr,' in call "',trim(callnam), &
            '" on proc #',myid
       call bad_Exit
    endif

  end subroutine ckerr

end program portlib_env_test

subroutine EZspline_2NetCDF_array3(n1, n2, n3, x1, x2, x3, f, filename, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj   
  use EZcdf
  implicit none
  integer, intent(in) :: n1, n2, n3
  real(fp), intent(in) :: x1(:), x2(:), x3(:), f(:, :, :)
  character(len=*), intent(in) :: filename
  integer, intent(out) :: ier
  integer ifail

  integer dimlens(3), ncid

  ier = 0
  call cdfOpn(ncid, filename, 'w')
  if(ncid==0) then
     ier = 34
     return
  end if
  dimlens = (/ 1, 1, 1 /)
  call cdfDefVar(ncid, 'n1', dimlens, 'INT', ifail)
  call cdfDefVar(ncid, 'n2', dimlens, 'INT', ifail)
  call cdfDefVar(ncid, 'n3', dimlens, 'INT', ifail)
  dimlens = (/ n1, 1, 1 /)
  call cdfDefVar(ncid, 'x1', dimlens, 'R8', ifail)
  dimlens = (/ n2, 1, 1 /)
  call cdfDefVar(ncid, 'x2', dimlens, 'R8', ifail)
  dimlens = (/ n3, 1, 1 /)
  call cdfDefVar(ncid, 'x3', dimlens, 'R8', ifail)
  dimlens = (/ n1, n2, n3 /)
  call cdfDefVar(ncid, 'f', dimlens, 'R8', ifail)
  if(ifail/=0) then
     ier = 38 
     return
  end if
  call cdfPutVar(ncid, 'n1', n1, ifail)
  call cdfPutVar(ncid, 'n2', n2, ifail)
  call cdfPutVar(ncid, 'n3', n3, ifail)
  call cdfPutVar(ncid, 'x1', x1, ifail)
  call cdfPutVar(ncid, 'x2', x2, ifail)
  call cdfPutVar(ncid, 'x3', x3, ifail)
  call cdfPutVar(ncid, 'f', f, ifail)
  if(ifail/=0) then
     ier = 35 
     return
  end if

  call cdfCls(ncid)

end subroutine EZspline_2NetCDF_array3

subroutine EZspline_2NetCDF_array2(n1, n2, x1, x2, f, filename, ier)
  use EZspline_obj   
  use EZcdf
  implicit none
  integer, intent(in) :: n1, n2
  real(fp), intent(in) :: x1(:), x2(:), f(:,:)
  character(len=*), intent(in) :: filename
  integer, intent(out) :: ier
  integer ifail

  integer dimlens(3), ncid

  ier = 0
  call cdfOpn(ncid, filename, 'w')
  if(ncid==0) then
     ier = 34
     return
  end if
  dimlens = (/ 1, 1, 1 /)
  call cdfDefVar(ncid, 'n1', dimlens, 'INT', ifail)
  call cdfDefVar(ncid, 'n2', dimlens, 'INT', ifail)
  dimlens = (/ n1, 1, 1 /)
  call cdfDefVar(ncid, 'x1', dimlens, 'R8', ifail)
  dimlens = (/ n2, 1, 1 /)
  call cdfDefVar(ncid, 'x2', dimlens, 'R8', ifail)
  dimlens = (/ n1, n2, 1 /)
  call cdfDefVar(ncid, 'f', dimlens, 'R8', ifail)
  if(ifail/=0) then
     ier = 38 
     return
  end if

  call cdfPutVar(ncid, 'n1', n1, ifail)
  call cdfPutVar(ncid, 'n2', n2, ifail)
  call cdfPutVar(ncid, 'x1', x1, ifail)
  call cdfPutVar(ncid, 'x2', x2, ifail)
  call cdfPutVar(ncid, 'f', f, ifail)
  if(ifail/=0) then
     ier = 35 
     return
  end if

  call cdfCls(ncid)

end subroutine EZspline_2NetCDF_array2

subroutine EZspline_2NetCDF1(n1, x1, f, filename, ier)
  use EZspline_obj   
  use EZcdf
  implicit none
  integer, intent(in) :: n1
  real(fp), intent(in) :: x1(:), f(:)
  character(len=*), intent(in) :: filename
  integer, intent(out) :: ier
  integer ifail

  integer dimlens(3), ncid

  ier = 0
  call cdfOpn(ncid, filename, 'w')
  if(ncid==0) then
     ier = 34
     return
  end if
  dimlens = (/ 1, 1, 1 /)
  call cdfDefVar(ncid, 'n1', dimlens, 'INT', ifail)
  dimlens = (/ n1, 1, 1 /)
  call cdfDefVar(ncid, 'x1', dimlens, 'R8', ifail)
  dimlens = (/ n1, 1, 1 /)
  call cdfDefVar(ncid, 'f', dimlens, 'R8', ifail)
  if(ifail/=0) then
     ier = 38 
     return
  end if

  call cdfPutVar(ncid, 'n1', n1, ifail)
  call cdfPutVar(ncid, 'x1', x1, ifail)
  call cdfPutVar(ncid, 'f', f, ifail)
  if(ifail/=0) then
     ier = 35 
     return
  end if

  call cdfCls(ncid)

end subroutine EZspline_2NetCDF1

subroutine EZspline_2NetCDF_cloud3(n, x1, x2, x3, f, filename, ier)
  use EZspline_obj   
  use EZcdf
  implicit none
  integer, intent(in) :: n
  real(fp), intent(in) :: x1(:), x2(:), x3(:), f(:)
  character(len=*), intent(in) :: filename
  integer, intent(out) :: ier
  integer ifail

  integer dimlens(3), ncid

  ier = 0
  call cdfOpn(ncid, filename, 'w')
  if(ncid==0) then
     ier = 34
     return
  end if
  dimlens = (/ 1, 1, 1 /)
  call cdfDefVar(ncid, 'n', dimlens, 'INT', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'x1', dimlens, 'R8', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'x2', dimlens, 'R8', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'x3', dimlens, 'R8', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'f', dimlens, 'R8', ifail)
  if(ifail/=0) then
     ier = 38 
     return
  end if

  call cdfPutVar(ncid, 'n', n, ifail)
  call cdfPutVar(ncid, 'x1', x1, ifail)
  call cdfPutVar(ncid, 'x2', x2, ifail)
  call cdfPutVar(ncid, 'x3', x3, ifail)
  call cdfPutVar(ncid, 'f', f, ifail)
  if(ifail/=0) then
     ier = 35 
     return
  end if

  call cdfCls(ncid)

end subroutine EZspline_2NetCDF_cloud3

subroutine EZspline_2NetCDF_cloud2(n, x1, x2, f, filename, ier)
  use EZspline_obj   
  use EZcdf
  implicit none
  integer, intent(in) :: n
  real(fp), intent(in) :: x1(:), x2(:), f(:)
  character(len=*), intent(in) :: filename
  integer, intent(out) :: ier
  integer ifail

  integer dimlens(3), ncid

  ier = 0
  call cdfOpn(ncid, filename, 'w')
  if(ncid==0) then
     ier = 34
     return
  end if
  dimlens = (/ 1, 1, 1 /)
  call cdfDefVar(ncid, 'n', dimlens, 'INT', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'x1', dimlens, 'R8', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'x2', dimlens, 'R8', ifail)
  dimlens = (/ n, 1, 1 /)
  call cdfDefVar(ncid, 'f', dimlens, 'R8', ifail)
  if(ifail/=0) then
     ier = 38 
     return
  end if

  call cdfPutVar(ncid, 'n', n, ifail)
  call cdfPutVar(ncid, 'x1', x1, ifail)
  call cdfPutVar(ncid, 'x2', x2, ifail)
  call cdfPutVar(ncid, 'f', f, ifail)
  if(ifail/=0) then
     ier = 35 
     return
  end if

  call cdfCls(ncid)

end subroutine EZspline_2NetCDF_cloud2

!  EZhybrid routines callable without a module interface...

subroutine EZhybrid_init2_x(spline_o, n1, n2, hspline, ier)

  !  init call (set array size from object)

  use EZspline_obj
  use EZspline
  implicit NONE

  type(EZspline2) spline_o
  integer, intent(in) :: n1, n2
  integer, intent(in) :: hspline(2)
  integer, intent(out) :: ier

  call EZhybrid_init(spline_o, n1, n2, hspline, ier)

end subroutine EZhybrid_init2_x

subroutine EZhybrid_init3_x(spline_o, n1, n2, n3, hspline, ier)

  !  init call (set array size from object)

  use EZspline_obj
  use EZspline
  implicit NONE

  type(EZspline3) spline_o
  integer, intent(in) :: n1, n2, n3
  integer, intent(in) :: hspline(3)
  integer, intent(out) :: ier

  call EZhybrid_init(spline_o, n1, n2, n3, hspline, ier)

end subroutine EZhybrid_init3_x

MODULE ezcdf_opncls
 
  interface cdfOpn
     module procedure ezcdf_open
  end interface

  interface cdf_open
     module procedure ezcdf_open
  end interface

  interface cdfCls
     module procedure ezcdf_close
  end interface

  interface cdf_close
     module procedure ezcdf_close
  end interface

CONTAINS
 
  subroutine ezcdf_open(ncid,filename,opt,ier)
    ! Create/open cdf file
    ! 03/09/99 C.Ludescher
    !
    !  opt values:
    !    "R" -- readonly, existing file
    !    "W" -- write new file
    !    "M" -- "Modify" -- read/write data in existing file
    !                       (but structure of file does not change)
    !    "A" -- "Append" -- add new structure (define new data items)
    !                       in existing file.  Existing items can also
    !                       be read/written, but only after *new* items
    !                       are first defined and then written.
    !    "V" -- "Verify/Append/Write" -- first try opening in "A" mode; if
    !                       that fails open in "W" mode.
    !
    !  for both "W" and "A" modes, the file is opened in "define data mode".
    !
    include "netcdf.inc"
    INTEGER,       intent(out) :: ncid
    character*(*), intent(in) :: filename
    character*1,   intent(in) :: opt
    integer, optional, intent(out) :: ier
    integer :: status
 
    if (opt .eq. 'w' .or. opt .eq. 'W') then
       ! New file... start in "define mode".
       status = nf_create(filename,IOR(NF_CLOBBER,NF_64BIT_OFFSET),ncid)
       call ezcdf_error(status,filename,'cdfcrt','nf_create')
    else if (opt .eq. 'm' .or. opt .eq. 'M') then
       ! Open existing file for read/write modifications...
       status = nf_open(filename, nf_write, ncid)
       call ezcdf_error(status,filename,'cdfopn','nf_open')
    else if (opt .eq. 'a' .or. opt .eq. 'A') then
       ! Open existing file for read/write modifications...
       status = nf_open(filename, nf_write, ncid)
       call ezcdf_error(status,filename,'cdfopn','nf_open')
       if( status .eq. NF_NOERR ) then
          status = nf_redef(ncid)  ! start in "define mode".
          call ezcdf_error(status,filename,'cdfopn','nf_redef')
       endif
    else if (opt .eq. 'v' .or. opt .eq. 'V') then
       ! Open existing file for read/write modifications...
       status = nf_open(filename, nf_write, ncid)
       if( status .eq. NF_NOERR ) then
          status = nf_redef(ncid)  ! start in "define mode".
       else
          status = nf_create(filename,IOR(NF_CLOBBER,NF_64BIT_OFFSET),ncid)  ! start new file.
       endif
       call ezcdf_error(status,filename,'cdfopn','nf_open')
    else
       ! Open for readonly
       status = nf_open(filename, nf_nowrite, ncid)
       call ezcdf_error(status,filename,'cdfopn','nf_open')
    end if
    if (PRESENT (ier)) then
       if (status .ne. NF_NOERR) then
          ier = 1
       else
          ier = 0
       endif
    endif
    return
  end subroutine ezcdf_open
 

  subroutine ezcdf_close(ncid, ier)
    include "netcdf.inc"
    INTEGER, INTENT(in) ::  ncid
    integer, optional,         intent(out) :: ier
    INTEGER status
    status = nf_close(ncid)
    call ezcdf_error(status,' ','cdfcls','nf_close')
    if(PRESENT (ier)) ier = status
  end subroutine ezcdf_close
 
END MODULE ezcdf_opncls

c-----------------------------------------------
 
      subroutine cptimi(ztime)
      implicit none
 
      real ztime
c
c  DMC 5 Sep 1991
c
c    this routine is a more portable FORTRAN version of the old macro
c    CPTIMI.MAR.  It returns the amount of cpu time used so far by the
c    current process, in a floating point word, in units of HUNDREDTHS
c    of seconds *** NOTE FUNNY UNITS which are used for historical
c    reasons
c
c    usage:
c
c       CALL CPTIMI(ZTIME1)
c
c         execute code-to-be-timed
c
c       CALL CPTIMI(ZTIME2)
c
c       ZTIME = 0.01*(ZTIME2-ZTIME1)
c       TYPE 1001,ZTIME
c 1001	FORMAT('  CPU time used = ',1pe11.4,' seconds.')
c
c-------------------------------------------------
c
c  dmc May 2007 -- use standard f95 intrinsic routine "cpu_time"
c

      call cpu_time(ztime)
      ztime = 100.0*ztime   ! units returned: 100ths of a second...

      return
      end

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Save object in file

#include "cpp/czspline_handle_size.h"

  #define _S czspline_save1
  #define _O czspline1
  #include "czspline_save.h"
  #undef _S
  #undef _O

  #define _S czspline_save2
  #define _O czspline2
  #include "czspline_save.h"
  #undef _S
  #undef _O

  #define _S czspline_save3
  #define _O czspline3
  #include "czspline_save.h"
  #undef _S
  #undef _O

      subroutine c9date(zdate)
      character*(*) zdate
C
C  get a 9 character date -- portably -- by calling C code
C  RGA, use 10 character C string so it can be null terminated
C
#include "fpreproc/byte_declare.h"
C
      BYTE_DECLARE z9date(10)
C
      ilen=10
      call c9dat0(z9date,ilen)
C
      call cstring(zdate,z9date,'2F')
C
      return
      end

!  tcspline -- dmc 20 Jan 1999
!
!  set up coefficients for bicubic spline with following BC's:
!  * LHS and RHS handled as in cubspl.f90 for 1st coordinate
!  * derivatives periodic in second coordinate (use pspline.f90)
!
! workspace:
!  if phi bdy cond. is periodic, not-a-knot, df/dphi = 0 everywhere,
!  or d2f/dphi2 = 0 everywhere, then the phi boundary condition is
!  "linear" and a workspace of size at least:
!
!     nwk = 20*inx*inth + 10*max(inx,inth,inph)
!
!  will suffice.
!
!  if the phi bdy cond. involves specification of df/dphi .ne. 0 or
!  d2f/dphi .ne. 0 at any (x,theta) grid point, then, the phi boundary
!  condition is "non-linear", a correction step is needed, and a workspace
!  of size at least:
!
!     nwk = 16*inx*inth*inph
!
!  is required.
!
subroutine tcspline(x,inx,th,inth,ph,inph,fspl,inf4,inf5, &
     ibcxmin,bcxmin,ibcxmax,bcxmax,inb1x, &
     ibcthmin,bcthmin,ibcthmax,bcthmax,inb1th, &
     ibcphmin,bcphmin,ibcphmax,bcphmax,inb1ph, &
     wk,nwk,ilinx,ilinth,ilinph,ier)
  use iso_c_binding, only: fp => c_double
  !
  !============
  implicit none
  integer inth,inph,inf4,inf5,ibcxmin,ibcxmax,inb1x,ibcthmin
  integer ibcthmax,inb1th,ibcphmin,ibcphmax,inb1ph,nwk,ilinx
  integer ilinth,ilinph,ier,inx,iflg,ith,ix,itest,ierx,ierth
  integer ierph,iaspl2,iabcx1,iabcx2,iabcth1,iabcth2,iawk,inwk
  integer iph,inpho,ic1,ic2,ibcphmina,ibcphmaxa,iabcph1,iabcph2
  integer iaccoef,i,iskip1,iskip2,ia1,ia2
  !============
  real(fp) :: xo2,xo6
  !============
  real(fp) :: x(inx),th(inth),ph(inph)
  real(fp) :: fspl(4,4,4,inf4,inf5,inph),wk(nwk)
  real(fp) :: bcxmin(inb1x,*),bcxmax(inb1x,*) ! inth x inph defined (if used)
  real(fp) :: bcthmin(inb1th,*),bcthmax(inb1th,*) ! inx x inph defined (if used)
  real(fp) :: bcphmin(inb1ph,*),bcphmax(inb1ph,*) ! inx x inth defined (if used)
  !
  !  input:
  !    x(1...inx) -- abscissae, first dimension of data
  !   th(1...inth) -- abscissae, second (periodic) dimension of data
  !   ph(1...inph) -- abscissae, third (periodic) dimension of data
  !   fspl(1,1,1,1..inx,1..inth,1..inph) -- function values
  !   inf4 -- fspl dimensioning, inf4.ge.inx required.
  !   inf5 -- fspl dimensioning, inf5.ge.inth required.
  !
  !  boundary conditions input:
  !
  !   bc data at xmin, xmax  vs.  theta,phi
  !   bc data at thmin, thmax  vs.  x,phi
  !   bc data at phmin, phmax  vs.  x,theta
  !
  !   ibcxmin -- indicator for boundary condition at x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- use periodic boundary condition
  !     =0 -- use "not a knot", bcxmin(...) ignored
  !     =1 -- match slope, specified at x(1),th(ith),ph(iph) by bcxmin(ith,iph)
  !     =2 -- match 2nd derivative, specified at x(1),th(ith),ph(iph)
  !           by bcxmin(ith,iph
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
  !     =5 -- match 1st derivative to 1st divided difference
  !     =6 -- match 2nd derivative to 2nd divided difference
  !     =7 -- match 3rd derivative to 3rd divided difference
  !           (for more detailed definition of BCs 5-7, see the
  !           comments of subroutine mkspline)
  !   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !     NOTE:  if ibcxmin=-1 then the periodic BC applies on both sides
  !            and ibcxmax is ignored.
  !   inb1x -- 1st dimension of bcxmin, bcxmax: if ibcxmin or ibcxmax .gt. 0
  !            this must be .ge. inth:
  !
  !   interpretation of ibcthmin,bcthmin,ibcthmax,bcthmax,inb1th
  !     is same as with ibcxmin,...
  !
  !   interpretation of ibcphmin,bcphmin,ibcphmax,bcphmax,inb1ph
  !     is same as with ibcxmin,...
  !
  !   the explicit bdy condition arrays are referenced only if the
  !     corresponding "ibc" flag values are set to 1 or 2.
  !
  !  output:
  !   fspl(*,*,*,1..inx,1..inth,1..inph) -- bicubic spline coeffs (4x4)
  !   ...fspl(1,1,1,*,*,*) is not replaced.
  !
  !   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
  !   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
  !   ilinph-- =1 on output if ph(inph) evenly spaced (tol=1e-3)
  !
  !   ier -- completion code, 0 for normal
  !
  !  workspace:
  !   wk -- must be at least 5*max(inx,inth,inph) large -- or more, see
  !         comments, above.
  !  nwk -- size of workspace
  !
  !---------------------------------
  !  ** in what follows, f is an abbreviation for fspl **
  !
  !  compute tricubic spline of 3d function, given values at the
  !  grid crossing points, f(1,1,1,i,j,k)=f(x(i),th(j),ph(k)).
  !
  !  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
  !                       and th btw th(j) and th(j+1), dt=th-th(j),
  !                       and ph btw ph(k) and ph(k+1), dp=ph-ph(k),
  !
  !      spline =
  !        f(1,1,1,i,j,k)+dx*f(2,1,1,i,j,k)+dx2*f(3,1,1,i,j,k)+dx3*f(4,1,1,i,j,k)
  !  +dt*(f(1,2,1,i,j,k)+dx*f(2,2,1,i,j,k)+dx2*f(3,2,1,i,j,k)+dx3*f(4,2,1,i,j,k))
  ! +dt2*(f(1,3,1,i,j,k)+dx*f(2,3,1,i,j,k)+dx2*f(3,3,1,i,j,k)+dx3*f(4,3,1,i,j,k))
  ! +dt3*(f(1,4,1,i,j,k)+dx*f(2,4,1,i,j,k)+dx2*f(3,4,1,i,j,k)+dx3*f(4,4,1,i,j,k))
  !        +dp*(
  !        f(1,1,2,i,j,k)+dx*f(2,1,2,i,j,k)+dx2*f(3,1,2,i,j,k)+dx3*f(4,1,2,i,j,k)
  !  +dt*(f(1,2,2,i,j,k)+dx*f(2,2,2,i,j,k)+dx2*f(3,2,2,i,j,k)+dx3*f(4,2,2,i,j,k))
  ! +dt2*(f(1,3,2,i,j,k)+dx*f(2,3,2,i,j,k)+dx2*f(3,3,2,i,j,k)+dx3*f(4,3,2,i,j,k))
  ! +dt3*(f(1,4,2,i,j,k)+dx*f(2,4,2,i,j,k)+dx2*f(3,4,2,i,j,k)+dx3*f(4,4,2,i,j,k)))
  !        +dp2*(
  !        f(1,1,3,i,j,k)+dx*f(2,1,3,i,j,k)+dx2*f(3,1,3,i,j,k)+dx3*f(4,1,3,i,j,k)
  !  +dt*(f(1,2,3,i,j,k)+dx*f(2,2,3,i,j,k)+dx2*f(3,2,3,i,j,k)+dx3*f(4,2,3,i,j,k))
  ! +dt2*(f(1,3,3,i,j,k)+dx*f(2,3,3,i,j,k)+dx2*f(3,3,3,i,j,k)+dx3*f(4,3,3,i,j,k))
  ! +dt3*(f(1,4,3,i,j,k)+dx*f(2,4,3,i,j,k)+dx2*f(3,4,3,i,j,k)+dx3*f(4,4,3,i,j,k)))
  !        +dp3*(
  !        f(1,1,4,i,j,k)+dx*f(2,1,4,i,j,k)+dx2*f(3,1,4,i,j,k)+dx3*f(4,1,4,i,j,k)
  !  +dt*(f(1,2,4,i,j,k)+dx*f(2,2,4,i,j,k)+dx2*f(3,2,4,i,j,k)+dx3*f(4,2,4,i,j,k))
  ! +dt2*(f(1,3,4,i,j,k)+dx*f(2,3,4,i,j,k)+dx2*f(3,3,4,i,j,k)+dx3*f(4,3,4,i,j,k))
  ! +dt3*(f(1,4,4,i,j,k)+dx*f(2,4,4,i,j,k)+dx2*f(3,4,4,i,j,k)+dx3*f(4,4,4,i,j,k)))
  !
  !      where dx2=dx**2 and dx3=dx**3.
  !      where dt2=dt**2 and dt3=dt**3.
  !      where dp2=dp**2 and dp3=dp**3.
  !
  !---------------------------------
  integer iselect1(10)
  integer iselect2(10)
  !
  real(fp) :: z0,z1,ztol
  real(fp) :: zcur(1)
  !
  data z0/0.0_fp/
  data z1/1.0_fp/
  data ztol/1.0E-3_fp/
  !
  !---------------------------------
  !
  ier=0
  !
  iflg=0
  !
  !  check phi bdy condition "linearity"
  !
  if(ibcphmin.ne.-1) then
     if((ibcphmin.eq.1).or.(ibcphmin.eq.2)) then
        do ith=1,inth
           do ix=1,inx
              if(bcphmin(ix,ith).ne.z0) iflg=1
           end do
        end do
     end if
     if((ibcphmax.eq.1).or.(ibcphmax.eq.2)) then
        do ith=1,inth
           do ix=1,inx
              if(bcphmax(ix,ith).ne.z0) iflg=1
           end do
        end do
     end if
  end if
  !
  itest=10*max(inx,inth,inph) + 20*inx*inth
  if(iflg.eq.1) then
     itest=16*inx*inth*inph
  end if
  !
  if(nwk.lt.itest) then
     write(6,9901) nwk,itest
     ier=1
9901 format(' ?tcspline:  workspace too small.'/ &
          '  user supplied nwk=',i7,'; need at least: ',i7/ &
          '  If no explicit df/dph boundary condition is set,'/ &
          '  nwk = 20*inx*inth + 10*max(inx,inth,inph) can be used.'/ &
          '  If an explicit df/dph or d2f/dph2 boundary condition'/ &
          '  is set, nwk=16*inx*inth*inph is required.')
  end if
  if(inx.lt.2) then
     write(6,'('' ?tcspline:  at least 2 x points required.'')')
     ier=1
  end if
  if(inth.lt.2) then
     write(6,'('' ?tcspline:  need at least 2 theta points.'')')
     ier=1
  end if
  if(inph.lt.2) then
     write(6,'('' ?tcspline:  need at least 2 phi points.'')')
     ier=1
  end if
  !
  if((ibcxmin.eq.1).or.(ibcxmax.eq.1).or.(ibcxmin.eq.2).or. &
       (ibcxmax.eq.2)) then
     if(inb1x.lt.inth) then
        ier=1
        write(6, &
             '('' ?tcspline:  1st dim of bcxmin/max arrays .lt. inth'')')
     end if
  end if
  !
  if((ibcthmin.eq.1).or.(ibcthmax.eq.1).or.(ibcthmin.eq.2).or. &
       (ibcthmax.eq.2)) then
     if(inb1th.lt.inx) then
        ier=1
        write(6, &
             '('' ?tcspline:  1st dim of bcthmin/max arrays .lt. inx'')')
     end if
  end if
  !
  if((ibcphmin.eq.1).or.(ibcphmax.eq.1).or.(ibcphmin.eq.2).or. &
       (ibcphmax.eq.2)) then
     if(inb1ph.lt.inx) then
        ier=1
        write(6, &
             '('' ?tcspline:  1st dim of bphmin/max arrays .lt. inx'')')
     end if
  end if
  !
  call ibc_ck(ibcxmin,'tcspline','xmin',-1,7,ier)
  if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'tcspline','xmax',0,7,ier)
  !
  call ibc_ck(ibcthmin,'tcspline','thmin',-1,7,ier)
  if(ibcthmin.ge.0) call ibc_ck(ibcthmax,'tcspline','thmax',0,7,ier)
  !
  call ibc_ck(ibcphmin,'tcspline','phmin',-1,7,ier)
  if(ibcphmax.ge.0) call ibc_ck(ibcphmax,'tcspline','phmax',0,7,ier)
  !
  !  check ilinx & x vector
  !
  call splinck(x,inx,ilinx,ztol,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?tcspline:  x axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(th,inth,ilinth,ztol,ierth)
  if(ierth.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?tcspline:  theta axis not strict ascending'')')
  end if
  !
  !  check ilinth & th vector
  !
  call splinck(ph,inph,ilinph,ztol,ierph)
  if(ierph.ne.0) ier=4
  !
  if(ier.eq.4) then
     write(6,'('' ?tcspline:  phi axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  !
  !  part 1.  compute (x,theta) spline coeffs via an intermediate
  !  routine that call bcspline
  !
  !  workspace addresses
  !
  iaspl2=1
  iabcx1=iaspl2+16*inx*inth
  iabcx2=iabcx1+inth
  iabcth1=iabcx2+inth
  iabcth2=iabcth1+inx
  iawk=iabcth2+inx
  inwk=nwk-iawk+1
  !
  do iph=1,inph
     !
     !  copy bc data
     !
     do ix=1,inx
        wk(iabcth1+ix-1)=0.0_fp
        wk(iabcth2+ix-1)=0.0_fp
        if((ibcthmin.eq.1).or.(ibcthmin.eq.2)) then
           wk(iabcth1+ix-1)=bcthmin(ix,iph)
        end if
        if((ibcthmin.ne.-1).and. &
             ((ibcthmax.eq.1).or.(ibcthmax.eq.2))) then
           wk(iabcth2+ix-1)=bcthmax(ix,iph)
        end if
     end do
     do ith=1,inth
        wk(iabcx1+ith-1)=0.0_fp
        wk(iabcx2+ith-1)=0.0_fp
        if((ibcxmin.eq.1).or.(ibcxmin.eq.2)) then
           wk(iabcx1+ith-1)=bcxmin(ith,iph)
        end if
        if((ibcxmin.ne.-1).and. &
             ((ibcxmax.eq.1).or.(ibcxmax.eq.2))) then
           wk(iabcx2+ith-1)=bcxmax(ith,iph)
        end if
     end do
     !
     !  call 2d spline intermediary routine
     !
     call tcsp23(x,inx,th,inth,fspl(1,1,1,1,1,iph),inf4, &
          ibcxmin,wk(iabcx1),ibcxmax,wk(iabcx2), &
          ibcthmin,wk(iabcth1),ibcthmax,wk(iabcth2), &
          wk(iaspl2),wk(iawk),inwk,ilinx,ilinth,ier)
     !
     if(ier.ne.0) then
        write(6,*) ' ?tcspline:  error in 2d spline, exiting.'
        return
     end if
     !
  end do
  !
  !  ok now fspl(*,*,1,*,*,*) have been evaluated and C2 in (x,theta)
  !  now need to extend to coeffs in phi direction.
  !
  xo2=0.5_fp
  xo6=1.0_fp/6.0_fp
  !
  !  spline each (x,th) coeff in the phi direction
  !
  inpho=4*(inph-1)
  do ith=1,inth-1
     do ix=1,inx-1
        !
        do ic1=1,4
           do ic2=1,4
              !
              !  copy coeff. ordinates in
              !
              do iph=1,inph
                 wk(4*(iph-1)+1)=fspl(ic1,ic2,1,ix,ith,iph)
              end do
              !
              !  use linear BC on this first pass; will correct later if
              !  necessary
              !
              wk(2)=0.0_fp
              wk(3)=0.0_fp
              wk(inpho+2)=0.0_fp
              wk(inpho+3)=0.0_fp
              !
              ibcphmina=ibcphmin
              ibcphmaxa=ibcphmax
              if(iflg.eq.1) then
                 if((ibcphmin.eq.1).or.(ibcphmin.eq.2)) ibcphmina=0
                 if((ibcphmax.eq.1).or.(ibcphmax.eq.2)) ibcphmaxa=0
              end if
              !
              call v_spline(ibcphmina,ibcphmaxa,inph,ph,wk, &
                   wk(4*inph+1))
              !
              !  copy coeffs out
              !
              do iph=1,inph-1
                 fspl(ic1,ic2,2,ix,ith,iph)=wk(4*(iph-1)+2)
                 fspl(ic1,ic2,3,ix,ith,iph)=wk(4*(iph-1)+3)*xo2
                 fspl(ic1,ic2,4,ix,ith,iph)=wk(4*(iph-1)+4)*xo6
              end do
              !
           end do                    ! ic2
        end do                       ! ic1
        !
     end do                          ! ix
  end do                             ! ith
  !
  !  if there are "non-linear" BCs requiring correction...
  !
  !  at each (x(ix),th(ith)) get the d/dph BC's right while preserving C2
  !  everywhere...
  !
  if(iflg.eq.1) then
     !
     !  first get BC correction numbers
     !
     iabcph1=1
     iabcph2=iabcph1+inx*inth
     iaccoef=iabcph2+inx*inth
     iawk=iaccoef+12*inx*inth*inph
     inwk=nwk-iawk+1
     !
     do i=1,10
        iselect1(i)=0
        iselect2(i)=0
     end do
     !
     !  note because iflg=1, we know at least one of ibcphmin/max = 1 or 2
     !
     iskip1=0
     if(ibcphmin.eq.1) then
        iselect1(4)=1               ! df/dph
     else if(ibcphmin.eq.2) then
        iselect1(7)=1               ! d2f/dph2
     else
        iskip1=1
     end if
     !
     iskip2=0
     if(ibcphmax.eq.1) then
        iselect2(4)=1               ! df/dph
     else if(ibcphmax.eq.2) then
        iselect2(7)=1               ! d2f/dph2
     else
        iskip2=1
     end if
     !
     ia1=iabcph1-1
     ia2=iabcph2-1
     do ith=1,inth
        do ix=1,inx
           ia1=ia1+1
           ia2=ia2+1
           !
           if(iskip1.eq.0) then
              call tcspeval(x(ix),th(ith),ph(1),iselect1, zcur, &
                   x,inx,th,inth,ph,inph,ilinx,ilinth,ilinph, &
                   fspl,inf4,inf5,ier)
              if(ier.ne.0) then
                 write(6,*) ' ?? tcspline:  error in tcspeval call'
                 return
              end if
              wk(ia1)=bcphmin(ix,ith)-zcur(1) ! correction needed
           else
              wk(ia1)=z0
           end if
           !
           if(iskip2.eq.0) then
              call tcspeval(x(ix),th(ith),ph(inph),iselect2, zcur, &
                   x,inx,th,inth,ph,inph,ilinx,ilinth,ilinph, &
                   fspl,inf4,inf5,ier)
              if(ier.ne.0) then
                 write(6,*) ' ?? tcspline:  error in tcspeval call'
                 return
              end if
              wk(ia2)=bcphmax(ix,ith)-zcur(1) ! correction needed
           else
              wk(ia2)=z0
           end if
        end do
     end do
     !
     call tcspcorr(x,inx,th,inth,ph,inph,fspl,inf4,inf5, &
          ibcxmin,ibcxmax,ibcthmin,ibcthmax, &
          ibcphmin,wk(iabcph1),ibcphmax,wk(iabcph2), &
          wk(iaccoef),wk(iawk),inwk)
     !
  end if
  !
  return
end subroutine tcspline
!-----------------------------------------
subroutine tcspcorr(x,inx,th,inth,ph,inph,fspl,inf4,inf5, &
     ibcxmin,ibcxmax,ibcthmin,ibcthmax, &
     ibcphmin,bcph1,ibcphmax,bcph2,ccorr,wk,nwk)
  use iso_c_binding, only: fp => c_double
  !
  !  intermediary routine for tcspline:
  !  do correction needed to get C2 3d spline with phi bdy conditions
  !  matched.
  !
  !  all input unless noted:
  !
  !============
  implicit none
  integer inth,inph,inf4,inf5,nwk,inx,iawk2,inpho,ith,ix,iph
  integer inxo,icph,intho,icx,icth
  !============
  real(fp) :: xo2,xo6,z0,zfac
  !============
  real(fp) :: x(inx)                       ! x axis
  real(fp) :: th(inth)                     ! th axis
  real(fp) :: ph(inph)                     ! ph axis
  !
  real(fp) :: fspl(4,4,4,inf4,inf5,inph)   ! spline coeffs -- adjusted
  !
  integer ibcxmin,ibcxmax           ! x BC flags
  integer ibcthmin,ibcthmax         ! th BC flags
  integer ibcphmin,ibcphmax         ! ph BC flags
  !
  real(fp) :: bcph1(inx,inth)              ! ph BC correction array @ phi(1)
  real(fp) :: bcph2(inx,inth)              ! ph BC correction array @ phi(inph)
  !
  !  workspaces:
  !
  real(fp) :: ccorr(3,4,inx,inth,inph)     ! correction coefficients (partial)
  !
  real(fp) :: wk(nwk)                      ! workspace
  !
  !---------------------------
  !
  xo2=0.5_fp
  xo6=1.0_fp/6.0_fp
  !
  !  1.  splines in phi -- fcns are zero everywhere but have non-zero BCs
  !
  if(nwk.lt.10*max(inx,inth,inph)) then
     write(6,*) ' ?? programming error in tcspcorr (tcspline)'
     return
  end if
  !
  z0=0.0_fp
  iawk2=4*inph+1
  !
  inpho=4*(inph-1)
  do ith=1,inth
     do ix=1,inx
        !
        do iph=1,inph
           wk(4*(iph-1)+1)=z0
        end do
        !
        !  set BC for this 1d spline correction
        !
        if(ibcphmin.eq.1) then
           wk(2)=bcph1(ix,ith)
        else if(ibcphmin.eq.2) then
           wk(3)=bcph1(ix,ith)
        end if
        !
        if(ibcphmax.eq.1) then
           wk(inpho+2)=bcph2(ix,ith)
        else if(ibcphmax.eq.2) then
           wk(inpho+3)=bcph2(ix,ith)
        end if
        !
        call v_spline(ibcphmin,ibcphmax,inph,ph,wk,wk(iawk2))
        !
        !  copy non-zero coeffs out to ccorr
        !
        do iph=1,inph-1
           ccorr(1,1,ix,ith,iph)=wk(4*(iph-1)+2)
           ccorr(2,1,ix,ith,iph)=wk(4*(iph-1)+3)*xo2
           ccorr(3,1,ix,ith,iph)=wk(4*(iph-1)+4)*xo6
        end do
        !
     end do
  end do
  !
  !  2. spline the coeffs in x -- use ibcx flags & zero for derivative
  !  bc if necessary
  !
  iawk2=4*inx+1
  !
  inxo=4*(inx-1)
  do iph=1,inph-1
     do ith=1,inth
        !
        do icph=1,3
           !
           do ix=1,inx
              wk(4*(ix-1)+1)=ccorr(icph,1,ix,ith,iph)
           end do
           !
           !  zero BC:  correction spline
           !
           wk(2)=0.0_fp
           wk(3)=0.0_fp
           wk(inxo+2)=0.0_fp
           wk(inxo+3)=0.0_fp
           !
           call v_spline(ibcxmin,ibcxmax,inx,x,wk,wk(iawk2))
           !
           do ix=1,inx-1
              ccorr(icph,2,ix,ith,iph)=wk(4*(ix-1)+2)
              ccorr(icph,3,ix,ith,iph)=wk(4*(ix-1)+3)*xo2
              ccorr(icph,4,ix,ith,iph)=wk(4*(ix-1)+4)*xo6
           end do
           !
        end do
        !
     end do
  end do
  !
  !  3.  spline all the ccorr coefs in th -- use ibcth flags & zero for
  !      derivative correction BC if necessary
  !
  !      add the results into fspl
  !
  iawk2=4*inth+1
  !
  intho=4*(inth-1)
  do iph=1,inph-1
     do ix=1,inx-1
        !
        do icx=1,4
           do icph=1,3
              !
              do ith=1,inth
                 wk(4*(ith-1)+1)=ccorr(icph,icx,ix,ith,iph)
              end do
              !
              !  zero BC:  correction spline
              !
              wk(2)=0.0_fp
              wk(3)=0.0_fp
              wk(intho+2)=0.0_fp
              wk(intho+3)=0.0_fp
              !
              call v_spline(ibcthmin,ibcthmax,inth,th,wk, &
                   wk(iawk2))
              !
              do ith=1,inth-1
                 do icth=1,4
                    zfac=1.0_fp
                    if(icth.eq.3) zfac=xo2
                    if(icth.eq.4) zfac=xo6
                    fspl(icx,icth,icph+1,ix,ith,iph)= &
                         fspl(icx,icth,icph+1,ix,ith,iph)+ &
                         wk(4*(ith-1)+icth)*zfac
                 end do
              end do
              !
           end do
        end do
        !
     end do
  end do
  !
  return
end subroutine tcspcorr
!-----------------------------------------
subroutine tcsp23(x,inx,th,inth,fspl,inf4, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcthmin,bcthmin,ibcthmax,bcthmax, &
     fspl2,wk,nwk,ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  intermediary routines
  !  call bcspline from tcspline loop
  !  to set up 2d splines in each phi plane
  !
  !============
  implicit none
  integer inth,inf4,ibcxmin,ibcxmax,ibcthmin,ibcthmax,nwk,ilinx
  integer ilinth,ier,inx,ith,ix,j,i
  !============
  real(fp) :: x(inx)                       ! x axis
  real(fp) :: th(inth)                     ! th axis
  !
  real(fp) :: fspl(4,4,4,inf4,inth)        ! fspl array at one phi pt.
  real(fp) :: fspl2(4,4,inx,inth)          ! temp fspl array for bcspline
  !
  real(fp) :: bcxmin(inth),bcxmax(inth)    ! d/dx BC's @ x(1),x(inx), th(*)
  real(fp) :: bcthmin(inx),bcthmax(inx)    ! d/dth BC's @ th(1),th(inth), x(*)
  !
  real(fp) :: wk(nwk)
  !
  !--------------------
  !
  !  1.  copy spline data in
  !
  do ith=1,inth
     do ix=1,inx
        fspl2(1,1,ix,ith)=fspl(1,1,1,ix,ith)
     end do
  end do
  !
  !  2.  compute the 2d spline
  !
  call bcspline(x,inx,th,inth,fspl2,inx, &
       ibcxmin,bcxmin,ibcxmax,bcxmax, &
       ibcthmin,bcthmin,ibcthmax,bcthmax, &
       wk,nwk,ilinx,ilinth,ier)
  if(ier.ne.0) return
  !
  !  3.  copy spline coeff results out
  !
  do ith=1,inth-1
     do ix=1,inx-1
        do j=1,4
           do i=1,4
              fspl(i,j,1,ix,ith)=fspl2(i,j,ix,ith)
           end do
        end do
     end do
  end do
  !
  return
end subroutine tcsp23

      SUBROUTINE TERM_input(jchar)
      implicit none
C
#include "fpreproc/byte_declare.h"
C
C...This routine was written by Harry H. Towner of the Princeton
C...Plasma Physics Lab.
C
C   Get a character from the terminal
C   --> DMC Oct 1991 <-- UNIX code using ordinary FORTRAN i/o
C                        which requires a carriage return
C
C...Parameters:
C*..jchar	- The byte that was input.
C
C***********************************************************************
C
      byte_declare jchar
C
#ifdef __VMS
      INCLUDE '($IODEF)'
      INTEGER SYS$ASSIGN,SYS$QIOW,IOS(2)
      INTEGER*2 ICHAN
C
C...Define function for passall style output
C
      integer ifunc,istat
C
      IFUNC=IOR(IO$_readVBLK,IO$M_Noecho)
C
      DATA ICHAN/0/
C
C***********************************************************************
C
C...Obtain channel if necessary.
C
      IF(ICHAN.EQ.0) THEN
        ISTAT=SYS$ASSIGN('TT',ICHAN,,)
      END IF
C
      ISTAT=SYS$QIOW(,%VAL(ICHAN),%VAL(IFUNC),IOS,,,%REF(jchar),
     >		%VAL(1),,,,)
#endif
C
C  UNIX code:
#if __CRAY || __SX
      integer ibuf,zgetc
 
      ibuf = zgetc()
      jchar=char(ibuf)
#elif __UNIX
      integer ibuf,zgetc
 
      ibuf = zgetc()
      jchar=ibuf
#endif
C
      RETURN
      END
C--------------------------------
C
C  read in a single character from the terminal
C
      subroutine term_char_in(achar)
      implicit none
      character*1 achar
C
      byte_declare jchar
C
      call term_input(jchar)
#if __CRAY || __SX
      achar=jchar
#else
      achar=char(jchar)
#endif
C
      return
      end
 

C-----------------------------------------------------------------------
C  IOPEN -- VMS/UNIX collection of OPEN statements
C   this routine should not be called directly -- call via subroutine
C   GENOPEN -- the calling arguments are explained there.
C     argument checking is done in GENOPEN.
C
      integer function IOPEN(lun,fname,fstat,ftype,irecsz)
C
      integer lun          ! logical unit number
      character*(*) fname  ! file name
      character*(*) fstat  ! file status 'OLD' or 'NEW'
      character*(*) ftype  ! file type 'ASCII' 'BINARY' or 'DIRECT'
      integer irecsz       ! record size ('DIRECT' files only)
C
C  on VMS a condition handler is used to trap exceptions on OPEN
C  statement.  Purpose is to display system messages due to "unusual"
C  error conditions, and yet allow code execution to continue.
C
C  on UNIX the IOSTAT=IOS OPEN statement qualifier is used; errors
C  do not result in a message, just the setting of the IOSTAT code.
C
C----------------------------------------
C
#ifdef __VMS
      external IOPERH		! VMS error handler
C
      ISTAT=1			! VMS default
#endif
#ifdef __UNIX
      ISTAT=0				! UNIX default
#endif
C
C  establish VMS condition handler
C   NOTE -- on OPEN error on VMS, the condition handler takes over,
C    and forces an exit from this routine with the value of IOPEN set
C    to the "condition code" identifying the error.
C
C           on UNIX, the IOSTAT=ISTAT expression is used in the OPEN
C    statements to capture the error status of the OPEN operation, and
C    this is returned as the function value to the caller.
C
      inb=index(fname,' ')-1
      if(inb.le.0) inb=len(fname)
C
#ifdef __VMS
      call LIB$ESTABLISH(IOPERH)
#endif
C
      if(ftype.eq.'ASCII') then
C
        if(fstat.eq.'OLD') then
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status='OLD',READONLY)
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            IOSTAT=ISTAT)
#endif
C
        else
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',carriagecontrol='LIST')
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',IOSTAT=ISTAT)
#endif
C
        endif
C
      else if(ftype.eq.'BINARY') then
C
        if(fstat.eq.'OLD') then
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status='OLD',READONLY,
     >            access='SEQUENTIAL',form='UNFORMATTED')
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='SEQUENTIAL',form='UNFORMATTED',
     >            IOSTAT=ISTAT)
#endif
C
        else
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',form='UNFORMATTED')
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',form='UNFORMATTED',
     >            IOSTAT=ISTAT)
#endif
C
        endif
C
      else if(ftype.eq.'DIRECT') then
C
        if(fstat.eq.'OLD') then
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status='OLD',READONLY,
     >            access='DIRECT',recordsize=irecsz)
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='DIRECT',recl=irecsz,
     >            IOSTAT=ISTAT)
#endif
C
        else
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='DIRECT',recordsize=irecsz)
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='DIRECT',recl=irecsz,
     >            IOSTAT=ISTAT)
#endif
C
        endif
C
C
      else if(ftype.eq.'BLOCKD') then
C
        if(fstat.eq.'OLD') then
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status='OLD',READONLY,
     >            access='SEQUENTIAL',recl=irecsz,
     >            recordtype='FIXED',form='UNFORMATTED')
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='SEQUENTIAL',recl=irecsz,
     >            form='UNFORMATTED',IOSTAT=ISTAT)
#endif
C
        else
C
#ifdef __VMS
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',recl=irecsz,
     >            recordtype='FIXED',form='UNFORMATTED')
#endif
#ifdef __UNIX
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',recl=irecsz,
     >            form='UNFORMATTED',IOSTAT=ISTAT)
#endif
C
        endif
C
      endif
C
#ifdef __VMS
      call LIB$REVERT
#endif
C
      IOPEN=ISTAT
C
      return
      end

subroutine akherm3(x,nx,y,ny,z,nz,fherm,nf2,nf3, &
     ilinx,iliny,ilinz,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on Akima's method
  !  [Hiroshi Akima, Communications of the ACM, Jan 1974, Vol. 17 No. 1]
  !
  !  3d routine
  !
  !  input:
  !
  !  nf2.get.nx and nf3.ge.ny  expected!
  !
  !============
  implicit none
  integer iliny,ilinz,ier,ilinx
  !============
  integer nx,ny,nz,nf2,nf3          ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: z(nz)                        ! z coordinate array
  real(fp) :: fherm(0:7,nf2,nf3,nz)        ! data/Hermite array
  !
  !  fherm(0,i,j,k) = function value f at x(i),y(j),z(k)  **on input**
  !
  !  fherm(1,i,j,k) = derivative df/dx at x(i),y(j),z(k)  **on output**
  !  fherm(2,i,j,k) = derivative df/dy at x(i),y(j),z(k)  **on output**
  !  fherm(3,i,j,k) = derivative df/dz at x(i),y(j),z(k)  **on output**
  !  fherm(4,i,j,k) = derivative d2f/dxdy at x(i),y(j),z(k)  **on output**
  !  fherm(5,i,j,k) = derivative d2f/dxdz at x(i),y(j),z(k)  **on output**
  !  fherm(6,i,j,k) = derivative d2f/dydz at x(i),y(j),z(k)  **on output**
  !  fherm(7,i,j,k) = derivative d3f/dxdydz at x(i),y(j),z(k)  **on output**
  !
  !  additional outputs:
  !
  !    ilinx = 1  if x is evenly spaced (approximately)
  !    iliny = 1  if y is evenly spaced (approximately)
  !    ilinz = 1  if z is evenly spaced (approximately)
  !
  !    ier = 0 if there are no errors
  !
  !  note possible errors:  x y or z NOT strict ascending
  !  nf2.lt.nx   .or.   nf3.lt.ny
  !
  !  a default boundary condition is used, based on divided differences
  !  in the edge region.  For more control of BC, use akherm3p...
  !
  call akherm3p(x,nx,y,ny,z,nz,fherm,nf2,nf3, &
       ilinx,iliny,ilinz,0,0,0,ier)
  !
  return
end subroutine akherm3
!----------------------------
subroutine akherm3p(x,nx,y,ny,z,nz,fherm,nf2,nf3, &
     ilinx,iliny,ilinz,ipx,ipy,ipz,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, based on Akima's method
  !  [Hiroshi Akima, Communications of the ACM, Jan 1974, Vol. 17 No. 1]
  !
  !  3d routine --
  !  with independently settable boundary condition options:
  !     ipx|ipy|ipz  =0  -- default, boundary conditions from divided diffs
  !     ipx|ipy|ipz  =1  -- periodic boundary condition
  !     ipx|ipy|ipz  =2  -- user supplied df/dx|df/dy|df/dz
  !
  !  input:
  !
  !  nf2.get.nx and nf3.ge.ny  expected!
  !
  !============
  implicit none
  integer iliny,ilinz,ier,ilinx,ierx,iery,ierz,ierbc,iz,iy,ix
  integer icx,incx,ix1,icy,incy,iy1,icz,incz,iz1,izm2,izm1
  integer izmm2,izmm1,izp2,izp1,izpp2,izpp1,iym2,iym1,iymm2
  integer iymm1,iyp2,iyp1,iypp2,iypp1,ixm2,ixm1,ixmm2,ixmm1
  integer iflagx,ixp2,ixp1,ixpp2,ixpp1,iflagy,iflagz,k
  !============
  real(fp) :: cxp,cxm,cxpp,cxmm,cxtrap0,cxtrapn,cyp,cym,cypp,cymm
  real(fp) :: cytrap0,cytrapn,czp,czm,czpp,czmm,cztrap0,cztrapn
  real(fp) :: zansr,cxm2,cxp2,cym2,cyp2,fzp,fzm
  !============
  integer nx,ny,nz,nf2,nf3          ! array dimensions
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  real(fp) :: z(nz)                        ! z coordinate array
  real(fp) :: fherm(0:7,nf2,nf3,nz)        ! data/Hermite array
  !
  integer ipx                       ! =0: dflt; =1: periodic df/dx
  integer ipy                       ! =0: dflt; =1: periodic df/dy
  integer ipz                       ! =0: dflt; =1: periodic df/dz
  !
  !  if ipx=2:  fherm(1,1,1:ny,1:nz) & fherm(1,nx,1:ny,1:nz) = INPUT df/dx BCs
  !  if ipy=2:  fherm(2,1:nx,1,1:nz) & fherm(2,1:nx,ny,1:nz) = INPUT df/dy BCs
  !  if ipz=2:  fherm(3,1:nx,1:ny,1) & fherm(3,1:nx,1:ny,nz) = INPUT df/dz BCs
  !
  !  for the rest of the grid points...
  !
  !  fherm(0,i,j,k) = function value f at x(i),y(j),z(k)  **on input**
  !
  !  fherm(1,i,j,k) = derivative df/dx at x(i),y(j),z(k)  **on output**
  !  fherm(2,i,j,k) = derivative df/dy at x(i),y(j),z(k)  **on output**
  !  fherm(3,i,j,k) = derivative df/dz at x(i),y(j),z(k)  **on output**
  !  fherm(4,i,j,k) = derivative d2f/dxdy at x(i),y(j),z(k)  **on output**
  !  fherm(5,i,j,k) = derivative d2f/dxdz at x(i),y(j),z(k)  **on output**
  !  fherm(6,i,j,k) = derivative d2f/dydz at x(i),y(j),z(k)  **on output**
  !  fherm(7,i,j,k) = derivative d3f/dxdydz at x(i),y(j),z(k)  **on output**
  !
  !  additional outputs:
  !
  !    ilinx = 1  if x is evenly spaced (approximately)
  !    iliny = 1  if y is evenly spaced (approximately)
  !    ilinz = 1  if z is evenly spaced (approximately)
  !
  !---------------------
  !  local...
  !
  real(fp) :: wx(2),wy(2),wz(2),exy(2,2),exz(2,2),eyz(2,2),fxyz(2,2,2)
  !
  real(fp), dimension(:,:,:), allocatable ::  ftmp
  !
  real(fp) :: xx(0:nx+1)
  real(fp) :: yy(0:ny+1)
  real(fp) :: zz(0:nz+1)
  !
  !----------------------------
  !
  !  error check
  !
  ier=0
  !
  call splinck(x,nx,ilinx,1.0E-3_fp,ierx)
  if(ierx.ne.0) ier=ier+1
  !
  if(ierx.ne.0) then
     write(6,'('' ?akherm3:  x axis not strict ascending'')')
  end if
  !
  call splinck(y,ny,iliny,1.0E-3_fp,iery)
  if(iery.ne.0) ier=ier+1
  !
  if(iery.ne.0) then
     write(6,'('' ?akherm3:  y axis not strict ascending'')')
  end if
  !
  call splinck(z,nz,ilinz,1.0E-3_fp,ierz)
  if(ierz.ne.0) ier=ier+1
  !
  if(ierz.ne.0) then
     write(6,'('' ?akherm3:  z axis not strict ascending'')')
  end if
  !
  if(nf2.lt.nx) then
     ier=ier+1
     write(6,*) '?akherm3:  fherm (x) array dimension too small.'
  end if
  !
  if(nf3.lt.ny) then
     ier=ier+1
     write(6,*) '?akherm3:  fherm (y) array dimension too small.'
  end if
  !
  ierbc=0
  call ibc_ck(ipx,'akherm3','X Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  !
  ierbc=0
  call ibc_ck(ipy,'akherm3','Y Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  !
  ierbc=0
  call ibc_ck(ipz,'akherm3','Z Bdy Cond',0,2,ierbc)
  ier=ier+ierbc
  !
  if(ier.ne.0) return
  !
  !  error check OK
  !
  !---------------------------------------
  !
  !  get a  temporary array for f -- will extend out by 1 zone in
  !  each direction so that numerical derivative evaluation can be
  !  done without a lot of special case logic near the edges...
  !
  allocate(ftmp(0:nx+1,0:ny+1,0:nz+1))
  !
  do iz=1,nz
     do iy=1,ny
        do ix=1,nx
           ftmp(ix,iy,iz)=fherm(0,ix,iy,iz)
        end do
     end do
  end do
  !
  !  also create expanded axes grids...
  !
  xx(1:nx)=x
  yy(1:ny)=y
  zz(1:nz)=z
  !
  xx(0)=2*x(1)-x(2)
  xx(nx+1)=2*x(nx)-x(nx-1)
  yy(0)=2*y(1)-y(2)
  yy(ny+1)=2*y(ny)-y(ny-1)
  zz(0)=2*z(1)-z(2)
  zz(nz+1)=2*z(nz)-z(nz-1)
  !
  !---------------------------------------
  !
  !  handle boundary conditions and create rows of extrapolated points
  !  in ftmp.  first do ftmp(0,1:ny), ftmp(nx+1,1:ny),
  !                then ftmp(1:nx,0), ftmp(1:nx,ny+1),
  !                then ... fill in the corners
  !
  !  also, for ipx.le.1 fill in the bdy fherm(1,*) values;
  !        for ipy.le.1 fill in the bdy fherm(2,*) values
  !
  !  x bc's
  !
  do iz=1,nz
     do iy=1,ny
        !
        cxp=(ftmp(2,iy,iz)-ftmp(1,iy,iz))/(xx(2)-xx(1))
        cxm=(ftmp(nx,iy,iz)-ftmp(nx-1,iy,iz))/(xx(nx)-xx(nx-1))
        !
        if(ipx.eq.1) then
           !
           !  periodic BC
           !
           if(nx.gt.2) then
              cxpp=(ftmp(3,iy,iz)-ftmp(2,iy,iz))/(xx(3)-xx(2))
              cxmm=(ftmp(nx-1,iy,iz)-ftmp(nx-2,iy,iz))/ &
                   (xx(nx-1)-xx(nx-2))
              !
              call akherm0(cxmm,cxm,cxp,cxpp,wx,fherm(1,1,iy,iz))
              fherm(1,nx,iy,iz)=fherm(1,1,iy,iz)
              !
           else
              fherm(1,1,iy,iz)=cxp  ! =cxm, nx=2
              fherm(1,nx,iy,iz)=fherm(1,1,iy,iz)
           end if
           !
           cxtrap0=cxm
           cxtrapn=cxp
           !
        else if(ipx.eq.0) then
           !
           !  default BC -- standard numeric extrapolation
           !
           if(nx.gt.2) then
              cxpp=(ftmp(3,iy,iz)-ftmp(2,iy,iz))/(xx(3)-xx(2))
              fherm(1,1,iy,iz)=1.5_fp*cxp-0.5_fp*cxpp
              !
              cxmm=(ftmp(nx-1,iy,iz)-ftmp(nx-2,iy,iz))/ &
                   (xx(nx-1)-xx(nx-2))
              fherm(1,nx,iy,iz)=1.5_fp*cxm-0.5_fp*cxmm
              !
           else
              fherm(1,1,iy,iz)=cxp  ! =cxm, nx=2
              fherm(1,nx,iy,iz)=fherm(1,1,iy,iz)
           end if
           !
           !  extrapolate to slope to ghost points just past bdy...
           !
           cxtrap0=2.0_fp*fherm(1,1,iy,iz)-cxp
           cxtrapn=2.0_fp*fherm(1,nx,iy,iz)-cxm
           !
        else
           !
           !  BC supplied by user.  Also use this for extrapolation...
           !
           cxtrap0=2.0_fp*fherm(1,1,iy,iz)-cxp
           cxtrapn=2.0_fp*fherm(1,nx,iy,iz)-cxm
           !
        end if
        !
        ftmp(0,iy,iz)=ftmp(1,iy,iz)-cxtrap0*(xx(1)-xx(0))
        ftmp(nx+1,iy,iz)=ftmp(nx,iy,iz)+cxtrapn*(xx(nx+1)-xx(nx))
        !
     end do
  end do
  !
  !  y bc's
  !
  do iz=1,nz
     do ix=1,nx
        !
        cyp=(ftmp(ix,2,iz)-ftmp(ix,1,iz))/(yy(2)-yy(1))
        cym=(ftmp(ix,ny,iz)-ftmp(ix,ny-1,iz))/(yy(ny)-yy(ny-1))
        !
        if(ipy.eq.1) then
           !
           !  periodic BC
           !
           if(ny.gt.2) then
              cypp=(ftmp(ix,3,iz)-ftmp(ix,2,iz))/(yy(3)-yy(2))
              cymm=(ftmp(ix,ny-1,iz)-ftmp(ix,ny-2,iz))/ &
                   (yy(ny-1)-yy(ny-2))
              !
              call akherm0(cymm,cym,cyp,cypp,wy,fherm(2,ix,1,iz))
              fherm(2,ix,ny,iz)=fherm(2,ix,1,iz)
              !
           else
              fherm(2,ix,1,iz) = cyp  ! =cym, ny=2
              fherm(2,ix,ny,iz)=fherm(2,ix,1,iz)
           end if
           cytrap0=cym
           cytrapn=cyp
           !
        else if(ipy.eq.0) then
           !
           !  default BC -- standard numeric extrapolation
           !
           if(ny.gt.2) then
              cypp=(ftmp(ix,3,iz)-ftmp(ix,2,iz))/(yy(3)-yy(2))
              fherm(2,ix,1,iz)=1.5_fp*cyp-0.5_fp*cypp
              !
              cymm=(ftmp(ix,ny-1,iz)-ftmp(ix,ny-2,iz))/ &
                   (yy(ny-1)-yy(ny-2))
              fherm(2,ix,ny,iz)=1.5_fp*cym-0.5_fp*cymm
              !
           else
              fherm(2,ix,1,iz) = cyp  ! =cym, ny=2
              fherm(2,ix,ny,iz)=fherm(2,ix,1,iz)
           end if
           !
           !  extrapolate to slope to ghost points just past bdy...
           !
           cytrap0=2.0_fp*fherm(2,ix,1,iz)-cyp
           cytrapn=2.0_fp*fherm(2,ix,ny,iz)-cym
           !
        else
           !
           !  BC supplied by user.  Also use this for extrapolation...
           !
           cytrap0=2.0_fp*fherm(2,ix,1,iz)-cyp
           cytrapn=2.0_fp*fherm(2,ix,ny,iz)-cym
           !
        end if
        !
        ftmp(ix,0,iz)=ftmp(ix,1,iz)-cytrap0*(yy(1)-yy(0))
        ftmp(ix,ny+1,iz)=ftmp(ix,ny,iz)+cytrapn*(yy(ny+1)-yy(ny))
        !
     end do
  end do
  !
  !  z bc's
  !
  do iy=1,ny
     do ix=1,nx
        !
        czp=(ftmp(ix,iy,2)-ftmp(ix,iy,1))/(zz(2)-zz(1))
        czm=(ftmp(ix,iy,nz)-ftmp(ix,iy,nz-1))/(zz(nz)-zz(nz-1))
        !
        if(ipy.eq.1) then
           !
           !  periodic BC
           !
           if(nz.gt.2) then
              czpp=(ftmp(ix,iy,3)-ftmp(ix,iy,2))/(zz(3)-zz(2))
              czmm=(ftmp(ix,iy,nz-1)-ftmp(ix,iy,nz-2))/ &
                   (zz(nz-1)-zz(nz-2))
              !
              call akherm0(czmm,czm,czp,czpp,wz,fherm(3,ix,iy,1))
              fherm(3,ix,iy,nz)=fherm(3,ix,iy,1)
              !
           else
              fherm(3,ix,iy,1) = czp
              fherm(3,ix,iy,nz)=fherm(3,ix,iy,1)
           end if
           !
           cztrap0=czm
           cztrapn=czp
           !
        else if(ipy.eq.0) then
           !
           !  default BC -- standard numeric extrapolation
           !
           if(nz.gt.2) then
              czpp=(ftmp(ix,iy,3)-ftmp(ix,iy,2))/(zz(3)-zz(2))
              fherm(3,ix,iy,1)=1.5_fp*czp-0.5_fp*czpp
              !
              czmm=(ftmp(ix,iy,nz-1)-ftmp(ix,iy,nz-2))/ &
                   (zz(nz-1)-zz(nz-2))
              fherm(3,ix,iy,nz)=1.5_fp*czm-0.5_fp*czmm
              !
           else
              fherm(3,ix,iy,1) = czp
              fherm(3,ix,iy,nz)=fherm(3,ix,iy,1)
           end if
           !
           !  extrapolate to slope to ghost points just past bdy...
           !
           cztrap0=2.0_fp*fherm(3,ix,iy,1)-czp
           cztrapn=2.0_fp*fherm(3,ix,iy,nz)-czm
           !
        else
           !
           !  BC supplied by user.  Also use this for extrapolation...
           !
           cztrap0=2.0_fp*fherm(3,ix,iy,1)-czp
           cztrapn=2.0_fp*fherm(3,ix,iy,nz)-czm
           !
        end if
        !
        ftmp(ix,iy,0)=ftmp(ix,iy,1)-cztrap0*(zz(1)-zz(0))
        ftmp(ix,iy,nz+1)=ftmp(ix,iy,nz)+cztrapn*(zz(nz+1)-zz(nz))
        !
     end do
  end do
  !
  !  and for the edges...
  !
  do iz=1,nz
     do ix=0,1
        icx=ix*(nx+1)
        incx=1-2*ix
        ix1=icx+incx
        do iy=0,1
           icy=iy*(ny+1)
           incy=1-2*iy
           iy1=icy+incy
           !
           ftmp(icx,icy,iz)=ftmp(icx,iy1,iz)+ftmp(ix1,icy,iz)- &
                ftmp(ix1,iy1,iz)
           !
        end do
     end do
  end do
  !
  do iy=1,ny
     do iz=0,1
        icz=iz*(nz+1)
        incz=1-2*iz
        iz1=icz+incz
        do ix=0,1
           icx=ix*(nx+1)
           incx=1-2*ix
           ix1=icx+incx
           !
           ftmp(icx,iy,icz)=ftmp(icx,iy,iz1)+ftmp(ix1,iy,icz)- &
                ftmp(ix1,iy,iz1)
           !
        end do
     end do
  end do
  !
  do ix=1,nx
     do iy=0,1
        icy=iy*(ny+1)
        incy=1-2*iy
        iy1=icy+incy
        do iz=0,1
           icz=iz*(nz+1)
           incz=1-2*iz
           iz1=icz+incz
           !
           ftmp(ix,icy,icz)=ftmp(ix,icy,iz1)+ftmp(ix,iy1,icz)- &
                ftmp(ix,iy1,iz1)
           !
        end do
     end do
  end do
  !
  !  and the corners...
  !
  do iz=0,1
     icz=iz*(nz+1)
     incz=1-2*iz
     iz1=icz+incz
     do iy=0,1
        icy=iy*(ny+1)
        incy=1-2*iy
        iy1=icy+incy
        do ix=0,1
           icx=ix*(nx+1)
           incx=1-2*ix
           ix1=icx+incx
           !
           ftmp(icx,icy,icz)=( &
                2*(ftmp(icx,icy,iz1)+ftmp(icx,iy1,icz)+ &
                ftmp(ix1,icy,icz)) - &
                (ftmp(icx,iy1,iz1)+ftmp(ix1,icy,iz1)+ &
                ftmp(ix1,iy1,icz)))/3
           !
        end do
     end do
  end do
  !
  !-----------------------------------------------------
  !  boundary done; now fill in the interior
  !
  !
  do iz=1,nz
     izm2=iz
     izm1=izm2-1
     !
     izmm2=iz-1
     izmm1=izmm2-1
     !
     izp2=iz+1
     izp1=izp2-1
     !
     izpp2=iz+2
     izpp1=izpp2-1
     !
     do iy=1,ny
        iym2=iy
        iym1=iym2-1
        !
        iymm2=iy-1
        iymm1=iymm2-1
        !
        iyp2=iy+1
        iyp1=iyp2-1
        !
        iypp2=iy+2
        iypp1=iypp2-1
        !
        do ix=1,nx
           !
           !  x div. diffs in vicinity
           !
           ixm2=ix
           ixm1=ixm2-1
           !
           ixmm2=ix-1
           ixmm1=ixmm2-1
           !
           iflagx=0
           cxm=(ftmp(ixm2,iy,iz)-ftmp(ixm1,iy,iz))/ &
                (xx(ixm2)-xx(ixm1))
           if(ix.gt.1) then
              cxmm=(ftmp(ixmm2,iy,iz)-ftmp(ixmm1,iy,iz))/ &
                   (xx(ixmm2)-xx(ixmm1))
           else
              if(ipx.eq.1) then
                 cxmm=(ftmp(nx-1,iy,iz)-ftmp(nx-2,iy,iz))/ &
                      (xx(nx-1)-xx(nx-2))
              else
                 iflagx=1
              end if
           end if
           !
           ixp2=ix+1
           ixp1=ixp2-1
           !
           ixpp2=ix+2
           ixpp1=ixpp2-1
           !
           cxp=(ftmp(ixp2,iy,iz)-ftmp(ixp1,iy,iz))/ &
                (xx(ixp2)-xx(ixp1))
           if(ix.lt.nx) then
              cxpp=(ftmp(ixpp2,iy,iz)-ftmp(ixpp1,iy,iz))/ &
                   (xx(ixpp2)-xx(ixpp1))
           else
              if(ipx.eq.1) then
                 cxpp=(ftmp(3,iy,iz)-ftmp(2,iy,iz))/ &
                      (xx(3)-xx(2))
              else
                 cxpp=cxp+(cxm-cxmm)
              end if
           end if
           !
           if(iflagx.eq.1) then
              cxmm=cxm+(cxp-cxpp)
           end if
           !
           !  Akima weightings + df/dx for interior pts
           !
           call akherm0(cxmm,cxm,cxp,cxpp,wx,zansr)
           if((ix.gt.1).and.(ix.lt.nx)) fherm(1,ix,iy,iz)=zansr
           !
           !  y div. diffs in vicinity
           !
           iflagy=0
           cym=(ftmp(ix,iym2,iz)-ftmp(ix,iym1,iz))/ &
                (yy(iym2)-yy(iym1))
           if(iy.gt.1) then
              cymm=(ftmp(ix,iymm2,iz)-ftmp(ix,iymm1,iz))/ &
                   (yy(iymm2)-yy(iymm1))
           else
              if(ipy.eq.1) then
                 cymm=(ftmp(ix,ny-1,iz)-ftmp(ix,ny-2,iz))/ &
                      (yy(ny-1)-yy(ny-2))
              else
                 iflagy=1
              end if
           end if
           !
           cyp=(ftmp(ix,iyp2,iz)-ftmp(ix,iyp1,iz))/ &
                (yy(iyp2)-yy(iyp1))
           if(iy.lt.ny) then
              cypp=(ftmp(ix,iypp2,iz)-ftmp(ix,iypp1,iz))/ &
                   (yy(iypp2)-yy(iypp1))
           else
              if(ipy.eq.1) then
                 cypp=(ftmp(ix,3,iz)-ftmp(ix,2,iz))/(yy(3)-yy(2))
              else
                 cypp=cyp+(cym-cymm)
              end if
           end if
           !
           if(iflagy.eq.1) then
              cymm=cym+(cyp-cypp)
           end if
           !
           !  Akima weightings + df/dy for interior pts
           !
           call akherm0(cymm,cym,cyp,cypp,wy,zansr)
           if((iy.gt.1).and.(iy.lt.ny)) fherm(2,ix,iy,iz)=zansr
           !
           !  z div. diffs in vicinity
           !
           iflagz=0
           czm=(ftmp(ix,iy,izm2)-ftmp(ix,iy,izm1))/ &
                (zz(izm2)-zz(izm1))
           if(iz.gt.1) then
              czmm=(ftmp(ix,iy,izmm2)-ftmp(ix,iy,izmm1))/ &
                   (zz(izmm2)-zz(izmm1))
           else
              if(ipz.eq.1) then
                 czmm=(ftmp(ix,iy,nz-1)-ftmp(ix,iy,nz-2))/ &
                      (zz(nz-1)-zz(nz-2))
              else
                 iflagz=1
              end if
           end if
           !
           czp=(ftmp(ix,iy,izp2)-ftmp(ix,iy,izp1))/ &
                (zz(izp2)-zz(izp1))
           if(iz.lt.nz) then
              czpp=(ftmp(ix,iy,izpp2)-ftmp(ix,iy,izpp1))/ &
                   (zz(izpp2)-zz(izpp1))
           else
              if(ipz.eq.1) then
                 czpp=(ftmp(ix,iy,3)-ftmp(ix,iy,2))/(zz(3)-zz(2))
              else
                 czpp=czp+(czm-czmm)
              end if
           end if
           !
           if(iflagz.eq.1) then
              czmm=czm+(czp-czpp)
           end if
           !
           !  Akima weightings + df/dy for interior pts
           !
           call akherm0(czmm,czm,czp,czpp,wz,zansr)
           if((iz.gt.1).and.(iz.lt.nz)) fherm(3,ix,iy,iz)=zansr
           !
           !  cross derivatives (2nd order divided differences)
           !
           cxm2=(ftmp(ixm2,iym1,iz)-ftmp(ixm1,iym1,iz))/ &
                (xx(ixm2)-xx(ixm1))
           exy(1,1)=(cxm-cxm2)/(yy(iym2)-yy(iym1))
           !
           cxm2=(ftmp(ixm2,iyp2,iz)-ftmp(ixm1,iyp2,iz))/ &
                (xx(ixm2)-xx(ixm1))
           exy(1,2)=(cxm2-cxm)/(yy(iyp2)-yy(iyp1))
           !
           cxp2=(ftmp(ixp2,iym1,iz)-ftmp(ixp1,iym1,iz))/ &
                (xx(ixp2)-xx(ixp1))
           exy(2,1)=(cxp-cxp2)/(yy(iym2)-yy(iym1))
           !
           cxp2=(ftmp(ixp2,iyp2,iz)-ftmp(ixp1,iyp2,iz))/ &
                (xx(ixp2)-xx(ixp1))
           exy(2,2)=(cxp2-cxp)/(yy(iyp2)-yy(iyp1))
           !
           !---------
           !
           cxm2=(ftmp(ixm2,iy,izm1)-ftmp(ixm1,iy,izm1))/ &
                (xx(ixm2)-xx(ixm1))
           exz(1,1)=(cxm-cxm2)/(zz(izm2)-zz(izm1))
           !
           cxm2=(ftmp(ixm2,iy,izp2)-ftmp(ixm1,iy,izp2))/ &
                (xx(ixm2)-xx(ixm1))
           exz(1,2)=(cxm2-cxm)/(zz(izp2)-zz(izp1))
           !
           cxp2=(ftmp(ixp2,iy,izm1)-ftmp(ixp1,iy,izm1))/ &
                (xx(ixp2)-xx(ixp1))
           exz(2,1)=(cxp-cxp2)/(zz(izm2)-zz(izm1))
           !
           cxp2=(ftmp(ixp2,iy,izp2)-ftmp(ixp1,iy,izp2))/ &
                (xx(ixp2)-xx(ixp1))
           exz(2,2)=(cxp2-cxp)/(zz(izp2)-zz(izp1))
           !
           !---------
           !
           cym2=(ftmp(ix,iym2,izm1)-ftmp(ix,iym1,izm1))/ &
                (yy(iym2)-yy(iym1))
           eyz(1,1)=(cym-cym2)/(zz(izm2)-zz(izm1))
           !
           cym2=(ftmp(ix,iym2,izp2)-ftmp(ix,iym1,izp2))/ &
                (yy(iym2)-yy(iym1))
           eyz(1,2)=(cym2-cym)/(zz(izp2)-zz(izp1))
           !
           cyp2=(ftmp(ix,iyp2,izm1)-ftmp(ix,iyp1,izm1))/ &
                (yy(iyp2)-yy(iyp1))
           eyz(2,1)=(cyp-cyp2)/(zz(izm2)-zz(izm1))
           !
           cyp2=(ftmp(ix,iyp2,izp2)-ftmp(ix,iyp1,izp2))/ &
                (yy(iyp2)-yy(iyp1))
           eyz(2,2)=(cyp2-cyp)/(zz(izp2)-zz(izp1))
           !
           !  dxdydz 3rd order cross deriv.
           !
           k=1
           !
           fzp=(ftmp(ixm2,iym2,izm2)-ftmp(ixm2,iym1,izm2)- &
                ftmp(ixm1,iym2,izm2)+ftmp(ixm1,iym1,izm2))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iym2)-yy(iym1)))
           fzm=(ftmp(ixm2,iym2,izm1)-ftmp(ixm2,iym1,izm1)- &
                ftmp(ixm1,iym2,izm1)+ftmp(ixm1,iym1,izm1))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iym2)-yy(iym1)))
           fxyz(1,1,k)=(fzp-fzm)/(zz(izm2)-zz(izm1))
           !
           fzp=(ftmp(ixm2,iyp2,izm2)-ftmp(ixm2,iyp1,izm2)- &
                ftmp(ixm1,iyp2,izm2)+ftmp(ixm1,iyp1,izm2))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iyp2)-yy(iyp1)))
           fzm=(ftmp(ixm2,iyp2,izm1)-ftmp(ixm2,iyp1,izm1)- &
                ftmp(ixm1,iyp2,izm1)+ftmp(ixm1,iyp1,izm1))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iyp2)-yy(iyp1)))
           fxyz(1,2,k)=(fzp-fzm)/(zz(izm2)-zz(izm1))
           !
           fzp=(ftmp(ixp2,iym2,izm2)-ftmp(ixp2,iym1,izm2)- &
                ftmp(ixp1,iym2,izm2)+ftmp(ixp1,iym1,izm2))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iym2)-yy(iym1)))
           fzm=(ftmp(ixp2,iym2,izm1)-ftmp(ixp2,iym1,izm1)- &
                ftmp(ixp1,iym2,izm1)+ftmp(ixp1,iym1,izm1))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iym2)-yy(iym1)))
           fxyz(2,1,k)=(fzp-fzm)/(zz(izm2)-zz(izm1))
           !
           fzp=(ftmp(ixp2,iyp2,izm2)-ftmp(ixp2,iyp1,izm2)- &
                ftmp(ixp1,iyp2,izm2)+ftmp(ixp1,iyp1,izm2))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iyp2)-yy(iyp1)))
           fzm=(ftmp(ixp2,iyp2,izm1)-ftmp(ixp2,iyp1,izm1)- &
                ftmp(ixp1,iyp2,izm1)+ftmp(ixp1,iyp1,izm1))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iyp2)-yy(iyp1)))
           fxyz(2,2,k)=(fzp-fzm)/(zz(izm2)-zz(izm1))
           !
           k=2
           !
           fzp=(ftmp(ixm2,iym2,izp2)-ftmp(ixm2,iym1,izp2)- &
                ftmp(ixm1,iym2,izp2)+ftmp(ixm1,iym1,izp2))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iym2)-yy(iym1)))
           fzm=(ftmp(ixm2,iym2,izp1)-ftmp(ixm2,iym1,izp1)- &
                ftmp(ixm1,iym2,izp1)+ftmp(ixm1,iym1,izp1))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iym2)-yy(iym1)))
           fxyz(1,1,k)=(fzp-fzm)/(zz(izp2)-zz(izp1))
           !
           fzp=(ftmp(ixm2,iyp2,izp2)-ftmp(ixm2,iyp1,izp2)- &
                ftmp(ixm1,iyp2,izp2)+ftmp(ixm1,iyp1,izp2))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iyp2)-yy(iyp1)))
           fzm=(ftmp(ixm2,iyp2,izp1)-ftmp(ixm2,iyp1,izp1)- &
                ftmp(ixm1,iyp2,izp1)+ftmp(ixm1,iyp1,izp1))/ &
                ((xx(ixm2)-xx(ixm1))*(yy(iyp2)-yy(iyp1)))
           fxyz(1,2,k)=(fzp-fzm)/(zz(izp2)-zz(izp1))
           !
           fzp=(ftmp(ixp2,iym2,izp2)-ftmp(ixp2,iym1,izp2)- &
                ftmp(ixp1,iym2,izp2)+ftmp(ixp1,iym1,izp2))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iym2)-yy(iym1)))
           fzm=(ftmp(ixp2,iym2,izp1)-ftmp(ixp2,iym1,izp1)- &
                ftmp(ixp1,iym2,izp1)+ftmp(ixp1,iym1,izp1))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iym2)-yy(iym1)))
           fxyz(2,1,k)=(fzp-fzm)/(zz(izp2)-zz(izp1))
           !
           fzp=(ftmp(ixp2,iyp2,izp2)-ftmp(ixp2,iyp1,izp2)- &
                ftmp(ixp1,iyp2,izp2)+ftmp(ixp1,iyp1,izp2))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iyp2)-yy(iyp1)))
           fzm=(ftmp(ixp2,iyp2,izp1)-ftmp(ixp2,iyp1,izp1)- &
                ftmp(ixp1,iyp2,izp1)+ftmp(ixp1,iyp1,izp1))/ &
                ((xx(ixp2)-xx(ixp1))*(yy(iyp2)-yy(iyp1)))
           fxyz(2,2,k)=(fzp-fzm)/(zz(izp2)-zz(izp1))
           !
           !  the values
           !
           fherm(4,ix,iy,iz)= &
                (wx(1)*(wy(1)*exy(1,1)+wy(2)*exy(1,2))+ &
                wx(2)*(wy(1)*exy(2,1)+wy(2)*exy(2,2)))/ &
                ((wx(1)+wx(2))*(wy(1)+wy(2)))
           !
           fherm(5,ix,iy,iz)= &
                (wx(1)*(wz(1)*exz(1,1)+wz(2)*exz(1,2))+ &
                wx(2)*(wz(1)*exz(2,1)+wz(2)*exz(2,2)))/ &
                ((wx(1)+wx(2))*(wz(1)+wz(2)))
           !
           fherm(6,ix,iy,iz)= &
                (wy(1)*(wz(1)*eyz(1,1)+wz(2)*eyz(1,2))+ &
                wy(2)*(wz(1)*eyz(2,1)+wz(2)*eyz(2,2)))/ &
                ((wy(1)+wy(2))*(wz(1)+wz(2)))
           !
           fherm(7,ix,iy,iz)=(wz(1)* &
                (wx(1)*(wy(1)*fxyz(1,1,1)+wy(2)*fxyz(1,2,1))+ &
                wx(2)*(wy(1)*fxyz(2,1,1)+wy(2)*fxyz(2,2,1))) + wz(2)* &
                (wx(1)*(wy(1)*fxyz(1,1,2)+wy(2)*fxyz(1,2,2))+ &
                wx(2)*(wy(1)*fxyz(2,1,2)+wy(2)*fxyz(2,2,2))) )/ &
                ((wx(1)+wx(2))*(wy(1)+wy(2))*(wz(1)+wz(2)))
           !
        end do
     end do
  end do
  !
  deallocate (ftmp)
  return
end subroutine akherm3p

subroutine zonfind(x,nx,zxget,i)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer nx,nxm,i1,i2,ij,ii
  real(fp) :: dx
  real(fp) :: x(nx),zxget
  integer i
  !
  !  find index i such that x(i).le.zxget.le.x(i+1)
  !
  !  x(1...nx) is strict increasing and x(1).le.zxget.le.x(nx)
  !  (this is assumed to already have been checked -- no check here!)
  !
  nxm=nx-1
  if((i.lt.1).or.(i.gt.nxm)) then
     i1=1
     i2=nx-1
     go to 10
  end if

  if(x(i).gt.zxget) then
     ! look down
     dx=x(i+1)-x(i)
     if((x(i)-zxget).gt.4*dx) then
        i1=1
        i2=i-1
        go to 10
     else
        i2=i-1
        do ij=i2,1,-1
           if((x(ij).le.zxget).and.(zxget.le.x(ij+1))) then
              i=ij
              return
           end if
        end do
        i=1
        return
     end if
  else if(x(i+1).lt.zxget) then
     ! look up
     dx=x(i+1)-x(i)
     if((zxget-x(i+1)).gt.4*dx) then
        i1=i+1
        i2=nxm
        go to 10
     else
        i2=i+1
        do ij=i2,nxm
           if((x(ij).le.zxget).and.(zxget.le.x(ij+1))) then
              i=ij
              return
           end if
        end do
        ij=nxm
        return
     end if
  else
     ! already there...
     return
  end if

  !---------------------------
  !  binary search
  !
10 continue

  if(i1.eq.i2) then
     ! found by proc. of elimination
     i=i1
     return
  end if

  ii=(i1+i2)/2

  if(zxget.lt.x(ii)) then
     i2=ii-1
  else if(zxget.gt.x(ii+1)) then
     i1=ii+1
  else
     ! found
     i=ii
     return
  end if

  go to 10

  return
end subroutine zonfind

#include "fpreproc/f77_dcomplx.h"
subroutine f3test(fun1,fun2,id,inump, &
     xmin,xmax,ymin,ymax,zmin,zmax, &
     name,namex,namey,namez)
  use iso_c_binding, only: fp => c_double
  !
  !   test/compare 2 methods of evaluation of 3d function values and derivatives
  !
  !     passed:
  !       subroutine fun1(x,y,z,fget1(1..10))
  !       subroutine fun2(x,y,z,fget2(1..10))
  !
  !          (input x,y, return vector of 6 numbers containing, in order:
  !     f,df/dx,df/dy,df/dz,d2f/dx2,d2f/dy2,d2f/dz2,d2f/dxdy,d2f/dxdz,d2f/dydz)
  !
  !============
  implicit none
  integer icyc,i,ict,ifvals,iz,iy,ix
  !============
  real(fp) :: zz,zy,zx,zdifa
  !============
  external fun1,fun2
  !
  integer id                        ! 1 for 1st derivs, 2 for 2nd derivs.
  integer inump                     ! #evals per dimension
  !
  real(fp) :: xmin,xmax                    ! x range
  real(fp) :: ymin,ymax                    ! y range
  real(fp) :: zmin,zmax                    ! z range
  !
  character(len=*) name                ! name/label for fcns --
  character(len=*) namex,namey,namez   ! name/label for x & y dims
  !
  !  NOTE `name*' should be short with no leading or trailing blanks
  !
  !  local:
  !
  real(fp) :: fget1(10),fget2(10),fmin(10),fmax(10),fdifa(10)
  !
  !  output of routine:  stats written to unit 6
  !
  !--------------------------------
  !
  data icyc/100000/
  !
  do i=1,10
     fmin(i)=1.0E35_fp
     fmax(i)=-1.0E35_fp
     fdifa(i)=0.0_fp
  end do
  !
  ict=0
  !
  if(id.eq.2) then
     ifvals=10
  else
     ifvals=4
  end if
  !
  do iz=1,inump
     zz=zmin+real(iz-1,fp)*(zmax-zmin)/real(inump-1,fp)
     do iy=1,inump
        zy=ymin+real(iy-1,fp)*(ymax-ymin)/real(inump-1,fp)
        do ix=1,inump
           zx=xmin+real(ix-1,fp)*(xmax-xmin)/real(inump-1,fp)
           !
           ict=ict+1
           if(icyc*(ict/icyc).eq.ict) then
              write(6,1001) ix,zx,iy,zy,iz,zz
1001          format( &
                   '  ...f3test at x(',i5,')=',1pe11.4, &
                   ', y(',i5,')=',1pe11.4,', z(',i5,')=',1pe11.4)
           end if
           !
           call fun1(zx,zy,zz,fget1)
           call fun2(zx,zy,zz,fget2)
           !
           do i=1,ifvals
              fmin(i)=min(fmin(i),fget1(i),fget2(i))
              fmax(i)=max(fmax(i),fget1(i),fget2(i))
              zdifa=abs(fget1(i)-fget2(i))
              fdifa(i)=max(fdifa(i),zdifa)
           end do
           !
        end do
     end do
  end do
  !
  write(6,1002) namex,namey,namez,name, &
       (name,fmin(i),fmax(i),fdifa(i),i=1,4)
1002 format(/ &
       '  test function comparison:'/ &
       '     x stands for "',a,'";  y stands for "',a, &
       '"; z stands for "',a/ &
       '     (',a,')     min value   max value   max |diff|'/ &
       '   ',a,':      ',3(1pe11.3,2x)/ &
       '  d',a,'/dx:   ',3(1pe11.3,2x)/ &
       '  d',a,'/dy:   ',3(1pe11.3,2x)/ &
       '  d',a,'/dz:   ',3(1pe11.3,2x))
  if(ifvals.gt.4) write(6,1003) &
       (name,fmin(i),fmax(i),fdifa(i),i=5,10)
1003 format( &
       ' d2',a,'/dx2:  ',3(1pe11.3,2x)/ &
       ' d2',a,'/dy2:  ',3(1pe11.3,2x)/ &
       ' d2',a,'/dz2:  ',3(1pe11.3,2x)/ &
       ' d2',a,'/dxdy: ',3(1pe11.3,2x)/ &
       ' d2',a,'/dxdz: ',3(1pe11.3,2x)/ &
       ' d2',a,'/dydz: ',3(1pe11.3,2x))
  !
  return
end subroutine f3test

!
! 1-D
!

!  DMC modifications -- spl_name optional argument.
!  a single file can contain more than one spline (or not).  If it does
!  contain more than one spline, then each one must have a distinct name,
!  which must be specified in the call to tell which one to read this time.

!  fullsv -- ezspline_save now has a "full_save" option which means, save
!  the spline including coefficients.  ezspline_load is modified to look
!  for and read fullsv data if it is present; if not, the spline coefficients
!  are recalculated.

subroutine EZspline_load1(spline_o, filename, ier, spl_name)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline1) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 21=could not load spline object from file filename
  ! 22=loaded spline object from file filename but failed at coefficient set-up
  integer, intent(out) :: ier

  character(len=*), intent(in), OPTIONAL :: spl_name  ! specify name of spline
  !  to be read-- in case file contains more than one.

  integer ncid, ifail
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'
  integer n1, BCS1(2)
  real(fp), dimension(:), allocatable :: f

  character(len=4) :: data_type

  character(len=32) :: zpre
  logical :: fullsv

  if(present(spl_name)) then
     zpre = spl_name
  else
     zpre = ' '
  end if

  ier = 0
  call cdfOpn(ncid, filename, 'r') ! no error flag??
  if(ncid==0) then
     ier=43
     return
  end if

  ! check if n1 is present; check if spline object has correct rank
  !                         n2 should NOT be present.

  call cdfInqVar(ncid, trim(zpre)//'n1', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 21
     return
  end if
  call cdfInqVar(ncid, trim(zpre)//'n2', dimlens, data_type, ifail)
  if(ifail.eq.0) then
     ier = 20
     return
  end if

  ! check if fullsv was in effect -- if so, x1pkg will be found.

  fullsv=.FALSE.
  call cdfInqVar(ncid, trim(zpre)//'x1pkg', dimlens, data_type, ifail)
  if(ifail.eq.0) then
     fullsv=.TRUE.
  end if

  if( spline_o%nguard /= 123456789 ) call EZspline_preInit(spline_o)

  if( ezspline_allocated(spline_o) ) call EZspline_free1(spline_o, ier)

  call cdfGetVar(ncid, trim(zpre)//'n1', n1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  if(ifail.ne.0) spline_o%isLinear=0

  if(spline_o%isLinear.eq.1) then
     call EZlinear_init1(spline_o, n1, ier)
  else
     BCS1 = (/0, 0/)
     call EZspline_init1(spline_o, n1, BCS1, ier)
  end if
  if(ier.ne.0) return

  call cdfGetVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  if(ifail.ne.0) spline_o%klookup1=-3  ! the old default

  call cdfGetVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  if(ifail/=0) then
     ier=44
     return
  end if

  if(.not.fullsv) then
     allocate(f(n1))
     if(spline_o%isReady==1) then
        call cdfGetVar(ncid, trim(zpre)//'f', f, ifail)
     else
        ier = 92
     end if
  else
     call cdfGetVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
     call cdfGetVar(ncid, trim(zpre)//'fspl', spline_o%fspl, ifail)
  end if

  if(ifail /=0) then
     ier = 21
     return
  end if

  call cdfCls(ncid)

  if(.not.fullsv) then
     call EZspline_setup1_x(spline_o, f, ier)
     deallocate(f)
     if(ifail /=0) ier = 22
  end if

end subroutine EZspline_load1





!!
!! 2-D
!!


subroutine EZspline_load2(spline_o, filename, ier, spl_name)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline2) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 20=attempt to load spline object with incorrect rank
  ! 21=could not load spline object from file filename
  ! 22=loaded spline object from file filename but failed at coefficient set-up
  integer, intent(out) :: ier

  character(len=*), intent(in), OPTIONAL :: spl_name  ! specify name of spline
  !  to be read-- in case file contains more than one.

  integer ncid, ifail, in0, in1, in2
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'
  integer n1, n2, BCS1(2), BCS2(2), hspline(2)
  real(fp), dimension(:,:), allocatable :: f

  character(len=4) :: data_type

  character(len=32) zpre
  logical :: fullsv

  if(present(spl_name)) then
     zpre = spl_name
  else
     zpre = ' '
  end if

  ier = 0
  call cdfOpn(ncid, filename, 'r') ! no error flag??
  if(ncid==0) then
     ier=43
     return
  end if

  ! check if n1 is present; check if spline object has correct rank
  !                         n2 should be present but not n3...

  call cdfInqVar(ncid, trim(zpre)//'n1', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 21
     return
  end if
  call cdfInqVar(ncid, trim(zpre)//'n2', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 20
     return
  end if
  call cdfInqVar(ncid, trim(zpre)//'n3', dimlens, data_type, ifail)
  if(ifail.eq.0) then
     ier = 20
     return
  end if

  ! check if fullsv was in effect -- if so, x1pkg will be found.

  fullsv=.FALSE.
  call cdfInqVar(ncid, trim(zpre)//'x1pkg', dimlens, data_type, ifail)
  if(ifail.eq.0) then
     fullsv=.TRUE.
  end if

  if(spline_o%nguard /= 123456789 ) call EZspline_preInit(spline_o)

  if( ezspline_allocated(spline_o) ) call EZspline_free2(spline_o, ier)

  call cdfGetVar(ncid, trim(zpre)//'n1', n1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'n2', n2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  if(ifail.ne.0) spline_o%isLinear=0
  call cdfGetVar(ncid, trim(zpre)//'isHybrid', spline_o%isHybrid, ifail)
  if(ifail.ne.0) spline_o%isHybrid=0
  spline_o%hspline = 0

  if(spline_o%isLinear.eq.1) then
     call EZlinear_init2(spline_o, n1, n2, ier)
  else if(spline_o%isHybrid.eq.1) then
     call cdfGetVar(ncid, trim(zpre)//'hspline', hspline, ifail)
     call EZhybrid_init2_x(spline_o, n1, n2, hspline, ier)
  else
     BCS1 = (/0, 0/); BCS2 = (/0, 0/)
     call EZspline_init2(spline_o, n1, n2, BCS1, BCS2, ier)
  end if
  if(ier.ne.0) return

  call cdfGetVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  if(ifail.ne.0) spline_o%klookup1=-3  ! the old default
  call cdfGetVar(ncid, trim(zpre)//'klookup2', spline_o%klookup2, ifail)
  if(ifail.ne.0) spline_o%klookup2=-3  ! the old default

  call cdfGetVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype2', spline_o%ibctype2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x2', spline_o%x2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval2min', spline_o%bcval2min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval2max', spline_o%bcval2max, ifail)
  if(ifail/=0) then
     ier=44
     return
  end if

  in0=size(spline_o%fspl,1)
  in1=size(spline_o%fspl,2)
  in2=size(spline_o%fspl,3)

  if(.not.fullsv) then
     allocate(f(in1,in2))
     if(spline_o%isReady==1) then
        call cdfGetVar(ncid, trim(zpre)//'f', f, ifail)
     else
        ier = 92
     end if
  else
     call cdfGetVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2min', spline_o%x2min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2max', spline_o%x2max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin2', spline_o%ilin2, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2pkg', spline_o%x2pkg, ifail)
     call cdfGetVar(ncid, trim(zpre)//'fspl', spline_o%fspl, ifail)
  end if

  if(ifail /=0) then
     ier = 21
     return
  end if

  call cdfCls(ncid)

  if(.not.fullsv) then
     call EZspline_setup2_x(spline_o, f, ier)
     deallocate(f)
     if(ifail /=0) ier = 22
  end if

end subroutine EZspline_load2


!!!
!!! 3-D
!!!


subroutine EZspline_load3(spline_o, filename, ier, spl_name)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  use EZcdf
  implicit none
  type(EZspline3) :: spline_o
  character(len=*) :: filename
  ! ier:
  ! 21=could not load spline object from file filename
  ! 22=loaded spline object from file filename but failed at coefficient set-up
  integer, intent(out) :: ier

  character(len=*), intent(in), OPTIONAL :: spl_name  ! specify name of spline
  !  to be read-- in case file contains more than one.

  integer ncid, ifail, in0, in1, in2, in3
  integer dimlens(3)
  character(len=2), parameter :: real8='R8'
  character(len=3), parameter :: int='INT'
  integer n1, n2, n3, BCS1(2), BCS2(2), BCS3(2), hspline(3)
  real(fp), dimension(:,:,:), allocatable :: f

  character(len=4) :: data_type

  character(len=32) :: zpre
  logical :: fullsv

  if(present(spl_name)) then
     zpre = spl_name
  else
     zpre = ' '
  end if

  ier = 0
  call cdfOpn(ncid, filename, 'r') ! no error flag??
  if(ncid==0) then
     ier=43
     return
  end if

  ! check if n1 is present; check if spline object has correct rank
  !                         n2 and n3 should also be present.

  call cdfInqVar(ncid, trim(zpre)//'n1', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 21
     return
  end if
  call cdfInqVar(ncid, trim(zpre)//'n2', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 20
     return
  end if
  call cdfInqVar(ncid, trim(zpre)//'n3', dimlens, data_type, ifail)
  if(ifail.ne.0) then
     ier = 20
     return
  end if

  ! check if fullsv was in effect -- if so, x1pkg will be found.

  fullsv=.FALSE.
  call cdfInqVar(ncid, trim(zpre)//'x1pkg', dimlens, data_type, ifail)
  if(ifail.eq.0) then
     fullsv=.TRUE.
  end if

  if(spline_o%nguard /= 123456789 ) call EZspline_preInit(spline_o)

  if( ezspline_allocated(spline_o) ) call EZspline_free3(spline_o, ier)

  call cdfGetVar(ncid, trim(zpre)//'n1', n1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'n2', n2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'n3', n3, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isLinear', spline_o%isLinear, ifail)
  if(ifail.ne.0) spline_o%isLinear=0
  call cdfGetVar(ncid, trim(zpre)//'isHybrid', spline_o%isHybrid, ifail)
  if(ifail.ne.0) spline_o%isHybrid=0
  spline_o%hspline = 0

  if(spline_o%isLinear.eq.1) then
     call EZlinear_init3(spline_o, n1, n2, n3, ier)
  else if(spline_o%isHybrid.eq.1) then
     call cdfGetVar(ncid, trim(zpre)//'hspline', hspline, ifail)
     call EZhybrid_init3_x(spline_o, n1, n2, n3, hspline, ier)
  else
     BCS1 = (/0, 0/); BCS2 = (/0, 0/); BCS3 = (/0, 0/)
     call EZspline_init3(spline_o, n1, n2, n3, BCS1, BCS2, BCS3, ier)
  end if
  if(ier.ne.0) return

  call cdfGetVar(ncid, trim(zpre)//'klookup1', spline_o%klookup1, ifail)
  if(ifail.ne.0) spline_o%klookup1=-3  ! the old default
  call cdfGetVar(ncid, trim(zpre)//'klookup2', spline_o%klookup2, ifail)
  if(ifail.ne.0) spline_o%klookup2=-3  ! the old default
  call cdfGetVar(ncid, trim(zpre)//'klookup3', spline_o%klookup3, ifail)
  if(ifail.ne.0) spline_o%klookup3=-3  ! the old default

  call cdfGetVar(ncid, trim(zpre)//'isHermite', spline_o%isHermite, ifail)
  call cdfGetVar(ncid, trim(zpre)//'isReady', spline_o%isReady, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype1', spline_o%ibctype1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype2', spline_o%ibctype2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'ibctype3', spline_o%ibctype3, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x1', spline_o%x1, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x2', spline_o%x2, ifail)
  call cdfGetVar(ncid, trim(zpre)//'x3', spline_o%x3, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1min', spline_o%bcval1min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval1max', spline_o%bcval1max, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval2min', spline_o%bcval2min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval2max', spline_o%bcval2max, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval3min', spline_o%bcval3min, ifail)
  call cdfGetVar(ncid, trim(zpre)//'bcval3max', spline_o%bcval3max, ifail)
  if(ifail/=0) then
     ier=44
     return
  end if

  in0=size(spline_o%fspl,1)
  in1=size(spline_o%fspl,2)
  in2=size(spline_o%fspl,3)
  in3=size(spline_o%fspl,4)

  if(.not.fullsv) then
     allocate(f(in1,in2,in3))
     if(spline_o%isReady==1) then
        call cdfGetVar(ncid, trim(zpre)//'f', f, ifail)
     else
        ier = 92
     end if
  else
     call cdfGetVar(ncid, trim(zpre)//'x1min', spline_o%x1min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1max', spline_o%x1max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin1', spline_o%ilin1, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2min', spline_o%x2min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2max', spline_o%x2max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin2', spline_o%ilin2, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x3min', spline_o%x3min, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x3max', spline_o%x3max, ifail)
     call cdfGetVar(ncid, trim(zpre)//'ilin3', spline_o%ilin3, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x1pkg', spline_o%x1pkg, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x2pkg', spline_o%x2pkg, ifail)
     call cdfGetVar(ncid, trim(zpre)//'x3pkg', spline_o%x3pkg, ifail)
     call ezspline_cdfget3(ncid, trim(zpre)//'fspl', spline_o%fspl, &
          in0*in1, in2, in3, ifail)
  end if

  if(ifail /=0) then
     ier = 21
     return
  end if

  call cdfCls(ncid)

  if(.not.fullsv) then
     call EZspline_setup3_x(spline_o, f, ier)
     deallocate(f)
     if(ifail /=0) ier = 22
  end if

end subroutine EZspline_load3

subroutine mkspl2pb(fun,x,nx,th,nth,fspl,nf3, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     wk,inwk,ilinx,ilinth,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  create a bicubic periodic spline with knots at grid points and
  !  function values from the callable function `fun' passed.
  !
  !  use bpsplinb to setup the spline coefficients
  !
  !  periodic boundary condition for theta grid;
  !  boundary condition data may be specified at x(1) and x(nx)
  !     ibcxmin=0 ==> "not a knot" boundary condition, cf cubspl.f90
  !     ibcxmin=1 ==> match slope, bcxmin(ith) gives df/dx at x(1),th(ith).
  !     ibcxmin=2 ==> match 2nd derivative, given at x(1),th(ith) by bcxmin(ith)
  !
  !     ibcxmax,bcxmax have analogous interpretation -- at x(nx)
  !
  !============
  implicit none
  integer nth,nf3,inwk,nx,ix,ith
  !============
  real(fp) :: fun
  !============
  external fun                      ! passed real function(x,th)
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: th(nth)                      ! th coordinate array
  !
  real(fp) :: fspl(4,4,nf3,nth)            ! function data / spline coeff array
  real(fp) :: wk(inwk)                     ! workspace for bpsplinb
  !
  integer ibcxmin                   ! boundary condition indicator
  real(fp) :: bcxmin(nth)                  ! boundary condition data
  integer ibcxmax                   ! boundary condition indicator
  real(fp) :: bcxmax(nth)                  ! boundary condition data
  !
  integer ilinx                     ! output =1 if x(...) evenly spaced
  integer ilinth                    ! output =1 if th(...) evenly spaced
  !
  integer ier                       ! completion code from bpspline
  !
  !----------------------------
  !
  ier=0
  if(nf3.lt.nx) then
     write(6,'('' ?mkspl2pb -- array dim error, nf3.lt.nx'')')
     ier=1
  end if
  if(inwk.lt.5*max(nx,nth)) then
     write(6,'('' ?mkspl2pb -- array dim error, inwk too small'')')
     ier=2
  end if
  !
  do ix=1,nx
     do ith=1,nth
        fspl(1,1,ix,ith)=fun(x(ix),th(ith))
     end do
  end do
  !
  call bpsplinb(x,nx,th,nth,fspl,nx,ibcxmin,bcxmin,ibcxmax,bcxmax, &
       wk,inwk,ilinx,ilinth,ier)
  !
  return
end subroutine mkspl2pb

!-----------------------------------------------------------------------
! return the elapsed time, in seconds, since 00:00, Jan. 1, 2000.
! (the algorithm is copied from Charles Karney's "wall_time()"
!
      SUBROUTINE wall_seconds(wall_secs)
      integer wall_secs        ! wall clock seconds since 1/1/2000
!
      integer time(8)
      integer y,m,d
!
!   Charles' description:
! Return wall clock time as the number of seconds since 00:00, January 1,
! 2000.  Use the standard rule for the Gregorian calendar---leap years every
! multiple of 4, unless it's a multiple of 100 and not a muliple of 400.
! Arithmetic is simplified by moving January and February to the previous
! year.  The pattern of month lengths from March thru January is regular with
! a 5-month period---31, 30, 31, 30, 31, 31, 30, 31, 30, 31, 31.  The 5-month
! period is 153 days long.  On a computer with 32-bit integers this won't
! overflow until 2068.
!------------------------------------
!
      isecs=0
!
      call clocaltim(time)
!
      y=time(1)+int((time(2)+9)/12)-1 ! Move January and February to prev. year
      m=mod(time(2)+9,12)             ! March is now month 0
!     CAL: .for code is processed as fixed format
      d=365*y+int(y/4)-int(y/100)+int(y/400)+int((m+4)*153/5)+time(3)
     >  -730548
!           January 1, 2000 is day 0
 
      wall_secs=60*(60*(24*d+time(5))+time(6))+time(7)
!
      return
      end

   module mtrcons
!. mtrcons                           Various constants collected together, to enable
!                                    a degree of consistency between routines
!
!
!  Author                            jim.conboy@ccfe.ac.uk
!  Version                           1.00,  06Jan2012
!  Modifications
!
!  1.00  06Jan2012                   jim.conboy@ccfe.ac.uk
!                                    Written
!----_^---------------------------------=========================================|
!
!
   implicit  none
!
!..GLOBAL
!
   integer, parameter           :: R8      = selected_real_kind(12,100)           !  64 bit
   !
   character(len=*), parameter  :: calph_L = 'abcdefghijklmnopqrstuvwxyz'  &
                                  ,calph_U = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'  &
                                  ,cnum    = '0123456789'                  &
                                  ,cschar  = '`¬!"£$%^&*()_:@~;''#?,./'    &
                                  ,coper   = '+-*/='                       &
                                  ,cbrkt   = '(){}[]<>'
   !
   character(len=1), parameter  :: cdlm    = '/'   & ! file path delimiter
                                  ,cdkdlm  = ':'   & ! disk name delimiter ( VMS )
                                  ,cdol    = '$'   & ! dollar
                                  ,cdot    = '.'   & ! point
                                  ,cus     = '_'   & ! U/score  
                                  ,cq      = ''''  & ! single quote
                                  ,cqq     = '"'   & ! double quote
                                  ,coq     = '`'   & ! open quote
                                  ,cspace  = ' '   &
                                  ,char0   = char(0)
   !
   character(len=8), parameter  :: csp8    = '        '
   !
   character(len=*), parameter  :: cfpath  = calph_L // calph_U // cnum // &
                                             cdlm // cdot // cus // cdol
   !
   character(len=*), parameter              :: cM = 'portlib/mtrcons'
!  contains

   end module mtrcons

subroutine ezspline_setup1_x(spline_o, f, ier)
  use iso_c_binding, only: fp => c_double

  !  setup call (set array size from object)

  use EZspline_obj
  use EZspline
  implicit NONE

  type(EZspline1) :: spline_o
  real(fp) :: f(size(spline_o%fspl,2))
  integer, intent(out) :: ier

  call ezspline_setup(spline_o, f, ier)

end subroutine ezspline_setup1_x

subroutine ezspline_setup2_x(spline_o, f, ier)
  use iso_c_binding, only: fp => c_double

  !  setup call (set array size from object)

  use EZspline_obj
  use EZspline
  implicit NONE

  type(EZspline2) :: spline_o
  real(fp) :: f(size(spline_o%fspl,2),size(spline_o%fspl,3))
  integer, intent(out) :: ier

  call ezspline_setup(spline_o, f, ier)

end subroutine ezspline_setup2_x

subroutine ezspline_setup3_x(spline_o, f, ier)
  use iso_c_binding, only: fp => c_double

  !  setup call (set array size from object)

  use EZspline_obj
  use EZspline
  implicit NONE

  type(EZspline3) :: spline_o
  real(fp) :: f(size(spline_o%fspl,2),size(spline_o%fspl,3), &
       size(spline_o%fspl,4))
  integer, intent(out) :: ier

  call ezspline_setup(spline_o, f, ier)

end subroutine ezspline_setup3_x

! $Id: ezcdf_genget.f90,v 1.17 2003-07-01 19:35:42 xshare Exp $
MODULE ezcdf_GenGet
  USE ezcdf_opncls
  USE ezcdf_inqvar
  EXTERNAL ezcdf_error
 
  PRIVATE
 
  include "netcdf.inc"
  integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
  integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
  character*(*), parameter :: cmplx_name = '__CmPlx_Re_Im'
  PRIVATE :: r4, r8, cmplx_name
 
  PUBLIC :: cdfr_3i, cdfr_3l, cdfr_3d, cdfr_3c16, cdfr_3f, cdfr_3c8,           &
       & cdfr_2i, cdfr_2l, cdfr_2d, cdfr_2c16, cdfr_2f, cdfr_2c8, cdfr_2c,     &
       & cdfr_1i, cdfr_1l, cdfr_1d, cdfr_1c16, cdfr_1f, cdfr_1c8, cdfr_1c,     &
       & cdfr_0i, cdfr_0l, cdfr_0d, cdfr_0c16, cdfr_0f, cdfr_0c8, cdfGetVar,   &
       & cdf_read
 

  ! Generic Interface to Read netcdf data Variables
  ! 03/10/99 C. Ludescher
  ! C. Ludescher/A. Pletzer Tue Apr  4 10:11:33 EDT 2000
  ! + support for complex types (ap) Wed May 16 15:18:05 EDT 2001
  !====================================================================
  ! Generic Read Routines: cdfGetVar

  ! alias to cdfGetVar (ifc does not like => )
  INTERFACE cdf_read
     MODULE PROCEDURE cdfr_3i, cdfr_3l, cdfr_3d, cdfr_3c16, cdfr_3f, cdfr_3c8,           &
                      cdfr_2i, cdfr_2l, cdfr_2d, cdfr_2c16, cdfr_2f, cdfr_2c8, cdfr_2c,  &
                      cdfr_1i, cdfr_1l, cdfr_1d, cdfr_1c16, cdfr_1f, cdfr_1c8, cdfr_1c,  &
                      cdfr_0i, cdfr_0l, cdfr_0d, cdfr_0c16, cdfr_0f, cdfr_0c8
  END INTERFACE
  ! same as above (Intel compiler does not handle well aliases)
  INTERFACE cdfGetVar
     MODULE PROCEDURE cdfr_3i, cdfr_3l, cdfr_3d, cdfr_3c16, cdfr_3f, cdfr_3c8,           &
                      cdfr_2i, cdfr_2l, cdfr_2d, cdfr_2c16, cdfr_2f, cdfr_2c8, cdfr_2c,  &
                      cdfr_1i, cdfr_1l, cdfr_1d, cdfr_1c16, cdfr_1f, cdfr_1c8, cdfr_1c,  &
                      cdfr_0i, cdfr_0l, cdfr_0d, cdfr_0c16, cdfr_0f, cdfr_0c8
  END INTERFACE

CONTAINS
!---------------------------------------------
!cdfGetVar implementation routines 

SUBROUTINE cdfr_3i(ncid,varnam,varval,ier)
  ! Read 3 dimensional Integer array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  integer, dimension(:,:,:), intent(out) :: varval
  integer, optional,         intent(out) :: ier
  ! Local
  integer, dimension(3)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j,  k
  integer, dimension(3)   :: dimlens

  integer, dimension(:,:,:), allocatable :: temp
  integer :: ndim1, ndim2, ndim3 

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'i',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2).and.dimlens(3)==ldim(3))then
     status = nf_get_var_int(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3i', 'nf_get_var_int')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2), dimlens(3)))
     status = nf_get_var_int(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3i', 'nf_get_var_int')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     ndim3 = min(dimlens(3), ldim(3))
     varval(1:ndim1, 1:ndim2, 1:ndim3) = temp(1:ndim1, 1:ndim2, 1:ndim3)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  cnt(3) = 1
!!$  do k = 1,min(dimlens(2),ldim(2))
!!$     st(2) = k
!!$     do j = 1,min(dimlens(3),ldim(3)) ! For each Z : read slab in varval
!!$        st(3) = j           ! Start of slab
!!$        status = nf_get_vara_int(ncid,varid,st,cnt,varval(1,k,j))
!!$        if (status .ne. NF_NOERR) then
!!$           call ezcdf_error(status,varnam,'cdfr_3i',                 &
!!$                &              'nf_get_vara_int')
!!$           return
!!$        end if
!!$     end do
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_3i
 
SUBROUTINE cdfr_3l(ncid,varnam,varval,ier)
  ! Read 3 dimensional logical array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  logical, dimension(:,:,:), intent(out) :: varval
  integer, optional,         intent(out) :: ier
  ! Local
  integer                                :: status
  integer, dimension(:,:,:), allocatable :: varval_i
  character*11, parameter :: logical_name = '__logical__'
 
  ALLOCATE (varval_i(size(varval,1), size(varval,2), size(varval,3)), stat=status)
  if (status .ne. 0) STOP 'Allocation error in cdf_getvar'
 
  call cdfr_3i(ncid,trim(varnam)//logical_name,varval_i,ier)
 
  WHERE (varval_i == 0)
     varval = .false.
  ELSEWHERE
     varval = .true.
  END WHERE
  DEALLOCATE (varval_i)
END SUBROUTINE cdfr_3l
 
SUBROUTINE cdfr_3d(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r8), dimension(:,:,:), intent(out) ::  varval
  integer, optional,               intent(out) :: ier
  ! Local
  integer, dimension(3)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j,  k
  integer, dimension(3)   :: dimlens

  real(r8), dimension(:,:,:), allocatable :: temp
  integer ndim1, ndim2, ndim3

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !

  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2).and.dimlens(3)==ldim(3))then
     status = nf_get_var_double(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3d', 'nf_get_var_double')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2), dimlens(3)))
     status = nf_get_var_double(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3d', 'nf_get_var_double')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     ndim3 = min(dimlens(3), ldim(3))
     varval(1:ndim1, 1:ndim2, 1:ndim3) = temp(1:ndim1, 1:ndim2, 1:ndim3)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  cnt(3) = 1
!!$  do k = 1,min(dimlens(2),ldim(2))
!!$     st(2) = k
!!$     do j = 1,min(dimlens(3),ldim(3)) ! For each Z : read slab into varval
!!$        st(3) = j                      ! Start of slab
!!$        status = nf_get_vara_double(ncid,varid,st,cnt,varval(1,k,j))
!!$        if (status .ne. NF_NOERR) then
!!$           call ezcdf_error(status,varnam,'cdfr_3d',                    &
!!$                &           'nf_get_vara_double')
!!$           return
!!$        end if
!!$     end do
!!$  end do

  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_3d

SUBROUTINE cdfr_3c16(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r8), dimension(:,:,:), intent(out) ::  varval
  integer, optional,               intent(out) :: ier
  ! Local
  integer, dimension(3)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j,  k, i
  integer, dimension(3)   :: dimlens

  real(r8), dimension(:,:,:), allocatable :: temp
  integer ndim1, ndim2, ndim3
 
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1) ! Re/Im pairs
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2).and.dimlens(3)==ldim(3))then
     status = nf_get_var_double(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3c16', 'nf_get_var_double')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2), dimlens(3)))
     status = nf_get_var_double(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3c16', 'nf_get_var_double')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     ndim3 = min(dimlens(3), ldim(3))
     do i = 1, ndim1/2
        varval(i, 1:ndim2, 1:ndim3) = temp(2*(i-1)+1, 1:ndim2, 1:ndim3) +  &
             & (0._r8,1._r8)*temp(2*(i-1)+2, 1:ndim2, 1:ndim3)
     enddo 
     deallocate(temp)
  endif
!!$
!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  cnt(3) = 1
!!$  do k = 1,min(dimlens(2),ldim(2))
!!$     st(2) = k
!!$     do j = 1,min(dimlens(3),ldim(3)) ! For each Z : read slab into varval
!!$        st(3) = j                      ! Start of slab
!!$        status = nf_get_vara_double(ncid,varid,st,cnt,varval(1,k,j))
!!$        if (status .ne. NF_NOERR) then
!!$           call ezcdf_error(status,varnam,'cdfr_3c16',                    &
!!$                &           'nf_get_vara_double')
!!$           return
!!$        end if
!!$     end do
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_3c16

SUBROUTINE cdfr_3f(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r4), dimension(:,:,:), intent(out) ::  varval
  integer, optional,               intent(out) :: ier
  ! Local
  integer, dimension(3)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j,  k
  integer, dimension(3)   :: dimlens

  real, dimension(:,:,:), allocatable :: temp
  integer ndim1, ndim2, ndim3

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2).and.dimlens(3)==ldim(3))then
     status = nf_get_var_real(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3f', 'nf_get_var_real')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2), dimlens(3)))
     status = nf_get_var_real(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3f', 'nf_get_var_real')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     ndim3 = min(dimlens(3), ldim(3))
     varval(1:ndim1, 1:ndim2, 1:ndim3) = temp(1:ndim1, 1:ndim2, 1:ndim3)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  cnt(3) = 1
!!$  do k = 1,min(dimlens(2),ldim(2))
!!$     st(2) = k
!!$     do j = 1,min(dimlens(3),ldim(3)) ! For each Z : read slab into varval
!!$        st(3) = j                      ! Start of slab
!!$        status = nf_get_vara_real(ncid,varid,st,cnt,varval(1,k,j))
!!$        if (status .ne. NF_NOERR) then
!!$           call ezcdf_error(status,varnam,'cdfr_3f',                    &
!!$                &           'nf_get_vara_real')
!!$           return
!!$        end if
!!$     end do
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_3f

SUBROUTINE cdfr_3c8(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r4), dimension(:,:,:), intent(out) ::  varval
  integer, optional,               intent(out) :: ier
  ! Local
  integer, dimension(3)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j,  k
  integer, dimension(3)   :: dimlens

  real, dimension(:,:,:), allocatable :: temp
  integer ndim1, ndim2, ndim3, i
 
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1) ! Re/Im pairs
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2).and.dimlens(3)==ldim(3))then
     status = nf_get_var_real(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3c8', 'nf_get_var_real')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2), dimlens(3)))
     status = nf_get_var_real(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_3c8', 'nf_get_var_real')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     ndim3 = min(dimlens(3), ldim(3))
     do i = 1, ndim1/2
        varval(i, 1:ndim2, 1:ndim3) = temp(2*(i-1)+1, 1:ndim2, 1:ndim3) +  &
             & (0.,1.)*temp(2*(i-1)+2, 1:ndim2, 1:ndim3)
     enddo 
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  cnt(3) = 1
!!$  do k = 1,min(dimlens(2),ldim(2))
!!$     st(2) = k
!!$     do j = 1,min(dimlens(3),ldim(3)) ! For each Z : read slab into varval
!!$        st(3) = j                      ! Start of slab
!!$        status = nf_get_vara_real(ncid,varid,st,cnt,varval(1,k,j))
!!$        if (status .ne. NF_NOERR) then
!!$           call ezcdf_error(status,varnam,'cdfr_3c8',                    &
!!$                &           'nf_get_vara_real')
!!$           return
!!$        end if
!!$     end do
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_3c8
 
SUBROUTINE cdfr_2i(ncid,varnam,varval,ier)
  ! Read 2 dimensional Integer array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  integer, dimension(:,:), intent(out) :: varval
  integer, optional,       intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j
  integer, dimension(2)   :: dimlens

  integer, dimension(:,:), allocatable :: temp
  integer ndim1, ndim2

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'i',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2))then
     status = nf_get_var_int(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2i', 'nf_get_var_int')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2)))
     status = nf_get_var_int(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2i', 'nf_get_var_int')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     varval(1:ndim1, 1:ndim2) = temp(1:ndim1, 1:ndim2)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
!!$     st(2) = j              ! Start of slab
!!$     status = nf_get_vara_int(ncid,varid,st,cnt,varval(1,j))
!!$     if (status .ne. NF_NOERR) then
!!$        call ezcdf_error(status,varnam,'cdfr_2i',                    &
!!$             &           'nf_get_vara_int')
!!$        return
!!$     end if
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2i
 
SUBROUTINE cdfr_2l(ncid,varnam,varval,ier)
  ! Read 2 dimensional logical array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  logical, dimension(:,:), intent(out) :: varval
  integer, optional,       intent(out) :: ier
  ! Local
  integer                              :: status
  integer, dimension(:,:), allocatable :: varval_i
  character*11, parameter :: logical_name = '__logical__'
 
  ALLOCATE (varval_i(size(varval,1), size(varval,2)), stat=status)
  if (status .ne. 0) STOP 'Allocation error in cdf_getvar'
 
  call cdfr_2i(ncid,trim(varnam)//logical_name,varval_i,ier)
 
  WHERE (varval_i == 0)
     varval = .false.
  ELSEWHERE
     varval = .true.
  END WHERE
  DEALLOCATE (varval_i)
END SUBROUTINE cdfr_2l
 
SUBROUTINE cdfr_2d(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r8), dimension(:,:), intent(out) ::  varval
  integer, optional,             intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j
  integer, dimension(2)   :: dimlens

  real(r8), dimension(:,:), allocatable :: temp
  integer ndim1, ndim2

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2))then
     status = nf_get_var_double(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2d', 'nf_get_var_double')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2)))
     status = nf_get_var_double(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2d', 'nf_get_var_double')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     varval(1:ndim1, 1:ndim2) = temp(1:ndim1, 1:ndim2)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
!!$     st(2) = j              ! Start of slab
!!$     status = nf_get_vara_double(ncid,varid,st,cnt,varval(1,j))
!!$     if (status .ne. NF_NOERR) then
!!$        call ezcdf_error(status,varnam,'cdfr_2d',                    &
!!$             &           'nf_get_vara_double')
!!$        return
!!$     end if
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2d

SUBROUTINE cdfr_2c16(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r8), dimension(:,:), intent(out) ::  varval
  integer, optional,             intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j, i
  integer, dimension(2)   :: dimlens

  real(r8), dimension(:,:), allocatable :: temp
  integer ndim1, ndim2
 
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1) ! Re/Im pairs
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2))then
     status = nf_get_var_double(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2c16', 'nf_get_var_double')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2)))
     status = nf_get_var_double(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2c16', 'nf_get_var_double')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     do i = 1, ndim1/2
        varval(i, 1:ndim2) = temp(2*(i-1)+1, 1:ndim2) + &
             & (0._r8, 1._r8)*temp(2*(i-1)+2, 1:ndim2)
     enddo
     deallocate(temp)
  endif
!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
!!$     st(2) = j              ! Start of slab
!!$     status = nf_get_vara_double(ncid,varid,st,cnt,varval(1,j))
!!$     if (status .ne. NF_NOERR) then
!!$        call ezcdf_error(status,varnam,'cdfr_2c16',                    &
!!$             &           'nf_get_vara_double')
!!$        return
!!$     end if
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2c16

SUBROUTINE cdfr_2f(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r4), dimension(:,:), intent(out) ::  varval
  integer, optional,             intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j
  integer, dimension(2)   :: dimlens

  real, dimension(:,:), allocatable :: temp
  integer ndim1, ndim2

  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2))then
     status = nf_get_var_real(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2f', 'nf_get_var_real')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2)))
     status = nf_get_var_real(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2f', 'nf_get_var_real')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     varval(1:ndim1, 1:ndim2) = temp(1:ndim1, 1:ndim2)
     deallocate(temp)
  endif

!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
!!$     st(2) = j              ! Start of slab
!!$     status = nf_get_vara_real(ncid,varid,st,cnt,varval(1,j))
!!$     if (status .ne. NF_NOERR) then
!!$        call ezcdf_error(status,varnam,'cdfr_2f',                    &
!!$             &           'nf_get_vara_real')
!!$        return
!!$     end if
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2f

SUBROUTINE cdfr_2c8(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r4), dimension(:,:), intent(out) ::  varval
  integer, optional,             intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, j, i
  integer, dimension(2)   :: dimlens

  real(r8), dimension(:,:), allocatable :: temp
  integer ndim1, ndim2
 
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1) ! Re/Pairs
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  if(dimlens(1)==ldim(1).and.dimlens(2)==ldim(2))then
     status = nf_get_var_real(ncid, varid, varval)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2c8', 'nf_get_var_real')
        return
     endif
  else
     allocate(temp(dimlens(1), dimlens(2)))
     status = nf_get_var_real(ncid, varid, temp)
     if(status/=NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2c8', 'nf_get_var_real')
        deallocate(temp)
        return
     endif
     ndim1 = min(dimlens(1), ldim(1))
     ndim2 = min(dimlens(2), ldim(2))
     do i = 1, ndim1/2
        varval(i, 1:ndim2) = temp(2*(i-1)+1, 1:ndim2) + &
             & (0.,1.)*temp(2*(i-1)+2, 1:ndim2)
     enddo
     deallocate(temp)
  endif
!!$  st(1) = 1
!!$  cnt(1) = min(dimlens(1),ldim(1)) ! x count
!!$  cnt(2) = 1
!!$  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
!!$     st(2) = j              ! Start of slab
!!$     status = nf_get_vara_real(ncid,varid,st,cnt,varval(1,j))
!!$     if (status .ne. NF_NOERR) then
!!$        call ezcdf_error(status,varnam,'cdfr_2c8',                    &
!!$             &           'nf_get_vara_real')
!!$        return
!!$     end if
!!$  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2c8
SUBROUTINE cdfr_2c(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  character*(*), dimension(:),intent(out) :: varval
  integer, optional,          intent(out) :: ier
  ! Local
  integer, dimension(2)   :: st,     cnt,    ldim
  integer                 :: varid,  status, charlen, j
  integer, dimension(2)   :: dimlens
  if (PRESENT (ier)) ier = 1
  ldim(1) = len(varval)
  ldim(2)=size(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'c',status)
  if (status .ne. 0) return
  !
  st(1) = 1
  cnt(1) = min(dimlens(1),ldim(1)) ! x count
  cnt(2) = 1
  do j = 1,min(dimlens(2),ldim(2)) ! For each Y : read slab into varval
     st(2) = j              ! Start of slab
     status = nf_get_vara_text(ncid,varid,st,cnt,varval(j))
     if (status .ne. NF_NOERR) then
        call ezcdf_error(status,varnam,'cdfr_2c',                       &
             &        'nf_get_var_text')
        return
     end if
  end do
  if (PRESENT (ier)) ier = 0
END SUBROUTINE cdfr_2c
 
SUBROUTINE cdfr_1i(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  integer, dimension(:), intent(out) :: varval
  integer, optional,     intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'i',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_int(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1i','nf_get_var_int')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1i
 
SUBROUTINE cdfr_1l(ncid,varnam,varval,ier)
  ! Read 1 dimensional logical array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  logical, dimension(:), intent(out) :: varval
  integer, optional,     intent(out) :: ier
  ! Local
  integer                            :: status
  integer, dimension(:), allocatable :: varval_i
  character*11, parameter :: logical_name = '__logical__'
 
  ALLOCATE (varval_i(size(varval,1)), stat=status)
  if (status .ne. 0) STOP 'Allocation error in cdf_getvar'
 
  call cdfr_1i(ncid,trim(varnam)//logical_name,varval_i,ier)
 
  WHERE (varval_i == 0)
     varval = .false.
  ELSEWHERE
     varval = .true.
  END WHERE
  DEALLOCATE (varval_i)
END SUBROUTINE cdfr_1l
 
SUBROUTINE cdfr_1d(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r8), dimension(:), intent(out) :: varval
  integer, optional,           intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_double(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1d','nf_get_var_double')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1d
SUBROUTINE cdfr_1c16(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r8), dimension(:), intent(out) :: varval
  integer, optional,           intent(out) :: ier
 
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1) ! Re/Im pairs
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_double(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1c16','nf_get_var_double')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1c16
SUBROUTINE cdfr_1f(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r4), dimension(:), intent(out) :: varval
  integer, optional,           intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_real(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1f','nf_get_var_real')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1f
SUBROUTINE cdfr_1c8(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r4), dimension(:), intent(out) :: varval
  integer, optional,           intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
 
  if (PRESENT (ier)) ier = 1
  ldim = shape(varval)
  ldim(1) = 2*ldim(1)
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_real(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1c8','nf_get_var_real')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1c8
SUBROUTINE cdfr_1c(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in)  :: ncid
  character*(*), intent(in)  :: varnam
  ! Output
  character*(*),     intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim(1) = len(varval)
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'c',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_text(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_1c','nf_get_var_text')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_1c
 
SUBROUTINE cdfr_0i(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  integer,           intent(out) ::  varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim(1) = 0
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'i',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_int(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_0i','nf_get_var_int')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_0i
 
SUBROUTINE cdfr_0l(ncid,varnam,varval,ier)
  ! Read scalar logical array
  !
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  logical,           intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer :: varval_i
  character*11, parameter :: logical_name = '__logical__'
 
  call cdfr_0i(ncid,trim(varnam)//logical_name,varval_i,ier)
 
  IF (varval_i == 0) THEN
     varval = .false.
  ELSE
     varval = .true.
  END IF
END SUBROUTINE cdfr_0l
 
SUBROUTINE cdfr_0d(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r8),     intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim(1) = 0
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_double(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_0d','nf_get_var_double')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_0d
SUBROUTINE cdfr_0c16(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r8),     intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
 
  if (PRESENT (ier)) ier = 1
  ldim(1) = 2 ! Re/Im pair
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'d',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_double(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_0d','nf_get_var_double')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_0c16
SUBROUTINE cdfr_0f(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  REAL(KIND=r4),     intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
  if (PRESENT (ier)) ier = 1
  ldim(1) = 0
  call cdfgv(ncid,varnam,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_real(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_0f','nf_get_var_real')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_0f
SUBROUTINE cdfr_0c8(ncid,varnam,varval,ier)
  implicit none
  ! Input
  integer,       intent(in) :: ncid
  character*(*), intent(in) :: varnam
  ! Output
  COMPLEX(KIND=r4),     intent(out) :: varval
  integer, optional, intent(out) :: ier
  ! Local
  integer                 :: varid,  status
  integer, dimension(1)   :: dimlens,ldim
 
  if (PRESENT (ier)) ier = 1
  ldim(1) = 2 ! Re/Im pair
  call cdfgv(ncid,trim(varnam)//cmplx_name,varid,dimlens,ldim,'r',status)
  if (status .ne. 0) return
  !
  status = nf_get_var_real(ncid,varid,varval)
  call ezcdf_error(status,varnam,'cdfr_0f','nf_get_var_real')
  if (PRESENT (ier)) ier = status
END SUBROUTINE cdfr_0c8

END MODULE ezcdf_GenGet

!******************** START FILE SPLAAN.F90 ; GROUP TRKRLIB ******************
!-------------------------------------------
!  derived from Forsyth/Malcolm/Moler SPLINE.F90 -- different BC:
!  y'=0 at LHS of data interval (low index side)
!
!CCCCCCCCCCCCCC
subroutine splaan (N, X, Y, B, C, D)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer N
  real(fp) :: X(N), Y(N), B(N), C(N), D(N)
  !
  !  THE COEFFICIENTS B(I), C(I), AND D(I), I=1,2,...,N ARE COMPUTED
  !  FOR A CUBIC INTERPOLATING SPLINE FOR WHICH S'(X1)=0.
  !
  !    S(X) = Y(I) + B(I)*(X-X(I)) + C(I)*(X-X(I))**2 + D(I)*(X-X(I))**3
  !
  !    FOR  X(I) .LE. X .LE. X(I+1)
  !
  !  INPUT..
  !
  !    N = THE NUMBER OF DATA POINTS OR KNOTS (N.GE.2)
  !    X = THE ABSCISSAS OF THE KNOTS IN STRICTLY INCREASING ORDER
  !    Y = THE ORDINATES OF THE KNOTS
  !
  !  OUTPUT..
  !
  !    B, C, D  = ARRAYS OF SPLINE COEFFICIENTS AS DEFINED ABOVE.
  !
  !  USING  P  TO DENOTE DIFFERENTIATION,
  !
  !    Y(I) = S(X(I))
  !    B(I) = SP(X(I))
  !    C(I) = SPP(X(I))/2
  !    D(I) = SPPP(X(I))/6  (DERIVATIVE FROM THE RIGHT)
  !
  !CCCCCCCCCCCCCC
  !  THE ACCOMPANYING FUNCTION SUBPROGRAM  SEVAL  CAN BE USED
  !  TO EVALUATE THE SPLINE.
  !
  !
  integer NM1, IB, I
  real(fp) :: T
  !
  NM1 = N-1
  IF ( N .LT. 2 ) RETURN
  IF ( N .LT. 3 ) GO TO 50
  !
  !  SET UP TRIDIAGONAL SYSTEM
  !
  !  B = DIAGONAL, D = OFFDIAGONAL, C = RIGHT HAND SIDE.
  !
  D(1) = X(2) - X(1)
  C(2) = (Y(2) - Y(1))/D(1)
  DO I = 2, NM1
    D(I) = X(I+1) - X(I)
    B(I) = 2._fp*(D(I-1) + D(I))
    C(I+1) = (Y(I+1) - Y(I))/D(I)
    C(I) = C(I+1) - C(I)
  end do
  !
  !  END CONDITIONS.  THIRD DERIVATIVES AT  X(1)  AND  X(N)
  !  OBTAINED FROM DIVIDED DIFFERENCES
  !
  B(1)=2._fp*D(1)
  B(N) = -D(N-1)
  C(1) = 0._fp
  C(N) = 0._fp
  IF ( N .EQ. 3 ) GO TO 15
  C(1) = (Y(2)-Y(1))/D(1)
  C(N) = C(N-1)/(X(N)-X(N-2)) - C(N-2)/(X(N-1)-X(N-3))
  C(N) = -C(N)*D(N-1)**2/(X(N)-X(N-3))
  !
  !  FORWARD ELIMINATION
  !
15 DO I = 2, N
    T = D(I-1)/B(I-1)
    B(I) = B(I) - T*D(I-1)
    C(I) = C(I) - T*C(I-1)
  end do
  !
  !  BACK SUBSTITUTION
  !
  C(N) = C(N)/B(N)
  DO IB = 1, NM1
    I = N-IB
    C(I) = (C(I) - D(I)*C(I+1))/B(I)
  end do
  !
  !  C(I) IS NOW THE SIGMA(I) OF THE TEXT
  !
  !  COMPUTE POLYNOMIAL COEFFICIENTS
  !
  B(N) = (Y(N) - Y(NM1))/D(NM1) + D(NM1)*(C(NM1) + 2._fp*C(N))
  DO I = 1, NM1
    B(I) = (Y(I+1) - Y(I))/D(I) - D(I)*(C(I+1) + 2._fp*C(I))
    D(I) = (C(I+1) - C(I))/D(I)
    C(I) = 3._fp*C(I)
  end do
  C(N) = 3._fp*C(N)
  D(N) = D(N-1)
  RETURN
  !
50 B(1) = (Y(2)-Y(1))/(X(2)-X(1))
  C(1) = 0._fp
  D(1) = 0._fp
  B(2) = B(1)
  C(2) = 0._fp
  D(2) = 0._fp
  return
end subroutine splaan

subroutine ezcdf_error(status,nam3,nam1,nam2)
  include "netcdf.inc"
  INTEGER, intent(in) :: status
  character*(*), intent(in) :: nam1, nam2, nam3
  if (status .ne. nf_noerr) then
     WRITE(*,10) trim(nam1),trim(nam2),trim(nam3)
10   format('% ',a,'--E-- A netCDF error has occurred in: ' ,a/      &
          &          'while processing: ',a)
     print *, nf_strerror(status)
  endif
end subroutine ezcdf_error

subroutine wclock_diff(ivals_start, ivals_end, t_seconds_r4)

  ! single precision version -- compute elapsed wall clock time, from
  ! two time stamps, in seconds

  ! for full comments see the R8 precision version, below...

  implicit NONE

  !--------------------
  ! INPUT:

  integer, dimension(8), intent(in) :: ivals_start  ! start time
  !  (returned from f90 date_and_time call)

  integer, dimension(8), intent(in) :: ivals_end    ! stop time
  !  (returned from f90 date_and_time call)

  real, intent(out) :: t_seconds_r4
  !  elapsed wall clock time (seconds)

  !------------------------
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  real(kind=R8) :: t_seconds_r8
  !------------------------

  call wclock_diff_r8(ivals_start,ivals_end,t_seconds_r8)
  t_seconds_r4 = t_seconds_r8

end subroutine wclock_diff

subroutine wclock_diff_r8(ivals_start, ivals_end, t_seconds)
  
  ! subroutine to difference integer data from two calls to f90 intrinsic 
  ! routine DATE_AND_TIME:
  !   integer, dimension(8) :: ivals
  !   call DATE_AND_TIME(values=ivals)  On Sept. 25, 2007 at 9:26:15.794 am
  !      ivals(1) = year, e.g.   2007
  !      ivals(2) = month, e.g.  9
  !      ivals(3) = day, e.g.    25
  !      ivals(4) = (time zone adjustment, ignored)
  !      ivals(5) = hour, e.g.   9
  !      ivals(6) = minute, e.g. 26
  !      ivals(7) = second, e.g. 15
  !      ivals(8) = msecs, e.g.  794

  ! contained routine wclock_diff returns the elapsed time between two
  ! calls to DATE_AND_TIME, the data captured in separate 8 word integer
  ! arrays.  The elapsed time can be returned in units specified by the
  ! user:  seconds, minutes, hours, days, years (assuming 365.25 days/year)
  !        or months (years*12.0).

  ! ACCURACY: the module assumes a leap year once every 4 years; millenial
  ! corrections are ignored (a later version may take this into account).

  ! NOTE also: for now, ivals(4) (time zone adjustment) is IGNORED; it is
  ! assumed without checking that the time zone adjustment is unchanged 
  ! in the two time stamps being compared.

  ! DMC 25 Sep 2007
  !-------------------------------

  implicit NONE

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  real*8, parameter :: dpyav = 365.25_R8 ! days/year (approx.)

  real*8, parameter :: x1000 = 1000.0_R8 ! msecs/sec
  real*8, parameter :: x1000th = 0.001_R8 ! secs/msec
  real*8, parameter :: x60   = 60.0_R8   ! minutes/hour, seconds/minute
  real*8, parameter :: x24   = 24.0_R8   ! hours/day
  real*8, parameter :: x12   = 12.0_R8   ! months/year

  real*8, parameter :: x100  = 100.0_R8
  real*8, parameter :: ONE   = 1.0_R8
  real*8, parameter :: ZERO  = 0.0_R8

  ! normal year days/month

  integer, dimension(12), parameter :: dpmon_norm = &
       (/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)

  ! leap year days/month

  integer, dimension(12), parameter :: dpmon_leap = &
       (/ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)

  !--------------------
  ! INPUT:

  integer, dimension(8), intent(in) :: ivals_start  ! start time
  !  (returned from f90 date_and_time call)

  integer, dimension(8), intent(in) :: ivals_end    ! stop time
  !  (returned from f90 date_and_time call)

  !--------------------
  ! OUTPUT:  

  real(kind=R8), intent(out) :: t_seconds  ! elapsed time in seconds

  !--------------------
  ! LOCAL:
  integer ia1(8),ia2(8),isign,iyear
  real(kind=R8) :: zh1,zh2
  real(kind=r8) :: zs1,zs2
  real(kind=r8) :: tdiff,daysum,tot_day1,day1,day2
  real(kind=r8) :: tdiff_hours

  !--------------------
  !  first see if ivals_start is BEFORE or AFTER 

  isign = 0

  do
     zh1 = x1000*x1000*ivals_start(1) + x100*x100*ivals_start(2) + &
          x100*ivals_start(3) + ONE*ivals_start(5)

     zh2 = x1000*x1000*ivals_end(1) + x100*x100*ivals_end(2) + &
          x100*ivals_end(3) + ONE*ivals_end(5)

     if(zh1.gt.zh2) then
        isign = -1
        ia1 = ivals_end
        ia2 = ivals_start

     else if(zh1.lt.zh2) then
        isign = 1
        ia1 = ivals_start
        ia2 = ivals_end

     else
        zs1= x60*ivals_start(6) + ONE*ivals_start(7) + ivals_start(8)/x1000
        zs2= x60*ivals_end(6) + ONE*ivals_end(7) + ivals_end(8)/x1000

        if(zs1.gt.zs2) then
           isign = -1
           ia1 = ivals_end
           ia2 = ivals_start

        else if(zs1.lt.zs2) then
           isign = 1
           ia1 = ivals_start
           ia2 = ivals_end

        else
           isign = 1
           tdiff = ZERO
           exit ! the two times are identical...
        endif
     endif

     !  OK the two times are in ia1 & ia2
     !  ia1 guaranteed earlier than ia2.

     day1 = days_in(ia1) ! days into the year ia1(1)
     day2 = days_in(ia2) ! days into the year ia2(2)

     if(ia1(1).eq.ia2(1)) then
        !  two time stamps in SAME year
        tdiff = day2-day1
        exit
     endif

     daysum = ZERO

     !  first count days in complete years between the two times...

     do iyear = ia1(1)+1,ia2(1)-1
        if(leap(iyear)) then
           daysum = daysum + ONE*366
        else
           daysum = daysum + ONE*365
        endif
     enddo
     
     !  number of days in year containing 1st time stamp
     if(leap(ia1(1))) then
        tot_day1 = ONE*366
     else
        tot_day1 = ONE*365
     endif

     !  two time stamps in DIFFERENT years
     tdiff = daysum + (tot_day1 - day1) + day2
     exit
  enddo

  !-------------------------
 
  t_seconds = isign*tdiff*x24*x60*x60

  contains
    ! PRIVATE routines
    
    !--------------------------------
    logical function leap(iyear)

      !  return T if leap year (every 4th year)

      !----------------
      integer, intent(in) :: iyear
      !----------------

      !----------------
      integer :: iy4
      !----------------

      iy4 = iyear/4
      iy4 = iy4*4

      leap = (iy4.eq.iyear)

    end function leap

    !--------------------------------
    real(kind=R8) function days_in(ia8)
      
      !  return the time into the year ia8(1) in time stamp ia8(1:8), in days

      !----------------
      integer, intent(in) :: ia8(8)
      !----------------

      !----------------
      real(kind=R8) :: dsum
      integer, dimension(12) :: montab
      integer :: imon
      !----------------

      if(leap(ia8(1))) then
         montab = dpmon_leap
      else
         montab = dpmon_norm
      endif

      ! count full months prior to month of time stamp

      dsum = ZERO
      do imon = 1,ia8(2)-1
         dsum = dsum + ONE*montab(imon)
      enddo

      ! add in the number of days of month of time stamp

      dsum = dsum + ONE*ia8(3)

      ! +hours

      dsum = dsum + ia8(5)/x24

      ! +minutes

      dsum = dsum + ia8(6)/(x24*x60)

      ! +seconds + msecs

      dsum = dsum + (ONE*ia8(7) + x1000th*ia8(8))/(x24*x60*x60)

      !-------------

      days_in = dsum

    end function days_in

end subroutine wclock_diff_r8

subroutine xlookup(ivec,xvec,nx,xpkg,imode,iv,dxn,hv,hiv,iwarn)

  !  vector lookup routine
  !
  !   given a set of x points xvec(...) and an x grid (xpkg, nx x pts)
  !   return the vector of indices iv(...) and displacements dxv(...)
  !   within the indexed zones, corresponding to each x point.
  !
  !   if any of the x points in the vector are out of range the warning
  !   flag iwarn is set.
  !
  !  MOD DMC Feb 2010: changes related to supporting nx=2 and nx=3 small grids.
  !  Changes are consistent with Feb 2010 changes in genxpkg:
  !    meanings of xpkg(1,4) and xpkg(3,4) interchanged.
  !
  !    if nx.eq.2:  xpkg(3,4) and xpkg(4,4) never referenced;
  !    if nx.eq.3:  xpkg(4,4) never referenced.
  !
  !  input:
  use iso_c_binding, only: fp => c_double
  implicit none
  integer inum,istat,ilin,ialg,iper,imsg,init_guess,iprev,i
  integer init,iprob,isrch,i_sign,inc
  real(kind=fp) :: stat,ztola,period,hav,havi,hloci,hloc,zdelta,xfac
  REAL(kind=fp) :: zindx0,zdindx,zindex
  !============
  integer ivec                      ! size of vector
  real(kind=fp) :: xvec(ivec)       ! x points to lookup on xpkg grid
  integer nx                        ! size of grid
  real(kind=fp) :: xpkg(nx,4)       ! grid data
  integer imode                     ! output control flag
  !  imode=1:  return indices iv(...) and un-normalized displacements dxn(...)
  !            ignore hv and hiv
  !                 dxn(j)=xvec(j)-xpkg(iv(j),1)
  !
  !  imode=2   return indices iv(...) and *normalized* displacements dxn(...)
  !            and hv(...) and hiv(...)
  !                 dxn(j)=(xvec(j)-xpkg(iv(j),1))*hiv(j)
  !
  !  output:
  integer iv(ivec)                  ! index into grid for each xvec(j)
  !  note: old values of iv(...) may be used as start point for grid
  !  searches, depending on xpkg controls
  real(fp) :: dxn(ivec)        ! displacement w/in zone (see imode)
  real(fp) :: hv(ivec)         ! zone width (if imode=2)
  real(fp) :: hiv(ivec)        ! inverse zone width (if imode=2)
  integer iwarn                     ! =0: OK; =n:  n points out of range

  !  xpkg is a "structure" constructed by subroutine genxpkg, which
  !  contains the x grid, xpkg(1:nx,1), spacing and error handling
  !  information -- see genxpkg.f90

  real(fp), dimension(:), allocatable :: xuse
  logical, dimension(:), allocatable :: iok
  integer, dimension(:), allocatable :: imina,imaxa

  if(nx.lt.2) then
     iwarn=1
     write(6,*) ' ?? xlookup: nx.lt.2, nx=',nx
     go to 1100
  end if

  inum=ivec
  allocate(xuse(inum),stat=istat)
  if(istat.ne.0) then
     iwarn=1
     write(6,*) ' ?? xlookup "xuse" vector allocation failure!'
     go to 1000
  end if

  if(nx.eq.2) then
     ilin=1
  end if

  if(nx.gt.2) then
     if(xpkg(3,4).eq.0.0_fp) then
        ilin=1              ! evenly spaced grid
     else
        ilin=0
        if(xpkg(3,4).gt.2.5_fp) then
           ialg=3
        else if(xpkg(3,4).gt.1.5_fp) then
           ialg=2
        else
           ialg=1
        end if
     end if
  end if

  if(xpkg(2,4).ne.0.0_fp) then
     iper=1                         ! periodic grid
  else
     iper=0
  end if

  ztola=abs(xpkg(1,4))              ! tolerance for range checking

  if(xpkg(1,4).ge.0.0_fp) then
     imsg=1                         ! write message on range error
  else
     imsg=0
  end if

  init_guess=0
  if(nx.gt.3) then
     if(xpkg(4,4).gt.0.0_fp) then
        init_guess=1
        iprev=min((nx-1),max(1,iv(ivec)))
     else
        init_guess=0
     end if
  end if

  iwarn=0

  !---------------------
  !  range check
  !
  if(iper.eq.0) then
     !
     !  check min/max with tolerance
     !
     do i=1,ivec
        if(xvec(i).lt.xpkg(1,1)) then
           xuse(i)=xpkg(1,1)
           if((xpkg(1,1)-xvec(i)).gt.ztola) iwarn=iwarn+1
        else if(xvec(i).gt.xpkg(nx,1)) then
           xuse(i)=xpkg(nx,1)
           if((xvec(i)-xpkg(nx,1)).gt.ztola) iwarn=iwarn+1
        else
           xuse(i)=xvec(i)
        end if
     end do

  else

     ! normalize to interval
     period=xpkg(nx,1)-xpkg(1,1)
     do i=1,ivec
        if((xvec(i).lt.xpkg(1,1)).or.(xvec(i).gt.xpkg(nx,1))) then
           xuse(i)=mod(xvec(i)-xpkg(1,1),period)
           if(xuse(i).lt.0.0_fp) xuse(i)=xuse(i)+period
           xuse(i)=xuse(i)+xpkg(1,1)
           xuse(i)=max(xpkg(1,1),min(xpkg(nx,1),xuse(i)))
        else
           xuse(i)=xvec(i)
        end if
     end do

  end if

  if((imsg.eq.1).and.(iwarn.gt.0)) then
     write(6,*) ' %xlookup:  ',iwarn,' points not in range: ', &
          xpkg(1,1),' to ',xpkg(nx,1)
  end if

  !---------------------
  !  actual lookup -- initially, assume even spacing
  !
  !   initial index guess:  1 + <1/h>*(x-x0) ... then refine
  !
  hav=xpkg(nx,2)
  havi=xpkg(nx,3)
  if(ilin.eq.1) then
     !
     !  faster lookup OK:  even spacing
     !
     if(init_guess.eq.0) then
        !
        !  even spacing lookup, no initial guess from previous iteration
        !
        do i=1,ivec
           iv(i)=1+havi*(xuse(i)-xpkg(1,1))
           iv(i)=max(1,min((nx-1),iv(i)))
           if(imode.eq.1) then
              dxn(i)=(xuse(i)-xpkg(iv(i),1))
           else
              dxn(i)=(xuse(i)-xpkg(iv(i),1))*havi
              hiv(i)=havi
              hv(i)=hav
           end if
        end do

     else
        !
        !  even spacing lookup, do use initial guess from previous iteration
        !
        do i=1,ivec
           if((xpkg(iprev,1).le.xuse(i)).and. &
                (xuse(i).le.xpkg(iprev+1,1))) then
              iv(i)=iprev
           else
              iv(i)=1+havi*(xuse(i)-xpkg(1,1))
              iv(i)=max(1,min((nx-1),iv(i)))
              iprev=iv(i)
           end if
           if(imode.eq.1) then
              dxn(i)=(xuse(i)-xpkg(iv(i),1))
           else
              dxn(i)=(xuse(i)-xpkg(iv(i),1))*havi
              hiv(i)=havi
              hv(i)=hav
           end if
        end do
     end if
     go to 1000
  end if

4 continue

  init=-1
  allocate(iok(inum),stat=istat)
  if(istat.ne.0) then
     iwarn=1
     write(6,*) ' ?? xlookup "iok" vector allocation failure!'
     go to 1000
  end if

  if(ialg.lt.3) then
     allocate(imina(inum),stat=istat)
     if(istat.ne.0) then
        iwarn=1
        write(6,*) ' ?? xlookup "imina" vector allocation failure!'
        go to 1000
     end if

     allocate(imaxa(inum),stat=istat)
     if(istat.ne.0) then
        iwarn=1
        write(6,*) ' ?? xlookup "imaxa" vector allocation failure!'
        go to 1000
     end if
  end if

5 continue                          ! re-entry -- hit problem cases...

  iprob=0                           ! count "problem" cases...
  init=init+1

  if(init_guess.eq.0) then
     go to (100,200,300) ialg
  else
     go to (150,250,350) ialg
  end if
  !-----------------------------------------------------------
  !  Newton like algorithm:  use local spacing to estimate
  !   step to next zone guess; don't use prior guess
  !
100 continue
  do i=1,ivec
     !
     !  first iteration
     !         
     if(init.eq.0) then
        iok(i)=.FALSE.
        imina(i)=1
        imaxa(i)=nx-1
        iv(i)=1+havi*(xuse(i)-xpkg(1,1))
        iv(i)=max(imina(i),min(imaxa(i),iv(i)))
        if(xuse(i).lt.xpkg(iv(i),1)) then
           isrch=0
           i_sign=-1
           imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           isrch=1
           i_sign=+1
           imina(i)=min((nx-1),(iv(i)+1))
        else
           iok(i)=.TRUE.
        end if
     end if
     !
     !  second iteration
     !
     if(.not.iok(i)) then
        hloci=xpkg(iv(i),3)
        hloc=xpkg(iv(i),2)
        zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
        if(i_sign*zdelta.le.hloc) then
           inc=i_sign
        else
           inc=zdelta*hloci
           inc=inc+i_sign
        end if
        iv(i)=iv(i)+inc
        iv(i)=max(imina(i),min(imaxa(i),iv(i)))
        if(xuse(i).lt.xpkg(iv(i),1)) then
           isrch=0
           i_sign=-1
           imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           isrch=1
           i_sign=+1
           imina(i)=min((nx-1),(iv(i)+1))
        else
           iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           hloci=xpkg(iv(i),3)
           hloc=xpkg(iv(i),2)
           zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
           if(i_sign*zdelta.le.hloc) then
              inc=i_sign
           else
              inc=zdelta*hloci
              inc=inc+i_sign
           end if
           iv(i)=iv(i)+inc
           iv(i)=max(imina(i),min(imaxa(i),iv(i)))
           if(xuse(i).lt.xpkg(iv(i),1)) then
              isrch=0
              i_sign=-1
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              isrch=1
              i_sign=+1
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              hloci=xpkg(iv(i),3)
              hloc=xpkg(iv(i),2)
              zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
              if(i_sign*zdelta.le.hloc) then
                 inc=i_sign
              else
                 inc=zdelta*hloci
                 inc=inc+i_sign
              end if
              iv(i)=iv(i)+inc
              iv(i)=max(imina(i),min(imaxa(i),iv(i)))
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 isrch=0
                 i_sign=-1
                 imaxa(i)=max(1,(iv(i)-1))
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 isrch=1
                 i_sign=+1
                 imina(i)=min((nx-1),(iv(i)+1))
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 hloci=xpkg(iv(i),3)
                 hloc=xpkg(iv(i),2)
                 zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
                 if(i_sign*zdelta.le.hloc) then
                    inc=i_sign
                 else
                    inc=zdelta*hloci
                    inc=inc+i_sign
                 end if
                 iv(i)=iv(i)+inc
                 iv(i)=max(imina(i),min(imaxa(i),iv(i)))
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    isrch=0
                    i_sign=-1
                    imaxa(i)=max(1,(iv(i)-1))
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    isrch=1
                    i_sign=+1
                    imina(i)=min((nx-1),(iv(i)+1))
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
  end do

  go to 500

  !-----------------------------------------------------------
  !  Newton like algorithm:  use local spacing to estimate
  !   step to next zone guess; DO use prior guess
  !
150 continue

  do i=1,ivec
     !
     !  first iteration
     !
     if(init.eq.0) then
        if((xpkg(iprev,1).le.xuse(i)).and. &
             (xuse(i).le.xpkg(iprev+1,1))) then
           iok(i)=.TRUE.
           iv(i)=iprev
        else
           iok(i)=.FALSE.
           imina(i)=1
           imaxa(i)=nx-1
           iv(i)=1+havi*(xuse(i)-xpkg(1,1))
           iv(i)=max(imina(i),min(imaxa(i),iv(i)))
           if(xuse(i).lt.xpkg(iv(i),1)) then
              isrch=0
              i_sign=-1
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              isrch=1
              i_sign=+1
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
        end if
     end if
     !
     !  second iteration
     !
     if(.not.iok(i)) then
        hloci=xpkg(iv(i),3)
        hloc=xpkg(iv(i),2)
        zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
        if(i_sign*zdelta.le.hloc) then
           inc=i_sign
        else
           inc=zdelta*hloci
           inc=inc+i_sign
        end if
        iv(i)=iv(i)+inc
        iv(i)=max(imina(i),min(imaxa(i),iv(i)))
        if(xuse(i).lt.xpkg(iv(i),1)) then
           isrch=0
           i_sign=-1
           imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           isrch=1
           i_sign=+1
           imina(i)=min((nx-1),(iv(i)+1))
        else
           iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           hloci=xpkg(iv(i),3)
           hloc=xpkg(iv(i),2)
           zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
           if(i_sign*zdelta.le.hloc) then
              inc=i_sign
           else
              inc=zdelta*hloci
              inc=inc+i_sign
           end if
           iv(i)=iv(i)+inc
           iv(i)=max(imina(i),min(imaxa(i),iv(i)))
           if(xuse(i).lt.xpkg(iv(i),1)) then
              isrch=0
              i_sign=-1
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              isrch=1
              i_sign=+1
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              hloci=xpkg(iv(i),3)
              hloc=xpkg(iv(i),2)
              zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
              if(i_sign*zdelta.le.hloc) then
                 inc=i_sign
              else
                 inc=zdelta*hloci
                 inc=inc+i_sign
              end if
              iv(i)=iv(i)+inc
              iv(i)=max(imina(i),min(imaxa(i),iv(i)))
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 isrch=0
                 i_sign=-1
                 imaxa(i)=max(1,(iv(i)-1))
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 isrch=1
                 i_sign=+1
                 imina(i)=min((nx-1),(iv(i)+1))
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 hloci=xpkg(iv(i),3)
                 hloc=xpkg(iv(i),2)
                 zdelta=(xuse(i)-xpkg(iv(i)+isrch,1))
                 if(i_sign*zdelta.le.hloc) then
                    inc=i_sign
                 else
                    inc=zdelta*hloci
                    inc=inc+i_sign
                 end if
                 iv(i)=iv(i)+inc
                 iv(i)=max(imina(i),min(imaxa(i),iv(i)))
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    isrch=0
                    i_sign=-1
                    imaxa(i)=max(1,(iv(i)-1))
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    isrch=1
                    i_sign=+1
                    imina(i)=min((nx-1),(iv(i)+1))
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
     iprev=iv(i)
  end do

  go to 500
  !-----------------------------------------------------------
  !  Binary search algorithm
  !
200 continue
  do i=1,ivec
     !
     !  first iteration
     !
     if(init.eq.0) then
        iok(i)=.FALSE.
        imina(i)=1
        imaxa(i)=nx-1
        iv(i)=nx/2
        if(xuse(i).lt.xpkg(iv(i),1)) then
           imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           imina(i)=min((nx-1),(iv(i)+1))
        else
           iok(i)=.TRUE.
        end if
      end if
      !
      !  second iteration
      !
      if(.not.iok(i)) then
        iv(i)=(imina(i)+imaxa(i))/2
        if(xuse(i).lt.xpkg(iv(i),1)) then
          imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
          imina(i)=min((nx-1),(iv(i)+1))
        else
          iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           iv(i)=(imina(i)+imaxa(i))/2
           if(xuse(i).lt.xpkg(iv(i),1)) then
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              iv(i)=(imina(i)+imaxa(i))/2
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 imaxa(i)=max(1,(iv(i)-1))
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 imina(i)=min((nx-1),(iv(i)+1))
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 iv(i)=(imina(i)+imaxa(i))/2
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    imaxa(i)=max(1,(iv(i)-1))
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    imina(i)=min((nx-1),(iv(i)+1))
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
  end do

  go to 500
  !-----------------------------------------------------------
  !  Binary search algorithm
  !
250 continue
  do i=1,ivec
     !
     !  first iteration
     !
     if(init.eq.0) then
        if((xpkg(iprev,1).le.xuse(i)).and. &
             (xuse(i).le.xpkg(iprev+1,1))) then
           iok(i)=.TRUE.
           iv(i)=iprev
        else
           iok(i)=.FALSE.
           imina(i)=1
           imaxa(i)=nx-1
           iv(i)=nx/2
           if(xuse(i).lt.xpkg(iv(i),1)) then
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
        end if
     end if
     !
     !  second iteration
     !
     if(.not.iok(i)) then
        iv(i)=(imina(i)+imaxa(i))/2
        if(xuse(i).lt.xpkg(iv(i),1)) then
           imaxa(i)=max(1,(iv(i)-1))
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           imina(i)=min((nx-1),(iv(i)+1))
        else
           iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           iv(i)=(imina(i)+imaxa(i))/2
           if(xuse(i).lt.xpkg(iv(i),1)) then
              imaxa(i)=max(1,(iv(i)-1))
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              imina(i)=min((nx-1),(iv(i)+1))
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              iv(i)=(imina(i)+imaxa(i))/2
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 imaxa(i)=max(1,(iv(i)-1))
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 imina(i)=min((nx-1),(iv(i)+1))
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 iv(i)=(imina(i)+imaxa(i))/2
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    imaxa(i)=max(1,(iv(i)-1))
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    imina(i)=min((nx-1),(iv(i)+1))
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
     iprev=iv(i)
  end do
  !
  go to 500
  !-----------------------------------------------------------
  !  algorithm:  piecewise linear indexing function lookup & correction
  !
300 continue
  do i=1,ivec
     !
     !  first iteration
     !
     if(init.eq.0) then
        iok(i)=.FALSE.
        !
        !  piecewise linear indexing function on even spaced grid
        !  (not same grid as x axis itself)
        !
        iv(i)=1+havi*(xuse(i)-xpkg(1,1))
        iv(i)=max(1,min(nx-1,iv(i)))
        xfac=(xuse(i)-(xpkg(1,1)+(iv(i)-1)*hav))*havi
        zindx0=xpkg(iv(i),2)
        if(iv(i).lt.nx-1) then
           zdindx=xpkg(iv(i)+1,2)-zindx0
        else
           zdindx=nx-zindx0
        end if
        zindex=zindx0+xfac*zdindx
        iv(i)=zindex
        iv(i)=max(1,min(nx-1,iv(i)))
        if(xuse(i).lt.xpkg(iv(i),1)) then
           i_sign=-1
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           i_sign=+1
        else
           iok(i)=.TRUE.
        end if
     end if
     !
     !  second iteration
     !
     if(.not.iok(i)) then
        iv(i)=iv(i)+i_sign
        if(xuse(i).lt.xpkg(iv(i),1)) then
           i_sign=-1
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           i_sign=+1
        else
           iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           iv(i)=iv(i)+i_sign
           if(xuse(i).lt.xpkg(iv(i),1)) then
              i_sign=-1
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              i_sign=+1
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              iv(i)=iv(i)+i_sign
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 i_sign=-1
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 i_sign=+1
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 iv(i)=iv(i)+i_sign
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    i_sign=-1
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    i_sign=+1
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
  end do

  go to 500
  !-----------------------------------------------------------
  !  algorithm:  piecewise linear indexing function lookup & correction
  !
350 continue
  do i=1,ivec
     !
     !  first iteration
     !
     if(init.eq.0) then
        if((xpkg(iprev,1).le.xuse(i)).and. &
             (xuse(i).le.xpkg(iprev+1,1))) then
           iok(i)=.TRUE.
           iv(i)=iprev
        else
           iok(i)=.FALSE.
           !
           !  piecewise linear indexing function on even spaced grid
           !  (not same grid as x axis itself)
           !
           iv(i)=1+havi*(xuse(i)-xpkg(1,1))
           iv(i)=max(1,min(nx-1,iv(i)))
           xfac=(xuse(i)-(xpkg(1,1)+(iv(i)-1)*hav))*havi
           zindx0=xpkg(iv(i),2)
           if(iv(i).lt.nx-1) then
              zdindx=xpkg(iv(i)+1,2)-zindx0
           else
              zdindx=nx-zindx0
           end if
           zindex=zindx0+xfac*zdindx
           iv(i)=zindex
           iv(i)=max(1,min(nx-1,iv(i)))
           if(xuse(i).lt.xpkg(iv(i),1)) then
              i_sign=-1
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              i_sign=+1
           else
              iok(i)=.TRUE.
           end if
        end if
     end if
     !
     !  second iteration
     !
     if(.not.iok(i)) then
        iv(i)=iv(i)+i_sign
        if(xuse(i).lt.xpkg(iv(i),1)) then
           i_sign=-1
        else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
           i_sign=+1
        else
           iok(i)=.TRUE.
        end if
        !
        !  third iteration
        !
        if(.not.iok(i)) then
           iv(i)=iv(i)+i_sign
           if(xuse(i).lt.xpkg(iv(i),1)) then
              i_sign=-1
           else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
              i_sign=+1
           else
              iok(i)=.TRUE.
           end if
           !
           !  fourth iteration
           !
           if(.not.iok(i)) then
              iv(i)=iv(i)+i_sign
              if(xuse(i).lt.xpkg(iv(i),1)) then
                 i_sign=-1
              else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                 i_sign=+1
              else
                 iok(i)=.TRUE.
              end if
              !
              !  fifth iteration
              !
              if(.not.iok(i)) then
                 iv(i)=iv(i)+i_sign
                 if(xuse(i).lt.xpkg(iv(i),1)) then
                    i_sign=-1
                 else if(xuse(i).gt.xpkg(iv(i)+1,1)) then
                    i_sign=+1
                 else
                    iok(i)=.TRUE.
                 end if
                 if(.not.iok(i)) iprob=iprob+1
                 !
                 !  end chain of iteration if-then-else blocks
                 !
              end if
           end if
        end if
     end if
     !
     !  end of loop
     !
     iprev=iv(i)
  end do

  go to 500
  !--------------------------------------------------------------------
  !  any "problems" left? if so, re-enter the loop...
  !
500 continue
  if(iprob.gt.0) go to 5
  !
  !  OK -- all zones found; complete output stats
  !
  if(imode.eq.1) then
     dxn=(xuse-xpkg(iv,1))          ! un-normalized
  else if(ialg.ne.3) then
     dxn=(xuse-xpkg(iv,1))*xpkg(iv,3) ! normalized to 1/h in each zone
     hv=xpkg(iv,2)
     hiv=xpkg(iv,3)
  else
     dxn=(xuse-xpkg(iv,1))*xpkg(iv,3) ! normalized to 1/h in each zone
     hv=xpkg(iv+1,1)-xpkg(iv,1)
     hiv=xpkg(iv,3)
  end if

  deallocate(iok)
  if(ialg.lt.3) then
     deallocate(imina)
     deallocate(imaxa)
  end if
  !
  !  all done -- generalized lookup
  !
1000 continue
  deallocate(xuse)

1100 continue
  return
end subroutine xlookup

subroutine EZspline_isGridRegular1(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_type
  use EZspline_obj
  implicit none
  type(EZspline1) :: spline_o
  ! ier:
  ! 14=x1 grid is not strictly increasing
  integer, intent(out) :: ier
  integer i

  ier = 0
  do i=1, spline_o%n1-1
     if(spline_o%x1(i+1) <= spline_o%x1(i)) then
        ier = 14
        return
     end if
  end do

end subroutine EZspline_isGridRegular1

subroutine EZspline_isGridRegular2(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) :: spline_o
  ! ier:
  ! 14=x1 grid is not strictly increasing
  ! 15=x2 grid is not strictly increasing
  integer, intent(out) :: ier
  integer i

  ier = 0
  do i=1, spline_o%n1-1
     if(spline_o%x1(i+1) <= spline_o%x1(i)) then
        ier = 14
        return
     end if
  end do
  do i=1, spline_o%n2-1
     if(spline_o%x2(i+1) <= spline_o%x2(i)) then
        ier = 15
        return
     end if
  end do

end subroutine EZspline_isGridRegular2


subroutine EZspline_isGridRegular3(spline_o, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) :: spline_o
  ! ier:
  ! 14=x1 grid is not strictly increasing
  ! 15=x2 grid is not strictly increasing
  ! 16=x3 grid is not strictly increasing
  integer, intent(out) :: ier
  integer i

  ier = 0
  do i=1, spline_o%n1-1
     if(spline_o%x1(i+1) <= spline_o%x1(i)) then
        ier = 14
        return
     end if
  end do
  do i=1, spline_o%n2-1
     if(spline_o%x2(i+1) <= spline_o%x2(i)) then
        ier = 15
        return
     end if
  end do
  do i=1, spline_o%n3-1
     if(spline_o%x3(i+1) <= spline_o%x3(i)) then
        ier = 16
        return
     end if
  end do

end subroutine EZspline_isGridRegular3

C-----------------------------------------------------------------------
C  VAX_GETARG -- VAX versions of Unix routines IARGC and GETARG
C    IARGC_VMS -- return count of command line arguments
C    GETARG_VMS -- return nth command line argument (blank delimitted)
C
C  On a VAX, programs using these routines must be invoked as
C  "foreign commands" -- See the VAX/VMS users' guide.
C
#if !__CRAY && !__X1 
C$	program vgtest
C
C$	character*32 zarg
C
C$	inum=iargc_vms()
C$	do i=1,inum
C$	  call getarg_vms(i,zarg)
C$	  write(6,1001) i,zarg
C$ 1001	  format(1x,' arg no. ',i2,' is:  ',a)
C$	enddo
C
C$	stop
C$	end
#endif
C-----------------------------------------------------------------------
      subroutine vax_getarg
C
C  read the command line with LIB$GET_FOREIGN
C
#ifdef __UNIX
      write(6,'('' ?vax_getarg called from unix.'')')
      return
#endif
C
#ifdef __VMS
      COMMON/VAXGETB/ ARGS
      CHARACTER*256 ARGS
C
      DATA ICALL/0/
C
C---------------------------------------
C
      if(icall.eq.0) then
        icall=1
        ARGS=' '
        istatl=lib$get_foreign(ARGS,,igot)
        if(istatl.ne.1) then
          write(6,'('' ?vax_getarg:  lib$get_foreign status='',i10)')
     >        istatl
          ARGS=' '
        else
          il=len(ARGS)
          if(igot.lt.il) ARGS(igot+1:il)=' '
        endif
      endif
      return
C
      end
C-----------------------------------------------------------------------
C
      integer function iargc_vms()
C
C  count command line arguments
C
      COMMON/VAXGETB/ ARGS
      CHARACTER*256 ARGS
C
      call vax_getarg
C
      istart=1
      icount=0
 10   continue
        call vax_nexarg(istart,ifin)
        if(istart.lt.0) go to 90
        icount=icount+1
        istart=ifin+1
      go to 10
C
 90   continue
      iargc_vms=icount
      return
      end
C-----------------------------------------------------------------------
C
      subroutine getarg_vms(inum,argv)
C
      character*(*) argv
C
C  fetch the inum'th command line argument
C
      COMMON/VAXGETB/ ARGS
      CHARACTER*256 ARGS
C
      call vax_getarg
C
      argv=' '
C
      istart=1
      icount=0
 10   continue
        call vax_nexarg(istart,ifin)
        if(istart.lt.0) go to 90
        icount=icount+1
        if(icount.eq.inum) then
          argv=ARGS(istart:ifin)
          go to 90
        endif
        istart=ifin+1
      go to 10
C
 90   continue
      return
      end
C-----------------------------------------------------------------------
C
      subroutine vax_nexarg(istart,ifin)
C
C  find the next command line argument
C    istart = place to start search (input)
C
C    istart = -1 if nothing found (output)
C    ARGS(istart:ifin) = argument found (if any) (output)
C
C
      COMMON/VAXGETB/ ARGS
      CHARACTER*256 ARGS
C
      CHARACTER*1 ZBLANK,ZTAB
C
C-----------------------------------------------
C
      ztab=char(9)
      zblank=' '
C
      il=len(args)
C
      if(istart.gt.il) then
        istart=-1
        return
      endif
C
C  find non blank non tab character
C
      do ic=istart,il
        if((ARGS(ic:ic).ne.zblank).and.(ARGS(ic:ic).ne.ztab)) go to 10
      enddo
C
C  nothing found
C
      istart=-1
      return
C
C  something found
C
 10   continue
      istart=ic
C
C  find the end
C
      do ic=istart,il
        if((ARGS(ic:ic).eq.zblank).or.(ARGS(ic:ic).eq.ztab)) go to 20
      enddo
C
      ic=il+1
C
C  found the end
C
 20   continue
      ifin=ic-1
 
      return
#endif
      end

!******************** START FILE SEVAL3.F90 ; GROUP TRKRLIB ************
!
real(fp) FUNCTION seval3(N, U, X, Y, B, C, D, deriv, deriv2)
  use iso_c_binding, only: fp => c_double
  !============
  implicit none
  real(fp) :: deriv2,zslop
  !============
  integer N
  real(fp) ::  U, X(N), Y(N), B(N), C(N), D(N), deriv
  !
  !CCCCCCCCCCCCCC
  !CCCCCCCCCCCCCC
  !  THIS subroutine EVALUATES THE CUBIC SPLINE FUNCTION
  !
  !    SEVAL3 = Y(I) + B(I)*(U-X(I)) + C(I)*(U-X(I))**2 + D(I)*(U-X(I))**3
  !
  !  and the derivative
  !
  !    deriv = B(i) + 2*C(i)*(U-X(i)) + 3*D(i)*(U-X(i))**2
  !
  !  and the 2nd derivative
  !
  !    deriv2 = 2*C(i) + 6*D(i)*(U-X(i))
  !
  !  WHERE  X(I) .LT. U .LT. X(I+1), USING HORNER'S RULE
  !
  !  IF  U .LT. X(1) THEN  I = 1  IS USED.
  !  IF  U .GE. X(N) THEN  I = N  IS USED.
  !
  !  INPUT..
  !
  !    N = THE NUMBER OF DATA POINTS
  !    U = THE ABSCISSA AT WHICH THE SPLINE IS TO BE EVALUATED
  !    X,Y = THE ARRAYS OF DATA ABSCISSAS AND ORDINATES
  !    B,C,D = ARRAYS OF SPLINE COEFFICIENTS COMPUTED BY SPLINE
  !
  !  IF  U  IS NOT IN THE SAME INTERVAL AS THE PREVIOUS CALL, THEN A
  !  BINARY SEARCH IS PERFORMED TO DETERMINE THE PROPER INTERVAL.
  !
  integer I, J, K, ILIN
  real(fp) :: DX
  DATA I/1/
  DATA ILIN/0/
  !
  IF ( I .GE. N ) I = 1
  IF ( U .LT. X(I) ) GO TO 10
  IF ( U .LE. X(I+1) ) GO TO 30
  !
  !  BINARY SEARCH
  !
10 I = 1
  J = N+1
20 K = (I+J)/2
  IF ( U .LT. X(K) ) J = K
  IF ( U .GE. X(K) ) I = K
  IF ( J .GT. I+1 ) GO TO 20
  !
  !  EVALUATE SPLINE
  !
30 DX = U - X(I)
  IF(ILIN.EQ.0) THEN
     seval3 = Y(I) + DX*(B(I) + DX*(C(I) + DX*D(I)))
     deriv = B(i) + DX*(2.0_fp*C(i) + DX*3.0_fp*D(i))
     deriv2 = 2.0_fp*C(i) + DX*6.0_fp*D(i)
  ELSE
     IF(I.EQ.N) THEN
        ZSLOP=(Y(N)-Y(N-1))/(X(N)-X(N-1))
     ELSE
        ZSLOP=(Y(I+1)-Y(I))/(X(I+1)-X(I))
     end if
     seval3=Y(I)+DX*ZSLOP
     deriv=ZSLOP
     deriv2=0.0_fp
  end if
  !
  RETURN
END FUNCTION seval3
!******************** END FILE SEVAL3.F90 ; GROUP TRKRLIB **************

!  PSPLINE -- modified from SPLINE.F90 -- dmc 3 Oct 1995
!
!	THE CODES (SPLINE & SEVAL) ARE TAKEN FROM:
!	FORSYTHE,MALCOLM AND MOLER, "COMPUTER METHODS FOR
!	MATHEMATICAL COMPUTATIONS",PRENTICE-HALL, 1977.
!
!  PSPLINE -- periodic spline -- adaptation of SPLINE.F90 by D. McCune
!  October 1995:  The function to be splined is taken as having periodic
!  derivatives (it need not be periodic itself), so that
!  the interpolating function satisfies
!            y'(x(1))=y'(x(N))
!           y''(x(1))=y''(x(N))
!  this results in a fully specified system (no addl BC assumptions
!  required); it is not a tridiagonal system but a modified NM1xNM1
!  tridiagonal system with non-zero offdiagonal corner (1,NM1), (NM1,1)
!  elements.  It remains symmetric & diagonally dominant, and is
!  solved by Gaussian elimination w/o pivoting.  NM1=N-1.
!
subroutine pspline (N, X, Y, B, C, D, WK)
  use iso_c_binding, only: fp => c_double
  !============
  implicit none
  real(fp) :: q
  !============
  integer N
  real(fp) :: X(N), Y(N), B(N), C(N), D(N), WK(N)
  !
  !  THE COEFFICIENTS B(I), C(I), AND D(I), I=1,2,...,N ARE COMPUTED
  !  FOR A periodic CUBIC INTERPOLATING SPLINE
  !
  !    S(X) = Y(I) + B(I)*(X-X(I)) + C(I)*(X-X(I))**2 + D(I)*(X-X(I))**3
  !
  !    FOR  X(I) .LE. X .LE. X(I+1)
  !
  !    WK(...) is used as a workspace during the Guassian elimination.
  !    it represents the rightmost column of the array
  !
  !    note B(N),C(N),D(N) give coeffs for a periodic continuation into
  !    the next period, up to X(N)+(X(2)-X(1)) only.
  !
  !    SEVAL can be used to evaluate the spline, but, it is up to the
  !    SEVAL caller to bring the argument into the normal range X(1) to X(N).
  !
  !  INPUT..
  !
  !    N = THE NUMBER OF DATA POINTS OR KNOTS (N.GE.2)
  !        includes a complete period of the data, the last point being
  !        a repeat of the first point.
  !    X = THE ABSCISSAS OF THE KNOTS IN STRICTLY INCREASING ORDER
  !        X(N)-X(1) is the period of the periodic function represented.
  !    Y = THE ORDINATES OF THE KNOTS
  !
  !  OUTPUT..
  !
  !    B, C, D  = ARRAYS OF SPLINE COEFFICIENTS AS DEFINED ABOVE.
  !
  !  USING  P  TO DENOTE DIFFERENTIATION,
  !
  !    Y(I) = S(X(I))
  !    B(I) = SP(X(I))
  !    C(I) = SPP(X(I))/2
  !    D(I) = SPPP(X(I))/6  (DERIVATIVE FROM THE RIGHT)
  !
  !CCCCCCCCCCCCCC
  !  THE ACCOMPANYING FUNCTION SUBPROGRAM  SEVAL  CAN BE USED
  !  TO EVALUATE THE SPLINE.
  !
  !
  integer NM1, NM2, IB, I
  real(fp) :: T
  !
  !-------------------------------------
  !
  NM1 = N-1
  NM2 = NM1-1
  !
  IF ( N .LT. 4 ) THEN
    write(6,9901)
9901 format(/ &
         ' ?PSPLINE -- at least 4 pts required for periodic spline.')
    return
  end if
  !
  !  SET UP MODIFIED NM1 x NM1 TRIDIAGONAL SYSTEM:
  !  B = DIAGONAL, D = OFFDIAGONAL, C = RIGHT HAND SIDE.
  !  WK(1:NM2) = rightmost column above diagonal
  !  WK(NM1)   = lower left corner element
  !
  D(1) = X(2) - X(1)
  D(NM1) = X(N) - X(NM1)
  B(1) = 2.0_fp*(D(1)+D(NM1))
  C(1) = (Y(N) - Y(NM1))/D(NM1)
  C(2) = (Y(2) - Y(1))/D(1)
  C(1) = C(2) - C(1)
  WK(1) = D(NM1)
  DO I = 2, NM1
    D(I) = X(I+1) - X(I)
    B(I) = 2._fp*(D(I-1) + D(I))
    C(I+1) = (Y(I+1) - Y(I))/D(I)
    C(I) = C(I+1) - C(I)
    WK(I) = 0.0_fp
  end do
  WK(NM2) = D(NM2)
  WK(NM1) = D(NM1)
  !
  !  END CONDITIONS -- implied by periodicity
  !     C(1)=C(N)  B(1)=B(N)  D(1)=D(N) -- no additional assumption needed.
  !
  !  FORWARD ELIMINATION
  !   WK(1)--WK(NM2) represent the rightmost column above the
  !   diagonal; WK(NM1) represents the non-zero lower left corner element
  !   which in each step is moved one column to the right.
  !
15 DO I = 2, NM2
    T = D(I-1)/B(I-1)
    B(I) = B(I) - T*D(I-1)
    C(I) = C(I) - T*C(I-1)
    WK(I) = WK(I) - T*WK(I-1)
    Q = WK(NM1)/B(I-1)
    WK(NM1) = -Q*D(I-1)
    B(NM1) = B(NM1) - Q*WK(I-1)
    C(NM1) = C(NM1) - Q*C(I-1)
  end do
  !
  !  correct the (NM1,NM2) element
  !
  WK(NM1) = WK(NM1) + D(NM2)
  !
  !  complete the forward elimination:  now WK(NM1) and WK(NM2) are
  !  the off diagonal elements of the 2x2 at the lower right hand corner
  !
  T = WK(NM1)/B(NM2)
  B(NM1) = B(NM1) - T*WK(NM2)
  C(NM1) = C(NM1) - T*C(NM2)
  !
  !  BACK SUBSTITUTION
  !
  C(NM1) = C(NM1)/B(NM1)
  C(NM2) = (C(NM2) - WK(NM2)*C(NM1))/B(NM2)
  !
  DO IB = 3, NM1
    I = N-IB
    C(I) = (C(I) - D(I)*C(I+1) - WK(I)*C(NM1))/B(I)
  end do
  !
  !  PERIODICITY:
  !
  C(N)=C(1)
  !
  !  C(I) IS NOW THE SIGMA(I) OF THE TEXT
  !
  !  COMPUTE POLYNOMIAL COEFFICIENTS
  !
  DO I = 1, NM1
    B(I) = (Y(I+1) - Y(I))/D(I) - D(I)*(C(I+1) + 2._fp*C(I))
    D(I) = (C(I+1) - C(I))/D(I)
    C(I) = 3._fp*C(I)
  end do
  ! periodic continuation...
  B(N) = B(1)
  C(N) = C(1)
  D(N) = D(1)
  !
  return
end subroutine pspline

      integer function ncvid(idum)
c
      character*70 msg
      data msg/
     >   '?? dummy integer function ncvid called (generic_dummy lib)'/
c
      write(6,'(A)') msg
      ncvid=0
      return
      end
c-------------------------------------
      integer function nctlen(idum)
c
      character*70 msg
      data msg/
     >   '?? dummy integer function nctlen called (generic_dummy lib)'/
c
      write(6,'(A)') msg
      nctlen=0
      return
      end
c-------------------------------------
      integer function ncsfil(idum)
c
      character*70 msg
      data msg/
     >   '?? dummy integer function ncsfil called (generic_dummy lib)'/
c
      write(6,'(A)') msg
      ncsfil=0
      return
      end
c-------------------------------------

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Return error if original grid is not strictly increasing

#include "cpp/czspline_handle_size.h"

#define _S czspline_isgridregular1
#define _O czspline1
#include "czspline_isgridregular.h"
#undef _S
#undef _O

#define _S czspline_isgridregular2
#define _O czspline2
#include "czspline_isgridregular.h"
#undef _S
#undef _O

#define _S czspline_isgridregular3
#define _O czspline3
#include "czspline_isgridregular.h"
#undef _S
#undef _O

SUBROUTINE find_io_unit(ilun)

  ! Return next available Fortran I/O Unit Specifier

  ! unit number returned in range MIN_ILUN (120) to MAX_ILUN (999)
  ! return ilun = -1 if none are available but it is probably not
  ! possible for ~1000 files to be open simultaneously for other system 
  ! reasons... (note: MIN_ILUN increased to 120 as pathscale compiler
  ! reserves units 100:102 and perhaps others will as well).

  IMPLICIT none
  INTEGER, INTENT(OUT) :: ilun
  LOGICAL :: open
  INTEGER, PARAMETER :: MIN_ILUN=120, MAX_ILUN=999

  integer :: iu,ifound

  ilun = -1
  ifound = 0

  DO iu=MIN_ILUN, MAX_ILUN
     INQUIRE(UNIT=iu, OPENED=open)
     IF (.NOT. open) THEN
        ifound=1
        EXIT
     ENDIF
  END DO

  if(ifound.eq.1) ilun = iu

END SUBROUTINE find_io_unit

SUBROUTINE find_io_unit_list(n,ilun_list)

  ! Return next N available Fortran I/O Unit Specifiers

  ! unit number returned in range MIN_ILUN (120) to MAX_ILUN (999)
  ! return ilun_list(j)=-1 if none are available for #j and up.

  IMPLICIT none
  INTEGER, INTENT(IN)  :: n  ! number of available LUNs desired.
  INTEGER, INTENT(OUT) :: ilun_list(n)
  LOGICAL :: open
  INTEGER, PARAMETER :: MIN_ILUN=120, MAX_ILUN=999

  integer :: iu,ifound

  ilun_list(1:n) = -1
  ifound = 0

  DO iu=MIN_ILUN, MAX_ILUN
     INQUIRE(UNIT=iu, OPENED=open)
     IF (.NOT. open) THEN
        ifound=ifound+1
        ilun_list(ifound) = iu
        if(ifound.eq.n) exit
     ENDIF
  END DO

END SUBROUTINE find_io_unit_list

	subroutine f90_link1
C
C  this is a token f90 routine.  In mixed f77/f90 environments, sometimes
C  an actual f90 routine must be linked, in order for the load process to
C  go correctly.
C
C  in portlib this is called out of "err_end".
C
      integer ivals(8)
C
      character*8 zzdate
      character*10 ztime
      character*5 zone
C
      call date_and_time(zzdate,ztime,zone,ivals)
      if(ivals(2).gt.12) write(6,1001) ivals(2)
 1001	format(' f90_link1:  ?? month .gt. 12:  ',i10)
C
      return
      end

      subroutine get_arg(i,arg)
C
C  return i'th argument on the command line.
C
#ifdef __NAGWARE
      use f90_unix_env
#endif
      implicit none
      integer i                         ! argument wanted (in)
      character*(*) arg                 ! i'th argument returned (out)
C
#ifdef __VMS
      call getarg_vms(i,arg)
#endif
 
#ifdef __UNIX
      integer j
 
#if __CRAY || __X1
      integer len,ierr
#endif
 
      j=i
 
c 06/30/00 CAL: not available with f90; is fort77 ?
ccc#if __HP
ccc      call igetarg(j,arg,len(arg))
ccc#elif __CRAY
#if __CRAY || __X1
      call pxfgetarg(j,arg,len,ierr)
#elif __ABS
      call getarg_(j,arg)
#else
      call getarg(j,arg)
#endif
 
#endif /* __UNIX */
 
      call str_pad(arg)
 
      return
      end
 
#ifdef __LF95

c
c  this compiler lacks FY-2003 routine -- attempt a patch...
c

      subroutine get_command_argument(i,arg)

      integer i                         ! argument wanted (in)
      character*(*) arg                 ! i'th argument returned (out)

      call get_arg(i,arg)

      return
      end

#endif

!/////
! R8 !
!/////
program drive
  !
  ! test drive for EZspline routines
  !
  ! A. Pletzer Mon Apr 24 08:33:20 EDT 2000
  !
  implicit none
  integer ier

  integer ier_count
  common/errors/ ier_count

  ier_count = 0

  write(0,*)'***********************************************'
  write(0,*)'* EZspline test drive using for _R8 precision *'
  write(0,*)'***********************************************'


  write(0,*)'This program performs 1-d, 2-d and 3-d data interpolation'
  write(0,*)'and derivative evaluations based on both spline and Akima'
  write(0,*)'Hermite representations. The Akima Hermite interpolation is'
  write(0,*)'a Hermite interpolation for which the derivatives of the'
  write(0,*)'function at the nodes are internally evaluated. Boundary '
  write(0,*)'conditions such as "not-a-knot", periodic, 1st and 2nd '
  write(0,*)'derivative imposed are tested, and so are interpolations'
  write(0,*)'performed on a set of isolated points, on a cloud of points'
  write(0,*)'and on a grid array of points (grid).'
  write(0,*)' '
  write(0,*)'If you have MATLAB installed on your system, you can view'
  write(0,*)'the interpolation results saved in the netCDF files *.nc'
  write(0,*)'provided you also have access to MEXCDF, a netCDF to MATLAB'
  write(0,*)'interface package freely available at'
  write(0,*)'http://crusty.er.usgs.gov/~cdenham/MexCDF/nc4ml5.html'
  write(0,*)'To run the MATLAB script ezspline_test.m, simply type'
  write(0,*)'"ezspline_test" at the matlab prompt.'

  write(0,*)''
  write(0,*)'> 1-D splines'
  write(0,*)''
  write(0,*)'>> not-a-knot boundary conditions'
  call spline1_not(ier)
  if(ier/=0) call err_count('**ERROR** in spline1_not')
  write(0,*)'>> periodic boundary conditions'
  call spline1_per(ier)
  if(ier/=0) call err_count('**ERROR** in spline1_per')
  write(0,*)'>> 1st derivative boundary conditions'
  call spline1_1st(ier)
  if(ier/=0) call err_count('**ERROR** in spline1_1st')
  write(0,*)'>> 2nd derivative boundary conditions'
  call spline1_2nd(ier)
  if(ier/=0) call err_count('**ERROR** in spline1_2nd')

  
  write(0,*)''
  write(0,*)'> 2-D splines'
  write(0,*)''
  write(0,*)'>> not-a-knot boundary conditions'
  call spline2_not(ier)
  if(ier/=0) call err_count('**ERROR** in spline2_not')
  write(0,*)'>> periodic boundary conditions'
  call spline2_per(ier)
  if(ier/=0) call err_count('**ERROR** in spline2_per')
  write(0,*)'>> mixed boundary conditions'
  call spline2_mix(ier)
  if(ier/=0) call err_count('**ERROR** in spline2_mix')

  write(0,*)''
  write(0,*)'> 3-D splines'
  write(0,*)''
  write(0,*)'>> mixed boundary conditions'
  call spline3_mix(ier)
  if(ier/=0) call err_count('**ERROR** in spline3_mix')
  write(0,*)'>> mixed boundary conditions 2'
  call spline3_mox(ier)
  if(ier/=0) call err_count('**ERROR** in spline3_mox')

  write(0,*)''
  write(0,*)'> 1-D Akima Hermite'
  write(0,*)''
  call akima1_not(ier)
  if(ier/=0) call err_count('**ERROR** in akima1_not')
  write(0,*)'>> periodic boundary conditions'
  call akima1_per(ier)
  if(ier/=0) call err_count('**ERROR** in akima1_per')

  write(0,*)''
  write(0,*)'> 2-D Akima Hermite'
  write(0,*)''
  call akima2_not(ier)
  if(ier/=0) call err_count('**ERROR** in akima2_not')
  write(0,*)'>> periodic boundary conditions'
  call akima2_per(ier)
  if(ier/=0) call err_count('**ERROR** in akima2_per')
  
  write(0,*)''
  write(0,*)'> 3-D Akima Hermite'
  write(0,*)''
  write(0,*)'>> mixed boundary conditions'
  call akima3_mix(ier)
  if(ier/=0) call err_count('**ERROR** in akima3_mix')

  write(0,*)''
  write(0,*)'> 1-D Piecewise Linear'
  write(0,*)''
  call pclin1(ier)
  if(ier/=0) call err_count('**ERROR** in pclin1')

  write(0,*)''
  write(0,*)'> 2-D Piecewise Linear'
  write(0,*)''
  call pclin2(ier)
  if(ier/=0) call err_count('**ERROR** in pclin2')

  write(0,*)''
  write(0,*)'> 3-D Piecewise Linear'
  write(0,*)''
  call pclin3(ier)
  if(ier/=0) call err_count('**ERROR** in pclin3')

  if(ier_count.eq.0) then
     stop ' *successful end of EZspline test drive*'
  else
     stop ' **ERRORS DETECTED** by end of EZspline test drive*'
  endif
end program drive

!------------------------------------------------
subroutine err_count(msg)

  implicit NONE
  character*(*), intent(in) :: msg

  integer ier_count
  common/errors/ ier_count

  write(0,*) msg
  ier_count = ier_count + 1

end subroutine err_count
!------------------------------------------------

! 
! 1-D SPLINE
!

!..........not a knot.....................................................
subroutine spline1_not(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ 0, 0 /)
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1

  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_isInDomain(spl,  x1_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation =>"spline1_not.nc" & "spline1_notx.nc" (exact)'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  f_cloudx = sin(x1_cloud)
  call EZspline_isInDomain(spl, k1, x1_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  
  call EZspline_2netCDF(k1, x1_cloud, f_cloud, 'spline1_not_.nc', ier)
  call EZspline_2netCDF(k1, x1_cloud, f_cloudx,'spline1_notx.nc', ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline1_not

!..........periodic........................................................
subroutine spline1_per(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ -1, -1 /) 
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation => "spline1_per.nc" & "spline1_perx.nc" (exact)'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  f_cloudx = sin(x1_cloud)
  call EZspline_2netCDF( k1, x1_cloud, f_cloud, 'spline1_per_.nc', ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline1_per

!..........1st derivative.....................................................
subroutine spline1_1st(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ 1, 1/)
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1
  spl%bcval1min = 1.0_r8
  spl%bcval1max = 1.0_r8

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation => "spline1_1st.nc" & "spline_1stx.nc" (exact)'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  f_cloudx = sin(x1_cloud)
  call EZspline_2netCDF(k1, x1_cloud, f_cloud, 'spline1_1st_.nc', ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline1_1st

!..........2nd derivative.....................................................
subroutine spline1_2nd(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1) &
           &   , fx_point, fx_pointx, fxx_point, fxx_pointx
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  real(r8) :: df,tmp
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ 2, 2/)
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1
  spl%bcval1min = 0.0_r8
  spl%bcval1max = 0.0_r8

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation => "spline1_2nd.nc" & "spline1_2nd.nc" (exact)'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  f_cloudx = sin(x1_cloud)
  call Ezspline_2netCDF( k1, x1_cloud, f_cloud, 'spline1_2nd_.nc', ier)

  write(0,*)' point derivative (x, fx, fx-exact, error)'
  x1_point  = twopi/2.23987563_r8
  fx_pointx = cos(x1_point)
  call EZspline_derivative(spl, 1, x1_point, fx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, fx_point, fx_pointx, &
       fx_point - fx_pointx

  write(0,*)' point derivative (x, fxx, fxx-exact, error)'
  fxx_pointx = -sin(x1_point)
  call EZspline_derivative(spl, 2, x1_point, fxx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, fxx_point, fxx_pointx, &
       fxx_point - fxx_pointx

  write(0,*)' gradient  (x, fx)'
  call EZspline_gradient(spl, x1_point, df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(2f10.6)') x1_point, df
  write(0,'(2f10.6)') x1_point, fx_pointx

  write(0,*)'save 1-D spline object in file "spline1.nc"'
  call EZspline_save(spl,"spline1.nc", ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  !  test eval after reload...
  tmp=df
  call EZspline_load(spl,"spline1.nc", ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  call EZspline_gradient(spl, x1_point, df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  if(df.ne.tmp) then
     write(0,*) ' ==> EZspline_gradient value change after save/load sequence:'
     write(0,'("     before, after: ",2(f10.6))') tmp,df
  endif

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline1_2nd

!! 
!! 2-D SPLINE
!!

!..........not a knot.....................................................
subroutine spline2_not(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx, &
       & fxx_point, fxx_pointx, fxy_point, fxy_pointx,  fyy_point, fyy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2)
  integer :: bcs1(2), bcs2(2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt
  real(r8) :: df(2)
  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ 0, 0/) ! not a knot
  bcs2 = (/ 0, 0/) ! not a knot
  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_isInDomain(spl,  x1_point, x2_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "spline2_not_c.nc" & "spline2_not_cx.nc" (exact)'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_isInDomain(spl,   k_cloud, x1_cloud, x2_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF( k_cloud, x1_cloud, x2_cloud, f_cloud, "spline2_not__c.nc", ier)
  call EZspline_2netCDF( k_cloud, x1_cloud, x2_cloud, f_cloudx,"spline2_notx_c.nc", ier)

  write(0,*)' array interpolation  => "spline2_not_a.nc" & "spline2_not_ax.nc" (exact)'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_isInDomain(spl,  k1, k2, x1_array, x2_array, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  call EZspline_2netCDF( k1, k2, x1_array, x2_array, f_array, "spline2_not__a.nc", ier)
  call EZspline_2netCDF( k1, k2, x1_array, x2_array, f_arrayx,"spline2_notx_a.nc", ier)
  
  write(0,*)' point derivative (x, y, fx, fx-exact, error)'
  fx_pointx = -2_r8*(1_r8 + Cos(x1_point) - Cos(x2_point))*Sin(x1_point)
  call EZspline_derivative(spl, 1, 0, x1_point, x2_point, fx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fx_point, fx_pointx, &
       fx_point - fx_pointx

  write(0,*)' point derivative (x, y, fy, fy-exact, error)'
  fy_pointx = 2_r8*(1_r8 + Cos(x1_point))*Sin(x2_point)
  call EZspline_derivative(spl, 0, 1, x1_point, x2_point, fy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fy_point, fy_pointx, &
       fy_point - fy_pointx

  write(0,*)' point derivative (x, y, fxx, fxx-exact, error)'
  fxx_pointx = -2_r8*(Cos(x1_point) + Cos(2_r8*x1_point) - Cos(x1_point)*Cos(x2_point))
  call EZspline_derivative(spl, 2, 0, x1_point, x2_point, fxx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fxx_point, fxx_pointx, &
       fxx_point - fxx_pointx

  write(0,*)' point derivative (x, y, fyy, fyy-exact, error)'
  fyy_pointx = 2.0_r8*(1.0_r8 + Cos(x1_point))*Cos(x2_point)
  call EZspline_derivative(spl, 0, 2, x1_point, x2_point, fyy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fyy_point, fyy_pointx, &
       fyy_point - fyy_pointx

  write(0,*)' point derivative (x, y, fxy, fxy-exact, error)'
  fxy_pointx = -2.0_r8*Sin(x1_point)*Sin(x2_point)
  call EZspline_derivative(spl, 1, 1, x1_point, x2_point, fxy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fxy_point, fxy_pointx, &
       fxy_point - fxy_pointx

  write(0,'(a,2f10.6)')' gradient (x, y, fx, fy)'
  call EZspline_gradient(spl, x1_point, x2_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return  
  write(0,'(4f10.6)') &
       & x1_point, x2_point, df(1), df(2)
  write(0,'(4f10.6)') &
       & x1_point, x2_point, fx_pointx, fy_pointx

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline2_not
  

!..........periodic.........................................................
subroutine spline2_per(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx, &
       & fxx_point, fxx_pointx, fxy_point, fxy_pointx,  fyy_point, fyy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2)
  integer :: bcs1(2), bcs2(2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ -1, -1/) ! periodic
  bcs2 = (/ -1, -1/) ! periodic
  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2
  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "spline2_per_c.nc" & "spline2_per_cx.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, f_cloud, "spline2_per__c.nc", ier)

  write(0,*)' array interpolation "spline2_per_a.nc" & "spline2_per_ax.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, x1_array, x2_array, f_array, "spline2_per__a.nc", ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline2_per


!..........mixed BCs............................................................
subroutine spline2_mix(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx, &
       & fxx_point, fxx_pointx, fxy_point, fxy_pointx,  fyy_point, fyy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2), tmp_array(k1, k2)
  integer :: bcs1(2), bcs2(2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ 1, 2/) ! fx on left, fxx on right
  bcs2 = (/2, 1/)
  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2
  spl%bcval1min = -2_r8*(1_r8 + Cos(spl%x1(1)) - Cos(spl%x2))*Sin(spl%x1(1)) 
  spl%bcval1max = -2_r8*( &
       & Cos(spl%x1(n1)) + Cos(2_r8*spl%x1(n1)) - Cos(spl%x1(n1))*Cos(spl%x2) &
       & ) 
  spl%bcval2max = 2_r8*(1_r8 + Cos(spl%x1))*Sin(spl%x2(n2))  ! (..,1)
  spl%bcval2min = 2_r8*(1_r8 + Cos(spl%x1))*Cos(spl%x2(1))   ! (2,..)

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "spline2_mix_c.nc" & "spline2_mix_cx.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)

  x2_cloud = twopi/2.2345456_r8

  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)

  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, f_cloud, "spline2_mix__c.nc", ier)

  write(0,*)' array interpolation "spline2_mix_a.nc" & "spline2_mix_ax.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, x1_array, x2_array, f_array, "spline2_mix__a.nc", ier)

  write(0,*)'save spline object in file "spline2.nc"'
  call EZspline_save(spl, "spline2.nc", ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  !  test eval after reload...
  call EZspline_load(spl,"spline2.nc", ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  call EZspline_interp(spl, k1, k2, x1_array, x2_array, tmp_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  do j = 1, k2
     do i = 1, k1
        if(tmp_array(i,j).ne.f_array(i,j)) then 
           write(0,'(" => save/reload value changed: (",i2,",",i2,"): ",2(f10.6))') i,j,f_array(i,j),tmp_array(i,j)
        endif
     enddo
  enddo

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline2_mix

!!! 
!!! 3-D SPLINE
!!!

!..........mixed BCs 1..........................................................
subroutine spline3_mix(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11, n3=11
  integer, parameter :: k1=11, k2=11, k3=11, k_cloud = 21
  real(r8) :: x1(n1), x2(n2), x3(n3), f(n1, n2, n3)
  real(r8) :: x1_point, x2_point, x3_point, f_point, f_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), x3_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), x3_array(k3), &
       f_array(k1, k2, k3), f_arrayx(k1, k2, k3), tmp_array(k1, k2, k3)
  integer :: bcs1(2), bcs2(2), bcs3(2) 
  type(EZspline3_r8) spl
  integer i, j, k
  real(r8) :: x_pt, y_pt, z_pt

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  do k = 1, n3
     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*sin( x2(j) )
           z_pt = x3(k)*sin( x1(i) )
           f(i,j,k) = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
        enddo
     enddo
  enddo

  bcs1 = (/ -1, -1 /) ! periodic
  bcs2 = (/ -1, -1 /) ! periodic
  bcs3 = (/  0,  0 /) ! not a knot
  write(0,'(" sizes ", i3,"*", i3, "*", i3, "=", i9)') n1, n2, n3, n1*n2*n3
  call EZspline_init(spl, n1, n2, n3, bcs1, bcs2, bcs3, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1, x2, x3 coincide 
  spl%x2 = x2 ! with default mesh
  spl%x3 = x3
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, z, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x3_point = spl%x3min + (spl%x3max-spl%x3min)/4.93642_r8
  x_pt = (1.0_r8 + x3_point*cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + x3_point*cos( x1_point ))*sin( x2_point )
  z_pt = x3_point*sin( x1_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
  call EZspline_isInDomain(spl, x1_point, x2_point, x3_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, x1_point, x2_point, x3_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(5f10.6," ERROR=>",e10.2)') x1_point, x2_point, x3_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "spline3_mix_c.nc" & "spline3_mix_cx.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x3_cloud = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*sin( x2_cloud ) )**2 &
       & + ( x3_cloud*sin( x1_cloud ) )**2
  call EZspline_isInDomain(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, &
       & "spline3_mix__c.nc", ier)
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloudx, &
       & "spline3_mix_cx.nc", ier)
  
  write(0,*)' array interpolation => "spline3_mix_a.nc" & "spline3_mix_ax.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
  x3_array = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k3-1,r8), i=1, k3) /)
  do k = 1, k3
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j,k) = &
                & ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*sin( x2_array(j) ) )**2 &
                & + ( x3_array(k)*sin( x1_array(i) ) )**2
        enddo
     enddo
  enddo
  call EZspline_isInDomain(spl, k1, k2, k3, x1_array, x2_array, x3_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  call EZspline_interp(spl, k1, k2, k3, x1_array, x2_array, x3_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_array,&
       & "spline3_mix__a.nc", ier)
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_arrayx,&
       & "spline3_mix_ax.nc", ier)

  write(0,*)'save spline object in file "spline3.nc"'
  call EZspline_save(spl, "spline3.nc", ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  !  test eval after reload...
  call EZspline_load(spl,"spline3.nc", ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  call EZspline_interp(spl, k1, k2, k3, x1_array, x2_array, x3_array, tmp_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  do k = 1, k3
     do j = 1, k2
        do i = 1, k1
           if(tmp_array(i,j,k).ne.f_array(i,j,k)) then 
              write(0,'(" => save/reload value changed: (",i2,",",i2,",",i2,"): ")') i,j,k
              write(0,'(10x,2(f10.6,1x))') f_array(i,j,k),tmp_array(i,j,k)
           endif
        enddo
     enddo
  enddo

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline3_mix

!..........mixed BCs 2..........................................................
subroutine spline3_mox(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11, n3=11
  integer, parameter ::k1=11, k2=11, k3=11, k_cloud = 21
  real(r8) :: x1(n1), x2(n2), x3(n3), f(n1, n2, n3)
  real(r8) :: x1_point, x2_point, x3_point, f_point, f_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), x3_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), x3_array(k3), &
       f_array(k1, k2, k3), f_arrayx(k1, k2, k3)
  integer :: bcs1(2), bcs2(2), bcs3(2) 
  type(EZspline3_r8) spl
  integer i, j, k
  real(r8) :: x_pt, y_pt, z_pt
  real(r8), dimension(:,:), allocatable :: a2, a3, b1, b3, c1, c2
  real(r8) df(3)

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  do k = 1, n3
     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*sin( x2(j) )
           z_pt = x3(k)*sin( x1(i) )
           f(i,j,k) = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
        enddo
     enddo
  enddo

  bcs1 = (/1, 2/) ! fx, fxx
  bcs2 = (/2, 2/) ! fyy, fyy
  bcs3 = (/1, 1/) ! fz, fz
  write(0,'(" sizes ", i3,"*", i3, "*", i3, "=", i9)') n1, n2, n3, n1*n2*n3
  call EZspline_init(spl, n1, n2, n3, bcs1, bcs2, bcs3, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 
  spl%x2 = x2
  spl%x3 = x3

  ! apply boundary conditions

  allocate(a2(spl%n2,spl%n3), a3(spl%n2,spl%n3))
  allocate(b1(spl%n1,spl%n3), b3(spl%n1,spl%n3))
  allocate(c1(spl%n1,spl%n2), c2(spl%n1,spl%n2))

  a2 = spread(spl%x2, dim=2, ncopies=spl%n3)
  a3 = spread(spl%x3, dim=1, ncopies=spl%n2)
  spl%bcval1min = -4_r8*a3*Sin(spl%x1min)*Sin(a2/2._r8)**2
  spl%bcval1max = -4_r8*a3*Cos(spl%x1max)*Sin(a2/2._r8)**2

  b1 = spread(spl%x1, dim=2, ncopies=spl%n3)
  b3 = spread(spl%x3, dim=1, ncopies=spl%n1)
  spl%bcval2min = 2_r8*(1_r8 + b3*Cos(b1))*Cos(spl%x2min)
  spl%bcval2max = 2_r8*(1_r8 + b3*Cos(b1))*Cos(spl%x2max)

  c1 = spread(spl%x1, dim=2, ncopies=spl%n2)
  c2 = spread(spl%x2, dim=1, ncopies=spl%n1)
  spl%bcval3min = 2_r8*spl%x3min + 2_r8*Cos(c1) - Cos(c1 - c2) - Cos(c1 + c2)
  spl%bcval3max = 2_r8*spl%x3max + 2_r8*Cos(c1) - Cos(c1 - c2) - Cos(c1 + c2)
  
  deallocate(a2, a3)
  deallocate(b1, b3)
  deallocate(c1, c2)
  
  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, z, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x3_point = spl%x3min + (spl%x3max-spl%x3min)/4.93642_r8
  x_pt = (1.0_r8 + x3_point*cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + x3_point*cos( x1_point ))*sin( x2_point )
  z_pt = x3_point*sin( x1_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
  call EZspline_interp(spl, x1_point, x2_point, x3_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(5f10.6," ERROR=>",e10.2)') x1_point, x2_point, x3_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,'(a,3f10.6)')' gradient (x, y, z, fx, fy, fz)'
  call EZspline_gradient(spl, x1_point, x2_point, x3_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(10f10.6)') x1_point, x2_point, x3_point, &
       & df(1), df(2), df(3)
  !compute exact values
  df(1)= -4_r8*x3_point*Sin(x1_point)*Sin(x2_point/2_r8)**2
  df(2)= 2_r8*(1_r8 + x3_point*Cos(x1_point))*Sin(x2_point)
  df(3)= 2_r8*x3_point + 2_r8*Cos(x1_point) - &
       & Cos(x1_point - x2_point) - Cos(x1_point + x2_point)
   write(0,'(10f10.6)') x1_point, x2_point, x3_point, &
       & df(1), df(2), df(3)
  
  write(0,*)' cloud interpolation => "spline3_mox__c.nc" & "spline3_mox_cx.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x3_cloud = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*sin( x2_cloud ) )**2 &
       & + ( x3_cloud*sin( x1_cloud ) )**2
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, &
       & "spline3_mox__c.nc", ier)

  write(0,*)' array interpolation => "spline3_mox__a.nc" & "spline3_mox_ax.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
  x3_array = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k3-1,r8), i=1, k3) /)
  do k = 1, k3
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j,k) = &
                & ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*sin( x2_array(j) ) )**2 &
                & + ( x3_array(k)*sin( x1_array(i) ) )**2
        enddo
     enddo
  enddo
  call EZspline_interp(spl, k1, k2, k3, x1_array, x2_array, x3_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_array, &
       & 'spline3_mox__a.nc',ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine spline3_mox



! 
! 1-D AKIMA
!

!..........standard BC.....................................................
subroutine akima1_not(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  real(r8) df
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ 0, 0 /)
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1

  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  ! For Akima Hermite represention
  spl%isHermite = 1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_isInDomain(spl,  x1_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation =>"akima1__not.nc"'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  f_cloudx = sin(x1_cloud)
  call EZspline_isInDomain(spl, k1, x1_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  

  write(0,*)' gradient  (x, fx)'
  call EZspline_gradient(spl, x1_point, df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(2f10.6)') x1_point, df
  write(0,'(2f10.6)') x1_point, cos(x1_point)

  call EZspline_2netCDF(k1, x1_cloud, f_cloud, "akima1__not.nc", ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine akima1_not

!..........periodic........................................................
subroutine akima1_per(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i, bcs1(2)
  real(r8) df
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  bcs1 = (/ -1, -1 /) 
  write(0,*)'grid size ',n1
  call EZspline_init(spl, n1, bcs1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1

  ! For Akima Hermite represention
  spl%isHermite = 1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' gradient  (x, fx)'
  call EZspline_gradient(spl, x1_point, df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(2f10.6)') x1_point, df
  write(0,'(2f10.6)') x1_point, cos(x1_point)

  write(0,*)' cloud interpolation => "akima1__per.nc"'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  f_cloudx = sin(x1_cloud)
  call EZspline_2netCDF( k1, x1_cloud, f_cloud, "akima1__per.nc", ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine akima1_per


!! 
!! 2-D AKIMA HERMITE
!!

!..........not a knot.....................................................
subroutine akima2_not(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2)
  integer :: bcs1(2), bcs2(2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt
  real(r8) df(2)

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ 0, 0/) ! not a knot
  bcs2 = (/ 0, 0/) ! not a knot
  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  ! For Akima Hermite represention
  spl%isHermite = 1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_isInDomain(spl,  x1_point, x2_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "akima2_not__c.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_isInDomain(spl,   k_cloud, x1_cloud, x2_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF( k_cloud, x1_cloud, x2_cloud, f_cloud, "akima2_not__c.nc", ier)

  write(0,*)' array interpolation  => "akima2_not__a.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_isInDomain(spl,  k1, k2, x1_array, x2_array, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  call EZspline_2netCDF( k1, k2, x1_array, x2_array, f_array, "akima2_not__a.nc", ier)
  
  write(0,*)' point derivative (x, y, fx, fx-exact, error)'
  fx_pointx = -2_r8*(1_r8 + Cos(x1_point) - Cos(x2_point))*Sin(x1_point)
  call EZspline_derivative(spl, 1, 0, x1_point, x2_point, fx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fx_point, fx_pointx, &
       fx_point - fx_pointx

  write(0,*)' point derivative (x, y, fy, fy-exact, error)'
  fy_pointx = 2_r8*(1_r8 + Cos(x1_point))*Sin(x2_point)
  call EZspline_derivative(spl, 0, 1, x1_point, x2_point, fy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fy_point, fy_pointx, &
       fy_point - fy_pointx

  write(0,'(a,2f10.6)')' gradient (x, y, fx, fy)'
  call EZspline_gradient(spl, x1_point, x2_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return  
  write(0,'(4f10.6)') &
       & x1_point, x2_point, df(1), df(2)
  write(0,'(4f10.6)') &
       & x1_point, x2_point, fx_pointx, fy_pointx


  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine akima2_not
  

!..........periodic.........................................................
subroutine akima2_per(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2)
  integer :: bcs1(2), bcs2(2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt
  real(r8) df(2)

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  bcs1 = (/ -1, -1/) ! periodic
  bcs2 = (/ -1, -1/) ! periodic
  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZspline_init(spl, n1, n2, bcs1, bcs2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2

  ! For Akima Hermite represention
  spl%isHermite = 1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "akima2_per__c.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, f_cloud, 'akima2_per__c.nc', ier)

  write(0,*)' array interpolation "akima2_per__a.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, x1_array, x2_array, f_array, 'akima2_per__a.nc', ier)

  write(0,'(a,2f10.6)')' gradient (x, y, fx, fy)'
  call EZspline_gradient(spl, x1_point, x2_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return  
  write(0,'(4f10.6)') &
       & x1_point, x2_point, df(1), df(2)
  fx_pointx = -2_r8*(1_r8 + Cos(x1_point) - Cos(x2_point))*Sin(x1_point)
  fy_pointx = 2_r8*(1_r8 + Cos(x1_point))*Sin(x2_point)
  write(0,'(4f10.6)') &
       & x1_point, x2_point, fx_pointx, fy_pointx

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine akima2_per



!!! 
!!! 3-D AKIMA HERMITE
!!!

!..........mixed BCs..........................................................
subroutine akima3_mix(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11, n3=11
  integer, parameter :: k1=11, k2=11, k3=11, k_cloud = 21
  real(r8) :: x1(n1), x2(n2), x3(n3), f(n1, n2, n3)
  real(r8) :: x1_point, x2_point, x3_point, f_point, f_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), x3_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), x3_array(k3), &
       f_array(k1, k2, k3), f_arrayx(k1, k2, k3)
  integer :: bcs1(2), bcs2(2), bcs3(2) 
  type(EZspline3_r8) spl
  integer i, j, k
  real(r8) :: x_pt, y_pt, z_pt
  real(r8) df(3)

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  do k = 1, n3
     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*sin( x2(j) )
           z_pt = x3(k)*sin( x1(i) )
           f(i,j,k) = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
        enddo
     enddo
  enddo

  bcs1 = (/ -1, -1 /) ! periodic
  bcs2 = (/ -1, -1 /) ! periodic
  bcs3 = (/  0,  0 /) ! not a knot
  write(0,'(" sizes ", i3,"*", i3, "*", i3, "=", i9)') n1, n2, n3, n1*n2*n3
  call EZspline_init(spl, n1, n2, n3, bcs1, bcs2, bcs3, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1, x2, x3 coincide 
  spl%x2 = x2 ! with default mesh
  spl%x3 = x3
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  ! For Akima Hermite represention
  spl%isHermite = 1

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, z, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x3_point = spl%x3min + (spl%x3max-spl%x3min)/4.93642_r8
  x_pt = (1.0_r8 + x3_point*cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + x3_point*cos( x1_point ))*sin( x2_point )
  z_pt = x3_point*sin( x1_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
  call EZspline_isInDomain(spl, x1_point, x2_point, x3_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, x1_point, x2_point, x3_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(5f10.6," ERROR=>",e10.2)') x1_point, x2_point, x3_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "akima3_mix__c.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x3_cloud = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*sin( x2_cloud ) )**2 &
       & + ( x3_cloud*sin( x1_cloud ) )**2
  call EZspline_isInDomain(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, &
       & "akima3_mix__c.nc", ier)
  
  write(0,*)' array interpolation => "akima3_mix__a.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
  x3_array = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k3-1,r8), i=1, k3) /)
  do k = 1, k3
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j,k) = &
                & ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*sin( x2_array(j) ) )**2 &
                & + ( x3_array(k)*sin( x1_array(i) ) )**2
        enddo
     enddo
  enddo
  call EZspline_isInDomain(spl, k1, k2, k3, x1_array, x2_array, x3_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  call EZspline_interp(spl, k1, k2, k3, x1_array, x2_array, x3_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_array,&
       & "akima3_mix__a.nc", ier)

  write(0,'(a,3f10.6)')' gradient (x, y, z, fx, fy, fz)'
  call EZspline_gradient(spl, x1_point, x2_point, x3_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(10f10.6)') x1_point, x2_point, x3_point, &
       & df(1), df(2), df(3)
  !compute exact values
  df(1)= -4_r8*x3_point*Sin(x1_point)*Sin(x2_point/2_r8)**2
  df(2)= 2_r8*(1_r8 + x3_point*Cos(x1_point))*Sin(x2_point)
  df(3)= 2_r8*x3_point + 2_r8*Cos(x1_point) - &
       & Cos(x1_point - x2_point) - Cos(x1_point + x2_point)
   write(0,'(10f10.6)') x1_point, x2_point, x3_point, &
       & df(1), df(2), df(3)
  
  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine akima3_mix

! 
! 1-D Piecewise Linear
!

subroutine pclin1(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1 = 11, k1 = 21
  real(r8) :: x1(n1), f(n1), x1_point, f_point, x1_cloud(k1), &
       & f_cloud(k1), f_cloudx(k1)
  type(EZspline1_r8) :: spl
  integer i
  
  ier = 0
  x1 = twopi*(/ (real(i-1,r8)/real(n1-1,r8), i=1, n1) /)
  f = sin(x1)

  write(0,*)'grid size ',n1
  call EZlinear_init(spl, n1, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  spl%x1 = x1

  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  write(0,*)' point interpolation (x, f, f-exact, error)'
  x1_point = spl%x1(1)
  call EZspline_isInDomain(spl,  x1_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = twopi/4.0_r8
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)

  x1_point = spl%x1(spl%n1)
  call EZspline_interp(spl, x1_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  write(0,'(3f10.6," ERROR=>",e10.2)') x1_point, f_point, &
       & sin(x1_point), f_point-sin(x1_point)
  
  write(0,*)' cloud interpolation =>"pclin1_.nc" & "pclin1x.nc" (exact)'
  x1_cloud = twopi*(/ (real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  f_cloudx = sin(x1_cloud)
  call EZspline_isInDomain(spl, k1, x1_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, x1_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return
  
  call EZspline_2netCDF(k1, x1_cloud, f_cloud, 'pclin1_.nc', ier)
  call EZspline_2netCDF(k1, x1_cloud, f_cloudx,'pclin1x.nc', ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine pclin1


!! 
!! 2-D piecewise linear
!!

subroutine pclin2(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11
  integer, parameter :: k1 = 21, k2 = 21, k_cloud = 41
  real(r8) :: x1(n1), x2(n2), f(n1, n2)
  real(r8) :: x1_point, x2_point, f_point, f_pointx, &
       & fx_point, fx_pointx, fy_point, fy_pointx, &
       & fxx_point, fxx_pointx, fxy_point, fxy_pointx,  fyy_point, fyy_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), &
       f_array(k1, k2), f_arrayx(k1, k2)
  type(EZspline2_r8) spl
  integer i, j
  real(r8) :: x_pt, y_pt
  real(r8) :: df(2)
  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)

     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + cos( x1(i) ))*sin( x2(j) )
           f(i,j) = (x_pt-1.0_r8)**2 + y_pt**2
        enddo
     enddo

  write(0,'(" sizes ", i3,"*", i3, "=", i9)') n1, n2, n1*n2
  call EZlinear_init(spl, n1, n2, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1  
  spl%x2 = x2
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x_pt = (1.0_r8 + cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + cos( x1_point ))*sin( x2_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 
  call EZspline_isInDomain(spl,  x1_point, x2_point, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, x1_point, x2_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "pclin2_c.nc" & "pclin2_cx.nc" (exact)'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + cos( x1_cloud ))*sin( x2_cloud ) )**2
  call EZspline_isInDomain(spl,   k_cloud, x1_cloud, x2_cloud, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF( k_cloud, x1_cloud, x2_cloud, f_cloud, "pclin2__c.nc", ier)
  call EZspline_2netCDF( k_cloud, x1_cloud, x2_cloud, f_cloudx,"pclin2x_c.nc", ier)

  write(0,*)' array interpolation  => "pclin2_a.nc" & "pclin2_ax.nc" (exact)'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j) = &
                & ( (1.0_r8 + &
                & cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & cos( x1_array(i) ))*sin( x2_array(j) ) )**2 
        enddo
     enddo
  call EZspline_isInDomain(spl,  k1, k2, x1_array, x2_array, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_interp(spl, k1, k2, x1_array, x2_array, f_array, ier)
  call EZspline_error(ier)
  call EZspline_2netCDF( k1, k2, x1_array, x2_array, f_array, "pclin2__a.nc", ier)
  call EZspline_2netCDF( k1, k2, x1_array, x2_array, f_arrayx,"pclin2x_a.nc", ier)
  
  write(0,*)' point derivative (x, y, fx, fx-exact, error)'
  fx_pointx = -2_r8*(1_r8 + Cos(x1_point) - Cos(x2_point))*Sin(x1_point)
  call EZspline_derivative(spl, 1, 0, x1_point, x2_point, fx_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fx_point, fx_pointx, &
       fx_point - fx_pointx

  write(0,*)' point derivative (x, y, fy, fy-exact, error)'
  fy_pointx = 2_r8*(1_r8 + Cos(x1_point))*Sin(x2_point)
  call EZspline_derivative(spl, 0, 1, x1_point, x2_point, fy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fy_point, fy_pointx, &
       fy_point - fy_pointx

  write(0,*)' point derivative (x, y, fxy, fxy-exact, error)'
  fxy_pointx = -2.0_r8*Sin(x1_point)*Sin(x2_point)
  call EZspline_derivative(spl, 1, 1, x1_point, x2_point, fxy_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(4f10.6," ERROR=>",e10.2)') x1_point, x2_point, fxy_point, fxy_pointx, &
       fxy_point - fxy_pointx

  write(0,'(a,2f10.6)')' gradient (x, y, fx, fy)'
  call EZspline_gradient(spl, x1_point, x2_point, &
       & df, ier)
  call EZspline_error(ier)
  if(ier /= 0) return  
  write(0,'(4f10.6)') &
       & x1_point, x2_point, df(1), df(2)
  write(0,'(4f10.6)') &
       & x1_point, x2_point, fx_pointx, fy_pointx

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine pclin2
  
!!! 
!!! 3-D piecewise linear
!!!
subroutine pclin3(ier)
  use EZspline_obj
  use EZspline
  implicit none
  integer, intent(out) :: ier

  integer, parameter :: r8 = selected_real_kind(12,100)
  real(r8), parameter :: twopi = 6.2831853071795865
  integer, parameter :: n1=11, n2=11, n3=11
  integer, parameter :: k1=11, k2=11, k3=11, k_cloud = 21
  real(r8) :: x1(n1), x2(n2), x3(n3), f(n1, n2, n3)
  real(r8) :: x1_point, x2_point, x3_point, f_point, f_pointx
  real(r8) :: x1_cloud(k_cloud), x2_cloud(k_cloud), x3_cloud(k_cloud), &
       & f_cloud(k_cloud), f_cloudx(k_cloud)
  real(r8) :: x1_array(k1), x2_array(k2), x3_array(k3), &
       f_array(k1, k2, k3), f_arrayx(k1, k2, k3)
  type(EZspline3_r8) spl
  integer i, j, k
  real(r8) :: x_pt, y_pt, z_pt

  ier = 0

  x1 = twopi* (/ ( real(i-1,r8)/real(n1-1, r8), i = 1, n1) /)
  x2 = twopi* (/ ( real(j-1,r8)/real(n2-1, r8), j = 1, n2) /)
  x3 =        (/ ( real(k-1,r8)/real(n3-1, r8), k = 1, n3) /)

  do k = 1, n3
     do j = 1, n2
        do i = 1, n1
           x_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*cos( x2(j) )
           y_pt = (1.0_r8 + x3(k)*cos( x1(i) ))*sin( x2(j) )
           z_pt = x3(k)*sin( x1(i) )
           f(i,j,k) = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
        enddo
     enddo
  enddo

  write(0,'(" sizes ", i3,"*", i3, "*", i3, "=", i9)') n1, n2, n3, n1*n2*n3
  call EZlinear_init(spl, n1, n2, n3, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  spl%x1 = x1 ! not really necessay here since x1, x2, x3 coincide 
  spl%x2 = x2 ! with default mesh
  spl%x3 = x3
  call EZspline_isGridRegular(spl, ier)
  call EZspline_error(ier)
  if(ier /=0 ) return

  call EZspline_setup(spl, f, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
 
  write(0,*)' point interpolation (x, y, z, f, f-exact, error)'
  x1_point = spl%x1min + (spl%x1max-spl%x1min)/2.34656_r8
  x2_point = spl%x2min + (spl%x2max-spl%x2min)/1.36482_r8
  x3_point = spl%x3min + (spl%x3max-spl%x3min)/4.93642_r8
  x_pt = (1.0_r8 + x3_point*cos( x1_point ))*cos( x2_point )
  y_pt = (1.0_r8 + x3_point*cos( x1_point ))*sin( x2_point )
  z_pt = x3_point*sin( x1_point )
  f_pointx = (x_pt-1.0_r8)**2 + y_pt**2 + z_pt**2
  call EZspline_isInDomain(spl, x1_point, x2_point, x3_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, x1_point, x2_point, x3_point, f_point, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  write(0,'(5f10.6," ERROR=>",e10.2)') x1_point, x2_point, x3_point, &
       & f_point, f_pointx, f_point-f_pointx

  write(0,*)' cloud interpolation => "pclin3_c.nc" & "pclin3_cx.nc"'
  x1_cloud = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x2_cloud = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  x3_cloud = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k_cloud-1,r8), i=1, k_cloud) /)
  f_cloudx = ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*cos( x2_cloud) - 1.0_r8 )**2 &
       & + ( (1.0_r8 + x3_cloud*cos( x1_cloud ))*sin( x2_cloud ) )**2 &
       & + ( x3_cloud*sin( x1_cloud ) )**2
  call EZspline_isInDomain(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  
  call EZspline_interp(spl, k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloud, &
       & "pclin3__c.nc", ier)
  call EZspline_2netCDF(k_cloud, x1_cloud, x2_cloud, x3_cloud, f_cloudx, &
       & "pclin3_cx.nc", ier)
  
  write(0,*)' array interpolation => "pclin3_a.nc" & "pclin3_ax.nc"'
  x1_array = spl%x1min + (spl%x1max-spl%x1min)* &
       & (/(real(i-1,r8)/real(k1-1,r8), i=1, k1) /)
  x2_array = spl%x2min + (spl%x2max-spl%x2min)* &
       & (/(real(i-1,r8)/real(k2-1,r8), i=1, k2) /)
  x3_array = spl%x3min + (spl%x3max-spl%x3min)* &
       & (/(real(i-1,r8)/real(k3-1,r8), i=1, k3) /)
  do k = 1, k3
     do j = 1, k2
        do i = 1, k1
           f_arrayx(i,j,k) = &
                & ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*cos( x2_array(j)) - 1.0_r8 )**2 &
                & + ( (1.0_r8 + &
                & x3_array(k)*cos( x1_array(i) ))*sin( x2_array(j) ) )**2 &
                & + ( x3_array(k)*sin( x1_array(i) ) )**2
        enddo
     enddo
  enddo
  call EZspline_isInDomain(spl, k1, k2, k3, x1_array, x2_array, x3_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return

  call EZspline_interp(spl, k1, k2, k3, x1_array, x2_array, x3_array, f_array, ier)
  call EZspline_error(ier)
  if(ier /= 0) return
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_array,&
       & "pclin3__a.nc", ier)
  call EZspline_2netCDF(k1, k2, k3, x1_array, x2_array, x3_array, f_arrayx,&
       & "pclin3_ax.nc", ier)

  call EZspline_free(spl, ier)
  call EZspline_error(ier)

end subroutine pclin3

C******************** START FILE DATCPU.FOR ; GROUP DATCPU ******************
      SUBROUTINE DATCPU(ZTIME)
C
C  THIS ROUTINE RETURNS THE AMOUNT OF CPU TIME USED UP UNTIL
C  THIS TIME IN SECONDS.
C
C  THIS VERSION FOR USE OUTSIDE OF TRANSP
C
C--------------------------------------
C
      call cptimer(ztime)
C
      RETURN
      END
C******************** END FILE DATCPU.FOR ; GROUP DATCPU ******************

C--------------------------------------------------------------------
C  TEMPFILE -- create a temporary filename
C
      subroutine tempfile(zprefix,zfile,ilz)
C
      character*(*) zprefix             ! filename prefix (no path) (input)
      character*(*) zfile               ! full filename (output)
      integer ilz                       ! nonblank length of filename (output)
C
      call tmpfile_d(zprefix,zfile,ilz)
C
      return
      end

subroutine mktricub(x,nx,y,ny,z,nz,f,nf2,nf3, &
     ibcxmin,bcxmin,ibcxmax,bcxmax,inb1x, &
     ibcymin,bcymin,ibcymax,bcymax,inb1y, &
     ibczmin,bczmin,ibczmax,bczmax,inb1z, &
     ilinx,iliny,ilinz,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup a tricubic spline; store coefficients in compact form
  !  (as per suggestion of L. Zakharov, PPPL, Feb. 1999)
  !  8 coeffs per (x,y,z) grid point:
  !          f,fxx,fyy,fzz,fxxyy,fxxzz,fyyzz,fxxyyzz
  !
  !  dmc -- modified Feb 2004 -- rewritten to compute coefficients
  !  directly rather than by conversion from the non-compact representation
  !  (to reduce cpu and memory cost)
  !
  !
  !  input:
  implicit none
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  integer nz                        ! length of z vector
  real(fp) :: x(nx)                        ! x vector, strict ascending
  real(fp) :: y(ny)                        ! y vector, strict ascending
  real(fp) :: z(nz)                        ! z vector, strict ascending
  !
  integer nf2                       ! 2nd dim. of f array, nf2.ge.nx
  integer nf3                       ! 3rd dim. of f array, nf3.ge.ny
  !
  !  input/output:
  !
  real(fp) :: f(8,nf2,nf3,nz)              ! data and spline coefficients
  !
  !  on input:  f(1,i,j,k) = f(x(i),y(j),z(k))
  !  on output:  f(1,i,j,k) unchanged
  !              f(2,i,j,k) = d2f/dx2(x(i),y(j),z(k))
  !              f(3,i,j,k) = d2f/dy2(x(i),y(j),z(k))
  !              f(4,i,j,k) = d2f/dz2(x(i),y(j),z(k))
  !              f(5,i,j,k) = d4f/dx2dy2(x(i),y(j),z(k))
  !              f(6,i,j,k) = d4f/dx2dz2(x(i),y(j),z(k))
  !              f(7,i,j,k) = d4f/dy2dz2(x(i),y(j),z(k))
  !              f(8,i,j,k) = d6f/dx2dy2dz2(x(i),y(j),z(k))
  !
  !  there is a rather Hermite like interpolation formula to go with
  !  this-- see evtricub.f90.  Also the bicubic formula is given in
  !  mkbicubw.f90; the tricubic formula is precisely analogous.
  !
  !  boundary condition data
  !  inputs:
  integer inb1x                     ! 1st dim of xmin & xmax bc arrays
  integer inb1y                     ! 1st dim of ymin & ymax bc arrays
  integer inb1z                     ! 1st dim of zmin & zmax bc arrays
  !
  integer ibcxmin,ibcxmax           ! BC type flag @xmin, xmax
  integer ibcymin,ibcymax           ! BC type flag @ymin, ymax
  integer ibczmin,ibczmax           ! BC type flag @zmin, zmax
  !
  real(fp) :: bcxmin(inb1x,nz),bcxmax(inb1x,nz) ! xmin & xmax BC data, ny x nz
  real(fp) :: bcymin(inb1y,nz),bcymax(inb1y,nz) ! ymin & ymax BC data, nx x nz
  real(fp) :: bczmin(inb1z,ny),bczmax(inb1z,ny) ! zmin & zmax BC data, nx x ny
  !
  !  where BC data is not required, dummy scalars may be passed.
  !  the ibc* flags determine whether BC data isneeded.
  !
  !  BC data:  bcxmin & bcxmax:  BC vs. y,z @xmin,xmax
  !            bcymin & bcymax:  BC vs. x,z @ymin,ymax
  !            bczmin & bczmax:  BC vs. x,y @zmin,zmax
  !
  !   ibcxmin -- indicator for boundary condition at xmin=x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- use periodic boundary condition
  !     =0 -- use "not a knot"
  !     =1 -- match slope, specified at x(1),y(iy),z(iz) by bcxmin(iy,iz)
  !     =2 -- match 2nd derivative, specified at x(1),y(iy),z(iz)
  !           by bcxmin(iy,iz
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all y(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all y(j)
  !     =5 -- df/dx BC from 1st divided difference
  !     =6 -- d2f/dx2 BC from 2nd divided difference (parabolic fit)
  !     =7 -- d3f/dx3 BC from 3rd divided difference (cubic fit)
  !   ***NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !     NOTE:  if ibcxmin=-1 then the periodic BC applies on both sides
  !            and ibcxmax, bcxmax are ignored.
  !   inb1x -- 1st dimension of bcxmin, bcxmax: if ibcxmin or ibcxmax .gt. 0
  !            this must be .ge. ny.
  !
  !   interpretation of ibcymin,bcymin,ibcymax,bcymax,inb1y
  !     is same as with ibcxmin,...
  !
  !   interpretation of ibczmin,bczmin,ibczmax,bczmax,inb1z
  !     is same as with ibcxmin,...
  !
  !   the explicit bdy condition arrays are referenced only if the
  !     corresponding "ibc" flag values are set to 1 or 2.
  !
  !  output:
  integer ilinx                     ! x vector equal spacing flag
  integer iliny                     ! y vector equal spacing flag
  integer ilinz                     ! z vector equal spacing flag
  !
  !   ilinx -- =1 on output if x(nx) pts are nearly evenly spaced (tol=1e-3)
  !   iliny -- =1 on output if y(ny) evenly spaced (tol=1e-3)
  !   ilinz -- =1 on output if z(nz) evenly spaced (tol=1e-3)
  !
  integer ier                       ! exit code
  !   ier -- completion code, 0 for normal
  !
  !-----------------------------------------------------
  !  workspace **dynamic allocation**
  !  f90 dynamic array
  !
  real(fp), dimension(:,:,:), allocatable :: fbicub ! bicubic subsection
  real(fp), dimension(:,:), allocatable :: fwk ! work array
  real(fp), dimension(:), allocatable :: bcx1,bcx2,bcy1,bcy2 ! BCs for mkbicub
  !
  real(fp), dimension(:,:,:,:), allocatable :: fcorr ! correction spline
  real(fp), dimension(:,:), allocatable :: bcc1,bcc2 ! correction BCs
  !
  integer iflg,ierx,iery,ierz
  integer ix,iy,iz
  !
  real(fp) :: ztol = 1.0E-3_fp
  real(fp) :: zbc1,zbc2,hz
  integer ibc1,ibc2
  !
  !-----------------------------------------------------
  !
  ier=0
  !
  iflg=0
  !
  !  check z bdy condition "linearity"
  !
  if(ibczmin.ne.-1) then
     if((ibczmin.eq.1).or.(ibczmin.eq.2)) then
        do iy=1,ny
           do ix=1,nx
              if(bczmin(ix,iy).ne.0.0_fp) iflg=1
           end do
        end do
     end if
     if((ibczmax.eq.1).or.(ibczmax.eq.2)) then
        do iy=1,ny
           do ix=1,nx
              if(bczmax(ix,iy).ne.0.0_fp) iflg=1
           end do
        end do
     end if
  end if
  !
  if(nx.lt.2) then
     write(6,'('' ?mktricub:  at least 2 x points required.'')')
     ier=1
  end if
  if(ny.lt.2) then
     write(6,'('' ?mktricub:  need at least 2 y points.'')')
     ier=1
  end if
  if(nz.lt.2) then
     write(6,'('' ?mktricub:  need at least 2 z points.'')')
     ier=1
  end if
  !
  if((ibcxmin.eq.1).or.(ibcxmax.eq.1).or.(ibcxmin.eq.2).or. &
       (ibcxmax.eq.2)) then
     if(inb1x.lt.ny) then
        ier=1
        write(6, &
             '('' ?mktricub:  1st dim of bcxmin/max arrays .lt. ny'')')
     end if
  end if
  !
  if((ibcymin.eq.1).or.(ibcymax.eq.1).or.(ibcymin.eq.2).or. &
       (ibcymax.eq.2)) then
     if(inb1y.lt.nx) then
        ier=1
        write(6, &
             '('' ?mktricub:  1st dim of bcymin/max arrays .lt. nx'')')
     end if
  end if
  !
  if((ibczmin.eq.1).or.(ibczmax.eq.1).or.(ibczmin.eq.2).or. &
       (ibczmax.eq.2)) then
     if(inb1z.lt.nx) then
        ier=1
        write(6, &
             '('' ?mktricub:  1st dim of bczmin/max arrays .lt. nx'')')
     end if
  end if
  !
  call ibc_ck(ibcxmin,'mktricub','xmin',-1,7,ier)
  if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'mktricub','xmax',0,7,ier)
  !
  call ibc_ck(ibcymin,'mktricub','ymin',-1,7,ier)
  if(ibcymin.ge.0) call ibc_ck(ibcymax,'mktricub','ymax',0,7,ier)
  !
  call ibc_ck(ibczmin,'mktricub','zmin',-1,7,ier)
  if(ibczmax.ge.0) call ibc_ck(ibczmax,'mktricub','zmax',0,7,ier)
  !
  !  check ilinx & x vector
  !
  call splinck(x,nx,ilinx,ztol,ierx)
  if(ierx.ne.0) ier=2
  !
  if(ier.eq.2) then
     write(6,'('' ?mktricub:  x axis not strict ascending'')')
  end if
  !
  !  check iliny & y vector
  !
  call splinck(y,ny,iliny,ztol,iery)
  if(iery.ne.0) ier=3
  !
  if(ier.eq.3) then
     write(6,'('' ?mktricub:  y axis not strict ascending'')')
  end if
  !
  !  check ilinz & z vector
  !
  call splinck(z,nz,ilinz,ztol,ierz)
  if(ierz.ne.0) ier=4
  !
  if(ier.eq.4) then
     write(6,'('' ?mktricub:  z axis not strict ascending'')')
  end if
  !
  if(ier.ne.0) return
  !
  !------------------------------------
  !  1.  compute (x,y) bicubic splines using mkbicub
  !
  allocate(fbicub(4,nx,ny))
  allocate(bcx1(ny),bcx2(ny),bcy1(nx),bcy2(nx))
  bcx1=0.0; bcx2=0.0; bcy1=0.0; bcy2=0.0_fp
  !
  do iz=1,nz
     if(ibcxmin.ne.-1) then
        if((ibcxmin.eq.1).or.(ibcxmin.eq.2)) then
           bcx1(1:ny)=bcxmin(1:ny,iz)
        end if
        if((ibcxmax.eq.1).or.(ibcxmax.eq.2)) then
           bcx2(1:ny)=bcxmax(1:ny,iz)
        end if
     end if
     if(ibcymin.ne.-1) then
        if((ibcymin.eq.1).or.(ibcymin.eq.2)) then
           bcy1(1:nx)=bcymin(1:nx,iz)
        end if
        if((ibcymax.eq.1).or.(ibcymax.eq.2)) then
           bcy2(1:nx)=bcymax(1:nx,iz)
        end if
     end if
     !
     fbicub(1,1:nx,1:ny) = f(1,1:nx,1:ny,iz)
     !
     call mkbicub(x,nx,y,ny,fbicub,nx, &
          ibcxmin,bcx1,ibcxmax,bcx2, &
          ibcymin,bcy1,ibcymax,bcy2, &
          ilinx,iliny,ier)
     if(ier.ne.0) return
     !
     f(2:3,1:nx,1:ny,iz) = fbicub(2:3,1:nx,1:ny)  ! fxx, fyy
     f(5,1:nx,1:ny,iz) = fbicub(4,1:nx,1:ny)      ! fxxyy
     !
  end do
  !
  deallocate(fbicub,bcx1,bcx2,bcy1,bcy2)
  !
  !  2.  homogeneous spline in z direction; inhomogeneous BC imposed later
  !      if necessary
  !
  zbc1=0.0_fp
  zbc2=0.0_fp
  ibc1=ibczmin
  ibc2=ibczmax
  if(iflg.eq.1) then
     if((ibczmin.eq.1).or.(ibczmin.eq.2)) ibc1=0
     if((ibczmax.eq.1).or.(ibczmax.eq.2)) ibc2=0
  end if
  !
  allocate(fwk(2,nz))
  !
  do iy=1,ny
     do ix=1,nx

        fwk(1,1:nz) = f(1,ix,iy,1:nz)
        call mkspline(z,nz,fwk, &
             ibc1,zbc1,ibc2,zbc2,ilinz,ier)
        if(ier.ne.0) return
        f(4,ix,iy,1:nz) = fwk(2,1:nz) ! fzz

        fwk(1,1:nz) = f(2,ix,iy,1:nz)
        call mkspline(z,nz,fwk, &
             ibc1,zbc1,ibc2,zbc2,ilinz,ier)
        if(ier.ne.0) return
        f(6,ix,iy,1:nz) = fwk(2,1:nz) ! fxxzz

        fwk(1,1:nz) = f(3,ix,iy,1:nz)
        call mkspline(z,nz,fwk, &
             ibc1,zbc1,ibc2,zbc2,ilinz,ier)
        if(ier.ne.0) return
        f(7,ix,iy,1:nz) = fwk(2,1:nz) ! fyyzz

        fwk(1,1:nz) = f(5,ix,iy,1:nz)
        call mkspline(z,nz,fwk, &
             ibc1,zbc1,ibc2,zbc2,ilinz,ier)
        if(ier.ne.0) return
        f(8,ix,iy,1:nz) = fwk(2,1:nz) ! fxxyyzz

     end do
  end do
  !
  deallocate(fwk)
  !
  if(iflg.eq.1) then
     !
     !  3. inhomogeneous BC correction
     !
     allocate(fwk(2,max(nx,ny,nz)))
     allocate(bcc1(nx,ny),bcc2(nx,ny))
     allocate(fcorr(4,nx,ny,nz))
     !
     !  correction BCs
     !
     do iy=1,ny
        do ix=1,nx
           bcc1(ix,iy)=0.0_fp
           if(ibczmin.eq.1) then
              hz=z(2)-z(1)
              bcc1(ix,iy)=(f(1,ix,iy,2)-f(1,ix,iy,1))/hz + &
                   hz*(-2*f(4,ix,iy,1)-f(4,ix,iy,2))/6
              bcc1(ix,iy)=bczmin(ix,iy)-bcc1(ix,iy)
           else if(ibczmin.eq.2) then
              bcc1(ix,iy)=bczmin(ix,iy)-f(4,ix,iy,1)
           end if
        end do
     end do
     !
     do iy=1,ny
        do ix=1,nx
           bcc2(ix,iy)=0.0_fp
           if(ibczmax.eq.1) then
              hz=z(2)-z(1)
              bcc2(ix,iy)=(f(1,ix,iy,2)-f(1,ix,iy,1))/hz + &
                   hz*(-2*f(4,ix,iy,1)-f(4,ix,iy,2))/6
              bcc2(ix,iy)=bczmax(ix,iy)-bcc2(ix,iy)
           else if(ibczmax.eq.2) then
              bcc2(ix,iy)=bczmax(ix,iy)-f(4,ix,iy,1)
           end if
        end do
     end do
     !
     fwk(1,1:nz)=0.0_fp  ! values are all zero, only BC is set...
     do iy=1,ny
        do ix=1,nx
           call mkspline(z,nz,fwk, &
                ibczmin,bcc1(ix,iy),ibczmax,bcc2(ix,iy),ilinz,ier)
           if(ier.ne.0) return
           fcorr(1,ix,iy,1:nz)=fwk(2,1:nz)  ! fzz-correction
        end do
     end do
     !
     !  higher order corrections
     !
     zbc1=0.0_fp
     zbc2=0.0_fp
     !
     do iz=1,nz
        do iy=1,ny
           fwk(1,1:nx)=fcorr(1,1:nx,iy,iz)
           call mkspline(x,nx,fwk, &
                ibcxmin,zbc1,ibcxmax,zbc2,ilinx,ier)
           if(ier.ne.0) return
           fcorr(2,1:nx,iy,iz)=fwk(2,1:nx)  ! fxxzz-correction
        end do
     end do
     !
     do iz=1,nz
        do ix=1,nx
           fwk(1,1:ny)=fcorr(1,ix,1:ny,iz)
           call mkspline(y,ny,fwk, &
                ibcymin,zbc1,ibcymax,zbc2,iliny,ier)
           if(ier.ne.0) return
           fcorr(3,ix,1:ny,iz)=fwk(2,1:ny)  ! fyyzz-correction

           fwk(1,1:ny)=fcorr(2,ix,1:ny,iz)
           call mkspline(y,ny,fwk, &
                ibcymin,zbc1,ibcymax,zbc2,iliny,ier)
           if(ier.ne.0) return
           fcorr(4,ix,1:ny,iz)=fwk(2,1:ny)  ! fxxyyzz-correction
        end do
     end do
     !
     !  apply correction
     !
     do iz=1,nz
        do iy=1,ny
           do ix=1,nx
              f(4,ix,iy,iz)=f(4,ix,iy,iz)+fcorr(1,ix,iy,iz)
              f(6,ix,iy,iz)=f(6,ix,iy,iz)+fcorr(2,ix,iy,iz)
              f(7,ix,iy,iz)=f(7,ix,iy,iz)+fcorr(3,ix,iy,iz)
              f(8,ix,iy,iz)=f(8,ix,iy,iz)+fcorr(4,ix,iy,iz)
           end do
        end do
     end do
     !
     deallocate(fwk,fcorr,bcc1,bcc2)
     !
  end if
  !
  !  that's all
  !
  return
end subroutine mktricub

!
! 1-D
!

subroutine EZspline_derivative1(spline_o, i1, p1, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: i1
  real(fp), intent(in) :: p1
  real(fp), intent(out) :: f
  integer, intent(out) :: ier

  integer ifail

  integer ict_herm(2)
  integer ict(3)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1 < 0) then
     ier = 12
     return
  end if
  if(i1 > 3) then
     ier = 13
     return
  end if

  if(i1 >1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHermite==1 .or. spline_o%isLinear==1) then

     if(i1 == 1) then
        ict_herm = (/0, 1/)
     else
        ict_herm = (/1, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call herm1ev(p1, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%ilin1, &
             &   spline_o%fspl(1,1), &
             &   ict_herm, f, ifail)
     else
        call pc1ev(p1, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%ilin1, &
             &   spline_o%fspl(1,1), &
             &   ict_herm, f, ifail)
     end if

  else   

     call ezmake_ict1(i1,ict)

     call evspline(p1, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%ilin1, &
          &   spline_o%fspl(1,1), &
          &   ict, f, ifail)

  end if
  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative1

subroutine EZspline_derivative1_array(spline_o, i1, k1, p1, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline1) spline_o
  integer, intent(in) :: i1
  integer, intent(in) :: k1
  real(fp), intent(in) :: p1(k1)
  real(fp), intent(out) :: f(k1)
  integer, intent(out) :: ier

  integer ifail

  integer ict(3)
  integer ict_herm(2)
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1 < 0) then
     ier = 12
     return
  end if
  if(i1 > 3) then
     ier = 13
     return
  end if

  if(i1 >1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHermite==1 .or. spline_o%isLinear==1) then

     if(i1 == 1) then
        ict_herm = (/0, 1/)
     else
        ict_herm = (/1, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call vecherm1(ict_herm, k1, p1, k1, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%fspl(1,1), &
             & iwarn, ifail)
     else
        call vecpc1(ict_herm, k1, p1, k1, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%fspl(1,1), &
             & iwarn, ifail)
     end if

  else   

     call ezmake_ict1(i1,ict)

     call vecspline(ict, k1, p1, k1, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%fspl(1,1), &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative1_array


!!
!! 2-D
!!


subroutine EZspline_derivative2(spline_o, i1, i2, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: i1, i2
  real(fp), intent(in) :: p1, p2
  real(fp), intent(out) :: f
  integer, intent(out) :: ier

  integer ifail

  integer ict(6)
  integer ict_herm(4)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if(i1<0 .OR. i2<0) then
     ier = 12
     return
  end if
  if(max(i1,i2) > 3) then
     ier = 13
     return
  end if

  if(max(i1,i2) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHybrid == 1) then

     call ezmake_ict2(i1,i2,ict)

     call evintrp2d(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%hspline, spline_o%fspl(1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3),  &
          &   ict, f, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1) then
     if(i1 == 1 .AND. i2 == 0) then
        ict_herm = (/0, 1, 0, 0/) 
     else if(i1 == 0 .AND. i2 == 1) then
        ict_herm = (/0, 0, 1, 0/) 
     else if(i1 == 1 .AND. i2 == 1) then
        ict_herm = (/0, 0, 0, 1/) 
     else
        ict_herm = (/1, 0, 0, 0/) 
     end if

     if(spline_o%isLinear == 0) then
        call herm2ev(p1, p2, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%x2(1), spline_o%n2, &
             &   spline_o%ilin1, spline_o%ilin2, &
             &   spline_o%fspl(1,1,1), spline_o%n1, &
             &   ict_herm, f, ifail)
     else
        call pc2ev(p1, p2, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%x2(1), spline_o%n2, &
             &   spline_o%ilin1, spline_o%ilin2, &
             &   spline_o%fspl(1,1,1), spline_o%n1, &
             &   ict_herm, f, ifail)
     end if

  else

     call ezmake_ict2(i1,i2,ict)

     call evbicub(p1, p2, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%ilin1, spline_o%ilin2, &
          &   spline_o%fspl(1,1,1), spline_o%n1, &
          &   ict, f, ifail)

  end if
  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative2



subroutine EZspline_derivative2_array(spline_o, i1, i2, &
     & k1, k2, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: i1, i2, k1, k2
  real(fp), intent(in) :: p1(k1), p2(k2)
  real(fp), intent(out) :: f(k1,k2)
  integer, intent(out) :: ier

  integer ifail

  integer ict(6)
  integer ict_herm(4)

  real(fp), dimension(:), allocatable :: p1_cloud, p2_cloud
  integer k12
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1<0 .OR. i2<0) then
     ier = 12
     return
  end if
  if(max(i1,i2) > 3) then
     ier = 13
     return
  end if

  if(max(i1,i2) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  k12 = k1*k2
  allocate(p1_cloud(k12), p2_cloud(k12), stat=ifail)
  if(ifail /= 0) then
     ier = 32
     return
  end if

  p1_cloud = reshape( &
       & source=spread(source=p1, dim=2, ncopies=k2), &
       & shape=(/k12/))
  p2_cloud = reshape( &
       & source=spread(source=p2, dim=1, ncopies=k1), &
       & shape=(/k12/))

  if(spline_o%isHybrid == 1) then

     call ezmake_ict2(i1,i2,ict)

     call vecintrp2d(ict, k12, p1_cloud, p2_cloud, k12, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1)then
     if(i1 == 1 .AND. i2 == 0) then
        ict_herm = (/0, 1, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1) then
        ict_herm = (/0, 0, 1, 0/)
     else if(i1 == 1 .AND. i2 == 1) then
        ict_herm = (/0, 0, 0, 1/)
     else
        ict_herm = (/1, 0, 0, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call vecherm2(ict_herm, k12, p1_cloud, p2_cloud, k12, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%fspl(1,1,1), spline_o%n1, &
             & iwarn, ifail)
     else
        call vecpc2(ict_herm, k12, p1_cloud, p2_cloud, k12, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%fspl(1,1,1), spline_o%n1, &
             & iwarn, ifail)
     end if

  else

     call ezmake_ict2(i1,i2,ict)  ! higher derivatives

     call vecbicub(ict, k12, p1_cloud, p2_cloud, k12, f, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  end if


  if(ifail /= 0) ier = 96

  deallocate(p1_cloud, p2_cloud, stat=ifail)
  if(ifail /= 0) then
     ier = 33
     return
  end if


end subroutine EZspline_derivative2_array


subroutine EZspline_derivative2_cloud(spline_o, i1, i2, &
     & k, p1, p2, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline2) spline_o
  integer, intent(in) :: i1, i2, k
  real(fp), intent(in) :: p1(k), p2(k)
  real(fp), intent(out) :: f(k)
  integer, intent(out) :: ier

  integer ifail

  integer ict(6)
  integer ict_herm(4)
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1<0 .OR. i2<0) then
     ier = 12
     return
  end if
  if(max(i1,i2) > 3) then
     ier = 13
     return
  end if

  if(max(i1,i2) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHybrid == 1) then

     call ezmake_ict2(i1,i2,ict)

     call vecintrp2d(ict, k, p1, p2, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3),  &
          & iwarn, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1)then
     if(i1 == 1 .AND. i2 == 0) then
        ict_herm = (/0, 1, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1) then
        ict_herm = (/0, 0, 1, 0/)
     else if(i1 == 1 .AND. i2 == 1) then
        ict_herm = (/0, 0, 0, 1/)
     else
        ict_herm = (/1, 0, 0, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call vecherm2(ict_herm, k, p1, p2, &
             & k, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%fspl(1,1,1), spline_o%n1, &
             & iwarn, ifail)
     else
        call vecpc2(ict_herm, k, p1, p2, &
             & k, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%fspl(1,1,1), spline_o%n1, &
             & iwarn, ifail)
     end if

  else

     call ezmake_ict2(i1,i2,ict)

     call vecbicub(ict, k, p1, p2, &
          & k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%fspl(1,1,1), spline_o%n1, &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative2_cloud

!!!
!!! 3-D
!!!


subroutine EZspline_derivative3(spline_o, i1, i2, i3, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: i1, i2, i3
  real(fp), intent(in) :: p1, p2, p3
  real(fp), intent(out) :: f
  integer, intent(out) :: ier

  integer ifail

  integer ict(10)
  integer ict_herm(8)

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1<0 .OR. i2<0 .OR. i3<0) then
     ier = 12
     return
  end if
  if(max(i1,max(i2,i3)) > 3) then
     ier = 13
     return
  end if

  if(maxval((/i1,i2,i3/)) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHybrid == 1) then

     call ezmake_ict3(i1,i2,i3,ict)

     call evintrp3d(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%hspline, spline_o%fspl(1,1,1,1), &
          &   size(spline_o%fspl,1), size(spline_o%fspl,2), &
          &   size(spline_o%fspl,3), size(spline_o%fspl,4), &
          &   ict, f, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1)then
     if(i1 == 1 .AND. i2 == 0 .AND. i3 == 0) then
        ict_herm = (/0, 1, 0, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 1, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 1, 0, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 0, 0, 1, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 1, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 1, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 0, 1/)
     else
        ict_herm = (/1, 0, 0, 0, 0, 0, 0, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call herm3ev(p1, p2, p3, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%x2(1), spline_o%n2, &
             &   spline_o%x3(1), spline_o%n3, &
             &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
             &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             &   ict_herm, f, ifail)
     else
        call pc3ev(p1, p2, p3, &
             &   spline_o%x1(1), spline_o%n1, &
             &   spline_o%x2(1), spline_o%n2, &
             &   spline_o%x3(1), spline_o%n3, &
             &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
             &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             &   ict_herm, f, ifail)
     end if

  else

     call ezmake_ict3(i1,i2,i3,ict)

     call evtricub(p1, p2, p3, &
          &   spline_o%x1(1), spline_o%n1, &
          &   spline_o%x2(1), spline_o%n2, &
          &   spline_o%x3(1), spline_o%n3, &
          &   spline_o%ilin1, spline_o%ilin2, spline_o%ilin3, &
          &   spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          &   ict, f, ifail)

  end if
  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative3


subroutine EZspline_derivative3_array(spline_o, i1, i2, i3, &
     & k1, k2, k3, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: i1, i2, i3, k1, k2, k3
  real(fp), intent(in) :: p1(k1), p2(k2), p3(k3)
  real(fp), intent(out) :: f(k1,k2,k3)
  integer, intent(out) :: ier

  integer ifail

  integer ict(10)
  integer ict_herm(8)

  real(fp), dimension(:), allocatable :: p1_cloud, p2_cloud, p3_cloud
  integer k123
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1<0 .OR. i2<0 .OR. i3<0) then
     ier = 12
     return
  end if
  if(max(i1,max(i2,i3)) > 3) then
     ier = 13
     return
  end if

  if(maxval((/i1,i2,i3/)) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  k123 = k1*k2*k3
  allocate(p1_cloud(k123), p2_cloud(k123), p3_cloud(k123), stat=ifail)
  if(ifail /= 0) then
     ier = 32
     return
  end if

  p1_cloud = reshape(source=spread( &
       & source=spread(source=p1, dim=2, ncopies=k2), &
       & dim=3, ncopies=k3), shape=(/k123/))
  p2_cloud = reshape(source=spread( &
       & source=spread(source=p2, dim=1, ncopies=k1), &
       & dim=3, ncopies=k3), shape=(/k123/))
  p3_cloud = reshape(source=spread( &
       & source=spread(source=p3, dim=1, ncopies=k1), &
       & dim=2, ncopies=k2), shape=(/k123/))

  if(spline_o%isHybrid == 1) then

     call ezmake_ict3(i1,i2,i3,ict)

     call vecintrp3d(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1)then
     if(i1 == 1 .AND. i2 == 0 .AND. i3 == 0) then
        ict_herm = (/0, 1, 0, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 1, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 1, 0, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 0, 0, 1, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 1, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 1, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 0, 1/)
     else
        ict_herm = (/1, 0, 0, 0, 0, 0, 0, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call vecherm3(ict_herm, k123, p1_cloud, p2_cloud, p3_cloud, k123, &
             & f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%n3, spline_o%x3pkg(1,1), &
             & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             & iwarn, ifail)
     else
        call vecpc3(ict_herm, k123, p1_cloud, p2_cloud, p3_cloud, k123, &
             & f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%n3, spline_o%x3pkg(1,1), &
             & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             & iwarn, ifail)
     end if

  else

     call ezmake_ict3(i1,i2,i3,ict)

     call vectricub(ict, k123, p1_cloud, p2_cloud, p3_cloud, k123, f, &
          & spline_o%n1,spline_o%x1pkg(1,1), &
          & spline_o%n2,spline_o%x2pkg(1,1), &
          & spline_o%n3,spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  end if


  if(ifail /= 0) ier = 96

  deallocate(p1_cloud, p2_cloud, p3_cloud, stat=ifail)
  if(ifail /= 0) then
     ier = 33
     return
  end if


end subroutine EZspline_derivative3_array

subroutine EZspline_derivative3_cloud(spline_o, i1, i2, i3, &
     & k, p1, p2, p3, f, ier)
  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: i1, i2, i3, k
  real(fp), intent(in) :: p1(k), p2(k), p3(k)
  real(fp), intent(out) :: f(k)
  integer, intent(out) :: ier

  integer ifail

  integer ict(10)
  integer ict_herm(8)
  integer:: iwarn=0

  ier = 0
  ifail=0
  if( .not.EZspline_allocated(spline_o) .or. spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  f = 0.0_fp
  if(i1<0 .OR. i2<0 .OR. i3<0) then
     ier = 12
     return
  end if
  if(max(i1,max(i2,i3)) > 3) then
     ier = 13
     return
  end if

  if(maxval((/i1,i2,i3/)) > 1 .AND. (spline_o%isHermite==1 .or. spline_o%isLinear==1)) then
     ier = 24; if(spline_o%isLinear==1) ier = 46
     return
  end if

  if(spline_o%isHybrid == 1) then

     call ezmake_ict3(i1,i2,i3,ict)

     call vecintrp3d(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, spline_o%fspl(1,1,1,1), &
          & size(spline_o%fspl,1), size(spline_o%fspl,2), &
          & size(spline_o%fspl,3), size(spline_o%fspl,4), &
          & iwarn, ifail)

  else if(spline_o%isHermite==1 .or. spline_o%isLinear==1)then
     if(i1 == 1 .AND. i2 == 0 .AND. i3 == 0) then
        ict_herm = (/0, 1, 0, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 1, 0, 0, 0, 0, 0/)
     else if(i1 == 0 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 1, 0, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 0) then
        ict_herm = (/0, 0, 0, 0, 1, 0, 0, 0/)
     else if(i1 == 1 .AND. i2 == 0 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 1, 0, 0/)
     else if(i1 == 0 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 1, 0/)
     else if(i1 == 1 .AND. i2 == 1 .AND. i3 == 1) then
        ict_herm = (/0, 0, 0, 0, 0, 0, 0, 1/)
     else
        ict_herm = (/1, 0, 0, 0, 0, 0, 0, 0/)
     end if

     if(spline_o%isLinear == 0) then
        call vecherm3(ict_herm, k, p1, p2, p3, &
             & k, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%n3, spline_o%x3pkg(1,1), &
             & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             & iwarn, ifail)
     else
        call vecpc3(ict_herm, k, p1, p2, p3, &
             & k, f, &
             & spline_o%n1, spline_o%x1pkg(1,1), &
             & spline_o%n2, spline_o%x2pkg(1,1), &
             & spline_o%n3, spline_o%x3pkg(1,1), &
             & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
             & iwarn, ifail)
     end if

  else

     call ezmake_ict3(i1,i2,i3,ict)

     call vectricub(ict, k, p1, p2, p3, &
          & k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn, ifail)

  end if

  if(ifail /= 0) ier = 96

end subroutine EZspline_derivative3_cloud

subroutine mkintrp3d(x,nx,y,ny,z,nz,jspline, &
     f,icoeff,ixdim,iydim,izdim, &
     ibcxmin,bcxmin,ibcxmax,bcxmax, &
     ibcymin,bcymin,ibcymax,bcymax, &
     ibczmin,bczmin,ibczmax,bczmax, &
     ier)
  use iso_c_binding, only: fp => c_double
  !
  !  setup a tricubic spline, or tricubic Hermite, or hybrid linear/zonal 2d or
  !  1d with 1d or 2d cubic or Hermite spline interpolation
  !
  !
  !  input:
  implicit none
  integer nx                        ! length of x vector
  integer ny                        ! length of y vector
  integer nz                        ! length of z vector
  real(fp) :: x(nx)                        ! x vector, strict ascending
  real(fp) :: y(ny)                        ! y vector, strict ascending
  real(fp) :: z(nz)                        ! z vector, strict ascending
  !
  integer :: jspline(3)             ! interpolation method control
  !        (1) -- 1st dimension: -1: zone, 0: pclin, 1: Hermite, 2: spline
  !        (2) -- 2nd dimension: -1: zone, 0: pclin, 1: Hermite, 2: spline
  !        (3) -- 3rd dimension: -1: zone, 0: pclin, 1: Hermite, 2: spline
  !
  !    Standard interpolation-- all jspline values match
  !      e.g. jspline(1)=jspline(2)=jspline(3)=2 for tricubic spline
  !
  !    Hybrid interpolation-- not all jspline values are the same.
  !
  !    RESTRICTION: if any jspline(...) element has value 1, none can have
  !    value 2.  I.e. Spline and Hermite interpolation cannot currently be mixed.
  !    This restriction exists because of technical issues in the
  !    implementation (it could be removed in principle but the work to do
  !    this has not been scheduled).
  !
  !  coefficient buffer dimensions
  integer :: icoeff                 ! #coefficients per data point
  integer :: ixdim                  ! nx; nx-1 if jspline(1)==-1
  integer :: iydim                  ! ny; ny-1 if jspline(2)==-1
  integer :: izdim                  ! nz; nz-1 if jspline(3)==-1
  !  input/output:
  real(fp) :: f(icoeff,ixdim,iydim,izdim)  ! data and spline coefficients
  !
  !  boundary condition data
  !    Contiguous storage is assumed-- 1st dimension size must match
  !      actual use
  !
  !
  integer ibcxmin,ibcxmax           ! BC type flag @xmin, xmax
  integer ibcymin,ibcymax           ! BC type flag @ymin, ymax
  integer ibczmin,ibczmax           ! BC type flag @zmin, zmax
  !
  real(fp) :: bcxmin(iydim,izdim),bcxmax(iydim,izdim) ! xmin & xmax BC data
  real(fp) :: bcymin(ixdim,izdim),bcymax(ixdim,izdim) ! ymin & ymax BC data
  real(fp) :: bczmin(ixdim,iydim),bczmax(ixdim,iydim) ! zmin & zmax BC data
  !
  !  where BC data is not required, dummy scalars may be passed.
  !  the ibc* flags determine whether BC data isneeded.
  !
  !  BC data not required for zonal or piecewise linear interpolation
  !  for Hermite interpolation ibc* values from set {-1,0,1} are accepted.
  !
  !  BC data:  bcxmin & bcxmax:  BC vs. y,z @xmin,xmax
  !            bcymin & bcymax:  BC vs. x,z @ymin,ymax
  !            bczmin & bczmax:  BC vs. x,y @zmin,zmax
  !
  !   ibcxmin -- indicator for boundary condition at xmin=x(1):
  !    bcxmin(...) -- boundary condition data
  !     =-1 -- use periodic boundary condition
  !     =0 -- use "not a knot"
  !     =1 -- match slope, specified at x(1),y(iy),z(iz) by bcxmin(iy,iz)
  !     =2 -- match 2nd derivative, specified at x(1),y(iy),z(iz)
  !           by bcxmin(iy,iz
  !     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all y(j)
  !     =4 -- boundary condition is d2f/dx2=0 at x(1), all y(j)
  !     =5 -- df/dx BC from 1st divided difference
  !     =6 -- d2f/dx2 BC from 2nd divided difference (parabolic fit)
  !     =7 -- d3f/dx3 BC from 3rd divided difference (cubic fit)
  !   ***NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
  !
  !   ibcxmax -- indicator for boundary condition at x(nx):
  !    bcxmax(...) -- boundary condition data
  !     (interpretation as with ibcxmin, bcxmin)
  !     NOTE:  if ibcxmin=-1 then the periodic BC applies on both sides
  !            and ibcxmax, bcxmax are ignored.
  !
  !   interpretation of ibcymin,bcymin,ibcymax,bcymax
  !     is same as with ibcxmin,...
  !
  !   interpretation of ibczmin,bczmin,ibczmax,bczmax
  !     is same as with ibcxmin,...
  !
  !   the explicit bdy condition arrays are referenced only if the
  !     corresponding "ibc" flag values are set > 0.
  !
  integer ier                       ! exit code
  !   ier -- completion code, 0 for normal
  !
  !-----------------------
  integer :: kspline
  integer :: ii,jj,imul,imin,imax,ickx,icky,ickz,inum
  integer :: idum1,idum2,idum3,idimcu
  integer :: ipx,ipy,ipz
  real(fp) :: ztol = 0.0001_fp
  logical :: ifound(-1:2)

  real(fp), dimension(:,:), allocatable :: wk2
  real(fp), dimension(:,:,:), allocatable :: wk3
  !-----------------------
  !
  ier=0
  !
  imin=3
  imax=-2
  imul=1
  inum=0
  idimcu=0
  ifound = .FALSE.

  do ii=1,3
    imin=min(imin,jspline(ii))
    imax=max(imax,jspline(ii))
    if(jspline(ii).gt.0) then
      idimcu=idimcu+1
      imul=imul*2
    end if
    if(.not.ifound(jspline(ii))) then
      ifound(jspline(ii)) = .TRUE.
      inum = inum+1
    end if
  end do

  if((imin.lt.-1).or.(imax.gt.2)) then
    ier = 1
    write(6,*) ' ?mkintrp3d: spline type control out of range -1 to 2: ', jspline
  end if
  if(ier.ne.0) return

  if(inum.eq.1) then
    kspline=imin   ! same interp type on all dimensions
  else
    kspline=-99    ! hybrid
    if(ifound(1).and.ifound(2)) then
      ier = 1
      write(6,*) &
           ' ?mkintrp3d: spline/Hermite hybrid not supported (', &
           jspline,')'
    end if
  end if
  if(ier.ne.0) return
  !
  if(imul.ne.icoeff) then
    write(6,*) &
         ' ?coeff dimension inconsistency for spline type codes ', &
         jspline
    write(6,*) ' in mkintrp3d: expected: ',imul,' got: ',icoeff
    ier=1
    return
  end if
  !
  !
  !  check dimensioning consistency
  !
  if(jspline(1).eq.-1) then
    ickx=nx-1
  else
    ickx=nx
  end if
  !
  if(jspline(2).eq.-1) then
    icky=ny-1
  else
    icky=ny
  end if
  !
  if(jspline(3).eq.-1) then
    ickz=nz-1
  else
    ickz=nz
  end if
  !
  if((ickx.ne.ixdim).or.(icky.ne.iydim).or.(ickz.ne.izdim)) then
    write(6,*) &
         ' ?mkintrp2d: dimensioning inconsistent with '// &
         'interpolation controls: ',jspline
    write(6,*) '  expected: ',ickx,icky,ickz, &
         '; got: ',ixdim,iydim,izdim
    ier=1
    return
  end if
  !
  if(jspline(1).le.0) then
    call splinck(x,nx,idum1,ztol,ier)
    if(ier.ne.0) then
      write(6,*) ' ?mkintrp2d: x axis not strict ascending.'
      return
    end if
  end if
  !
  if(jspline(2).le.0) then
    call splinck(y,ny,idum1,ztol,ier)
    if(ier.ne.0) then
      write(6,*) ' ?mkintrp2d: y axis not strict ascending.'
      return
    end if
  end if
  !
  if(jspline(3).le.0) then
    call splinck(z,nz,idum1,ztol,ier)
    if(ier.ne.0) then
      write(6,*) ' ?mkintrp2d: z axis not strict ascending.'
      return
    end if
  end if
  !
  !  if no work to be done: exit now
  if(imul.eq.1) return
  !
  !  check Hermite BCs if necessary
  !
  if(jspline(1).eq.1) then
    if((min(ibcxmin,ibcxmax).lt.-1).or. &
         (max(ibcxmin,ibcxmax).gt.1)) then
      write(6,*) ' ?mkintrp2d: Bdy Cond code out of range for'
      write(6,*) '  Hermite interpolation; (-1:1) allowed, '// &
           'found: ',ibcxmin,ibcxmax
      ier=1
      return
    end if
    ipx=0
    if(ibcxmin.eq.-1) then
      ipx=1
    else if((ibcxmin.eq.1).or.(ibcxmax.eq.1)) then
      ipx=2
    end if
  end if
  !
  if(jspline(2).eq.1) then
    if((min(ibcymin,ibcymax).lt.-1).or. &
         (max(ibcymin,ibcymax).gt.1)) then
      write(6,*) ' ?mkintrp2d: Bdy Cond code out of range for'
      write(6,*) '  Hermite interpolation; (-1:1) allowed, '// &
           'found: ',ibcymin,ibcymax
      ier=1
      return
    end if
    ipy=0
    if(ibcymin.eq.-1) then
      ipy=1
    else if((ibcymin.eq.1).or.(ibcymax.eq.1)) then
      ipy=2
    end if
  end if
  !
  if(jspline(3).eq.1) then
    if((min(ibczmin,ibczmax).lt.-1).or. &
         (max(ibczmin,ibczmax).gt.1)) then
      write(6,*) ' ?mkintrp2d: Bdy Cond code out of range for'
      write(6,*) '  Hermite interpolation; (-1:1) allowed, '// &
           'found: ',ibczmin,ibczmax
      ier=1
      return
    end if
    ipz=0
    if(ibczmin.eq.-1) then
      ipz=1
    else if((ibczmin.eq.1).or.(ibczmax.eq.1)) then
      ipz=2
    end if
  end if
  !
  if(kspline.eq.1) then
    ! tricubic Hermite

    ! put the BCs inside the function data at the right locations...
    call util_bcherm3(f, ixdim, iydim, izdim, &
         ibcxmin,ibcxmax, ibcymin,ibcymax, ibczmin,ibczmax, &
         bcxmin, bcxmax,  bcymin, bcymax,  bczmin, bczmax, &
         x, y, z)

    call akherm3p(x,ixdim, y,iydim, z,izdim, f,ixdim,iydim, &
         idum1,idum2,idum3, ipx,ipy,ipz, ier)

  else if(kspline.eq.2) then
    ! tricubic Spline

    call mktricub(x,nx,y,ny,z,nz, &
         f,ixdim,iydim, &
         ibcxmin,bcxmin,ibcxmax,bcxmax,iydim, &
         ibcymin,bcymin,ibcymax,bcymax,ixdim, &
         ibczmin,bczmin,ibczmax,bczmax,ixdim, &
         idum1,idum2,idum3, ier)

  else
     ! Hybrid
    if(idimcu.eq.1) then
      ! cubic along 1 dimension; other dims are step or pclin

      if(jspline(1).gt.0) then
        ! cubic in x direction
        do jj=1,izdim
          do ii=1,iydim
            if(jspline(1).eq.1) then
              call util_bcherm1(f(1,1,ii,jj), ixdim, &
                   ibcxmin, ibcxmax, &
                   bcxmin(ii,jj), bcxmax(ii,jj), x)
              call akherm1p(x,ixdim,f(1,1,ii,jj),idum1,ipx, &
                   ier)

            else if(jspline(1).eq.2) then
              call mkspline(x,ixdim,f(1,1,ii,jj), &
                   ibcxmin,bcxmin(ii,jj), &
                   ibcxmax,bcxmax(ii,jj), &
                   idum1,ier)
            end if
            if(ier.ne.0) exit
          end do
          if(ier.ne.0) exit
        end do

      else if(jspline(2).gt.0) then
        ! cubic in y direction
        allocate(wk2(2,ny))

        do jj=1,izdim
          do ii=1,ixdim
            wk2(1,1:iydim) = f(1,ii,1:iydim,jj)
            wk2(2,1:iydim) = 0.0_fp
            if(jspline(2).eq.1) then
              call util_bcherm1(wk2, iydim, &
                   ibcymin, ibcymax, &
                   bcymin(ii,jj), bcymax(ii,jj), y)
              call akherm1p(y,iydim,wk2,idum2,ipy,ier)

            else if(jspline(2).eq.2) then
              call mkspline(y,iydim,wk2, &
                   ibcymin,bcymin(ii,jj), &
                   ibcymax,bcymax(ii,jj), &
                   idum2,ier)

            end if
            if(ier.ne.0) exit
            f(1:2,ii,1:iydim,jj) = wk2(1:2,1:iydim)
          end do
          if(ier.ne.0) exit
        end do

        deallocate(wk2)

      else
        ! cubic in z direction
        allocate(wk2(2,nz))

        do jj=1,iydim
          do ii=1,ixdim
            wk2(1,1:izdim) = f(1,ii,jj,1:izdim)
            wk2(2,1:izdim) = 0.0_fp
            if(jspline(3).eq.1) then
              call util_bcherm1(wk2, izdim, &
                   ibczmin, ibczmax, &
                   bczmin(ii,jj), bczmax(ii,jj), z)
              call akherm1p(z,izdim,wk2,idum2,ipz,ier)

            else if(jspline(3).eq.2) then
              call mkspline(z,izdim,wk2, &
                   ibczmin,bczmin(ii,jj), &
                   ibczmax,bczmax(ii,jj), &
                   idum2,ier)

            end if
            if(ier.ne.0) exit
            f(1:2,ii,jj,1:izdim) = wk2(1:2,1:izdim)
          end do
          if(ier.ne.0) exit
        end do

        deallocate(wk2)

      end if
    else
      ! cubic along 2 dimensions
      if(jspline(3).le.0) then
        do ii=1,izdim
          if(jspline(1).eq.1) then
            call util_bcherm2(f(1,1,1,ii),ixdim,iydim, &
                 ibcxmin, ibcxmax, ibcymin, ibcymax, &
                 bcxmin(1,ii), bcxmax(1,ii), &
                 bcymin(1,ii), bcymax(1,ii), &
                 x,y)
            call akherm2p(x,ixdim,y,iydim,f(1,1,1,ii),ixdim, &
                 idum1,idum2,ipx,ipy,ier)
          else
            call mkbicub(x,ixdim,y,iydim,f(1,1,1,ii),ixdim, &
                 ibcxmin, bcxmin(1,ii), ibcxmax, bcxmax(1,ii), &
                 ibcymin, bcymin(1,ii), ibcymax, bcymax(1,ii), &
                 idum1,idum2,ier)
          end if
          if(ier.ne.0) exit
        end do

      else if(jspline(2).le.0) then
        allocate(wk3(4,nx,nz))

        do ii=1,iydim
          wk3 = f(1:4,1:nx,ii,1:nz)
          if(jspline(1).eq.1) then
            call util_bcherm2(wk3,ixdim,izdim, &
                 ibcxmin, ibcxmax, ibczmin, ibczmax, &
                 bcxmin(ii,1:nz), bcxmax(ii,1:nz), &
                 bczmin(1,ii), bczmax(1,ii), x, z)
            call akherm2p(x,ixdim,z,izdim,wk3,ixdim, &
                 idum1,idum2,ipx,ipz,ier)
          else
            call mkbicub(x,ixdim,z,izdim,wk3,ixdim, &
                 ibcxmin,bcxmin(ii,1:nz), &
                 ibcxmax,bcxmax(ii,1:nz), &
                 ibczmin,bczmin(1,ii), ibczmax,bczmax(1,ii), &
                 idum1,idum2,ier)
          end if
          if(ier.ne.0) exit
          f(1:4,1:nx,ii,1:nz) = wk3
        end do

        deallocate(wk3)

      else
        allocate(wk3(4,ny,nz))

        do ii=1,ixdim
          wk3 = f(1:4,ii,1:ny,1:nz)
          if(jspline(2).eq.1) then
            call util_bcherm2(wk3,iydim,izdim, &
                 ibcymin, ibcymax, ibczmin, ibczmax, &
                 bcymin(ii,1:nz), bcymax(ii,1:nz), &
                 bczmin(ii,1:ny), bczmax(ii,1:ny), y, z)
            call akherm2p(y,iydim,z,izdim,wk3,iydim, &
                 idum1,idum2,ipy,ipz,ier)
          else
            call mkbicub(y,iydim,z,izdim,wk3,iydim, &
                 ibcymin,bcymin(ii,1:nz), &
                 ibcymax,bcymax(ii,1:nz), &
                 ibczmin,bczmin(ii,1:ny), &
                 ibczmax,bczmax(ii,1:ny), &
                 idum1,idum2,ier)
          end if
          if(ier.ne.0) exit
          f(1:4,ii,1:ny,1:nz) = wk3
        end do

        deallocate(wk3)

      end if
    end if

  end if

  return
end subroutine mkintrp3d

subroutine mkherm2(fun,x,nx,y,ny,fherm)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, from evaluation of
  !  function and derivatives.  function of 2 indep. coordinates.
  !
  !  input:
  !
  !============
  implicit none
  integer ny,nx,ix,iy
  !============
  real(fp) :: fun,dfdx,dfdy,d2fdxdy
  !============
  external fun                      ! passed real function(x,y)
  real(fp) :: x(nx)                        ! x coordinate array
  real(fp) :: y(ny)                        ! y coordinate array
  !
  !  the passed function fun must have the interface:
  !
  !        real function <name>(x,y,dfdx,dfdy,d2fdxdy)
  !  where x,y are input, the function returns the function value,
  !  and the arguments dfdx and dfdy return as output the function
  !  derivative at the point (x,y).
  !
  !  output:
  !
  real(fp) :: fherm(0:3,nx,ny)             ! function data & derivatives
  !
  !  fherm(0,i,j) = function value f at x(i),y(j)
  !  fherm(1,i,j) = derivative df/dx at x(i),y(j)
  !  fherm(2,i,j) = derivative df/dy at x(i),y(j)
  !  fherm(3,i,j) = derivative d2f/dxdy at x(i),y(j)
  !
  !----------------------------
  !
  do ix=1,nx
     do iy=1,ny
        fherm(0,ix,iy)=fun(x(ix),y(iy),dfdx,dfdy,d2fdxdy)
        fherm(1,ix,iy)=dfdx
        fherm(2,ix,iy)=dfdy
        fherm(3,ix,iy)=d2fdxdy
     end do
  end do
  !
  return
end subroutine mkherm2

#include "fpreproc/byte_declare.h"

!
! A set of utilities for writing to a log file
!
! example of usage:
!
!    integer :: i = 47
!    real*8  :: d = 3.14159e17
!
!    call openLog("mylog.log",icpu=7,numcpu=16)     ! if not opened, logging goes to portlib_<pid>.log
!
!    call setLogLevel(INFO_LEVEL)  ! default log level = WARN_LEVEL to show warnings and errors only
!
!    call infoLog("just an info message")
!    call infoLog("just an info message with i = ",i)
!    call infoLog("just an info message with d = ",d)
!
!    call warnLog("just a warn message")
!    call gosleep(1)
!    call warnLog("just a warn message with i = ",i)
!    call warnLog("just a warn message with d = ",d)
!
!    call errorLog("just an error message")
!    call errorLog("just an error message with i = ",i)
!    call gosleep(1)
!    call errorLog("just an error message with d = ",d)
!   
!    call warnLog("enable buffering and no time stamps")
!
!    if (logLevel()>=INFO_LEVEL) then
!      call setLogBuffered(.true.)     ! do not flush after each log message
!      call setLogTime(.false.)        ! do not time stamp log messages
!
!      call infoLog("some more detailed messages")
!
!      write(logline,'(a,i2,a,e12.4)') 'vec(',i,') = ',d
!      call infoLog(logline)
!
!      call setLogTime(.true.)
!      call setLogBuffered(.false.)     ! flush buffers
!    end if
!   
!    call warnLog("time stamps enabled")
!
! with output in mylog_07.log,
!    
!    23Jul2009 12:32:17.26 [07] -openLog: PID=17767
!    23Jul2009 12:32:17.26 [07] %just an info message
!    23Jul2009 12:32:17.26 [07] %just an info message with i =47
!    23Jul2009 12:32:17.26 [07] %just an info message with d =3.141593e+17
!    23Jul2009 12:32:17.26 [07] !just a warn message
!    23Jul2009 12:32:18.26 [07] !just a warn message with i =47
!    23Jul2009 12:32:18.26 [07] !just a warn message with d =3.141593e+17
!    23Jul2009 12:32:18.26 [07] ?just an error message
!    23Jul2009 12:32:18.26 [07] ?just an error message with i =47
!    23Jul2009 12:32:19.26 [07] ?just an error message with d =3.141593e+17
!    23Jul2009 12:32:19.26 [07] !enable buffering and disable time stamps
!    [07] %some more detailed messages
!    [07] %vec(47) =   0.3142E+18
!    23Jul2009 12:32:19.26 [07] !time stamps enabled
!
! Mods
!    22Dec2009    Jim.Conboy@cffe.ac.uk
!                 cstring(trim(),  => cstr_2C(trim(), 
!                 [ Former invalid under debug compilation ]
!
!    16Dec2009    Jim.Conboy@cffe.ac.uk
!                 Added errLogOpen to log file open errors
!----------------------------------------------------------------------------
module logmod
#ifdef __MPI
  use mpi
#endif
  integer, parameter, public :: INFO_LEVEL  = 0   ! log level for info messages
  integer, parameter, public :: WARN_LEVEL  = 1   ! log level for warning messages
  integer, parameter, public :: ERROR_LEVEL = 2   ! log level for error messages
  integer, parameter, public :: NOMSG_LEVEL = 3   ! log level for no messages

  character*132, save :: logline   ! a utility string

  ! --- internal ---
  interface infoLog
     module procedure infoLogMsg, infoLogInt, infoLogFloat, &
                      infoLogMsg2,infoLogInt2,infoLogFloat2, &
                      infoLogLogical
  end interface

  interface warnLog
     module procedure warnLogMsg, warnLogInt, warnLogFloat
  end interface

  interface errorLog
     module procedure errorLogMsg, errorLogInt, errorLogFloat
  end interface

  interface setLogLevel
     module procedure setLogLevelInt, setLogLevelString
  end interface
  
  private
  public logline, infoLog, warnLog, errorLog
  public openLog, closeLog, getLogName, setLogLevel, setLogBuffered, logLevel, setLogTime
  public errLogOpen, errLogAlloc
  public enterLog, exitLog, isOpenLog

contains
  !
  ! ------ openLog ------
  ! Open a log file.  The status flag is similar to fortran's open
  ! statment.  A log file will be automatically opened to portlib_<processID>.log
  ! if a message is written but a log file is not currently open.
  !
  !   status = 'ONCE'    -> do nothing if already open otherwise like 'REPLACE' (default)
  !          = 'NEW'     -> new file created, error if file already exists
  !          = 'OLD'     -> reopen an existing file and append new messages
  !          = 'REPLACE' -> if old file exists, delete and open a new file
  !          = 'RENAME' ->  if old file exists, rename old file as <file.name>~  and open a new file
  !
  ! If there is an error and iostat is not present, a message will be written
  ! to stderr and the error will be ignored.
  !
  ! If ICPU>=0 is given, then the file name will be modified to accommodate the cpu index
  ! and the cpu index will be included in each message which is written.  As an example
  !   FILE='foo.log', ICPU=7, NUMCPU=16  will create the log file 'foo_07.log'
  !
  ! After opening a new log file, a header line will be printed with the flag '-' and
  ! it will contain the process id, such as
  !    23Jul2009 13:43:02.09 -openLog: PID=18475
  !
  ! The LOG_LEVEL environment variable will be used to set the logging level in openLog
  ! unless getenv=.false. is present,
  !    LOG_LEVEL=0   -> info
  !    LOG_LEVEL=1   -> warning
  !    LOG_LEVEL=2   -> error
  !    LOG_LEVEL=3   -> no log messages except the header line
  !
  subroutine openLog(file,status,iostat,ic_myid,comm_world,icpu, numcpu,getenv)
    character*(*),          intent(in)  :: file    ! name of the log file
    character*(*),optional, intent(in)  :: status  ! open status flag
    integer,      optional, intent(out) :: iostat  ! 0->ok, nonzero->error
    integer,      optional, intent(out) :: ic_myid ! return myid# incorporated into the log file name
    integer,      optional, intent(in)  :: comm_world ! communicator
    integer,      optional, intent(in)  :: icpu    ! index of cpu or -1 if no cpus -- this is indexed from 0
    integer,      optional, intent(in)  :: numcpu  ! maximum number of cpus
    logical,      optional, intent(in)  :: getenv  ! if .true., then fetch the environment variable LOG_LEVEL
                                                   ! and use it to set the initial logging level (default .true.)

    character*10 :: lstatus  ! lower case status

    byte_declare :: name(len(file)+1) ! C file name
    byte_declare :: st(2)             ! single character status for C

    integer :: ier      ! error flag
    integer :: ig       ! nonzero to set log level from LOG_LEVEL environment variable
    integer :: ic, mc   ! cpu index and maximum number of cpus
    integer :: mpierr
    integer :: myid 

    integer, SAVE :: numprocs = 0
    integer, SAVE :: icpu_get    ! index of cpu or -1 if no cpus -- this is indexed from 0
    integer, SAVE :: numcpu_get  ! maximum number of cpus when icpu>=0
   
    if (present(comm_world)) then !ignore icpu and numcpu
       if(numprocs.eq.0) then
#ifdef __MPI
          call MPI_COMM_RANK(comm_world,myid,mpierr)
          call MPI_COMM_SIZE(comm_world,numprocs,mpierr)
#else
          numprocs=1
          myid=0
#endif

          numcpu_get= numprocs
          icpu_get=myid

       endif

       ic=icpu_get
       
       mc=numcpu_get

    else
       ic = -1
       if (present(icpu)) ic=icpu
       
       mc = -1
       if (present(numcpu)) mc=numcpu
       
    endif
    ier=0

    lstatus = 'once'
    if (present(status)) lstatus = status

    ig=1
    if (present(getenv)) then
       if (.not. getenv) ig=0
    end if

    call ulower(lstatus)
    if (lstatus=='once') then
       call cstr_2C('1', st, '2C') 
    else if (lstatus=='new') then
       call cstr_2C('n', st, '2C')
    else if (lstatus=='old') then
       call cstr_2C('a', st, '2C')
    else if (lstatus=='replace') then
       call cstr_2C('r', st, '2C')
    else if (lstatus=='rename') then
       call cstr_2C('m', st, '2C')
    else
       print '(a)',"?openLog: unknown status option = "//trim(lstatus)
       ier=1 ; goto 100
    end if

    call cstr_2C(trim(file),name,'2C')
       
    call c_openlog(name(1), st(1), ier,comm_world ,ic, mc, ig)

100 continue
    if (present(iostat)) iostat=ier
    if (present(ic_myid)) ic_myid=ic
  end subroutine openLog

  !
  ! ----- closeLog -----
  ! Close an open log file.
  !
  ! If there is an error and iostat is not present, a message will be written
  ! to stderr and the error will be ignored.
  !
  subroutine closeLog(iostat)
    integer,      optional, intent(out) :: iostat  ! 0->ok, nonzero->error
    
    integer :: ier   ! error flag

    ier=0

    call c_closelog(ier)
    if (present(iostat)) iostat=ier
  end subroutine closeLog

  !
  ! ------- isOpenLog --------
  ! Return true if the log file is open
  !
  function isOpenLog() result(isopen)
    logical :: isopen   ! true if log file is open

    integer, external :: c_isopenlog

    isopen = c_isopenlog()/=0
  end function isOpenLog

  !
  ! ------ getLogName -----
  ! Return the name of the open log file.
  !
  subroutine getLogName(file, ier) 
    character*(*), intent(out) :: file   ! returned file name
    integer,       intent(out) :: ier    ! nonzero on error
                                         !   -1 -> no open log file
                                         !   -2 -> file name was too small

    byte_declare :: name(len(file)+1) ! C file name

    file = " "

    call c_getlogname(size(name), name, ier)
    if (ier<0) return
    ier=0
       
    call cstring(file, name, '2F')
    file = adjustl(trim(file))
  end subroutine getLogName

  !
  ! ------ setLogLevelString ------
  ! Set the level of logging by name.  The levels should be used as,
  !
  ! level --  "INFO","WARN","ERR","NOMSG" or "0", "1", "2", "3"
  !
  !   0 -> info level, detailed information not to be used for production runs
  !   1 -> warn level (default), typically used to mark entrance and exit
  !        of major subroutines or other significant messages
  !   2 -> error level, used to write an error before aborting the execution
  !   3 -> no log messages
  !
  subroutine setLogLevelString(level)
    character*(*),optional, intent(in) :: level  ! level as a string

    character*10 :: l_level  ! lower case level
    integer      :: ilevel   ! 0->info, 1->warn, 2->error, 3->no message

    ilevel = 1

    if (present(level)) then
       l_level = adjustl(level)
       call ulower(l_level)

       if (len_trim(l_level)>2) then
          if (l_level(1:3)=='inf') ilevel=0
          if (l_level(1:3)=='war') ilevel=1
          if (l_level(1:3)=='err') ilevel=2
          if (l_level(1:3)=='nom') ilevel=3
       else if (len_trim(l_level)>0) then
          if (l_level(1:1)=='0') ilevel=0
          if (l_level(1:1)=='1') ilevel=1
          if (l_level(1:1)=='2') ilevel=2
          if (l_level(1:1)=='3') ilevel=3
       end if
    end if
    call c_setloglevel(ilevel)
  end subroutine setLogLevelString

  !
  ! ------ setLogLevelInt ------
  ! Set the level of logging by integer.  The levels should be used as,
  !
  !   0 -> info level, detailed information not to be used for production runs
  !   1 -> warn level (default), typically used to mark entrance and exit
  !        of major subroutines or other significant messages
  !   2 -> error level, used to write an error before aborting the execution
  !   3 -> no log messages
  !
  subroutine setLogLevelInt(klevel)
    integer,intent(in) :: klevel  ! 0->info, 1->warn, 2->error, 3->no message

    integer :: ilevel 
    
    ilevel = min(3,max(0,klevel))

    call c_setloglevel(ilevel)
  end subroutine setLogLevelInt

  !
  ! ------- logLevel ------
  ! Return the logging level
  !
  integer function logLevel()
    integer, external :: c_loglevel

    logLevel = c_loglevel()
  end function logLevel

  !
  ! ------- setLogBuffered -----
  ! Change whether the log file is being buffered.  The default is unbuffered.
  !
  subroutine setLogBuffered(ibuff)
    logical, intent(in) :: ibuff   ! .true. for buffered output, .false. for unbuffered
    integer :: ib                  ! integer logical

    ib=0
    if (ibuff) ib=1 

    call c_setlogbuffered(ib)
  end subroutine setLogBuffered

  !
  ! ------- setLogTime -----
  ! Change whether the log file time stamps the messages.  Default is true.
  !
  subroutine setLogTime(itime)
    logical, intent(in) :: itime   ! .true. for time stamped output
    integer :: it                  ! integer logical

    it=0
    if (itime) it=1 

    call c_setlogtime(it)
  end subroutine setLogTime

  !
  ! ----- enterLog ------
  ! Write out a warn level log message of the form
  ! ... \Enter\ msg
  !
  ! This is used for tagging entry to a subroutine or code block and should
  ! be paired with an exitLog(msg)
  !
  subroutine enterLog(msg)
    character*(*), intent(in) :: msg   ! subroutine or code block name

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (WARN_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_enterlog(cmsg)
  end subroutine enterLog

  !
  ! ----- exitLog ------
  ! Write out a warn level log message of the form
  ! ... /Exit/ msg
  !
  ! This is used for tagging entry to a subroutine or code block and should
  ! be paired with an enterLog(msg)
  !
  subroutine exitLog(msg)
    character*(*), intent(in) :: msg   ! subroutine or code block name

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (WARN_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_exitlog(cmsg)
  end subroutine exitLog

  !
  ! ----- infoLog ------
  ! Write out an info level log message optionally with an integer (format I9)
  ! or double (format ES24.16) value.
  !
  ! INFO_LEVEL messages are tagged with the flag '%'
  !
  subroutine infoLogMsg2(cSr, cmsg)
    character*(*), intent(in) :: cSr    ! log message
    character*(*), intent(in) :: cmsg   ! log message
  !
    call infoLogMsg( cSr//' -I- '//cmsg )
    return
  end subroutine infoLogMsg2

  subroutine infoLogMsg(msg)
    character*(*), intent(in) :: msg   ! log message

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (INFO_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_infolog(cmsg)
  end subroutine infoLogMsg

  subroutine infoLogInt2(cSr, cmsg, ivalue )
    character*(*), intent(in) :: cSr      ! log message
    character*(*), intent(in) :: cmsg     ! log message
    integer,       intent(in) :: ivalue   ! integer value
  !
    call infoLogInt( cSr//' -I- '//cmsg, ivalue )
    return
  end subroutine infoLogInt2

  subroutine infoLogInt(msg, ivalue)
    character*(*), intent(in) :: msg     ! log message
    integer,       intent(in) :: ivalue  ! integer value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (INFO_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_infologi(cmsg,ivalue)
  end subroutine infoLogInt

  subroutine infoLogLogical(msg, lvalue)
    character*(*), intent(in) :: msg     ! log message
    logical,       intent(in) :: lvalue  ! logical value
    integer                   :: ivalue

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (INFO_LEVEL<c_loglevel()) return

    ivalue = 0
    if (lvalue) ivalue = 1

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_infologi(cmsg,ivalue)
  end subroutine infoLogLogical

  subroutine infoLogFloat2(cSr, cmsg, dvalue )
    character*(*), intent(in) :: cSr      ! log message
    character*(*), intent(in) :: cmsg     ! log message
    real*8,        intent(in) :: dvalue   ! double value
  !
    call infoLogFloat( cSr//' -I- '//cmsg, dvalue )
    return
  end subroutine infoLogFloat2

  subroutine infoLogFloat(msg, dvalue)
    character*(*), intent(in) :: msg     ! log message
    real*8,        intent(in) :: dvalue  ! double value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (INFO_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_infologd(cmsg,dvalue)
  end subroutine infoLogFloat

  !
  ! ----- warnLog ------
  ! Write out a warn level log message optionally with an integer (format I9)
  ! or double (format ES24.16) value.
  !
  ! WARN_LEVEL messages are tagged with the flag '!'
  !
  subroutine warnLogMsg(msg)
    character*(*), intent(in) :: msg   ! log message

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (WARN_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_warnlog(cmsg)
  end subroutine warnLogMsg

  subroutine warnLogInt(msg, ivalue)
    character*(*), intent(in) :: msg     ! log message
    integer,       intent(in) :: ivalue  ! integer value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (WARN_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_warnlogi(cmsg,ivalue)
  end subroutine warnLogInt

  subroutine warnLogFloat(msg, dvalue)
    character*(*), intent(in) :: msg     ! log message
    real*8,        intent(in) :: dvalue  ! double value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (WARN_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_warnlogd(cmsg,dvalue)
  end subroutine warnLogFloat

  !
  ! ----- errorLog ------
  ! Write out an error level log message optionally with an integer (format I9)
  ! or double (format ES24.16) value.
  !
  ! ERROR_LEVEL messages are tagged with the flag '?'
  !
  subroutine errorLogMsg(msg)
    character*(*), intent(in) :: msg   ! log message

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (ERROR_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_errorlog(cmsg)
  end subroutine errorLogMsg

  subroutine errorLogInt(msg, ivalue)
    character*(*), intent(in) :: msg     ! log message
    integer,       intent(in) :: ivalue  ! integer value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (ERROR_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_errorlogi(cmsg,ivalue)
  end subroutine errorLogInt

  subroutine errorLogFloat(msg, dvalue)
    character*(*), intent(in) :: msg     ! log message
    real*8,        intent(in) :: dvalue  ! double value

    integer, external :: c_loglevel       ! get current log level
    byte_declare      :: cmsg(len(msg)+1) ! C message

    if (ERROR_LEVEL<c_loglevel()) return

    call cstr_2C(trim(msg),cmsg,'2C')
    call c_errorlogd(cmsg,dvalue)
  end subroutine errorLogFloat

  subroutine errLogOpen( cr, iostat, cFile, ilun, Status, lFatal )
  !--   Log a file open error 
    implicit  none
    character(len=*),intent(in)        :: cr      ! calling routine
    integer, intent(in)                :: iostat  ! open return ; do nothing if == 0
    character(len=*),intent(in)        :: cFile   ! tried to open this file
    integer, intent(in)                :: ilun    !   ..  on unit
    character(len=*), &
       intent(in), optional            :: Status  !  of the file
    logical, intent(in), optional      :: lFatal  !  call bad_exit if this is set..
  !
    integer                            :: ifatal  !  {1:2} for notfatal|fatal}
    character(len=4),dimension(3)      :: cEF = (/' -E-',' -F-',' -I-'/)
    character(len=256)                 :: cbuf   &
                                         ,cmsg
  !
    if( iostat == 0 )                       then
       write(cbuf,'(5a,i4)') &
          cr,cEF(3),' opened ',trim(cFile),' on ',ilun
       return
    endif
  !
    ifatal = 1
    if( present(lFatal) )  then
       if( lFatal ) ifatal = 2
    endif
    write(cbuf,'(2a,1x,i6,3a,i4)') &
      cr,cEF(ifatal),iostat,' opening ',trim(cFile),' on ',ilun 
    if( present(status))  cbuf = cbuf//' status '//Status
  !
    call cstr_2C(trim(cbuf),cmsg,'2C')
    call c_errorlog(cmsg)
  !
    if( ifatal == 2 .and. iostat /= 0 )    call bad_exit()
  !
  end subroutine errLogOpen

  subroutine errLogAlloc( cr, istat, cArray, isize, lFatal )
  !--  Log an array allocation error
    implicit  none
    character(len=*),intent(in)        :: cr      ! calling routine
    integer, intent(in)                :: istat   ! allocate return ; do nothing if == 0
    character(len=*),intent(in)        :: cArray  ! tried to allocate this array
    integer, intent(in)                :: isize   !   ..  # words
    logical, intent(in), optional      :: lFatal  !  call bad_exit if this is set..
  !
    integer                            :: ifatal  !  {1:2} for notfatal|fatal}
    character(len=4),dimension(3)      :: cEF = (/' -E-',' -F-',' -I-'/)
    character(len=256)                 :: cbuf   &
                                         ,cmsg
  !
    if( istat == 0 )                     return
  !
    ifatal = 1
    if( present(lFatal) )  then
       if( lFatal ) ifatal = 2
    endif
    write(cbuf,'(2a,1x,i8,3a,i10,a)') &
      cr,cEF(ifatal),istat,' allocating ',trim(cArray),' (',isize,')'
  !
    call cstr_2C(trim(cbuf),cmsg,'2C')
    call c_errorlog(cmsg)
  !
    if( ifatal == 2 .and. istat /= 0 )    call bad_exit()
  !
  end subroutine errLogAlloc
end module logmod

subroutine mkherm1(fun,x,nx,fherm)
  use iso_c_binding, only: fp => c_double
  !
  !  create a data set for Hermite interpolation, from evaluation of
  !  function and derivatives.  function of 1 indep. coordinate.
  !
  !  input:
  !
  !============
  implicit none
  integer nx,ix
  !============
  real(fp) :: fun,dfdx
  !============
  external fun                      ! passed real function(x,dfdx)
  real(fp) :: x(nx)                        ! x coordinate array
  !
  !  the passed function fun must have the interface:
  !
  !        real function <name>(x,dfdx)
  !  where x is input, the function returns the function value and the
  !  argument dfdx returns as output the function derivative at x.
  !
  !  output:
  !
  real(fp) :: fherm(0:1,nx)                ! function data & derivative
  !
  !  fherm(0,j) = function value f at x(j)
  !  fherm(1,j) = derivative df/dx at x(j)
  !
  !----------------------------
  !
  do ix=1,nx
     fherm(0,ix)=fun(x(ix),dfdx)
     fherm(1,ix)=dfdx
  end do
  !
  return
end subroutine mkherm1

      subroutine sget_user(zname)
      character*(*) zname
C
C  get the current username
C
#ifdef __VMS
      include '($JPIDEF)'    ! VMS only
C
      ITEM = JPI$_USERNAME
      ISTAT = LIB$GETJPI(ITEM,,,IRET,ZNAME,ILEN)
C
#endif
#ifdef __UNIX
      call ugetlog(zname)
#endif
      return
      end

c------------------------------------------------------------/usr$getdvi
C
C  ADAPTED FROM SGLIB "usr$getdvi" ROUTINE -- DMC 6 SEP 1991
C   FOR "VAXONLY" LIBRARY IN CMSMMS SYSTEM
C
C  CALL TO THIS ROUTINE ON A UNIX SYSTEM IS FATAL!
C
C  THE GETDVI SYSTEM SERVICE IS VMS SPECIFIC!
C
      subroutine UGETDVI(physnam,klass,istat)
#ifdef __NAGWARE
      use f90_unix_proc
#endif
c
c  get device class for a physical device name
c
c  arguments:
      character*(*) physnam	!physical name of device
      integer       klass	!(return) device class
C			! 0=unknown, 1=disk, 2=terminal, 5=mailbox(nl:)
      integer       istat	!(return) status code
C
C-----------------------------------------------------------------------
C  BEGIN VAX ONLY CODE
c
c  local variables:
#ifdef __VMS
      include '($DVIDEF)'   ! VMS ONLY CODE STARTS WITH THIS LINE
      include '($DCDEF)'
c
      integer sys$getdviw
c
      structure /itmlst/
        integer*2 dvi_leng /4/	!length of response
        integer*2 dvi_code /dvi$_devclass/	!code for device class
        integer*4 dvi_bufr /0/	!address of response
        integer*4 dvi_resl /0/	!address of response length
      endstructure
c
      record /itmlst/ dvi
      integer class		!response buffer
      integer lresp		!response length
c
      integer lphys		!length of device name
C
c-----------------------------------------------------------------------
C
      lphys = len(physnam)
      lcol = index(physnam(1:lphys),' ')
      if(lcol.ne.0) lphys = lcol
c
      istat = 1		!assume success
      lcol = index(physnam(1:lphys),':')
      ldot = index(physnam(1:lphys),'.')
      if(ldot.ne.0 .and. lcol.eq.0) then
        klass = 1		!has a dot, but no colon => disk
        go to 800
      endif
      class = 0		!assume undefined
C
      dvi.dvi_leng = 4
      dvi.dvi_code = dvi$_devclass
      dvi.dvi_bufr = %loc(class)
      dvi.dvi_resl = 0	!%loc(lresp)
c
      igood = sys$getdviw(,,physnam(1:lphys),dvi,,,,)
cx	if(.not.igood) go to 800
c
      if(class.eq.0) then
        klass = 0	!unknown
      elseif(class.eq.dc$_term) then
        klass = 2	!terminal (on this node)
      elseif(class.eq.dc$_mailbox) then
        klass = 5
      else
        klass = 1
      endif
c
      istat = igood
 800  continue
      return
#endif
C-----------------------------------------------------------------------
#ifdef __UNIX
      WRITE(6,9991)
 9991 FORMAT(' ?UGETDVI:  NOT CALLABLE ON UNIX SYSTEM'/
     >         '  PROGRAMMING ERROR IN CALLER'/)
      CALL EXIT(1)
#endif
      end

!define _TEST
  subroutine cdump( cvar, cval, istat )
  !.. cdump                            Dump Char string in Octal ( desperate.. )
  !                                    codesys/source/portlib/cdump.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  06Jan2012
  !  Modifications
  !
  !  1.00  06Jan2012                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(in)       :: cvar         & ! variable to dump
                                       ,cval           !  & its value
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  integer, parameter                 :: ilun=6       & ! io unit
                                       ,ncln=30        ! nchar / line
  integer                            :: i,j            ! loop index 
  integer                            :: l,k            ! length of cval
  integer,dimension(ncln)            :: ival           ! integer value
  !
  character(len=*),parameter         :: cSr='portlib/cdump'
  !----------------------------------::================!.........................|
  !
  istat = 0
  l = min(len(cval),len_trim(cval)+1)
  write(ilun,'(4a,i9)')  cSr,' -I- of ',cvar,' 1:',l
  l_ln: do i=0,l-1,ncln
     k = min(ncln,l-i)
     l_char: do j=1,k
        ival(j) = ichar( cval(i+j:i+j) )
     enddo l_char
     write(ilun,100) i+1,i+k,(cval(i+j:i+j),j=1,k)
     write(ilun,101)         (ival(j)  ,j=1,k)
  enddo l_ln
  !
100 format(2i6,t15,30(a1,2x))
101 format(    t15,30(Z2,1x))
  !
  end subroutine cdump
#ifdef _TEST
  program test_cdump
  !.. test_cdump                       as it says on the can
  !                                    codesys/source/portlib/test_cdump.
  !  Use
  !            >cpp --traditional $CS/source/portlib/cdump.f90 ./cdump.F
  !            >lf95 --nfix cdump.F -o cdump
  !            >./cdump
  !
  !  Author                            <author>@<place>
  !  Version                           1.00,  06Jan2012
  !  Modifications
  !
  !  1.00  06Jan2012                   <author>@<place>
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  !use..
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..local
  integer                            :: i              ! loop index 
  character(len=10)                  :: cval
  !
  character(len=*),parameter         :: cSr='<dir>/test_cdump'
  !----------------------------------::================!.........................|
  !
  call cdump( 'Test1', 'abcde/fghij/klmno/pqrst/uvwxy/z    ', i )
  !
  call cdump( 'Test2', '0123456789 !"$%^&*()_+', i )
  !
  cval = 'ABCDE'
  cval(3:3) = char(0)
  call cdump( 'Test3', cval, i )
  !
  end program test_cdump

#endif

subroutine evspline(xget,x,nx,ilinx,f,ict,fval,ier)
  use iso_c_binding, only: fp => c_double
  !
  !  use mkspline to set up spline coefficients...
  !
  !  evaluate a 1d cubic Spline interpolant -- this is C2
  !
  !  this subroutine calls two subroutines:
  !     herm1x  -- find cell containing (xget)
  !     fvspline  -- evaluate interpolant function and (optionally) derivatives
  !
  !  input arguments:
  !  ================
  !
  implicit none
  integer nx                        ! grid size
  real(fp) :: xget                         ! target of this interpolation
  real(fp) :: x(nx)                        ! ordered x grid
  integer ilinx                     ! ilinx=1 => assume x evenly spaced
  !
  real(fp) :: f(0:1,nx)                    ! function data
  !
  !  f(0,i) = f @ x(i)
  !  f(1,i) = d2f/dx2 @ x(i)
  !
  !      (these are spline coefficients selected for continuous 2-
  !      diffentiability, see mkspline.f90)
  !
  integer ict(3)                    ! code specifying output desired
  !
  !  ict(1)=1 -- return f  (0, don't)
  !  ict(2)=1 -- return df/dx  (0, don't)
  !  ict(3)=1 -- return d2f/dx2  (0, don't)
  !
  !        set ict(1)=3 to get d3f/dx3 (only)
  !
  ! output arguments:
  ! =================
  !
  real(fp) :: fval(*)                      ! output data
  integer ier                       ! error code =0 ==> no error
  !
  !  fval(1) receives the first output (depends on ict(...) spec)
  !  fval(2) receives the second output (depends on ict(...) spec)
  !  fval(3) receives the third output (depends on ict(...) spec)
  !
  !  examples:
  !    on input ict = [1,1,1]
  !   on output fval= [f,df/dx,d2f/dx2]
  !
  !    on input ict = [1,0,0]
  !   on output fval= [f] ... elements 2 -- 3 never referenced.
  !
  !    on input ict = [0,0,1]
  !   on output fval= [d2f/dx2] ... elements 2 -- 3 never referenced.
  !
  !  ier -- completion code:  0 means OK
  !-------------------
  !  local:
  !
  integer i(1)                         ! cell indices
  !
  !  normalized displacement from x(i) grid point.
  !    xparam=0 @x(i)  xparam=1 @x(i+1)
  !
  real(fp) :: xparam(1)
  !
  !  cell dimensions and
  !  inverse cell dimensions hxi = 1/(x(i+1)-x(i))
  !
  real(fp) :: hx(1)
  real(fp) :: hxi(1)
  !
  !  0 .le. xparam .le. 1
  !
  !  ** the interface is very similar to herm2ev.f90; can use herm2xy **
  !---------------------------------------------------------------------
  !
  i(1)=0
  call herm1x(xget,x,nx,ilinx,i(1),xparam(1),hx(1),hxi(1),ier)
  if(ier.ne.0) return
  !
  call fvspline(ict,1,1,fval,i,xparam,hx,hxi,f,nx)
  !
  return
end subroutine evspline
!---------------------------------------------------------------------
!  evaluate C1 cubic Hermite function interpolation -- 2d fcn
!   --vectorized-- dmc 10 Feb 1999
!
subroutine fvspline(ict,ivec,ivecd, &
     fval,ii,xparam,hx,hxi,fin,nx)
  use iso_c_binding, only: fp => c_double
  !
  !  use mkspline to set up spline coefficients...
  !
  !============
  implicit none
  integer nx,iadr,i
  !============
  real(fp) :: xp,xpi,xp2,xpi2,cx,cxi,hx2,cxd,cxdi
  !============
  integer ict(3)                    ! requested output control
  integer ivec                      ! vector length
  integer ivecd                     ! vector dimension (1st dim of fval)
  !
  integer ii(ivec)                  ! target cells (i)
  real(fp) :: xparam(ivec)
  ! normalized displacements from (i) corners
  !
  real(fp) :: hx(ivec)                     ! grid spacing, and
  real(fp) :: hxi(ivec)                    ! inverse grid spacing 1/(x(i+1)-x(i))
  !
  real(fp) :: fin(0:1,nx)                  ! interpolant data (cf "evspline")
  !
  real(fp) :: fval(ivecd,*)                ! output returned
  !
  !  for detailed description of fin, ict and fval see subroutine
  !  evspline comments.  Note ict is not vectorized; the same output
  !  is expected to be returned for all input vector data points.
  !
  !  note that the index inputs ii and parameter inputs
  !     xparam,hx,hxi, are vectorized, and the
  !     output array fval has a vector ** 1st dimension ** whose
  !     size must be given as a separate argument
  !
  !  to use this routine in scalar mode, pass in ivec=ivecd=1
  !
  !---------------
  !  Spline evaluation consists of a "mixing" of the interpolant
  !  data using the linear functionals xparam, xpi = 1-xparam,
  !  xparam**3-xparam, xpi**3-xpi ...
  !  and their derivatives as needed.
  !
  integer v
  !
  real(fp) :: sum
  real(fp) :: sixth
  !
  data sixth/0.166666666666666667_fp/
  !
  !---------------
  !   ...in x direction
  !
  iadr=0
  !
  if(ict(1).le.2) then
     !
     !  normal call
     !
     if(ict(1).eq.1) then
        !
        !  get desired values:
        !
        iadr = iadr + 1
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cx=xp*(xp2-1.0_fp)
           cxi=xpi*(xpi2-1.0_fp)
           hx2=hx(v)*hx(v)
           !
           !  function value:
           !
           sum=xpi*fin(0,i) +xp*fin(0,i+1)
           sum=sum+sixth*hx2*(cxi*fin(1,i) +cx*fin(1,i+1))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(2).eq.1) then
        !
        !  df/dx:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           xp2=xp*xp
           xpi2=xpi*xpi
           !
           cxd=3.0_fp*xp2-1.0_fp
           cxdi=-3.0_fp*xpi2+1.0_fp

           sum=hxi(v)*(fin(0,i+1)-fin(0,i))
           sum=sum+sixth*hx(v)*(cxdi*fin(1,i) +cxd*fin(1,i+1))
           !
           fval(v,iadr)=sum
        end do
     end if
     !
     if(ict(3).eq.1) then
        !
        !  d2f/dx2:
        !
        iadr=iadr+1
        do v=1,ivec
           i=ii(v)
           !
           xp=xparam(v)
           xpi=1.0_fp-xp
           !
           sum=xpi*fin(1,i) +xp*fin(1,i+1)
           fval(v,iadr)=sum
        end do
     end if
     !
  else
     !
     !  return fxxx = d3f/dx3
     !
     iadr=1
     do v=1,ivec
        i=ii(v)
        fval(v,iadr)=hxi(v)*(fin(1,i+1)-fin(1,i))
     end do
     !
  end if
  !
  return
end subroutine fvspline

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Initialization of ezspline

#include "cpp/czspline_handle_size.h"

#define _S czhybrid_init2
#define _O czspline2
subroutine _S(handle, n1, n2, hspline, BCS1, BCS2, ier)
  use ezspline_obj
  use ezspline
  use czspline_pointer_types
  implicit none
  integer, intent(inout) :: handle(_ARRSZ)
  integer, intent(in) :: n1, n2
  integer, intent(in) :: hspline(2)
  integer, intent(in) :: BCS1(2), BCS2(2)
  integer, intent(out) :: ier
  type(_O) :: self
  allocate(self % ptr)
  call ezhybrid_init(self % ptr, n1, n2, hspline, ier, BCS1, BCS2)
  handle = 0
  handle = transfer(self, handle)
end subroutine _S
#undef _S
#undef _O

#define _S czhybrid_init3
#define _O czspline3
subroutine _S(handle, n1, n2, n3, hspline, BCS1, BCS2, BCS3, ier)
  use ezspline_obj
  use ezspline
  use czspline_pointer_types
  implicit none
  integer, intent(inout) :: handle(_ARRSZ)
  integer, intent(in) :: n1, n2, n3
  integer, intent(in) :: hspline(3)
  integer, intent(in) :: BCS1(2), BCS2(2), BCS3(2)
  integer, intent(out) :: ier
  type(_O) :: self
  allocate(self % ptr)
  call ezhybrid_init(self % ptr, n1, n2, n3, hspline, ier, BCS1, BCS2, BCS3)
  handle = 0
  handle = transfer(self, handle)
end subroutine _S
#undef _S
#undef _O

subroutine mpi_env_comm_get(icomm)

  !  return the mpi_env_mod MPI communicator variable
  !  NOTE: this is MPI_COMM_WORLD, always, with the current version
  !        of the code; there is no provision for changing this.
  !        (See updated source/doc/mpi_transp.doc and the new
  !        mpi_proc_data module for multiple-communicator support).

  use mpi_env_mod
  implicit NONE

  integer, intent(out) :: icomm

  icomm = mpi_env_comm

end subroutine mpi_env_comm_get

!EZcdf, Easy Interface to netCDF Routine Calls
!=============================================
 
!The module is available through the NTCC Webpage,
!w3.pppl.gov/NTTC  under "Modules Library", as compressed
!tarfile, ezcdf.tar.gz, and as zip archive, ezcdf.zip.
!Alternatively it can be obtained from ftp.pppl.gov
!in pub/NTCC/.
 
 
! AUTHORS
 
!Conceived by 7/98 by Sunitinder Sekhon
!Modified by J. Menard 12/98 to run on Cray C90
!Completely re-written by C.Ludescher 2/99
!Added complex support (64 and 128 bit) by A. Pletzer 5/01
 
 
! CONTACT
 
! C. Ludescher cludescher@pppl.gov
! A. Pletzer   pletzer@pppl.gov
 
 
! REVISION HISTORY
 
!      date         Description
 
! February  1999  -- Created
! April     2000  -- A.Pletzer: Added R4
! May 01,   2000  -- C. Ludescher: Simplified by adding module ezcdf
! May 17,   2001  -- A. Pletzer: Added C8 and C16
! Interface for cdfopn to handle optional argument ier
! 04/28/00 C.Ludescher
! + ezcdf_close for symmetry (ap)
! September 2002  -- S. Hirshman, added aliases to mimic F90 I/O routines
!                    added cdf_inquire with OPTIONAL xtype argument
!                    added 'LOG' data type (nf_int) to handle logicals
!                    (user may use 'INT' interchangeably)
!
! April 2003      -- removed ONLY and some rename clauses from USE stmts
!                    (D. McCune).  These caused problems, because an
!                    application with "use ezcdf" would indirectly see
!                    "use ezcdf_inqvar" with various ONLY clauses; it
!                    was unclear which one would rule, but, at load time
!                    it was clear that the ONLY clauses were making some
!                    legitimate ezcdf entries invisible, at least when
!                    built using Lahey-Fujitsu fortran.  Also, the
!                    indirect presence of multiple "USE ezcdf_opencls"
!                    with rename lists caused problems which were resolved
!                    by removing the rename lists ans using INTERFACE
!                    statements inside ezcdf_opncls instead.
!
 
MODULE ezcdf

  ! No aliases. this caused the Intel compiler to fail, so I had to duplicated
  ! 2 interfaces: cdfPutVar <=> cdf_write and cdfGetVar <=> cdf_read (pletzer)

  USE ezcdf_GenPut
  USE ezcdf_GenGet
  USE ezcdf_attrib
  USE ezcdf_opncls
 

END MODULE ezcdf

subroutine EZspline_cinterp(spline_o, k, p1, p2, p3, f, ier)
  ! list of coordinate triplets
  ! this version of interp that has been inlined for better performance on the
  ! crays (pletzer@pppl.gov) Thu Jun 15 08:52:46 PDT 2000
  ! NOTE:
  ! This routine does not require the -dp switch on Crays since
  ! all constant have been made kind=r8.

  ! DMC Apr 2007 -- only the tricubic SPLINE evaluation has been inlined;
  ! if a different method interpolation is used, the standard f77-style
  ! pspline subroutine is called.

  use iso_c_binding, only: fp => c_double
  use EZspline_obj
  implicit none
  type(EZspline3) spline_o
  integer, intent(in) :: k
  real(fp), intent(in) :: p1(k), p2(k), p3(k)  ! location arrays
  real(fp), intent(out):: f(k)  ! interpolant array
  integer, intent(out) :: ier

  integer :: ifail
  integer, parameter :: ict(10)=(/1,0,0,0,0,0,0,0,0,0/)
  integer:: iwarn=0

  integer ix(k)                  ! zone indices {j}
  REAL(fp) dxn(k)       ! normalized displacements w/in zones
  REAL(fp) hx(k)        ! h(j) vector
  REAL(fp) hxi(k)       ! 1/h(j) vector
  !
  integer iy(k)                  ! zone indices {j}
  REAL(fp) dyn(k)       ! normalized displacements w/in zones
  REAL(fp) hy(k)        ! h(j) vector
  REAL(fp) hyi(k)       ! 1/h(j) vector
  !
  integer iz(k)                  ! zone indices {j}
  REAL(fp) dzn(k)       ! normalized displacements w/in zones
  REAL(fp) hz(k)        ! h(j) vector
  REAL(fp) hzi(k)       ! 1/h(j) vector
  integer v
  !
  REAL(fp) , parameter ::  sixth=0.166666666666666667_fp
  REAL(fp) , parameter ::  one=1.0_fp
  REAL(fp) , parameter ::  three=3.0_fp

  integer j1, j2 , j3
  REAL(fp) z36th,z216th,xp,xpi,xp2,xpi2,cx,cxi,hx2,cxd,cxdi,yp,       &
       & ypi,yp2,ypi2,cy,cyi,hy2,cyd,cydi,zp,zpi,zp2,zpi2,cz,czi,hz2,     &
       & czd,czdi,somme

  ier = 0
  ifail=0
  if(spline_o%isReady /= 1) then
     ier = 94
     return
  end if

  if (spline_o%isLinear == 1) then

     call vecpc3(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  else if (spline_o%isHybrid == 1) then

     call vecintrp3d(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%hspline, &
          & spline_o%fspl(1,1,1,1), size(spline_o%fspl,1), &
          & size(spline_o%fspl,2), size(spline_o%fspl,3), &
          & size(spline_o%fspl,4), iwarn, ifail)

  else if (spline_o%isHermite ==0) then
     !
!!$     call vectricub(ict, k, p1, p2, p3, k, f, &
!!$          & spline_o%n1,spline_o%x1pkg(1,1), &
!!$          & spline_o%n2,spline_o%x2pkg(1,1), &
!!$          & spline_o%n3,spline_o%x3pkg(1,1), &
!!$          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
!!$          & iwarn, ifail)

     call xlookup(k,p1,spline_o%n1,spline_o%x1pkg(1,1),2,ix,dxn,hx,hxi,ifail)
     call xlookup(k,p2,spline_o%n2,spline_o%x2pkg(1,1),2,iy,dyn,hy,hyi,ifail)
     call xlookup(k,p3,spline_o%n3,spline_o%x3pkg(1,1),2,iz,dzn,hz,hzi,ifail)

!!$      call fvtricub(ict,k,k,f,ix,iy,iz,dxn,dyn,dzn,           &
!!$     &   hx,hxi,hy,hyi,hz,hzi,spline_o%fspl(1,1,1,1), &
!!$     &   spline_o%n1, spline_o%n2, spline_o%n3)


     z36th=sixth*sixth
     z216th=sixth*sixth*sixth
     !
     !  prepare useful parameters...
     !
     do v=1,k
        j1=ix(v)
        j2=iy(v)
        j3=iz(v)
        !
        !   ...in x direction
        !
        xp=dxn(v)
        xpi=one-xp
        xp2=xp*xp
        xpi2=xpi*xpi
        !
!!$         if((ict(1).eq.1).or.(ict(3).eq.1).or.(ict(4).eq.1).or.         &
!!$     &      (ict(6).eq.1).or.(ict(7).eq.1).or.(ict(10).eq.1)) then
        cx=xp*(xp2-ONE)
        cxi=xpi*(xpi2-ONE)
        hx2=hx(v)*hx(v)
!!$         end if
!!$         if((ict(2).eq.1).or.(ict(8).eq.1).or.(ict(9).eq.1)) then
!!$            cxd=THREE*xp2-ONE
!!$            cxdi=-THREE*xpi2+ONE
!!$         end if
        !
        !   ...and in y direction
        !
        yp=dyn(v)
        ypi=ONE-yp
        yp2=yp*yp
        ypi2=ypi*ypi
        !
!!$         if((ict(1).eq.1).or.(ict(2).eq.1).or.(ict(4).eq.1).or.         &
!!$     &      (ict(5).eq.1).or.(ict(7).eq.1).or.(ict(9).eq.1)) then
        cy=yp*(yp2-ONE)
        cyi=ypi*(ypi2-ONE)
        hy2=hy(v)*hy(v)
!!$         end if
!!$         if((ict(3).eq.1).or.(ict(8).eq.1).or.(ict(10).eq.1)) then
!!$            cyd=THREE*yp2-ONE
!!$            cydi=-THREE*ypi2+ONE
!!$         end if
        !
        !   ...and in z direction
        !
        zp=dzn(v)
        zpi=ONE-zp
        zp2=zp*zp
        zpi2=zpi*zpi
        !
!!$         if((ict(1).eq.1).or.(ict(2).eq.1).or.(ict(3).eq.1).or.         &
!!$     &      (ict(5).eq.1).or.(ict(6).eq.1).or.(ict(8).eq.1)) then
        cz=zp*(zp2-ONE)
        czi=zpi*(zpi2-ONE)
        hz2=hz(v)*hz(v)
!!$         end if
!!$         if((ict(4).eq.1).or.(ict(9).eq.1).or.(ict(10).eq.1)) then
!!$            czd=THREE*zp2-ONE
!!$            czdi=-THREE*zpi2+ONE
!!$         end if
        !
        !  get desired values:
        !
        if(ict(1).eq.1) then
           !
           !  function value:
           !
           somme=(                                                       &
                &         zpi*(                                                    &
                &           xpi*(ypi*spline_o%fspl(1,j1,j2,j3)  +yp*spline_o%fspl(1,j1,j2+1,j3))+            &
                &            xp*(ypi*spline_o%fspl(1,j1+1,j2,j3)+yp*spline_o%fspl(1,j1+1,j2+1,j3)))          &
                &        +zp*(                                                     &
                &           xpi*(ypi*spline_o%fspl(1,j1,j2,j3+1)  +yp*spline_o%fspl(1,j1,j2+1,j3+1))+        &
                &            xp*(ypi*spline_o%fspl(1,j1+1,j2,j3+1)+yp*spline_o%fspl(1,j1+1,j2+1,j3+1))))
           !
           somme=somme+sixth*hx2*(                                         &
                &         zpi*(                                                    &
                &           cxi*(ypi*spline_o%fspl(2,j1,j2,j3)  +yp*spline_o%fspl(2,j1,j2+1,j3))+            &
                &            cx*(ypi*spline_o%fspl(2,j1+1,j2,j3)+yp*spline_o%fspl(2,j1+1,j2+1,j3)))          &
                &        +zp*(                                                     &
                &           cxi*(ypi*spline_o%fspl(2,j1,j2,j3+1)  +yp*spline_o%fspl(2,j1,j2+1,j3+1))+        &
                &            cx*(ypi*spline_o%fspl(2,j1+1,j2,j3+1)+yp*spline_o%fspl(2,j1+1,j2+1,j3+1))))
           !
           somme=somme+sixth*hy2*(                                         &
                &         zpi*(                                                    &
                &           xpi*(cyi*spline_o%fspl(3,j1,j2,j3)  +cy*spline_o%fspl(3,j1,j2+1,j3))+            &
                &            xp*(cyi*spline_o%fspl(3,j1+1,j2,j3)+cy*spline_o%fspl(3,j1+1,j2+1,j3)))          &
                &        +zp*(                                                     &
                &           xpi*(cyi*spline_o%fspl(3,j1,j2,j3+1)  +cy*spline_o%fspl(3,j1,j2+1,j3+1))+        &
                &            xp*(cyi*spline_o%fspl(3,j1+1,j2,j3+1)+cy*spline_o%fspl(3,j1+1,j2+1,j3+1))))
           !
           somme=somme+sixth*hz2*(                                         &
                &         czi*(                                                    &
                &           xpi*(ypi*spline_o%fspl(4,j1,j2,j3)  +yp*spline_o%fspl(4,j1,j2+1,j3))+            &
                &            xp*(ypi*spline_o%fspl(4,j1+1,j2,j3)+yp*spline_o%fspl(4,j1+1,j2+1,j3)))          &
                &        +cz*(                                                     &
                &           xpi*(ypi*spline_o%fspl(4,j1,j2,j3+1)  +yp*spline_o%fspl(4,j1,j2+1,j3+1))+        &
                &            xp*(ypi*spline_o%fspl(4,j1+1,j2,j3+1)+yp*spline_o%fspl(4,j1+1,j2+1,j3+1))))
           !
           somme=somme+z36th*hx2*hy2*(                                     &
                &         zpi*(                                                    &
                &           cxi*(cyi*spline_o%fspl(5,j1,j2,j3)  +cy*spline_o%fspl(5,j1,j2+1,j3))+            &
                &            cx*(cyi*spline_o%fspl(5,j1+1,j2,j3)+cy*spline_o%fspl(5,j1+1,j2+1,j3)))          &
                &        +zp*(                                                     &
                &           cxi*(cyi*spline_o%fspl(5,j1,j2,j3+1)  +cy*spline_o%fspl(5,j1,j2+1,j3+1))+        &
                &            cx*(cyi*spline_o%fspl(5,j1+1,j2,j3+1)+cy*spline_o%fspl(5,j1+1,j2+1,j3+1))))
           !
           somme=somme+z36th*hx2*hz2*(                                     &
                &         czi*(                                                    &
                &           cxi*(ypi*spline_o%fspl(6,j1,j2,j3)  +yp*spline_o%fspl(6,j1,j2+1,j3))+            &
                &            cx*(ypi*spline_o%fspl(6,j1+1,j2,j3)+yp*spline_o%fspl(6,j1+1,j2+1,j3)))          &
                &        +cz*(                                                     &
                &           cxi*(ypi*spline_o%fspl(6,j1,j2,j3+1)  +yp*spline_o%fspl(6,j1,j2+1,j3+1))+        &
                &            cx*(ypi*spline_o%fspl(6,j1+1,j2,j3+1)+yp*spline_o%fspl(6,j1+1,j2+1,j3+1))))
           !
           somme=somme+z36th*hy2*hz2*(                                     &
                &         czi*(                                                    &
                &           xpi*(cyi*spline_o%fspl(7,j1,j2,j3)  +cy*spline_o%fspl(7,j1,j2+1,j3))+            &
                &            xp*(cyi*spline_o%fspl(7,j1+1,j2,j3)+cy*spline_o%fspl(7,j1+1,j2+1,j3)))          &
                &        +cz*(                                                     &
                &           xpi*(cyi*spline_o%fspl(7,j1,j2,j3+1)  +cy*spline_o%fspl(7,j1,j2+1,j3+1))+        &
                &            xp*(cyi*spline_o%fspl(7,j1+1,j2,j3+1)+cy*spline_o%fspl(7,j1+1,j2+1,j3+1))))
           !
           somme=somme+z216th*hx2*hy2*hz2*(                                &
                &         czi*(                                                    &
                &           cxi*(cyi*spline_o%fspl(8,j1,j2,j3)  +cy*spline_o%fspl(8,j1,j2+1,j3))+            &
                &            cx*(cyi*spline_o%fspl(8,j1+1,j2,j3)+cy*spline_o%fspl(8,j1+1,j2+1,j3)))          &
                &        +cz*(                                                     &
                &           cxi*(cyi*spline_o%fspl(8,j1,j2,j3+1)  +cy*spline_o%fspl(8,j1,j2+1,j3+1))+        &
                &            cx*(cyi*spline_o%fspl(8,j1+1,j2,j3+1)+cy*spline_o%fspl(8,j1+1,j2+1,j3+1))))
           !
           f(v)=somme
        else
           write(6,*) 'ERROR ict(1) must be 1 (interpolation)'
        end if
        !
        !
     end do                             ! vector loop


     if(ifail /= 0) ier = 97

  else

     call vecherm3(ict, k, p1, p2, p3, k, f, &
          & spline_o%n1, spline_o%x1pkg(1,1), &
          & spline_o%n2, spline_o%x2pkg(1,1), &
          & spline_o%n3, spline_o%x3pkg(1,1), &
          & spline_o%fspl(1,1,1,1), spline_o%n1, spline_o%n2, &
          & iwarn,ifail)

  end if

  if(ifail /= 0) ier = 97

end subroutine EZspline_cinterp

!---------------------------------------------------------------------------
! This code was developed at Tech-X (www.txcorp.com). It is free for any one
! to use but comes with no warranty whatsoever. Use at your own risk. 
! Thanks for reporting bugs to pletzer@txcorp.com. 
!---------------------------------------------------------------------------
! Boiler plate code to generate pointer to types for 1, 2, and 3 dimensions

module czspline_pointer_types

  use ezspline_obj
  use ezspline

#define _O1 czspline1
#define _O2 ezspline1
  ! generic implementation
#include "czspline_type.h"
#undef _O1
#undef _O2

#define _O1 czspline2
#define _O2 ezspline2
  ! generic implementation
#include "czspline_type.h"
#undef _O1
#undef _O2

#define _O1 czspline3
#define _O2 ezspline3
  ! generic implementation
#include "czspline_type.h"
#undef _O1
#undef _O2

end module czspline_pointer_types
